
DROP TABLE IF EXISTS `address_book`;
CREATE TABLE `address_book` (
  `address_book_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `entry_gender` char(1) NOT NULL default '',
  `entry_company` varchar(32) default NULL,
  `entry_company_tax_id` varchar(32) default NULL,
  `entry_firstname` varchar(32) NOT NULL default '',
  `entry_lastname` varchar(32) NOT NULL default '',
  `entry_street_address` varchar(64) NOT NULL default '',
  `entry_suburb` varchar(32) default NULL,
  `entry_postcode` varchar(10) NOT NULL default '',
  `entry_city` varchar(32) NOT NULL default '',
  `entry_state` varchar(32) default NULL,
  `entry_country_id` int(11) NOT NULL default '0',
  `entry_zone_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`address_book_id`),
  KEY `idx_address_book_customers_id` (`customers_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1;



DROP TABLE IF EXISTS `address_format`;
CREATE TABLE `address_format` (
  `address_format_id` int(11) NOT NULL auto_increment,
  `address_format` varchar(128) NOT NULL default '',
  `address_summary` varchar(48) NOT NULL default '',
  PRIMARY KEY  (`address_format_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1;



INSERT INTO `address_format` (`address_format_id`, `address_format`, `address_summary`) VALUES
(1, '$firstname $lastname$cr$streets$cr$city, $postcode$cr$statecomma$country', '$city / $country'),
(2, '$firstname $lastname$cr$streets$cr$city, $state    $postcode$cr$country', '$city, $state / $country'),
(3, '$firstname $lastname$cr$streets$cr$city$cr$postcode - $statecomma$country', '$state / $country'),
(4, '$firstname $lastname$cr$streets$cr$city ($postcode)$cr$country', '$postcode / $country'),
(5, '$firstname $lastname$cr$streets$cr$postcode $city$cr$country', '$city / $country');



DROP TABLE IF EXISTS `admin`;
CREATE TABLE `admin` (
  `admin_id` int(11) NOT NULL auto_increment,
  `admin_username` varchar(96) NOT NULL,
  `admin_groups_id` int(11) default NULL,
  `admin_firstname` varchar(32) NOT NULL default '',
  `admin_lastname` varchar(32) default NULL,
  `admin_email_address` varchar(96) NOT NULL default '',
  `admin_password` varchar(40) NOT NULL default '',
  `admin_created` datetime default NULL,
  `admin_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `admin_logdate` datetime default NULL,
  `admin_lognum` int(11) NOT NULL default '0',
  PRIMARY KEY  (`admin_id`),
  UNIQUE KEY `admin_email_address` (`admin_email_address`)
) TYPE=MyISAM  AUTO_INCREMENT=1;



DROP TABLE IF EXISTS `admin_permissions`;
CREATE TABLE `admin_permissions` (
  `admin_permissions_id` int(11) NOT NULL auto_increment,
  `admin_permissions_name` varchar(120) NOT NULL default '',
  `admin_permissions_description` varchar(255) NOT NULL default '',
  `admin_permissions_status` tinyint(1) NOT NULL default '1',
  `admin_permissions_time_added` varchar(20) NOT NULL default '',
  `admin_permissions_time_last_modified` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`admin_permissions_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1;



INSERT INTO `admin_permissions` (`admin_permissions_id`, `admin_permissions_name`, `admin_permissions_description`, `admin_permissions_status`, `admin_permissions_time_added`, `admin_permissions_time_last_modified`) VALUES
(1, 'Super admin', 'Super admin - all access', 1, NOW(), NOW()),
(2, 'Marketing', 'Marketing permissions', 1, NOW(), NOW());


DROP TABLE IF EXISTS `admin_permissions_groups`;
CREATE TABLE `admin_permissions_groups` (
  `admin_permissions_groups_id` int(11) NOT NULL auto_increment,
  `admin_permissions_id` int(11) NOT NULL default '0',
  `admin_permissions_groups_filename` varchar(64) NOT NULL default '',
  `admin_permissions_groups_time_added` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`admin_permissions_groups_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1;



INSERT INTO `admin_permissions_groups` (`admin_permissions_groups_id`, `admin_permissions_id`, `admin_permissions_groups_filename`, `admin_permissions_groups_time_added`) VALUES
(3, 1, 'accessories.php', NOW()),
(2, 1, 'admin_files.php', NOW()),
(4, 1, 'accessories_handler.php', NOW()),
(5, 1, 'admin_files.php', NOW()),
(6, 1, 'admin_members.php', NOW()),
(17, 1, 'ajax_utils.php', NOW()),
(18, 1, 'articles.php', NOW()),
(19, 1, 'articles_authors.php', NOW()),
(20, 1, 'articles_config.php', NOW()),
(21, 1, 'articles_handler.php', NOW()),
(22, 1, 'article_reviews.php', NOW()),
(23, 1, 'backup.php', NOW()),
(24, 1, 'banner_manager.php', NOW()),
(25, 1, 'banner_statistics.php', NOW()),
(26, 1, 'batch_print.php', NOW()),
(27, 1, 'categories.php', NOW()),
(28, 1, 'configuration.php', NOW()),
(29, 1, 'countries.php', NOW()),
(30, 1, 'coupon_admin.php', NOW()),
(31, 1, 'coupon_restrict.php', NOW()),
(32, 1, 'create_account.php', NOW()),
(33, 1, 'create_account_process.php', NOW()),
(34, 1, 'create_account_success.php', NOW()),
(35, 1, 'create_order.php', NOW()),
(36, 1, 'create_order_process.php', NOW()),
(37, 1, 'currencies.php', NOW()),
(38, 1, 'customers.php', NOW()),
(39, 1, 'customers_feedback.php', NOW()),
(40, 1, 'customers_groups.php', NOW()),
(41, 1, 'display.php', NOW()),
(42, 1, 'display_handler.php', NOW()),
(43, 1, 'easypopulate.php', NOW()),
(44, 1, 'easypopulate_functions.php', NOW()),
(45, 1, 'edit_orders.php', NOW()),
(46, 1, 'extra_images_handler.php', NOW()),
(47, 1, 'extra_images_upload.php', NOW()),
(48, 1, 'fedex_popup.php', NOW()),
(49, 1, 'files_handler.php', NOW()),
(50, 1, 'forbiden.php', NOW()),
(51, 1, 'geo_zones.php', NOW()),
(52, 1, 'googlesitemap.php', NOW()),
(53, 1, 'gv_mail.php', NOW()),
(54, 1, 'gv_queue.php', NOW()),
(55, 1, 'gv_sent.php', NOW()),
(56, 1, 'htaccess.php', NOW()),
(57, 1, 'image_stamp.php', NOW()),
(58, 1, 'image_stamp_handler.php', NOW()),
(59, 1, 'index.php', NOW()),
(60, 1, 'invoice.php', NOW()),
(61, 1, 'invoice_main.php', NOW()),
(62, 1, 'languages.php', NOW()),
(63, 1, 'listcategories.php', NOW()),
(64, 1, 'listproducts.php', NOW()),
(65, 1, 'login.php', NOW()),
(66, 1, 'logoff.php', NOW()),
(67, 1, 'mail.php', NOW()),
(68, 1, 'manufacturers.php', NOW()),
(69, 1, 'modules.php', NOW()),
(70, 1, 'newsletters.php', NOW()),
(71, 1, 'orders.php', NOW()),
(72, 1, 'orders_handler.php', NOW()),
(73, 1, 'orders_status.php', NOW()),
(74, 1, 'packingslip.php', NOW()),
(75, 1, 'paypal_ipn.php', NOW()),
(76, 1, 'paypal_ipn_order.php', NOW()),
(77, 1, 'plugins_handler.php', NOW()),
(78, 1, 'polls.php', NOW()),
(79, 1, 'poll_delete.php', NOW()),
(80, 1, 'poll_list.php', NOW()),
(81, 1, 'popup_image.php', NOW()),
(82, 1, 'popup_infobox_help.php', NOW()),
(83, 1, 'popup_products_image.php', NOW()),
(84, 1, 'products_attributes.php', NOW()),
(85, 1, 'products_attributes_functions.php', NOW()),
(86, 1, 'products_attributes_handler.php', NOW()),
(87, 1, 'products_expected.php', NOW()),
(88, 1, 'product_thumb.php', NOW()),
(89, 1, 'recover_cart_sales.php', NOW()),
(90, 1, 'refund_methods.php', NOW()),
(91, 1, 'returns.php', NOW()),
(92, 1, 'returns_invoice.php', NOW()),
(93, 1, 'returns_packingslip.php', NOW()),
(94, 1, 'returns_reasons.php', NOW()),
(95, 1, 'returns_status.php', NOW()),
(96, 1, 'return_product.php', NOW()),
(97, 1, 'return_text.php', NOW()),
(98, 1, 'reviews.php', NOW()),
(99, 1, 'reviews_filter.php', NOW()),
(100, 1, 'reviews_filter_handler.php', NOW()),
(101, 1, 'server_info.php', NOW()),
(102, 1, 'shipping_manifest.php', NOW()),
(103, 1, 'ship_fedex.php', NOW()),
(104, 1, 'sitemaps.index.php', NOW()),
(105, 1, 'site_layout.php', NOW()),
(106, 1, 'site_layout_handler.php', NOW()),
(107, 1, 'specials.php', NOW()),
(108, 1, 'stats_customers.php', NOW()),
(109, 1, 'stats_low_stock_attrib.php', NOW()),
(110, 1, 'stats_monthly_sales.php', NOW()),
(111, 1, 'stats_products_purchased.php', NOW()),
(112, 1, 'stats_products_viewed.php', NOW()),
(113, 1, 'stats_recover_cart_sales.php', NOW()),
(114, 1, 'stock.php', NOW()),
(115, 1, 'tax_classes.php', NOW()),
(116, 1, 'tax_rates.php', NOW()),
(117, 1, 'tools.php', NOW()),
(118, 1, 'tools_handler.php', NOW()),
(119, 1, 'track_fedex.php', NOW()),
(120, 1, 'validcategories.php', NOW()),
(121, 1, 'validproducts.php', NOW()),
(122, 1, 'whos_online.php', NOW()),
(123, 1, 'zones.php', NOW()),
(124, 1, 'templates.php', NOW()),
(125, 1, 'export_customers.php', NOW()),
(126, 1, 'feeder.php', NOW()),
(127, 1, 'feeders.php', NOW()),
(128, 1, 'pdf_invoice.php', NOW()),
(129, 1, 'pdf_packingslip.php', NOW()),
(130, 1, 'shipping_status_carriers.php', NOW()),
(131, 1, 'subscriptions.php', NOW()),
(132, 1, 'affiliates.php', NOW()),
(133, 1, 'affiliate_banners.php', NOW()),
(134, 1, 'affiliate_clicks.php', NOW()),
(135, 1, 'affiliate_contact.php', NOW()),
(136, 1, 'affiliate_invoice.php', NOW()),
(137, 1, 'affiliate_news.php', NOW()),
(138, 1, 'affiliate_newsletters.php', NOW()),
(139, 1, 'affiliate_payment.php', NOW()),
(140, 1, 'affiliate_popup_image.php', NOW()),
(141, 1, 'affiliate_sales.php', NOW()),
(142, 1, 'affiliate_statistics.php', NOW()),
(143, 1, 'affiliate_summary.php', NOW()),
(144, 1, 'batch.php', NOW());


DROP TABLE IF EXISTS `affiliates`;
CREATE TABLE `affiliates` (
  `affiliate_id` int(11) NOT NULL auto_increment,
  `affiliate_gender` char(1) NOT NULL default '',
  `affiliate_firstname` varchar(32) NOT NULL default '',
  `affiliate_lastname` varchar(32) NOT NULL default '',
  `affiliate_dob` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_email_address` varchar(96) NOT NULL default '',
  `affiliate_telephone` varchar(32) NOT NULL default '',
  `affiliate_fax` varchar(32) NOT NULL default '',
  `affiliate_password` varchar(40) NOT NULL default '',
  `affiliate_homepage` varchar(96) NOT NULL default '',
  `affiliate_street_address` varchar(64) NOT NULL default '',
  `affiliate_suburb` varchar(64) NOT NULL default '',
  `affiliate_city` varchar(32) NOT NULL default '',
  `affiliate_postcode` varchar(10) NOT NULL default '',
  `affiliate_state` varchar(32) NOT NULL default '',
  `affiliate_country_id` int(11) NOT NULL default '0',
  `affiliate_zone_id` int(11) NOT NULL default '0',
  `affiliate_agb` tinyint(4) NOT NULL default '0',
  `affiliate_company` varchar(60) NOT NULL default '',
  `affiliate_company_taxid` varchar(64) NOT NULL default '',
  `affiliate_commission_percent` decimal(4,2) NOT NULL default '0.00',
  `affiliate_payment_check` varchar(100) NOT NULL default '',
  `affiliate_payment_paypal` varchar(64) NOT NULL default '',
  `affiliate_payment_bank_name` varchar(64) NOT NULL default '',
  `affiliate_payment_bank_branch_number` varchar(64) NOT NULL default '',
  `affiliate_payment_bank_swift_code` varchar(64) NOT NULL default '',
  `affiliate_payment_bank_account_name` varchar(64) NOT NULL default '',
  `affiliate_payment_bank_account_number` varchar(64) NOT NULL default '',
  `affiliate_date_of_last_logon` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_number_of_logons` int(11) NOT NULL default '0',
  `affiliate_date_account_created` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_date_account_last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_lft` int(11) NOT NULL,
  `affiliate_rgt` int(11) NOT NULL,
  `affiliate_root` int(11) NOT NULL,
  `affiliate_newsletter` char(1) NOT NULL default '1',
  PRIMARY KEY  (`affiliate_id`)
) TYPE=InnoDB AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `affiliate_banners`;
CREATE TABLE `affiliate_banners` (
  `affiliate_banners_id` int(11) NOT NULL auto_increment,
  `affiliate_banners_title` varchar(64) NOT NULL default '',
  `affiliate_products_id` int(11) NOT NULL default '0',
  `affiliate_category_id` int(11) NOT NULL default '0',
  `affiliate_banners_image` varchar(64) NOT NULL default '',
  `affiliate_banners_group` varchar(10) NOT NULL default '',
  `affiliate_banners_html_text` text,
  `affiliate_expires_impressions` int(7) default '0',
  `affiliate_expires_date` datetime default NULL,
  `affiliate_date_scheduled` datetime default NULL,
  `affiliate_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_date_status_change` datetime default NULL,
  `affiliate_status` int(1) NOT NULL default '1',
  PRIMARY KEY  (`affiliate_banners_id`)
) TYPE=InnoDB AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `affiliate_banners_history`;
CREATE TABLE `affiliate_banners_history` (
  `affiliate_banners_history_id` int(11) NOT NULL auto_increment,
  `affiliate_banners_products_id` int(11) NOT NULL default '0',
  `affiliate_banners_id` int(11) NOT NULL default '0',
  `affiliate_banners_affiliate_id` int(11) NOT NULL default '0',
  `affiliate_banners_shown` int(11) NOT NULL default '0',
  `affiliate_banners_clicks` tinyint(4) NOT NULL default '0',
  `affiliate_banners_history_date` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`affiliate_banners_history_id`,`affiliate_banners_products_id`)
) TYPE=InnoDB AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `affiliate_clickthroughs`;
CREATE TABLE `affiliate_clickthroughs` (
  `affiliate_clickthrough_id` int(11) NOT NULL auto_increment,
  `affiliate_id` int(11) NOT NULL default '0',
  `affiliate_clientdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_clientbrowser` varchar(200) default 'Could Not Find This Data',
  `affiliate_clientip` varchar(50) default 'Could Not Find This Data',
  `affiliate_clientreferer` varchar(200) default 'none detected (maybe a direct link)',
  `affiliate_products_id` int(11) default '0',
  `affiliate_banner_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`affiliate_clickthrough_id`),
  KEY `refid` (`affiliate_id`)
) TYPE=InnoDB AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `affiliate_news`;
CREATE TABLE `affiliate_news` (
  `news_id` int(11) NOT NULL auto_increment,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `news_status` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`news_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `affiliate_newsletters`;
CREATE TABLE `affiliate_newsletters` (
  `affiliate_newsletters_id` int(11) NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `content` text NOT NULL,
  `module` varchar(255) NOT NULL default '',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_sent` datetime default NULL,
  `status` int(1) default NULL,
  `locked` int(1) default '0',
  PRIMARY KEY  (`affiliate_newsletters_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `affiliate_news_contents`;
CREATE TABLE `affiliate_news_contents` (
  `affiliate_news_contents_id` int(11) NOT NULL auto_increment,
  `affiliate_news_id` int(11) NOT NULL default '0',
  `affiliate_news_languages_id` int(11) NOT NULL default '0',
  `affiliate_news_headlines` varchar(255) NOT NULL default '',
  `affiliate_news_contents` text NOT NULL,
  PRIMARY KEY  (`affiliate_news_contents_id`),
  KEY `affiliate_news_id` (`affiliate_news_id`),
  KEY `affiliate_news_languages_id` (`affiliate_news_languages_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `affiliate_payment`;
CREATE TABLE `affiliate_payment` (
  `affiliate_payment_id` int(11) NOT NULL auto_increment,
  `affiliate_id` int(11) NOT NULL default '0',
  `affiliate_payment` decimal(15,2) NOT NULL default '0.00',
  `affiliate_payment_tax` decimal(15,2) NOT NULL default '0.00',
  `affiliate_payment_total` decimal(15,2) NOT NULL default '0.00',
  `affiliate_payment_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_payment_last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_payment_status` int(5) NOT NULL default '0',
  `affiliate_firstname` varchar(32) NOT NULL default '',
  `affiliate_lastname` varchar(32) NOT NULL default '',
  `affiliate_street_address` varchar(64) NOT NULL default '',
  `affiliate_suburb` varchar(64) NOT NULL default '',
  `affiliate_city` varchar(32) NOT NULL default '',
  `affiliate_postcode` varchar(10) NOT NULL default '',
  `affiliate_country` varchar(32) NOT NULL default '0',
  `affiliate_company` varchar(60) NOT NULL default '',
  `affiliate_state` varchar(32) NOT NULL default '0',
  `affiliate_address_format_id` int(5) NOT NULL default '0',
  `affiliate_last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`affiliate_payment_id`)
) TYPE=InnoDB AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `affiliate_payment_status`;
CREATE TABLE `affiliate_payment_status` (
  `affiliate_payment_status_id` int(11) NOT NULL default '0',
  `affiliate_language_id` int(11) NOT NULL default '1',
  `affiliate_payment_status_name` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`affiliate_payment_status_id`,`affiliate_language_id`),
  KEY `idx_affiliate_payment_status_name` (`affiliate_payment_status_name`)
) TYPE=InnoDB;


INSERT INTO `affiliate_payment_status` (`affiliate_payment_status_id`, `affiliate_language_id`, `affiliate_payment_status_name`) VALUES
(1, 1, 'Paid'),
(0, 1, 'Pending');


DROP TABLE IF EXISTS `affiliate_payment_status_history`;
CREATE TABLE `affiliate_payment_status_history` (
  `affiliate_status_history_id` int(11) NOT NULL auto_increment,
  `affiliate_payment_id` int(11) NOT NULL default '0',
  `affiliate_new_value` int(5) NOT NULL default '0',
  `affiliate_old_value` int(5) default NULL,
  `affiliate_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_notified` int(1) default '0',
  PRIMARY KEY  (`affiliate_status_history_id`)
) TYPE=InnoDB AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `affiliate_sales`;
CREATE TABLE `affiliate_sales` (
  `affiliate_id` int(11) NOT NULL default '0',
  `affiliate_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_browser` varchar(100) NOT NULL default '',
  `affiliate_ipaddress` varchar(20) NOT NULL default '',
  `affiliate_orders_id` int(11) NOT NULL default '0',
  `affiliate_value` decimal(15,2) NOT NULL default '0.00',
  `affiliate_payment` decimal(15,2) NOT NULL default '0.00',
  `affiliate_clickthroughs_id` int(11) NOT NULL default '0',
  `affiliate_billing_status` int(5) NOT NULL default '0',
  `affiliate_payment_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_payment_id` int(11) NOT NULL default '0',
  `affiliate_percent` decimal(4,2) NOT NULL default '0.00',
  `affiliate_salesman` int(11) NOT NULL default '0',
  PRIMARY KEY  (`affiliate_orders_id`,`affiliate_id`)
) TYPE=InnoDB;


DROP TABLE IF EXISTS `articles`;
CREATE TABLE `articles` (
  `articles_id` int(11) NOT NULL auto_increment,
  `articles_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `articles_last_modified` datetime default NULL,
  `articles_date_available` datetime default NULL,
  `articles_status` tinyint(1) NOT NULL default '0',
  `authors_id` int(11) default NULL,
  `sort_order` int(4) NOT NULL,
  `articles_redirect` varchar(255) default NULL,
  PRIMARY KEY  (`articles_id`),
  KEY `idx_articles_date_added` (`articles_date_added`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;

INSERT INTO `articles` (`articles_id`, `articles_date_added`, `articles_last_modified`, `articles_date_available`, `articles_status`, `authors_id`, `sort_order`) VALUES
(1,  NOW(), NULL, NULL, 1, 0, 1),
(2, NOW(), NULL, NULL, 1, 0, 0);


DROP TABLE IF EXISTS `articles_description`;
CREATE TABLE `articles_description` (
  `articles_id` int(11) NOT NULL auto_increment,
  `language_id` int(11) NOT NULL default '1',
  `articles_name` varchar(64) NOT NULL default '',
  `articles_description` text,
  `articles_url` varchar(255) default NULL,
  `articles_viewed` int(5) default '0',
  `articles_head_title_tag` varchar(80) default NULL,
  `articles_head_desc_tag` text,
  `articles_head_keywords_tag` text,
  PRIMARY KEY  (`articles_id`,`language_id`),
  KEY `articles_name` (`articles_name`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;

INSERT INTO `articles_description` (`articles_id`, `language_id`, `articles_name`, `articles_description`, `articles_url`, `articles_viewed`, `articles_head_title_tag`, `articles_head_desc_tag`, `articles_head_keywords_tag`) VALUES
(1, 1, 'Contact us', '<p>Contact us page:</p>\r\n<p>{:MODULE_CONTACT_US:}</p>', '', 23, 'Contact us', 'Contact us', 'Contact us'),
(2, 1, 'Site map', '<p>{:MODULE_SITE_MAP:}</p>', '', 16, 'Site map', 'Site map', 'Site map');


DROP TABLE IF EXISTS `articles_to_topics`;
CREATE TABLE `articles_to_topics` (
  `articles_id` int(11) NOT NULL default '0',
  `topics_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`articles_id`,`topics_id`)
) TYPE=MyISAM;

INSERT INTO `articles_to_topics` (`articles_id`, `topics_id`) VALUES
(1, 0),
(2, 0);



DROP TABLE IF EXISTS `article_reviews`;
CREATE TABLE `article_reviews` (
  `reviews_id` int(11) NOT NULL auto_increment,
  `articles_id` int(11) NOT NULL default '0',
  `customers_id` int(11) default NULL,
  `customers_name` varchar(64) NOT NULL default '',
  `reviews_rating` int(1) default NULL,
  `date_added` datetime default NULL,
  `last_modified` datetime default NULL,
  `reviews_read` int(5) NOT NULL default '0',
  `approved` tinyint(3) unsigned default '0',
  PRIMARY KEY  (`reviews_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `article_reviews_description`;
CREATE TABLE `article_reviews_description` (
  `reviews_id` int(11) NOT NULL default '0',
  `languages_id` int(11) NOT NULL default '0',
  `reviews_text` text NOT NULL,
  PRIMARY KEY  (`reviews_id`,`languages_id`)
) TYPE=MyISAM;



DROP TABLE IF EXISTS `authors`;
CREATE TABLE `authors` (
  `authors_id` int(11) NOT NULL auto_increment,
  `authors_name` varchar(32) NOT NULL default '',
  `authors_image` varchar(64) default NULL,
  `date_added` datetime default NULL,
  `last_modified` datetime default NULL,
  PRIMARY KEY  (`authors_id`),
  KEY `IDX_AUTHORS_NAME` (`authors_name`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `authors_info`;
CREATE TABLE `authors_info` (
  `authors_id` int(11) NOT NULL default '0',
  `languages_id` int(11) NOT NULL default '0',
  `authors_description` text,
  `authors_url` varchar(255) NOT NULL default '',
  `url_clicked` int(5) NOT NULL default '0',
  `date_last_click` datetime default NULL,
  PRIMARY KEY  (`authors_id`,`languages_id`)
) TYPE=MyISAM;



DROP TABLE IF EXISTS `banners`;
CREATE TABLE `banners` (
  `banners_id` int(11) NOT NULL auto_increment,
  `banners_title` varchar(64) NOT NULL default '',
  `banners_url` varchar(255) NOT NULL default '',
  `banners_image` varchar(64) NOT NULL default '',
  `banners_group` varchar(255) NOT NULL default '',
  `banners_html_text` text,
  `expires_impressions` int(7) default NULL,
  `expires_clicks` int(7) default NULL,
  `expires_date` datetime default NULL,
  `date_scheduled` datetime default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_status_change` datetime default NULL,
  `status` int(1) NOT NULL default '1',
  PRIMARY KEY  (`banners_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1;

INSERT INTO `banners` (`banners_id`, `banners_title`, `banners_url`, `banners_image`, `banners_group`, `banners_html_text`, `expires_impressions`, `expires_clicks`, `expires_date`, `date_scheduled`, `date_added`, `date_status_change`, `status`) VALUES
(1, 'Adsense bottom', '', '', 'banner_bottom', '<script type="text/javascript"><!--\r\ngoogle_ad_client = "pub-5646984675357361";\r\n/* 728x90, created 4/30/09 */\r\ngoogle_ad_slot = "5203836540";\r\ngoogle_ad_width = 728;\r\ngoogle_ad_height = 90;\r\n//-->\r\n</script>\r\n<script type="text/javascript"\r\nsrc="http://pagead2.googlesyndication.com/pagead/show_ads.js">\r\n</script>', NULL, NULL, NULL, NULL, NOW(), NULL, 1);


DROP TABLE IF EXISTS `banners_groups`;
CREATE TABLE `banners_groups` (
  `banners_groups_id` int(11) NOT NULL auto_increment,
  `banners_groups` varchar(255) NOT NULL default '',
  `banners_groups_title` varchar(255) NOT NULL default '',
  `banners_groups_description` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`banners_groups_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;



INSERT INTO `banners_groups` (`banners_groups_id`, `banners_groups`, `banners_groups_title`, `banners_groups_description`) VALUES
(1, 'banner_top', 'Banner Top', ''),
(2, 'banner_left', 'Banner Left', ''),
(3, 'banner_right', 'Banner Right', ''),
(4, 'banner_bottom', 'Banner Bottom', '');



DROP TABLE IF EXISTS `banners_history`;
CREATE TABLE `banners_history` (
  `banners_history_id` int(11) NOT NULL auto_increment,
  `banners_id` int(11) NOT NULL default '0',
  `banners_shown` int(5) NOT NULL default '0',
  `banners_clicked` int(5) NOT NULL default '0',
  `banners_history_date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`banners_history_id`),
  KEY `banners_id` (`banners_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `cache`;
CREATE TABLE `cache` (
  `cache_id` varchar(32) NOT NULL default '',
  `cache_language_id` tinyint(1) NOT NULL default '0',
  `cache_name` varchar(255) NOT NULL default '',
  `cache_data` mediumtext NOT NULL,
  `cache_global` tinyint(1) NOT NULL default '1',
  `cache_gzip` tinyint(1) NOT NULL default '1',
  `cache_method` varchar(20) NOT NULL default 'RETURN',
  `cache_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `cache_expires` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`cache_id`,`cache_language_id`),
  KEY `cache_id` (`cache_id`),
  KEY `cache_language_id` (`cache_language_id`),
  KEY `cache_global` (`cache_global`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS `carriers`;
CREATE TABLE `carriers` (
  `carrier_id` int(11) NOT NULL auto_increment,
  `carrier_name` varchar(32) NOT NULL,
  `carrier_link` varchar(255) NOT NULL,
  PRIMARY KEY  (`carrier_id`),
  KEY `carrier_name` (`carrier_name`)
) TYPE=MyISAM AUTO_INCREMENT=1;

INSERT INTO `carriers` (`carrier_id`, `carrier_name`, `carrier_link`) VALUES
(1, 'USPS', 'http://trkcnfrm1.smi.usps.com/PTSInternetWeb/InterLabelInquiry.do?origTrackNum=#tracking#'),
(2, 'FedEx', 'http://www.fedex.com/cgi-bin/tracking?action=track&language=english&cntry_code=us&initial=x&tracknumbers=#tracking#'),
(3, 'UPS', 'http://wwwapps.ups.com/etracking/tracking.cgi?TypeOfInquiryNumber=T&InquiryNumber1=#tracking#'),
(4, 'DHL', 'http://track.dhl-usa.com/TrackByNbr.asp?ShipmentNumber=#tracking#');

DROP TABLE IF EXISTS `categories`;
CREATE TABLE `categories` (
  `categories_id` int(11) NOT NULL auto_increment,
  `categories_image` varchar(64) default NULL,
  `parent_id` int(11) NOT NULL default '0',
  `sort_order` int(3) default NULL,
  `products_sort` varchar(30) NOT NULL,
  `date_added` datetime default NULL,
  `last_modified` datetime default NULL,
  `categories_status` tinyint(1) NOT NULL default '1',
  `categories_comments` text NOT NULL,
  `categories_subscribe` varchar(64) NOT NULL default '',
  `virtual_display` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`categories_id`),
  KEY `idx_categories_parent_id` (`parent_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1;



DROP TABLE IF EXISTS `categories_description`;
CREATE TABLE `categories_description` (
  `categories_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `categories_name` varchar(255) NOT NULL default '',
  `categories_heading_title` varchar(255) default NULL,
  `categories_description` text,
  `categories_meta_keywords` varchar(255) NOT NULL default '',
  `categories_meta_description` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`categories_id`,`language_id`),
  KEY `idx_categories_name` (`categories_name`)
) TYPE=MyISAM;



DROP TABLE IF EXISTS `configuration`;
CREATE TABLE `configuration` (
  `configuration_id` int(11) NOT NULL auto_increment,
  `configuration_title` varchar(64) NOT NULL default '',
  `configuration_key` varchar(64) NOT NULL default '',
  `configuration_value` varchar(255) NOT NULL default '',
  `configuration_description` varchar(255) NOT NULL default '',
  `configuration_group_id` int(11) NOT NULL default '0',
  `sort_order` int(5) default NULL,
  `last_modified` datetime default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `use_function` varchar(255) default NULL,
  `set_function` text,
  PRIMARY KEY  (`configuration_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1;

INSERT INTO `configuration` (`configuration_id`, `configuration_title`, `configuration_key`, `configuration_value`, `configuration_description`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES
(1, 'Store Name', 'STORE_NAME', 'eclime.com', 'The name of my store', 1, 1, NOW(), NOW(), NULL, NULL),
(2, 'Store Owner', 'STORE_OWNER', 'John Doe', 'The name of my store owner', 1, 2, NOW(), NOW(), NULL, NULL),
(3, 'E-Mail Address', 'STORE_OWNER_EMAIL_ADDRESS', 'test@testing.com', 'The e-mail address of my store owner', 1, 3, NOW(), NOW(), NULL, NULL),
(4, 'E-Mail From', 'EMAIL_FROM', 'John Doe <test@testing.com>', 'The e-mail address used in (sent) e-mails', 1, 4, NOW(), NOW(), NULL, NULL),
(5, 'Country', 'STORE_COUNTRY', '223', 'The country my store is located in <br><br><b>Note: Please remember to update the store zone.</b>', 1, 6, NULL, NOW(), 'tep_get_country_name', 'tep_cfg_pull_down_country_list('),
(6, 'Zone', 'STORE_ZONE', '51', 'The zone my store is located in', 1, 7, NOW(), NOW(), 'tep_cfg_get_zone_name', 'tep_cfg_pull_down_zone_list('),
(1630, 'Handling Fee', 'MODULE_SHIPPING_TABLE_HANDLING', '0', 'Handling fee for this shipping method.', 6, 0, NULL, NOW(), NULL, NULL),
(10, 'Send Extra Order Emails To', 'SEND_EXTRA_ORDER_EMAILS_TO', '', 'Send extra order emails to the following email addresses, in this format: Name 1 &lt;email@address1&gt;, Name 2 &lt;email@address2&gt;', 1, 11, NULL, NOW(), NULL, NULL),
(1632, 'Sort order of display.', 'MODULE_SHIPPING_TABLE_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', 6, 0, NULL, NOW(), NULL, NULL),
(12, 'Display Cart After Adding Product', 'DISPLAY_CART', 'true', 'Display the shopping cart after adding a product (or return back to their origin)', 1, 14, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(14, 'Default Search Operator', 'ADVANCED_SEARCH_DEFAULT_OPERATOR', 'and', 'Default search operators', 1, 17, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''and'', ''or''),'),
(15, 'Store Address and Phone', 'STORE_NAME_ADDRESS', '123 Testing Ave \r\nPhiladelphia PA 19116\r\n215-333-4444', 'This is the Store Name, Address and Phone used on printable documents and displayed online', 1, 18, NOW(), NOW(), NULL, 'tep_cfg_textarea('),
(17, 'Tax Decimal Places', 'TAX_DECIMAL_PLACES', '2', 'Pad the tax value this amount of decimal places', 1, 20, NOW(), NOW(), NULL, NULL),
(18, 'Display Prices with Tax', 'DISPLAY_PRICE_WITH_TAX', 'false', 'Display prices with tax included (true) or add the tax at the end (false)', 1, 21, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(19, 'First Name', 'ENTRY_FIRST_NAME_MIN_LENGTH', '2', 'Minimum length of first name', 2, 1, NULL, NOW(), NULL, NULL),
(20, 'Last Name', 'ENTRY_LAST_NAME_MIN_LENGTH', '2', 'Minimum length of last name', 2, 2, NULL, NOW(), NULL, NULL),
(21, 'Date of Birth', 'ENTRY_DOB_MIN_LENGTH', '10', 'Minimum length of date of birth', 2, 3, NULL, NOW(), NULL, NULL),
(22, 'E-Mail Address', 'ENTRY_EMAIL_ADDRESS_MIN_LENGTH', '6', 'Minimum length of e-mail address', 2, 4, NULL, NOW(), NULL, NULL),
(23, 'Street Address', 'ENTRY_STREET_ADDRESS_MIN_LENGTH', '5', 'Minimum length of street address', 2, 5, NULL, NOW(), NULL, NULL),
(24, 'Company', 'ENTRY_COMPANY_MIN_LENGTH', '2', 'Minimum length of company name', 2, 6, NULL, NOW(), NULL, NULL),
(25, 'Post Code', 'ENTRY_POSTCODE_MIN_LENGTH', '4', 'Minimum length of post code', 2, 7, NULL, NOW(), NULL, NULL),
(26, 'City', 'ENTRY_CITY_MIN_LENGTH', '3', 'Minimum length of city', 2, 8, NULL, NOW(), NULL, NULL),
(27, 'State', 'ENTRY_STATE_MIN_LENGTH', '2', 'Minimum length of state', 2, 9, NULL, NOW(), NULL, NULL),
(28, 'Telephone Number', 'ENTRY_TELEPHONE_MIN_LENGTH', '3', 'Minimum length of telephone number', 2, 10, NULL, NOW(), NULL, NULL),
(29, 'Password', 'ENTRY_PASSWORD_MIN_LENGTH', '5', 'Minimum length of password', 2, 11, NULL, NOW(), NULL, NULL),
(30, 'Credit Card Owner Name', 'CC_OWNER_MIN_LENGTH', '3', 'Minimum length of credit card owner name', 2, 12, NULL, NOW(), NULL, NULL),
(31, 'Credit Card Number', 'CC_NUMBER_MIN_LENGTH', '10', 'Minimum length of credit card number', 2, 13, NULL, NOW(), NULL, NULL),
(32, 'Review Text', 'REVIEW_TEXT_MIN_LENGTH', '1', 'Minimum length of review text', 2, 14, NOW(), NOW(), NULL, NULL),
(33, 'Best Sellers', 'MIN_DISPLAY_BESTSELLERS', '1', 'Minimum number of best sellers to display', 2, 15, NULL, NOW(), NULL, NULL),
(34, 'Also Purchased', 'MIN_DISPLAY_ALSO_PURCHASED', '1', 'Minimum number of products to display in the ''This Customer Also Purchased'' box', 2, 16, NULL, NOW(), NULL, NULL),
(35, 'Address Book Entries', 'MAX_ADDRESS_BOOK_ENTRIES', '5', 'Maximum address book entries a customer is allowed to have', 3, 1, NULL, NOW(), NULL, NULL),
(36, 'Search Results', 'MAX_DISPLAY_SEARCH_RESULTS', '30', 'Amount of products to list', 3, 2, NOW(), NOW(), NULL, NULL),
(37, 'Page Links', 'MAX_DISPLAY_PAGE_LINKS', '5', 'Number of ''number'' links use for page-sets', 3, 3, NULL, NOW(), NULL, NULL),
(38, 'Special Products', 'MAX_DISPLAY_SPECIAL_PRODUCTS', '9', 'Maximum number of products on special to display', 3, 4, NOW(), NOW(), NULL, NULL),
(39, 'New Products Listing', 'MAX_DISPLAY_NEW_PRODUCTS', '40', 'Maximum number of new products to display in a category', 3, 14, NOW(), NOW(), NULL, NULL),
(40, 'Products Expected', 'MAX_DISPLAY_UPCOMING_PRODUCTS', '3', 'Maximum number of products expected to display', 3, 6, NOW(), NOW(), NULL, NULL),
(41, 'Manufacturers List', 'MAX_DISPLAY_MANUFACTURERS_IN_A_LIST', '0', 'Used in manufacturers box; when the number of manufacturers exceeds this number, a drop-down list will be displayed instead of the default list', 3, 7, NULL, NOW(), NULL, NULL),
(42, 'Manufacturers Select Size', 'MAX_MANUFACTURERS_LIST', '1', 'Used in manufacturers box; when this value is ''1'' the classic drop-down list will be used for the manufacturers box. Otherwise, a list-box with the specified number of rows will be displayed.', 3, 7, NULL, NOW(), NULL, NULL),
(43, 'Length of Manufacturers Name', 'MAX_DISPLAY_MANUFACTURER_NAME_LEN', '15', 'Used in manufacturers box; maximum length of manufacturers name to display', 3, 8, NULL, NOW(), NULL, NULL),
(44, 'New Reviews', 'MAX_DISPLAY_NEW_REVIEWS', '6', 'Maximum number of new reviews to display', 3, 9, NULL, NOW(), NULL, NULL),
(45, 'Selection of Random Reviews', 'MAX_RANDOM_SELECT_REVIEWS', '10', 'How many records to select from to choose one random product review', 3, 10, NULL, NOW(), NULL, NULL),
(46, 'Selection of Random New Products', 'MAX_RANDOM_SELECT_NEW', '10', 'How many records to select from to choose one random new product to display', 3, 11, NULL, NOW(), NULL, NULL),
(47, 'Selection of Products on Special', 'MAX_RANDOM_SELECT_SPECIALS', '10', 'How many records to select from to choose one random product special to display', 3, 12, NULL, NOW(), NULL, NULL),
(50, 'Best Sellers', 'MAX_DISPLAY_BESTSELLERS', '10', 'Maximum number of best sellers to display', 3, 15, NULL, NOW(), NULL, NULL),
(51, 'Also Purchased', 'MAX_DISPLAY_ALSO_PURCHASED', '6', 'Maximum number of products to display in the ''This Customer Also Purchased'' box', 3, 16, NULL, NOW(), NULL, NULL),
(53, 'Order History', 'MAX_DISPLAY_ORDER_HISTORY', '10', 'Maximum number of orders to display in the order history page', 3, 18, NULL, NOW(), NULL, NULL),
(54, 'Small Image Width', 'SMALL_IMAGE_WIDTH', '100', 'The pixel width of small images', 4, 1, NULL, NOW(), NULL, NULL),
(55, 'Small Image Height', 'SMALL_IMAGE_HEIGHT', '100', 'The pixel height of small images', 4, 2, NOW(), NOW(), NULL, NULL),
(56, 'Heading Image Width', 'HEADING_IMAGE_WIDTH', '57', 'The pixel width of heading images', 4, 3, NULL, NOW(), NULL, NULL),
(57, 'Heading Image Height', 'HEADING_IMAGE_HEIGHT', '57', 'The pixel height of heading images', 4, 4, NOW(), NOW(), NULL, NULL),
(58, 'Subcategory Image Width', 'SUBCATEGORY_IMAGE_WIDTH', '150', 'The pixel width of subcategory images', 4, 5, NOW(), NOW(), NULL, NULL),
(59, 'Subcategory Image Height', 'SUBCATEGORY_IMAGE_HEIGHT', '150', 'The pixel height of subcategory images', 4, 6, NOW(), NOW(), NULL, NULL),
(60, 'Calculate Image Size', 'CONFIG_CALCULATE_IMAGE_SIZE', 'true', 'Calculate the size of images?', 4, 7, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(61, 'Image Required', 'IMAGE_REQUIRED', 'true', 'Enable to display broken images. Good for development.', 4, 8, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(62, 'Gender', 'ACCOUNT_GENDER', 'true', 'Display gender in the customers account', 5, 1, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(63, 'Date of Birth', 'ACCOUNT_DOB', 'true', 'Display date of birth in the customers account', 5, 2, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(64, 'Company', 'ACCOUNT_COMPANY', 'true', 'Display company in the customers account', 5, 3, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(65, 'Suburb', 'ACCOUNT_SUBURB', 'true', 'Display suburb in the customers account', 5, 4, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(66, 'State', 'ACCOUNT_STATE', 'true', 'Display state in the customers account', 5, 5, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(67, 'Installed Modules', 'MODULE_PAYMENT_INSTALLED', 'moneyorder.php', 'List of payment module filenames separated by a semi-colon. This is automatically updated. No need to edit. (Example: cc.php;cod.php;paypal.php)', 6, 0, NOW(), NOW(), NULL, NULL),
(68, 'Installed Modules', 'MODULE_ORDER_TOTAL_INSTALLED', 'ot_subtotal.php;ot_shipping.php;ot_tax.php;ot_loyalty_discount.php;ot_loworderfee.php;ot_coupon.php;ot_gv.php;ot_total.php', 'List of order_total module filenames separated by a semi-colon. This is automatically updated. No need to edit. (Example: ot_subtotal.php;ot_tax.php;ot_shipping.php;ot_total.php)', 6, 0, NOW(), NOW(), NULL, NULL),
(69, 'Installed Modules', 'MODULE_SHIPPING_INSTALLED', 'flat.php;freeshipper.php;indvship.php;item.php;table.php;zones.php', 'List of shipping module filenames separated by a semi-colon. This is automatically updated. No need to edit. (Example: ups.php;flat.php;item.php)', 6, 0, NOW(), NOW(), NULL, NULL),
(70, 'Fax', 'ACCOUNT_FAX', 'true', 'Display fax in the customers account', 5, 6, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(84, 'Default Currency', 'DEFAULT_CURRENCY', 'USD', 'Default Currency', 6, 0, NULL, NOW(), NULL, NULL),
(85, 'Default Language', 'DEFAULT_LANGUAGE', 'en', 'Default Language', 6, 0, NULL, NOW(), NULL, NULL),
(86, 'Default Order Status For New Orders', 'DEFAULT_ORDERS_STATUS_ID', '1', 'When a new order is created, this order status will be assigned to it.', 6, 0, NULL, NOW(), NULL, NULL),
(87, 'Display Shipping', 'MODULE_ORDER_TOTAL_SHIPPING_STATUS', 'true', 'Do you want to display the order shipping cost?', 6, 1, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(88, 'Sort Order', 'MODULE_ORDER_TOTAL_SHIPPING_SORT_ORDER', '2', 'Sort order of display.', 6, 2, NULL, NOW(), NULL, NULL),
(89, 'Allow Free Shipping', 'MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING', 'false', 'Do you want to allow free shipping?', 6, 3, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(90, 'Free Shipping For Orders Over', 'MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER', '5', 'Provide free shipping for orders over the set amount.', 6, 4, NULL, NOW(), 'currencies->format', NULL),
(91, 'Provide Free Shipping For Orders Made', 'MODULE_ORDER_TOTAL_SHIPPING_DESTINATION', 'national', 'Provide free shipping for orders sent to the set destination.', 6, 5, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''national'', ''international'', ''both''),'),
(92, 'Display Sub-Total', 'MODULE_ORDER_TOTAL_SUBTOTAL_STATUS', 'true', 'Do you want to display the order sub-total cost?', 6, 1, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(93, 'Sort Order', 'MODULE_ORDER_TOTAL_SUBTOTAL_SORT_ORDER', '1', 'Sort order of display.', 6, 2, NULL, NOW(), NULL, NULL),
(454, 'Sort Order', 'MODULE_ORDER_TOTAL_TAX_SORT_ORDER', '3', 'Sort order of display.', 6, 2, NULL, NOW(), NULL, NULL),
(453, 'Display Tax', 'MODULE_ORDER_TOTAL_TAX_STATUS', 'true', 'Do you want to display the order tax value?', 6, 1, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(96, 'Display Total', 'MODULE_ORDER_TOTAL_TOTAL_STATUS', 'true', 'Do you want to display the total order value?', 6, 1, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(97, 'Sort Order', 'MODULE_ORDER_TOTAL_TOTAL_SORT_ORDER', '900', 'Sort order of display.', 6, 2, NULL, NOW(), NULL, NULL),
(98, 'Country of Origin', 'SHIPPING_ORIGIN_COUNTRY', '223', 'Select the country of origin to be used in shipping quotes.', 7, 1, NULL, NOW(), 'tep_get_country_name', 'tep_cfg_pull_down_country_list('),
(99, 'Postal Code', 'SHIPPING_ORIGIN_ZIP', '19116', 'Enter the Postal Code (ZIP) of the Store to be used in shipping quotes.', 7, 2, NOW(), NOW(), NULL, NULL),
(100, 'Enter the Maximum Package Weight you will ship', 'SHIPPING_MAX_WEIGHT', '50', 'Carriers have a max weight limit for a single package. This is a common one for all.', 7, 3, NULL, NOW(), NULL, NULL),
(101, 'Package Tare weight.', 'SHIPPING_BOX_WEIGHT', '1', 'What is the weight of typical packaging of small to medium packages?', 7, 4, NOW(), NOW(), NULL, NULL),
(102, 'Larger packages - percentage increase.', 'SHIPPING_BOX_PADDING', '10', 'For 10% enter 10', 7, 5, NULL, NOW(), NULL, NULL),
(1613, 'New Categories Listing', 'MAX_DISPLAY_NEW_CATEGORIES', '10', 'Maximum number of new categories to display in new categories page', 3, 15, NOW(), NOW(), NULL, NULL),
(113, 'Check stock level', 'STOCK_CHECK', 'true', 'Check to see if sufficent stock is available', 9, 1, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(114, 'Subtract stock', 'STOCK_LIMITED', 'true', 'Subtract product in stock by product orders', 9, 2, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(115, 'Allow Checkout', 'STOCK_ALLOW_CHECKOUT', 'true', 'Allow customer to checkout even if there is insufficient stock', 9, 3, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(116, 'Mark product out of stock', 'STOCK_MARK_PRODUCT_OUT_OF_STOCK', '***', 'Display something on screen so customer can see which product has insufficient stock', 9, 4, NULL, NOW(), NULL, NULL),
(117, 'Stock Re-order level', 'STOCK_REORDER_LEVEL', '5', 'Define when stock needs to be re-ordered', 9, 5, NULL, NOW(), NULL, NULL),
(118, 'Store Page Parse Time', 'STORE_PAGE_PARSE_TIME', 'false', 'Store the time it takes to parse a page', 10, 1, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(119, 'Log Destination', 'STORE_PAGE_PARSE_TIME_LOG', '/var/log/www/tep/page_parse_time.log', 'Directory and filename of the page parse time log', 10, 2, NULL, NOW(), NULL, NULL),
(120, 'Log Date Format', 'STORE_PARSE_DATE_TIME_FORMAT', '%d/%m/%Y %H:%M:%S', 'The date format', 10, 3, NULL, NOW(), NULL, NULL),
(121, 'Display The Page Parse Time', 'DISPLAY_PAGE_PARSE_TIME', 'false', 'Display the page parse time (store page parse time must be enabled)', 10, 4, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(122, 'Store Database Queries', 'STORE_DB_TRANSACTIONS', 'false', 'Store the database queries in the page parse time log (PHP4 only)', 10, 5, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(125, 'E-Mail Transport Method', 'EMAIL_TRANSPORT', 'sendmail', 'Defines if this server uses a local connection to sendmail or uses an SMTP connection via TCP/IP. Servers running on Windows and MacOS should change this setting to SMTP.', 12, 1, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''sendmail'', ''smtp''),'),
(126, 'E-Mail Linefeeds', 'EMAIL_LINEFEED', 'LF', 'Defines the character sequence used to separate mail headers.', 12, 2, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''LF'', ''CRLF''),'),
(127, 'Use MIME HTML When Sending Emails', 'EMAIL_USE_HTML', 'false', 'Send e-mails in HTML format', 12, 3, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(128, 'Verify E-Mail Addresses Through DNS', 'ENTRY_EMAIL_ADDRESS_CHECK', 'false', 'Verify e-mail address through a DNS server', 12, 4, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(129, 'Send E-Mails', 'SEND_EMAILS', 'true', 'Send out e-mails', 12, 5, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(130, 'Enable download', 'DOWNLOAD_ENABLED', 'true', 'Enable the products download functions.', 13, 1, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(131, 'Download by redirect', 'DOWNLOAD_BY_REDIRECT', 'true', 'Use browser redirection for download. Disable on non-Unix systems.', 13, 2, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(132, 'Expiry delay (days)', 'DOWNLOAD_MAX_DAYS', '7', 'Set number of days before the download link expires. 0 means no limit.', 13, 3, NULL, NOW(), NULL, ''),
(133, 'Maximum number of downloads', 'DOWNLOAD_MAX_COUNT', '5', 'Set the maximum number of downloads. 0 means no download authorized.', 13, 4, NULL, NOW(), NULL, ''),
(136, 'Session Directory', 'SESSION_WRITE_DIRECTORY', '', 'If sessions are file based, store them in this directory.', 15, 1, NOW(), NOW(), NULL, NULL),
(137, 'Force Cookie Use', 'SESSION_FORCE_COOKIE_USE', 'False', 'Force the use of sessions when cookies are only enabled.', 15, 2, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''True'', ''False''),'),
(138, 'Check SSL Session ID', 'SESSION_CHECK_SSL_SESSION_ID', 'False', 'Validate the SSL_SESSION_ID on every secure HTTPS page request.', 15, 3, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''True'', ''False''),'),
(139, 'Check User Agent', 'SESSION_CHECK_USER_AGENT', 'False', 'Validate the clients browser user agent on every page request.', 15, 4, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''True'', ''False''),'),
(140, 'Check IP Address', 'SESSION_CHECK_IP_ADDRESS', 'False', 'Validate the clients IP address on every page request.', 15, 5, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''True'', ''False''),'),
(141, 'Prevent Spider Sessions', 'SESSION_BLOCK_SPIDERS', 'True', 'Prevent known spiders from starting a session.', 15, 6, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''True'', ''False''),'),
(142, 'Recreate Session', 'SESSION_RECREATE', 'True', 'Recreate the session to generate a new session ID when the customer logs on or creates an account (PHP >=4.1 needed).', 15, 7, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''True'', ''False''),'),
(143, 'Categories/Products Description', 'HTML_EDITOR_CATEGORIES_PRODUCTS_DESCRIPTION', 'Enable', 'Enable/Disable HTML Editor on products description page.', 112, 0, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''Enable'', ''Disable''),'),
(144, 'Topics/Articles', 'HTML_EDITOR_TOPICS_ARTICLES', 'Enable', 'Enable/Disable HTML Editor on product description page.', 112, 0, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''Enable'', ''Disable''),'),
(145, 'Newsletters', 'HTML_EDITOR_NEWSLETTER', 'Enable', 'Enable/Disable HTML Editor on newsletter page.', 112, 0, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''Enable'', ''Disable''),'),
(146, 'Send Email', 'HTML_EDITOR_SEND_EMAIL', 'Enable', 'Enable/Disable HTML Editor on send email page.', 112, 0, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''Enable'', ''Disable''),'),
(147, 'HTML Editor', 'HTML_EDITOR_ADVANCED_BASIC', 'Basic', 'Advanced/Basic HTML Editor.<br />Basic Features FASTER<br />Advanced Features SLOWER.', 112, 0, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''Advanced'', ''Basic''),'),
(177, 'Display Total', 'MODULE_ORDER_TOTAL_COUPON_STATUS', 'true', 'Do you want to display the Discount Coupon value?', 6, 1, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(178, 'Sort Order', 'MODULE_ORDER_TOTAL_COUPON_SORT_ORDER', '9', 'Sort order of display.', 6, 2, NULL, NOW(), NULL, NULL),
(179, 'Include Shipping', 'MODULE_ORDER_TOTAL_COUPON_INC_SHIPPING', 'false', 'Include Shipping in calculation', 6, 5, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(180, 'Include Tax', 'MODULE_ORDER_TOTAL_COUPON_INC_TAX', 'false', 'Include Tax in calculation.', 6, 6, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(181, 'Re-calculate Tax', 'MODULE_ORDER_TOTAL_COUPON_CALC_TAX', 'None', 'Re-Calculate Tax', 6, 7, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''None'', ''Standard'', ''Credit Note''),'),
(182, 'Tax Class', 'MODULE_ORDER_TOTAL_COUPON_TAX_CLASS', '0', 'Use the following tax class when treating Discount Coupon as Credit Note.', 6, 0, NULL, NOW(), 'tep_get_tax_class_title', 'tep_cfg_pull_down_tax_classes('),
(211, 'Allow Category Descriptions', 'ALLOW_CATEGORY_DESCRIPTIONS', 'true', 'Allow use of full text descriptions for categories', 1, 19, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(212, 'Display category header', 'DISPLAY_CATEGORY_HEADER', 'Yes', 'Display category header', 1, 20, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''Yes'', ''No''),'),
(593, 'Prevent Adding Out of Stock to Cart', 'PRODINFO_ATTRIBUTE_NO_ADD_OUT_OF_STOCK', 'True', 'Prevents adding an out of stock attribute combination to the cart.', 888001, 40, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''True'', ''False''),'),
(592, 'Display Out of Stock Message Line', 'PRODINFO_ATTRIBUTE_OUT_OF_STOCK_MSGLINE', 'False', 'Controls the display of a message line indicating an out of stock attributes is selected.', 888001, 30, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''True'', ''False''),'),
(591, 'Mark Out of Stock Attributes', 'PRODINFO_ATTRIBUTE_MARK_OUT_OF_STOCK', 'Right', 'Controls how out of stock attributes are marked as out of stock.', 888001, 20, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''None'', ''Right'', ''Left''),'),
(590, 'Show Out of Stock Attributes', 'PRODINFO_ATTRIBUTE_SHOW_OUT_OF_STOCK', 'True', 'Controls the display of out of stock attributes.', 888001, 10, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''True'', ''False''),'),
(1631, 'Shipping Zone', 'MODULE_SHIPPING_TABLE_ZONE', '0', 'If a zone is selected, only enable this shipping method for that zone.', 6, 0, NULL, NOW(), 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes('),
(358, 'Downloads Controller Update Status Value', 'DOWNLOADS_ORDERS_STATUS_UPDATED_VALUE', '100000', 'What orders_status resets the Download days and Max Downloads - Default is 4', 13, 90, NOW(), NOW(), NULL, NULL),
(359, 'Downloads Controller Download on hold message', 'DOWNLOADS_CONTROLLER_ON_HOLD_MSG', '<br /><span style="color:#FF0000;">NOTE: Downloads are not available until payment has been confirmed</span>', 'Downloads Controller Download on hold message', 13, 91, NOW(), NOW(), NULL, NULL),
(360, 'Downloads Controller Order Status Value', 'DOWNLOADS_CONTROLLER_ORDERS_STATUS', '2', 'Downloads Controller Order Status Value - Default=2', 13, 92, NOW(), NOW(), NULL, NULL),
(378, '<B>Down for Maintenance: ON/OFF</B>', 'DOWN_FOR_MAINTENANCE', 'false', 'Down for Maintenance <br>(true=on false=off)', 16, 1, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(379, 'Down for Maintenance: filename', 'DOWN_FOR_MAINTENANCE_FILENAME', 'down_for_maintenance.php', 'Down for Maintenance filename Default=down_for_maintenance.php', 16, 2, NULL, NOW(), NULL, ''),
(385, 'Down For Maintenance (exclude this IP-Address)', 'EXCLUDE_ADMIN_IP_FOR_MAINTENANCE', '', 'This IP Address is able to access the website while it is Down For Maintenance (like webmaster)', 16, 8, NOW(), NOW(), NULL, NULL),
(1719, 'Large Image Width', 'LARGE_IMAGE_WIDTH', '250', 'The pixel width of large images', 4, 1, NULL, NOW(), NULL, NULL),
(1720, 'Large Image Height', 'LARGE_IMAGE_HEIGHT', '250', 'The pixel height of large images', 4, 1, NULL, NOW(), NULL, NULL),
(387, 'Date and hours for notice before maintenance', 'PERIOD_BEFORE_DOWN_FOR_MAINTENANCE', '16/05/2003  between the hours of 2-3 PM', 'Date and hours for notice before maintenance website, enter date and hours for maintenance website', 16, 10, NOW(), NOW(), NULL, NULL),
(388, 'Display when webmaster has enabled maintenance', 'DISPLAY_MAINTENANCE_TIME', 'true', 'Display when Webmaster has enabled maintenance <br>(true=on false=off)<br>', 16, 11, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(389, 'Display website maintenance period', 'DISPLAY_MAINTENANCE_PERIOD', 'true', 'Display Website maintenance period <br>(true=on false=off)<br>', 16, 12, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(390, 'Website maintenance period', 'TEXT_MAINTENANCE_PERIOD_TIME', '2h00', 'Enter Website Maintenance period (hh:mm)', 16, 13, NOW(), NOW(), NULL, NULL),
(505, 'Display New Articles Link', 'DISPLAY_NEW_ARTICLES', 'true', 'Display a link to New Articles in the Articles box?', 456, 1, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(506, 'Number of Days Display New Articles', 'NEW_ARTICLES_DAYS_DISPLAY', '30', 'The number of days to display New Articles?', 456, 2, NOW(), NOW(), NULL, NULL),
(507, 'Maximum New Articles Per Page', 'MAX_NEW_ARTICLES_PER_PAGE', '10', 'The maximum number of New Articles to display per page<br>(New Articles page)', 456, 3, NOW(), NOW(), NULL, NULL),
(508, 'Display All Articles Link', 'DISPLAY_ALL_ARTICLES', 'true', 'Display a link to All Articles in the Articles box?', 456, 4, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(509, 'Maximum Articles Per Page', 'MAX_ARTICLES_PER_PAGE', '10', 'The maximum number of Articles to display per page<br>(All Articles and Topic/Author pages)', 456, 5, NOW(), NOW(), NULL, NULL),
(510, 'Maximum Display Upcoming Articles', 'MAX_DISPLAY_UPCOMING_ARTICLES', '5', 'Maximum number of articles to display in the Upcoming Articles module', 456, 6, NOW(), NOW(), NULL, NULL),
(511, 'Enable Article Reviews', 'ENABLE_ARTICLE_REVIEWS', 'true', 'Enable registered users to review articles?', 456, 7, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(512, 'Enable Tell a Friend About Article', 'ENABLE_TELL_A_FRIEND_ARTICLE', 'true', 'Enable Tell a Friend option in the Article Information page?', 456, 8, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(513, 'Minimum Number Cross-Sell Products', 'MIN_DISPLAY_ARTICLES_XSELL', '1', 'Minimum number of products to display in the articles Cross-Sell listing.', 456, 9, NOW(), NOW(), NULL, NULL),
(514, 'Maximum Number Cross-Sell Products', 'MAX_DISPLAY_ARTICLES_XSELL', '6', 'Maximum number of products to display in the articles Cross-Sell listing.', 456, 10, NOW(), NOW(), NULL, NULL),
(515, 'Show Article Counts', 'SHOW_ARTICLE_COUNTS', 'true', 'Count recursively how many articles are in each topic', 456, 11, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(516, 'Maximum Length of Author Name', 'MAX_DISPLAY_AUTHOR_NAME_LEN', '20', 'The maximum length of the author''s name for display in the Author box', 456, 12, NOW(), NOW(), NULL, NULL),
(517, 'Authors List Style', 'MAX_DISPLAY_AUTHORS_IN_A_LIST', '1', 'Used in Authors box. When the number of authors exceeds this number, a drop-down list will be displayed instead of the default list', 456, 13, NOW(), NOW(), NULL, NULL),
(518, 'Authors Select Box Size', 'MAX_AUTHORS_LIST', '1', 'Used in Authors box. When this value is 1 the classic drop-down list will be used for the authors box. Otherwise, a list-box with the specified number of rows will be displayed.', 456, 14, NOW(), NOW(), NULL, NULL),
(519, 'Display Author in Article Listing', 'DISPLAY_AUTHOR_ARTICLE_LISTING', 'false', 'Display the Author in the Article Listing?', 456, 15, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(520, 'Display Topic in Article Listing', 'DISPLAY_TOPIC_ARTICLE_LISTING', 'true', 'Display the Topic in the Article Listing?', 456, 16, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(521, 'Display Abstract in Article Listing', 'DISPLAY_ABSTRACT_ARTICLE_LISTING', 'true', 'Display the Abstract in the Article Listing?', 456, 17, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(522, 'Display Date Added in Article Listing', 'DISPLAY_DATE_ADDED_ARTICLE_LISTING', 'false', 'Display the Date Added in the Article Listing?', 456, 18, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(523, 'Maximum Article Abstract Length', 'MAX_ARTICLE_ABSTRACT_LENGTH', '300', 'Sets the maximum length of the Article Abstract to be displayed<br><br>(No. of characters)', 456, 19, NOW(), NOW(), NULL, NULL),
(524, 'Display Topic/Author Filter', 'ARTICLE_LIST_FILTER', 'false', 'Do you want to display the Topic/Author Filter?', 456, 20, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(525, 'Location of Prev/Next Navigation Bar', 'ARTICLE_PREV_NEXT_BAR_LOCATION', 'bottom', 'Sets the location of the Previous/Next Navigation Bar<br><br>(top; bottom; both)', 456, 21, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''top'', ''bottom'', ''both''),'),
(391, 'Down For Maintenance Start Time', 'TEXT_DATE_TIME', NOW(), 'Show when down for maintenance', 16, 14, NOW(), NOW(), NULL, NULL),
(1634, 'Enable Banner System', 'BANNER_SYSTEM_ENABLED', 'true', 'Enable banner system, this takes extra system resources and recommended to be turned off when not used.', 1, 10, NOW(), NOW(), '', 'tep_cfg_select_option(array(''false'', ''true''),'),
(1728, 'Max Wish List', 'MAX_DISPLAY_WISHLIST_PRODUCTS', '12', 'How many wish list items to show per page on the main wishlist.php file', 12954, 0, NOW(), NOW(), NULL, NULL),
(645, 'Tax Class', 'MODULE_ORDER_TOTAL_LOWORDERFEE_TAX_CLASS', '0', 'Use the following tax class on the low order fee.', 6, 7, NULL, NOW(), 'tep_get_tax_class_title', 'tep_cfg_pull_down_tax_classes('),
(644, 'Attach Low Order Fee On Orders Made', 'MODULE_ORDER_TOTAL_LOWORDERFEE_DESTINATION', 'both', 'Attach low order fee for orders sent to the set destination.', 6, 6, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''national'', ''international'', ''both''),'),
(643, 'Order Fee', 'MODULE_ORDER_TOTAL_LOWORDERFEE_FEE', '5', 'Low order fee.', 6, 5, NULL, NOW(), 'currencies->format', NULL),
(642, 'Order Fee For Orders Under', 'MODULE_ORDER_TOTAL_LOWORDERFEE_ORDER_UNDER', '50', 'Add the low order fee to orders under this amount.', 6, 4, NULL, NOW(), 'currencies->format', NULL),
(641, 'Allow Low Order Fee', 'MODULE_ORDER_TOTAL_LOWORDERFEE_LOW_ORDER_FEE', 'false', 'Do you want to allow low order fees?', 6, 3, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(640, 'Sort Order', 'MODULE_ORDER_TOTAL_LOWORDERFEE_SORT_ORDER', '5', 'Sort order of display.', 6, 2, NULL, NOW(), NULL, NULL),
(639, 'Display Low Order Fee', 'MODULE_ORDER_TOTAL_LOWORDERFEE_STATUS', 'true', 'Do you want to display the low order fee?', 6, 1, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(638, 'Order Status', 'MODULE_LOYALTY_DISCOUNT_ORDER_STATUS', '3', 'Set the minimum order status for an order to add it to the total amount ordered', 6, 8, NULL, NOW(), NULL, NULL),
(637, 'Discount Percentage', 'MODULE_LOYALTY_DISCOUNT_TABLE', '1000:5,1500:7.5,2000:10,3000:12.5,5000:15', 'Set the cumulative order total breaks per period set above, and discount percentages', 6, 7, NULL, NOW(), NULL, NULL),
(635, 'Calculate Tax', 'MODULE_LOYALTY_DISCOUNT_CALC_TAX', 'false', 'Re-calculate Tax on discounted amount.', 6, 5, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(636, 'Cumulative order total period', 'MODULE_LOYALTY_DISCOUNT_CUMORDER_PERIOD', 'year', 'Set the period over which to calculate cumulative order total.', 6, 6, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''alltime'', ''year'', ''quarter'', ''month''),'),
(634, 'Include Tax', 'MODULE_LOYALTY_DISCOUNT_INC_TAX', 'true', 'Include Tax in calculation.', 6, 4, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(633, 'Include Shipping', 'MODULE_LOYALTY_DISCOUNT_INC_SHIPPING', 'true', 'Include Shipping in calculation', 6, 3, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(632, 'Sort Order', 'MODULE_LOYALTY_DISCOUNT_SORT_ORDER', '4', 'Sort order of display.', 6, 2, NULL, NOW(), NULL, NULL),
(631, 'Display Total', 'MODULE_LOYALTY_DISCOUNT_STATUS', 'true', 'Do you want to enable the Order Discount?', 6, 1, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(601, 'Merchant Notifications', 'MODULE_PAYMENT_AUTHORIZENET_EMAIL_MERCHANT', 'True', 'Should Authorize.Net e-mail a receipt to the store owner?', 6, 0, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''True'', ''False''),'),
(1635, 'Enable Seo URL validation?', 'FWR_VALIDATION_ON', 'true', 'Enable the SEO URL validation?', 888002, 1, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(780, 'Enable SEO URLs?', 'SEO_URLS', 'false', 'Enable the SEO URLs?  This is a global setting and will turn them off completely.', 888002, 0, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(781, 'Choose URL Type', 'SEO_URLS_TYPE', 'Rewrite', 'Choose which SEO URL format to use:<br><br><b>cName =></b> /index.php?cName=XXX<br><b>Rewrite =></b> /XXX-c-1.html', 888002, 1, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''cName'', ''Rewrite''),'),
(782, 'Filter Short Words', 'SEO_URLS_FILTER_SHORT_WORDS', '2', 'This setting only affects the Rewrite option.  It will filter words less than or equal to the value from the URL.', 888002, 2, NOW(), NOW(), NULL, NULL),
(783, 'Reset SEO URLs Cache', 'SEO_URLS_CACHE_RESET', 'false', 'This will reset the cache data for SEO', 888002, 3, NOW(), NOW(), 'tep_reset_cache_data_seo_urls', 'tep_cfg_select_option(array(''reset'', ''false''),'),
(1200, 'Order Editor- Display Payment Method dropdown?', 'DISPLAY_PAYMENT_METHOD_DROPDOWN', 'true', 'Display Payment Method in Order Editor as dropdown menu (true) or as input field (false)', 1, 21, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(80, 'RSS Articles', 'MAX_RSS_ARTICLES', '10', 'Number of articles displayed by the RSS feed', 3, 25, NOW(), NOW(), NULL, NULL),
(1433, 'Tax Class', 'MODULE_ORDER_TOTAL_GV_TAX_CLASS', '0', 'Use the following tax class when treating Gift Voucher as Credit Note.', 6, 0, NULL, NOW(), 'tep_get_tax_class_title', 'tep_cfg_pull_down_tax_classes('),
(1434, 'Credit including Tax', 'MODULE_ORDER_TOTAL_GV_CREDIT_TAX', 'false', 'Add tax to purchased Gift Voucher when crediting to Account', 6, 8, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''), '),
(1432, 'Re-calculate Tax', 'MODULE_ORDER_TOTAL_GV_CALC_TAX', 'None', 'Re-Calculate Tax', 6, 7, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''None'', ''Standard'', ''Credit Note''), '),
(1431, 'Include Tax', 'MODULE_ORDER_TOTAL_GV_INC_TAX', 'true', 'Include Tax in calculation.', 6, 6, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''), '),
(1428, 'Sort Order', 'MODULE_ORDER_TOTAL_GV_SORT_ORDER', '740', 'Sort order of display.', 6, 2, NULL, NOW(), NULL, NULL),
(1429, 'Queue Purchases', 'MODULE_ORDER_TOTAL_GV_QUEUE', 'true', 'Do you want to queue purchases of the Gift Voucher?', 6, 3, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''), '),
(1430, 'Include Shipping', 'MODULE_ORDER_TOTAL_GV_INC_SHIPPING', 'true', 'Include Shipping in calculation', 6, 5, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''), '),
(1427, 'Display Total', 'MODULE_ORDER_TOTAL_GV_STATUS', 'true', 'Do you want to display the Gift Voucher value?', 6, 1, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''), '),
(1446, 'Sort order of display.', 'MODULE_PAYMENT_MONEYORDER_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', 6, 0, NULL, NOW(), NULL, NULL),
(1447, 'Payment Zone', 'MODULE_PAYMENT_MONEYORDER_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', 6, 2, NULL, NOW(), 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes('),
(1445, 'Make Payable to:', 'MODULE_PAYMENT_MONEYORDER_PAYTO', '', 'Who should payments be made payable to?', 6, 1, NULL, NOW(), NULL, NULL),
(1444, 'Enable Check/Money Order Module', 'MODULE_PAYMENT_MONEYORDER_STATUS', 'True', 'Do you want to accept Check/Money Order payments?', 6, 1, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''True'', ''False''), '),
(1448, 'Set Order Status', 'MODULE_PAYMENT_MONEYORDER_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', 6, 0, NULL, NOW(), 'tep_get_order_status_name', 'tep_cfg_pull_down_order_statuses('),
(1449, 'Indiv Ship Home Country', 'INDIVIDUAL_SHIP_HOME_COUNTRY', '223', 'Individual ship home country ID (other countries will have extra freight)', 7, NULL, NOW(), NOW(), NULL, NULL),
(1450, 'Indiv Ship Outside Home Increase', 'INDIVIDUAL_SHIP_INCREASE', '3', 'Individual ship x increase for shipping outside home country. For example: If you set your item ship price to $50 and this value to 3 and ship outside your home country they will pay $150, and if this value was 2, they would pay $100.', 7, NULL, NOW(), NOW(), NULL, NULL),
(1464, 'Shipping Zone', 'MODULE_SHIPPING_ITEM_ZONE', '0', 'If a zone is selected, only enable this shipping method for that zone.', 6, 0, NULL, NOW(), 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes('),
(1463, 'Tax Class', 'MODULE_SHIPPING_ITEM_TAX_CLASS', '0', 'Use the following tax class on the shipping fee.', 6, 0, NULL, NOW(), 'tep_get_tax_class_title', 'tep_cfg_pull_down_tax_classes('),
(1462, 'Handling Fee', 'MODULE_SHIPPING_ITEM_HANDLING', '0', 'Handling fee for this shipping method.', 6, 0, NULL, NOW(), NULL, NULL),
(1461, 'Shipping Cost', 'MODULE_SHIPPING_ITEM_COST', '2.50', 'The shipping cost will be multiplied by the number of items in an order that uses this shipping method.', 6, 0, NULL, NOW(), NULL, NULL),
(1460, 'Enable Item Shipping', 'MODULE_SHIPPING_ITEM_STATUS', 'False', 'Do you want to offer per item rate shipping?', 6, 0, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''True'', ''False''), '),
(1465, 'Sort Order', 'MODULE_SHIPPING_ITEM_SORT_ORDER', '0', 'Sort order of display.', 6, 0, NULL, NOW(), NULL, NULL),
(1486, 'Tax Class', 'MODULE_SHIPPING_GLOBALSHIP_TAX_CLASS', '0', 'Use the following tax class on the shipping fee.', 6, 0, NULL, NOW(), 'tep_get_tax_class_title', 'tep_cfg_pull_down_tax_classes('),
(1485, 'Shipping Cost', 'MODULE_SHIPPING_GLOBALSHIP_ADDITIONAL_COST', '5.00', 'The shipping cost for all orders using this shipping method.', 6, 0, NULL, NOW(), NULL, NULL),
(1484, 'Shipping Cost', 'MODULE_SHIPPING_GLOBALSHIP_COST', '5.00', 'The shipping cost for all orders using this shipping method.', 6, 0, NULL, NOW(), NULL, NULL),
(1483, 'Enable Global Shipping', 'MODULE_SHIPPING_GLOBALSHIP_STATUS', 'True', 'Do you want to offer flat rate shipping?', 6, 0, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''True'', ''False''), '),
(1487, 'Shipping Zone', 'MODULE_SHIPPING_GLOBALSHIP_ZONE', '0', 'If a zone is selected, only enable this shipping method for that zone.', 6, 0, NULL, NOW(), 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes('),
(1488, 'Sort Order', 'MODULE_SHIPPING_GLOBALSHIP_SORT_ORDER', '0', 'Sort order of display.', 6, 0, NULL, NOW(), NULL, NULL),
(1629, 'Table Method', 'MODULE_SHIPPING_TABLE_MODE', 'count', 'The shipping cost is based on the total weight, or the order total, or the number of items ordered.', 6, 0, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''weight'', ''price'', ''count''), '),
(1628, 'Shipping Table', 'MODULE_SHIPPING_TABLE_COST', '2:6.00,4:9.00,6:12.00,9:16.50,12:21.50,15:22.50,20:25.50,30:32.50,40:35.50,50:37.50,100:0.00', 'The shipping cost is based on the total weight, cost or number of items. Example: 25:8.50,50:5.50,etc.. Up to 25 charge 8.50, from there to 50 charge 5.50, etc', 6, 0, NULL, NOW(), NULL, NULL),
(1627, 'Enable Table Method', 'MODULE_SHIPPING_TABLE_STATUS', 'True', 'Do you want to offer table rate shipping?', 6, 0, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''True'', ''False''), '),
(1626, 'Shipping Title', 'MODULE_SHIPPING_TABLE_DISPLAY_TITLE', 'USPS', 'Shipping title that will be displayed next to theshipping name on the shipping page.', 6, 0, NULL, NOW(), NULL, NULL),
(1604, 'Stamp Image ON/OFF', 'IMAGE_STAMP_ON_OFF', 'on', 'Turn ON/OFF image stamp requires GD 2 version', 4, 8, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''on'', ''off''),'),
(1625, 'Shipping Name', 'MODULE_SHIPPING_TABLE_DISPLAY_NAME', 'Shipping:', 'Shipping name that will be displayed to the user on the shipping page.', 6, 0, NULL, NOW(), NULL, NULL),
(1620, 'Display Extra images', 'DISPLAY_EXTRA_IMAGES', 'true', 'Display Extra images', 888001, 87, NOW(), NOW(), '', 'tep_cfg_select_option(array(''false'', ''true''),'),
(1621, 'Index Title', 'INDEX_META_TITLE', 'eclime', 'Default page title', 1, 1, NOW(), NOW(), '', ''),
(1622, 'Index Meta Description', 'INDEX_META_DESCRIPTION', 'eclime - powerful e-commerce software based on osCommerce', 'Default page description', 1, 1, NOW(), NOW(), '', ''),
(1674, 'Sort Order', 'MODULE_SHIPPING_FREESHIPPER_SORT_ORDER', '0', 'Sort order of display.', 6, 0, NULL, NOW(), NULL, NULL),
(1623, 'Index Meta Keywords', 'INDEX_META_KEYWORDS', 'eclime, ecommerce, oscommerce', 'Default page keywords (separated by comma)', 1, 1, NOW(), NOW(), '', ''),
(1673, 'Shipping Zone', 'MODULE_SHIPPING_FREESHIPPER_ZONE', '0', 'If a zone is selected, only enable this shipping method for that zone.', 6, 0, NULL, NOW(), 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes('),
(1624, 'Location of Prev/Next Navigation Bar (1-top, 2-bottom, 3-both)', 'PREV_NEXT_BAR_LOCATION', '3', 'Sets the location of the Prev/Next Navigation Bar (1-top, 2-bottom, 3-both)', 8, 10, NOW(), NOW(), NULL, NULL),
(1672, 'Tax Class', 'MODULE_SHIPPING_FREESHIPPER_TAX_CLASS', '0', 'Use the following tax class on the shipping fee.', 6, 0, NULL, NOW(), 'tep_get_tax_class_title', 'tep_cfg_pull_down_tax_classes(');
INSERT INTO `configuration` (`configuration_id`, `configuration_title`, `configuration_key`, `configuration_value`, `configuration_description`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES
(1671, 'Free Shipping Cost', 'MODULE_SHIPPING_FREESHIPPER_COST', '0.00', 'What is the Shipping cost? The Handling fee will also be added.', 6, 6, NULL, NOW(), NULL, NULL),
(1641, 'Enable Flat Shipping', 'MODULE_SHIPPING_FLAT_STATUS', 'True', 'Do you want to offer flat rate shipping?', 6, 0, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''True'', ''False''), '),
(1642, 'Shipping Cost', 'MODULE_SHIPPING_FLAT_COST', '5.00', 'The shipping cost for all orders using this shipping method.', 6, 0, NULL, NOW(), NULL, NULL),
(1643, 'Tax Class', 'MODULE_SHIPPING_FLAT_TAX_CLASS', '0', 'Use the following tax class on the shipping fee.', 6, 0, NULL, NOW(), 'tep_get_tax_class_title', 'tep_cfg_pull_down_tax_classes('),
(1644, 'Shipping Zone', 'MODULE_SHIPPING_FLAT_ZONE', '0', 'If a zone is selected, only enable this shipping method for that zone.', 6, 0, NULL, NOW(), 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes('),
(1645, 'Sort Order', 'MODULE_SHIPPING_FLAT_SORT_ORDER', '0', 'Sort order of display.', 6, 0, NULL, NOW(), NULL, NULL),
(1702, 'Shipping Zone', 'MODULE_SHIPPING_INDVSHIP_ZONE', '0', 'If a zone is selected, only enable this shipping method for that zone.', 6, 0, NULL, NOW(), 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes('),
(1703, 'Sort Order', 'MODULE_SHIPPING_INDVSHIP_SORT_ORDER', '0', 'Sort order of display.', 6, 0, NULL, NOW(), NULL, NULL),
(1714, 'Country', 'ACCOUNT_COUNTRY', 'true', 'Display country in the customers account', 5, 10, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(1713, 'Display Articles Menu', 'DISPLAY_ARTICLES_MENU', 'true', 'Display an articles menu links on a website?', 456, 2, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''),'),
(1715, 'Default charge for restocking a non-faulty item', 'DEFAULT_RESTOCK_VALUE', '12.5', 'This is the charge applied to refund to cover the return of non-faulty items which are to be entered back into stock for resale', 9, NULL, NOW(), NOW(), NULL, NULL),
(1716, 'Default Return Reason', 'DEFAULT_RETURN_REASON', '2', 'This is the default reason applied to all returns', 6, NULL, NOW(), NOW(), NULL, NULL),
(1717, 'Default Return Status', 'DEFAULT_RETURN_STATUS_ID', '1', 'Default return status assigned to all new returns', 6, NULL, NOW(), NOW(), NULL, NULL),
(1718, 'Default Refund Method', 'DEFAULT_REFUND_METHOD', '1', 'Default method for refund payment', 6, NULL, NOW(), NOW(), NULL, NULL),
(1670, 'Enable Free Shipping', 'MODULE_SHIPPING_FREESHIPPER_STATUS', '1', 'Do you want to offer Free shipping?', 6, 5, NULL, NOW(), NULL, NULL),
(1700, 'Enable Individual Shipping Prices', 'MODULE_SHIPPING_INDVSHIP_STATUS', 'True', 'Do you want to offer individual shipping prices?', 6, 0, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''True'', ''False''), '),
(1701, 'Tax Class', 'MODULE_SHIPPING_INDVSHIP_TAX_CLASS', '0', 'Use the following tax class on the shipping fee.', 6, 0, NULL, NOW(), 'tep_get_tax_class_title', 'tep_cfg_pull_down_tax_classes('),
(1699, 'Zone 1 Handling Fee', 'MODULE_SHIPPING_ZONES_HANDLING_1', '0', 'Handling Fee for this shipping zone', 6, 0, NULL, NOW(), NULL, NULL),
(1698, 'Zone 1 Shipping Table', 'MODULE_SHIPPING_ZONES_COST_1', '3:8.50,7:10.50,99:20.00', 'Shipping rates to Zone 1 destinations based on a group of maximum order weights. Example: 3:8.50,7:10.50,... Weights less than or equal to 3 would cost 8.50 for Zone 1 destinations.', 6, 0, NULL, NOW(), NULL, NULL),
(1697, 'Zone 1 Countries', 'MODULE_SHIPPING_ZONES_COUNTRIES_1', 'US,CA', 'Comma separated list of two character ISO country codes that are part of Zone 1.', 6, 0, NULL, NOW(), NULL, NULL),
(1696, 'Sort Order', 'MODULE_SHIPPING_ZONES_SORT_ORDER', '0', 'Sort order of display.', 6, 0, NULL, NOW(), NULL, NULL),
(1695, 'Tax Class', 'MODULE_SHIPPING_ZONES_TAX_CLASS', '0', 'Use the following tax class on the shipping fee.', 6, 0, NULL, NOW(), 'tep_get_tax_class_title', 'tep_cfg_pull_down_tax_classes('),
(1694, 'Enable Zones Method', 'MODULE_SHIPPING_ZONES_STATUS', 'True', 'Do you want to offer zone rate shipping?', 6, 0, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''True'', ''False''), '),
(1721, 'Smaller Image Width', 'SMALLER_IMAGE_WIDTH', '50', 'The pixel width of smaller images', 4, 5, NULL, NOW(), NULL, NULL),
(1722, 'Smaller Image Height', 'SMALLER_IMAGE_HEIGHT', '50', 'The pixel height of smaller images', 4, 6, NULL, NOW(), NULL, NULL),
(1723, 'Manufacturers small image width', 'MANUFACTURERS_SMALL_IMAGE_WIDTH', '80', 'The pixel width of small manufacturers images', 4, 2, NOW(), NOW(), NULL, ''),
(1724, 'Manufacturers small image height', 'MANUFACTURERS_SMALL_IMAGE_HEIGHT', '30', 'The pixel height of manufacturers images', 4, 2, NOW(), NOW(), NULL, ''),
(1725, 'Manufacturers medium image width', 'MANUFACTURERS_MEDIUM_IMAGE_WIDTH', '180', 'The pixel width of medium manufacturers images', 4, 3, NOW(), NOW(), NULL, ''),
(1726, 'Manufacturers medium image height', 'MANUFACTURERS_MEDIUM_IMAGE_HEIGHT', '50', 'The pixel height of medium manufacturers images', 4, 3, NOW(), NOW(), NULL, ''),
(1727, 'Random Products Listing', 'MAX_DISPLAY_RANDOM_PRODUCTS', '15', 'Maximum number of random products to display.', 3, 10, NOW(), NOW(), NULL, ''),
(1729, 'Wishlist Redirect', 'WISHLIST_REDIRECT', 'No', 'Do you want to redirect back to the product_info.php page when a customer adds a product to their wishlist?', 12954, 0, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''Yes'', ''No''),'),
(1730, 'Who''s Online', 'WHOS_ONLINE', 'Off', 'Shows Who''s Online, If you use Google Analysis or any other free tracking services, set this feature to: "Off" By turning this feature "Off" you may also save some of the system''s resources.', 1, 25, NOW(), NOW(), NULL, 'tep_cfg_select_option(array(''On'', ''Off''),'),
(1731, 'Current Template', 'CURRENT_TEMPLATE', 'eclime_two', 'Current template', 0, 25, NOW(), NOW(), NULL, ''),
(1732, 'Invoice serial prefix', 'INVOICE_SERIAL', 'I-', 'Invoice number prefix', 1, 22, NULL, NOW(), NULL, NULL),
(1733, 'Newsletter email confirmation', 'NEWSLETTER_CONFIRM_EMAIL', 'Off', 'This feature requires user to confirm the email before the newsletter feature can be used.', 1, 23, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''On'', ''Off''),'),
(1734, 'Agree to terms and conditions', 'ACCOUNT_AGREE_TO_TERMS', 'Off', 'This feature requires user to agree to terms before user can register an account.', 5, 11, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''On'', ''Off''),'),
(1735, 'Agree to terms and conditions - URL', 'ACCOUNT_AGREE_TO_TERMS_URL', 'article_info.php?articles_id=11', 'This is the terms and conditions URL.', 5, 12, NULL, NOW(), NULL, ''),
(1736, 'Checkout - Agree to terms and conditions', 'CHECKOUT_AGREE_TO_TERMS', 'Off', 'This feature requires user to agree to terms before the checkout.', 1, 26, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''On'', ''Off''),'),
(1737, 'Checkout - Agree to terms and conditions - URL', 'CHECKOUT_AGREE_TO_TERMS_URL', 'index.php', 'This is the checkout terms and conditions URL.', 1, 27, NULL, NOW(), NULL, ''),
(1761, 'Enable products bundles', 'ENABLE_PRODUCTS_BUNDLES', 'On', 'This feature allows user to buy a bundle of parts that may be priced at something different from the total cost of the parts.', 1, 29, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''On'', ''Off''),'),
(1762, 'Login Page', 'CAPTCHA_LOGIN', 'On', 'User will require to enter a security code in order to login', 17, 1, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''On'', ''Off''),'),
(1763, 'Login Page - Protection Type', 'CAPTCHA_LOGIN_TYPE', 'Logic', 'Security image protection type<br /> Logic = Security image will only appear after (x) amount of failed attempts.<br />Force = The security image will always be shown.', 17, 2, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''Logic'', ''Force''),'),
(1764, 'Login Page - Failed attempts', 'CAPTCHA_LOGIN_ATTEMPTS', '3', 'Number of failed attempts before diplaying the security image.', 17, 3, NULL, NOW(), NULL, ''),
(1765, 'Registration Page', 'CAPTCHA_REGISTRATION', 'On', 'User will require to enter a security code in order to login', 17, 4, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''On'', ''Off''),'),
(1766, 'Registration Page - Protection Type', 'CAPTCHA_REGISTRATION_TYPE', 'Logic', 'Security image protection type<br /> Logic = Security image will only appear on (x) amount of failed logins.<br />Force = The security image will always be shown.', 17, 5, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''Logic'', ''Force''),'),
(1767, 'Registration Page - Registrations', 'CAPTCHA_REGISTRATION_ATTEMPTS', '1', 'Number of repeated registrations before diplaying the security image.', 17, 6, NULL, NOW(), NULL, ''),
(1768, 'Image Width', 'CAPTCHA_IMAGE_WIDTH', '150', 'The width of the security code image.', 17, 7, NULL, NOW(), NULL, ''),
(1769, 'Image Height', 'CAPTCHA_IMAGE_HEIGHT', '50', 'The height of the security code image.', 17, 8, NULL, NOW(), NULL, ''),
(1770, 'Number of Characters', 'CAPTCHA_CHARS_NUM', '3', 'The number of characters to display on the security image.', 17, 9, NULL, NOW(), NULL, ''),
(1771, 'Max Character Rotation', 'CAPTCHA_CHARS_MAX_ROTATION', '25', 'The maximum character rotation.', 17, 10, NULL, NOW(), NULL, ''),
(1772, 'Image Noise', 'CAPTCHA_NOISE', 'On', 'Use distortion noise.', 17, 11, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''On'', ''Off''),'),
(1773, 'Image NBC Noise', 'CAPTCHA_NB_NOISE', '5', 'Number of background characters.', 17, 12, NULL, NOW(), NULL, ''),
(1774, 'Image Quality', 'CAPTCHA_IMAGE_QUALITY', '80', 'Image quality (from 0 to 100).', 17, 13, NULL, NOW(), NULL, ''),
(1775, 'phpBB Integration', 'PHPBB_INTEGRATION', 'Disabled', 'phpBB Integration', 18, 1, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''Enabled'', ''Disabled''),'),
(1776, 'phpBB Directory URL', 'PHPBB_DIR', 'forum/', 'phpBB Directory', 18, 1, NULL, NOW(), NULL, ''),
(1777, 'phpBB Database Tables Prefix', 'PHPBB_DB_PREFIX', 'phpbb_', 'phpBB Prefix for tables in database', 18, 1, NULL, NOW(), NULL, ''),
(1778, 'phpBB - User Account Activation', 'PHPBB_ACCOUNT_ACTIVATION', 'None', 'This determines whether users have immediate access to the board or if confirmation is required.', 18, 1, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''None'', ''User'', ''Admin''),'),
(1779, 'Auto FTP', 'GOOGLEBASE_FTP_ENABLED', 'Disabled', 'Automatically transfers a generated feed file to google base.', 19, 1, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''Enabled'', ''Disabled''),'),
(1780, 'FTP Username', 'GOOGLEBASE_FTP_USERNAME', 'username', 'FTP username from your googlebase account', 19, 1, NULL, NOW(), NULL, ''),
(1781, 'FTP Password', 'GOOGLEBASE_FTP_PASSWORD', 'password', 'FTP password from your googlebase account', 19, 1, NULL, NOW(), NULL, ''),
(1782, 'Feed Name', 'GOOGLEBASE_FEEDNAME', 'googlebase.txt', 'Feed name from your googlebase account', 19, 1, NULL, NOW(), NULL, ''),
(1783, 'Convert Currency', 'GOOGLEBASE_CONVERT_CURRENCY', 'No', 'Convert currency is only needed if a feed required in a different currecny', 19, 1, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''Yes'', ''No''),'),
(1784, 'Currency Type', 'GOOGLEBASE_CURRENCY_TYPE', 'USD', 'Currency type (eg. USD, EUR, GBP)', 19, 1, NULL, NOW(), NULL, ''),
(1785, 'Default Language', 'GOOGLEBASE_DEFAULT_LANGUAGE', '1', 'Default Language', 19, 1, NULL, NOW(), NULL, 'tep_cfg_pull_down_language_list('),
(1786, 'Auto FTP', 'YAHOO_FTP_ENABLED', 'Disabled', 'Automatically transfers a generated feed file to yahoo.', 20, 1, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''Enabled'', ''Disabled''),'),
(1787, 'FTP Username', 'YAHOO_FTP_USERNAME', 'username', 'FTP username from your yahoo account', 20, 1, NULL, NOW(), NULL, ''),
(1788, 'FTP Password', 'YAHOO_FTP_PASSWORD', 'password', 'FTP password from your yahoo account', 20, 1, NULL, NOW(), NULL, ''),
(1789, 'Feed Name', 'YAHOO_FEEDNAME', 'yahoo.txt', 'Feed name from your yahoo account', 20, 1, NULL, NOW(), NULL, ''),
(1790, 'Convert Currency', 'YAHOO_CONVERT_CURRENCY', 'No', 'Convert currency is only needed if a feed required in a different currecny', 20, 1, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''Yes'', ''No''),'),
(1791, 'Currency Type', 'YAHOO_CURRENCY_TYPE', 'USD', 'Currency type (eg. USD, EUR, GBP)', 20, 1, NULL, NOW(), NULL, ''),
(1792, 'Default Language', 'YAHOO_DEFAULT_LANGUAGE', '1', 'Default Language', 20, 1, NULL, NOW(), NULL, 'tep_cfg_pull_down_language_list('),
(1793, 'Default contact us page', 'DEFAULT_CONTACT_PAGE', 'article_info.php?articles_id=9', 'Default contact page', 1, 18, NULL, NOW(), NULL, ''),
(1794, 'Store Phone', 'STORE_PHONE', '1-(800)-123-4567', 'This is the Store Phone', 1, 18, NULL, NOW(), NULL, ''),
(1795, 'Environment', 'ENVIRONMENT', 'TESTING', 'Environment', 1, 30, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''PRODUCTION'', ''TESTING''),'),
(1796, 'Affiliate System', 'AFFILIATE_SYSTEM', 'On', 'Enable/Disable the entire affiliate system', 11, 1, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''On'', ''Off''), '),
(1797, 'E-Mail Address', 'AFFILIATE_EMAIL_ADDRESS', '<affiliate@localhost.com>', 'The E Mail Address for the Affiliate Program', 11, 1, NULL, NOW(), NULL, NULL),
(1798, 'Affiliate Pay Per Sale Payment % Rate', 'AFFILIATE_PERCENT', '10.0000', 'Percentage Rate for the Affiliate Program', 11, 2, NULL, NOW(), NULL, NULL),
(1799, 'Payment Threshold', 'AFFILIATE_THRESHOLD', '50.00', 'Payment Threshold for paying affiliates', 11, 3, NULL, NOW(), NULL, NULL),
(1800, 'Cookie Lifetime', 'AFFILIATE_COOKIE_LIFETIME', '7200', 'How long does the click count (seconds) if customer comes back', 11, 4, NULL, NOW(), NULL, NULL),
(1801, 'Billing Time', 'AFFILIATE_BILLING_TIME', '30', 'Orders billed must be at least "30" days old.<br>This is needed if a order is refunded', 11, 5, NULL, NOW(), NULL, NULL),
(1802, 'Order Min Status', 'AFFILIATE_PAYMENT_ORDER_MIN_STATUS', '3', 'The status an order must have at least, to be billed', 11, 6, NULL, NOW(), NULL, NULL),
(1803, 'Pay Affiliates with check', 'AFFILIATE_USE_CHECK', 'true', 'Pay Affiliates with check', 11, 7, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''), '),
(1804, 'Pay Affiliates with PayPal', 'AFFILIATE_USE_PAYPAL', 'true', 'Pay Affiliates with PayPal', 11, 8, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''), '),
(1805, 'Pay Affiliates by Bank', 'AFFILIATE_USE_BANK', 'true', 'Pay Affiliates by Bank', 11, 9, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''), '),
(1806, 'Individual Affiliate Percentage', 'AFFILATE_INDIVIDUAL_PERCENTAGE', 'true', 'Allow per Affiliate provision', 11, 10, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''), '),
(1807, 'Use Affiliate-tier', 'AFFILATE_USE_TIER', 'false', 'Multilevel Affiliate provisions', 11, 11, NULL, NOW(), NULL, 'tep_cfg_select_option(array(''true'', ''false''), '),
(1808, 'Number of Tierlevels', 'AFFILIATE_TIER_LEVELS', '0', 'Number of Tierlevels', 11, 12, NULL, NOW(), NULL, NULL),
(1809, 'Percentage Rate for the Tierlevels', 'AFFILIATE_TIER_PERCENTAGE', '8.00;5.00;1.00', 'Percent Rates for the tierlevels<br>Example: 8.00;5.00;1.00', 11, 13, NULL, NOW(), NULL, NULL),
(1810, 'Affiliate News', 'MAX_DISPLAY_AFFILIATE_NEWS', '3', 'Maximum number of items to display on the Affiliate News page', 11, 14, NULL, NOW(), NULL, NULL);



DROP TABLE IF EXISTS `configuration_group`;
CREATE TABLE `configuration_group` (
  `configuration_group_id` int(11) NOT NULL auto_increment,
  `configuration_group_title` varchar(64) NOT NULL default '',
  `configuration_group_description` varchar(255) NOT NULL default '',
  `sort_order` int(5) default NULL,
  `visible` int(1) default '1',
  PRIMARY KEY  (`configuration_group_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1;


INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES
(1, 'My Store', 'General information about my store', 1, 1),
(2, 'Minimum Values', 'The minimum values for functions / data', 2, 1),
(3, 'Maximum Values', 'The maximum values for functions / data', 3, 1),
(4, 'Images', 'Image parameters', 4, 1),
(5, 'Customer Details', 'Customer account configuration', 5, 1),
(6, 'Module Options', 'Hidden from configuration', 6, 0),
(7, 'Shipping/Packaging', 'Shipping options available at my store', 7, 1),
(8, 'Product Listing', 'Product Listing    configuration options', 8, 1),
(9, 'Stock', 'Stock configuration options', 9, 1),
(10, 'Logging', 'Logging configuration options', 10, 1),
(11, 'Affiliate Program', 'Options for the Affiliate Program', 50, 1),
(12, 'E-Mail Options', 'General setting for E-Mail transport and HTML E-Mails', 12, 1),
(13, 'Download', 'Downloadable products options', 13, 1),
(15, 'Sessions', 'Session options', 15, 1),
(16, 'Site Maintenance', 'Site Maintenance Options', 16, 1),
(17, 'CAPTCHA Security Code', '<b>C</b>ompletely <b>A</b>utomated <b>P</b>ublic <b>T</b>uring test to tell <b>C</b>omputers and <b>H</b>umans <b>A</b>part.', 17, 1),
(18, 'Integration', 'Integration', 18, 1),
(19, 'Google Base Feeder', 'Hidden from configuration', 19, 0),
(20, 'Yahoo Data Feeder', 'Hidden from configuration', 20, 0),
(112, 'Advanced HTML Editor', 'FCKeditor 2.6 Options', 15, 1),
(12954, 'Wish List Settings', 'Settings for your Wish List', 25, 1),
(888001, 'Product Information', 'Product Information page configuration options', 8, 1),
(888002, 'SEO URLs', 'Options for Ultimate SEO URLs by Chemo', 902, 1);




DROP TABLE IF EXISTS `counter`;
CREATE TABLE `counter` (
  `startdate` char(8) default NULL,
  `counter` int(12) default NULL
) TYPE=MyISAM;


DROP TABLE IF EXISTS `counter_history`;
CREATE TABLE `counter_history` (
  `month` char(8) default NULL,
  `counter` int(12) default NULL
) TYPE=MyISAM;


DROP TABLE IF EXISTS `countries`;
CREATE TABLE `countries` (
  `countries_id` int(11) NOT NULL auto_increment,
  `countries_name` varchar(64) NOT NULL default '',
  `countries_iso_code_2` char(2) NOT NULL default '',
  `countries_iso_code_3` char(3) NOT NULL default '',
  `address_format_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`countries_id`),
  KEY `IDX_COUNTRIES_NAME` (`countries_name`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;



INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`) VALUES
(1, 'Afghanistan', 'AF', 'AFG', 1),
(2, 'Albania', 'AL', 'ALB', 1),
(3, 'Algeria', 'DZ', 'DZA', 1),
(4, 'American Samoa', 'AS', 'ASM', 1),
(5, 'Andorra', 'AD', 'AND', 1),
(6, 'Angola', 'AO', 'AGO', 1),
(7, 'Anguilla', 'AI', 'AIA', 1),
(8, 'Antarctica', 'AQ', 'ATA', 1),
(9, 'Antigua and Barbuda', 'AG', 'ATG', 1),
(10, 'Argentina', 'AR', 'ARG', 1),
(11, 'Armenia', 'AM', 'ARM', 1),
(12, 'Aruba', 'AW', 'ABW', 1),
(13, 'Australia', 'AU', 'AUS', 1),
(14, 'Austria', 'AT', 'AUT', 5),
(15, 'Azerbaijan', 'AZ', 'AZE', 1),
(16, 'Bahamas', 'BS', 'BHS', 1),
(17, 'Bahrain', 'BH', 'BHR', 1),
(18, 'Bangladesh', 'BD', 'BGD', 1),
(19, 'Barbados', 'BB', 'BRB', 1),
(20, 'Belarus', 'BY', 'BLR', 1),
(21, 'Belgium', 'BE', 'BEL', 1),
(22, 'Belize', 'BZ', 'BLZ', 1),
(23, 'Benin', 'BJ', 'BEN', 1),
(24, 'Bermuda', 'BM', 'BMU', 1),
(25, 'Bhutan', 'BT', 'BTN', 1),
(26, 'Bolivia', 'BO', 'BOL', 1),
(27, 'Bosnia and Herzegowina', 'BA', 'BIH', 1),
(28, 'Botswana', 'BW', 'BWA', 1),
(29, 'Bouvet Island', 'BV', 'BVT', 1),
(30, 'Brazil', 'BR', 'BRA', 1),
(31, 'British Indian Ocean Territory', 'IO', 'IOT', 1),
(32, 'Brunei Darussalam', 'BN', 'BRN', 1),
(33, 'Bulgaria', 'BG', 'BGR', 1),
(34, 'Burkina Faso', 'BF', 'BFA', 1),
(35, 'Burundi', 'BI', 'BDI', 1),
(36, 'Cambodia', 'KH', 'KHM', 1),
(37, 'Cameroon', 'CM', 'CMR', 1),
(38, 'Canada', 'CA', 'CAN', 1),
(39, 'Cape Verde', 'CV', 'CPV', 1),
(40, 'Cayman Islands', 'KY', 'CYM', 1),
(41, 'Central African Republic', 'CF', 'CAF', 1),
(42, 'Chad', 'TD', 'TCD', 1),
(43, 'Chile', 'CL', 'CHL', 1),
(44, 'China', 'CN', 'CHN', 1),
(45, 'Christmas Island', 'CX', 'CXR', 1),
(46, 'Cocos (Keeling) Islands', 'CC', 'CCK', 1),
(47, 'Colombia', 'CO', 'COL', 1),
(48, 'Comoros', 'KM', 'COM', 1),
(49, 'Congo', 'CG', 'COG', 1),
(50, 'Cook Islands', 'CK', 'COK', 1),
(51, 'Costa Rica', 'CR', 'CRI', 1),
(52, 'Cote D''Ivoire', 'CI', 'CIV', 1),
(53, 'Croatia', 'HR', 'HRV', 1),
(54, 'Cuba', 'CU', 'CUB', 1),
(55, 'Cyprus', 'CY', 'CYP', 1),
(56, 'Czech Republic', 'CZ', 'CZE', 1),
(57, 'Denmark', 'DK', 'DNK', 1),
(58, 'Djibouti', 'DJ', 'DJI', 1),
(59, 'Dominica', 'DM', 'DMA', 1),
(60, 'Dominican Republic', 'DO', 'DOM', 1),
(61, 'East Timor', 'TP', 'TMP', 1),
(62, 'Ecuador', 'EC', 'ECU', 1),
(63, 'Egypt', 'EG', 'EGY', 1),
(64, 'El Salvador', 'SV', 'SLV', 1),
(65, 'Equatorial Guinea', 'GQ', 'GNQ', 1),
(66, 'Eritrea', 'ER', 'ERI', 1),
(67, 'Estonia', 'EE', 'EST', 1),
(68, 'Ethiopia', 'ET', 'ETH', 1),
(69, 'Falkland Islands (Malvinas)', 'FK', 'FLK', 1),
(70, 'Faroe Islands', 'FO', 'FRO', 1),
(71, 'Fiji', 'FJ', 'FJI', 1),
(72, 'Finland', 'FI', 'FIN', 1),
(73, 'France', 'FR', 'FRA', 1),
(74, 'France, Metropolitan', 'FX', 'FXX', 1),
(75, 'French Guiana', 'GF', 'GUF', 1),
(76, 'French Polynesia', 'PF', 'PYF', 1),
(77, 'French Southern Territories', 'TF', 'ATF', 1),
(78, 'Gabon', 'GA', 'GAB', 1),
(79, 'Gambia', 'GM', 'GMB', 1),
(80, 'Georgia', 'GE', 'GEO', 1),
(81, 'Germany', 'DE', 'DEU', 5),
(82, 'Ghana', 'GH', 'GHA', 1),
(83, 'Gibraltar', 'GI', 'GIB', 1),
(84, 'Greece', 'GR', 'GRC', 1),
(85, 'Greenland', 'GL', 'GRL', 1),
(86, 'Grenada', 'GD', 'GRD', 1),
(87, 'Guadeloupe', 'GP', 'GLP', 1),
(88, 'Guam', 'GU', 'GUM', 1),
(89, 'Guatemala', 'GT', 'GTM', 1),
(90, 'Guinea', 'GN', 'GIN', 1),
(91, 'Guinea-bissau', 'GW', 'GNB', 1),
(92, 'Guyana', 'GY', 'GUY', 1),
(93, 'Haiti', 'HT', 'HTI', 1),
(94, 'Heard and Mc Donald Islands', 'HM', 'HMD', 1),
(95, 'Honduras', 'HN', 'HND', 1),
(96, 'Hong Kong', 'HK', 'HKG', 1),
(97, 'Hungary', 'HU', 'HUN', 1),
(98, 'Iceland', 'IS', 'ISL', 1),
(99, 'India', 'IN', 'IND', 1),
(100, 'Indonesia', 'ID', 'IDN', 1),
(101, 'Iran (Islamic Republic of)', 'IR', 'IRN', 1),
(102, 'Iraq', 'IQ', 'IRQ', 1),
(103, 'Ireland', 'IE', 'IRL', 1),
(104, 'Israel', 'IL', 'ISR', 1),
(105, 'Italy', 'IT', 'ITA', 1),
(106, 'Jamaica', 'JM', 'JAM', 1),
(107, 'Japan', 'JP', 'JPN', 1),
(108, 'Jordan', 'JO', 'JOR', 1),
(109, 'Kazakhstan', 'KZ', 'KAZ', 1),
(110, 'Kenya', 'KE', 'KEN', 1),
(111, 'Kiribati', 'KI', 'KIR', 1),
(112, 'Korea, Democratic People''s Republic of', 'KP', 'PRK', 1),
(113, 'Korea, Republic of', 'KR', 'KOR', 1),
(114, 'Kuwait', 'KW', 'KWT', 1),
(115, 'Kyrgyzstan', 'KG', 'KGZ', 1),
(116, 'Lao People''s Democratic Republic', 'LA', 'LAO', 1),
(117, 'Latvia', 'LV', 'LVA', 1),
(118, 'Lebanon', 'LB', 'LBN', 1),
(119, 'Lesotho', 'LS', 'LSO', 1),
(120, 'Liberia', 'LR', 'LBR', 1),
(121, 'Libyan Arab Jamahiriya', 'LY', 'LBY', 1),
(122, 'Liechtenstein', 'LI', 'LIE', 1),
(123, 'Lithuania', 'LT', 'LTU', 1),
(124, 'Luxembourg', 'LU', 'LUX', 1),
(125, 'Macau', 'MO', 'MAC', 1),
(126, 'Macedonia, The Former Yugoslav Republic of', 'MK', 'MKD', 1),
(127, 'Madagascar', 'MG', 'MDG', 1),
(128, 'Malawi', 'MW', 'MWI', 1),
(129, 'Malaysia', 'MY', 'MYS', 1),
(130, 'Maldives', 'MV', 'MDV', 1),
(131, 'Mali', 'ML', 'MLI', 1),
(132, 'Malta', 'MT', 'MLT', 1),
(133, 'Marshall Islands', 'MH', 'MHL', 1),
(134, 'Martinique', 'MQ', 'MTQ', 1),
(135, 'Mauritania', 'MR', 'MRT', 1),
(136, 'Mauritius', 'MU', 'MUS', 1),
(137, 'Mayotte', 'YT', 'MYT', 1),
(138, 'Mexico', 'MX', 'MEX', 1),
(139, 'Micronesia, Federated States of', 'FM', 'FSM', 1),
(140, 'Moldova, Republic of', 'MD', 'MDA', 1),
(141, 'Monaco', 'MC', 'MCO', 1),
(142, 'Mongolia', 'MN', 'MNG', 1),
(143, 'Montserrat', 'MS', 'MSR', 1),
(144, 'Morocco', 'MA', 'MAR', 1),
(145, 'Mozambique', 'MZ', 'MOZ', 1),
(146, 'Myanmar', 'MM', 'MMR', 1),
(147, 'Namibia', 'NA', 'NAM', 1),
(148, 'Nauru', 'NR', 'NRU', 1),
(149, 'Nepal', 'NP', 'NPL', 1),
(150, 'Netherlands', 'NL', 'NLD', 1),
(151, 'Netherlands Antilles', 'AN', 'ANT', 1),
(152, 'New Caledonia', 'NC', 'NCL', 1),
(153, 'New Zealand', 'NZ', 'NZL', 1),
(154, 'Nicaragua', 'NI', 'NIC', 1),
(155, 'Niger', 'NE', 'NER', 1),
(156, 'Nigeria', 'NG', 'NGA', 1),
(157, 'Niue', 'NU', 'NIU', 1),
(158, 'Norfolk Island', 'NF', 'NFK', 1),
(159, 'Northern Mariana Islands', 'MP', 'MNP', 1),
(160, 'Norway', 'NO', 'NOR', 1),
(161, 'Oman', 'OM', 'OMN', 1),
(162, 'Pakistan', 'PK', 'PAK', 1),
(163, 'Palau', 'PW', 'PLW', 1),
(164, 'Panama', 'PA', 'PAN', 1),
(165, 'Papua New Guinea', 'PG', 'PNG', 1),
(166, 'Paraguay', 'PY', 'PRY', 1),
(167, 'Peru', 'PE', 'PER', 1),
(168, 'Philippines', 'PH', 'PHL', 1),
(169, 'Pitcairn', 'PN', 'PCN', 1),
(170, 'Poland', 'PL', 'POL', 1),
(171, 'Portugal', 'PT', 'PRT', 1),
(172, 'Puerto Rico', 'PR', 'PRI', 1),
(173, 'Qatar', 'QA', 'QAT', 1),
(174, 'Reunion', 'RE', 'REU', 1),
(175, 'Romania', 'RO', 'ROM', 1),
(176, 'Russian Federation', 'RU', 'RUS', 1),
(177, 'Rwanda', 'RW', 'RWA', 1),
(178, 'Saint Kitts and Nevis', 'KN', 'KNA', 1),
(179, 'Saint Lucia', 'LC', 'LCA', 1),
(180, 'Saint Vincent and the Grenadines', 'VC', 'VCT', 1),
(181, 'Samoa', 'WS', 'WSM', 1),
(182, 'San Marino', 'SM', 'SMR', 1),
(183, 'Sao Tome and Principe', 'ST', 'STP', 1),
(184, 'Saudi Arabia', 'SA', 'SAU', 1),
(185, 'Senegal', 'SN', 'SEN', 1),
(186, 'Seychelles', 'SC', 'SYC', 1),
(187, 'Sierra Leone', 'SL', 'SLE', 1),
(188, 'Singapore', 'SG', 'SGP', 4),
(189, 'Slovakia (Slovak Republic)', 'SK', 'SVK', 1),
(190, 'Slovenia', 'SI', 'SVN', 1),
(191, 'Solomon Islands', 'SB', 'SLB', 1),
(192, 'Somalia', 'SO', 'SOM', 1),
(193, 'South Africa', 'ZA', 'ZAF', 1),
(194, 'South Georgia and the South Sandwich Islands', 'GS', 'SGS', 1),
(195, 'Spain', 'ES', 'ESP', 3),
(196, 'Sri Lanka', 'LK', 'LKA', 1),
(197, 'St. Helena', 'SH', 'SHN', 1),
(198, 'St. Pierre and Miquelon', 'PM', 'SPM', 1),
(199, 'Sudan', 'SD', 'SDN', 1),
(200, 'Suriname', 'SR', 'SUR', 1),
(201, 'Svalbard and Jan Mayen Islands', 'SJ', 'SJM', 1),
(202, 'Swaziland', 'SZ', 'SWZ', 1),
(203, 'Sweden', 'SE', 'SWE', 1),
(204, 'Switzerland', 'CH', 'CHE', 1),
(205, 'Syrian Arab Republic', 'SY', 'SYR', 1),
(206, 'Taiwan', 'TW', 'TWN', 1),
(207, 'Tajikistan', 'TJ', 'TJK', 1),
(208, 'Tanzania, United Republic of', 'TZ', 'TZA', 1),
(209, 'Thailand', 'TH', 'THA', 1),
(210, 'Togo', 'TG', 'TGO', 1),
(211, 'Tokelau', 'TK', 'TKL', 1),
(212, 'Tonga', 'TO', 'TON', 1),
(213, 'Trinidad and Tobago', 'TT', 'TTO', 1),
(214, 'Tunisia', 'TN', 'TUN', 1),
(215, 'Turkey', 'TR', 'TUR', 1),
(216, 'Turkmenistan', 'TM', 'TKM', 1),
(217, 'Turks and Caicos Islands', 'TC', 'TCA', 1),
(218, 'Tuvalu', 'TV', 'TUV', 1),
(219, 'Uganda', 'UG', 'UGA', 1),
(220, 'Ukraine', 'UA', 'UKR', 1),
(221, 'United Arab Emirates', 'AE', 'ARE', 1),
(222, 'United Kingdom', 'GB', 'GBR', 1),
(223, 'United States', 'US', 'USA', 2),
(224, 'United States Minor Outlying Islands', 'UM', 'UMI', 1),
(225, 'Uruguay', 'UY', 'URY', 1),
(226, 'Uzbekistan', 'UZ', 'UZB', 1),
(227, 'Vanuatu', 'VU', 'VUT', 1),
(228, 'Vatican City State (Holy See)', 'VA', 'VAT', 1),
(229, 'Venezuela', 'VE', 'VEN', 1),
(230, 'Viet Nam', 'VN', 'VNM', 1),
(231, 'Virgin Islands (British)', 'VG', 'VGB', 1),
(232, 'Virgin Islands (U.S.)', 'VI', 'VIR', 1),
(233, 'Wallis and Futuna Islands', 'WF', 'WLF', 1),
(234, 'Western Sahara', 'EH', 'ESH', 1),
(235, 'Yemen', 'YE', 'YEM', 1),
(236, 'Yugoslavia', 'YU', 'YUG', 1),
(237, 'Zaire', 'ZR', 'ZAR', 1),
(238, 'Zambia', 'ZM', 'ZMB', 1),
(239, 'Zimbabwe', 'ZW', 'ZWE', 1);

DROP TABLE IF EXISTS `coupons`;
CREATE TABLE `coupons` (
  `coupon_id` int(11) NOT NULL auto_increment,
  `coupon_type` char(1) NOT NULL default 'F',
  `coupon_code` varchar(32) NOT NULL default '',
  `coupon_amount` decimal(8,4) NOT NULL default '0.0000',
  `coupon_minimum_order` decimal(8,4) NOT NULL default '0.0000',
  `coupon_start_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `coupon_expire_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `uses_per_coupon` int(5) NOT NULL default '1',
  `uses_per_user` int(5) NOT NULL default '0',
  `restrict_to_products` varchar(255) default NULL,
  `restrict_to_categories` varchar(255) default NULL,
  `restrict_to_customers` text,
  `coupon_active` char(1) NOT NULL default 'Y',
  `date_created` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`coupon_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `coupons_description`;
CREATE TABLE `coupons_description` (
  `coupon_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '0',
  `coupon_name` varchar(32) NOT NULL default '',
  `coupon_description` text,
  KEY `coupon_id` (`coupon_id`)
) TYPE=MyISAM;



DROP TABLE IF EXISTS `coupon_email_track`;
CREATE TABLE `coupon_email_track` (
  `unique_id` int(11) NOT NULL auto_increment,
  `coupon_id` int(11) NOT NULL default '0',
  `customer_id_sent` int(11) NOT NULL default '0',
  `sent_firstname` varchar(32) default NULL,
  `sent_lastname` varchar(32) default NULL,
  `emailed_to` varchar(32) default NULL,
  `date_sent` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`unique_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `coupon_gv_customer`;
CREATE TABLE `coupon_gv_customer` (
  `customer_id` int(5) NOT NULL default '0',
  `amount` decimal(8,4) NOT NULL default '0.0000',
  PRIMARY KEY  (`customer_id`),
  KEY `customer_id` (`customer_id`)
) TYPE=MyISAM;



DROP TABLE IF EXISTS `coupon_gv_queue`;
CREATE TABLE `coupon_gv_queue` (
  `unique_id` int(5) NOT NULL auto_increment,
  `customer_id` int(5) NOT NULL default '0',
  `order_id` int(5) NOT NULL default '0',
  `amount` decimal(8,4) NOT NULL default '0.0000',
  `date_created` datetime NOT NULL default '0000-00-00 00:00:00',
  `ipaddr` varchar(32) NOT NULL default '',
  `release_flag` char(1) NOT NULL default 'N',
  PRIMARY KEY  (`unique_id`),
  KEY `uid` (`unique_id`,`customer_id`,`order_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `coupon_redeem_track`;
CREATE TABLE `coupon_redeem_track` (
  `unique_id` int(11) NOT NULL auto_increment,
  `coupon_id` int(11) NOT NULL default '0',
  `customer_id` int(11) NOT NULL default '0',
  `redeem_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `redeem_ip` varchar(32) NOT NULL default '',
  `order_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`unique_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `currencies`;
CREATE TABLE `currencies` (
  `currencies_id` int(11) NOT NULL auto_increment,
  `title` varchar(32) NOT NULL default '',
  `code` char(3) NOT NULL default '',
  `symbol_left` varchar(12) default NULL,
  `symbol_right` varchar(12) default NULL,
  `decimal_point` char(1) default NULL,
  `thousands_point` char(1) default NULL,
  `decimal_places` char(1) default NULL,
  `value` float(13,8) default NULL,
  `last_updated` datetime default NULL,
  PRIMARY KEY  (`currencies_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;


INSERT INTO `currencies` (`currencies_id`, `title`, `code`, `symbol_left`, `symbol_right`, `decimal_point`, `thousands_point`, `decimal_places`, `value`, `last_updated`) VALUES
(1, 'US Dollar', 'USD', '$', '', '.', ',', '2', 1.00000000, NOW()),
(2, 'Euro', 'EUR', '', 'EUR', '.', ',', '2', 0.64560002, NULL);

DROP TABLE IF EXISTS `customers`;
CREATE TABLE `customers` (
  `customers_id` int(11) NOT NULL auto_increment,
  `purchased_without_account` tinyint(1) unsigned NOT NULL default '0',
  `customers_gender` char(1) NOT NULL default '',
  `customers_firstname` varchar(32) NOT NULL default '',
  `customers_lastname` varchar(32) NOT NULL default '',
  `customers_dob` datetime NOT NULL default '0000-00-00 00:00:00',
  `customers_email_address` varchar(96) NOT NULL default '',
  `customers_user_id` varchar(255) NOT NULL default '',
  `customers_email_confirmation_key` varchar(15) NOT NULL default '',
  `customers_default_address_id` int(11) NOT NULL default '0',
  `customers_telephone` varchar(32) NOT NULL default '',
  `customers_fax` varchar(32) default NULL,
  `customers_password` varchar(40) NOT NULL default '',
  `customers_newsletter` char(1) default NULL,
  `customers_group_name` varchar(27) NOT NULL default 'Retail',
  `customers_group_id` int(11) NOT NULL default '0',
  `customers_group_ra` enum('0','1') NOT NULL default '0',
  `customers_payment_allowed` varchar(255) NOT NULL default '',
  `customers_shipment_allowed` varchar(255) NOT NULL default '',
  `customers_paypal_payerid` varchar(20) default NULL,
  `customers_paypal_ec` tinyint(1) unsigned NOT NULL default '0',
  `registration_ip_address` varchar(19) NOT NULL default '0.0.0.0',
  `activation_key` varchar(20) NOT NULL,
  `active` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`customers_id`),
  KEY `purchased_without_account` (`purchased_without_account`)
) TYPE=MyISAM  AUTO_INCREMENT=1;


DROP TABLE IF EXISTS `customers_basket`;
CREATE TABLE `customers_basket` (
  `customers_basket_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `products_id` tinytext NOT NULL,
  `customers_basket_quantity` int(2) NOT NULL default '0',
  `final_price` decimal(15,4) NOT NULL default '0.0000',
  `customers_basket_date_added` varchar(8) default NULL,
  PRIMARY KEY  (`customers_basket_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `customers_basket_attributes`;
CREATE TABLE `customers_basket_attributes` (
  `customers_basket_attributes_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `products_id` tinytext NOT NULL,
  `products_options_id` int(11) NOT NULL default '0',
  `products_options_value_id` int(11) NOT NULL default '0',
  `products_options_value_text` varchar(32) default NULL,
  PRIMARY KEY  (`customers_basket_attributes_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `customers_groups`;
CREATE TABLE `customers_groups` (
  `customers_group_id` smallint(5) unsigned NOT NULL default '0',
  `customers_group_name` varchar(32) NOT NULL default '',
  `customers_group_show_tax` enum('1','0') NOT NULL default '1',
  `customers_group_tax_exempt` enum('0','1') NOT NULL default '0',
  `group_payment_allowed` varchar(255) NOT NULL default '',
  `group_shipment_allowed` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`customers_group_id`)
) TYPE=MyISAM;


INSERT INTO `customers_groups` (`customers_group_id`, `customers_group_name`, `customers_group_show_tax`, `customers_group_tax_exempt`, `group_payment_allowed`, `group_shipment_allowed`) VALUES
(0, 'Retail', '1', '0', '', ''),
(1, 'Wholesale', '0', '0', '', '');

DROP TABLE IF EXISTS `customers_info`;
CREATE TABLE `customers_info` (
  `customers_info_id` int(11) NOT NULL default '0',
  `customers_info_date_of_last_logon` datetime default NULL,
  `customers_info_number_of_logons` int(5) default NULL,
  `customers_info_date_account_created` datetime default NULL,
  `customers_info_date_account_last_modified` datetime default NULL,
  `global_product_notifications` int(1) default '0',
  PRIMARY KEY  (`customers_info_id`)
) TYPE=MyISAM;



DROP TABLE IF EXISTS `customers_wishlist`;
CREATE TABLE `customers_wishlist` (
  `customers_wishlist_id` int(11) NOT NULL auto_increment,
  `products_id` tinytext NOT NULL,
  `customers_id` int(13) NOT NULL default '0',
  `public` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`customers_wishlist_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `customers_wishlist_attributes`;
CREATE TABLE `customers_wishlist_attributes` (
  `customers_wishlist_attributes_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `products_id` tinytext NOT NULL,
  `products_options_id` int(11) NOT NULL default '0',
  `products_options_value_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`customers_wishlist_attributes_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `geo_zones`;
CREATE TABLE `geo_zones` (
  `geo_zone_id` int(11) NOT NULL auto_increment,
  `geo_zone_name` varchar(32) NOT NULL default '',
  `geo_zone_description` varchar(255) NOT NULL default '',
  `last_modified` datetime default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`geo_zone_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;


INSERT INTO `geo_zones` (`geo_zone_id`, `geo_zone_name`, `geo_zone_description`, `last_modified`, `date_added`) VALUES
(1, 'PA', 'PA Sales Tax', NULL, NOW());

DROP TABLE IF EXISTS `image_stamp`;
CREATE TABLE `image_stamp` (
  `image_id` int(11) NOT NULL auto_increment,
  `stamp_image` varchar(64) default NULL,
  `status` enum('active','inactive') default 'active',
  PRIMARY KEY  (`image_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `image_stamp_saved_options`;
CREATE TABLE `image_stamp_saved_options` (
  `image_stamp_saved_options_id` int(11) NOT NULL auto_increment,
  `image_stamp_saved_options_title` varchar(255) default '',
  `image_stamp_saved_options_description` varchar(255) default '',
  `image_stamp_saved_options` varchar(255) default '',
  PRIMARY KEY  (`image_stamp_saved_options_id`)
) TYPE=InnoDB AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `languages`;
CREATE TABLE `languages` (
  `languages_id` int(11) NOT NULL auto_increment,
  `name` varchar(32) NOT NULL default '',
  `code` char(2) NOT NULL default '',
  `image` varchar(64) default NULL,
  `directory` varchar(32) default NULL,
  `encoding` varchar(64) NOT NULL default 'ISO-8859-1',
  `sort_order` int(3) default NULL,
  PRIMARY KEY  (`languages_id`),
  KEY `IDX_LANGUAGES_NAME` (`name`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;


INSERT INTO `languages` (`languages_id`, `name`, `code`, `image`, `directory`, `encoding`, `sort_order`) VALUES
(1, 'English', 'en', 'icon.gif', 'english', 'ISO-8859-1', 1);

DROP TABLE IF EXISTS `login_attempts`;
CREATE TABLE `login_attempts` (
  `id` int(200) NOT NULL auto_increment,
  `ip_address` varchar(64) NOT NULL default '0.0.0.0',
  `user_name` varchar(64) NOT NULL default '',
  `password` varchar(200) NOT NULL default '',
  `attempt_count` int(100) default '0',
  `time_stamp` int(30) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `manufacturers`;
CREATE TABLE `manufacturers` (
  `manufacturers_id` int(11) NOT NULL auto_increment,
  `manufacturers_name` varchar(32) NOT NULL default '',
  `manufacturers_image` varchar(64) default NULL,
  `date_added` datetime default NULL,
  `last_modified` datetime default NULL,
  PRIMARY KEY  (`manufacturers_id`),
  KEY `IDX_MANUFACTURERS_NAME` (`manufacturers_name`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `manufacturers_info`;
CREATE TABLE `manufacturers_info` (
  `manufacturers_id` int(11) NOT NULL default '0',
  `languages_id` int(11) NOT NULL default '0',
  `manufacturers_url` varchar(255) NOT NULL default '',
  `url_clicked` int(5) NOT NULL default '0',
  `date_last_click` datetime default NULL,
  PRIMARY KEY  (`manufacturers_id`,`languages_id`)
) TYPE=MyISAM;


DROP TABLE IF EXISTS `tags`;
CREATE TABLE `tags` (
  `tags_id` int(11) NOT NULL auto_increment,
  `tag` varchar(32) NOT NULL default '',
  `language_id` int(11) NOT NULL default '1',
  `products_count` int(11) NOT NULL default '0',
  `date_added` datetime default '0000-00-00 00:00:00',
  `last_modified` datetime default NULL,
  PRIMARY KEY  (`tags_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1;


DROP TABLE IF EXISTS `tags_data`;
CREATE TABLE `tags_data` (
  `tags_data_id` int(11) NOT NULL auto_increment,
  `tags_id` int(11) NOT NULL default 0,
  `tag_hit_count` int(20) NOT NULL default 1,
  `date_added` datetime default NULL,
  `last_modified` datetime default NULL,
  PRIMARY KEY  (`tags_data_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1;


DROP TABLE IF EXISTS `products_to_tags`;
CREATE TABLE `products_to_tags` (
  `products_id` int(11) NOT NULL default '0',
  `tags_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`products_id`,`tags_id`)
) TYPE=MyISAM;


DROP TABLE IF EXISTS `newsletters`;
CREATE TABLE `newsletters` (
  `newsletters_id` int(11) NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `content` text NOT NULL,
  `module` varchar(255) NOT NULL default '',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_sent` datetime default NULL,
  `status` int(1) default NULL,
  `locked` int(1) default '0',
  PRIMARY KEY  (`newsletters_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

DROP TABLE IF EXISTS `google_orders`;
CREATE TABLE `google_orders` (
  `orders_id` int(11) default NULL,
  `google_order_number` bigint(20) default NULL,
  `order_amount` decimal(15,4) default NULL
) TYPE=InnoDB;

DROP TABLE IF EXISTS `google_checkout`;
CREATE TABLE `google_checkout` (
  `customers_id` int(11) default NULL,
  `buyer_id` bigint(20) default NULL
) TYPE=InnoDB;


DROP TABLE IF EXISTS `orders`;
CREATE TABLE `orders` (
  `orders_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `customers_name` varchar(64) NOT NULL default '',
  `customers_company` varchar(32) default NULL,
  `customers_street_address` varchar(64) NOT NULL default '',
  `customers_suburb` varchar(32) default NULL,
  `customers_city` varchar(32) NOT NULL default '',
  `customers_postcode` varchar(10) NOT NULL default '',
  `customers_state` varchar(32) default NULL,
  `customers_country` varchar(32) NOT NULL default '',
  `customers_telephone` varchar(32) NOT NULL default '',
  `customers_email_address` varchar(96) NOT NULL default '',
  `customers_address_format_id` int(5) NOT NULL default '0',
  `delivery_name` varchar(64) NOT NULL default '',
  `delivery_company` varchar(32) default NULL,
  `delivery_street_address` varchar(64) NOT NULL default '',
  `delivery_suburb` varchar(32) default NULL,
  `delivery_city` varchar(32) NOT NULL default '',
  `delivery_postcode` varchar(10) NOT NULL default '',
  `delivery_state` varchar(32) default NULL,
  `delivery_country` varchar(32) NOT NULL default '',
  `delivery_address_format_id` int(5) NOT NULL default '0',
  `delivery_tracking_number` varchar(255) NOT NULL default '',
  `invoice_serial` varchar(5) NOT NULL default '',
  `invoice_number` int(11) NOT NULL default '0',
  `billing_name` varchar(64) NOT NULL default '',
  `billing_company` varchar(32) default NULL,
  `billing_street_address` varchar(64) NOT NULL default '',
  `billing_suburb` varchar(32) default NULL,
  `billing_city` varchar(32) NOT NULL default '',
  `billing_postcode` varchar(10) NOT NULL default '',
  `billing_state` varchar(32) default NULL,
  `billing_country` varchar(32) NOT NULL default '',
  `billing_address_format_id` int(5) NOT NULL default '0',
  `payment_method` varchar(32) NOT NULL default '',
  `cc_type` varchar(20) default NULL,
  `cc_owner` varchar(64) default NULL,
  `cc_number` varchar(32) default NULL,
  `cc_expires` varchar(4) default NULL,
  `last_modified` datetime default NULL,
  `date_purchased` datetime default NULL,
  `orders_status` int(5) NOT NULL default '0',
  `orders_date_finished` datetime default NULL,
  `currency` char(3) default NULL,
  `currency_value` decimal(14,6) default NULL,
  `paypal_ipn_id` int(11) NOT NULL default '0',
  `fedex_tracking` varchar(20) NOT NULL default '',
  `purchased_without_account` tinyint(1) unsigned NOT NULL default '0',
  `shipping_tax` decimal(7,4) NOT NULL default '0.0000',
  `shipping_date` datetime default NULL,
  `carrier_id` int(11) default NULL,
  `language_id` int(11) NOT NULL default '1',
  PRIMARY KEY  (`orders_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1;



DROP TABLE IF EXISTS `orders_products`;
CREATE TABLE `orders_products` (
  `orders_products_id` int(11) NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `products_id` int(11) NOT NULL default '0',
  `products_model` varchar(12) default NULL,
  `products_name` varchar(255) NOT NULL,
  `products_price` decimal(15,4) NOT NULL default '0.0000',
  `final_price` decimal(15,4) NOT NULL default '0.0000',
  `products_discount_made` decimal(15,4) NOT NULL,
  `products_tax` decimal(7,4) NOT NULL default '0.0000',
  `products_quantity` int(2) NOT NULL default '0',
  `products_stock_attributes` varchar(255) default NULL,
  `products_return` TINYINT(2) NOT NULL DEFAULT '1',
  `products_returned` tinyint(2) unsigned default '0',
  `products_exchanged` tinyint(2) NOT NULL default '0',
  `products_exchanged_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`orders_products_id`),
  KEY `orders_id` (`orders_id`),
  KEY `products_id` (`products_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `orders_products_attributes`;
CREATE TABLE `orders_products_attributes` (
  `orders_products_attributes_id` int(11) NOT NULL auto_increment,
  `products_attributes_id` int(11) NOT NULL,
  `orders_id` int(11) NOT NULL default '0',
  `orders_products_id` int(11) NOT NULL default '0',
  `products_options` varchar(32) NOT NULL,
  `products_options_values` varchar(32) NOT NULL,
  `options_values_price` decimal(15,4) NOT NULL default '0.0000',
  `price_prefix` char(1) NOT NULL,
  `weight_prefix` char(1) NOT NULL,
  `products_options_weight` decimal(5,2) NOT NULL default '0.00',
  PRIMARY KEY  (`orders_products_attributes_id`),
  KEY `orders_products_id` (`orders_products_id`)
) TYPE=InnoDB AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `orders_products_download`;
CREATE TABLE `orders_products_download` (
  `orders_products_download_id` int(11) NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `products_attributes_id` int(11) NOT NULL default '0',
  `orders_products_id` int(11) NOT NULL default '0',
  `orders_products_filename` varchar(255) NOT NULL default '',
  `download_maxdays` int(2) NOT NULL default '0',
  `download_count` int(2) NOT NULL default '0',
  PRIMARY KEY  (`orders_products_download_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `orders_status`;
CREATE TABLE `orders_status` (
  `orders_status_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `orders_status_name` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`orders_status_id`,`language_id`),
  KEY `idx_orders_status_name` (`orders_status_name`)
) TYPE=MyISAM;


INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES
(1, 1, 'Pending'),
(2, 1, 'Processing'),
(3, 1, 'Shipped'),
(4, 1, 'Updated');

DROP TABLE IF EXISTS `orders_status_history`;
CREATE TABLE `orders_status_history` (
  `orders_status_history_id` int(11) NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `orders_status_id` int(5) NOT NULL default '0',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `customer_notified` int(1) default '0',
  `comments` text,
  PRIMARY KEY  (`orders_status_history_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `orders_status_history_transactions`;
CREATE TABLE `orders_status_history_transactions` (
  `orders_status_history_id` int(11) NOT NULL,
  `transaction_id` varchar(64) NOT NULL,
  `transaction_type` varchar(32) NOT NULL,
  `payment_type` varchar(32) NOT NULL,
  `payment_status` varchar(32) NOT NULL,
  `transaction_amount` decimal(7,2) NOT NULL,
  `module_code` varchar(32) NOT NULL,
  `transaction_avs` varchar(64) NOT NULL,
  `transaction_cvv2` varchar(64) NOT NULL,
  `transaction_msgs` varchar(255) NOT NULL,
  PRIMARY KEY  (`orders_status_history_id`),
  KEY `transaction_id` (`transaction_id`)
) TYPE=InnoDB;

DROP TABLE IF EXISTS `orders_total`;
CREATE TABLE `orders_total` (
  `orders_total_id` int(10) unsigned NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `title` varchar(255) NOT NULL default '',
  `text` varchar(255) NOT NULL default '',
  `value` decimal(15,4) NOT NULL default '0.0000',
  `class` varchar(32) NOT NULL default '',
  `sort_order` int(11) NOT NULL default '0',
  PRIMARY KEY  (`orders_total_id`),
  KEY `idx_orders_total_orders_id` (`orders_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `packaging`;
CREATE TABLE `packaging` (
  `package_id` int(11) NOT NULL auto_increment,
  `package_name` varchar(64) NOT NULL default '',
  `package_description` varchar(255) NOT NULL default '',
  `package_length` decimal(6,2) NOT NULL default '5.00',
  `package_width` decimal(6,2) NOT NULL default '5.00',
  `package_height` decimal(6,2) NOT NULL default '5.00',
  `package_empty_weight` decimal(6,2) NOT NULL default '0.00',
  `package_max_weight` decimal(6,2) NOT NULL default '50.00',
  `package_cost` int(5) NOT NULL default '0',
  PRIMARY KEY  (`package_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `password_requests`;
CREATE TABLE `password_requests` (
  `password_requests_id` int(11) NOT NULL auto_increment,
  `customers_email` varchar(200) NOT NULL default '',
  `customers_id` int(11) NOT NULL default '0',
  `password_requests_ip` varchar(15) NOT NULL default '0.0.0.0',
  `password_requests_key` varchar(200) NOT NULL default '',
  `password_requests_count` int(11) NOT NULL default '0',
  `password_sent_count` int(11) NOT NULL default '0',
  `password_new` varchar(200) NOT NULL default '',
  `password_requests_time_added` varchar(20) NOT NULL default '',
  `password_requests_time_last_modified` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`password_requests_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `paypal_ipn`;
CREATE TABLE `paypal_ipn` (
  `paypal_ipn_id` int(10) unsigned NOT NULL auto_increment,
  `txn_type` int(10) unsigned NOT NULL default '0',
  `reason_code` int(11) default NULL,
  `payment_type` int(11) NOT NULL default '0',
  `payment_status` int(11) NOT NULL default '0',
  `pending_reason` int(11) default NULL,
  `invoice` varchar(64) default NULL,
  `mc_currency` int(11) NOT NULL default '1',
  `first_name` varchar(32) NOT NULL default '',
  `last_name` varchar(32) NOT NULL default '',
  `payer_business_name` varchar(32) default NULL,
  `address_name` varchar(32) NOT NULL default '',
  `address_street` varchar(64) NOT NULL default '',
  `address_city` varchar(32) NOT NULL default '',
  `address_state` varchar(32) NOT NULL default '',
  `address_zip` varchar(64) NOT NULL default '',
  `address_country` varchar(32) NOT NULL default '',
  `address_status` varchar(64) NOT NULL default '',
  `address_owner` varchar(64) NOT NULL default '0',
  `payer_email` varchar(96) NOT NULL default '',
  `ebay_address_id` varchar(96) default NULL,
  `payer_id` varchar(32) NOT NULL default '',
  `payer_status` varchar(32) NOT NULL default '',
  `payment_date` varchar(32) NOT NULL default '',
  `business` varchar(32) NOT NULL default '',
  `receiver_email` varchar(96) NOT NULL default '',
  `receiver_id` varchar(32) NOT NULL default '',
  `paypal_address_id` varchar(64) NOT NULL default '',
  `txn_id` varchar(17) NOT NULL default '',
  `notify_version` varchar(17) NOT NULL default '',
  `verify_sign` varchar(64) NOT NULL default '',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`paypal_ipn_id`,`txn_id`),
  KEY `idx_paypal_ipn_paypal_ipn_id` (`paypal_ipn_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `plugins`;
CREATE TABLE `plugins` (
  `plugins_id` int(11) NOT NULL auto_increment,
  `language_id` int(11) NOT NULL default '1',
  `plugins_key` varchar(100) NOT NULL default '',
  `plugins_group` varchar(100) NOT NULL default '',
  `plugins_name` varchar(255) NOT NULL default '',
  `plugins_file_name` varchar(100) NOT NULL default '',
  `plugins_options` text,
  `plugins_text` text,
  `plugins_description` varchar(255) NOT NULL default '',
  `plugins_sort_order` int(11) NOT NULL default '1',
  `plugins_status` int(1) NOT NULL default '1',
  `plugins_date_added` datetime default NULL,
  PRIMARY KEY  (`plugins_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;


INSERT INTO `plugins` (`plugins_id`, `language_id`, `plugins_key`, `plugins_group`, `plugins_name`, `plugins_file_name`, `plugins_options`, `plugins_text`, `plugins_description`, `plugins_sort_order`, `plugins_status`, `plugins_date_added`) VALUES
(1, 1, 'SEARCH', 'LEFT', 'Search', 'search.php', 'a:2:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:6:"Search";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}}', '', 'Quick search Plugin!', 0, 1, '0000-00-00 00:00:00'),
(2, 1, 'CATEGORIES', 'LEFT', 'Categories', 'categories.php', 'a:2:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:10:"Categories";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}}', '', 'Categories Plugin!', 1, 1, '0000-00-00 00:00:00'),
(3, 1, 'ARTICLES', 'LEFT', 'Articles', 'articles.php', 'a:2:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:9:"Site Info";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}}', '', 'Articles Plugin!', 2, 1, '0000-00-00 00:00:00'),
(4, 1, 'MANUFACTURERS', 'LEFT', 'Manufacturers', 'manufacturers.php', 'a:7:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:13:"Manufacturers";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:2;a:5:{s:4:"name";s:8:"Show url";s:11:"description";s:21:"Show header as link ?";s:3:"key";s:8:"show_url";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:3;a:5:{s:4:"name";s:13:"Smart display";s:11:"description";s:98:"Hides manufacturers plugin under certain conditions (where it''s not needed) <br />Recommended "On"";s:3:"key";s:13:"smart_display";s:7:"options";a:2:{i:1;s:2:"On";i:0;s:3:"Off";}s:5:"value";s:1:"1";}i:4;a:4:{s:4:"name";s:4:"Type";s:3:"key";s:4:"type";s:7:"options";a:2:{s:6:"images";s:6:"Images";s:8:"dropdown";s:9:"Drop down";}s:5:"value";s:6:"images";}i:5;a:4:{s:4:"name";s:10:"Sort order";s:3:"key";s:10:"sort_order";s:7:"options";a:5:{s:4:"name";s:4:"Name";s:9:"name_desc";s:9:"Name Desc";s:10:"date_added";s:10:"Date added";s:15:"date_added_desc";s:15:"Date added Desc";s:6:"random";s:6:"Random";}s:5:"value";s:4:"name";}i:6;a:4:{s:4:"name";s:5:"Limit";s:3:"key";s:5:"limit";s:7:"options";s:0:"";s:5:"value";s:2:"15";}}', '', 'Manufacturers Plugin', 4, 1, '0000-00-00 00:00:00'),
(5, 1, 'INFO1', 'LEFT', 'Info 1', 'info1.php', 'a:2:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:11:"Information";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}}', '<br style="clear:both;"/>\n<div style="text-align:center;">\n	<a href="http://www.eclime.com"><img src="templates/eclime_two/images/eclime_88x35.gif" alt="eclime - Free powerful e-commerce software" /></a><br /><br />\n	<img src="templates/eclime_two/images/smarty.gif" alt="100% pure Smarty" /><br /><br />\n	<img src="templates/eclime_two/images/webstandards.gif" alt="Web standards" /><br /><br />\n	<img src="templates/eclime_two/images/noframes.gif" alt="No frames" /><br /><br />\n	<img src="templates/eclime_two/images/nn4safe.gif" alt="NN4safe" /><br /><br /><br />\n	<a href="rss.php"><img src="templates/eclime_two/images/rss2.gif" alt="RSS 2.0" /></a><br /><br />\n</div>\n', 'Information Plugin!', 6, 1, '0000-00-00 00:00:00'),
(6, 1, 'CURRENCIES', 'RIGHT', 'Currencies', 'currencies.php', 'a:2:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:10:"Currencies";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}}', '', 'Quick search Plugin!', 4, 1, '0000-00-00 00:00:00'),
(7, 1, 'LANGUAGES', 'RIGHT', 'Languages', 'languages.php', 'a:3:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:9:"Languages";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:2;a:4:{s:4:"name";s:4:"Type";s:3:"key";s:4:"type";s:7:"options";a:2:{s:5:"links";s:5:"Links";s:8:"dropdown";s:9:"Drop down";}s:5:"value";s:4:"name";}}', '', 'Languages Plugin!', 5, 1, '0000-00-00 00:00:00'),
(8, 1, 'BESTSELLERS', 'RIGHT', 'Best sellers', 'bestsellers.php', 'a:4:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:12:"Best sellers";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:2;a:4:{s:4:"name";s:5:"Limit";s:3:"key";s:5:"limit";s:7:"options";s:0:"";s:5:"value";s:2:"10";}i:3;a:4:{s:4:"name";s:18:"Category sensitive";s:3:"key";s:18:"category_sensitive";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}}', '', 'This is a best seller plugin', 9, 1, '0000-00-00 00:00:00'),
(9, 1, 'POLL', 'RIGHT', 'Poll', 'poll.php', 'a:3:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:4:"Poll";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:2;a:5:{s:4:"name";s:20:"Always show results?";s:11:"description";s:197:""Yes" - Poll results will be shown all the time (uses more resources).<br />"No" - poll results will disappear after user voted and viewed the results (uses less resources).<br />(Recommended "No")";s:3:"key";s:19:"always_show_results";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"0";}}', '', 'Poll Plugin!', 8, 1, '0000-00-00 00:00:00'),
(10, 1, 'RECENTLYVISITED', 'RIGHT', 'Recently Visited', 'recentlyvisited.php', 'a:7:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:16:"Recently Visited";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:2;a:4:{s:4:"name";s:4:"Type";s:3:"key";s:4:"type";s:7:"options";a:3:{s:4:"both";s:4:"Both";s:8:"products";s:13:"Products only";s:10:"categories";s:15:"Categories only";}s:5:"value";s:4:"both";}i:3;a:4:{s:4:"name";s:15:"Products header";s:3:"key";s:15:"products_header";s:7:"options";s:0:"";s:5:"value";s:15:"Recent products";}i:4;a:4:{s:4:"name";s:17:"Categories header";s:3:"key";s:17:"categories_header";s:7:"options";s:0:"";s:5:"value";s:17:"Recent categories";}i:5;a:4:{s:4:"name";s:14:"Products Limit";s:3:"key";s:14:"products_limit";s:7:"options";s:0:"";s:5:"value";s:1:"5";}i:6;a:4:{s:4:"name";s:16:"Categories Limit";s:3:"key";s:16:"categories_limit";s:7:"options";s:0:"";s:5:"value";s:1:"3";}}', '', 'Recently visited products/categories plugin.', 7, 1, '0000-00-00 00:00:00'),
(11, 1, 'SHOPPINGCART', 'RIGHT', 'Shopping cart', 'shoppingcart.php', 'a:10:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:13:"Shopping cart";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:2;a:5:{s:4:"name";s:8:"Show url";s:11:"description";s:21:"Show header as link ?";s:3:"key";s:8:"show_url";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:3;a:5:{s:4:"name";s:13:"Show Products";s:11:"description";s:13:"Show products";s:3:"key";s:13:"show_products";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:4;a:5:{s:4:"name";s:19:"Show Products Count";s:11:"description";s:19:"Show products count";s:3:"key";s:19:"show_products_count";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"0";}i:5;a:5:{s:4:"name";s:10:"Show Price";s:11:"description";s:19:"Show products price";s:3:"key";s:10:"show_price";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:6;a:5:{s:4:"name";s:10:"Show Total";s:11:"description";s:25:"Show products total price";s:3:"key";s:10:"show_total";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:7;a:5:{s:4:"name";s:10:"Show Image";s:11:"description";s:19:"Show products image";s:3:"key";s:10:"show_image";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:8;a:5:{s:4:"name";s:10:"Show Attr.";s:11:"description";s:24:"Show products attributes";s:3:"key";s:9:"show_attr";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:9;a:5:{s:4:"name";s:13:"Smart display";s:11:"description";s:91:"Hides shopping cart under certain conditions (where it''s not needed) <br />Recommended "On"";s:3:"key";s:13:"smart_display";s:7:"options";a:2:{i:1;s:2:"On";i:0;s:3:"Off";}s:5:"value";s:1:"1";}}', '', 'Mini shopping cart plugin!', 2, 1, '0000-00-00 00:00:00'),
(12, 1, 'REVIEWS', 'RIGHT', 'Reviews', 'reviews.php', 'a:8:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:15:"Product reviews";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:2;a:5:{s:4:"name";s:8:"Show url";s:11:"description";s:21:"Show header as link ?";s:3:"key";s:8:"show_url";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:3;a:5:{s:4:"name";s:13:"Smart display";s:11:"description";s:92:"Hides reviews plugin under certain conditions (where it''s not needed) <br />Recommended "On"";s:3:"key";s:13:"smart_display";s:7:"options";a:2:{i:1;s:2:"On";i:0;s:3:"Off";}s:5:"value";s:1:"1";}i:4;a:5:{s:4:"name";s:17:"Product sensitive";s:11:"description";s:93:"When user is viewing a product; available reviews will be shown specifically for that product";s:3:"key";s:17:"product_sensitive";s:7:"options";a:2:{i:1;s:2:"On";i:0;s:3:"Off";}s:5:"value";s:1:"1";}i:5;a:5:{s:4:"name";s:13:"Force Display";s:11:"description";s:130:"If set to ''On'' and there are no reviews to diplay for a particular product; any available review(s) will be shown in custom order.";s:3:"key";s:12:"force_diplay";s:7:"options";a:2:{i:1;s:2:"On";i:0;s:3:"Off";}s:5:"value";s:1:"1";}i:6;a:4:{s:4:"name";s:10:"Sort order";s:3:"key";s:10:"sort_order";s:7:"options";a:5:{s:15:"date_added_desc";s:15:"Date added Desc";s:10:"date_added";s:10:"Date added";s:4:"name";s:4:"Name";s:9:"name_desc";s:9:"Name Desc";s:6:"random";s:6:"Random";}s:5:"value";s:15:"date_added_desc";}i:7;a:4:{s:4:"name";s:5:"Limit";s:3:"key";s:5:"limit";s:7:"options";s:0:"";s:5:"value";s:1:"5";}}', '', 'Reviews Plugin!', 10, 1, '0000-00-00 00:00:00'),
(13, 1, 'MAINPAGEINFO', 'CENTER', 'Main page info', 'mainpage.php', 'a:2:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:8:"Welcome!";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"0";}}', '<table cellspacing="0" cellpadding="0" style="border: 0pt none ; width: 100%;margin-bottom:10px;">\r\n    <tbody>\r\n        <tr>\r\n            <td style="background-image: url(templates/eclime_two/images/eclime_banner_bg.jpg); background-position: center top; background-repeat: repeat-x; text-align: left; width: 50%;"><img src="templates/eclime_two/images/eclime_banner_l.jpg" alt="Welcome to eclime.com" style="border: 0pt none ; vertical-align: bottom;" /></td>\r\n            <td style="background-image: url(templates/eclime_two/images/eclime_banner_bg.jpg); background-position: center top; background-repeat: repeat-x; text-align: right; width: 50%;"><img src="templates/eclime_two/images/eclime_banner_r.jpg" alt="Welcome to eclime.com" style="border: 0pt none ; vertical-align: bottom;" /></td>\r\n        </tr>\r\n    </tbody>\r\n</table>', 'Main page info Plugin!', 0, 1, '0000-00-00 00:00:00'),
(14, 1, 'NEWPRODUCTS', 'CENTER', 'New Products', 'newproducts.php', 'a:5:{i:0;a:5:{s:4:"name";s:4:"Name";s:11:"description";s:0:"";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:12:"New Products";}i:1;a:5:{s:4:"name";s:11:"Show header";s:11:"description";s:0:"";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:2;a:5:{s:4:"name";s:5:"Limit";s:11:"description";s:0:"";s:3:"key";s:5:"limit";s:7:"options";s:0:"";s:5:"value";s:1:"5";}i:3;a:5:{s:4:"name";s:8:"Days old";s:11:"description";s:37:"Show products only up to X days old. ";s:3:"key";s:8:"days_ago";s:7:"options";s:0:"";s:5:"value";s:2:"31";}i:4;a:5:{s:4:"name";s:11:"Category Id";s:11:"description";s:0:"";s:3:"key";s:13:"categories_id";s:7:"options";s:0:"";s:5:"value";s:1:"0";}}', '', 'Displays new products.', 1, 1, '0000-00-00 00:00:00'),
(15, 1, 'RANDOMPRODUCTS', 'CENTER', 'Random Products', 'randomproducts.php', 'a:4:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:15:"Random Products";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:2;a:4:{s:4:"name";s:5:"Limit";s:3:"key";s:5:"limit";s:7:"options";s:0:"";s:5:"value";s:1:"5";}i:3;a:4:{s:4:"name";s:11:"Category Id";s:3:"key";s:13:"categories_id";s:7:"options";s:0:"";s:5:"value";s:1:"0";}}', '', 'Displays products randomly.', 3, 1, '0000-00-00 00:00:00'),
(16, 1, 'SPECIALSPRODUCTS', 'CENTER', 'Product Specials', 'specialsproducts.php', 'a:5:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:17:"Products Specials";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:2;a:4:{s:4:"name";s:5:"Limit";s:3:"key";s:5:"limit";s:7:"options";s:0:"";s:5:"value";s:1:"5";}i:3;a:4:{s:4:"name";s:10:"Sort order";s:3:"key";s:10:"sort_order";s:7:"options";a:7:{s:8:"date_asc";s:4:"Date";s:9:"date_desc";s:9:"Date DESC";s:15:"price_saved_asc";s:11:"Price Saved";s:16:"price_saved_desc";s:16:"Price Saved DESC";s:9:"price_asc";s:5:"Price";s:10:"price_desc";s:10:"Price DESC";s:6:"random";s:6:"Random";}s:5:"value";s:6:"random";}i:4;a:4:{s:4:"name";s:11:"Category Id";s:3:"key";s:13:"categories_id";s:7:"options";s:0:"";s:5:"value";s:1:"0";}}', '', 'Displays specials products', 4, 1, '0000-00-00 00:00:00'),
(17, 1, 'VIRTUALPRODUCTS', 'CENTER', 'Virtual Products', 'virtualproducts.php', 'a:4:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:16:"Virtual products";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:2;a:4:{s:4:"name";s:10:"Sort order";s:3:"key";s:10:"sort_order";s:7:"options";a:2:{s:6:"custom";s:6:"Custom";s:6:"random";s:6:"Random";}s:5:"value";s:6:"custom";}i:3;a:4:{s:4:"name";s:152:"<img src="includes/languages/english/images/buttons/mini_edit_products.gif" width="84" height="14" border="0" alt="Edit products" title="Edit products">";s:3:"key";s:13:"edit_products";s:7:"options";s:6:"hidden";s:5:"value";s:38:"plugin_key=VIRTUALPRODUCTS&action=show";}}', '', 'Displays existing products in custom sort order.', 2, 1, '0000-00-00 00:00:00'),
(18, 1, 'INFO2', 'RIGHT', 'Info 2', 'info2.php', 'a:2:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:14:"Google Adsense";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}}', '<script type="text/javascript"><!--\r\ngoogle_ad_client = "pub-5646984675357361";\r\n/* 120x240, created 4/30/09 */\r\ngoogle_ad_slot = "5514549946";\r\ngoogle_ad_width = 120;\r\ngoogle_ad_height = 240;\r\n//-->\r\n</script> <script type="text/javascript"\r\nsrc="http://pagead2.googlesyndication.com/pagead/show_ads.js">\r\n</script>', 'Information Plugin!', 11, 1, '0000-00-00 00:00:00'),
(19, 1, 'INFO3', 'LEFT', 'Info 3', 'info3.php', 'a:2:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:11:"Information";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}}', '<script type="text/javascript"><!--\r\ngoogle_ad_client = "pub-5646984675357361";\r\n/* 120x240, created 4/30/09 */\r\ngoogle_ad_slot = "5514549946";\r\ngoogle_ad_width = 120;\r\ngoogle_ad_height = 240;\r\n//-->\r\n</script> <script type="text/javascript"\r\nsrc="http://pagead2.googlesyndication.com/pagead/show_ads.js">\r\n</script>', 'Information Plugin!', 5, 1, '0000-00-00 00:00:00'),
(20, 1, 'INFO4', 'LEFT', 'Info 4', 'info4.php', 'a:2:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:13:"Information 4";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"0";}}', '<p><img width="194" height="129" src="images/coupon_15off.gif" alt="" /></p>', 'Information Plugin!', 3, 1, '0000-00-00 00:00:00'),
(21, 1, 'TAGCLOUD', 'RIGHT', 'Tag Cloud', 'tagcloud.php', 'a:5:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:9:"Tag Cloud";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:2;a:4:{s:4:"name";s:9:"Tags sort";s:3:"key";s:4:"sort";s:7:"options";a:2:{s:5:"count";s:5:"Count";s:6:"random";s:6:"Random";}s:5:"value";s:6:"random";}i:3;a:5:{s:4:"name";s:19:"Tags generated from";s:3:"key";s:9:"tags_type";s:7:"options";a:2:{s:5:"users";s:11:"User clicks";s:8:"products";s:16:"Products density";}s:5:"value";s:8:"products";s:11:"description";s:221:"<strong>User clicks</strong> &mdash; tag cloud is based on how many times user clicked on a specific tag.<br /><br /><strong>Products density</strong> &mdash; tag cloud is based on how many tags are available per product.";}i:4;a:4:{s:4:"name";s:10:"Tags limit";s:3:"key";s:9:"tag_limit";s:7:"options";s:0:"";s:5:"value";s:2:"15";}}', '', 'Tag Cloud Plugin.', 3, 1, '0000-00-00 00:00:00'),
(22, 1, 'SHIPPING', 'RIGHT', 'Shipping estimate', 'shipping.php', 'a:4:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:17:"Shipping estimate";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:2;a:4:{s:4:"name";s:16:"Show description";s:3:"key";s:16:"show_description";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:3;a:4:{s:4:"name";s:24:"Merge with shopping cart";s:3:"key";s:5:"merge";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"0";}}', '', 'Shipping estimate plugin', 6, 1, '0000-00-00 00:00:00'),
(23, 1, 'AFFILIATE', 'RIGHT', 'Affiliates', 'affiliate.php', 'a:6:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:10:"Affiliates";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:2;a:5:{s:4:"name";s:13:"Smart display";s:11:"description";s:94:"Hides affiliate plugin under certain conditions (where it''s not needed) <br />Recommended "On"";s:3:"key";s:13:"smart_display";s:7:"options";a:2:{i:1;s:2:"On";i:0;s:3:"Off";}s:5:"value";s:1:"1";}i:3;a:4:{s:4:"name";s:8:"FAQ Page";s:3:"key";s:8:"faq_page";s:7:"options";s:0:"";s:5:"value";s:31:"article_info.php?articles_id=21";}i:4;a:4:{s:4:"name";s:9:"Info Page";s:3:"key";s:9:"info_page";s:7:"options";s:0:"";s:5:"value";s:31:"article_info.php?articles_id=20";}i:5;a:4:{s:4:"name";s:15:"Conditions Page";s:3:"key";s:15:"conditions_page";s:7:"options";s:0:"";s:5:"value";s:31:"article_info.php?articles_id=19";}}', '', 'Affiliate plugin', 1, 1, '2009-11-19 19:24:23'),
(24, 1, 'LOGIN', 'RIGHT', 'Login', 'login.php', 'a:3:{i:0;a:4:{s:4:"name";s:4:"Name";s:3:"key";s:4:"name";s:7:"options";s:0:"";s:5:"value";s:11:"Quick Login";}i:1;a:4:{s:4:"name";s:11:"Show header";s:3:"key";s:11:"show_header";s:7:"options";a:2:{i:1;s:3:"Yes";i:0;s:2:"No";}s:5:"value";s:1:"1";}i:2;a:5:{s:4:"name";s:13:"Smart display";s:11:"description";s:90:"Hides login plugin under certain conditions (where it''s not needed) <br />Recommended "On"";s:3:"key";s:13:"smart_display";s:7:"options";a:2:{i:1;s:2:"On";i:0;s:3:"Off";}s:5:"value";s:1:"1";}}', '', 'Login plugin', 0, 1, '2009-11-20 13:57:27');


DROP TABLE IF EXISTS `poll`;
CREATE TABLE `poll` (
  `poll_id` int(11) NOT NULL auto_increment,
  `poll_type` enum('dropdown','radio') NOT NULL default 'radio',
  `poll_public` char(1) NOT NULL default '1',
  `poll_open` char(1) NOT NULL default '1',
  `categories_id` int(11) NOT NULL default '0',
  `products_id` int(11) NOT NULL default '0',
  `poll_count` mediumint(9) NOT NULL default '0',
  `poll_time` varchar(14) NOT NULL default '',
  PRIMARY KEY  (`poll_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `poll_description`;
CREATE TABLE `poll_description` (
  `poll_description_id` int(11) NOT NULL auto_increment,
  `poll_id` int(11) NOT NULL default '0',
  `poll_description` varchar(255) NOT NULL default '',
  `language_id` int(11) NOT NULL default '1',
  PRIMARY KEY  (`poll_description_id`, `language_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `poll_options`;
CREATE TABLE `poll_options` (
  `poll_options_id` int(11) NOT NULL auto_increment,
  `poll_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`poll_options_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `poll_options_description`;
CREATE TABLE `poll_options_description` (
  `poll_options_description_id` int(11) NOT NULL auto_increment,
  `poll_id` int(11) NOT NULL default '0',
  `poll_options_id` int(11) NOT NULL default '0',
  `poll_options_description` varchar(255) NOT NULL default '',
  `language_id` int(11) NOT NULL default '1',
  PRIMARY KEY  (`poll_options_description_id`, `language_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `poll_votes`;
CREATE TABLE `poll_votes` (
  `poll_votes_id` int(11) NOT NULL auto_increment,
  `poll_id` int(11) NOT NULL default '0',
  `poll_option_id` int(11) NOT NULL default '0',
  `poll_vote_ip` varchar(20) NOT NULL default '',
  `poll_vote_time` varchar(14) NOT NULL default '',
  PRIMARY KEY  (`poll_votes_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `products`;
CREATE TABLE `products` (
  `products_id` int(11) NOT NULL auto_increment,
  `products_quantity` int(4) NOT NULL default '0',
  `products_model` varchar(25) default NULL,
  `products_image` varchar(64) default NULL,
  `products_image_thumb` varchar(64) NOT NULL,
  `products_image_stamp` varchar(64) NOT NULL default '',
  `products_price` decimal(15,4) NOT NULL default '0.0000',
  `products_vendor_price` decimal(15,4) NOT NULL default '0.0000',
  `products_price_groups` smallint(2) NOT NULL default '0',
  `products_price_hidden` tinyint(1) NOT NULL default '0',
  `reviews_count` int(5) NOT NULL default '0',
  `average_rating` decimal(15,2) NOT NULL,
  `products_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `products_last_modified` datetime default NULL,
  `products_date_available` datetime default NULL,
  `products_weight` decimal(5,2) NOT NULL default '0.00',
  `products_status` tinyint(1) NOT NULL default '0',
  `products_tax_class_id` int(11) NOT NULL default '0',
  `manufacturers_id` int(11) default NULL,
  `products_ordered` int(11) NOT NULL default '0',
  `products_ship_price` decimal(15,4) NOT NULL default '0.0000',
  `products_length` decimal(6,2) NOT NULL default '12.00',
  `products_width` decimal(6,2) NOT NULL default '12.00',
  `products_height` decimal(6,2) NOT NULL default '12.00',
  `products_ready_to_ship` int(1) NOT NULL default '0',
  `products_to_rss` tinyint(4) NOT NULL default '1',
  `products_ship_price_two` decimal(15,4) NOT NULL default '0.0000',
  `accessories` enum('true','false') NOT NULL default 'false',
  `products_bundle` tinyint(4) NOT NULL default '0',
  `products_subscribe` varchar(64) NOT NULL default '',
  `products_access` varchar(64) NOT NULL default '0',
  `sort_order` int(4) NOT NULL default '0',
  `media` tinyint(4) NOT NULL default '0',
  `tags` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`products_id`),
  KEY `idx_products_date_added` (`products_date_added`)
) TYPE=MyISAM  AUTO_INCREMENT=1;



DROP TABLE IF EXISTS `products_accessories`;
CREATE TABLE `products_accessories` (
  `accessories_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `accessories_products_id` int(11) NOT NULL default '0',
  `accessories_text` varchar(200) NOT NULL,
  `accessories_date_added` datetime default NULL,
  `accessories_last_modified` datetime default NULL,
  `status` int(1) NOT NULL default '1',
  `sort_order` int(11) NOT NULL default '0',
  PRIMARY KEY  (`accessories_id`),
  KEY `products_id` (`products_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `products_attributes`;
CREATE TABLE `products_attributes` (
  `products_attributes_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `options_id` int(11) NOT NULL default '0',
  `options_values_id` int(11) NOT NULL default '0',
  `options_values_price` decimal(15,4) NOT NULL default '0.0000',
  `price_prefix` char(1) NOT NULL,
  `weight_prefix` char(1) NOT NULL,
  `products_options_weight` decimal(5,2) NOT NULL default '0.00',
  `products_options_sort_order` int(6) NOT NULL default '0',
  `selected` enum('true','false') NOT NULL default 'false',
  `products_attributes_image` varchar(200) NOT NULL,
  `products_attributes_image_stamp` varchar(200) NOT NULL,
  PRIMARY KEY  (`products_attributes_id`),
  KEY `products_id` (`products_id`,`options_id`)
) TYPE=InnoDB  AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `products_attributes_download`;
CREATE TABLE `products_attributes_download` (
  `products_attributes_id` int(11) NOT NULL default '0',
  `products_attributes_filename` varchar(255) NOT NULL default '',
  `products_attributes_maxdays` int(2) default '0',
  `products_attributes_maxcount` int(2) default '0',
  PRIMARY KEY  (`products_attributes_id`)
) TYPE=MyISAM;



DROP TABLE IF EXISTS `products_bundles`;
CREATE TABLE `products_bundles` (
  `products_id` int(11) NOT NULL default '0',
  `products_bundle_id` SMALLINT NOT NULL default '0',
  `products_bundle_qty` SMALLINT NOT NULL default '0',
  `products_bundle_sort` SMALLINT NOT NULL default '0',
  PRIMARY KEY  (`products_id`, `products_bundle_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1;



DROP TABLE IF EXISTS `products_description`;
CREATE TABLE `products_description` (
  `products_id` int(11) NOT NULL auto_increment,
  `language_id` int(11) NOT NULL default '1',
  `products_name` varchar(255) NOT NULL default '',
  `products_description` text,
  `products_description2` text NOT NULL,
  `products_meta_title` varchar(255) NOT NULL,
  `products_meta_description` varchar(255) NOT NULL,
  `products_meta_keywords` varchar(255) NOT NULL,
  `products_url` varchar(255) default NULL,
  `products_viewed` int(5) default '0',
  PRIMARY KEY  (`products_id`,`language_id`),
  KEY `products_name` (`products_name`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `products_extra_images`;
CREATE TABLE `products_extra_images` (
  `products_extra_images_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) default NULL,
  `products_extra_image` varchar(100) default NULL,
  `products_extra_image_stamp` varchar(100) default NULL,
  `products_extra_image_thumb` varchar(100) NOT NULL default '0',
  `products_extra_image_name` varchar(255) default '',
  `products_extra_image_sort` int(11) default '0',
  KEY `products_extra_images_id` (`products_extra_images_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1;



DROP TABLE IF EXISTS `products_groups`;
CREATE TABLE `products_groups` (
  `products_groups_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `customers_group_id` int(11) NOT NULL default '0',
  `customers_group_price` decimal(15,4) NOT NULL default '0.0000',
  `products_qty` int(11) NOT NULL default 0,
  PRIMARY KEY (products_groups_id)
) TYPE=MyISAM;



DROP TABLE IF EXISTS `products_notifications`;
CREATE TABLE `products_notifications` (
  `products_id` int(11) NOT NULL default '0',
  `customers_id` int(11) NOT NULL default '0',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`products_id`,`customers_id`)
) TYPE=MyISAM;



DROP TABLE IF EXISTS `products_options`;
CREATE TABLE `products_options` (
  `products_options_id` int(11) NOT NULL auto_increment,
  `products_options_track_stock` tinyint(4) NOT NULL default '0',
  `products_options_type` int(5) NOT NULL default '0',
  `products_options_length` smallint(2) NOT NULL default '32',
  `products_options_comment` varchar(32) default NULL,
  `products_options_sort_order` int(6) NOT NULL default '0',
  `type` enum('dropdown','radio') NOT NULL default 'dropdown',
  PRIMARY KEY  (`products_options_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `products_options_description`;
CREATE TABLE `products_options_description` (
  `products_options_id` int(11) NOT NULL auto_increment,
  `language_id` int(11) NOT NULL default '1',
  `products_options_name` varchar(32) NOT NULL default '',
  `products_options_description` text NOT NULL,
  PRIMARY KEY  (`products_options_id`,`language_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1;


DROP TABLE IF EXISTS `products_options_values`;
CREATE TABLE `products_options_values` (
  `products_options_values_id` int(11) NOT NULL auto_increment,
  `language_id` int(11) NOT NULL default '1',
  `products_options_values_name` varchar(255) NOT NULL,
  `products_options_values_description` text NOT NULL,
  PRIMARY KEY  (`products_options_values_id`,`language_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `products_options_values_to_products_options`;
CREATE TABLE `products_options_values_to_products_options` (
  `products_options_values_to_products_options_id` int(11) NOT NULL auto_increment,
  `products_options_id` int(11) NOT NULL default '0',
  `products_options_values_id` int(11) NOT NULL default '0',
  `products_options_values_sort_order` int(6) NOT NULL default '0',
  PRIMARY KEY  (`products_options_values_to_products_options_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `products_shipping`;
CREATE TABLE `products_shipping` (
  `products_id` int(11) NOT NULL default '0',
  `products_ship_methods_id` int(11) default NULL,
  `products_ship_zip` varchar(32) default NULL,
  `products_ship_price` varchar(10) default NULL,
  `products_ship_price_two` varchar(10) default NULL
) TYPE=MyISAM;



DROP TABLE IF EXISTS `products_stock`;
CREATE TABLE `products_stock` (
  `products_stock_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `products_stock_attributes` varchar(255) NOT NULL default '',
  `products_stock_quantity` int(11) NOT NULL default '0',
  PRIMARY KEY  (`products_stock_id`),
  UNIQUE KEY `idx_products_stock_attributes` (`products_id`,`products_stock_attributes`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `products_to_categories`;
CREATE TABLE `products_to_categories` (
  `products_id` int(11) NOT NULL default '0',
  `categories_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`products_id`,`categories_id`)
) TYPE=MyISAM;



DROP TABLE IF EXISTS `reviews`;
CREATE TABLE `reviews` (
  `reviews_id` int(11) NOT NULL AUTO_INCREMENT,
  `products_id` int(11) NOT NULL DEFAULT '0',
  `customers_id` int(11) DEFAULT NULL,
  `customers_name` varchar(64) NOT NULL DEFAULT '',
  `reviews_rating` decimal(15,2) DEFAULT NULL,
  `date_added` datetime DEFAULT NULL,
  `last_modified` datetime DEFAULT NULL,
  `reviews_read` int(5) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`reviews_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;


DROP TABLE IF EXISTS `reviews_description`;
CREATE TABLE `reviews_description` (
  `reviews_id` int(11) NOT NULL default '0',
  `languages_id` int(11) NOT NULL default '0',
  `reviews_text` text NOT NULL,
  PRIMARY KEY  (`reviews_id`,`languages_id`)
) TYPE=MyISAM;



DROP TABLE IF EXISTS `reviews_filter`;
CREATE TABLE `reviews_filter` (
  `reviews_filter_id` int(11) NOT NULL auto_increment,
  `reviews_filter_text` varchar(255) NOT NULL default '',
  `reviews_filter_points` decimal(15,2) NOT NULL default '1.00',
  `reviews_filter_groups_id` int(11) NOT NULL default '0',
  `reviews_filter_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`reviews_filter_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `reviews_filter_groups`;
CREATE TABLE `reviews_filter_groups` (
  `reviews_filter_groups_id` int(11) NOT NULL auto_increment,
  `reviews_filter_groups_name` varchar(255) NOT NULL default '',
  `reviews_filter_groups_description` varchar(255) NOT NULL default '',
  `reviews_filter_groups_points` decimal(15,2) NOT NULL default '1.00',
  `reviews_filter_groups_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`reviews_filter_groups_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `rma_refund_methods`;
CREATE TABLE `rma_refund_methods` (
  `refund_method_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `refund_method_name` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`refund_method_id`,`language_id`),
  KEY `idx_refund_method_name` (`refund_method_name`)
) TYPE=MyISAM;


INSERT INTO `rma_refund_methods` (`refund_method_id`, `language_id`, `refund_method_name`) VALUES
(2, 1, 'Credit Card'),
(1, 1, 'Paypal'),
(3, 1, 'Exchange'),
(4, 1, 'Gift Vouchers');

DROP TABLE IF EXISTS `rma_refund_payments`;
CREATE TABLE `rma_refund_payments` (
  `refund_payment_id` int(11) NOT NULL auto_increment,
  `returns_id` int(11) NOT NULL default '0',
  `refund_payment_name` varchar(64) NOT NULL default 'No Refund Made',
  `refund_payment_value` decimal(15,4) NOT NULL default '0.0000',
  `refund_payment_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `refund_payment_reference` varchar(50) default NULL,
  `refund_payment_deductions` decimal(15,4) NOT NULL default '0.0000',
  `customer_method` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`refund_payment_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `rma_returns`;
CREATE TABLE `rma_returns` (
  `returns_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `rma_value` varchar(15) NOT NULL default '0',
  `order_id` int(11) NOT NULL default '0',
  `customers_name` varchar(64) NOT NULL default '',
  `customers_acct` varchar(32) default NULL,
  `customers_company` varchar(32) default NULL,
  `customers_street_address` varchar(64) NOT NULL default '',
  `customers_suburb` varchar(32) default NULL,
  `customers_city` varchar(32) NOT NULL default '',
  `customers_postcode` varchar(10) NOT NULL default '',
  `customers_state` varchar(32) default NULL,
  `customers_country` varchar(32) NOT NULL default '',
  `customers_telephone` varchar(32) NOT NULL default '',
  `customers_fax` varchar(32) NOT NULL default '',
  `customers_email_address` varchar(96) NOT NULL default '',
  `customers_address_format_id` int(5) NOT NULL default '0',
  `delivery_name` varchar(64) NOT NULL default '',
  `delivery_company` varchar(32) default NULL,
  `delivery_street_address` varchar(64) NOT NULL default '',
  `delivery_suburb` varchar(32) default NULL,
  `delivery_city` varchar(32) NOT NULL default '',
  `delivery_postcode` varchar(10) NOT NULL default '',
  `delivery_state` varchar(32) default NULL,
  `delivery_country` varchar(32) NOT NULL default '',
  `delivery_address_format_id` int(5) NOT NULL default '0',
  `billing_name` varchar(64) NOT NULL default '',
  `billing_acct` varchar(32) default NULL,
  `billing_company` varchar(32) default NULL,
  `billing_street_address` varchar(64) NOT NULL default '',
  `billing_suburb` varchar(32) default NULL,
  `billing_city` varchar(32) NOT NULL default '',
  `billing_postcode` varchar(10) NOT NULL default '',
  `billing_state` varchar(32) default NULL,
  `billing_country` varchar(32) NOT NULL default '',
  `billing_address_format_id` int(5) NOT NULL default '0',
  `payment_method` varchar(64) NOT NULL default '',
  `cc_type` varchar(20) default NULL,
  `cc_owner` varchar(64) default NULL,
  `cc_number` varchar(32) default NULL,
  `cc_expires` varchar(4) default NULL,
  `cvvnumber` char(3) default NULL,
  `last_modified` datetime default NULL,
  `date_purchased` datetime default NULL,
  `returns_status` int(5) NOT NULL default '1',
  `returns_date_finished` datetime NOT NULL default '0000-00-00 00:00:00',
  `comments` text,
  `currency` char(3) default NULL,
  `currency_value` decimal(14,6) default NULL,
  `account_name` varchar(32) NOT NULL default '',
  `account_number` varchar(20) default NULL,
  `po_number` varchar(12) default NULL,
  `date_finished` datetime NOT NULL default '0000-00-00 00:00:00',
  `returns_reason` tinyint(5) unsigned default '0',
  `contact_user_name` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`returns_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `rma_returns_products`;
CREATE TABLE `rma_returns_products` (
  `returns_products_id` int(11) NOT NULL auto_increment,
  `orders_products_id` int(11) NOT NULL default '0',
  `returns_id` int(11) NOT NULL default '0',
  `order_id` int(11) NOT NULL default '0',
  `products_id` int(11) NOT NULL default '0',
  `products_model` varchar(12) default NULL,
  `products_name` varchar(120) NOT NULL default '',
  `products_price` decimal(15,4) NOT NULL default '0.0000',
  `products_discount_made` decimal(4,2) default NULL,
  `final_price` decimal(15,4) NOT NULL default '0.0000',
  `products_tax` decimal(7,4) NOT NULL default '0.0000',
  `products_quantity` int(2) NOT NULL default '0',
  `products_serial_number` varchar(128) default NULL,
  `products_returned` tinyint(2) unsigned default '0',
  `products_exchanged` tinyint(2) unsigned default '0',
  PRIMARY KEY  (`returns_products_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `rma_returns_reasons`;
CREATE TABLE `rma_returns_reasons` (
  `return_reason_id` tinyint(3) unsigned NOT NULL default '0',
  `language_id` tinyint(3) unsigned NOT NULL default '1',
  `return_reason_name` varchar(25) default NULL,
  PRIMARY KEY  (`return_reason_id`,`language_id`)
) TYPE=MyISAM;


INSERT INTO `rma_returns_reasons` (`return_reason_id`, `language_id`, `return_reason_name`) VALUES
(1, 1, 'Faulty'),
(2, 1, 'Damaged'),
(3, 1, 'Incorrect Item'),
(4, 1, 'Warranty');

DROP TABLE IF EXISTS `rma_returns_status`;
CREATE TABLE `rma_returns_status` (
  `returns_status_id` int(11) NOT NULL default '1',
  `language_id` int(11) NOT NULL default '1',
  `returns_status_name` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`returns_status_id`,`language_id`),
  KEY `idx_returns_status_name` (`returns_status_name`)
) TYPE=MyISAM;


INSERT INTO `rma_returns_status` (`returns_status_id`, `language_id`, `returns_status_name`) VALUES
(1, 1, 'Pending'),
(2, 1, 'Awaiting Return'),
(3, 1, 'Cancelled'),
(4, 1, 'Complete');

DROP TABLE IF EXISTS `rma_returns_status_history`;
CREATE TABLE `rma_returns_status_history` (
  `returns_status_history_id` int(11) unsigned NOT NULL auto_increment,
  `returns_id` int(11) unsigned NOT NULL default '0',
  `returns_status` int(5) unsigned NOT NULL default '0',
  `date_added` datetime default NULL,
  `customer_notified` int(1) unsigned default '0',
  `comments` text,
  PRIMARY KEY  (`returns_status_history_id`)
) TYPE=MyISAM  COMMENT='Return products''s status change history' AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `rma_returns_text`;
CREATE TABLE `rma_returns_text` (
  `return_text_id` tinyint(3) unsigned NOT NULL default '0',
  `language_id` tinyint(3) unsigned NOT NULL default '1',
  `return_text_one` text,
  PRIMARY KEY  (`return_text_id`,`language_id`),
  KEY `status_id` (`return_text_id`)
) TYPE=MyISAM;


INSERT INTO `rma_returns_text` (`return_text_id`, `language_id`, `return_text_one`) VALUES
(1, 1, 'Thank you for submitting your return request. Please be sure to make a note of the above RMA number, as you will need it to track the progress of your return. We will be in touch soon with further instructions regarding your return request.');

DROP TABLE IF EXISTS `rma_returns_totals`;
CREATE TABLE `rma_returns_totals` (
  `returns_total_id` int(10) unsigned NOT NULL auto_increment,
  `returns_id` int(11) NOT NULL default '0',
  `title` varchar(255) NOT NULL default '',
  `text` varchar(255) NOT NULL default '',
  `value` decimal(15,4) NOT NULL default '0.0000',
  `class` varchar(32) NOT NULL default '',
  `sort_order` int(11) NOT NULL default '0',
  PRIMARY KEY  (`returns_total_id`),
  KEY `idx_returns_total_returns_id` (`returns_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `scart`;
CREATE TABLE `scart` (
  `scartid` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `dateadded` varchar(8) NOT NULL default '',
  PRIMARY KEY  (`scartid`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `searchword_swap`;
CREATE TABLE `searchword_swap` (
  `sws_id` mediumint(11) NOT NULL auto_increment,
  `sws_word` varchar(100) NOT NULL default '',
  `sws_replacement` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`sws_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `search_queries`;
CREATE TABLE `search_queries` (
  `search_id` int(11) NOT NULL auto_increment,
  `search_text` varchar(200) default NULL,
  `search_count` int(11) NOT NULL default '1',
  `search_found` int(11) NOT NULL default '0',
  PRIMARY KEY  (`search_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1;



DROP TABLE IF EXISTS `search_queries_sorted`;
CREATE TABLE `search_queries_sorted` (
  `search_id` smallint(6) NOT NULL auto_increment,
  `search_text` tinytext NOT NULL,
  `search_count` int(11) NOT NULL default '0',
  PRIMARY KEY  (`search_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `sessions`;
CREATE TABLE `sessions` (
  `sesskey` varchar(32) NOT NULL default '',
  `expiry` int(11) unsigned NOT NULL default '0',
  `value` text NOT NULL,
  PRIMARY KEY  (`sesskey`)
) TYPE=MyISAM;


INSERT INTO `sessions` (`sesskey`, `expiry`, `value`) VALUES
('fh66d4oqpai7lidjppk4vfp084', 1230244246, 'language|s:7:"english";languages_id|s:1:"1";selected_box|s:13:"configuration";login_id|s:1:"1";login_groups_id|s:1:"1";login_first_name|N;');

DROP TABLE IF EXISTS `shipping_manifest`;
CREATE TABLE `shipping_manifest` (
  `delivery_id` int(5) NOT NULL auto_increment,
  `orders_id` int(6) NOT NULL default '0',
  `delivery_name` varchar(128) NOT NULL default '',
  `delivery_company` varchar(128) NOT NULL default '',
  `delivery_address_1` varchar(128) NOT NULL default '',
  `delivery_address_2` varchar(128) NOT NULL default '',
  `delivery_city` varchar(64) NOT NULL default '',
  `delivery_state` char(2) NOT NULL default '',
  `delivery_postcode` varchar(10) NOT NULL default '',
  `delivery_phone` varchar(10) NOT NULL default '',
  `package_weight` char(3) NOT NULL default '',
  `package_value` varchar(4) NOT NULL default '',
  `oversized` int(1) NOT NULL default '0',
  `pickup_date` date NOT NULL default '0000-00-00',
  `shipping_type` varchar(64) NOT NULL default '',
  `residential` char(1) NOT NULL default '',
  `cod` int(1) NOT NULL default '0',
  `tracking_num` varchar(20) NOT NULL default '',
  `multiple` int(3) NOT NULL default '0',
  PRIMARY KEY  (`delivery_id`),
  UNIQUE KEY `tracking_num` (`tracking_num`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `specials`;
CREATE TABLE `specials` (
  `specials_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `specials_new_products_price` decimal(15,4) NOT NULL default '0.0000',
  `specials_text` varchar(200) NOT NULL,
  `specials_date_added` datetime default NULL,
  `specials_last_modified` datetime default NULL,
  `expires_date` datetime default NULL,
  `date_status_change` datetime default NULL,
  `status` int(1) NOT NULL default '1',
  `customers_group_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`specials_id`),
  KEY `products_id` (`products_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `tax_class`;
CREATE TABLE `tax_class` (
  `tax_class_id` int(11) NOT NULL auto_increment,
  `tax_class_title` varchar(32) NOT NULL default '',
  `tax_class_description` varchar(255) NOT NULL default '',
  `last_modified` datetime default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`tax_class_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1;


INSERT INTO `tax_class` (`tax_class_id`, `tax_class_title`, `tax_class_description`, `last_modified`, `date_added`) VALUES
(2, 'Taxable Item', 'Any taxable item', NULL, NOW()),
(3, 'Non Taxable', 'Non Taxable Goods', NULL, NOW());

DROP TABLE IF EXISTS `tax_rates`;
CREATE TABLE `tax_rates` (
  `tax_rates_id` int(11) NOT NULL auto_increment,
  `tax_zone_id` int(11) NOT NULL default '0',
  `tax_class_id` int(11) NOT NULL default '0',
  `tax_priority` int(5) default '1',
  `tax_rate` decimal(7,4) NOT NULL default '0.0000',
  `tax_description` varchar(255) NOT NULL default '',
  `last_modified` datetime default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`tax_rates_id`),
  KEY `tax_zone_id` (`tax_zone_id`),
  KEY `tax_class_id` (`tax_class_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1;


INSERT INTO `tax_rates` (`tax_rates_id`, `tax_zone_id`, `tax_class_id`, `tax_priority`, `tax_rate`, `tax_description`, `last_modified`, `date_added`) VALUES
(1, 1, 2, 0, 7.0000, 'Sales Tax', NULL, NOW());

DROP TABLE IF EXISTS `topics`;
CREATE TABLE `topics` (
  `topics_id` int(11) NOT NULL auto_increment,
  `topics_image` varchar(64) default NULL,
  `topics_status` tinyint(1) NOT NULL default '1',
  `parent_id` int(11) NOT NULL default '0',
  `sort_order` int(3) default NULL,
  `date_added` datetime default NULL,
  `last_modified` datetime default NULL,
  PRIMARY KEY  (`topics_id`),
  KEY `idx_topics_parent_id` (`parent_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `topics_description`;
CREATE TABLE `topics_description` (
  `topics_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `topics_name` varchar(32) NOT NULL default '',
  `topics_heading_title` varchar(64) default NULL,
  `topics_description` text,
  PRIMARY KEY  (`topics_id`,`language_id`),
  KEY `idx_topics_name` (`topics_name`)
) TYPE=MyISAM;



DROP TABLE IF EXISTS `virtual_display`;
CREATE TABLE `virtual_display` (
  `virtual_display_id` int(100) NOT NULL auto_increment,
  `category_cover_id` int(100) NOT NULL default '0',
  `virtual_display_type` enum('product','category','banner') default 'product',
  `products_id` int(100) NOT NULL default '0',
  `category_id` int(100) NOT NULL default '0',
  `parent_id` int(100) NOT NULL default '0',
  `date_added` datetime default NULL,
  `last_modified` datetime default NULL,
  `sort_order` int(3) default NULL,
  PRIMARY KEY  (`virtual_display_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1;



DROP TABLE IF EXISTS `whos_online`;
CREATE TABLE `whos_online` (
  `customer_id` int(11) default NULL,
  `full_name` varchar(64) NOT NULL default '',
  `session_id` varchar(128) NOT NULL default '',
  `ip_address` varchar(15) NOT NULL default '',
  `time_entry` varchar(14) NOT NULL default '',
  `time_last_click` varchar(14) NOT NULL default '',
  `last_page_url` varchar(250) NOT NULL default '',
  KEY `session_id` (`session_id`),
  KEY `ip_address` (`ip_address`),
  KEY `time_last_click` (`time_last_click`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS `zones`;
CREATE TABLE `zones` (
  `zone_id` int(11) NOT NULL auto_increment,
  `zone_country_id` int(11) NOT NULL default '0',
  `zone_code` varchar(32) NOT NULL default '',
  `zone_name` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`zone_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1;


INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES
(1, 223, 'AL', 'Alabama'),
(2, 223, 'AK', 'Alaska'),
(4, 223, 'AZ', 'Arizona'),
(5, 223, 'AR', 'Arkansas'),
(12, 223, 'CA', 'California'),
(13, 223, 'CO', 'Colorado'),
(14, 223, 'CT', 'Connecticut'),
(15, 223, 'DE', 'Delaware'),
(16, 223, 'DC', 'District of Columbia'),
(18, 223, 'FL', 'Florida'),
(19, 223, 'GA', 'Georgia'),
(21, 223, 'HI', 'Hawaii'),
(22, 223, 'ID', 'Idaho'),
(23, 223, 'IL', 'Illinois'),
(24, 223, 'IN', 'Indiana'),
(25, 223, 'IA', 'Iowa'),
(26, 223, 'KS', 'Kansas'),
(27, 223, 'KY', 'Kentucky'),
(28, 223, 'LA', 'Louisiana'),
(29, 223, 'ME', 'Maine'),
(31, 223, 'MD', 'Maryland'),
(32, 223, 'MA', 'Massachusetts'),
(33, 223, 'MI', 'Michigan'),
(34, 223, 'MN', 'Minnesota'),
(35, 223, 'MS', 'Mississippi'),
(36, 223, 'MO', 'Missouri'),
(37, 223, 'MT', 'Montana'),
(38, 223, 'NE', 'Nebraska'),
(39, 223, 'NV', 'Nevada'),
(40, 223, 'NH', 'New Hampshire'),
(41, 223, 'NJ', 'New Jersey'),
(42, 223, 'NM', 'New Mexico'),
(43, 223, 'NY', 'New York'),
(44, 223, 'NC', 'North Carolina'),
(45, 223, 'ND', 'North Dakota'),
(47, 223, 'OH', 'Ohio'),
(48, 223, 'OK', 'Oklahoma'),
(49, 223, 'OR', 'Oregon'),
(51, 223, 'PA', 'Pennsylvania'),
(53, 223, 'RI', 'Rhode Island'),
(54, 223, 'SC', 'South Carolina'),
(55, 223, 'SD', 'South Dakota'),
(56, 223, 'TN', 'Tennessee'),
(57, 223, 'TX', 'Texas'),
(58, 223, 'UT', 'Utah'),
(59, 223, 'VT', 'Vermont'),
(61, 223, 'VA', 'Virginia'),
(62, 223, 'WA', 'Washington'),
(63, 223, 'WV', 'West Virginia'),
(64, 223, 'WI', 'Wisconsin'),
(65, 223, 'WY', 'Wyoming');

DROP TABLE IF EXISTS `zones_to_geo_zones`;
CREATE TABLE `zones_to_geo_zones` (
  `association_id` int(11) NOT NULL auto_increment,
  `zone_country_id` int(11) NOT NULL default '0',
  `zone_id` int(11) default NULL,
  `geo_zone_id` int(11) default NULL,
  `last_modified` datetime default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`association_id`),
  KEY `geo_zone_id` (`geo_zone_id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

DROP TABLE IF EXISTS `misc_info`;
CREATE TABLE  `misc_info` (
  `info_id` int(11) NOT NULL auto_increment,
  `language_id` INT( 11 ) NOT NULL DEFAULT '1',
  `info_key` varchar(100) NOT NULL default '',
  `info_key_id` varchar(100) NOT NULL default '',
  `info_name` varchar(255) NOT NULL default '',
  `info_text` text,
  `info_extras` text,
  `info_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `info_date_updated` datetime NOT NULL default '0000-00-00 00:00:00',
  `info_ip` varchar(15) NOT NULL default '0.0.0.0',
  PRIMARY KEY  (`info_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;


DROP TABLE IF EXISTS `media`;
CREATE TABLE `media` (
  `media_id` int(11) NOT NULL auto_increment,
  `media_name` varchar(255) NOT NULL default '',
  `media_info` varchar(255) NOT NULL default '',
  `media_playlist_id` int(11) NOT NULL default '0',
  `media_location` varchar(255) NOT NULL default '',
  `media_image` varchar(255) NOT NULL default '',
  `media_time` varchar(8) NOT NULL default '',
  `media_url` varchar(255) NOT NULL default '',
  `media_price` decimal(15,4) NOT NULL default '0.0000',
  `media_sort` int(3) NOT NULL default '0',
  PRIMARY KEY  (`media_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1;



DROP TABLE IF EXISTS `media_playlist`;
CREATE TABLE `media_playlist` (
  `media_playlist_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `media_playlist_name` varchar(255) NOT NULL default '',
  `media_playlist_options` TEXT NOT NULL default '',
  `media_playlist_sort` int(3) NOT NULL default '0',
  PRIMARY KEY (`media_playlist_id`)
) TYPE=MyISAM  AUTO_INCREMENT=1;
