<?php
  require_once ( 'includes/application_top.php' );
  @include_once ( DIR_WS_LANGUAGES . $language . '/' . FILENAME_ACCOUNT_EDIT);

	if ( false == tep_session_is_registered('customer_id') ) {
		$navigation->set_snapshot();
		tep_redirect(tep_href_link(FILENAME_LOGIN, '', 'SSL'));
	}

	$country = tep_get_customers_default_country_id($customer_id);

	if ( false === empty($_POST['action']) && ($_POST['action'] == 'process') ) {
		if (ACCOUNT_GENDER == 'true') $gender = tep_db_prepare_input($_POST['gender']);
		$firstname = tep_db_prepare_input($_POST['firstname']);
		$lastname = tep_db_prepare_input($_POST['lastname']);

		if ( 'true' === ACCOUNT_DOB ) {
			$dob_month = tep_db_prepare_input($_POST['dob_month']);
			$dob_day = tep_db_prepare_input($_POST['dob_day']);
			$dob_year = tep_db_prepare_input($_POST['dob_year']);
			$dob = $dob_month . '/' . $dob_day . '/' . $dob_year;
		}

	$email_address = tep_db_prepare_input($_POST['email_address']);


	if ( '223' == $country ) { # check if US
		$phone1 = tep_db_prepare_input($_POST['phoneAreaCode']);
		$phone2 = tep_db_prepare_input($_POST['phonePrefix']);
		$phone3 = tep_db_prepare_input($_POST['phoneNumber']);
		$telephone = $phone1."-".$phone2."-".$phone3;
		$fax1 = tep_db_prepare_input($_POST['faxAreaCode']);
		$fax2 = tep_db_prepare_input($_POST['faxPrefix']);
		$fax3 = tep_db_prepare_input($_POST['faxNumber']);
		$fax = $fax1."-".$fax2."-".$fax3;
    } else {
		$telephone = tep_db_prepare_input($_POST['phone']);
		$fax = tep_db_prepare_input($_POST['fax']);
    }


    $error = false;

    if (ACCOUNT_GENDER == 'true') {
      if ( ($gender != 'm') && ($gender != 'f') ) {
      	$error_type['gender'] = true;
        $error = true;
        $messageStack->add('account_edit', ENTRY_GENDER_ERROR);
      }
    }

    if (strlen($firstname) < ENTRY_FIRST_NAME_MIN_LENGTH) {
    	$error_type['firstname'] = true;
      $error = true;
      $messageStack->add('account_edit', ENTRY_FIRST_NAME_ERROR);
    }

    if (strlen($lastname) < ENTRY_LAST_NAME_MIN_LENGTH) {
    	$error_type['lastname'] = true;
      $error = true;
      $messageStack->add('account_edit', ENTRY_LAST_NAME_ERROR);
    }

    if (ACCOUNT_DOB == 'true') {
	if( !$dob_month || false === is_numeric($dob_month) ) {
		$error_type['dob_month'] = true;
		$error_type['dob'] = true;
		$error = true;
	}
	if( !$dob_day || false === is_numeric($dob_day) ) {
		$error_type['dob_day'] = true;
		$error_type['dob'] = true;
		$error = true;
	}
	if( !$dob_year || false === is_numeric($dob_year) ) {
		$error_type['dob_year'] = true;
		$error_type['dob'] = true;
		$error = true;
	}
	if ( true === is_numeric($dob_month) && true === is_numeric($dob_day) & true === is_numeric($dob_year) ) {
	  if ( !checkdate($dob_month, $dob_day, $dob_year ) ) {
     	$error_type['dob_month'] = true;
     	$error_type['dob_day'] = true;
		$error_type['dob'] = true;
      }
    }

    if( true === $error_type['dob'] )
      $error_message .= ENTRY_DATE_OF_BIRTH_ERROR."<br />";
    }

    if (strlen($email_address) < ENTRY_EMAIL_ADDRESS_MIN_LENGTH) {
    	$error_type['email_address'] = true;
      $error = true;
      $messageStack->add('account_edit', ENTRY_EMAIL_ADDRESS_ERROR);
    }

    if (!tep_validate_email($email_address)) {
    	$error_type['email_address'] = true;
      $error = true;
      $messageStack->add('account_edit', ENTRY_EMAIL_ADDRESS_CHECK_ERROR);
    }

    $check_email_query = tep_db_query("select count(*) as total from " . TABLE_CUSTOMERS . " where customers_email_address = '" . tep_db_input($email_address) . "' and customers_id != '" . (int)$customer_id . "'");
    $check_email = tep_db_fetch_array($check_email_query);
    if ($check_email['total'] > 0) {
    	$error_type['email_address'] = true;
      $error = true;
      $messageStack->add('account_edit', ENTRY_EMAIL_ADDRESS_ERROR_EXISTS);
    }

	if ( '223' == $country ) { # check if US
		if (strlen($phone1) < 3) $error_type['phoneAreaCode'] = true;
		if (strlen($phone2) < 3) $error_type['phonePrefix'] = true;
		if (strlen($phone3) < 4) $error_type['phoneNumber'] = true;

		if ( (strlen($phone1) < 3) || (strlen($phone2) < 3) || (strlen($phone3) < 4) ) {
			$error_message .= ENTRY_PHONE_NUMBER_ERROR."<br />";
			$error = true;
		}
		if ( false === empty($fax1) || false === empty($fax1) || false === empty($fax1) ) {
			if (strlen($fax1) < 3) $error_type['faxAreaCode'] = true;
			if (strlen($fax2) < 3) $error_type['faxPrefix'] = true;
			if (strlen($fax3) < 4) $error_type['faxNumber'] = true;
			if ( (strlen($fax1) < 3) || (strlen($fax2) < 3) || (strlen($fax3) < 4) ) {
				$error_message .= ENTRY_FAX_NUMBER_ERROR."<br />";
				$error = true;
			}
		}
		//echo "HERE: $phone1- $phone2 - $phone3";exit;
	} else {
		if (strlen($telephone) < 8) $error_type['phoneNumber'] = true;
		if ( false === empty($fax) ) {
			if (strlen($fax) < 8) $error_type['faxNumber'] = true;
		}
	}

	if ( false === empty($error_message) ) {
		$messageStack->add('account_edit', $error_message);
	}




	if ($error == false) {

      $sql_data_array = array('customers_firstname' => $firstname,
                              'customers_lastname' => $lastname,
                              'customers_email_address' => $email_address,
                              'customers_telephone' => $telephone,
                              'customers_fax' => $fax);

      if (ACCOUNT_GENDER == 'true') $sql_data_array['customers_gender'] = $gender;

      if (ACCOUNT_DOB == 'true') $sql_data_array['customers_dob'] = tep_date_raw($dob);

      tep_db_perform(TABLE_CUSTOMERS, $sql_data_array, 'update', "customers_id = '" . (int)$customer_id . "'");

      tep_db_query("update " . TABLE_CUSTOMERS_INFO . " set customers_info_date_account_last_modified = now() where customers_info_id = '" . (int)$customer_id . "'");

      $sql_data_array = array('entry_firstname' => $firstname,
                              'entry_lastname' => $lastname);

      tep_db_perform(TABLE_ADDRESS_BOOK, $sql_data_array, 'update', "customers_id = '" . (int)$customer_id . "' and address_book_id = '" . (int)$customer_default_address_id . "'");

// reset the session variables
      $customer_first_name = $firstname;

      $messageStack->add_session('account', SUCCESS_ACCOUNT_UPDATED, 'success' );

      tep_redirect(tep_href_link(FILENAME_ACCOUNT, '', 'SSL'));
    }
  }
	$account_query_sql = "
					SELECT
						customers_gender,
						customers_firstname,
						customers_lastname,
						customers_dob,
						customers_email_address,
						customers_telephone,
						customers_fax
					FROM
						" . TABLE_CUSTOMERS . "
					WHERE
						customers_id = '" . (int)$customer_id . "'";
	$account_query = tep_db_query($account_query_sql);
	$account = tep_db_fetch_array($account_query);

	if ( true === empty($_POST) ) {
		if ( '223' == $country ) { # check if US
			list($phone1, $phone2, $phone3) = explode("-",$account['customers_telephone']);
			list($fax1, $fax2, $fax3)       = explode("-",$account['customers_fax']);
		} else {
			$phone = $account['customers_telephone'];
			$fax = $account['customers_fax'];
		}
		$dob_date = date("m/d/Y", strtotime($account['customers_dob']));
		if ( false === empty($account['customers_dob']) ) {
	 		list($dob_month, $dob_day, $dob_year) = explode('/',$dob_date);
		}
	}

	$breadcrumb->add(NAVBAR_TITLE_1, tep_href_link(FILENAME_ACCOUNT, '', 'SSL'));
	$breadcrumb->add(NAVBAR_TITLE_2);

	$smarty->assign('breadcrumb', $breadcrumb->_trail);
	$smarty->assign('messagestack', $messageStack->get_messages());

	$content = CONTENT_ACCOUNT_EDIT;
	$smarty->assign('my_account_active', ' class="active"');

	$smarty->assign('HEADER_TITLE', HEADING_TITLE);
	$smarty->assign('URL_ACCOUNT', tep_href_link(FILENAME_ACCOUNT, ''));
	$smarty->assign('IMAGE_BUTTON_BACK', IMAGE_BUTTON_BACK);
	$smarty->assign('IMAGE_BUTTON_UPDATE', IMAGE_BUTTON_UPDATE);


	if ( ACCOUNT_GENDER == 'true' ) {
		$smarty->assign('ACCOUNT_GENDER', ACCOUNT_GENDER);

		if (isset($gender)) {
			$male = ($gender == 'm') ? true : false;
		} else {
			$male = ($account['customers_gender'] == 'm') ? true : false;
		}
		$female = !$male;

		$class = ( true === $error_type['gender'] ? 'class="inputNormalError"' : '' );
		$smarty->assign('ENTRY_GENDER', ENTRY_GENDER);
		$smarty->assign('ENTRY_GENDER_TEXT', ENTRY_GENDER_TEXT);
		$smarty->assign('INPUT_ENTRY_GENDER', '<span'.$class.'>'.tep_draw_radio_field('gender', 'm', $male, 'id="gender_m"') . '&nbsp;&nbsp;' . MALE . '&nbsp;&nbsp;' . tep_draw_radio_field('gender', 'f', $female, 'id="gender_f"') . '&nbsp;&nbsp;' . FEMALE . '</span>' );
	}

	$class = ( true === $error_type['firstname'] ? 'inputNormalError' : 'inputNormal' );
	$smarty->assign('ENTRY_FIRST_NAME', ENTRY_FIRST_NAME);
	$smarty->assign('ENTRY_FIRST_NAME_TEXT', ENTRY_FIRST_NAME_TEXT);
	$smarty->assign('INPUT_FIRST_NAME', tep_draw_input_field('firstname', $account['customers_firstname'],'id="firstname" class="'.$class.'"'));

	$class = ( true === $error_type['lastname'] ? 'inputNormalError' : 'inputNormal' );
	$smarty->assign('ENTRY_LAST_NAME', ENTRY_LAST_NAME);
	$smarty->assign('ENTRY_LAST_NAME_TEXT', ENTRY_LAST_NAME_TEXT);
	$smarty->assign('INPUT_LAST_NAME', tep_draw_input_field('lastname', $account['customers_lastname'],'id="lastname" class="'.$class.'"'));

	if ( 'true' == ACCOUNT_DOB ) {

		$smarty->assign('ACCOUNT_DOB', ACCOUNT_DOB); # ON-OFF flag
		$smarty->assign('ENTRY_DATE_OF_BIRTH', ENTRY_DATE_OF_BIRTH);
		$smarty->assign('ENTRY_DATE_OF_BIRTH_TEXT', ENTRY_DATE_OF_BIRTH_TEXT);


		$dob_month_values = array();
				array_push($dob_month_values, array('id' => '0','text' => TEXT_EXAMPLE_MONTH));
				for ( $i=1; $i <= 12; $i++ ) {
					$pre = ( $i <= 9 ? '0' : '' );
					array_push($dob_month_values,
						array('id'=>$pre.$i,'text'=>$pre.$i)
					);
				}
		$class = ( true === $error_type['dob_month'] ? 'class="inputNormalError"' : '' );
		$smarty->assign('INPUT_DATE_OF_BIRTH_MONTH', tep_draw_pull_down_menu('dob_month', $dob_month_values, $dob_month, $class));

		$dob_month_full_values = array();
				array_push($dob_month_full_values, array('id' => '0','text' => TEXT_EXAMPLE_MONTH_FULL));
				for ( $i=1; $i <= 12; $i++ ) {
					$pre = ( $i <= 9 ? '0' : '' );
					array_push($dob_month_full_values,
						array('id'=>$pre.$i,'text'=>$pre.$i.' - '.getMonth($i))
					);
				}
		$class = ( true === $error_type['dob_month'] ? 'class="inputNormalError"' : '' );
		$smarty->assign('INPUT_DATE_OF_BIRTH_MONTH_FULL', tep_draw_pull_down_menu('dob_month', $dob_month_full_values, $dob_month, $class));


		$dob_day_values = array();
				array_push($dob_day_values, array('id' => '0','text' => TEXT_EXAMPLE_DAY));
				for ( $i=1; $i <= 31; $i++ ) {
					$pre = ( $i <= 9 ? '0' : '' );
					array_push($dob_day_values,
						array('id'=>$pre.$i,'text'=>$pre.$i)
					);
				}

		$class = ( true === $error_type['dob_day'] ? 'class="inputNormalError"' : '' );
		$smarty->assign('INPUT_DATE_OF_BIRTH_DAY', tep_draw_pull_down_menu('dob_day', $dob_day_values, $dob_day, $class));


		$dob_year_values = array();
				$c_year = date('Y' );
				array_push($dob_year_values, array('id' => '0','text' => TEXT_EXAMPLE_YEAR));
				for ( $i=($c_year-10); $i >= ($c_year-90); $i-- ) {
					array_push($dob_year_values,
						array('id'=>$i,'text'=>$i)
					);
				}
		$class = ( true === $error_type['dob_year'] ? 'class="inputNormalError"' : '' );
		$smarty->assign('INPUT_DATE_OF_BIRTH_YEAR', tep_draw_pull_down_menu('dob_year', $dob_year_values, $dob_year, $class));
	}

	$class = ( true === $error_type['email_address'] ? 'inputNormalError' : 'inputNormal' );
	$smarty->assign('ENTRY_EMAIL_ADDRESS_TEXT', ENTRY_EMAIL_ADDRESS_TEXT);
	$smarty->assign('ENTRY_EMAIL_ADDRESS', ENTRY_EMAIL_ADDRESS);
	$smarty->assign('INPUT_EMAIL_ADDRESS', tep_draw_input_field('email_address', $account['customers_email_address'], 'id="email_address" class="'.$class.'"'));




	$smarty->assign('ENTRY_TELEPHONE_NUMBER', ENTRY_TELEPHONE_NUMBER);
	$smarty->assign('ENTRY_TELEPHONE_NUMBER_TEXT', ENTRY_TELEPHONE_NUMBER_TEXT);

	$smarty->assign('ENTRY_FAX_NUMBER', ENTRY_FAX_NUMBER);
	$smarty->assign('ENTRY_FAX_NUMBER_TEXT', ENTRY_FAX_NUMBER_TEXT);
	$smarty->assign('ACCOUNT_FAX', ACCOUNT_FAX); # ON-OFF flag

	if ( '223' == $country ) { # check if US
		$class = ( true === $error_type['phoneAreaCode'] ? 'inputNormalError' : 'inputNormal' );
		$phoneAreaCode = tep_draw_input_field('phoneAreaCode', $phone1, 'id="phone" class="'.$class.'" size="3" onselect="stopAutoTab();" maxlength="3" style="width:35px;" onkeypress="AutoTabEdit(this,3,event);" onclick="this.value=\'\';"' );
		$class = ( true === $error_type['phonePrefix'] ? 'inputNormalError' : 'inputNormal' );
		$phonePrefix = tep_draw_input_field('phonePrefix', $phone2, 'id="phonePrefix" class="'.$class.'" size="3" onselect="stopAutoTab();" maxlength="3" style="width:35px;" onkeypress="AutoTabEdit(this,3,event);" onclick="this.value=\'\';"' );
		$class = ( true === $error_type['phoneNumber'] ? 'inputNormalError' : 'inputNormal' );
		$phoneNumber = tep_draw_input_field('phoneNumber', $phone3, 'id="phoneNumber" class="'.$class.'" size="4" onselect="stopAutoTab();" maxlength="4" style="width:40px;" onkeypress="CaptureEnterKey(event);"' );
		$smarty->assign('INPUT_TELEPHONE_NUMBER', $phoneAreaCode . '-' . $phonePrefix . '-' . $phoneNumber);

		$class = ( true === $error_type['faxAreaCode'] ? 'inputNormalError' : 'inputNormal' );
		$faxAreaCode = tep_draw_input_field('faxAreaCode', $fax1, 'id="fax" class="'.$class.'" size="3" onselect="stopAutoTab();" maxlength="3" style="width:35px;" onkeypress="AutoTabEdit(this,3,event);" onclick="this.value=\'\';"' );
		$class = ( true === $error_type['faxPrefix'] ? 'inputNormalError' : 'inputNormal' );
		$faxPrefix = tep_draw_input_field('faxPrefix', $fax2, 'id="faxPrefix" class="'.$class.'" size="3" onselect="stopAutoTab();" maxlength="3" style="width:35px;" onkeypress="AutoTabEdit(this,3,event);" onclick="this.value=\'\';"' );
		$class = ( true === $error_type['faxNumber'] ? 'inputNormalError' : 'inputNormal' );
		$faxNumber = tep_draw_input_field('faxNumber', $fax3, 'id="faxNumber" class="'.$class.'" size="4" onselect="stopAutoTab();" maxlength="4" style="width:40px;" onkeypress="CaptureEnterKey(event);"' );
		$smarty->assign('INPUT_FAX_NUMBER', $faxAreaCode . '-' . $faxPrefix . '-' . $faxNumber);
	} else {
		$class = ( true === $error_type['phoneNumber'] ? 'inputNormalError' : 'inputNormal' );
		$phoneNumber = tep_draw_input_field('phone', $telephone, 'id="phoneNumber" class="'.$class.'"');
		$smarty->assign('INPUT_TELEPHONE_NUMBER', $phoneNumber);

		$class = ( true === $error_type['faxNumber'] ? 'inputNormalError' : 'inputNormal' );
		$faxNumber = tep_draw_input_field('fax', $fax, 'id="fax" class="'.$class.'"');
		$smarty->assign('INPUT_FAX_NUMBER', $faxNumber);
	}


	require_once ( DIR_WS_INCLUDES . 'meta_tags.php' );


	$page_content = tep_draw_form('account_edit', tep_href_link(FILENAME_ACCOUNT_EDIT, '', 'SSL'), 'post', '' );
	$page_content .= tep_draw_hidden_field('action', 'process' );
	$page_content .= $smarty->fetch('account_edit.tpl' );

	$smarty->assign('page_content', $page_content);

	require_once ( DIR_WS_INCLUDES . 'application_bottom.php' );
	$smarty->display('common/page.tpl' );
?>
