<?php
	require_once ( 'includes/application_top.php' );

	if ( false == tep_session_is_registered('customer_id') ) {
		$navigation->set_snapshot();
		tep_redirect(tep_href_link(FILENAME_LOGIN, '', 'SSL'));
	}

	@include_once ( DIR_WS_LANGUAGES . $language . '/' . FILENAME_ACCOUNT_HISTORY);

	$breadcrumb->add(NAVBAR_TITLE_1, tep_href_link(FILENAME_ACCOUNT, '', 'SSL'));
	$breadcrumb->add(NAVBAR_TITLE_2);

	$content = CONTENT_ACCOUNT_HISTORY;
	$smarty->assign('my_account_active', ' class="active"');



	$smarty->assign('HEADER_TITLE', HEADING_TITLE);

	$orders_total = tep_count_customer_orders();

	$smarty->assign('orders_total', $orders_total);
	$smarty->assign('TEXT_ORDER_NUMBER', TEXT_ORDER_NUMBER);
	$smarty->assign('TEXT_ORDER_ITEMS', TEXT_ORDER_ITEMS);
	$smarty->assign('IMAGE_BUTTON_BACK', IMAGE_BUTTON_BACK);

	$smarty->assign('breadcrumb', $breadcrumb->_trail);

	if ( $orders_total > 0 ) {

		$history_query_sql = "
						SELECT
							o.orders_id,
							o.date_purchased,
							o.delivery_name,
							o.billing_name,
							ot.text as order_total,
							s.orders_status_name
						FROM
							" . TABLE_ORDERS . " o,
							" . TABLE_ORDERS_TOTAL . " ot,
							" . TABLE_ORDERS_STATUS . " s
						WHERE
							o.customers_id = '" . (int)$customer_id . "'
							AND o.orders_id = ot.orders_id
							AND ot.class = 'ot_total'
							AND o.orders_status = s.orders_status_id
							AND s.language_id = '" . (int)$languages_id . "'
						ORDER BY orders_id DESC";


		$history_split = new splitPageResults($history_query_sql, MAX_DISPLAY_ORDER_HISTORY);
		$history_query = tep_db_query($history_split->sql_query);

		while ($history = tep_db_fetch_array($history_query)) {
			$products_query_sql = "
								SELECT
									count(*) as count
								FROM
									" . TABLE_ORDERS_PRODUCTS . "
								WHERE
									orders_id = '" . (int)$history['orders_id'] . "'";
			$products_query = tep_db_query($products_query_sql);
			$products = tep_db_fetch_array($products_query);

			if (tep_not_null($history['delivery_name'])) {
				$order_type = TEXT_ORDER_SHIPPED_TO;
				$order_name = $history['delivery_name'];
			} else {
				$order_type = TEXT_ORDER_BILLED_TO;
				$order_name = $history['billing_name'];
			}

			$history['order_total'] = strip_tags($history['order_total']);
			$history['order_count'] = $products['count'];
			$history['date_purchased_long'] = tep_date_long($history['date_purchased']);
			$history['url'] = tep_href_link(FILENAME_ACCOUNT_HISTORY_INFO, (isset($_GET['page']) ? 'page=' . $_GET['page'] . '&' : '') . 'order_id=' . $history['orders_id'], 'SSL' );

			$_ORDERS[] = $history;

		}
		$smarty->assign('_ORDERS', $_ORDERS);

		### PAGING
		if ( $history_split->get_number_of_pages() > 1 ) {
			$smarty->assign('TEXT_DISPLAY_NUMBER_OF_ORDERS', $history_split->display_count(TEXT_DISPLAY_NUMBER_OF_ORDERS));
			$_PAGING = TEXT_RESULT_PAGE . ' ' . $history_split->display_links(MAX_DISPLAY_ORDER_HISTORY, tep_get_all_get_params(array('page', 'info', 'x', 'y')));
		}

		if ( (PREV_NEXT_BAR_LOCATION == '1' || PREV_NEXT_BAR_LOCATION == '3')  ) { // top
			$smarty->assign('_PAGINGTOP', $_PAGING);
		}

		if ( (PREV_NEXT_BAR_LOCATION == '2' || PREV_NEXT_BAR_LOCATION == '3')  ) { // top
			$smarty->assign('_PAGINGBOTTOM', $_PAGING);
		}
		### PAGING

		$smarty->assign('URL_ACCOUNT', tep_href_link(FILENAME_ACCOUNT, '', 'SSL'));

		$page_content = $smarty->fetch('account_history.tpl' );


	} else {

		$smarty->assign('TEXT_NO_PURCHASES', TEXT_NO_PURCHASES);
		$smarty->assign('URL_ACCOUNT', tep_href_link(FILENAME_ACCOUNT, '', 'SSL'));

		$page_content = $smarty->fetch('account_history_empty.tpl' );
	}



	require_once (  DIR_WS_INCLUDES . 'meta_tags.php' );

	$smarty->assign('page_content', $page_content);

	require_once (  DIR_WS_INCLUDES . 'application_bottom.php' );
	$smarty->display('common/page.tpl' );
?>