<?php
	require_once ( 'includes/application_top.php' );

	If (!tep_session_is_registered('customer_id')) {
		$navigation->set_snapshot();
		tep_redirect(tep_href_link(FILENAME_LOGIN, '', 'SSL'));
	}

	if (!isset($_GET['order_id']) || (isset($_GET['order_id']) && !is_numeric($_GET['order_id']))) {
		tep_redirect(tep_href_link(FILENAME_ACCOUNT_HISTORY, '', 'SSL'));
	}
	$customer_info_query_sql = "
						SELECT
							customers_id,
							orders_status
						FROM
							" . TABLE_ORDERS . "
						WHERE
							orders_id = '". (int)$_GET['order_id'] . "'";
	$customer_info_query = tep_db_query($customer_info_query_sql);
	$customer_info = tep_db_fetch_array($customer_info_query);
	$orders_status = $customer_info['orders_status']; # RMA RETURNS
	if ($customer_info['customers_id'] != $customer_id) {
		tep_redirect(tep_href_link(FILENAME_ACCOUNT_HISTORY, '', 'SSL'));
	}

	@include_once ( DIR_WS_LANGUAGES . $language . '/' . FILENAME_ACCOUNT_HISTORY_INFO );

	$breadcrumb->add(NAVBAR_TITLE_1, tep_href_link(FILENAME_ACCOUNT, '', 'SSL'));
	$breadcrumb->add(NAVBAR_TITLE_2, tep_href_link(FILENAME_ACCOUNT_HISTORY, '', 'SSL'));
	$breadcrumb->add(sprintf(NAVBAR_TITLE_3, $_GET['order_id']));

	require_once (DIR_WS_CLASSES . 'order.php' );
	$order_id = $_GET['order_id'];
	$order = new order($_GET['order_id']);

	$content = CONTENT_ACCOUNT_HISTORY_INFO;
	$smarty->assign('my_account_active', ' class="active"');
	$smarty->assign('HEADER_TITLE', HEADING_TITLE . " (Order #$order_id)");
	$smarty->assign('breadcrumb', $breadcrumb->_trail);
	$smarty->assign('page_content', $page_content);
	$order->info['date_purchased_long'] = tep_date_long($order->info['date_purchased']);
	$smarty->assign('_ORDERINFO', $order->info);

	foreach ( $order->products as $product ) {
		# Begin RMA Returns
		if ( $product['return'] == '1' ) {
			$rma_query_one_sql = "
								SELECT
									returns_id
								FROM
									" . TABLE_RETURNS_PRODUCTS . "
								WHERE
									products_id = '{$product['id']}'
									AND order_id = '{$_GET['order_id']}'
									AND orders_products_id = '{$product['opid']}'
									";

			$rma_query_one = tep_db_query($rma_query_one_sql);
			$rma_query = tep_db_fetch_array($rma_query_one);

			$rma_number_query_sql = "
									SELECT
										rma_value
									FROM
										" . TABLE_RETURNS . "
									WHERE
										returns_id = '{$rma_query['returns_id']}'";
			$rma_number_query = tep_db_query($rma_number_query_sql);
			$rma_result = tep_db_fetch_array($rma_number_query);

			$smarty->assign('TEXT_RMA', TEXT_RMA);
			$product['return_url'] = tep_href_link(FILENAME_RETURNS_TRACK, 'action=returns_show&rma=' . $rma_result['rma_value'] . '&order_id=' . $_GET['order_id'], 'SSL');
			$product['rma_value'] = $rma_result['rma_value'];
			$product['return_text'] = TEXT_RMA_NUMBER . $product['rma_value'];
		} else {
			$product['return_url'] = tep_href_link(FILENAME_RETURN, 'order_id=' . $_GET['order_id'] . '&opid='.$product['opid'].'&products_id=' . tep_get_uprid($product['id'], $product['attributes']), 'SSL');
			$product['return_text'] = TEXT_RETURN_PRODUCT;
		}
		# Begin RMA Returns

		$product['price'] = $currencies->format(tep_add_tax($product['final_price'], $product['tax']) * $product['qty'], true, $order->info['currency'], $order->info['currency_value']);
		$product['url'] = tep_href_link(FILENAME_PRODUCT_INFO, 'products_id=' . $product['id'], 'NONSSL' );
		$product['products_bundles'] = tep_get_bundle_products($product['id']);
		if ( sizeof($order->info['tax_groups']) > 1 ) {
			$product['tax'] = tep_display_tax_value($product['tax']);
		}
		$_ORDERPRODUCTS[] = $product;

	}

	if ( true === is_array($order->delivery) ) {
		$smarty->assign('shipping_address_use', 'true' );
		$smarty->assign('HEADING_DELIVERY_ADDRESS', HEADING_DELIVERY_ADDRESS);
		$smarty->assign('DELIVERY_ADDRESS', tep_address_format($order->delivery['format_id'], $order->delivery, 1, ' ', '<br />'));
		$smarty->assign('HEADING_SHIPPING_METHOD', HEADING_SHIPPING_METHOD);
		$smarty->assign('SHIPPING_METHOD', $order->info['shipping_method']);
		$smarty->assign('shipping_method_use', 'true' );

	} else {
		$smarty->assign('shipping_address_use', 'false' );
	}

	$smarty->assign('HEADING_BILLING_ADDRESS', HEADING_BILLING_ADDRESS);
	$smarty->assign('BILLING_ADDRESS', tep_address_format($order->billing['format_id'], $order->billing, 1, ' ', '<br />'));
	$smarty->assign('HEADING_PAYMENT_METHOD', HEADING_PAYMENT_METHOD);
	$smarty->assign('PAYMENT_METHOD', $order->info['payment_method']);
	$smarty->assign('URL_BACK', tep_href_link(FILENAME_ACCOUNT_HISTORY));

	$statuses_query_sql = "
					SELECT
						os.orders_status_name,
						osh.date_added,
						osh.comments
					FROM
						" . TABLE_ORDERS_STATUS . " os,
						" . TABLE_ORDERS_STATUS_HISTORY . " osh
					WHERE
						osh.orders_id = '" . (int)$_GET['order_id'] . "'
						AND osh.orders_status_id = os.orders_status_id
						AND os.language_id = '" . (int)$languages_id . "'
					ORDER BY
						osh.date_added";
	$statuses_query = tep_db_query($statuses_query_sql);
	while ( $statuses = tep_db_fetch_array($statuses_query) ) {
		$statuses['date_added_short'] = tep_date_short($statuses['date_added']);
		$statuses['comments'] = nl2br(tep_output_string_protected($statuses['comments']));
		$_STATUSES[] = $statuses;
	}

	$smarty->assign('_STATUSES', $_STATUSES);
	$smarty->assign('_ORDERPRODUCTS', $_ORDERPRODUCTS);
	$smarty->assign('_ORDERTOTALS', $order->totals);
	$smarty->assign('_ORDERSHIPPING', $order->shipping);
	$smarty->assign('order_id', $order_id);

	if ( 'true' == DOWNLOAD_ENABLED ) {
		include_once ( DIR_WS_MODULES . 'downloads.php' );
		$smarty->assign('DOWNLOAD_ENABLED', 'true' );
	} else {
		$smarty->assign('DOWNLOAD_ENABLED', 'false' );
	}

	require_once ( DIR_WS_INCLUDES . 'meta_tags.php' );
	$page_content = $smarty->fetch('account_history_info.tpl' );
	$smarty->assign('page_content', $page_content);

	require_once ( DIR_WS_INCLUDES . 'application_bottom.php' );
	$smarty->display('common/page.tpl' );
?>