<?php

  require_once ( 'includes/application_top.php' );

  if (!tep_session_is_registered('customer_id')) {
    $navigation->set_snapshot();
    tep_redirect(tep_href_link(FILENAME_LOGIN, '', 'SSL'));
  }

// needs to be included earlier to set the success message in the messageStack
  @include_once ( DIR_WS_LANGUAGES . $language . '/' . FILENAME_ACCOUNT_PASSWORD);

	# PASSWORD CHANGED
	if ( true == tep_session_is_registered('password_change') ) {
		tep_session_unregister('password_change');
		$messageStack->add('password_change', TEXT_CHANGE_DEFAULT_PASSWORD, 'warning');
	}
	# PASSWORD CHANGED

  if (isset($_POST['action']) && ($_POST['action'] == 'process')) {
    $password_current = tep_db_prepare_input($_POST['password_current']);
    $password_new = tep_db_prepare_input($_POST['password_new']);
    $password_confirmation = tep_db_prepare_input($_POST['password_confirmation']);

    $error = false;

    if (strlen($password_current) < ENTRY_PASSWORD_MIN_LENGTH) {
    	$error_type['password_current'] = true;
      $error = true;

      $messageStack->add('account_password', ENTRY_PASSWORD_CURRENT_ERROR);
    } elseif (strlen($password_new) < ENTRY_PASSWORD_MIN_LENGTH) {
    	$error_type['password_new'] = true;
      $error = true;

      $messageStack->add('account_password', ENTRY_PASSWORD_NEW_ERROR);
    } elseif ($password_new != $password_confirmation) {
    	$error_type['password_new'] = true;
    	$error_type['password_current'] = true;
      $error = true;

      $messageStack->add('account_password', ENTRY_PASSWORD_NEW_ERROR_NOT_MATCHING);
    }

    if ($error == false) {
      $check_customer_query = tep_db_query("select customers_password from " . TABLE_CUSTOMERS . " where customers_id = '" . (int)$customer_id . "'");
      $check_customer = tep_db_fetch_array($check_customer_query);

      if (tep_validate_password($password_current, $check_customer['customers_password'])) {
        tep_db_query("update " . TABLE_CUSTOMERS . " set customers_password = '" . tep_encrypt_password($password_new) . "' where customers_id = '" . (int)$customer_id . "'");

        tep_db_query("update " . TABLE_CUSTOMERS_INFO . " set customers_info_date_account_last_modified = now() where customers_info_id = '" . (int)$customer_id . "'");

        $messageStack->add_session('account', SUCCESS_PASSWORD_UPDATED, 'success' );

        tep_redirect(tep_href_link(FILENAME_ACCOUNT, '', 'SSL'));
      } else {
      	$error_type['password_current'] = true;
        $error = true;

        $messageStack->add('account_password', ERROR_CURRENT_PASSWORD_NOT_MATCHING);
      }
    }
  }

	$breadcrumb->add(NAVBAR_TITLE_1, tep_href_link(FILENAME_ACCOUNT, '', 'SSL'));
	$breadcrumb->add(NAVBAR_TITLE_2);

	$smarty->assign('breadcrumb', $breadcrumb->_trail);
	$smarty->assign('messagestack', $messageStack->get_messages());

	$content = CONTENT_ACCOUNT_PASSWORD;
	$smarty->assign('my_account_active', ' class="active"');

	$smarty->assign('HEADER_TITLE', HEADING_TITLE);

	$smarty->assign('ENTRY_PASSWORD_CURRENT', ENTRY_PASSWORD_CURRENT);
	$smarty->assign('ENTRY_PASSWORD_CURRENT_TEXT', ENTRY_PASSWORD_CURRENT_TEXT);
	$smarty->assign('INPUT_PASSWORD_CURRENT', tep_draw_password_field('password_current', '' ,'if="password_current"'));

	$smarty->assign('ENTRY_PASSWORD_NEW', ENTRY_PASSWORD_NEW);
	$smarty->assign('ENTRY_PASSWORD_NEW_TEXT', ENTRY_PASSWORD_NEW_TEXT);
	$smarty->assign('INPUT_PASSWORD_NEW', tep_draw_password_field('password_new', '' ,'if="password_new"'));

	$smarty->assign('ENTRY_PASSWORD_CONFIRMATION', ENTRY_PASSWORD_CONFIRMATION);
	$smarty->assign('ENTRY_PASSWORD_CONFIRMATION_TEXT', ENTRY_PASSWORD_CONFIRMATION_TEXT);
	$smarty->assign('INPUT_PASSWORD_CONFIRMATION', tep_draw_password_field('password_confirmation', '' ,'if="password_confirmation"'));


	$smarty->assign('URL_ACCOUNT', tep_href_link(FILENAME_ACCOUNT, ''));
	$smarty->assign('IMAGE_BUTTON_BACK', IMAGE_BUTTON_BACK);
	$smarty->assign('IMAGE_BUTTON_UPDATE', IMAGE_BUTTON_UPDATE);

	require_once ( DIR_WS_INCLUDES . 'meta_tags.php' );


	$page_content = tep_draw_form('account_password', tep_href_link(FILENAME_ACCOUNT_PASSWORD, '', 'SSL'), 'post', 'onSubmit="return check_form(account_password);"' );
	$page_content .= tep_draw_hidden_field('action', 'process' );
	$page_content .= $smarty->fetch('account_password.tpl' );
	$page_content .= '</form>';

	$smarty->assign('page_content', $page_content);

	require_once ( DIR_WS_INCLUDES . 'application_bottom.php' );
	$smarty->display('common/page.tpl' );


?>
