<?php
	require_once ( 'includes/application_top.php' );
	$cID = ( true === empty($_GET['cID']) ? 1 : $_GET['cID'] );

	function tep_insert_permission($permission_name, $permission_description) {
		if ( true === empty($permission_name) ) {
			return false;
		}
		$permissions_query_sql = "
							SELECT
								admin_permissions_id
							FROM
								".TABLE_ADMIN_PERMISSIONS . "
							WHERE admin_permissions_name = '$permission_name'";
		$permissions_query = tep_db_query($permissions_query_sql);
		if ( 0 < tep_db_num_rows($permissions_query) ) {
			return false;
		}
		$permissions_insert_query_sql = "
									INSERT INTO
										".TABLE_ADMIN_PERMISSIONS."
									(
										`admin_permissions_name`,
										`admin_permissions_description`,
										`admin_permissions_time_added`,
										`admin_permissions_time_last_modified`
									)
									VALUES
									(
										'$permission_name',
										'$permission_description',
										NOW(),
										NOW()
									)";
		$permissions_insert_query = tep_db_query($permissions_insert_query_sql);
		return tep_db_insert_id($permissions_insert_query);

	}

	function tep_edit_permission($permission_id, $permission_name, $permission_description) {
		if ( true === empty($permission_id) || true === empty($permission_name) ) {
			return false;
		}
		$permissions_query_sql = "
							SELECT
								admin_permissions_id
							FROM
								".TABLE_ADMIN_PERMISSIONS . "
							WHERE
								admin_permissions_name = '$permission_name'
								AND admin_permissions_id <> '$permission_id'
								";
		$permissions_query = tep_db_query($permissions_query_sql);
		if ( 0 < tep_db_num_rows($permissions_query) ) {
			return false;
		}
		$permissions_update_query_sql = "
									UPDATE
										".TABLE_ADMIN_PERMISSIONS."
									SET
										`admin_permissions_name` = '$permission_name',
										`admin_permissions_description` = '$permission_description',
										`admin_permissions_time_last_modified` = NOW()
									WHERE
										admin_permissions_id = '$permission_id'
									";
		return tep_db_query($permissions_update_query_sql);
	}

	function tep_delete_permission($permission_id) {
		if ( true == empty($permission_id) ) {
			return false;
		}
		$delete_permissions_query_sql = "DELETE FROM " . TABLE_ADMIN_PERMISSIONS . " WHERE admin_permissions_id = '$permission_id'";
		$delete_permissions_query = tep_db_query($delete_permissions_query_sql);
		if ( true == $delete_permissions_query ) {
			$delete_permissions_query_sql = "DELETE FROM " . TABLE_ADMIN_PERMISSIONS_GOUPS . " WHERE admin_permissions_id = '$permission_id'";
			$delete_permissions_query = tep_db_query($delete_permissions_query_sql);
			return $delete_permissions_query;
		}
	}


	function tep_update_permissions($filenames_array, $admin_permission_id) {

		if ( true == empty($filenames_array) || false === is_array($filenames_array) || true === empty($admin_permission_id) ) {
			return false;
		}

		if ( '1' == $admin_permission_id ) {
			$delete_permissions = tep_db_query("DELETE FROM " . TABLE_ADMIN_PERMISSIONS_GOUPS . " WHERE admin_permissions_id = '$admin_permission_id' AND admin_permissions_groups_filename <> '".basename(__FILE__)."'");
		} else {
			$delete_permissions = tep_db_query("DELETE FROM " . TABLE_ADMIN_PERMISSIONS_GOUPS . " WHERE admin_permissions_id = '$admin_permission_id'");
		}

		foreach ( $filenames_array as $filename ) {
			$permissions_insert_query_sql = "
									INSERT INTO
										".TABLE_ADMIN_PERMISSIONS_GOUPS."
									(
										`admin_permissions_id`,
										`admin_permissions_groups_filename`,
										`admin_permissions_groups_time_added`
									)
									VALUES
									(
										'$admin_permission_id',
										'$filename',
										NOW()
									)";
			tep_db_query($permissions_insert_query_sql);
		}
		return true;

	}
	function tep_get_all_permissions() {
		$permissions_query_sql = "
							SELECT
								admin_permissions_id,
								admin_permissions_name,
								admin_permissions_description
							FROM
								".TABLE_ADMIN_PERMISSIONS;
		$permissions_query = tep_db_query($permissions_query_sql);
		if ( 0 >= tep_db_num_rows($permissions_query) ) {
			return false;
		}
		while ( $perms = tep_db_fetch_array($permissions_query) ) {
			$permissions[] = array(
								'id' => $perms['admin_permissions_id'],
								'name' => $perms['admin_permissions_name'],
								'description' => $perms['admin_permissions_description'],
								);
		}
		return $permissions;
	}


	if ( $_SESSION['updated_permission'] ) {
		$messageStack->add('Permission "'.$_SESSION['updated_permission_name'].'" successfully updated!', 'success');
		unset($_SESSION['updated_permission']);
		unset($_SESSION['updated_permission_name']);
	}

	if ( $_SESSION['inserted_permission'] ) {
		$messageStack->add('Successfully added new permission "'.$_SESSION['inserted_permission_name'].'"!', 'success');
		unset($_SESSION['inserted_permission']);
		unset($_SESSION['inserted_permission_name']);
	}

	if ( $_SESSION['deleted_permission'] ) {
		$messageStack->add('Successfully deleted permission "'.$_SESSION['deleted_permission_name'].'"', 'success');
		unset($_SESSION['deleted_permission']);
		unset($_SESSION['deleted_permission_name']);
	}

	if ( $_SESSION['edited_permission'] ) {
		$messageStack->add('Successfully edited permission "'.$_SESSION['edited_permission_name'].'"', 'success');
		unset($_SESSION['edited_permission']);
		unset($_SESSION['edited_permission_name']);
	}



	if ( false === empty($_GET['action']) ) {
		switch ($_GET['action']) {
			case 'update_permissions':
				$admin_permission_id = tep_db_prepare_input($_POST['admin_permission_id']);
				$updated = tep_update_permissions($_POST['filename'], $admin_permission_id);
				if ( true === $updated ) {
					$permission_info = tep_get_permission_info($_GET['cPath']);
					$_SESSION['updated_permission'] = true;
					$_SESSION['updated_permission_name'] = $permission_info['admin_permissions_name'];
					tep_redirect(tep_redirect(tep_href_link(FILENAME_ADMIN_FILES, tep_get_all_get_params(array('action','cPath')).'cID='.$_GET['cPath'])));
				} else {
					$messageStack->add('Cannot update', 'error');
				}
		break;
		case 'new_permission':
			$permission_name = tep_db_prepare_input($_POST['permission_name']);
			$permission_description = tep_db_prepare_input($_POST['permission_description']);
			if ( true === empty($permission_name) ) {
				$messageStack->add('Please provide permission name', 'error');
			} else {
				$inserted_id = tep_insert_permission($permission_name, $permission_description);
				if ( false === empty($inserted_id) ) {
					$_SESSION['inserted_permission'] = true;
					$_SESSION['inserted_permission_name'] = $permission_name;
					tep_redirect(tep_redirect(tep_href_link(FILENAME_ADMIN_FILES, tep_get_all_get_params(array('action','cPath')).'cID='.$inserted_id)));
				} else {
					$messageStack->add('Cannot add permission', 'error');
				}
			}
		break;
		case 'edit_permission':
			$permission_id = tep_db_prepare_input($_POST['permission_id']);
			$permission_name = tep_db_prepare_input($_POST['permission_name']);
			$permission_description = tep_db_prepare_input($_POST['permission_description']);
			if ( true === empty($permission_name) ) {
				$messageStack->add('Please provide permission name', 'error');
			} else {
				$edited = tep_edit_permission($permission_id, $permission_name, $permission_description);
				if ( false === empty($edited) ) {
					$_SESSION['edited_permission'] = true;
					$_SESSION['edited_permission_name'] = $permission_name;
					tep_redirect(tep_redirect(tep_href_link(FILENAME_ADMIN_FILES, tep_get_all_get_params(array('action','cPath')).'cID='.$permission_id)));
				} else {
					$messageStack->add('Cannot edit permission', 'error');
				}
			}
		break;
		case 'delete_permission':
			$permission_id = tep_db_prepare_input($_POST['permission_id']);
			if ( '1' != $permission_id ) {
			$permission_name = tep_db_prepare_input($_POST['permission_name']);
			$deleted = tep_delete_permission($permission_id);
				if ( true == $deleted ) {
					$_SESSION['deleted_permission'] = true;
					$_SESSION['deleted_permission_name'] = $permission_name;
					tep_redirect(tep_redirect(tep_href_link(FILENAME_ADMIN_FILES, tep_get_all_get_params(array('action','cPath','cID')))));
				} else {
					$messageStack->add('Cannot delete permission', 'error');
				}
			} else {
				$messageStack->add('You cannot delete super-admin permission.', 'error');
			}

		break;

    }

  }

	function tep_get_admin_all_available_filenames() {
		$dir = dir('.');
		while ( $file = $dir->read() ) {
			if ( ( substr($file, -4) == '.php') ) {
				$available_files[] = $file;
			}
		}
		$dir->close();
		$dir = dir('includes/paypal_wpp/');
		while ( $file = $dir->read() ) {
			if ( ( substr($file, -4) == '.php') ) {
				$available_files[] = $file;
			}
		}
		$dir->close();
		return $available_files;
	}



	function tep_get_admin_permissions_group($admin_permissions_id) {
		$available_files = tep_get_admin_all_available_filenames();
		if ( true == empty($admin_permissions_id) || false === is_array($available_files) ) {
			return false;
		}
		$permissions_query_sql = "
							SELECT
								admin_permissions_groups_filename
							FROM
								".TABLE_ADMIN_PERMISSIONS_GOUPS."
							WHERE admin_permissions_id = '$admin_permissions_id'";
		$permissions_query = tep_db_query($permissions_query_sql);
		if ( 0 < tep_db_num_rows($permissions_query) ) {
			while ( $permissions = tep_db_fetch_array($permissions_query) ) {
				$allowed_files[] = $permissions['admin_permissions_groups_filename'];
			}
		}

		foreach ( $available_files as $available_file ) {
			if ( true === is_array($allowed_files) ) {
				if ( true === in_array($available_file, $allowed_files) ) {
					$allowed = 1;
				} else {
					$allowed = 0;
				}
			} else {
				$allowed = 0;
			}
			$allowed_files_return[] = array(
									 'filename' => $available_file,
									 'access' => $allowed
									 );
		}
		return $allowed_files_return;
	}

	function tep_get_permission_info($permission_id) {
		$permissions_query_sql = "
							SELECT
								admin_permissions_id,
								admin_permissions_name,
								admin_permissions_description
							FROM
								".TABLE_ADMIN_PERMISSIONS . "
							WHERE admin_permissions_id = '$permission_id'";
		$permissions_query = tep_db_query($permissions_query_sql);
		if ( 0 >= tep_db_num_rows($permissions_query) ) {
			return false;
		}

		return tep_db_fetch_array($permissions_query);
	}
?>
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
<html <?php echo HTML_PARAMS; ?>>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo CHARSET; ?>">
<title><?php echo TITLE; ?></title>
<link rel="stylesheet" type="text/css" href="includes/stylesheet.css">
<script src="includes/javascript/prototype.js" type="text/javascript"></script>
<script src="includes/javascript/general.js" type="text/javascript"></script>
<script src="includes/javascript/utils.js" type="text/javascript"></script>
<script src="includes/javascript/float.js" type="text/javascript"></script>
</head>
<body marginwidth="0" marginheight="0" topmargin="0" bottommargin="0" leftmargin="0" rightmargin="0" bgcolor="#FFFFFF" onload="SetFocus();">

<?php
require_once ( DIR_WS_INCLUDES . 'header.php' );

if ( false === empty($_GET['cPath']) ) {
	$permission_info = tep_get_permission_info($_GET['cPath']);
	echo '<h1 class="pageHeading">'.$permission_info['admin_permissions_name'].'</h1>';
	echo $permission_info['admin_permissions_description'];
} else {
	echo '<h1 class="pageHeading">'.HEADING_TITLE.'</h1>';
}
?>
<table border="0" width="100%" cellspacing="2" cellpadding="2">
	<tr>
		<td width="75%" valign="top">
<?php


switch ($_GET['action']) {
		case 'new':
		case 'new_permission':
		case 'edit':
		case 'edit_permission':

	$edit_perm = false;
	if ( 'edit' == $_GET['action'] || 'edit_permission' == $_GET['action'] ) {
		$edit_perm = true;
		$permission_info = tep_get_permission_info($cID);
	}
?>

<?php echo tep_draw_form('file_permissions', FILENAME_ADMIN_FILES, tep_get_all_get_params(array('action')).'action='.( true === $edit_perm ? 'edit_permission' : 'new_permission'), 'post', 'enctype="multipart/form-data"');?>
<?php echo ( true === $edit_perm ? tep_draw_hidden_field('permission_id', $cID) : '' ); ?>
<table border="0" width="100%" cellspacing="2" cellpadding="2">
	<tr>
		<td valign="top">Permission name:</td>
		<td valign="top"><?php echo tep_draw_input_field('permission_name', $permission_info['admin_permissions_name']);?></td>
	</tr>
	<tr>
		<td valign="top">Permission description:</td>
		<td valign="top"><?php echo tep_draw_input_field('permission_description', $permission_info['admin_permissions_description']);?></td>
	</tr>
	<tr>
		<td valign="top" colspan="2">
		<?php echo '<a href="'.tep_href_link(FILENAME_ADMIN_FILES, tep_get_all_get_params(array('action','cPath'))).'"'.tep_image(DIR_WS_INCLUDES . 'languages/'.$language . '/images/buttons/button_cancel.gif', IMAGE_CANCEL).'</a>';?>
		<?php echo tep_image_submit('button_save.gif', IMAGE_SAVE);?>
		</td>
	</tr>
</table>
</form>
		<?php
		break;
		default:

if ( true === empty($_GET['cPath']) ) {

	$admin_permissions = tep_get_all_permissions();
	if ( true === is_array($admin_permissions) ) {
?>
<table border="0" width="100%" cellspacing="0" cellpadding="2">
              <tr class="dataTableHeadingRow">
                <td class="dataTableHeadingContent" width="60%"><?php echo TABLE_HEADING_PERMISSIONS; ?></td>
                <td class="dataTableHeadingContent" align="right"><?php echo TABLE_HEADING_ACTION; ?>&nbsp;</td>
              </tr>
<?php
	foreach ( $admin_permissions as $admin_permission ) {
?>

<?php
	if ( $cID == $admin_permission['id'] ) {
		echo '<tr class="dataTableRowSelected" onmouseover="this.style.cursor=\'hand\'" onclick="document.location.href=\'' . tep_href_link(FILENAME_ADMIN_FILES, 'cPath=' . $admin_permission['id'].'&action=view') . '\'">' . "\n";
	} else {
		echo '<tr class="dataTableRow" onmouseover="this.className=\'dataTableRowOver\';this.style.cursor=\'hand\'" onmouseout="this.className=\'dataTableRow\'" onclick="document.location.href=\'' . tep_href_link(FILENAME_ADMIN_FILES, 'cID=' . $admin_permission['id']) . '\'">' . "\n";
	}
?>
		<td class="dataTableContent"><a href="<?php echo tep_href_link(FILENAME_ADMIN_FILES, 'cPath=' . $admin_permission['id'].'&action=view'); ?>"><?php echo tep_image(DIR_WS_ICONS . 'folder.png', ICON_FOLDER); ?></a>&nbsp;<?php echo $admin_permission['name']; ?></td>
		<td class="dataTableContent" align="right"><?php echo tep_image(DIR_WS_IMAGES . 'icon_info.gif', IMAGE_ICON_INFO); ?>&nbsp;</td>
	</tr>
<?php
	}
?>
<tr>
	<td colspan="2" align="right">
	<a href="<?php echo tep_href_link(FILENAME_ADMIN_FILES, tep_get_all_get_params(array('action','cPath')) . 'action=new').'">'.tep_image(DIR_WS_INCLUDES . 'languages/'.$language . '/images/buttons/button_new.gif', IMAGE_NEW); ?></a>
	</td>
</tr>
</table>
<?php
	}
	} else {
?>
<table border="0" width="100%" cellspacing="0" cellpadding="2">
<tr class="dataTableHeadingRow">
	<td class="dataTableHeadingContent" width="60%"><?php echo TABLE_HEADING_FILENAME; ?></td>
</tr>

<tr>
	<td class="dataTableContent" width="60%">
<?php
	$permissions_files = tep_get_admin_permissions_group($_GET['cPath']);
	if ( true === is_array($permissions_files) ) {
		echo tep_draw_form('file_permissions', FILENAME_ADMIN_FILES, tep_get_all_get_params(array('action')).'action=update_permissions', 'post', 'enctype="multipart/form-data"');
		foreach ( $permissions_files as $permissions_file ) {
			$checked = ( '1' == $permissions_file['access'] ? true : false );
			list($filename, $ext) = explode('.',$permissions_file['filename']);
			$checkbox_id = "id_$filename";
			$checkbox_param = '';
			if ( FILENAME_ADMIN_ACCOUNT == $permissions_file['filename'] ) {
				$checkbox_param = ' disabled="disabled"';
				$checked = true;
			}
			echo tep_draw_checkbox_field('filename[]', $permissions_file['filename'], $checked, '', 'id="'.$checkbox_id.'"'.$checkbox_param) ;
			echo "<label for=\"$checkbox_id\">{$permissions_file['filename']}</label><br />";
		}
		echo tep_draw_hidden_field('admin_permission_id', $_GET['cPath']);
?>
	</td>
</tr>
<tr>
	<td colspan="2" align="right">
	<div id="menubar">
	<input type="button" onclick="javascript:checkAll(document.file_permissions);" value="Check All" align="absmiddle" />
	<input type="button" onclick="javascript:inverseAll(document.file_permissions);" value="Inverse All" align="absmiddle" />
	<input type="button" onclick="javascript:uncheckAll(document.file_permissions);" value="Uncheck All" align="absmiddle" />
	&nbsp;&nbsp;
	<?php echo tep_image_submit('button_save.gif', IMAGE_SAVE, 'align="absmiddle"'); ?>
	<a href="<?php echo tep_href_link(FILENAME_ADMIN_FILES, tep_get_all_get_params(array('action','cPath')).'cID='.$_GET['cPath']); ?>"><?php echo tep_image(DIR_WS_INCLUDES . 'languages/'.$language . '/images/buttons/button_cancel.gif', IMAGE_CANCEL, '','','align="absmiddle"'); ?></a>
	</div>
	</td>
</tr>
</table>
</form>

	<?php
	}


	}
	break;
}
?>

		</td>


<?php
	$heading = array();
	$contents = array();
	switch ($_GET['action']) {
		case 'view':
			$heading[] = array('text' => '<b>Permission details</b>' );
			$contents[] = array('align' => 'center', 'text' => '<a href="'.tep_href_link(FILENAME_ADMIN_FILES, tep_get_all_get_params(array('action','cPath')).'cID='.$_GET['cPath']).'"'.tep_image(DIR_WS_INCLUDES . 'languages/'.$language . '/images/buttons/button_back.gif', IMAGE_BACK).'</a>' );
			$contents[] = array('text' => '<br />');
		break;
		case 'new':
		case 'new_permission':
			$heading[] = array('text' => '<b>New permission</b>' );
			$contents[] = array('align' => 'center', 'text' => 'Create a new permission');
			$contents[] = array('align' => 'center', 'text' => '<a href="'.tep_href_link(FILENAME_ADMIN_FILES, tep_get_all_get_params(array('action','cPath'))).'"'.tep_image(DIR_WS_INCLUDES . 'languages/'.$language . '/images/buttons/button_cancel.gif', IMAGE_CANCEL).'</a>' );
		break;
		case 'edit':
		case 'edit_permission':
			$heading[] = array('text' => '<b>Edit permission</b>' );
			$contents[] = array('align' => 'center', 'text' => 'Edit existing permission');
			$contents[] = array('align' => 'center', 'text' => '<a href="'.tep_href_link(FILENAME_ADMIN_FILES, tep_get_all_get_params(array('action','cPath'))).'"'.tep_image(DIR_WS_INCLUDES . 'languages/'.$language . '/images/buttons/button_cancel.gif', IMAGE_CANCEL).'</a>' );
		break;
		case 'delete':
		case 'delete_permission':
			$permission_info = tep_get_permission_info($cID);

			$contents = array('form' => tep_draw_form('form_delete_permission', FILENAME_ADMIN_FILES, tep_get_all_get_params(array('action','cPath','cID')) . 'cID='.$cID.'&action=delete_permission', 'post', 'enctype="multipart/form-data"'));
			$heading[] = array('text' => '<b>Delete permission?</b>' );
			$contents[] = array('text' => tep_draw_hidden_field('permission_id', $_GET['cID']).tep_draw_hidden_field('permission_name', $permission_info['admin_permissions_name']) );
			$contents[] = array('align' => 'center', 'text' => '<br /> Are you sure you want to <strong>delete "'.$permission_info['admin_permissions_name'].'"</strong> permission ?');
			$contents[] = array('align' => 'center', 'text' =>
				tep_image_submit('button_delete.gif', IMAGE_DELETE).
				' <a href="'.tep_href_link(FILENAME_ADMIN_FILES, tep_get_all_get_params(array('action','cPath','cID')) . 'cID='.$cID).'">'.tep_image(DIR_WS_INCLUDES . 'languages/'.$language . '/images/buttons/button_cancel.gif', IMAGE_CANCEL).'</a>'
				);

		break;
		default:
			$permission_info = tep_get_permission_info($cID);
			$heading[] = array('text' => '<strong>'.$permission_info['admin_permissions_name'].'</strong>' );
			$contents[] = array('align' => 'center', 'text' =>
			$permission_info['admin_permissions_description'].'<br /><br />'.
			' <a href="'.tep_href_link(FILENAME_ADMIN_FILES, tep_get_all_get_params(array('action','cPath', 'cID')) . 'action=view&cPath='.$cID).'">'.tep_image(DIR_WS_INCLUDES . 'languages/'.$language . '/images/buttons/button_details.gif', IMAGE_DETAILS).'</a>' .
			' <a href="'.tep_href_link(FILENAME_ADMIN_FILES, tep_get_all_get_params(array('action','cPath')) . 'action=edit').'">'.tep_image(DIR_WS_INCLUDES . 'languages/'.$language . '/images/buttons/button_edit.gif', IMAGE_EDIT).'</a>' .
			( '1' == $cID ? '' : ' <a href="'.tep_href_link(FILENAME_ADMIN_FILES, tep_get_all_get_params(array('action','cPath')) . 'action=delete').'">'.tep_image(DIR_WS_INCLUDES . 'languages/'.$language . '/images/buttons/button_delete.gif', IMAGE_DELETE).'</a>' )
			);

		}


  if ( (tep_not_null($heading)) && (tep_not_null($contents)) ) {
    echo '            <td width="25%" valign="top">' . "\n";

    $box = new box;
    echo $box->infoBox($heading, $contents);

    echo '            </td>' . "\n";
  }

?>

	</tr>
</table>



<?php /**/ require_once ( DIR_WS_INCLUDES . 'footer.php' ); ?>

<br />
</body>
</html>
<?php require_once ( DIR_WS_INCLUDES . 'application_bottom.php' ); ?>