<?php
$stimer = explode(' ', microtime());
$stimer = $stimer[1] + $stimer[0];
error_reporting(E_ALL & ~E_NOTICE);

chdir('../');
require_once ( 'configure/catalog_configure.php' );
require_once ( 'includes/filenames.php' );
require_once ( 'includes/database_tables.php' );
require_once ( 'includes/functions/database.php' );
require_once ( 'includes/functions/general.php' );
require_once ( 'includes/functions/sessions.php' );
require_once ( 'includes/functions/html_output.php' );
require_once ( 'includes/classes/currencies.php' );
require_once ( 'includes/functions/image_stamp.php' );
require_once ( 'includes/classes/feeder.php' );

$configuration_query = tep_db_query('SELECT configuration_key, configuration_value FROM ' . TABLE_CONFIGURATION);
while ($configuration = tep_db_fetch_array($configuration_query)) {
	define($configuration['configuration_key'], $configuration['configuration_value']);
}

$current_feed = tep_db_input($_GET['feed']);

switch ($current_feed) {
	case 'GOOGLE':
		if ( 'true' === SEO_URLS ) {
			require_once ( 'includes/classes/cache.class.php' );
			$seocache = new cache(GOOGLEBASE_DEFAULT_LANGUAGE);
			$seocache->get_cache();
		}
		$feeder = new Feeder(GOOGLEBASE_FEEDNAME);
		$output_config = array(
						'link'				=> 'url', // The URL of the web page associated with the item. This should not forward to another URL; it must point directly to the target page. The domain name may not be an IP address. URL. (Must include the http:// portion.)
						'title'				=> 'products_name', // The name or title of the item. Text. Suggested maximum length of 70 characters.
						'description'		=> 'products_description', // Text describing the item. Do not include promotional or boilerplate text, such as "Free shipping!" or "Click here now!" We search over this text when matching user queries to your item. Please make sure you include the same item description available on your website in the description field in your data feed.
																		// Text, up to a maximum length of 10,000 characters. Ideally greater than 15 characters and 3 words.
						'brand'				=> 'manufacturers_name', // The brand name of the product. Text.
						'mpn'				=> 'products_model', // Manufacturer's Part Number is a unique code determined by the manufacturer for that product. Text.
						'expiration_date'	=> 'expiration_date', // The date that the item listing expires or that information about this item is going to change. ISO 8601 format: YYYY-MM-DD. Note: all dates and times are in PST (GMT -8).
						'price'				=> 'products_price', // The price for the item. Number. 25.00
						'image_link'		=> 'products_image', // The URL of an associated image for the item. Use your full-sized images, not thumbnail images. If you do not have an image available, leave the attribute blank. Do not include logos or an image that says, "Image not available."
																// URL. (Must include the http:// portion.) Up to 10 URLs can be included. For tab-delimited, separate each URL by a comma.
						'id'				=> 'products_id', // A unique alphanumeric identifier for the item - e.g., your internal ID code. IMPORTANT: Once you submit an item with a unique id, this identifier must not change when you send in a new data feed. Each item must retain the same id in subsequent feeds.
						'condition'			=> 'products_condition', // The condition of the product. Text. Supported values are: new, used, and refurbished.
						'weight'			=> 'products_weight', // The shipping weight of a product. Number and unit. Valid units include lb, pound, oz, ounce, g, gram, kg, kilogram. If unit isn't included, we assume a default unit of pounds.
						'quantity'			=> 'products_quantity' // The number of items available. Number. Indicate a value of 0 for out-of-stock items.
					);
		$feeder->set_output_config($output_config);
		if ( 'Enabled' === GOOGLEBASE_FTP_ENABLED ) {
			$feeder->set_ftp_enabled(true);
			$feeder->set_ftp_server('uploads.google.com');
			$feeder->set_ftp_username(GOOGLEBASE_FTP_USERNAME);
			$feeder->set_ftp_password(GOOGLEBASE_FTP_PASSWORD);
			$feeder->set_ftp_destination_file(GOOGLEBASE_FEEDNAME);
		}
		$fed = $feeder->feed();
	break;

	case 'YAHOO':
		if ( 'true' === SEO_URLS ) {
			require_once ( 'includes/classes/cache.class.php' );
			$seocache = new cache(YAHOO_DEFAULT_LANGUAGE);
			$seocache->get_cache();
		}
		$feeder = new Feeder(YAHOO_FEEDNAME);
		$output_config = array(
						'code'						=> 'products_id', // A merchant-specific identifier, or SKU. A unique code must be used for each product and should be kept consistent from feed to feed.
						'name'						=> 'products_name', // The product name, with no control characters or embedded HTML.
						'description'				=> 'products_description', // 	The product description, with no control characters or embedded HTML. If you do not have product descriptions, you may enter the same data as the "name" field.
						'price'						=> 'products_price', // Price, in US dollars, with a decimal point and no $ sign. 95.00 (not $95.00, 95)
						'product-url'				=> 'url', // The URL that links to the product on your site. You must include http:// in your URLs.
						'merchant-site-category'	=> 'products_category_path', // The category you use on your own site for each product. Please include your full hierarchy for each entry and separate the different levels with a " > ". home electronics > audio & video > video > dvd players
						'medium'					=> '', // Required for Music and Video products only (please leave this field blank for all other product types)
															// For Music, must be one of (not case sensitive):
															// CD, Cassette, MiniDisc, LP, EP, 45
															// For Video, must be one of (not case sensitive):
															// DVD, VHS, VCD, Beta, 8mm, Laser Disc
						'image-url'					=> 'products_image', // The URL that links to your product image. You must include http:// in your URLs.
						'manufacturer'				=> 'manufacturers_name', // The manufacturer of the product, with no control characters or embedded HTML. Highly recommended for Computers and Electronics products.
						'model-no'					=> 'products_model', // The model number for the product. Highly recommended for Home and Garden, Computers, and Electronics products.
						'condition'					=> 'products_condition', // The condition of the product.
						'promo-text'				=> 'price_special_text', // You may use this field to relay any special promotions associated with the product. Up to 50 characters of text, with no control characters or embedded HTML.
						'shipping-weight'			=> 'products_weight', // The weight of the item in pounds, up to one decimal place. Note: Required if you wish to compute shipping estimates based on weight or standard UPS ground rates. 2, 2.5
					);
		$feeder->set_output_config($output_config);
		$feeder->set_categories_use_full_path(true);
		if ( 'Enabled' === YAHOO_FTP_ENABLED ) {
			$feeder->set_ftp_enabled(true);
			$feeder->set_ftp_server('ftp.productsubmit.adcentral.yahoo.com');
			$feeder->set_ftp_username(YAHOO_FTP_USERNAME);
			$feeder->set_ftp_password(YAHOO_FTP_PASSWORD);
			$feeder->set_ftp_destination_file(YAHOO_FEEDNAME);
		}
		$fed = $feeder->feed();
	break;

	default:
		echo "No feed selected.";
	break;
}

if ( false === $fed['error'] ) {
	echo "File completed: <a href=\"../$feeder->feeder_option_source_file\" target=\"_blank\">" . $feeder->feeder_option_feed_file_name . "</a><br />\n";
} else {
	echo $fed['message'];
}

$etimer = explode( ' ', microtime() );
$etimer = $etimer[1] + $etimer[0];
echo '<br /><input type="button" value="Close Window" onclick="javascript:window.close();" />';
echo '<p style="margin:auto; text-align:center">';
printf( "Generated in <b>%f</b> seconds.", ($etimer-$stimer) );
echo '</p>';
?>