<?php
	class Feeder {

		function Feeder($feed_file_name = '') {
			$this->feeder_option_default_language_id 	= 1;
			$this->feeder_option_exp_date 				= date('Y-m-d', time() + 2592000);
			$this->feeder_option_file_size_limit 		= 15; // MB 1048576 bytes
			$this->feeder_option_condition 				= 'New';  // possible entries are New, Refurbished, Used
			$this->feeder_option_weight_type			= 'lb'; // Valid units include lb, pound, oz, ounce, g, gram, kg, kilogram.
			$this->feeder_option_output_dir 			= 'feeds/';
			$this->feeder_option_feed_file_name			= $feed_file_name;
			$this->feeder_option_source_file 			= $this->feeder_option_output_dir. $feed_file_name;
			$this->feeder_option_catalog_images_url 	= HTTP_SERVER . DIR_WS_HTTP_CATALOG . DIR_WS_IMAGES;
			$this->feeder_option_convert_currency		= false;
			$this->feeder_option_convert_currency_type	= 'USD';
			$this->feeder_option_ftp_enabled			= false;
			$this->feeder_option_ftp_server				= '';
			$this->feeder_option_ftp_username			= '';
			$this->feeder_option_ftp_password			= '';
			$this->feeder_option_ftp_directory			= '';
			$this->feeder_option_ftp_destination_file	= '';

			$this->categories_use_full_path				= false;
			$this->categories_delim						= ' > ';
			$this->categories_delim_empty_trail			= true;

			$this->feeder_delim							= "\t";
			$this->feeder_strip_search 					= array("![\t ]+$|^[\t ]+!m",'%[\r\n]+%m');
			$this->feeder_cleaner_array 				= array('>' => '> ', '&reg;' => '', '' => '', '&trade;' => '', '' => '', "\t" => '', '	' => '');
			$this->feeder_output_config					= array();
			$this->strip_html							= false;
			$this->products_limit						= 0; // 0 = unlimited
		}

		function set_feeder_delim($feeder_delim = "\t") {
			$this->feeder_delim = $feeder_delim;
		}

		function set_categories_use_full_path($categories_use_full_path = false) {
			$this->categories_use_full_path = $categories_use_full_path;
		}

		function set_categories_delim($categories_delim = false) {
			$this->categories_delim = $categories_delim;
		}

		function set_categories_delim_empty_trail($categories_delim_empty_trail = true) {
			$this->categories_delim_empty_trail = $categories_delim_empty_trail;
		}

		function set_strip_html($strip_html = false) {
			$this->strip_html = $strip_html;
		}

		function set_products_limit($products_limit = 0) {
			$this->products_limit = $products_limit;
		}

		function set_default_language_id($default_language_id = 1) {
			$this->feeder_option_default_language_id = $default_language_id;
		}

		function set_exp_date($exp_date = '') {
			$this->feeder_option_exp_date = $exp_date;
		}

		function set_file_size_limit($file_size_limit = 15) {
			$this->feeder_option_file_size_limit = $file_size_limit;
		}

		function set_condition($condition = 'New') {
			$this->feeder_option_condition = $condition;
		}

		function set_weight_type($weight_type = 'lb') {
			$this->feeder_option_weight_type = $weight_type;
		}

		function set_output_dir($output_dir = 'feeds/') {
			$this->feeder_option_output_dir = $output_dir;
		}

		function set_file_name($feed_file_name = '') {
			$this->feeder_option_feed_file_name = $feed_file_name;
		}

		function set_convert_currency($convert_currency = false) {
			$this->feeder_option_convert_currency = $convert_currency;
		}

		function set_convert_currency_type($convert_currency_type = 'USD') {
			$this->feeder_option_convert_currency_type = $convert_currency_type;
		}

		function set_ftp_enabled($ftp_enabled = false) {
			$this->feeder_option_ftp_enabled = $ftp_enabled;
		}

		function set_ftp_server($ftp_server = '') {
			$this->feeder_option_ftp_server = $ftp_server;
		}

		function set_ftp_username($username = '') {
			$this->feeder_option_ftp_username = $username;
		}

		function set_ftp_password($password = '') {
			$this->feeder_option_ftp_password = $password;
		}

		function set_ftp_directory($directory = '') {
			$this->feeder_option_ftp_directory = $directory;
		}

		function set_ftp_destination_file($destination_file = '') {
			$this->feeder_option_ftp_destination_file = $destination_file;
		}

		function set_output_config($output_config = array()) {
			$this->feeder_output_config = $output_config;
		}

		function ftp_file($ftpservername, $ftpusername, $ftppassword, $ftpsourcefile, $ftpdirectory, $ftpdestinationfile) {
			$conn_id = ftp_connect($ftpservername);
			if ( false === $conn_id ) {
				echo "FTP open connection failed to $ftpservername <br />\n" ;
				return false;
			}
			$login_result = ftp_login($conn_id, $ftpusername, $ftppassword);

			if ( false === $conn_id || false === $login_result ) {
				echo "FTP connection has failed!<br />\n";
				echo "Attempted to connect to " . $ftpservername . " for user " . $ftpusername . "<br />\n";
				return false;
			} else {
				echo "Connected to " . $ftpservername . ", for user " . $ftpusername . "<br />\n";
			}

			if ( 0 < strlen( $ftpdirectory ) ) {
				if ( ftp_chdir($conn_id, $ftpdirectory) ) {
					echo "Current directory is now: " . ftp_pwd($conn_id) . "<br />\n";
				} else {
					echo "Couldn't change directory on $ftpservername<br />\n";
					return false;
				}
			}

			ftp_pasv($conn_id, true);
			$uploaded = ftp_put($conn_id, $ftpdestinationfile, $ftpsourcefile, FTP_ASCII);

			if ( false === $uploaded ) {
				echo "$ftpservername: FTP upload has failed!<br />\n";
				return false;
			} else {
				echo "Uploaded " . $ftpsourcefile . " to " . $ftpservername . " as " . $ftpdestinationfile . "<br />\n";
			}
			ftp_close($conn_id);
			return true;
		}

		function set_categories() {
			$set_categories_query_sql = "SELECT
											c.categories_id,
											c.parent_id,
											cd.categories_name
										FROM
											categories c,
											categories_description cd
										WHERE
											c.categories_id = cd.categories_id";
			$set_categories_query = tep_db_query($set_categories_query_sql);
			if ( 0 < tep_db_num_rows($set_categories_query) ) {
				while ( $set_categories = tep_db_fetch_array($set_categories_query) ) {
					$this->temp_categories_array[$set_categories['categories_id']] = $set_categories['categories_name'];
					$this->temp_parent_categories_array[$set_categories['categories_id']] = $set_categories['parent_id'];
				}
			}
		}

		function category_path_array($categories_id, $categories_array = '') {
			if ( false === is_array($categories_array) ) {
				$categories_array = array();
			}
			$categories_array[] = $this->temp_categories_array[$categories_id];
			if ( false === empty($this->temp_parent_categories_array[$categories_id]) ) {
				$categories_array = $this->category_path_array($this->temp_parent_categories_array[$categories_id], $categories_array);
			}
			return $categories_array;
		}

		function category_path($categories_id) {
			$categories_array = $this->category_path_array($categories_id);
			$categories_array = array_reverse($categories_array);
			$return_string = '';
			if ( true === is_array($categories_array) ) {
				foreach ( $categories_array as $categories ) {

					$return_string .= $categories . ( $categories === end($categories_array) && true === $this->categories_delim_empty_trail ? '' : $this->categories_delim );
				}
			}
			return $return_string;
		}

		function feed() {
			$return = array();
			$return['message'] = '';
			$return['error'] = false;
			if ( false === is_writable($this->feeder_option_output_dir) ) {
				$return['error'] = true;
				$return['message'] = "Unable to write to dir: $this->feeder_option_output_dir<br />";
			}

			if ( true === file_exists( $this->feeder_option_source_file ) ) {
				if ( true === is_writable($this->feeder_option_source_file) ) {
					$unlinked = @unlink($this->feeder_option_source_file);
					if ( false === $unlinked ) {
						$return['error'] = true;
						$return['message'] .= "Unable to remove existing file: $this->feeder_option_source_file<br />";
					}
				} else {
					$return['error'] = true;
					$return['message'] .= "File $this->feeder_option_source_file is not writable<br />";
				}
			}

			$limit_sql = ( 0 < $this->products_limit ? " LIMIT $this->products_limit " : '' );
			$products_query_sql = "SELECT
						pd.products_name,
						pd.products_description,
						p.products_image,
						p.products_image_thumb,
						p.products_image_stamp,
						p.products_id,
						p.manufacturers_id,
						p.products_price,
						p.average_rating,
						p.reviews_count,
						IF (s.status, s.specials_new_products_price, NULL)
							AS specials_new_products_price,
						IF (s.status, s.specials_new_products_price, p.products_price)
							AS final_price,
						s.specials_text AS price_special_text,
						p.products_model,
						p.products_date_added,
						p.products_weight,
						p.products_tax_class_id,
						p.products_date_available,
						p.products_quantity,
						p.products_price_groups,
						m.manufacturers_name,
						m.manufacturers_image,
						p2c.categories_id,
						cd.categories_name,
						cd.categories_heading_title

					FROM
						" . TABLE_PRODUCTS_DESCRIPTION . " pd,
						" . TABLE_PRODUCTS . " p
					LEFT JOIN
						" . TABLE_MANUFACTURERS . " m
						ON
							p.manufacturers_id = m.manufacturers_id
					LEFT JOIN
						" . TABLE_SPECIALS . " s
						ON (p.products_id = s.products_id)
					LEFT JOIN
						" . TABLE_PRODUCTS_TO_CATEGORIES . " p2c
						ON (p.products_id = p2c.products_id)
					LEFT JOIN
						" . TABLE_CATEGORIES_DESCRIPTION . " cd
						ON (p2c.categories_id = cd.categories_id AND cd.language_id = '" . (int)$this->feeder_option_default_language_id . "')
					WHERE
						p.products_status = '1'
						AND p.products_id = pd.products_id
						AND pd.language_id = '" . (int)$this->feeder_option_default_language_id . "'

					ORDER BY
						 p.products_date_added ASC
					$limit_sql";

			$products_query = tep_db_query($products_query_sql);

			if ( 0 < tep_db_num_rows($products_query) ) {
				$file_handler = fopen($this->feeder_option_source_file, 'w');
				chmod($this->feeder_option_source_file, 0777);
				$output_string = '';

				if ( true === is_readable($this->feeder_option_source_file) ) {
					$total_bytes_written = 0;
					$total_bytes_allowed = $this->feeder_option_file_size_limit * 1048576;

					foreach ( $this->feeder_output_config as $output_config => $output_value ) {
						$output_string .= $output_config . $this->feeder_delim;
					}
					$output_string .= "\n";

					file_put_contents($this->feeder_option_source_file, $output_string, FILE_APPEND);

					if ( true === $this->categories_use_full_path ) {
							$this->set_categories();
					}

					while ( $products = tep_db_fetch_array($products_query) ) {

						if ( true === $this->categories_use_full_path ) {
							$products['products_category_path'] = $this->category_path($products['categories_id']);
						}

						if( false === empty($products['products_image_thumb']) ) {
							$products['products_image'] = $catalog_images_url.$products['products_image_thumb'];
						} else {
							$products['products_image'] = $catalog_images_url.$products['products_image'];
							if ( 'on' === IMAGE_STAMP_ON_OFF ) {
								if( $products['products_image_stamp'] ) {
									$products['products_image'] = generate_image_stamp($products['products_image'], DIR_WS_IMAGES.$products['products_image_stamp']);
								}
							}
						}

						$products['products_image'] = $this->feeder_option_catalog_images_url . $products['products_image'];
						$currency_convert = ( true == $this->feeder_option_convert_currency ? '&currency='.$this->feeder_option_convert_currency_type : '' );
						$products['url'] = tep_href_link(FILENAME_PRODUCT_INFO, 'products_id=' . $products['products_id']. $currency_convert);
						$products['products_name'] = preg_replace($this->feeder_strip_search, " ", $products['products_name']);
						$products['products_description'] = preg_replace($this->feeder_strip_search, " ", $products['products_description']);
						if ( true === $this->strip_html ) {
							$products['products_name'] = strip_tags($products['products_name']);
							$products['products_description'] = strip_tags($products['products_description']);
						}
						$products['expiration_date'] = $this->feeder_option_exp_date;
						$products['products_price'] = number_format($products['final_price'], 2, '.', '');
						$products['products_condition'] = $this->feeder_option_condition;
						if ( true == $this->feeder_option_convert_currency ) {
							$currency_query_sql = "SELECT value FROM currencies WHERE code = '" . $this->feeder_option_convert_currency_type . "'";
							$currency_query = tep_db_query($currency_query_sql);
							if ( 0 < tep_db_num_rows($currency_query) ) {
								$currency = tep_db_fetch_array($currency_query);
								$products['final_price'] = $products['final_price'] * $currency['value'];
							}
						}

						$output_string = '';
						foreach ( $this->feeder_output_config as $output_config => $output_value ) {
							$output_string .= $products[$output_value] . $this->feeder_delim;
						}
						$output_string .= "\n";
						$bytes_written = file_put_contents($this->feeder_option_source_file, $output_string, FILE_APPEND);
						$total_bytes_written += $bytes_written;
						if ( $total_bytes_written >= $total_bytes_allowed ) {
							break;
						}
					}
					fclose($file_handler);
					if ( true === $this->feeder_option_enable_ftp ) {
						$this->ftp_file($this->feeder_option_ftp_server, $this->feeder_option_ftp_username, $this->feeder_option_ftp_password , "../$this->feeder_option_source_file", $this->feeder_option_ftp_directory, $this->feeder_option_ftp_destination_file);
					}
				} else {
					$return['error'] = true;
					$return['message'] .= "File: $this->feeder_option_source_file is not readable<br />";
				}
			} else {
				$return['error'] = true;
				$return['message'] .= "No products found<br />";
			}

			return $return;
		}
	}
?>