<?php
/*

  Example usage:

  $messageStack = new messageStack();
  $messageStack->add('Error: Error 1', 'error');
  $messageStack->add('Error: Error 2', 'warning');
  if ($messageStack->size > 0) echo $messageStack->output();
*/

  class messageStack extends tableBlock {
    var $size = 0;

    function messageStack() {
      global $messageToStack;

      $this->errors = array();

      if (tep_session_is_registered('messageToStack')) {
        for ($i = 0, $n = sizeof($messageToStack); $i < $n; $i++) {
          $this->add($messageToStack[$i]['text'], $messageToStack[$i]['type']);
        }
        tep_session_unregister('messageToStack');
      }
    }

    function add($message, $type = 'error') {
      if ($type == 'error') {
        $this->errors[] = array('params' => 'class="messageStackError"', 'text' => tep_image(DIR_WS_ICONS . 'warning.png', ICON_ERROR) . '&nbsp;' . $message);
      } elseif ($type == 'warning') {
        $this->errors[] = array('params' => 'class="messageStackWarning"', 'text' => tep_image(DIR_WS_ICONS . 'info.png', ICON_WARNING) . '&nbsp;' . $message);
      } elseif ($type == 'success') {
        $this->errors[] = array('params' => 'class="messageStackSuccess"', 'text' => tep_image(DIR_WS_ICONS . 'tick.png', ICON_SUCCESS) . '&nbsp;' . $message);
      } else {
        $this->errors[] = array('params' => 'class="messageStackError"', 'text' => $message);
      }
      $this->size++;
    }

	function add_global($message, $type = 'error') {
		switch ($type) {
			case 'error':
				$this->global_messages[] = array('params' => 'class="messageStackError"', 'text' => tep_image(DIR_WS_ICONS . 'warning.png', ICON_ERROR) . '&nbsp;' . $message);
			break;
			case 'warning':
				$this->global_messages[] = array('params' => 'class="messageStackWarning"', 'text' => tep_image(DIR_WS_ICONS . 'info.png', ICON_WARNING) . '&nbsp;' . $message);
			break;
			case 'success':
				$this->global_messages[] = array('params' => 'class="messageStackSuccess"', 'text' => tep_image(DIR_WS_ICONS . 'tick.png', ICON_SUCCESS) . '&nbsp;' . $message);
			break;
			default:
				$this->global_messages[] = array('params' => 'class="messageStackError"', 'text' => $message);
			break;
		}
		$this->size++;
	}

	function print_global_messages() {
		if ( true === is_array($this->global_messages) ) {
			$output = '';
			foreach ( $this->global_messages as $message ) {
				$output .= "<p {$message['params']}>".$message['text'].'</p>';
			}
			echo $output;
		}
    }

    function print_messages() {
		if ( true === is_array($this->errors) ) {
			$output = '';
			foreach ( $this->errors as $message ) {
				$output .= "<p {$message['params']}>".$message['text'].'</p>';
			}
			echo $output;
		}
    }


    function add_session($message, $type = 'error') {
      global $messageToStack;

      if (!tep_session_is_registered('messageToStack')) {
        tep_session_register('messageToStack');
        $messageToStack = array();
      }

      $messageToStack[] = array('text' => $message, 'type' => $type);
    }

    function reset() {
      $this->errors = array();
      $this->size = 0;
    }

    function output() {
      $this->table_data_parameters = 'class="messageBox"';
      return $this->tableBlock($this->errors);
    }
  }
?>
