<?php

  class order {
    var $info, $totals, $products, $customer, $delivery;

    function order($order_id) {
      $this->info = array();
      $this->totals = array();
      $this->products = array();
      $this->customer = array();
      $this->delivery = array();
      $this->shipping = array();

      $this->query($order_id);
    }
//Begin Order Editor modifications
    function query($order_id) {
    	$order_query_sql = "SELECT
    							o.*,
    							c.carrier_name,
    							c.carrier_link
    						FROM
    							" . TABLE_ORDERS . " o
    							LEFT JOIN " . TABLE_CARRIERS. " c
    								ON o.carrier_id = c.carrier_id
    						WHERE
    							orders_id = '" . (int)$order_id . "'";
		$order_query = tep_db_query($order_query_sql);
		$order = tep_db_fetch_array($order_query);

      $totals_query = tep_db_query("select * from " . TABLE_ORDERS_TOTAL . " where orders_id = '" . (int)$order_id . "' order by sort_order");
      while ($totals = tep_db_fetch_array($totals_query)) {
        $this->totals[] = array(
	  'title' => $totals['title'],
	  'text' => $totals['text'],
	  'class' => $totals['class'],
	  'value' => $totals['value'],
	  'sort_order' => $totals['sort_order'],
	  'orders_total_id' => $totals['orders_total_id']);
      }

		if ( true === is_numeric($order['customers_id']) ) {
			$customers_query_sql ="
								SELECT
									ab.entry_company_tax_id
								FROM
									" . TABLE_ADDRESS_BOOK . " ab,
									" . TABLE_CUSTOMERS . " c
								WHERE
									c.customers_default_address_id = ab.address_book_id
									AND c.customers_id = '{$order['customers_id']}'";
			$customers_query = tep_db_query($customers_query_sql);
			if ( 1 == tep_db_num_rows($customers_query) ) {
				$customers_info = tep_db_fetch_array($customers_query);
				$company_tax_id = $customers_info['entry_company_tax_id'];
			}
		}

      $this->info = array('currency' => $order['currency'],
                          'currency_value' => $order['currency_value'],
                          'payment_method' => $order['payment_method'],
                          'cc_type' => $order['cc_type'],
                          'cc_owner' => $order['cc_owner'],
                          'cc_number' => $order['cc_number'],
                          'cc_expires' => $order['cc_expires'],
					 	  'shipping_tax' => $order['shipping_tax'],
                          'date_purchased' => $order['date_purchased'],
                          'orders_status' => $order['orders_status'],
                          'last_modified' => $order['last_modified']);

      $this->customer = array('name' => $order['customers_name'],
                              'company' => $order['customers_company'],
                              'company_tax_id' => $company_tax_id,
                              'street_address' => $order['customers_street_address'],
                              'suburb' => $order['customers_suburb'],
                              'city' => $order['customers_city'],
                              'postcode' => $order['customers_postcode'],
                              'state' => $order['customers_state'],
                              'country' => $order['customers_country'],
                              'format_id' => $order['customers_address_format_id'],
                              'telephone' => $order['customers_telephone'],
                              'email_address' => $order['customers_email_address']);

      $this->delivery = array('name' => $order['delivery_name'],
                              'company' => $order['delivery_company'],
                              'street_address' => $order['delivery_street_address'],
                              'suburb' => $order['delivery_suburb'],
                              'city' => $order['delivery_city'],
                              'postcode' => $order['delivery_postcode'],
                              'state' => $order['delivery_state'],
                              'country' => $order['delivery_country'],
                              'format_id' => $order['delivery_address_format_id']);

      $this->billing = array('name' => $order['billing_name'],
      						 'invoice_serial' => $order['invoice_serial'],
                             'invoice_number' => $order['invoice_number'],
                             'company' => $order['billing_company'],
                             'street_address' => $order['billing_street_address'],
                             'suburb' => $order['billing_suburb'],
                             'city' => $order['billing_city'],
                             'postcode' => $order['billing_postcode'],
                             'state' => $order['billing_state'],
                             'country' => $order['billing_country'],
                             'format_id' => $order['billing_address_format_id']);
	 if ( $order['shipping_date'] ) {
	 	$time = strtotime($order['shipping_date']);
	 	$shipping_date_month = date('m', $time);
	 	$shipping_date_day = date('d', $time);
	 	$shipping_date_year = date('Y', $time);
	 }
     $this->shipping = array('shipping_date' => $order['shipping_date'],
                              'shipping_date_month' => $shipping_date_month,
                              'shipping_date_day' => $shipping_date_day,
                              'shipping_date_year' => $shipping_date_year,
                              'tracking_number' => $order['delivery_tracking_number'],
							  'carrier_name' => $order['carrier_name'],
							  'carrier_link' => $order['carrier_link'],
                              'carrier_id' => $order['carrier_id']);

    $countryid = tep_get_country_id($this->delivery["country"]);
	$zoneid = tep_get_zone_id($countryid, $this->delivery["state"]);

    $index = 0;
    $orders_products_query_sql = "
     SELECT
	 op.orders_products_id,
	 op.products_name,
	 op.products_model,
	 op.products_price,
	 op.products_tax,
	 op.products_quantity,
	 op.final_price,
	 p.products_id,
	 p.products_image,
	 p.products_image_thumb,
	 p.products_image_stamp,
	 p.products_tax_class_id,
	 p.products_weight
  FROM " . TABLE_ORDERS_PRODUCTS . " op
  LEFT JOIN " . TABLE_PRODUCTS . " p
    ON op.products_id = p.products_id
 WHERE orders_id = '" . (int)$order_id . "'";
	$orders_products_query = tep_db_query($orders_products_query_sql);

       while ($orders_products = tep_db_fetch_array($orders_products_query)) {
         $this->products[$index] = array(
		                      'qty' => $orders_products['products_quantity'],
                                'name' => $orders_products['products_name'],
                                'image' => $orders_products['products_image'],
                                'image_thumb' => $orders_products['products_image_thumb'],
                                'image_stamp' => $orders_products['products_image_stamp'],
                                'model' => $orders_products['products_model'],
                                'tax' => $orders_products['products_tax'],
                                'tax_description' => tep_get_tax_description($orders_products['products_tax_class_id'], $countryid, $zoneid),
                                'price' => $orders_products['products_price'],
                                'final_price' => $orders_products['final_price'],
                                'weight' => $orders_products['products_weight'],
                                'products_id' => $orders_products['products_id']);

        $subindex = 0;
	$attributes_query_sql = "
					SELECT
						*
					FROM
						" . TABLE_ORDERS_PRODUCTS_ATTRIBUTES . "
					WHERE
						orders_id = '" . (int)$order_id . "'
						and orders_products_id = '" . (int)$orders_products['orders_products_id'] . "'
					ORDER BY products_options";

	$attributes_query = tep_db_query($attributes_query_sql);

	if (tep_db_num_rows($attributes_query)) {
		while ($attributes = tep_db_fetch_array($attributes_query)) {
			$this->products[$index]['attributes'][$subindex] = array(
					'products_attributes_id' => $attributes['products_attributes_id'],
					'option' => $attributes['products_options'],
					'value' => $attributes['products_options_values'],
					'prefix' => $attributes['price_prefix'],
					'price' => $attributes['options_values_price'],
					'orders_products_attributes_id' => $attributes['orders_products_attributes_id']);
            $subindex++;
          }
        }
        $index++;
      }
    }

  //end Order Editor
	function create_invoice($order_id) {
		$counter=0;
		while ( ($this->billing['invoice_number']==0) && ($counter<5) ) {

			$max_query = tep_db_query("SELECT MAX(invoice_number) AS invoice FROM ". TABLE_ORDERS);
			$max_invoice = tep_db_fetch_array($max_query);
			tep_db_query("UPDATE ". TABLE_ORDERS . " SET invoice_serial = '".INVOICE_SERIAL."', invoice_number = '".($max_invoice['invoice']+1)."' WHERE orders_id = '" . (int)$order_id . "'");
			// Check to avoid multiple admins generating the same invoice number for different invoices (MyISAM type tables don't support transactions)
			$new_invoice_number_query = tep_db_query("SELECT COUNT(*) AS rows FROM ". TABLE_ORDERS . " WHERE invoice_number='".($max_invoice['invoice']+1)."'");
			$num_invoice = tep_db_fetch_array($new_invoice_number_query);
			if ( 1 == $num_invoice['rows'] ) {
				// OK
				$this->billing['invoice_serial'] = INVOICE_SERIAL;
				$this->billing['invoice_number'] = $max_invoice['invoice']+1;
			} else {
				// More than one invoice has this very same number. Undo
				tep_db_query("update ". TABLE_ORDERS . " set invoice_number='0' where orders_id = '" . (int)$order_id . "'");
			}
			$counter++;
		}
	}
  }
?>