<?php


	function tep_get_stamp_images(){
		$sql = "SELECT * FROM `image_stamp` WHERE status = 'active' ORDER BY image_id DESC";
		$image_stamp_query = tep_db_query($sql);

		if ( !tep_db_num_rows($image_stamp_query) ) return false;

		$return_array = array();
		array_push($return_array, array('id' => 0, 'text' => TEXT_NONE));
		while ( $image_stamp_row = tep_db_fetch_array($image_stamp_query)) {
     		 array_push($return_array,
     		 	array('id' => $image_stamp_row['image_id'], 'text' => $image_stamp_row['stamp_image'])
     		 	);
		}
		return $return_array;
	}

	function tep_get_saved_options() {
		$saved_options_query_sql = "SELECT * FROM image_stamp_saved_options";
		$saved_options_query = tep_db_query($saved_options_query_sql);

		if ( !tep_db_num_rows($saved_options_query) ) {
			return "NO OPTIONS";
			//return false;
		}
		$return_array = array();
		while ( $saved_options = tep_db_fetch_array($saved_options_query)) {
			array_push($return_array, $saved_options);
		}
		return $return_array;

	}

	function tep_get_saved_options_array() {
		$saved_options_query_sql = "SELECT * FROM image_stamp_saved_options";
		$saved_options_query = tep_db_query($saved_options_query_sql);

		$return_array = array();
		if ( !tep_db_num_rows($saved_options_query) ) return false;

		array_push($return_array,
     		 	array('id' => '0', 'text' => '--none--')
     		 	);
		while ( $saved_options = tep_db_fetch_array($saved_options_query)) {
			array_push($return_array,
     		 	array('id' => $saved_options['image_stamp_saved_options_id'], 'text' => $saved_options['image_stamp_saved_options_title'])
     		 	);
		}
		return $return_array;

	}

	function tep_save_options($title, $description, $options) {
		$save_options_query_sql = "
		INSERT INTO image_stamp_saved_options
		(
			image_stamp_saved_options_title,
			image_stamp_saved_options_description,
			image_stamp_saved_options
		)
		VALUES
		(
			'$title',
			'$description',
			'$options'
		)
		";
		if ( tep_db_query($save_options_query_sql) ) {
			return true;
		} else {
			return false;
		}
	}

	function tep_delete_saved_option($option_id) {
		$sql = "DELETE FROM image_stamp_saved_options WHERE image_stamp_saved_options_id = '$option_id' LIMIT 1";
		return tep_db_query($sql);
	}


	function tep_insert_stamp_image($image, $status = 'active'){
		switch($status){
			case 'active':
				$status = 'active';
			break;

			case 'inactive':
				$status = 'inactive';
			break;
			default:
				$status = 'inactive';
			break;

		}
		$sql = "INSERT INTO `image_stamp`
				(
					`stamp_image`,
					`status`
				)
			VALUES
				(
					'$image',
					'$status'
				)
			";
		return tep_db_query($sql);
	}

	function tep_convert_options_string_to_array($options_string) {

	}


	function tep_convert_options_string_readable_string_array($options_string) {

		$options = explode(':', $options_string);

		if ( true == is_array($options) ) {
			$return_array = array();
			foreach ( $options as $option ) {
				list($opt, $val) = explode('-', $option);
				switch ( $opt ) {
					case 'L':
						if ( 'WT' == $val ) {
							$return_array['Layer'] = 'Watermark on Top';
						} else {
							$return_array['Layer'] = 'Watermark Under';
						}
					break;
					case 'P':
						switch ( $val ) {
							case 'RC':
								$return_array['Position'] = 'Right-Center';
							break;
							case 'RT':
								$return_array['Position'] = 'Right-Top';
							break;
							case 'RB':
								$return_array['Position'] = 'Right-Bottom';
							break;
							case 'LC':
								$return_array['Position'] = 'Left-Center';
							break;
							case 'LT':
								$return_array['Position'] = 'Left-Top';
							break;
							case 'LB':
								$return_array['Position'] = 'Left-Bottom';
							break;
							case 'CT':
								$return_array['Position'] = 'Center-Top';
							break;
							case 'CB':
								$return_array['Position'] = 'Center-Bottom';
							break;
							case 'CA':
								$return_array['Position'] = 'Center-Absolute';
							break;
						}
					break;

					case 'PX':
						$return_array['Position custom X'] = $val;
					break;

					case 'PY':
						$return_array['Position custom Y'] = $val;
					break;
				}
			}

		} else {
			return false;
		}

		return $return_array;

	}


	function tep_get_image_and_image_stamp_by_attribute_id($attribute_id){
		$sql = "SELECT products_attributes_image, products_attributes_image_stamp FROM products_attributes WHERE products_attributes_id = '$attribute_id' LIMIT 1";
		$image_stamp_query = tep_db_query($sql);
		$image_stamp = tep_db_fetch_array($image_stamp_query);
		return $image_stamp;
	}



	function tep_get_stamp_image_by_id($image_id){
		$sql = "SELECT stamp_image FROM `image_stamp` WHERE image_id = '$image_id' LIMIT 1";
		$image_stamp_query = tep_db_query($sql);
		$image_stamp = tep_db_fetch_array($image_stamp_query);
		return $image_stamp['stamp_image'];
	}



	function tep_get_stamp_image_options_string_by_id($options_id){
		$sql = "SELECT image_stamp_saved_options FROM `image_stamp_saved_options` WHERE image_stamp_saved_options_id = '$options_id' LIMIT 1";
		$image_stamp_query = tep_db_query($sql);
		$image_stamp = tep_db_fetch_array($image_stamp_query);
		return $image_stamp['image_stamp_saved_options'];
	}

	function tep_get_stamp_image_options_id_by_options_string($options_string){
		$sql = "SELECT image_stamp_saved_options_id FROM `image_stamp_saved_options` WHERE image_stamp_saved_options = '$options_string' LIMIT 1";
		$image_stamp_query = tep_db_query($sql);
		$image_stamp = tep_db_fetch_array($image_stamp_query);
		return $image_stamp['image_stamp_saved_options_id'];
	}

	function tep_delete_stamp_image($image_stamp_id) {
		$image = tep_get_stamp_image_by_id($image_stamp_id);
			if ( false === empty($image) ) {
				$sql = "DELETE FROM `image_stamp` WHERE image_id = '$image_stamp_id' LIMIT 1";
				$image_stamp_query = tep_db_query($sql);
				if ($image_stamp_query) {
					if( true === is_file(DIR_WS_CATALOG_IMAGES . $image) ) {
						return @unlink(DIR_WS_CATALOG_IMAGES . $image);
					}
				} else {
					return false;
				}
			} else {
				return false;
			}
	}

	function tep_stamp_image_clean_up($image_stamp_id) {
		$image = tep_get_stamp_image_by_id($image_stamp_id);
			if ( false === file_exists(DIR_WS_CATALOG_IMAGES . $image) ) {
				$sql = "DELETE FROM `image_stamp` WHERE image_id = '$image_stamp_id' LIMIT 1";
				$image_stamp_query = tep_db_query($sql);
			}
	}

	function tep_get_stamp_id_by_image($stamp_image){
		$sql = "SELECT image_id FROM `image_stamp` WHERE stamp_image = '$stamp_image' LIMIT 1";
		$image_stamp_query = tep_db_query($sql);
		$image_stamp = tep_db_fetch_array($image_stamp_query);
		return $image_stamp['image_id'];
	}

	function tep_generate_stamp_image_name($image) {
		$image_chunks = explode('/', $image);
		foreach ( $image_chunks as $i_chunk ) {
			if ( $i_chunk !== end($image_chunks) ) {
				$out_folder .= $i_chunk . '/';
			} else {
				list($tmp_n, $tmp_x) = explode('.',$i_chunk);
				$out_filename = IMG_STAMP_FILENAME_PREFIX . $tmp_n.'.jpg';
			}
		}
		return $out_folder.$out_filename;
	}

	function tep_touch_products_image($products_id) {
		if ( false == is_numeric($products_id) ) {
			return false;
		}
		$image_query_sql = "
			SELECT
				products_image,
				products_image_stamp
			FROM
				".TABLE_PRODUCTS."
			WHERE
				products_id = '$products_id'
			LIMIT 1
		";
		### Get watermark layering option value - to pas it to: generate_imagestamped_name
		list($stamp_image, $stamp_image_options) = explode('|', $image['products_image_stamp']);
		$options = explode(':', $stamp_image_options);
		if( true === is_array($options) ) {
			foreach ( $options as $option ) {
				list($opt, $val) = explode('-', $option);
				if ( 'L' == $opt ) { #layer
					$stamp_image_layering = $val;
				}
			}
		}
		### ~


		$image_query = tep_db_query($image_query_sql);
		$image = tep_db_fetch_array($image_query);
		$image_chk = generate_imagestamped_name($image['products_image'], $image['products_image_stamp'], $stamp_image_layering);

		$the_file = DIR_WS_CATALOG_IMAGES.$image_chk;
		if ( true == file_exists($the_file) ){
			touch($the_file);
			return true;
		} else {
			return false;
		}
	}

	function tep_touch_image_stamp($image) {
		if ( true == empty($image) ) {
			return false;
		}

		list($image, $image_opts) = explode('|', $image);

		if ( true === file_exists($image) ) {
			return touch($image);

		} elseif ( true === file_exists(DIR_WS_CATALOG_IMAGES . $image) ) {
			return touch(DIR_WS_CATALOG_IMAGES . $image);
		} else {
			return false;
		}

	}


?>