<?php
	define('FPDF_FONTPATH', 'includes/fpdf/font/');
	require_once ( 'includes/fpdf/fpdf.php' );
	require_once ( 'includes/application_top.php' );
	require_once ( DIR_WS_LANGUAGES . $language . '/' . FILENAME_ORDERS_PACKINGSLIP );
	require_once ( DIR_WS_CLASSES . 'currencies.php' );
	$currencies = new currencies();
	include_once ( DIR_WS_CLASSES . 'order.php' );

	$oID = tep_db_input($_GET['oID']);
	$oID = (int)$oID;
	$order = new order($oID);
	$order->create_invoice($oID);
	$invoice_number = $order->billing['invoice_serial'] . $order->billing['invoice_number'];

class PDF extends FPDF {
	//Page header
	function RoundedRect($x, $y, $w, $h, $r, $style = '') {
		$k = $this->k;
		$hp = $this->h;
		if ( 'F' == $style ) {
			$op = 'f';
		} elseif ( 'FD' == $style || 'DF' == $style ) {
			$op = 'B';
		} else {
			$op = 'S';
		}
		$MyArc = 4/3 * (sqrt(2) - 1);
		$this->_out(sprintf('%.2f %.2f m', ($x+$r)*$k, ($hp-$y)*$k ));
		$xc = $x + $w - $r;
		$yc = $y + $r;
		$this->_out(sprintf('%.2f %.2f l', $xc*$k, ($hp-$y)*$k ));
		$this->_Arc($xc + $r*$MyArc, $yc - $r, $xc + $r, $yc - $r*$MyArc, $xc + $r, $yc);
		$xc = $x + $w - $r;
		$yc = $y + $h - $r;
		$this->_out(sprintf('%.2f %.2f l', ($x+$w)*$k, ($hp-$yc)*$k));
		$this->_Arc($xc + $r, $yc + $r*$MyArc, $xc + $r*$MyArc, $yc + $r, $xc, $yc + $r);
		$xc = $x + $r;
		$yc = $y + $h - $r;
		$this->_out(sprintf('%.2f %.2f l', $xc*$k, ($hp-($y+$h))*$k));
		$this->_Arc($xc - $r*$MyArc, $yc + $r, $xc - $r, $yc + $r*$MyArc, $xc - $r, $yc);
		$xc = $x + $r;
		$yc = $y + $r;
		$this->_out(sprintf('%.2f %.2f l', ($x)*$k, ($hp-$yc)*$k ));
		$this->_Arc($xc - $r, $yc - $r*$MyArc, $xc - $r*$MyArc, $yc - $r, $xc, $yc - $r);
		$this->_out($op);
    }

    function _Arc($x1, $y1, $x2, $y2, $x3, $y3) {
		$h = $this->h;
		$this->_out(sprintf('%.2f %.2f %.2f %.2f %.2f %.2f c ', $x1*$this->k, ($h-$y1)*$this->k,
		    $x2*$this->k, ($h-$y2)*$this->k, $x3*$this->k, ($h-$y3)*$this->k));
    }

function Header() {
	global $oID, $invoice_number;
	$date = strftime('%A, %d %B %Y');

	$this->Image('images/logo_print.gif', 5, 15, 50);

    // Invoice Number and date
	$this->SetFont('Arial', 'B', 9);
	$this->SetTextColor(0, 0, 0);
	$this->SetY(37);
	$this->MultiCell(100, 5, ENTRY_INVOICE_NUM . $invoice_number . "\n" . $date , 0, 'L');

	// Company Address
	$this->SetX(0);
	$this->SetY(20);
    $this->SetFont('Arial', 'B', 10);
    $this->SetTextColor(200, 0, 0);

    $this->Ln(0);
    $this->Cell(149);
	$this->MultiCell(50, 3.5, STORE_NAME_ADDRESS, 0, 'L');

	//email
	$this->SetX(0);
	$this->SetY(37);
	$this->SetFont('Arial', '', 10);
	$this->SetTextColor(158, 11, 14);
	$this->Ln(0);
    $this->Cell(90);
	$this->MultiCell(100, 5, ENTRY_EMAIL_TITLE . ' ' . STORE_OWNER_EMAIL_ADDRESS . "\n" . ENTRY_WEB_TITLE . ' ' .  HTTP_SERVER, 0, 'R');
}

function Footer() {
    //Position at 1.5 cm from bottom
    $this->SetY(-25);
    $this->SetFont('Arial', '', 10);
	$this->SetTextColor(158, 11, 14);
	$this->Cell(0, 10, sprintf(ENTRY_INVOICE_TEXT, STORE_NAME), 0, 0, 'C');
	$this->SetY(-15);
	}
}

//Instanciation of inherited class
$pdf = new PDF('P', 'mm');

// Set the Page Margins
$pdf->SetMargins(6, 2, 6);

// Add the first page
$pdf->AddPage();

//Draw the top line with invoice text
$pdf->Cell(50);
$pdf->SetY(60);
$pdf->SetDrawColor(153, 153, 153);
$pdf->Cell(15, .1, '', 1, 1, 'L', 1);
$pdf->SetFont('Arial', 'BI', 15);
$pdf->SetTextColor(153, 153, 153);
$pdf->Text(22, 61.5, ENTRY_PACKINGSLIP_TITLE);
$pdf->SetY(60);
$pdf->SetDrawColor(153, 153, 153);
$pdf->Cell(49);
$pdf->Cell(150, .1, '', 1, 1, 'L', 1);

//Draw Box for Invoice Address
$pdf->SetDrawColor(0);
$pdf->SetLineWidth(0.2);
$pdf->SetFillColor(245);
$pdf->RoundedRect(6, 67, 90, 35, 2, 'DF');

//Draw the invoice address text
$pdf->SetFont('Arial', 'B', 10);
$pdf->SetTextColor(0);
$pdf->Text(11, 77, strtoupper(ENTRY_SHIP_TO));
$pdf->SetX(0);
$pdf->SetY(80);
$pdf->Cell(9);
$pdf->MultiCell(70, 3.3, tep_address_format(1, $order->delivery, '', '', "\n"), 0, 'L');


//Draw Box for Order Number, Date & Payment method
$pdf->SetDrawColor(0);
$pdf->SetLineWidth(0.2);
$pdf->SetFillColor(245);
$pdf->RoundedRect(6, 107, 192, 11, 2, 'DF');

//Draw Order Number Text
$pdf->Text(10, 113, ENTRY_INVOICE_ORDER . tep_db_input($oID));
//Draw Date of Order Text
$pdf->Text(165, 113, ENTRY_INVOICE_DATE . ' ' . tep_date_short($order->info['date_purchased']));

//Fields Name position
$Y_Fields_Name_position = 125;
//Table position, under Fields Name
$Y_Table_Position = 131;


function output_table_heading($Y_Fields_Name_position) {
	global $pdf;
	//First create each Field Name
	//Gray color filling each Field Name box
	$pdf->SetFillColor(245);
	//Bold Font for Field Name
	$pdf->SetFont('Arial', 'B', 10);
	$pdf->SetY($Y_Fields_Name_position);
	$pdf->SetX(6);
	$pdf->Cell(09, 6, TABLE_HEADING_QUANTITY, 1, 0, 'C', 1);
	$pdf->SetX(15);
	$pdf->Cell(27, 6, TABLE_HEADING_PRODUCTS_MODEL, 1, 0, 'C', 1);
	$pdf->SetX(40);
	$pdf->Cell(165, 6, TABLE_HEADING_PRODUCTS, 1, 0, 'C', 1);
	$pdf->Ln();
}
output_table_heading($Y_Fields_Name_position);
//Show the products information line by line
for ($i = 0, $n = sizeof($order->products); $i < $n; $i++) {
	$pdf->SetFont('Arial', '', 10);
	$pdf->SetY($Y_Table_Position);
	$pdf->SetX(6);
	$pdf->MultiCell(9, 6, $order->products[$i]['qty'], 1, 'C');
	$pdf->SetY($Y_Table_Position);
	$pdf->SetX(40);
	if (strlen($order->products[$i]['name']) > 40 && strlen($order->products[$i]['name']) < 100){
		$pdf->SetFont('Arial', '', 8);
		$pdf->MultiCell(165, 6, $order->products[$i]['name'], 1, 'L');
	} else if (strlen($order->products[$i]['name']) > 100){
		$pdf->SetFont('Arial', '', 8);
		$pdf->MultiCell(165, 6, substr($order->products[$i]['name'], 0, 100), 1, 'L');
	} else {
		$pdf->MultiCell(165, 6, $order->products[$i]['name'], 1, 'L');
	}

	$pdf->SetFont('Arial', '', 10);
	$pdf->SetY($Y_Table_Position);
	$pdf->SetX(15);
    $pdf->SetFont('Arial', '', 8);
	$pdf->MultiCell(25, 6, $order->products[$i]['model'], 1, 'C');

	$Y_Table_Position += 6;

	//get attribs
    if ( (isset($order->products[$i]['attributes'])) && (sizeof($order->products[$i]['attributes']) > 0) ) {
        for ($j=0, $n2=sizeof($order->products[$i]['attributes']); $j<$n2; $j++) {
	      $pdf->SetY($Y_Table_Position);
	      $pdf->SetX(40);
	      $pdf->SetFont( 'Arial', 'I', 8);
    	  if (strlen(" - " .$order->products[$i]['attributes'][$j]['option'] . ': ' . $order->products[$i]['attributes'][$j]['value'] )> 40 && strlen(" - " .$order->products[$i]['attributes'][$j]['option'] . ': ' . $order->products[$i]['attributes'][$j]['value']) < 100){
		    $pdf->MultiCell(165, 6, " - " .$order->products[$i]['attributes'][$j]['option'] . ': ' . $order->products[$i]['attributes'][$j]['value'], 1, 'L', '1');
    	  } else if (strlen(" - " .$order->products[$i]['attributes'][$j]['option'] . ': ' . $order->products[$i]['attributes'][$j]['value']) > 100){
		    $pdf->MultiCell(165, 6, substr(" - " .$order->products[$i]['attributes'][$j]['option'] . ': ' . $order->products[$i]['attributes'][$j]['value'], 0, 100), 1, 'L', '1');
    	  } else {
		    $pdf->MultiCell(165, 6, " - " .$order->products[$i]['attributes'][$j]['option'] . ': ' . $order->products[$i]['attributes'][$j]['value'], 1, 'L', '1');
    	  }

          $Y_Table_Position += 6;

          //Check for product line overflow
          $item_count++;
	      if ( $item_count > 20 ) {
             $pdf->AddPage();
             //Fields Name position
             $Y_Fields_Name_position = 125;
             //Table position, under Fields Name
             $Y_Table_Position = 70;
             output_table_heading($Y_Table_Position-6);
             $item_count = 1;
             $pdf->SetTextColor(255, 255, 255);
             $pdf->SetFillColor(255, 190, 183);
             $pdf->SetDrawColor(229, 238, 255);
          }
        }
    }
    $Y_Table_Position += 1;

    //Check for product line overflow
     $item_count++;
    if ((is_long($item_count / 32) && $i >= 20) || ($i == 20)){
		$pdf->AddPage();
		//Fields Name position
		$Y_Fields_Name_position = 125;
		//Table position, under Fields Name
		$Y_Table_Position = 70;
		output_table_heading($Y_Table_Position-6);
		if ($i == 20) $item_count = 1;
    }
}

	// PDF's created now output the file
	if ( 'download' == $_GET['action'] ) {
		$pdf->Output('packingslip-'.$invoice_number.'.pdf', 'D');
	} else {
		$pdf->Output();
	}
?>