<?php
	require_once ( 'includes/application_top.php' );


	$tID = ( false === empty($_GET['tID']) ? $_GET['tID'] : CURRENT_TEMPLATE );

	function getAvailableTemplates() {
		if ( true === is_dir(SMARTY_TEMPLATES_DIR) ) {
	  		if ($dh = opendir(SMARTY_TEMPLATES_DIR)) {
	  			$template_config_array = array();
	  			while (($file = readdir($dh)) !== false) {
	  				$dir = SMARTY_TEMPLATES_DIR . $file;
	  				if ( '..' != basename($dir) && '.' != basename($dir) && '.svn' != basename($dir) && 'dir' == filetype($dir) ) {
						$base_dir = basename($dir);
						if ($tpl_dh = opendir($dir)) {
							while (($tpl_file = readdir($tpl_dh)) !== false) {
								$template_file = $dir . '/' . $tpl_file;
								if ( 'tpl_info.cfg' === basename($template_file) && 'file' == filetype($template_file) ) {
									if ( true === is_readable($template_file) ) {
										$handle = fopen($template_file, "r");
										$contents = fread($handle, filesize($template_file));
										fclose($handle);
										$lines = preg_split("/(\r\n|\r|\n)/", $contents);
										foreach ( $lines as $line ) {
											$line = trim($line);
											if ( '#' != substr($line, 0, 1) && false === empty($line) ) {
												list($param, $val) = explode('=', $line);
												$param = trim($param);
												$val = trim($val);
												$template_config_array[$base_dir][$param] = $val;
											}
										}
									}
								}
							}
						}
	  				}
	  			}
	  		}
		}
		return $template_config_array;
	}

	function installTemplate($template_id) {
		global $messageStack;
		if ( true === empty($template_id) ) {
			$messageStack->add_session('Error: template id is empty', 'error');
			return false;
		}
		$sql_install_template = "
							UPDATE
								" . TABLE_CONFIGURATION . "
							SET
								configuration_value = '$template_id'
							WHERE
								configuration_key = 'CURRENT_TEMPLATE'";
		$installed = tep_db_query($sql_install_template);
		if ( $installed ) {
			require_once ( SMARTY_DIR.'Smarty.class.php' );
			$smarty = new Smarty;
			$smarty->compile_dir = DIR_FS_CATALOG.'templates_c';
			$smarty->cache_dir = DIR_FS_CATALOG.'cache';
			$smarty->clear_compiled_tpl();
			$smarty->clear_all_cache();
			$messageStack->add_session(sprintf(MSG_SUCCESS_INSTALLED, $template_id), 'success');
		}
	}

	$template_config_array = getAvailableTemplates();

	$action = (isset($_GET['action']) ? $_GET['action'] : '' );
		if (tep_not_null($action)) {
			switch ($action) {
				case 'installconfirm':
					installTemplate($_POST['template_id']);
					tep_redirect(tep_href_link(FILENAME_TEMPLATES,'tID='.$_POST['template_id']));
				break;
			}
		}
?>
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
<html <?php echo HTML_PARAMS; ?>>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo CHARSET; ?>">
<title><?php echo TITLE; ?></title>
<link rel="stylesheet" type="text/css" href="includes/stylesheet.css">
<script src="includes/javascript/prototype.js" type="text/javascript"></script>
<script src="includes/javascript/general.js" type="text/javascript"></script>
</head>
<body marginwidth="0" marginheight="0" topmargin="0" bottommargin="0" leftmargin="0" rightmargin="0" bgcolor="#FFFFFF" onload="SetFocus();">

<?php require_once ( DIR_WS_INCLUDES . 'header.php' ); ?>

<h1 class="pageHeading"><?php echo HEADING_TITLE; ?></h1>

<table border="0" width="100%" cellspacing="2" cellpadding="2">
  <tr>
    <td width="100%" valign="top"><table border="0" width="100%" cellspacing="0" cellpadding="2">
      <tr>
        <td valign="top"><table border="0" width="100%" cellspacing="0" cellpadding="2">
              <tr class="dataTableHeadingRow">
                <td class="dataTableHeadingContent"><?php echo TABLE_HEADING_TEMPLATE_NAME; ?></td>
                <td class="dataTableHeadingContent"><?php echo TABLE_HEADING_AUTHOR_NAME; ?></td>
                <td class="dataTableHeadingContent"><?php echo TABLE_HEADING_AUTHOR_WEBSITE; ?></td>
                <td class="dataTableHeadingContent" align="right"><?php echo TABLE_HEADING_ACTION; ?>&nbsp;</td>
              </tr>
<?php
	if ( true === is_array($template_config_array) ) {
		foreach ( $template_config_array as $template_dir_name => $template_config ) {

			if ( $template_dir_name == $tID ) {
				$current_template_info = $template_config;
				$onclick = ( CURRENT_TEMPLATE != $tID ?  'onclick="document.location.href=\'' . tep_href_link(FILENAME_TEMPLATES, '&tID=' . $template_dir_name . '&action=set') . '\'"' : '' );
				echo '<tr id="defaultSelected" class="dataTableRowSelected" onmouseover="rowOverEffect(this)" onmouseout="rowOutEffect(this)"'.$onclick.'>' . "\n";
			} else {
				echo '<tr class="dataTableRow" onmouseover="rowOverEffect(this)" onmouseout="rowOutEffect(this)" onclick="document.location.href=\'' . tep_href_link(FILENAME_TEMPLATES, '&tID=' . $template_dir_name) . '\'">' . "\n";
			}
?>
			<td class="dataTableContent"><?php echo ( false === empty($template_config['name']) ? $template_config['name'] : 'N/A' ); ?></td>
			<td class="dataTableContent"><?php echo ( false === empty($template_config['author']) ? $template_config['author'] : 'N/A' ); ?></td>
			<td class="dataTableContent"><?php echo ( false === empty($template_config['author_website']) ? $template_config['author_website'] : 'N/A' ); ?></td>
			<td class="dataTableContent" align="right">
			<?php echo ( CURRENT_TEMPLATE == $template_dir_name ? TEMPLATE_INSTALLED : '' );?>
			<?php if ( $template_dir_name == $tID ) { echo tep_image(DIR_WS_ICONS . 'icon_arrow_right.png' ); } else { echo '<a href="' . tep_href_link(FILENAME_TEMPLATES, '&tID=' . $template_dir_name) . '">' . tep_image(DIR_WS_IMAGES . 'icon_info.gif', IMAGE_ICON_INFO) . '</a>'; } ?>&nbsp;</td>
		</tr>
<?php
		}
	}
?>
            </table></td>
<?php
  $heading = array();
  $contents = array();

  switch ($action) {
    case 'set':
      $heading[] = array('text' => '<b>' . TEXT_INFO_HEADING_INSTALL_TEMPLATE . '</b>' );

      $contents = array('form' => tep_draw_form('template', FILENAME_TEMPLATES, '&tID=' . $_GET['tID'] . '&action=installconfirm'));
      $contents[] = array('text' => sprintf(TEXT_INFO_INSTALL_TEMPLATE, $current_template_info['name']));
      $contents[] = array('text' => tep_draw_hidden_field('template_id', $_GET['tID']));
      $contents[] = array('align' => 'center', 'text' => '<br />' . tep_image_submit('button_confirm.gif', IMAGE_INSERT) . ' <a href="' . tep_href_link(FILENAME_TEMPLATES, '&tID=' . $_GET['tID']) . '">' . tep_image_button('button_cancel.gif', IMAGE_CANCEL) . '</a>' );
      break;
    default:
      if ( true === is_array($current_template_info)) {
        $heading[] = array('text' => ( CURRENT_TEMPLATE == $_GET['tID'] ? TABLE_HEADING_TEMPLATE_INSTALLED : TABLE_HEADING_TEMPLATE ) );
        if ( false === empty($current_template_info['name']) ) {
        	$contents[] = array('text' => '<strong>' . TABLE_HEADING_TEMPLATE_NAME . '</strong><br />'.$current_template_info['name'] );
        }
        if ( false === empty($current_template_info['screenshot']) ) {
        	$contents[] = array('text' => '<strong>' . TABLE_HEADING_TEMPLATE_SCREENSHOT . '</strong><br /><a href="../templates/'.$tID.'/'.$current_template_info['screenshot'].'" target="_blank">'.tep_image('../templates/'.$tID.'/'.$current_template_info['screenshot'], TABLE_HEADING_TEMPLATE_SCREENSHOT, '220', '220') );
        }
        if ( false === empty($current_template_info['author']) ) {
        	$contents[] = array('text' => '<strong>' . TABLE_HEADING_AUTHOR_NAME . '</strong><br />'.$current_template_info['author'] );
        }
        if ( false === empty($current_template_info['author_website']) ) {
        	$contents[] = array('text' => '<strong>' . TABLE_HEADING_AUTHOR_WEBSITE . '</strong><br /><a href="'.$current_template_info['author_website'].'">'.$current_template_info['author_website'].'</a>' );
        }
        if ( false === empty($current_template_info['author_email']) ) {
        	$contents[] = array('text' => '<strong>' . TABLE_HEADING_AUTHOR_EMAIL . '</strong><br /><a href="mailto:'.$current_template_info['author_email'].'?subject=Template:'.$current_template_info['name'].'">'.$current_template_info['author_email'].'</a>' );
        }
        if ( false === empty($current_template_info['copyright']) ) {
        	$contents[] = array('text' => '<strong>' . TABLE_HEADING_COPYRIGHT . '</strong><br />'.$current_template_info['copyright'] );
        }



        if ( CURRENT_TEMPLATE != $_GET['tID'] ) {
        	$contents[] = array('align' => 'center', 'text' => '<br /><a href="' . tep_href_link(FILENAME_TEMPLATES, '&tID=' . $_GET['tID'] .'&action=set') . '">' . tep_image_button('button_module_install.gif', IMAGE_INSTALL) . '</a>' );
        }
        }
      break;
  }

  if ( (tep_not_null($heading)) && (tep_not_null($contents)) ) {
    echo '            <td width="25%" valign="top">' . "\n";

    $box = new box;
    echo $box->infoBox($heading, $contents);

    echo '            </td>' . "\n";
  }
?>
		</td>
      </tr>
    </table></td>

  </tr>
</table>


<?php require_once ( DIR_WS_INCLUDES . 'footer.php' ); ?>

<br />
</body>
</html>
<?php require_once ( DIR_WS_INCLUDES . 'application_bottom.php' ); ?>
