<?php
	require_once ( 'includes/application_top.php' );
	@include_once ( DIR_WS_LANGUAGES . $language . '/' . FILENAME_AFFILIATE_SUMMARY );
	if ( true !== tep_session_is_registered('affiliate_id') ) {
		$navigation->set_snapshot();
		$messageStack->add_session('login', sprintf(TEXT_LOGIN_FIRST, tep_href_link(FILENAME_AFFILIATE_CREATE_ACCOUNT)), 'success');
		tep_redirect(tep_href_link(FILENAME_AFFILIATE_LOGIN, '', 'SSL'));
	}

	$breadcrumb->add(NAVBAR_TITLE);
	$affiliate = array();
	$affiliate_banner_history_query = tep_db_query("SELECT sum(affiliate_banners_shown) AS impressions FROM " . TABLE_AFFILIATE_BANNERS_HISTORY .  " WHERE affiliate_banners_affiliate_id  = '$affiliate_id'");
	if ( 0 < tep_db_num_rows($affiliate_banner_history_query) ) {
		$affiliate_banner_history = tep_db_fetch_array($affiliate_banner_history_query);
		$affiliate['impressions'] = ( 0 < $affiliate_banner_history['impressions'] ? $affiliate_banner_history['impressions'] : TEXT_NA);
	}
	$affiliate_clickthroughs_query = tep_db_query("SELECT count(*) AS clickthroughs FROM " . TABLE_AFFILIATE_CLICKTHROUGHS . " WHERE affiliate_id = '$affiliate_id'");
	if ( 0 < tep_db_num_rows($affiliate_clickthroughs_query) ) {
		$affiliate_clickthroughs = tep_db_fetch_array($affiliate_clickthroughs_query);
		$affiliate['clickthroughs'] = ( 0 < $affiliate_clickthroughs['clickthroughs'] ? $affiliate_clickthroughs['clickthroughs'] : TEXT_NA);
	}
	$affiliate_sales_query_sql = "
							SELECT
  								count(*) AS transactions,
  								sum(affiliate_value) as total,
  								sum(affiliate_payment) as commission
  							FROM
  								" . TABLE_AFFILIATE_SALES . " a
  								LEFT JOIN " . TABLE_ORDERS . " o
  									ON (a.affiliate_orders_id = o.orders_id)
  							WHERE
  								a.affiliate_id = '$affiliate_id'
  								and o.orders_status >= " . AFFILIATE_PAYMENT_ORDER_MIN_STATUS;
	$affiliate_sales_query = tep_db_query($affiliate_sales_query_sql);
	if ( 0 < tep_db_num_rows($affiliate_sales_query) ) {
		$affiliate_sales = tep_db_fetch_array($affiliate_sales_query);
		$affiliate['conversions'] = ( $affiliate['clickthroughs'] > 0 ? tep_round(($affiliate_sales['transactions'] / $affiliate['clickthroughs'])*100, 2) . "%" : TEXT_NA );
		$affiliate['average'] = ( $affiliate_sales['transactions'] > 0 ? tep_round($affiliate_sales['total'] / $affiliate_sales['transactions'], 2) : TEXT_NA );
		$affiliate['total'] = $currencies->display_price($affiliate_sales['total'], '');
		$affiliate['transactions'] = $affiliate_sales['transactions'];

	}
	$affiliate_values_query = tep_db_query("SELECT * FROM " . TABLE_AFFILIATES . " WHERE affiliate_id = '$affiliate_id'");
	if ( 0 < tep_db_num_rows($affiliate_sales_query) ) {
		$affiliate_values = tep_db_fetch_array($affiliate_values_query);
		$affiliate['percent'] = ( $affiliate_values['affiliate_commission_percent'] < AFFILIATE_PERCENT ? AFFILIATE_PERCENT : $affiliate_values['affiliate_commission_percent'] );
		$affiliate['full_name'] = $affiliate_values['affiliate_firstname'] . ' ' . $affiliate_values['affiliate_lastname'];
		$affiliate['affiliate_id'] = $affiliate_values['affiliate_id'];
	}
	$affiliate['pay_per_click'] = $currencies->display_price(AFFILIATE_PAY_PER_CLICK, '');
	$affiliate['payment'] = $currencies->display_price(AFFILIATE_PAYMENT, '');
	$affiliate['percent'] = tep_round($affiliate['percent'], 2). '%';
	$affiliate['commission'] = $currencies->display_price($affiliate_sales['commission'], '');
	$affiliate_news_query_sql = "
								SELECT
									nc.affiliate_news_headlines as headline,
									nc.affiliate_news_contents as content,
									n.date_added
								FROM
									" . TABLE_AFFILIATE_NEWS . " n,
									" . TABLE_AFFILIATE_NEWS_CONTENTS . " nc
								WHERE
									n.news_id = nc.affiliate_news_id
									AND nc.affiliate_news_languages_id = '$languages_id'
									AND n.news_status = '1'
									AND n.date_added >= ( CURRENT_DATE() - INTERVAL 1 DAY )
								ORDER BY
									n.date_added DESC";
	$affiliate_news_query = tep_db_query($affiliate_news_query_sql);
	if ( 0 < tep_db_num_rows($affiliate_news_query) ) {
		$affiliate_news = '';
		$affiliate_news_array = tep_db_fetch_array($affiliate_news_query);
		$affiliate_news .= '<a href="'.tep_href_link(FILENAME_AFFILIATE_NEWS).'">'."{$affiliate_news_array['headline']}</a> &mdash; <span style=\"font-size:0.8em;\">".tep_date_long($affiliate_news_array['date_added']).'</span>';
		$affiliate_news .= ( 1 < tep_db_num_rows($affiliate_news_query) ? '<br />' : '' );
		unset($affiliate_news_array);
		$messageStack->add('news', $affiliate_news, 'warning');
	}
	$smarty->assign('URL_AFFILIATE_ACCOUNT', tep_href_link(FILENAME_AFFILIATE_ACCOUNT, '', 'SSL'));
	$smarty->assign('URL_AFFILIATE_NEWSLETTERS', tep_href_link(FILENAME_AFFILIATE_NEWSLETTERS, '', 'SSL'));
	$smarty->assign('URL_AFFILIATE_PASSWORD', tep_href_link(FILENAME_AFFILIATE_PASSWORD, '', 'SSL'));
	$smarty->assign('URL_AFFILIATE_NEWS', tep_href_link(FILENAME_AFFILIATE_NEWS, '', 'SSL'));
	$smarty->assign('URL_AFFILIATE_LINKS', tep_href_link(FILENAME_AFFILIATE_LINKS, '', 'SSL'));
	$smarty->assign('URL_AFFILIATE_REPORTS', tep_href_link(FILENAME_AFFILIATE_REPORTS, '', 'SSL'));
	$smarty->assign('URL_AFFILIATE_CLICKS', tep_href_link(FILENAME_AFFILIATE_CLICKS, '', 'SSL'));
	$smarty->assign('URL_AFFILIATE_PAYMENT', tep_href_link(FILENAME_AFFILIATE_PAYMENT, '', 'SSL'));
	$smarty->assign('URL_AFFILIATE_SALES', tep_href_link(FILENAME_AFFILIATE_SALES, '', 'SSL'));
	$smarty->assign('affiliate', $affiliate);
	require_once ( DIR_WS_INCLUDES . 'meta_tags.php' );
	$smarty->assign('HEADER_TITLE', sprintf(HEADING_TITLE, $affiliate['full_name']));
	$smarty->assign('breadcrumb', $breadcrumb->_trail);
	$smarty->assign('messagestack', $messageStack->get_messages());
	$page_content = $smarty->fetch('affiliate_summary.tpl');
	$smarty->assign('page_content', $page_content);
	require_once ( DIR_WS_INCLUDES . 'application_bottom.php' );
	$smarty->display('common/page.tpl');
?>