<?php

	require_once ( 'includes/application_top.php' );
	require_once ( DIR_WS_LANGUAGES . $language . '/' . FILENAME_ARTICLES);
	// the following tPath references come from application_top.php
	$topic_depth = 'top';

	if (isset($tPath) && tep_not_null($tPath)) {
		$topics_articles_query = tep_db_query("select count(*) as total from " . TABLE_ARTICLES_TO_TOPICS . " where topics_id = '" . (int)$current_topic_id . "'");
		$topics_articles = tep_db_fetch_array($topics_articles_query);
		if ($topics_articles['total'] > 0) {
			$topic_depth = 'articles'; // display articles
		} else {
			$topic_parent_query = tep_db_query("select count(*) as total from " . TABLE_TOPICS . " where parent_id = '" . (int)$current_topic_id . "'");
			$topic_parent = tep_db_fetch_array($topic_parent_query);
			if ($topic_parent['total'] > 0) {
				$topic_depth = 'nested'; // navigate through the topics
			} else {
				$topic_depth = 'articles'; // topic has no articles, but display the 'no articles' message
			}
		}
	}


	if ($topic_depth == 'top' && !isset($_GET['authors_id'])) {
		$breadcrumb->add(NAVBAR_TITLE_DEFAULT, tep_href_link(FILENAME_ARTICLES));
	}


	$content = CONTENT_ARTICLES_MAIN;

	require_once ( DIR_WS_INCLUDES . 'meta_tags.php' );




	$smarty->assign('DISPLAY_AUTHOR_ARTICLE_LISTING', DISPLAY_AUTHOR_ARTICLE_LISTING);
	$smarty->assign('DISPLAY_TOPIC_ARTICLE_LISTING', DISPLAY_TOPIC_ARTICLE_LISTING);
	//$smarty->assign('DISPLAY_ABSTRACT_ARTICLE_LISTING', DISPLAY_ABSTRACT_ARTICLE_LISTING);
	$smarty->assign('DISPLAY_DATE_ADDED_ARTICLE_LISTING', DISPLAY_DATE_ADDED_ARTICLE_LISTING);
	$smarty->assign('DISPLAY_ABSTRACT_ARTICLE_LISTING', DISPLAY_ABSTRACT_ARTICLE_LISTING);

	$smarty->assign('TEXT_BY', TEXT_BY);
	$smarty->assign('TEXT_TOPIC', TEXT_TOPIC);
	$smarty->assign('TEXT_DATE_ADDED', TEXT_DATE_ADDED);
	$smarty->assign('TEXT_ARTICLES_BY', TEXT_ARTICLES_BY);



	if ( $topic_depth == 'nested' ) {
		$topic_query_sql = "
					SELECT
						td.topics_name,
						td.topics_heading_title,
						td.topics_description
					FROM
						" . TABLE_TOPICS . " t,
						" . TABLE_TOPICS_DESCRIPTION . " td
					WHERE
						t.topics_id = '" . (int)$current_topic_id . "'
						AND td.topics_id = '" . (int)$current_topic_id . "'
						AND td.language_id = '" . (int)$languages_id . "'";
	$topic_query = tep_db_query($topic_query_sql);
	$topic = tep_db_fetch_array($topic_query);

	if ( tep_not_null($topic['topics_heading_title']) ) {
		$smarty->assign('HEADER_TITLE', $topic['topics_heading_title']);
	} else {
		$smarty->assign('HEADER_TITLE', HEADING_TITLE);
	}

	$topic['image'] = tep_image(DIR_WS_IMAGES . $topic['topics_image'], $topic['topics_name'], HEADING_IMAGE_WIDTH, HEADING_IMAGE_HEIGHT);


	if (isset($tPath) && strpos('_', $tPath)) {
		// check to see if there are deeper topics within the current topic
		$topic_links = array_reverse($tPath_array);
		for( $i=0, $n=sizeof($topic_links); $i<$n; $i++ ) {
			$topics_query_sql = "
							SELECT
								a.articles_id
							FROM
								(" . TABLE_ARTICLES . " a, " . TABLE_ARTICLES_TO_TOPICS . " a2t)
							LEFT JOIN
								" . TABLE_TOPICS_DESCRIPTION . " td
								ON a2t.topics_id = td.topics_id
							LEFT JOIN
								" . TABLE_AUTHORS . " au
								ON a.authors_id = au.authors_id,
								" . TABLE_ARTICLES_DESCRIPTION . " ad
							WHERE (a.articles_date_available IS NULL or to_days(a.articles_date_available) <= to_days(now()))
							AND a.articles_id = a2t.articles_id
							AND a.articles_status = '1'
							AND a.articles_id = ad.articles_id
							AND ad.language_id = '1'
							AND td.language_id = '1'
							AND a.articles_date_added > SUBDATE(now(), INTERVAL '30' DAY ";
			$topics_query = tep_db_query($topics_query_sql);
			$topics = tep_db_fetch_array($topics_query);
			if ($topics['total'] > 1) {

				$topics_query_sql = "
        						SELECT
        							t.topics_id,
        							td.topics_name,
        							t.parent_id
        						FROM
        							" . TABLE_TOPICS . " t,
        							" . TABLE_TOPICS_DESCRIPTION . " td
        						WHERE
        							t.parent_id = '" . (int)$topic_links[$i] . "'
        							AND t.topics_id = td.topics_id
        							AND td.language_id = '" . (int)$languages_id . "'
        						ORDER BY
        							sort_order,
        							td.topics_name";
				$topics_query = tep_db_query($topics_query_sql);
				break; // we've found the deepest topic the customer is in
			}
		}
		} else {


			$topics_query_sql = "
							SELECT
								t.topics_id,
								td.topics_name,
								t.parent_id
							FROM
								" . TABLE_TOPICS . " t,
								" . TABLE_TOPICS_DESCRIPTION . " td
							WHERE
								t.parent_id = '" . (int)$current_topic_id . "'
								AND t.topics_id = td.topics_id
								AND td.language_id = '" . (int)$languages_id . "'
							ORDER BY
								sort_order,
								td.topics_name";
			$topics_query = tep_db_query($topics_query_sql);
		}



	} elseif ($topic_depth == 'articles' || isset($_GET['authors_id'])) {


	$topic_query_sql = "
					SELECT
						td.topics_name,
						td.topics_heading_title,
						td.topics_description
					FROM
						" . TABLE_TOPICS . " t,
						" . TABLE_TOPICS_DESCRIPTION . " td
					WHERE
						t.topics_id = '" . (int)$current_topic_id . "'
						AND td.topics_id = '" . (int)$current_topic_id . "'
						AND td.language_id = '" . (int)$languages_id . "'";
	$topic_query = tep_db_query($topic_query_sql);
	$topic = tep_db_fetch_array($topic_query);

	if (isset($_GET['authors_id'])) {
		if (isset($_GET['filter_id']) && tep_not_null($_GET['filter_id'])) {
			$listing_sql = "select a.articles_id, a.authors_id, a.articles_date_added, ad.articles_name, ad.articles_head_desc_tag, au.authors_name, td.topics_name, a2t.topics_id from (" . TABLE_ARTICLES . " a, " . TABLE_ARTICLES_DESCRIPTION . " ad) left join " . TABLE_AUTHORS . " au on a.authors_id = au.authors_id, " . TABLE_ARTICLES_TO_TOPICS . " a2t left join " . TABLE_TOPICS_DESCRIPTION . " td on a2t.topics_id = td.topics_id where (a.articles_date_available IS NULL or to_days(a.articles_date_available) <= to_days(now())) and a.articles_status = '1' and au.authors_id = '" . (int)$_GET['authors_id'] . "' and a.articles_id = a2t.articles_id and ad.articles_id = a2t.articles_id and ad.language_id = '" . (int)$languages_id . "' and td.language_id = '" . (int)$languages_id . "' and a2t.topics_id = '" . (int)$_GET['filter_id'] . "' order by a.sort_order, a.articles_date_added desc, ad.articles_name";
		} else {
			$listing_sql = "select a.articles_id, a.authors_id, a.articles_date_added, ad.articles_name, ad.articles_head_desc_tag, au.authors_name, td.topics_name, a2t.topics_id from (" . TABLE_ARTICLES . " a, " . TABLE_ARTICLES_DESCRIPTION . " ad) left join " . TABLE_AUTHORS . " au on a.authors_id = au.authors_id, " . TABLE_ARTICLES_TO_TOPICS . " a2t left join " . TABLE_TOPICS_DESCRIPTION . " td on a2t.topics_id = td.topics_id where (a.articles_date_available IS NULL or to_days(a.articles_date_available) <= to_days(now())) and a.articles_status = '1' and au.authors_id = '" . (int)$_GET['authors_id'] . "' and a.articles_id = a2t.articles_id and ad.articles_id = a2t.articles_id and ad.language_id = '" . (int)$languages_id . "' and td.language_id = '" . (int)$languages_id . "' order by a.sort_order,  a.articles_date_added desc, ad.articles_name";
		}
	} else {
		if (isset($_GET['filter_id']) && tep_not_null($_GET['filter_id'])) {
			$listing_sql = "select a.articles_id, a.authors_id, a.articles_date_added, ad.articles_name, ad.articles_head_desc_tag, au.authors_name, td.topics_name, a2t.topics_id from (" . TABLE_ARTICLES . " a, " . TABLE_ARTICLES_DESCRIPTION . " ad) left join " . TABLE_AUTHORS . " au on a.authors_id = au.authors_id, " . TABLE_ARTICLES_TO_TOPICS . " a2t left join " . TABLE_TOPICS_DESCRIPTION . " td on a2t.topics_id = td.topics_id where (a.articles_date_available IS NULL or to_days(a.articles_date_available) <= to_days(now())) and a.articles_status = '1' and a.articles_id = a2t.articles_id and ad.articles_id = a2t.articles_id and ad.language_id = '" . (int)$languages_id . "' and td.language_id = '" . (int)$languages_id . "' and a2t.topics_id = '" . (int)$current_topic_id . "' and au.authors_id = '" . (int)$_GET['filter_id'] . "' order by a.sort_order,  a.articles_date_added desc, ad.articles_name";
      } else {
      	$listing_sql = "select a.articles_id, a.authors_id, a.articles_date_added, ad.articles_name, ad.articles_head_desc_tag, au.authors_name, td.topics_name, a2t.topics_id from (" . TABLE_ARTICLES . " a, " . TABLE_ARTICLES_DESCRIPTION . " ad) left join " . TABLE_AUTHORS . " au on a.authors_id = au.authors_id, " . TABLE_ARTICLES_TO_TOPICS . " a2t left join " . TABLE_TOPICS_DESCRIPTION . " td on a2t.topics_id = td.topics_id where (a.articles_date_available IS NULL or to_days(a.articles_date_available) <= to_days(now())) and a.articles_status = '1' and a.articles_id = a2t.articles_id and ad.articles_id = a2t.articles_id and ad.language_id = '" . (int)$languages_id . "' and td.language_id = '" . (int)$languages_id . "' and a2t.topics_id = '" . (int)$current_topic_id . "' order by a.sort_order,  a.articles_date_added desc, ad.articles_name";
      }
	}

	$listing_split = new splitPageResults($listing_sql, MAX_ARTICLES_PER_PAGE);



	if ($listing_split->number_of_rows > 0) {
		$articles_listing_query = tep_db_query($listing_split->sql_query);

		while ($articles_listing = tep_db_fetch_array($articles_listing_query)) {

			$articles_listing['url'] = tep_href_link(FILENAME_ARTICLE_INFO, 'articles_id=' . $articles_listing['articles_id']);
			if ( 'true' == DISPLAY_AUTHOR_ARTICLE_LISTING && tep_not_null($articles_listing['authors_name']) ) {
				$articles_listing['authors_name_url'] = tep_href_link(FILENAME_ARTICLES, 'authors_id=' . $articles_listing['authors_id']);
				$articles_listing['authors_name_text'] = TEXT_BY . ' ' . '<a href="' . $articles_listing['authors_name_url'] . '"> ' . $articles_listing['authors_name'] . '</a>';
			}
			$articles_listing['articles_date_added_long'] = tep_date_long($articles_listing['articles_date_added']);


			$_ARTICLES[] = $articles_listing;
		}


		$smarty->assign('TEXT_BY', TEXT_BY);
		$smarty->assign('_ARTICLES', $_ARTICLES);

	### PAGING
	if ( $listing_split->get_number_of_pages() > 1 ) {
		$smarty->assign('TEXT_DISPLAY_NUMBER_OF_ARTICLES', $listing_split->display_count(TEXT_DISPLAY_NUMBER_OF_ARTICLES));
		$_PAGING = TEXT_RESULT_PAGE . ' ' . $listing_split->display_links(MAX_DISPLAY_PAGE_LINKS, tep_get_all_get_params(array('page', 'info', 'x', 'y')));
	}

	if ( (ARTICLE_PREV_NEXT_BAR_LOCATION == '1' || ARTICLE_PREV_NEXT_BAR_LOCATION == '3')  ) { // top
		$smarty->assign('_PAGINGTOP', $_PAGING);
	}

	if ( (ARTICLE_PREV_NEXT_BAR_LOCATION == '2' || ARTICLE_PREV_NEXT_BAR_LOCATION == '3')  ) { // top
		$smarty->assign('_PAGINGBOTTOM', $_PAGING);
	}
	### PAGING


	}




	if ( tep_not_null($topic['topics_heading_title']) ) {
		$smarty->assign('HEADER_TITLE', $topic['topics_heading_title']);
	} else {
		$smarty->assign('HEADER_TITLE', HEADING_TITLE);
	}

	if (isset($_GET['authors_id'])) {
		$author_query = tep_db_query("select au.authors_name, aui.authors_description, aui.authors_url from " . TABLE_AUTHORS . " au, " . TABLE_AUTHORS_INFO . " aui where au.authors_id = '" . (int)$_GET['authors_id'] . "' and au.authors_id = aui.authors_id and aui.languages_id = '" . (int)$languages_id . "'");
		$authors = tep_db_fetch_array($author_query);
		$author_name = $authors['authors_name'];
		$authors_description = $authors['authors_description'];
		$authors_url = $authors['authors_url'];
	}

	if (ARTICLE_LIST_FILTER) {
      if (isset($_GET['authors_id'])) {
        $filterlist_sql = "select distinct t.topics_id as id, td.topics_name as name from (" . TABLE_ARTICLES . " a, " . TABLE_ARTICLES_TO_TOPICS . " a2t, " . TABLE_TOPICS . " t, " . TABLE_TOPICS_DESCRIPTION . " td) where a.articles_status = '1' and a.articles_id = a2t.articles_id and a2t.topics_id = t.topics_id and a2t.topics_id = td.topics_id and td.language_id = '" . (int)$languages_id . "' and a.authors_id = '" . (int)$_GET['authors_id'] . "' order by td.topics_name";
      } else {
        $filterlist_sql= "select distinct au.authors_id as id, au.authors_name as name from (" . TABLE_ARTICLES . " a, " . TABLE_ARTICLES_TO_TOPICS . " a2t, " . TABLE_AUTHORS . " au) where a.articles_status = '1' and a.authors_id = au.authors_id and a.articles_id = a2t.articles_id and a2t.topics_id = '" . (int)$current_topic_id . "' order by au.authors_name";
      }
      $filterlist_query = tep_db_query($filterlist_sql);
      if (tep_db_num_rows($filterlist_query) > 1) {
        if (isset($_GET['authors_id'])) {
          $options = array(array('id' => '', 'text' => TEXT_ALL_TOPICS));
        } else {
          $options = array(array('id' => '', 'text' => TEXT_ALL_AUTHORS));
        }
        while ($filterlist = tep_db_fetch_array($filterlist_query)) {
          $options[] = array('id' => $filterlist['id'], 'text' => $filterlist['name']);
        }
      }
    }

	//include_once (DIR_WS_MODULES . FILENAME_ARTICLE_LISTING);

	$page_content = $smarty->fetch('articles_topic.tpl');

	} else { // default page

	$smarty->assign('HEADER_TITLE', HEADING_TITLE);
	$smarty->assign('TEXT_CURRENT_ARTICLES', TEXT_CURRENT_ARTICLES);

  	$articles_all_query_raw = "
  						SELECT
  							a.articles_id,
  							a.articles_date_added,
  							ad.articles_name,
  							ad.articles_head_desc_tag,
  							au.authors_id, au.authors_name,
  							td.topics_id,
  							td.topics_name
  						FROM
  							" . TABLE_ARTICLES_DESCRIPTION . " ad,

  							" . TABLE_ARTICLES_TO_TOPICS . " a2t

  						LEFT JOIN
  							" . TABLE_TOPICS_DESCRIPTION . " td
  							ON
  								a2t.topics_id = td.topics_id,
  								" . TABLE_ARTICLES . " a
  						LEFT JOIN
  							" . TABLE_AUTHORS . " au
  							ON
  								a.authors_id = au.authors_id
  						WHERE
  							(a.articles_date_available IS NULL OR to_days(a.articles_date_available) <= to_days(now()))
  							AND a.articles_id = a2t.articles_id
  							AND a.articles_status = '1'
  							AND a.articles_id = ad.articles_id
  							AND ad.language_id = '" . (int)$languages_id . "'
  							AND td.language_id = '" . (int)$languages_id . "'
  						ORDER BY
  							a.articles_date_added desc,
  							ad.articles_name";
  	$articles_all_split = new splitPageResults($articles_all_query_raw, MAX_ARTICLES_PER_PAGE);


  	if ($articles_all_split->number_of_rows > 0) {
    $articles_all_query = tep_db_query($articles_all_split->sql_query);

    $smarty->assign('TEXT_ALL_ARTICLES', TEXT_ALL_ARTICLES);

    while ($articles_all = tep_db_fetch_array($articles_all_query)) {
    		$articles_all['articles_url'] = tep_href_link(FILENAME_ARTICLE_INFO, 'articles_id=' . $articles_all['articles_id']);
    		$articles_all['authors_url'] = tep_href_link(FILENAME_ARTICLES, 'authors_id=' . $articles_all['authors_id']);
    		$articles_all['topics_url'] = tep_href_link(FILENAME_ARTICLES, 'tPath=' . $articles_all['topics_id']);
    		$articles_all['description'] = clean_html_comments(substr($articles_all['articles_head_desc_tag'],0, MAX_ARTICLE_ABSTRACT_LENGTH)) . ((strlen($articles_all['articles_head_desc_tag']) >= MAX_ARTICLE_ABSTRACT_LENGTH) ? '...' : '' );
    		$articles_all['date'] = tep_date_long($articles_all['articles_date_added']);
    		$_ARTICLES[] = $articles_all;
    }
	$smarty->assign('_ARTICLES', $_ARTICLES);

		$page_content = $smarty->fetch('articles.tpl' );

  	} else {
  		$smarty->assign('TEXT_NO_ARTICLES', TEXT_NO_ARTICLES);
		$page_content = $smarty->fetch('articles_empty.tpl' );
  	}

}


	$smarty->assign('page_content', $page_content);

	require_once ( DIR_WS_INCLUDES . 'application_bottom.php' );
	$smarty->display('common/page.tpl' );
?>