<?php

  require_once ( 'includes/application_top.php' );

// if the customer is not logged on, redirect them to the login page
  if (!tep_session_is_registered('customer_id')) {
    $navigation->set_snapshot(array('mode' => 'SSL', 'page' => FILENAME_CHECKOUT_PAYMENT));
    tep_redirect(tep_href_link(FILENAME_LOGIN, '', 'SSL'));
  }

// if there is nothing in the customers cart, redirect them to the shopping cart page
  if ($cart->count_contents() < 1) {
    tep_redirect(tep_href_link(FILENAME_SHOPPING_CART));
  }

// avoid hack attempts during the checkout procedure by checking the internal cartID
  if (isset($cart->cartID) && tep_session_is_registered('cartID')) {
    if ($cart->cartID != $cartID) {
      tep_redirect(tep_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));
    }
  }

// if no shipping method has been selected, redirect the customer to the shipping method selection page
  if (!tep_session_is_registered('shipping')) {
    tep_redirect(tep_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));
  }

  if (!tep_session_is_registered('payment')) tep_session_register('payment' );
  if (isset($_POST['payment'])) $payment = $_POST['payment'];

  if (!tep_session_is_registered('comments')) tep_session_register('comments' );
  if (tep_not_null($_POST['comments'])) {
    $comments = tep_db_prepare_input($_POST['comments']);
  }

// load the selected payment module
  require_once (DIR_WS_CLASSES . 'payment.php' );
  $payment_modules = new payment($payment);
  require_once (DIR_WS_CLASSES . 'order_total.php' );

  require_once (DIR_WS_CLASSES . 'order.php' );
  $order = new order;

    // redirect if the country disabled after user entered different country.
  if ( 'false' === ACCOUNT_COUNTRY ) {
  		if( STORE_COUNTRY !== $order->billing['country']['id'] ) {
  			tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'));
  		}
  }


  $payment_modules->update_status();
  $order_total_modules = new order_total;
  $order_total_modules->collect_posts();
  $order_total_modules->pre_confirmation_check();

  if ( (is_array($payment_modules->modules)) && (sizeof($payment_modules->modules) > 1) && (!is_object($$payment)) && (!$credit_covers) ) {
    tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error=ccerr&error=' . urlencode(ERROR_NO_PAYMENT_MODULE_SELECTED), 'SSL'));  // Rigadin in v5.13: modified error coding in URL
  }

  if (is_array($payment_modules->modules)) {
    $payment_modules->pre_confirmation_check();
  }

// load the selected shipping module
  require_once (DIR_WS_CLASSES . 'shipping.php' );
  $shipping_modules = new shipping($shipping);

// Stock Check
  $any_out_of_stock = false;
  if (STOCK_CHECK == 'true') {
    $check_stock='';
    for ($i=0, $n=sizeof($order->products); $i<$n; $i++) {
      if (isset($order->products[$i]['attributes']) && is_array($order->products[$i]['attributes'])) {
        $attributes=array();
        foreach ($order->products[$i]['attributes'] as $attribute) {
          $attributes[$attribute['option_id']]=$attribute['value_id'];
        }
        $check_stock[$i] = tep_check_stock($order->products[$i]['id'], $order->products[$i]['qty'], $attributes);
      } else {
        $check_stock[$i] = tep_check_stock($order->products[$i]['id'], $order->products[$i]['qty']);
      }
      if ($check_stock[$i]) {
        $any_out_of_stock = true;
      }
    }
    // Out of Stock
    if ( (STOCK_ALLOW_CHECKOUT != 'true') && ($any_out_of_stock == true) ) {
      tep_redirect(tep_href_link(FILENAME_SHOPPING_CART));
    }
  }

	@include_once ( DIR_WS_LANGUAGES . $language . '/' . FILENAME_CHECKOUT_CONFIRMATION );

	$breadcrumb->add(NAVBAR_TITLE_1, tep_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));
	$breadcrumb->add(NAVBAR_TITLE_2, tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'));
	$breadcrumb->add(NAVBAR_TITLE_3);

	$content = CONTENT_CHECKOUT_CONFIRMATION;


	$smarty->assign('sendto', $sendto);

	$smarty->assign('_ORDERINFO', $order->info);

	$smarty->assign('breadcrumb', $breadcrumb->_trail);
	$smarty->assign('messagestack', $messageStack->get_messages());

	$smarty->assign('CHECKOUT_BAR_DELIVERY', CHECKOUT_BAR_DELIVERY);
	$smarty->assign('CHECKOUT_BAR_PAYMENT', CHECKOUT_BAR_PAYMENT);
	$smarty->assign('CHECKOUT_BAR_CONFIRMATION', CHECKOUT_BAR_CONFIRMATION);
	$smarty->assign('CHECKOUT_BAR_FINISHED', CHECKOUT_BAR_FINISHED);

	$smarty->assign('CHECKOUT_BAR_CONFIRMATION_CLASS', ' class="current"' );

	$smarty->assign('HEADING_DELIVERY_ADDRESS', HEADING_DELIVERY_ADDRESS);
	$smarty->assign('URL_CHECKOUT_SHIPPING_ADDRESS', tep_href_link(FILENAME_CHECKOUT_SHIPPING_ADDRESS, '', 'SSL'));

	$smarty->assign('TEXT_EDIT', TEXT_EDIT);
	$smarty->assign('TEXT_PRICE', TEXT_PRICE);
	$smarty->assign('TEXT_NO_TAX', TEXT_NO_TAX);
	$smarty->assign('TEXT_CLICK_ONCE_TO_SUBMIT', TEXT_CLICK_ONCE_TO_SUBMIT);
	if ( 'On' == CHECKOUT_AGREE_TO_TERMS ) {
		$smarty->assign('TEXT_AGREE_TO_TERMS', sprintf(TEXT_AGREE_TO_TERMS, CHECKOUT_AGREE_TO_TERMS_URL));
		$smarty->assign('INPUT_AGREE_TO_TERMS', tep_draw_checkbox_field('agreed_to_terms', 'yes', false, 'id="agreed_to_terms"'));
	}

	$smarty->assign('DELIVERY_ADDRESS', tep_address_format($order->delivery['format_id'], $order->delivery, 1, ' ', '<br />'));
	$smarty->assign('HEADING_SHIPPING_METHOD', HEADING_SHIPPING_METHOD);

	$smarty->assign('URL_CHECKOUT_SHIPPING', tep_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));

	$smarty->assign('HEADING_BILLING_ADDRESS', HEADING_BILLING_ADDRESS);
	$smarty->assign('BILLING_ADDRESS', tep_address_format($order->billing['format_id'], $order->billing, 1, ' ', '<br />'));
	$smarty->assign('URL_CHECKOUT_PAYMENT_ADDRESS', tep_href_link(FILENAME_CHECKOUT_PAYMENT_ADDRESS, '', 'SSL'));

	$smarty->assign('HEADING_PAYMENT_METHOD', HEADING_PAYMENT_METHOD);
	$smarty->assign('URL_CHECKOUT_PAYMENT', tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'));

	$smarty->assign('HEADING_PRODUCTS', HEADING_PRODUCTS);
	$smarty->assign('URL_SHOPPING_CART', tep_href_link(FILENAME_SHOPPING_CART));




	foreach ( $order->products as $product ) {

		if ( 'true' == STOCK_CHECK ) {
			if ( 'On' == ENABLE_PRODUCTS_BUNDLES && '1' == $product['products_bundle'] ) {
				$product_bundles = tep_get_bundle_products($product['id']);
				if ( true === is_array($product_bundles['products']) ) {
					foreach ( $product_bundles['products'] as $prod_bundle ) {
						if ($prod_bundle['products_quantity'] <= 0 && STOCK_ALLOW_CHECKOUT != true) {
					}
				}
			} else {
				if ( true == isset($product['attributes']) && true == is_array($product['attributes']) ) {
					$stock_check = tep_check_stock($product['id'], $product['quantity'], $product['attributes']);
				} else {
					$stock_check = tep_check_stock($product['id'], $product['quantity']);
				}
			}
			$product['stock_check'] = $stock_check;
		}
	}

		 if ( false === empty($product['attributes']) && is_array($product['attributes']) ) {
		 	reset($product['attributes']);
			  	while ( list($option, $value) = each($product['attributes']) ) {
			  		$product['attribute'][$option]['products_options_name'] = $product['attributes'][$option]['option'];
			  		$product['attribute'][$option]['products_options_values_name'] = $product['attributes'][$option]['value'];
			  		$product['attribute'][$option]['price_prefix'] = $product['attributes'][$option]['prefix'];
                         $product['attribute'][$option]['options_values_price'] = $product['attributes'][$option]['price'];
                         $product['attribute'][$option]['options_price'] = $currencies->display_price($product['attributes'][$option]['price'], 0);
			  	}
			}
		$product['url'] = tep_href_link(FILENAME_PRODUCT_INFO, 'cPath=' . tep_get_product_path($product['id']) . '&products_id=' . $product['id'], 'NONSSL' );
		$product['price'] = $currencies->display_price($product['final_price'], $product['tax'], $product['qty']);
		$product['price'] = tep_display_tax_value($product['price']);
		if ( 0 < $product['tax'] ) {
			$product['tax_text'] = sprintf(TEXT_PLUS_TAX, $product['tax']);
		}
		$_PRODUCTS[] = $product;

	}
	$smarty->assign('_PRODUCTS', $_PRODUCTS);

	if ( MODULE_ORDER_TOTAL_INSTALLED ) {
	    $order_total_modules->process();
	    $smarty->assign('_ORDERTOTAL', $order_total_modules->output());
	}

	if (is_array($payment_modules->modules)) {
		if ($confirmation = $payment_modules->confirmation()) {
			$smarty->assign('HEADING_PAYMENT_INFORMATION', HEADING_PAYMENT_INFORMATION);
			$smarty->assign('confirmation', $confirmation);
		}
	}


	$smarty->assign('HEADER_TITLE', HEADING_TITLE);
	$smarty->assign('HEADING_ORDER_COMMENTS', HEADING_ORDER_COMMENTS);

	if ( false === empty($order->info['comments']) ) {
		$order->info['comments_hidden'] = tep_draw_hidden_field('comments', $order->info['comments']);
	}

	if ( false === empty($$payment->form_action_url) ) {
		$form_action_url = $$payment->form_action_url;
	} else {
		$form_action_url = tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL' );
	}

	 if ( true === is_array($payment_modules->modules) ) {
	 	$smarty->assign('process_button', $payment_modules->process_button());
	 }


	if ( 'On' == CHECKOUT_AGREE_TO_TERMS ) {
		$agree_js = '<script type="text/javascript">function submitOrderAgree(){'.
					'if(document.getElementById(\'agreed_to_terms\').checked!=true){alert("'.TEXT_ERROR_AGREE_TO_TERMS.'");return false;}else{return submitOrder();}' .
					'return false;'.
					'}</script>';
		$_JAVASCRIPTINCLUDES .= $agree_js;
		$smarty->assign('_JAVASCRIPTINCLUDES', $_JAVASCRIPTINCLUDES);
		$smarty->assign('BUTTON_CONFIRM_ORDER_ONCLICK', 'return submitOrderAgree();');
	} else {
		$smarty->assign('BUTTON_CONFIRM_ORDER_ONCLICK', 'return submitOrder();');
	}

	require_once ( DIR_WS_INCLUDES . 'meta_tags.php' );


	$page_content = tep_draw_form('checkout_confirmation', $form_action_url, 'post' );
	$page_content .= $smarty->fetch('checkout_confirmation.tpl' );
	$page_content .= '</form>';

	$smarty->assign('page_content', $page_content);

	require_once ( DIR_WS_INCLUDES . 'application_bottom.php' );
	$smarty->display('common/page.tpl' );
?>