<?php

  require_once ( 'includes/application_top.php' );

	// if the customer is not logged on, redirect them to the login page
	if ( !tep_session_is_registered('customer_id') ) {
		$navigation->set_snapshot(array('mode' => 'SSL', 'page' => FILENAME_CHECKOUT_PAYMENT));
		tep_redirect(tep_href_link(FILENAME_LOGIN, '', 'SSL'));
	}

	if ( !tep_session_is_registered('sendto') ) {
		tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'));
	}

	if ( tep_not_null(MODULE_PAYMENT_INSTALLED) && !tep_session_is_registered('payment') ) {
		tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'));
	}


	// avoid hack attempts during the checkout procedure by checking the internal cartID
	if ( isset($cart->cartID) && tep_session_is_registered('cartID') ) {
		if ( $cart->cartID != $cartID ) {
			tep_redirect(tep_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));
		}
	}

	include_once ( DIR_WS_LANGUAGES . $language . '/' . FILENAME_CHECKOUT_PROCESS );

	// load selected payment module
	require_once ( DIR_WS_CLASSES . 'payment.php' );

	if ($credit_covers) {
		$payment = '';
	}
	$payment_modules = new payment($payment);

	// load the selected shipping module
	require_once ( DIR_WS_CLASSES . 'shipping.php' );
	$shipping_modules = new shipping($shipping);

	require_once ( DIR_WS_CLASSES . 'order.php' );
	$order = new order;

	// MOVED BELOW Authorizenet ADC
	// load the before_process function from the payment modules
	// $payment_modules->before_process();
	require_once ( DIR_WS_CLASSES . 'order_total.php' );
	$order_total_modules = new order_total;

	$order_totals = $order_total_modules->process();
	// remove items from wishlist if customer purchased them
	$wishList->clear();


	// BOF: MOD - Authorizenet ADC Direct Connection
	// Make sure the /catalog/includes/class/order.php is included
	// and $order object is created before this!!!
	if ( 'True' == MODULE_PAYMENT_AUTHORIZENET_STATUS ) {
		include_once ( DIR_WS_MODULES . 'authorizenet_direct.php' );
	}

	/*****  Eway payment processing *****/
	if ( 'eWay' != $_REQUEST['refer'] ) {
		 $payment_modules->before_process();
	}

	$sql_data_array = array('customers_id' => $customer_id,
                          'customers_name' => $order->customer['firstname'] . ' ' . $order->customer['lastname'],
                          'customers_company' => $order->customer['company'],
                          'customers_street_address' => $order->customer['street_address'],
                          'customers_suburb' => $order->customer['suburb'],
                          'customers_city' => $order->customer['city'],
                          'customers_postcode' => $order->customer['postcode'],
                          'customers_state' => $order->customer['state'],
                          'customers_country' => $order->customer['country']['title'],
                          'customers_telephone' => $order->customer['telephone'],
                          'customers_email_address' => $order->customer['email_address'],
                          'customers_address_format_id' => $order->customer['format_id'],
                          'delivery_name' => $order->delivery['firstname'] . ' ' . $order->delivery['lastname'],
                          'delivery_company' => $order->delivery['company'],
                          'delivery_street_address' => $order->delivery['street_address'],
                          'delivery_suburb' => $order->delivery['suburb'],
                          'delivery_city' => $order->delivery['city'],
                          'delivery_postcode' => $order->delivery['postcode'],
                          'delivery_state' => $order->delivery['state'],
                          'delivery_country' => $order->delivery['country']['title'],
                          'delivery_address_format_id' => $order->delivery['format_id'],
                          'billing_name' => $order->billing['firstname'] . ' ' . $order->billing['lastname'],
                          'billing_company' => $order->billing['company'],
                          'billing_street_address' => $order->billing['street_address'],
                          'billing_suburb' => $order->billing['suburb'],
                          'billing_city' => $order->billing['city'],
                          'billing_postcode' => $order->billing['postcode'],
                          'billing_state' => $order->billing['state'],
                          'billing_country' => $order->billing['country']['title'],
                          'billing_address_format_id' => $order->billing['format_id'],
                          'payment_method' => $order->info['payment_method'],
                          'cc_type' => $order->info['cc_type'],
                          'cc_owner' => $order->info['cc_owner'],
                          'cc_number' => $order->info['cc_number'],
                          'cc_expires' => $order->info['cc_expires'],
                          'date_purchased' => 'now()',
                          'last_modified' => 'now()',
                          'orders_status' => $order->info['order_status'],
                          'currency' => $order->info['currency'],
                          'currency_value' => $order->info['currency_value']);
  tep_db_perform(TABLE_ORDERS, $sql_data_array);
  $insert_id = tep_db_insert_id();
  for ($i=0, $n=sizeof($order_totals); $i<$n; $i++) {
    $sql_data_array = array('orders_id' => $insert_id,
                            'title' => $order_totals[$i]['title'],
                            'text' => $order_totals[$i]['text'],
                            'value' => $order_totals[$i]['value'],
                            'class' => $order_totals[$i]['code'],
                            'sort_order' => $order_totals[$i]['sort_order']);
    tep_db_perform(TABLE_ORDERS_TOTAL, $sql_data_array);

	if ( true === is_array($order_totals[$i]['discount']) ) {
		$discount = $order_totals[$i]['discount'];
		$coupon_amount = $discount['coupon_amount'];
		$coupon_type = $discount['coupon_type'];
	}
  }

  $customer_notification = ( SEND_EMAILS == 'true' ? '1' : '0' );
  $sql_data_array = array('orders_id' => $insert_id,
                          'orders_status_id' => $order->info['order_status'],
                          'date_added' => 'now()',
                          'customer_notified' => $customer_notification,
                          'comments' => $order->info['comments']);
  tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);

	// initialized for the email confirmation
	$products_ordered = '';
	$subtotal = 0;
	$total_tax = 0;

	for ($i=0, $n=sizeof($order->products); $i<$n; $i++) {
    $products_stock_attributes=null;
    if (STOCK_LIMITED == 'true') {
        $products_attributes = $order->products[$i]['attributes'];
      if (DOWNLOAD_ENABLED == 'true') {
        $stock_query_raw = "SELECT products_quantity, p.products_bundle, pad.products_attributes_filename
                            FROM " . TABLE_PRODUCTS . " p
                            LEFT JOIN " . TABLE_PRODUCTS_ATTRIBUTES . " pa
                             ON p.products_id=pa.products_id
                            LEFT JOIN " . TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD . " pad
                             ON pa.products_attributes_id=pad.products_attributes_id
                            WHERE p.products_id = '" . tep_get_prid($order->products[$i]['id']) . "'";
	// Will work with only one option for downloadable products
	// otherwise, we have to build the query dynamically with a loop

	$products_attributes = $order->products[$i]['attributes'];
	if ( is_array($products_attributes) ) {
		$stock_query_raw .= " AND pa.options_id = '" . $products_attributes[0]['option_id'] . "' AND pa.options_values_id = '" . $products_attributes[0]['value_id'] . "'";
	}
	$stock_query = tep_db_query($stock_query_raw);

	if (tep_db_num_rows($stock_query) > 0) {
		$stock_values = tep_db_fetch_array($stock_query);
	}

	$actual_stock_bought = $order->products[$i]['qty'];
	$download_selected = false;

	if ( ( 'true' == DOWNLOAD_ENABLED ) && isset($stock_values['products_attributes_filename']) && tep_not_null($stock_values['products_attributes_filename'])) {
		$download_selected = true;
		$products_stock_attributes='$$DOWNLOAD$$';
	}


	//If not downloadable and attributes present, adjust attribute stock
	if ( !$download_selected && is_array($products_attributes) ) {
		$all_nonstocked = true;
                $products_stock_attributes_array = array();
                foreach ($products_attributes as $attribute) {
                    if ($attribute['track_stock'] == 1) {
                      $products_stock_attributes_array[] = $attribute['option_id'] . "-" . $attribute['value_id'];
                      $all_nonstocked = false;
                    }
                }
                if ($all_nonstocked) {
                    $actual_stock_bought = $order->products[$i]['qty'];
                }  else {
                  asort($products_stock_attributes_array, SORT_NUMERIC);
                  $products_stock_attributes = implode(",", $products_stock_attributes_array);
                  $attributes_stock_query = tep_db_query("select products_stock_quantity from " . TABLE_PRODUCTS_STOCK . " where products_stock_attributes = '$products_stock_attributes' AND products_id = '" . tep_get_prid($order->products[$i]['id']) . "'");
                  if (tep_db_num_rows($attributes_stock_query) > 0) {
                      $attributes_stock_values = tep_db_fetch_array($attributes_stock_query);
                      $attributes_stock_left = $attributes_stock_values['products_stock_quantity'] - $order->products[$i]['qty'];
                      tep_db_query("update " . TABLE_PRODUCTS_STOCK . " set products_stock_quantity = '" . $attributes_stock_left . "' where products_stock_attributes = '$products_stock_attributes' AND products_id = '" . tep_get_prid($order->products[$i]['id']) . "'");
                      $actual_stock_bought = ($attributes_stock_left < 1) ? $attributes_stock_values['products_stock_quantity'] : $order->products[$i]['qty'];
            } else {
              $attributes_stock_left = 0 - $order->products[$i]['qty'];
              tep_db_query("insert into " . TABLE_PRODUCTS_STOCK . " (products_id, products_stock_attributes, products_stock_quantity) values ('" . tep_get_prid($order->products[$i]['id']) . "', '" . $products_stock_attributes . "', '" . $attributes_stock_left . "')");
              $actual_stock_bought = 0;
            }
          }
        }
// do not decrement quantities if products_attributes_filename exists
        if (!$download_selected) {
        	// control stock for bundled products
        	if ( '1' == $stock_values['products_bundle'] ) {
			$products_bundles = tep_get_bundle_products($order->products[$i]['id']);
			if ( false != $products_bundles ) {
				if ( true === is_array($products_bundles['products']) ) {
					foreach ( $products_bundles['products'] as $prod_bundles ) {
						$stock_left = $prod_bundles['products_quantity'] - ( $prod_bundles['products_bundle_qty'] * $order->products[$i]['qty']);
						tep_db_query("update " . TABLE_PRODUCTS . " set products_quantity = '" . $stock_left . "' where products_id = '" . $prod_bundles['products_bundle_id'] . "'");
					}
				}
			}
		} else {
	          $stock_left = $stock_values['products_quantity'] - $actual_stock_bought;
	          tep_db_query("UPDATE " . TABLE_PRODUCTS . "
	                        SET products_quantity = products_quantity - '" . $actual_stock_bought . "'
	                        WHERE products_id = '" . tep_get_prid($order->products[$i]['id']) . "'");
	          if ( ($stock_left < 1) && (STOCK_ALLOW_CHECKOUT == 'false') ) {
	            tep_db_query("update " . TABLE_PRODUCTS . " set products_status = '0' where products_id = '" . tep_get_prid($order->products[$i]['id']) . "'");
	          }
	        }
        }
      }
    }
    tep_db_query("update " . TABLE_PRODUCTS . " set products_ordered = products_ordered + " . sprintf('%d', $order->products[$i]['qty']) . " where products_id = '" . tep_get_prid($order->products[$i]['id']) . "'");


    if ( false == isset($products_stock_attributes)) {
    	$products_stock_attributes = null;
    }

    ## COUPONS
    if ( false === empty($coupon_amount) && false === empty($coupon_type) ) {
		switch ($coupon_type) {
			case 'P': # %
				$discount = ( $order->products[$i]['final_price'] * $coupon_amount / 100 );
			break;

			case 'F': # Amount
				$discount = ( $coupon_amount / count($order->products) );
			break;
		}
	}
	## COUPONS END

	$products_return = (true === $download_selected ? '0' : '1');

	$sql_data_array = array('orders_id' => $insert_id,
                            'products_id' => tep_get_prid($order->products[$i]['id']),
                            'products_model' => $order->products[$i]['model'],
                            'products_name' => $order->products[$i]['name'],
                            'products_price' => $order->products[$i]['price'],
                            'final_price' => $order->products[$i]['final_price'],
                            'products_discount_made' => $discount,// amount only
                            'products_tax' => $order->products[$i]['tax'],
                            'products_quantity' => $order->products[$i]['qty'],
                            'products_return' => $products_return,
                            'products_stock_attributes' => $products_stock_attributes);
    tep_db_perform(TABLE_ORDERS_PRODUCTS, $sql_data_array);
    $order_products_id = tep_db_insert_id();

	//------insert customer choosen option to order--------
    $attributes_exist = '0';
    $products_ordered_attributes = '';
    if (isset($order->products[$i]['attributes'])) {
      $attributes_exist = '1';
      for ($j=0, $n2=sizeof($order->products[$i]['attributes']); $j<$n2; $j++) {

        if (DOWNLOAD_ENABLED == 'true') {
          $attributes_query = "
          						SELECT
          							pa.products_attributes_id,
          							poptd.products_options_name,
          							poval.products_options_values_name,
          							pa.options_values_price,
          							pa.price_prefix,
          							pad.products_attributes_maxdays,
          							pad.products_attributes_maxcount,
          							pad.products_attributes_filename
          						FROM
          							" . TABLE_PRODUCTS_OPTIONS . " popt,
          							" . TABLE_PRODUCTS_OPTIONS_DESCRIPTION . " poptd,
          							" . TABLE_PRODUCTS_OPTIONS_VALUES . " poval,
          							" . TABLE_PRODUCTS_ATTRIBUTES . " pa
          							LEFT JOIN " . TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD . " pad
          								ON pa.products_attributes_id = pad.products_attributes_id
          						WHERE
          							pa.products_id = '" . $order->products[$i]['id'] . "'
          							AND pa.options_id = '" . $order->products[$i]['attributes'][$j]['option_id'] . "'
          							AND pa.options_id = popt.products_options_id
          							AND poptd.products_options_id = popt.products_options_id
          							AND pa.options_values_id = '" . $order->products[$i]['attributes'][$j]['value_id'] . "'
          							AND pa.options_values_id = poval.products_options_values_id
          							AND poptd.language_id = '" . $languages_id . "'
          							AND poval.language_id = '" . $languages_id . "'";
          $attributes = tep_db_query($attributes_query);
		} else {
			$attributes_query = "
								SELECT
									pa.products_attributes_id,
									poptd.products_options_name,
									poval.products_options_values_name,
									pa.options_values_price,
									pa.price_prefix
								FROM
									" . TABLE_PRODUCTS_OPTIONS . " popt,
									" . TABLE_PRODUCTS_OPTIONS_DESCRIPTION . " poptd,
									" . TABLE_PRODUCTS_OPTIONS_VALUES . " poval,
									" . TABLE_PRODUCTS_ATTRIBUTES . " pa
								WHERE
									pa.products_id = '" . $order->products[$i]['id'] . "'
									AND pa.options_id = '" . $order->products[$i]['attributes'][$j]['option_id'] . "'
									AND pa.options_id = popt.products_options_id
									AND poptd.products_options_id = popt.products_options_id
									AND pa.options_values_id = '" . $order->products[$i]['attributes'][$j]['value_id'] . "'
									AND pa.options_values_id = poval.products_options_values_id
									AND poptd.language_id = '" . $languages_id . "'
									AND poval.language_id = '" . $languages_id . "'";
			$attributes = tep_db_query($attributes_query);
        }
        $attributes_values = tep_db_fetch_array($attributes);

        $sql_data_array = array('orders_id' => $insert_id,
        						'products_attributes_id' => $attributes_values['products_attributes_id'],
                                'orders_products_id' => $order_products_id,
                                'products_options' => $attributes_values['products_options_name'],
//                              'products_options_values' => $attributes_values['products_options_values_name'],
                                'products_options_values' => $order->products[$i]['attributes'][$j]['value'],
                                'options_values_price' => $attributes_values['options_values_price'],
                                'price_prefix' => $attributes_values['price_prefix']);
        tep_db_perform(TABLE_ORDERS_PRODUCTS_ATTRIBUTES, $sql_data_array);

        if ((DOWNLOAD_ENABLED == 'true') && isset($attributes_values['products_attributes_filename']) && tep_not_null($attributes_values['products_attributes_filename'])) {
          $sql_data_array = array('orders_id' => $insert_id,
          						  'products_attributes_id' => $attributes_values['products_attributes_id'],
                                  'orders_products_id' => $order_products_id,
                                  'orders_products_filename' => $attributes_values['products_attributes_filename'],
                                  'download_maxdays' => $attributes_values['products_attributes_maxdays'],
                                  'download_count' => $attributes_values['products_attributes_maxcount']);
          tep_db_perform(TABLE_ORDERS_PRODUCTS_DOWNLOAD, $sql_data_array);
        }
        $products_ordered_attributes .= "\n\t" . $attributes_values['products_options_name'] . ' ' . $attributes_values['products_options_values_name'];
      }
    }
    $total_weight += ($order->products[$i]['qty'] * $order->products[$i]['weight']);
    $total_tax += tep_calculate_tax($total_products_price, $products_tax) * $order->products[$i]['qty'];
    $total_cost += $total_products_price;
    $products_ordered .= $order->products[$i]['qty'] . ' x ' . $order->products[$i]['name'] . ' (' . $order->products[$i]['model'] . ') = ' . $currencies->display_price($order->products[$i]['final_price'], $order->products[$i]['tax'], $order->products[$i]['qty']) . $products_ordered_attributes . "\n";
  }
$order_total_modules->apply_credit();
// lets start with the email confirmation
if (!tep_session_is_registered('noaccount')) {
  $email_order = STORE_NAME . "\n" .
                 EMAIL_SEPARATOR . "\n" .
                 EMAIL_TEXT_ORDER_NUMBER . ' ' . $insert_id . "\n" .
                 EMAIL_TEXT_INVOICE_URL . ' ' . tep_href_link(FILENAME_ACCOUNT_HISTORY_INFO, 'order_id=' . $insert_id, 'SSL', false) . "\n" .
                 EMAIL_TEXT_DATE_ORDERED . ' ' . strftime(DATE_FORMAT_LONG) . "\n\n";
  if ($order->info['comments']) {
    $email_order .= tep_db_output($order->info['comments']) . "\n\n";
  }
  $email_order .= EMAIL_TEXT_PRODUCTS . "\n" .
                  EMAIL_SEPARATOR . "\n" .
                  $products_ordered .
                  EMAIL_SEPARATOR . "\n";
  } else {
  $email_order = STORE_NAME . "\n" .
                 EMAIL_SEPARATOR . "\n" .
                 EMAIL_TEXT_ORDER_NUMBER . ' ' . $insert_id . "\n" .
                 EMAIL_TEXT_DATE_ORDERED . ' ' . strftime(DATE_FORMAT_LONG) . "\n\n";
  if ($order->info['comments']) {
    $email_order .= tep_db_output($order->info['comments']) . "\n\n";
  }
  $email_order .= EMAIL_TEXT_PRODUCTS . "\n" .
                  EMAIL_SEPARATOR . "\n" .
                  $products_ordered .
                  EMAIL_SEPARATOR . "\n";
  }

  for ($i=0, $n=sizeof($order_totals); $i<$n; $i++) {
    $email_order .= strip_tags($order_totals[$i]['title']) . ' ' . strip_tags($order_totals[$i]['text']) . "\n";
  }

  if ($order->content_type != 'virtual') {
    $email_order .= "\n" . EMAIL_TEXT_DELIVERY_ADDRESS . "\n" .
                    EMAIL_SEPARATOR . "\n" .
                    tep_address_label($customer_id, $sendto, 0, '', "\n") . "\n";
  }

  $email_order .= "\n" . EMAIL_TEXT_BILLING_ADDRESS . "\n" .
                  EMAIL_SEPARATOR . "\n" .
                  tep_address_label($customer_id, $billto, 0, '', "\n") . "\n\n";
  if (is_object($$payment)) {
    $email_order .= EMAIL_TEXT_PAYMENT_METHOD . "\n" .
                    EMAIL_SEPARATOR . "\n";
    $payment_class = $$payment;
    $email_order .= $payment_class->title . "\n\n";
    if ($payment_class->email_footer) {
      $email_order .= $payment_class->email_footer . "\n\n";
    }
  }
	@tep_mail($order->customer['firstname'] . ' ' . $order->customer['lastname'], $order->customer['email_address'], EMAIL_TEXT_SUBJECT, $email_order, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);

	// send emails to other people
	if ( SEND_EXTRA_ORDER_EMAILS_TO != '' ) {
		@tep_mail('', SEND_EXTRA_ORDER_EMAILS_TO, EMAIL_TEXT_SUBJECT, $email_order, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
	}

	// subscriptions
	if ( true === is_array($order->products) ) {
		$products_admin_subscribtions = array();
		foreach ( $order->products as $product ) {
			if ( false === empty($product['subscribe']) ) {
		    	$products_admin_subscribtions_array = explode(',', $product['subscribe']);
		    	foreach ( $products_admin_subscribtions_array as $products_subscribtion_admin_id ) {
		    		$sbscr_price = $currencies->display_price($product['price'],$product['tax'], 1);
		    		$sbscr_price_total = $currencies->display_price($product['price'],$product['tax'],$product['qty']);
		    		$sbscr_attributes = '';
		    		if ( true === is_array($product['attributes']) ) {
		    			foreach ( $product['attributes'] as $sbscr_attribute ) {
		    				$sbscr_attributes .= " - {$sbscr_attribute['option']}: {$sbscr_attribute['value']}";
		    			}
		    		}
		    		$sbscr_model = ( false === empty($product['model']) ? " [{$product['model']}]" : '' );
		    		$products_admin_subscribtions[$products_subscribtion_admin_id][] = array('id' => $product['id'], 'qty' => $product['qty'], 'name' => $product['name'], 'model' => $sbscr_model, 'price' => $sbscr_price, 'price_total' => $sbscr_price_total, 'attributes' => $sbscr_attributes);
		    	}
		    }
		}
	}
	if ( true === is_array($products_admin_subscribtions) && 0 < count($products_admin_subscribtions) ) {
		foreach ( $products_admin_subscribtions as $admin_id => $prod_info ) {
			$admin_id = tep_db_input($admin_id);
			if ( true === is_array($prod_info) ) {
				$subscribed_products = '';
				foreach ( $prod_info as $prod ) {
					$subscribed_products .= "\n\t{$prod['qty']} {$prod['name']}{$prod['model']} {$prod['attributes']} @ {$prod['price']} = {$prod['price_total']}";
				}
			}

			$admin_data_query_sql = "SELECT admin_firstname, admin_lastname, admin_email_address FROM ".TABLE_ADMIN." WHERE admin_id = '$admin_id'";
			$admin_data_query = tep_db_query($admin_data_query_sql);
			if ( 0 < tep_db_num_rows($admin_data_query) ) {
				$admin_data = tep_db_fetch_array($admin_data_query);
				$http_admin = HTTP_SERVER.DIR_WS_HTTP_CATALOG.'admin/';
				$admin_name = "{$admin_data['admin_firstname']} {$admin_data['admin_lastname']}";
				$subject = sprintf(EMAIL_SUBSCRIBE_TEXT_SUBJECT, STORE_NAME);
				$subscribtion_email_text = sprintf(EMAIL_SUBSCRIBE_TEXT_BODY, $admin_name, $subscribed_products, $http_admin, $http_admin);
				@tep_mail($admin_name, $admin_data['admin_email_address'], $subject, $subscribtion_email_text, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
			}
		}
	}
	tep_db_query("UPDATE " . TABLE_ORDERS . " SET language_id = '" . $languages_id . "' WHERE orders_id = '" . (int)$insert_id . "'");

	// load the after_process function from the payment modules
	$payment_modules->after_process();
	$cart->reset(true);

	if ( true === defined('AFFILIATE_SYSTEM') && 'On' === AFFILIATE_SYSTEM ) {
		$affiliate->checkout($order, $insert_id);
	}

// unregister session variables used during checkout
  tep_session_unregister('sendto');
  tep_session_unregister('billto');
  tep_session_unregister('shipping');
  tep_session_unregister('payment');
  tep_session_unregister('comments');

  if(tep_session_is_registered('credit_covers')) tep_session_unregister('credit_covers');
  $order_total_modules->clear_posts();

  tep_redirect(tep_href_link(FILENAME_CHECKOUT_SUCCESS, 'order_id='.$insert_id, 'SSL'));
  require_once ( DIR_WS_INCLUDES . 'application_bottom.php');
?>