<?php

  require_once ( 'includes/application_top.php' );
  require_once ( 'includes/classes/http_client.php' );

  @include_once ( DIR_WS_LANGUAGES . $language . '/' . FILENAME_CHECKOUT_SHIPPING);

	if (tep_get_configuration_key_value('MODULE_SHIPPING_FREESHIPPER_STATUS') and $cart->show_weight()!=0) {
		tep_session_unregister('shipping');
	}
	if (tep_get_configuration_key_value('MODULE_SHIPPING_INDVSHIP_STATUS') and $shiptotal) {
		tep_session_unregister('shipping');
	}

	// if the customer is not logged on, redirect them to the login page
	if (!tep_session_is_registered('customer_id')) {
		$navigation->set_snapshot();
		$messageStack->add_session('login', sprintf(TEXT_LOGIN_FIRST, tep_href_link(FILENAME_CREATE_ACCOUNT)), 'success');
		tep_redirect(tep_href_link(FILENAME_LOGIN, '', 'SSL'));
	}

// if there is nothing in the customers cart, redirect them to the shopping cart page
  if ($cart->count_contents() < 1) {
    tep_redirect(tep_href_link(FILENAME_SHOPPING_CART));
  }

// if no shipping destination address was selected, use the customers own address as default
  if (!tep_session_is_registered('sendto')) {
    tep_session_register('sendto');
    $sendto = $customer_default_address_id;
  } else {
// verify the selected shipping address
    $check_address_query = tep_db_query("select count(*) as total from " . TABLE_ADDRESS_BOOK . " where customers_id = '" . (int)$customer_id . "' and address_book_id = '" . (int)$sendto . "'");
    $check_address = tep_db_fetch_array($check_address_query);

    if ($check_address['total'] != '1') {
      $sendto = $customer_default_address_id;
      if (tep_session_is_registered('shipping')) tep_session_unregister('shipping' );
    }
  }

  require_once ( DIR_WS_CLASSES . 'order.php' );
  $order = new order;


// register a random ID in the session to check throughout the checkout procedure
// against alterations in the shopping cart contents
  if (!tep_session_is_registered('cartID')) tep_session_register('cartID' );
  $cartID = $cart->cartID;

// if the order contains only virtual products, forward the customer to the billing page as
// a shipping address is not needed
// LINE CHANGED: MOD - ICW CREDIT CLASS GV AMENDE LINE BELOW
//  if ($order->content_type == 'virtual') {
  if (($order->content_type == 'virtual') || ($order->content_type == 'virtual_weight')) {
    if (!tep_session_is_registered('shipping')) tep_session_register('shipping' );
    $shipping = false;
    $sendto = false;
    tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'));
  }

  $total_weight = $cart->show_weight();
  $total_count = $cart->count_contents();

// load all enabled shipping modules
  require_once ( DIR_WS_CLASSES . 'shipping.php' );
  $shipping_modules = new shipping;

  if ( defined('MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING') && (MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING == 'true') ) {
    $pass = false;

    switch (MODULE_ORDER_TOTAL_SHIPPING_DESTINATION) {
      case 'national':
        if ($order->delivery['country_id'] == STORE_COUNTRY) {
          $pass = true;
        }
        break;
      case 'international':
        if ($order->delivery['country_id'] != STORE_COUNTRY) {
          $pass = true;
        }
        break;
      case 'both':
        $pass = true;
        break;
    }

    $free_shipping = false;
    if ( ($pass == true) && ($order->info['total'] >= MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER) ) {
      $free_shipping = true;

      include_once (DIR_WS_LANGUAGES . $language . '/modules/order_total/ot_shipping.php' );
    }
  } else {
    $free_shipping = false;
  }

	# Coupons FREE SHIPPING Start
	silent_revalidate_coupon();
	if ( true == tep_session_is_registered('cc_id') ) {
		if ( tep_session_is_registered('cc_free_shipping') ) {
			$free_shipping_title = 'Free shipping';
			$free_shipping = true;
		}
	}
	if( false === empty($_GET['success']) ) {
		$messageStack->add('ot_coupon', $_GET['success'], 'success' );
	}
	# Coupons FREE SHIPPING End



// process the selected shipping method
  if ( isset($_POST['action']) && ($_POST['action'] == 'process') ) {
    if (!tep_session_is_registered('comments')) tep_session_register('comments' );
    if (tep_not_null($_POST['comments'])) {
      $comments = tep_db_prepare_input($_POST['comments']);
    }

    if (!tep_session_is_registered('shipping')) tep_session_register('shipping' );

    if ( (tep_count_shipping_modules() > 0) || ($free_shipping == true) ) {
      if ( (isset($_POST['shipping'])) && (strpos($_POST['shipping'], '_')) ) {
        $shipping = $_POST['shipping'];

        list($module, $method) = explode('_', $shipping);
        if ( is_object($$module) || ($shipping == 'free_free') ) {
          if ($shipping == 'free_free') {
            $quote[0]['methods'][0]['title'] = FREE_SHIPPING_TITLE;
            $quote[0]['methods'][0]['cost'] = '0';
          } else {
            $quote = $shipping_modules->quote($method, $module);
          }
          if (isset($quote['error'])) {
            tep_session_unregister('shipping');
          } else {
            if ( (isset($quote[0]['methods'][0]['title'])) && (isset($quote[0]['methods'][0]['cost'])) ) {
              $shipping = array('id' => $shipping,
                                'title' => (($free_shipping == true) ?  $quote[0]['methods'][0]['title'] : $quote[0]['module'] . ' (' . $quote[0]['methods'][0]['title'] . ')'),
                                'cost' => $quote[0]['methods'][0]['cost']);


              tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'));
            }
          }
        } else {
          tep_session_unregister('shipping');
        }
      }
    } else {
    		#
	}
  }

	$quotes = $shipping_modules->quote();


	if ( !tep_session_is_registered('shipping') || ( tep_session_is_registered('shipping') && ($shipping == false) && (tep_count_shipping_modules() > 1) ) ) $shipping = $shipping_modules->cheapest();
	$breadcrumb->add(NAVBAR_TITLE);
	$content = CONTENT_CHECKOUT_SHIPPING;



	$smarty->assign('HEADER_TITLE', HEADING_TITLE);

	$smarty->assign('CHECKOUT_BAR_DELIVERY', CHECKOUT_BAR_DELIVERY);
	$smarty->assign('CHECKOUT_BAR_PAYMENT', CHECKOUT_BAR_PAYMENT);
	$smarty->assign('CHECKOUT_BAR_CONFIRMATION', CHECKOUT_BAR_CONFIRMATION);
	$smarty->assign('CHECKOUT_BAR_FINISHED', CHECKOUT_BAR_FINISHED);
	$smarty->assign('CHECKOUT_BAR_DELIVERY_CLASS', ' class="current"' );

	$smarty->assign('TITLE_SHIPPING_ADDRESS', TITLE_SHIPPING_ADDRESS);
	$smarty->assign('shipping_address', tep_address_array($customer_id, $sendto));
	$smarty->assign('shipping_address_formatted', tep_address_label($customer_id, $sendto, true, ' ', '<br />'));
	$smarty->assign('URL_CHECKOUT_SHIPPING_ADDRESS', tep_href_link(FILENAME_CHECKOUT_SHIPPING_ADDRESS, '', 'SSL'));
	$smarty->assign('IMAGE_BUTTON_CHANGE_ADDRESS', IMAGE_BUTTON_CHANGE_ADDRESS);

	$smarty->assign('TABLE_HEADING_SHIPPING_METHOD', TABLE_HEADING_SHIPPING_METHOD);
	$smarty->assign('TABLE_HEADING_COMMENTS', TABLE_HEADING_COMMENTS);
	$smarty->assign('INPUT_COMMENTS', tep_draw_textarea_field('comments', 'soft', '60', '5', '', 'id="text_comments"'));
	$smarty->assign('IMAGE_BUTTON_CONTINUE', IMAGE_BUTTON_CONTINUE);

	$smarty->assign('AVAILABLE_SHIPPING', tep_count_shipping_modules());

	if ( sizeof($quotes) > 1 && sizeof($quotes[0]) > 1 ) {
		$smarty->assign('AVAILABLE_SHIPPING_MORE_THEN_ONE', 'true' );
		$smarty->assign('TEXT_CHOOSE_SHIPPING_METHOD', TEXT_CHOOSE_SHIPPING_METHOD);
		$smarty->assign('TITLE_PLEASE_SELECT', TITLE_PLEASE_SELECT);
	}


	if ( true === $free_shipping ) {
		$smarty->assign('FREE_SHIPPING', 'true' );
		$smarty->assign('FREE_SHIPPING_TITLE', $free_shipping_title );
		$smarty->assign('FREE_SHIPPING_ICON', $quote['icon']);
		$smarty->assign('FREE_SHIPPING_DESCRIPTION',  tep_draw_hidden_field('shipping', 'free_free'));

	}

	if ( 0 < count($quotes) ) {
		foreach ( $quotes as $quote ) {
			if ( false === empty($quote['error']) ) {
				$messageStack->add('quote_error', $quote['error'], 'error');
			} else {

				foreach ( $quote['methods'] as $method ) {
					$shipping_out['title'] = $method['title'];
					$checked = ( ($quote['id'] . '_' . $method['id'] == $shipping['id']) ? true : false );

					if ( (count($quote['methods']) > 1) || (count($quote) > 1) ) {
						$shipping_out['price'] = $currencies->format(tep_add_tax($method['cost'], (isset($quote['tax']) ? $quote['tax'] : 0)));
						$shipping_out['radio'] = tep_draw_radio_field('shipping', $quote['id'] . '_' . $method['id'], $checked , 'id="'.$quote['id'] . '_' . $method['id'].'"' );
						$shipping_out['radio_id'] = $quote['id'] . '_' . $method['id'];
					} else {
						$shipping_out['price'] = $currencies->format(tep_add_tax($method['cost'], $quote['tax']));
						$shipping_out['hidden'] = tep_draw_hidden_field('shipping', $quote['id'] . '_' . $method['id']);
					}

				}
			}
			$_SHIPPING[] = $shipping_out;

		}
		$smarty->assign('_SHIPPING', $_SHIPPING);
	} else {
		$messageStack->add('quote_error', TEXT_ERROR_NO_SHIPPING_METHODS, 'error');
	}



	require_once ( DIR_WS_INCLUDES . 'meta_tags.php' );

	$smarty->assign('breadcrumb', $breadcrumb->_trail);
	$smarty->assign('messagestack', $messageStack->get_messages());


	$page_content = tep_draw_form('checkout_address', tep_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));
	$page_content .= tep_draw_hidden_field('action', 'process' );
	$page_content .= $smarty->fetch('checkout_shipping.tpl' );
	$page_content .= '</form>';

	$smarty->assign('page_content', $page_content);

	require_once ( DIR_WS_INCLUDES . 'application_bottom.php' );
	$smarty->display('common/page.tpl' );

?>