<?php

  require_once ( 'includes/application_top.php' );

	if (tep_session_is_registered('customer_id')) {
		tep_redirect(tep_href_link(FILENAME_ACCOUNT));
	}

	@include_once ( DIR_WS_LANGUAGES . $language . '/' . FILENAME_CREATE_ACCOUNT);

	if ( true === defined('PHPBB_INTEGRATION') && 'Enabled' == PHPBB_INTEGRATION ) {
		require_once ( DIR_WS_FUNCTIONS . 'phpbb.php' );
	}

	if ( 'On' == CAPTCHA_REGISTRATION ) {
		require_once ( DIR_WS_FUNCTIONS. 'captcha.php' );
		$show_captcha = ( 'Logic' == CAPTCHA_REGISTRATION_TYPE ? tep_show_registration_captcha_by_ip() : true );
	}
	$process = false;
	$refresh = false;
	if (isset($_POST['action']) && (($_POST['action'] == 'process') || ($_POST['action'] == 'refresh'))) {
		if ( $_POST['action'] == 'process' ) $process = true;
		if ( $_POST['action'] == 'refresh' ) $refresh = true;

    if (ACCOUNT_GENDER == 'true') {
      if (isset($_POST['gender'])) {
        $gender = tep_db_prepare_input($_POST['gender']);
      } else {
        $gender = false;
      }
    }
    $firstname = tep_db_prepare_input($_POST['firstname']);
    $lastname = tep_db_prepare_input($_POST['lastname']);
    if ( 'true' === ACCOUNT_DOB ) {
		$dob_month = tep_db_prepare_input($_POST['dob_month']);
		$dob_day = tep_db_prepare_input($_POST['dob_day']);
		$dob_year = tep_db_prepare_input($_POST['dob_year']);
		$dob = $dob_month . '/' . $dob_day . '/' . $dob_year;
    }

    $email_address = tep_db_prepare_input($_POST['email_address']);
    $username = tep_db_prepare_input($_POST['username']);

    if (ACCOUNT_COMPANY == 'true') {
    $company = tep_db_prepare_input($_POST['company']);
    $company_tax_id = tep_db_prepare_input($_POST['company_tax_id']);
    }

    $street_address = tep_db_prepare_input($_POST['street_address']);
    if (ACCOUNT_SUBURB == 'true') $suburb = tep_db_prepare_input($_POST['suburb']);
    $postcode = tep_db_prepare_input($_POST['postcode']);
    $city = tep_db_prepare_input($_POST['city']);
    if (ACCOUNT_STATE == 'true') {
      $state = tep_db_prepare_input($_POST['state']);
      if (isset($_POST['zone_id'])) {
        $zone_id = tep_db_prepare_input($_POST['zone_id']);
      } else {
        $zone_id = false;
      }
    }
    $country = tep_db_prepare_input($_POST['country']);

	if ( '223' == $country ) { # check if US 1[3][3][4]
		$phone1 = tep_db_prepare_input($_POST['phoneAreaCode']);
		$phone2 = tep_db_prepare_input($_POST['phonePrefix']);
		$phone3 = tep_db_prepare_input($_POST['phoneNumber']);
		$telephone = $phone1."-".$phone2."-".$phone3;

		if ( 'true' == ACCOUNT_FAX ) {
			$fax1 = tep_db_prepare_input($_POST['faxAreaCode']);
			$fax2 = tep_db_prepare_input($_POST['faxPrefix']);
			$fax3 = tep_db_prepare_input($_POST['faxNumber']);
			$fax = $fax1."-".$fax2."-".$fax3;
		}
    } else {
		$telephone = tep_db_prepare_input($_POST['phone']);
		if ( 'true' == ACCOUNT_FAX ) {
			$fax = tep_db_prepare_input($_POST['fax']);
		}
    }

    if (isset($_POST['newsletter'])) {
      $newsletter = tep_db_prepare_input($_POST['newsletter']);
    } else {
      $newsletter = false;
    }
    $password = tep_db_prepare_input($_POST['password']);
    $confirmation = tep_db_prepare_input($_POST['confirmation']);

    if ($process) {
    $error         = false;
	$error_type    = array();
	$error_message = '';

    if (ACCOUNT_GENDER == 'true') {
      if ( ($gender != 'm') && ($gender != 'f') ) {
        $error = true;
		$error_type['gender'] = true;
		$error_message .= ENTRY_GENDER_ERROR."<br />";
      }
    }

    if (strlen($firstname) < ENTRY_FIRST_NAME_MIN_LENGTH) {
      $error = true;
	  $error_type['firstname'] = true;
      $error_message .= ENTRY_FIRST_NAME_ERROR."<br />";
    }

    if (strlen($lastname) < ENTRY_LAST_NAME_MIN_LENGTH) {
      $error = true;
	  $error_type['lastname'] = true;
      $error_message .= ENTRY_LAST_NAME_ERROR."<br />";
    }

    if (ACCOUNT_DOB == 'true') {
	if( !$dob_month ) {
		$error_type['dob_month'] = true;
		$error_type['dob'] = true;
		$error = true;
	}
	if( !$dob_day ) {
		$error_type['dob_day'] = true;
		$error_type['dob'] = true;
		$error = true;
	}
	if( !$dob_year ) {
		$error_type['dob_year'] = true;
		$error_type['dob'] = true;
		$error = true;
	}
     if ( !checkdate($dob_month, $dob_day, $dob_year ) ) {
     	$error_type['dob_month'] = true;
     	$error_type['dob_day'] = true;
		$error_type['dob'] = true;
      }
      if( true === $error_type['dob'] )
      $error_message .= ENTRY_DATE_OF_BIRTH_ERROR."<br />";

    }

    if ( 'On' == ACCOUNT_AGREE_TO_TERMS ) {
    	$agreed_to_terms = tep_db_prepare_input($_POST['agreed_to_terms']);
    	if ( 'no' == $agreed_to_terms ) {
    		tep_redirect(tep_href_link(FILENAME_DEFAULT));
    		exit();
    	}
    	if ( 'yes' != $agreed_to_terms ) {
    		$error = true;
    		$error_type['agreed_to_terms'] = true;
    		$error_message .= ENTRY_AGREE_TO_TERMS_ERROR."<br />";
    	}


    }

    if (strlen($email_address) < ENTRY_EMAIL_ADDRESS_MIN_LENGTH) {
      $error = true;
	  $error_type['email_address'] = true;
      $error_message .= ENTRY_EMAIL_ADDRESS_ERROR."<br />";

    } elseif (tep_validate_email($email_address) == false) {
      $error = true;
	  $error_type['email_address'] = true;
      $error_message .= ENTRY_EMAIL_ADDRESS_CHECK_ERROR."<br />";

    } else {
      $check_email_query = tep_db_query("select count(*) as total from " . TABLE_CUSTOMERS . " where customers_email_address = '" . tep_db_input($email_address) . "'");
      $check_email = tep_db_fetch_array($check_email_query);
      if ($check_email['total'] > 0 && tep_paypal_wpp_create_account_check($email_address)) {
        $get_customer_info = tep_db_query("select customers_id, customers_email_address, purchased_without_account from " . TABLE_CUSTOMERS . " where customers_email_address = '" . tep_db_input($email_address) . "'");
        $customer_info = tep_db_fetch_array($get_customer_info);
        $customer_id = $customer_info['customers_id'];
        $customer_email_address = $customer_info['customers_email_address'];
        $customer_pwa = $customer_info['purchased_without_account'];
        $phpbb_email_exists = false;
        if ( true === defined('PHPBB_INTEGRATION') && 'Enabled' == PHPBB_INTEGRATION ) {
			$phpbb_email_exists = phpbb_email_exists($email_address);
        }
        if ( '1' != $customer_pwa  || true === $phpbb_email_exists ) {
           $error = true;
		   $error_type['email_address'] = true;
           $error_message .= ENTRY_EMAIL_ADDRESS_ERROR_EXISTS."<br />";

        } else {
          tep_db_query("delete from " . TABLE_ADDRESS_BOOK . " where customers_id = '" . $customer_id . "'");
          tep_db_query("delete from " . TABLE_CUSTOMERS . " where customers_id = '" . $customer_id . "'");
          tep_db_query("delete from " . TABLE_CUSTOMERS_INFO . " where customers_info_id = '" . $customer_id . "'");
          tep_db_query("delete from " . TABLE_CUSTOMERS_BASKET . " where customers_id = '" . $customer_id . "'");
          tep_db_query("delete from " . TABLE_CUSTOMERS_BASKET_ATTRIBUTES . " where customers_id = '" . $customer_id . "'");
          tep_db_query("delete from " . TABLE_WHOS_ONLINE . " where customer_id = '" . $customer_id . "'");
        }
      }
    }

    if (strlen($street_address) < ENTRY_STREET_ADDRESS_MIN_LENGTH) {
      $error = true;
	  $error_type['street_address'] = true;
      $error_message .= ENTRY_STREET_ADDRESS_ERROR."<br />";
    }

    if (strlen($postcode) < ENTRY_POSTCODE_MIN_LENGTH) {
      $error = true;
	  $error_type['postcode'] = true;
      $error_message .= ENTRY_POST_CODE_ERROR."<br />";
    }

    if (strlen($city) < ENTRY_CITY_MIN_LENGTH) {
      $error = true;
	  $error_type['city'] = true;

      $error_message .= ENTRY_CITY_ERROR."<br />";
    }

    if (strlen($state) < ENTRY_STATE_MIN_LENTH) {
      $error = true;
	  $error_type['state'] = true;
      $error_message .= ENTRY_STATE_ERROR."<br />";
    }

    if (is_numeric($country) == false) {
      $error = true;
	  $error_type['country'] = true;
      $error_message .= ENTRY_COUNTRY_ERROR."<br />";
    }

    if (ACCOUNT_STATE == 'true') {
      $zone_id = 0;
      $check_query = tep_db_query("select count(*) as total from " . TABLE_ZONES . " where zone_country_id = '" . (int)$country . "'");
      $check = tep_db_fetch_array($check_query);
      $entry_state_has_zones = ($check['total'] > 0);
      if ($entry_state_has_zones == true) {
        $zone_query = tep_db_query("select distinct zone_id from " . TABLE_ZONES . " where zone_country_id = '" . (int)$country . "' and (zone_name like '" . tep_db_input($state) . "%' or zone_code like '%" . tep_db_input($state) . "%')");
        if (tep_db_num_rows($zone_query) == 1) {
          $zone = tep_db_fetch_array($zone_query);
          $zone_id = $zone['zone_id'];
        } else {
          $error = true;
		$error_type['state'] = true;
          $error_message .= ENTRY_STATE_ERROR_SELECT."<br />";
        }
      } else {
        if (strlen($state) < ENTRY_STATE_MIN_LENGTH) {
          $error = true;
		$error_type['state'] = true;
          $error_message .= ENTRY_STATE_ERROR."<br />";
        }
      }
    }

    if ( '223' == $country ) { # check if US
		if (strlen($phone1) < 3) $error_type['phoneAreaCode'] = true;
		if (strlen($phone2) < 3) $error_type['phonePrefix'] = true;
		if (strlen($phone3) < 4) $error_type['phoneNumber'] = true;
		if ( (strlen($phone1) < 3) || (strlen($phone2) < 3) || (strlen($phone3) < 4) ) {
			$error = true;
			$error_message .= ENTRY_PHONE_NUMBER_ERROR."<br />";
		}
		if ( 'true' == ACCOUNT_FAX ) {
			if ( false === empty($fax1) || false === empty($fax2) || false === empty($fax3) ) {
				if (strlen($fax1) < 3) $error_type['faxAreaCode'] = true;
				if (strlen($fax2) < 3) $error_type['faxPrefix'] = true;
				if (strlen($fax3) < 4) $error_type['faxNumber'] = true;
				if ( (strlen($fax1) < 3) || (strlen($fax2) < 3) || (strlen($fax3) < 4) ) {
					$error = true;
					$error_message .= ENTRY_FAX_NUMBER_ERROR."<br />";
				}
			}
		}
	} else {
		if (strlen($telephone) < 8) {
			$error = true;
			$error_type['phoneNumber'] = true;
		}
		if ( 'true' == ACCOUNT_FAX ) {
			if ( false === empty($fax) ) {
				if (strlen($fax) < 8) {
					$error = true;
					$error_type['faxNumber'] = true;
				}
			}
		}
	}


    if (strlen($password) < ENTRY_PASSWORD_MIN_LENGTH) {
      $error = true;
	  $error_type['password'] = true;

      $error_message .= ENTRY_PASSWORD_ERROR."<br />";
    } elseif ($password != $confirmation) {
      $error = true;
	  $error_type['password'] = true;

      $error_message .= ENTRY_PASSWORD_ERROR_NOT_MATCHING."<br />";
    }


	if ( 'On' == CAPTCHA_REGISTRATION && true === $show_captcha  ) {
		$security_entered = urlsafe_b64encode(CAP_RC4(CAPTCHA_ENCRYPTION_KEY, (strtoupper(tep_db_prepare_input($_POST['security'])))));
		if ( true === empty($security_entered) || $security_entered != $_SESSION['captcha_secure_code'] ) {
			$securitycode_error = true;
			$error_type['captcha'] = true;
			$error = true;
			$error_message .= ERROR_SECURITY . "<br />";

		}
	}


	if ( true === defined('PHPBB_INTEGRATION') && 'Enabled' == PHPBB_INTEGRATION && '1' == $_POST['forum_account'] ) {
		if ( true === empty($username) ) {
			$securitycode_error = true;
			$error_type['username'] = true;
			$error = true;
			$error_message .= ENTRY_USENAME_ERROR_EMPTY . "<br />";
		} elseif ( true === phpbb_username_exists($username) ) {
			$securitycode_error = true;
			$error_type['username'] = true;
			$error = true;
			$error_message .= ENTRY_USENAME_ERROR_EXISTS . "<br />";
		}
	}



	if ($error == true) {
		$messageStack->add('create_account', $error_message);
	}

	if ($error == false) {
		$name = $firstname . ' ' . $lastname;

	if ( true === defined('PHPBB_INTEGRATION') && 'Enabled' == PHPBB_INTEGRATION && '1' == $_POST['forum_account'] ) {
		phpbb_create_forum_account($email_address, $username, $password);
	}


      $customers_email_confirmation_key = tep_create_random_value(15);
      $sql_data_array = array('customers_firstname' => $firstname,
                              'customers_lastname' => $lastname,
                              'customers_email_address' => $email_address,
							  'customers_user_id' => $username,
                              'customers_email_confirmation_key' => $customers_email_confirmation_key,
                              'customers_telephone' => $telephone,
                              'customers_fax' => $fax,
                              'customers_newsletter' => $newsletter,
                              'customers_password' => tep_encrypt_password($password),
                              'registration_ip_address' => $_SERVER['REMOTE_ADDR']
                              );

      if ( ACCOUNT_GENDER == 'true' ) $sql_data_array['customers_gender'] = $gender;
      if ( ACCOUNT_DOB == 'true' ) $sql_data_array['customers_dob'] = tep_date_raw($dob);
      if ( ACCOUNT_COMPANY == 'true' && tep_not_null($company_tax_id)  ) {
        $sql_data_array['customers_group_ra'] = '1';
      }

      tep_db_perform(TABLE_CUSTOMERS, $sql_data_array);

      $customer_id = tep_db_insert_id();

		if ( true === defined('PHPBB_INTEGRATION') && 'Enabled' == PHPBB_INTEGRATION && '1' == $_POST['forum_account'] ) {
			phpbb_user_login($customer_id);
		}

      $sql_data_array = array('customers_id' => $customer_id,
                              'entry_firstname' => $firstname,
                              'entry_lastname' => $lastname,
                              'entry_street_address' => $street_address,
                              'entry_postcode' => $postcode,
                              'entry_city' => $city,
                              'entry_state' => $state,
                              'entry_country_id' => $country);

      if (ACCOUNT_GENDER == 'true') $sql_data_array['entry_gender'] = $gender;

      if (ACCOUNT_COMPANY == 'true') {
        $sql_data_array['entry_company'] = $company;
        $sql_data_array['entry_company_tax_id'] = $company_tax_id;
      }

      if (ACCOUNT_SUBURB == 'true') $sql_data_array['entry_suburb'] = $suburb;
      if (ACCOUNT_STATE == 'true') {
      	$zone_id = ( $zone_id > 0 ? $zone_id : '0' );
        $sql_data_array['entry_zone_id'] = $zone_id;
        $sql_data_array['entry_state'] = $state;
      }

      tep_db_perform(TABLE_ADDRESS_BOOK, $sql_data_array);

      $address_id = tep_db_insert_id();

      tep_db_query("update " . TABLE_CUSTOMERS . " set customers_default_address_id = '" . (int)$address_id . "' where customers_id = '" . (int)$customer_id . "'");

      tep_db_query("insert into " . TABLE_CUSTOMERS_INFO . " (customers_info_id, customers_info_number_of_logons, customers_info_date_account_created) values ('" . (int)$customer_id . "', '0', now())");

      if (SESSION_RECREATE == 'True') {
        tep_session_recreate();
        $SID=tep_session_name() . '=' . tep_session_id();
      }

      $customer_first_name = $firstname;
      $customer_default_address_id = $address_id;
      $customer_country_id = $country;
      $customer_zone_id = $zone_id;
      tep_session_register('customer_id' );
      tep_session_register('customer_first_name' );
      tep_session_register('customer_default_address_id' );
      tep_session_register('customer_country_id' );
      tep_session_register('customer_zone_id' );

	$cart->restore_contents();
	$wishList->restore_wishlist();








      if (ACCOUNT_GENDER == 'true') {
         if ($gender == 'm') {
           $email_text = sprintf(EMAIL_GREET_MR, $lastname);
         } else {
           $email_text = sprintf(EMAIL_GREET_MS, $lastname);
         }
      } else {
        $email_text = sprintf(EMAIL_GREET_NONE, $firstname);
      }

		$email_text .= EMAIL_WELCOME . EMAIL_TEXT . ( 'On' == NEWSLETTER_CONFIRM_EMAIL ? sprintf(EMAIL_CONFIRM, htmlspecialchars_decode(tep_href_link(FILENAME_ACCOUNT_NEWSLETTERS, "action=confirm_email&confirmation_key=$customers_email_confirmation_key", 'SSL', false))) : '' ) . EMAIL_CONTACT . EMAIL_WARNING;

	  if ( true == defined('NEW_SIGNUP_GIFT_VOUCHER_AMOUNT') ) {
	  	if (NEW_SIGNUP_GIFT_VOUCHER_AMOUNT > 0) {
	  		$coupon_code = create_coupon_code();
	  		$insert_query = tep_db_query("insert into " . TABLE_COUPONS . " (coupon_code, coupon_type, coupon_amount, date_created) values ('" . $coupon_code . "', 'G', '" . NEW_SIGNUP_GIFT_VOUCHER_AMOUNT . "', now())");
	  		$insert_id = tep_db_insert_id($insert_query);
	  		$insert_query = tep_db_query("insert into " . TABLE_COUPON_EMAIL_TRACK . " (coupon_id, customer_id_sent, sent_firstname, emailed_to, date_sent) values ('" . $insert_id ."', '0', 'Admin', '" . $email_address . "', now() )");

	  		$email_text .= sprintf(EMAIL_GV_INCENTIVE_HEADER, $currencies->format(NEW_SIGNUP_GIFT_VOUCHER_AMOUNT)) . "\n\n" .
                   sprintf(EMAIL_GV_REDEEM, $coupon_code) . "\n\n" .
                   EMAIL_GV_LINK . tep_href_link(FILENAME_GV_REDEEM, 'gv_no=' . $coupon_code,'NONSSL', false) .
                   "\n\n";
	  	}
	  }
	if ( true == defined('NEW_SIGNUP_DISCOUNT_COUPON') && '' != NEW_SIGNUP_DISCOUNT_COUPON ) {
		$coupon_code = NEW_SIGNUP_DISCOUNT_COUPON;
		$coupon_query = tep_db_query("select * from " . TABLE_COUPONS . " where coupon_code = '" . $coupon_code . "'");
		$coupon = tep_db_fetch_array($coupon_query);
		$coupon_id = $coupon['coupon_code'];
		$coupon_desc_query = tep_db_query("select * from " . TABLE_COUPONS_DESCRIPTION . " where coupon_id = '" . $coupon_id . "' and language_id = '" . (int)$languages_id . "'");
		$coupon_desc = tep_db_fetch_array($coupon_desc_query);
		$insert_query = tep_db_query("insert into " . TABLE_COUPON_EMAIL_TRACK . " (coupon_id, customer_id_sent, sent_firstname, emailed_to, date_sent) values ('" . $coupon_id ."', '0', 'Admin', '" . $email_address . "', now() )");
		$email_text .= EMAIL_COUPON_INCENTIVE_HEADER .  "\n" .
                   sprintf("%s", $coupon_desc['coupon_description']) ."\n\n" .
                   sprintf(EMAIL_COUPON_REDEEM, $coupon['coupon_code']) . "\n\n" .
                   "\n\n";
	}
	if ( true === defined('PHPBB_INTEGRATION') && 'Enabled' == PHPBB_INTEGRATION && 'User' === PHPBB_ACCOUNT_ACTIVATION  ) {
		$phpbb_userid = phpbb_get_user_id($username);
		$phpbb_activation_key = phpbb_get_activation_key($username);
		$phpbb_activation_url = HTTP_SERVER . DIR_WS_HTTP_CATALOG . PHPBB_DIR . "ucp.php?mode=activate&u=" . $phpbb_userid. '&k=' . $phpbb_activation_key;
		$email_text .= sprintf(TEXT_ACTIVATE_BOARD_ACCOUNT, $phpbb_activation_url);
	}

      if (tep_session_is_registered('floating_gv_code')) {
        $gv_query = tep_db_query("SELECT c.coupon_id, c.coupon_amount, IF(rt.coupon_id>0, 'true', 'false') AS redeemed FROM ". TABLE_COUPONS ." c LEFT JOIN ". TABLE_COUPON_REDEEM_TRACK." rt USING(coupon_id), ". TABLE_COUPON_EMAIL_TRACK ." et WHERE c.coupon_code = '". $floating_gv_code ."' AND c.coupon_id = et.coupon_id");
        // check if coupon exist
        if (tep_db_num_rows($gv_query) >0) {
          $coupon = tep_db_fetch_array($gv_query);
          // check if coupon_id exist and coupon not redeemed
          if($coupon['coupon_id']>0 && $coupon['redeemed'] == 'false') {
              tep_session_unregister('floating_gv_code' );
              $gv_query = tep_db_query("insert into  " . TABLE_COUPON_REDEEM_TRACK . " (coupon_id, customer_id, redeem_date, redeem_ip) values ('" . $coupon['coupon_id'] . "', '" . $customer_id . "', now(),'" . $REMOTE_ADDR . "')");
              $gv_update = tep_db_query("update " . TABLE_COUPONS . " set coupon_active = 'N' where coupon_id = '" . $coupon['coupon_id'] . "'");
              tep_gv_account_update($customer_id, $coupon['coupon_id']);
          }
        }
      }

      @tep_mail($name, $email_address, EMAIL_SUBJECT, $email_text, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);

      // alert shop owner of account created by a company
      if ( ACCOUNT_COMPANY == 'true' && tep_not_null($company_tax_id) ) {
        $alert_email_text = "Please note that " . $firstname . " " . $lastname . " of the company: " . $company . " has created an account.";
        @tep_mail(STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS, 'Company account created', $alert_email_text, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
      }


	if (sizeof($navigation->snapshot) > 0 && '' != $navigation->snapshot['page']) {
          $origin_href = tep_href_link($navigation->snapshot['page'], tep_array_to_string($navigation->snapshot['get'], array(tep_session_name())), $navigation->snapshot['mode']);
          $navigation->clear_snapshot();
          tep_redirect($origin_href);
        } else {
        	tep_redirect(tep_href_link(FILENAME_CREATE_ACCOUNT_SUCCESS, '', 'SSL'));
        }
    }
  }

 }
	if ($_POST['action'] == 'refresh') {$state = '';}
	$country = ( true === empty($country) ? DEFAULT_COUNTRY : $country );

	$content = CONTENT_CREATE_ACCOUNT;
	$smarty->assign('create_account_active', ' class="active"');
	$smarty->assign('messagestack', $messageStack->get_messages());
	$smarty->assign('error_type', $error_type);

	$smarty->assign('HEADER_TITLE', NAVBAR_TITLE);

	$class = ( true === $error_type['email_address'] ? 'inputNormalError' : 'inputNormal' );
	$smarty->assign('INPUT_EMAIL_ADDRESS', tep_draw_input_field('email_address', '', 'id="email_address" class="'.$class.'"'));

	if ( true === defined('PHPBB_INTEGRATION') && 'Enabled' == PHPBB_INTEGRATION ) {
		$class = ( true === $error_type['username'] ? 'inputNormalError' : 'inputNormal' );
		$smarty->assign('INPUT_USERNAME', tep_draw_input_field('username', '', 'id="username" class="'.$class.'"'));
		$forum_account_1 = ( '1' == $_POST['forum_account'] || false === isset($_POST['forum_account']) ? true : false );
		$forum_account_0 = ( '0' == $_POST['forum_account'] ? true : false );
		$smarty->assign('INPUT_FORUM_ACCOUNT', tep_draw_radio_field('forum_account', '1', $forum_account_1, 'id="forum_account_1" onclick="document.getElementById(\'username\').disabled=false;"') . '&nbsp;&nbsp;' . TEXT_YES . '&nbsp;&nbsp;' . tep_draw_radio_field('forum_account', '0', $forum_account_0, 'id="forum_account_0" onclick="document.getElementById(\'username\').disabled=true;"') . '&nbsp;&nbsp;' . TEXT_NO );
	}





	$class = ( true === $error_type['password'] ? 'inputNormalError' : 'inputNormal' );
	$smarty->assign('INPUT_PASSWORD', tep_draw_password_field('password', $password, 'id="password" class="'.$class.'"'));
	$smarty->assign('INPUT_PASSWORD_CONFIRMATION', tep_draw_password_field('confirmation', $confirmation, 'id="confirmation" class="'.$class.'"'));


	if ( 'true' == ACCOUNT_GENDER ) {
		$class = ( true === $error_type['gender'] ? ' class="inputNormalError"' : '' );
		$smarty->assign('INPUT_ENTRY_GENDER', '<span'.$class.'>'.tep_draw_radio_field('gender', 'm', false, 'id="gender_m"') . '&nbsp;&nbsp;' . MALE . '&nbsp;&nbsp;' . tep_draw_radio_field('gender', 'f', false, 'id="gender_f"') . '&nbsp;&nbsp;' . FEMALE . '</span>' );
	}

	$class = ( true === $error_type['firstname'] ? 'inputNormalError' : 'inputNormal' );
	$smarty->assign('INPUT_FIRST_NAME', tep_draw_input_field('firstname', '','class="'.$class.'" id="firstname"'));

	$class = ( true === $error_type['lastname'] ? 'inputNormalError' : 'inputNormal' );
	$smarty->assign('INPUT_LAST_NAME', tep_draw_input_field('lastname', '','class="'.$class.'" id="lastname"'));


	if ( 'true' == ACCOUNT_DOB ) {
		$class = ( true === $error_type['lastname'] ? 'inputNormalError' : 'inputNormal' );
		$dob_month_values = array();
				array_push($dob_month_values, array('id' => '0','text' => TEXT_EXAMPLE_MONTH));
				for ( $i=1; $i <= 12; $i++ ) {
					$pre = ( $i <= 9 ? '0' : '' );
					array_push($dob_month_values,
						array('id'=>$pre.$i,'text'=>$pre.$i)
					);
				}
		$class = ( true === $error_type['dob_month'] ? 'inputNormalError' : '' );
		$smarty->assign('INPUT_DATE_OF_BIRTH_MONTH', tep_draw_pull_down_menu('dob_month', $dob_month_values, NULL, 'id="dob_month"'.$class));

		$dob_month_full_values = array();
				array_push($dob_month_full_values, array('id' => '0','text' => TEXT_EXAMPLE_MONTH_FULL));
				for ( $i=1; $i <= 12; $i++ ) {
					$pre = ( $i <= 9 ? '0' : '' );
					array_push($dob_month_full_values,
						array('id'=>$pre.$i,'text'=>$pre.$i.' - '.getMonth($i))
					);
				}
		$class = ( true === $error_type['dob_month'] ? ' class="inputNormalError"' : '' );
		$smarty->assign('INPUT_DATE_OF_BIRTH_MONTH_FULL', tep_draw_pull_down_menu('dob_month', $dob_month_full_values, NULL, 'id="dob_month"'.$class));


		$dob_month_name_values = array();
				array_push($dob_month_name_values, array('id' => '0','text' => TEXT_EXAMPLE_MONTH_NAME));
				for ( $i=1; $i <= 12; $i++ ) {
					$pre = ( $i <= 9 ? '0' : '' );
					array_push($dob_month_name_values,
						array('id'=>$pre.$i,'text'=>getMonth($i))
					);
				}
		$class = ( true === $error_type['dob_month'] ? ' class="inputNormalError"' : '' );
		$smarty->assign('INPUT_DATE_OF_BIRTH_MONTH_NAMES', tep_draw_pull_down_menu('dob_month', $dob_month_name_values, NULL, 'id="dob_month"'.$class));


		$dob_day_values = array();
				array_push($dob_day_values, array('id' => '0','text' => TEXT_EXAMPLE_DAY));
				for ( $i=1; $i <= 31; $i++ ) {
					$pre = ( $i <= 9 ? '0' : '' );
					array_push($dob_day_values,
						array('id'=>$pre.$i,'text'=>$pre.$i)
					);
				}

		$class = ( true === $error_type['dob_day'] ? 'inputNormalError' : '' );
		$smarty->assign('INPUT_DATE_OF_BIRTH_DAY', tep_draw_pull_down_menu('dob_day', $dob_day_values, NULL, 'class="'.$class.'"'));


		$dob_year_values = array();
				$c_year = date('Y' );
				array_push($dob_year_values, array('id' => '0','text' => TEXT_EXAMPLE_YEAR));
				for ( $i=($c_year-10); $i >= ($c_year-90); $i-- ) {
					array_push($dob_year_values,
						array('id'=>$i,'text'=>$i)
					);
				}
		$class = ( true === $error_type['dob_year'] ? 'inputNormalError' : '' );
		$smarty->assign('INPUT_DATE_OF_BIRTH_YEAR', tep_draw_pull_down_menu('dob_year', $dob_year_values, NULL, 'class="'.$class.'"'));
	}


	if ( 'true' == ACCOUNT_COMPANY ) {
		$class = ( true === $error_type['company'] ? 'inputNormalError' : 'inputNormal' );
		$smarty->assign('INPUT_COMPANY', tep_draw_input_field('company', '','class="'.$class.'" id="company"'));

		$class = ( true === $error_type['company_tax_id'] ? 'inputNormalError' : 'inputNormal' );
		$smarty->assign('INPUT_COMPANY_TAX_ID', tep_draw_input_field('company_tax_id', '','class="'.$class.'" id="company_tax_id"'));
	}

	$class = ( true === $error_type['street_address'] ? 'inputNormalError' : 'inputNormal' );
	$smarty->assign('INPUT_STREET_ADDRESS', tep_draw_input_field('street_address', '', 'class="'.$class.'" id="street_address"'));


	if ( 'true' == ACCOUNT_SUBURB ) {
		$class = ( true === $error_type['suburb'] ? 'inputNormalError' : 'inputNormal' );
		$smarty->assign('INPUT_SUBURB', tep_draw_input_field('suburb', '','class="'.$class.'" id="suburb"'));
	}

	$class = ( true === $error_type['city'] ? 'inputNormalError' : 'inputNormal' );
	$smarty->assign('INPUT_CITY', tep_draw_input_field('city', '', 'class="'.$class.'" id="city"'));


	if ( 'true' == ACCOUNT_STATE ) {
		$class = ( true === $error_type['state'] ? 'inputNormalError' : 'inputNormal' );
		$zones_array = array();
		$zones_query_sql = "
							SELECT
								zone_name
							FROM
								" . TABLE_ZONES . "
							WHERE
								zone_country_id = '$country'
							ORDER BY zone_name";
		$zones_query = tep_db_query($zones_query_sql);
		if ( 0 < tep_db_num_rows($zones_query) ) {
			$zones_array[] = array('id' => '', 'text' => PULL_DOWN_DEFAULT );
			while ($zones_values = tep_db_fetch_array($zones_query)) {
				$zones_array[] = array('id' => $zones_values['zone_name'], 'text' => $zones_values['zone_name']);
			}
			$output_states = tep_draw_pull_down_menu('state', $zones_array, '', 'class="'.$class.'" id="state"' );
		} else {
			$output_states = tep_draw_input_field('state','','class="'.$class.'" id="state"' );
		}

		$smarty->assign('INPUT_STATE', $output_states);
	}

	$class = ( true === $error_type['postcode'] ? 'inputNormalError' : 'inputNormal' );
	$smarty->assign('INPUT_POST_CODE', tep_draw_input_field('postcode', '', 'class="'.$class.'" id="postcode"'));

	if ( 'true' == ACCOUNT_COUNTRY ) {
		$class = ( true === $error_type['country'] ? 'inputNormalError' : 'inputNormal' );
		$smarty->assign('INPUT_COUNTRY', tep_get_country_list('country', $country,'onchange="return refresh_form(\'create_account\');" id="country"'));
	} else {
		$smarty->assign('INPUT_COUNTRY', tep_draw_hidden_field('country', STORE_COUNTRY));
	}

	if ( '223' == $country ) { # check if US
	$class = ( true === $error_type['phoneAreaCode'] ? 'inputNormalError' : 'inputNormal' );
	$phoneAreaCode = tep_draw_input_field('phoneAreaCode', $phone1, 'id="phone" class="'.$class.'" size="3" onselect="stopAutoTab();" maxlength="3" style="width:35px;" onkeypress="AutoTabEdit(this,3,event);" onclick="this.value=\'\';"' );
	$class = ( true === $error_type['phonePrefix'] ? 'inputNormalError' : 'inputNormal' );
	$phonePrefix = tep_draw_input_field('phonePrefix', $phone2, 'id="phonePrefix" class="'.$class.'" size="3" onselect="stopAutoTab();" maxlength="3" style="width:35px;" onkeypress="AutoTabEdit(this,3,event);" onclick="this.value=\'\';"' );
	$class = ( true === $error_type['phoneNumber'] ? 'inputNormalError' : 'inputNormal' );
	$phoneNumber = tep_draw_input_field('phoneNumber', $phone3, 'id="phoneNumber" class="'.$class.'" size="4" onselect="stopAutoTab();" maxlength="4" style="width:40px;" onkeypress="CaptureEnterKey(event);"' );
	$smarty->assign('INPUT_TELEPHONE_NUMBER', $phoneAreaCode . '-' . $phonePrefix . '-' . $phoneNumber);

	if ( 'true' == ACCOUNT_FAX ) {
		$class = ( true === $error_type['faxAreaCode'] ? 'inputNormalError' : 'inputNormal' );
		$faxAreaCode = tep_draw_input_field('faxAreaCode', $fax1, 'id="fax" class="'.$class.'" size="3" onselect="stopAutoTab();" maxlength="3" style="width:35px;" onkeypress="AutoTabEdit(this,3,event);" onclick="this.value=\'\';"' );
		$class = ( true === $error_type['faxPrefix'] ? 'inputNormalError' : 'inputNormal' );
		$faxPrefix = tep_draw_input_field('faxPrefix', $fax2, 'id="faxPrefix" class="'.$class.'" size="3" onselect="stopAutoTab();" maxlength="3" style="width:35px;" onkeypress="AutoTabEdit(this,3,event);" onclick="this.value=\'\';"' );
		$class = ( true === $error_type['faxNumber'] ? 'inputNormalError' : 'inputNormal' );
		$faxNumber = tep_draw_input_field('faxNumber', $fax3, 'id="faxNumber" class="'.$class.'" size="4" onselect="stopAutoTab();" maxlength="4" style="width:40px;" onkeypress="CaptureEnterKey(event);"' );
		$smarty->assign('INPUT_FAX_NUMBER', $faxAreaCode . '-' . $faxPrefix . '-' . $faxNumber);
	}

	} else {
		$class = ( true === $error_type['phoneNumber'] ? 'inputNormalError' : 'inputNormal' );
		$phoneNumber = tep_draw_input_field('phone', $telephone, 'id="phoneNumber" class="'.$class.'"');
		$smarty->assign('INPUT_TELEPHONE_NUMBER', $phoneNumber);
		if ( 'true' == ACCOUNT_FAX ) {
			$class = ( true === $error_type['faxNumber'] ? 'inputNormalError' : 'inputNormal' );
			$faxNumber = tep_draw_input_field('fax', $fax, 'id="fax" class="'.$class.'"');
			$smarty->assign('INPUT_FAX_NUMBER', $faxNumber);
		}
	}


	if ( 'On' == ACCOUNT_AGREE_TO_TERMS ) {
		$smarty->assign('URL_AGREE_TO_TERMS', tep_href_link(ACCOUNT_AGREE_TO_TERMS_URL));
		$terms_values = array(array('id' => '', 'text' => PULL_DOWN_DEFAULT), array('id' => 'yes', 'text' => TEXT_AGREE_TO_TERMS_YES), array('id' => 'no', 'text' => TEXT_AGREE_TO_TERMS_NO));
		$class = ( true === $error_type['agreed_to_terms'] ? 'inputNormalError' : 'inputNormal' );
		$smarty->assign('INPUT_AGREE_TO_TERMS', tep_draw_pull_down_menu('agreed_to_terms', $terms_values, NULL, 'id="agreed_to_terms" class="'.$class.'"'));
	}


	$smarty->assign('INPUT_NEWSLETTER', tep_draw_checkbox_field('newsletter', '1', true, 'id="newsletter"'));


	if ( 'On' == CAPTCHA_REGISTRATION ) {
		$securitycode_error = false;
		if ( true === $show_captcha  )  {
			$security_entered = urlsafe_b64encode(CAP_RC4(CAPTCHA_ENCRYPTION_KEY, (strtoupper(tep_db_prepare_input($_POST['security'])))));
			if ( true === empty($security_entered) || $security_entered != $_SESSION['captcha_secure_code'] ) {
			    	$securitycode_error = true;
			}
		}
	}

	if ( 'On' == CAPTCHA_REGISTRATION && true === $show_captcha  ) {
			$class = ( true === $error_type['captcha'] ? 'inputNormalError' : 'inputNormal' );
			$smarty->assign('INPUT_CAPTCHA', tep_draw_input_field('security', '', 'class="'.$class.'" size="6" id=""'));
			tep_session_register('captcha_secure_code');
			$generated_captcha_key = tep_create_random_value(CAPTCHA_CHARS_NUM);
			$captcha_secure_code = urlsafe_b64encode(CAP_RC4(CAPTCHA_ENCRYPTION_KEY, (strtoupper(tep_db_prepare_input($generated_captcha_key)))));
			$smarty->assign('CAPTCHA_IMAGE', '<img src="'.DIR_WS_IMAGES.'captcha.php?code='.$captcha_secure_code.'" border="0" style="border:1px #CCCCCC dotted; margin:5px;" id="id_captcha" />');
	}

	require_once ( DIR_WS_INCLUDES . 'meta_tags.php' );

	$page_content = tep_draw_form('create_account', tep_href_link(FILENAME_CREATE_ACCOUNT, '', 'SSL'), 'post' );
	$page_content .= '<div>'.tep_draw_hidden_field('action', 'process', 'id="action"' ).'</div>';
	$page_content .= $smarty->fetch('create_account.tpl' );
	$page_content .= '</form>';
	$smarty->assign('page_content', $page_content);

	require_once ( DIR_WS_INCLUDES . 'application_bottom.php' );
	$smarty->display('common/page.tpl' );
?>