<?php
require_once ( '../configure/catalog_configure.php' );
require_once ( '../' . DIR_WS_FUNCTIONS . 'sessions.php' );
require_once ( '../' . DIR_WS_INCLUDES . 'database_tables.php' );
require_once ( '../' . DIR_WS_FUNCTIONS . 'database.php' );

tep_session_name('osCsid');
tep_session_save_path(SESSION_WRITE_DIRECTORY);
tep_session_start();


$configuration_query_sql = 'SELECT configuration_key AS cfgKey, configuration_value AS cfgValue FROM ' . TABLE_CONFIGURATION . " WHERE configuration_group_id = '17'";
$configuration_query = tep_db_query($configuration_query_sql);
while ( $configuration = tep_db_fetch_array($configuration_query) ) {
	define($configuration['cfgKey'], $configuration['cfgValue']);
}


if ( 'true' == $_GET['reload'] ) {
	function tep_generate_random_key($length) {
		$rand_value = '';
	    while (strlen($rand_value) < $length) {
	    	$char = chr(rand(0,255));
	        if (eregi('^[a-z0-9]$', $char)) $rand_value .= $char;
	    }
	    return $rand_value;
	  }
	$code = tep_generate_random_key(CAPTCHA_CHARS_NUM);
	$_SESSION['captcha_secure_code'] = urlsafe_b64encode(CAP_RC4(CAPTCHA_ENCRYPTION_KEY, (strtoupper($code))));
} else {
	$security_code = $_SESSION['captcha_secure_code'];
	$code = CAP_RC4(CAPTCHA_ENCRYPTION_KEY, urlsafe_b64decode($security_code));
}




function urlsafe_b64decode($string) {
	$data = str_replace(array('-','_'),array('+','/'),$string);
	$mod4 = strlen($data) % 4;
	if ($mod4) {
		$data .= substr('====', $mod4);
	}
	return base64_decode($data);
}

function urlsafe_b64encode($string) {
	$data = base64_encode($string);
	$data = str_replace(array('+','/','='),array('-','_',''),$data);
	return $data;
}




  function CAP_RC4($key, $data) {
    // To Encrypt - Call CAP_RC4 with key and plain text.
    // To Decrypt - Call CAP_RC4 with key and encrypted text.
    $key_length = strlen($key);
    for ($i = 0; $i < 255; $i++) {
      $key[$i] = ord(substr($key, ($i % $key_length)+1, 1));
      $counter[$i] = $i;
    }
    for ($i = 0; $i < 255; $i++) {
      $x = ($x + $counter[$i] + $key[$i]) % 256;
      $temp_swap = $counter[$i];
      $counter[$i] = $counter[$x];
      $counter[$x] = $temp_swap;
    }
    for ($i = 0; $i < strlen($data); $i++) {
      $a = ($a + 1) % 256;
      $j = ($j + $counter[$a]) % 256;
      $temp = $counter[$a];
      $counter[$a] = $counter[$j];
      $counter[$j] = $temp;
      $k = $counter[(($counter[$a] + $counter[$j]) % 256)];
      $Xcipher = ord(substr($data, $i, 1)) ^ $k;
      $Xcrypt .= chr($Xcipher);
    }
    return $Xcrypt;
  }


  class GenerateCaptcha {

        var $TTF_folder    = '../fonts/';
        var $TTF_RANGE     = array();
        var $chars         = CAPTCHA_CHARS_NUM;
        var $use_only_md5  = FALSE;
        var $minsize       = 20;
        var $maxsize       = 40;
        var $maxrotation   = CAPTCHA_CHARS_MAX_ROTATION;
        var $noise         = CAPTCHA_NOISE;
        var $websafecolors = FALSE;

	   var $lx            = CAPTCHA_IMAGE_WIDTH;                   // width of picture
        var $ly            = CAPTCHA_IMAGE_HEIGHT;                   // height of picture
        var $jpegquality   = CAPTCHA_IMAGE_QUALITY;     // image quality
        var $nb_noise      = CAPTCHA_NB_NOISE;             // number of background-noise-characters


	function get_TTF() {
		if( $fonts_dir = opendir($this->TTF_folder) ) {

			while ( $file = @readdir($fonts_dir) ) {
				if ( substr(strtolower($file), -4) != '.ttf' ) { continue; }
				if ( is_readable($this->TTF_folder.$file) ) {
					$this->TTF_RANGE[] = $file;
				}
			}

			closedir($fonts_dir);
		}
	}

	function change_TTF() {
		$this->get_TTF();
		if( true === is_array($this->TTF_RANGE) ) {
			srand((float)microtime() * 10000000);
			$key = array_rand($this->TTF_RANGE);
			$this->TTF_file = $this->TTF_folder.$this->TTF_RANGE[$key];
		} else {
			$this->TTF_file = $this->TTF_folder.$this->TTF_RANGE;
		}
            return $this->TTF_file;
        }


	function random_color($min,$max)
        {
            srand((double)microtime() * 1000000);
            $this->r = intval(rand($min,$max));
            srand((double)microtime() * 1000000);
            $this->g = intval(rand($min,$max));
            srand((double)microtime() * 1000000);
            $this->b = intval(rand($min,$max));
        }

	function GenerateCaptcha(){
		global $code;

		$image = @imagecreate($this->lx, $this->ly) or die('Cannot initialize new GD image stream');

		// Set Backgroundcolor
		$this->random_color(224, 255);
		$back =  @imagecolorallocate($image, $this->r, $this->g, $this->b);
		ImageFilledRectangle($image,0,0,$this->lx,$this->ly,$back);


		if ( 'On' == $this->noise ) {
			if ( $this->nb_noise > 0 ) {
	          for($i=0; $i < $this->nb_noise; $i++) {
	                    srand((double)microtime()*1000000);
	                    $size    = intval(rand((int)($this->minsize / 2.3), (int)($this->maxsize / 1.7)));
	                    srand((double)microtime()*1000000);
	                    $angle    = intval(rand(0, 360));
	                    srand((double)microtime()*1000000);
	                    $x        = intval(rand(0, $this->lx));
	                    srand((double)microtime()*1000000);
	                    $y        = intval(rand(0, (int)($this->ly - ($size / 5))));
	                    $this->random_color(160, 224);
	                    $color    = imagecolorallocate($image, $this->r, $this->g, $this->b);
	                    srand((double)microtime()*1000000);
	                    $text    = chr(intval(rand(45,250)));
	                   	ImageTTFText($image, $size, $angle, $x, $y, $color, $this->change_TTF(), $text);
	                }
			} else {
				for($i=0; $i < $this->lx; $i += (int)($this->minsize / 1.5)) {
	                    $this->random_color(160, 224);
	                    $color    = imagecolorallocate($image, $this->r, $this->g, $this->b);
	                    @imageline($image, $i, 0, $i, $this->ly, $color);
	                }

	                for($i=0 ; $i < $this->ly; $i += (int)($this->minsize / 1.8)) {
	                    $this->random_color(160, 224);
	                    $color    = imagecolorallocate($image, $this->r, $this->g, $this->b);
	                    @imageline($image, 0, $i, $this->lx, $i, $color);
	                }
			}
		}

		// generate Text

		for($i=0, $x = intval(rand($this->minsize,$this->maxsize)); $i < $this->chars; $i++) {
                $text    = strtoupper(substr($code, $i, 1));
                srand((double)microtime()*1000000);
                $angle    = intval(rand(($this->maxrotation * -1), $this->maxrotation));
                srand((double)microtime()*1000000);
                $size    = intval(rand($this->minsize, $this->maxsize));
                srand((double)microtime()*1000000);
                $y        = intval(rand((int)($size * 1.5), (int)($this->ly - ($size / 7))));
                $this->random_color(0, 127);
                $color    =  imagecolorallocate($image, $this->r, $this->g, $this->b);
                $this->random_color(0, 127);
                $shadow = imagecolorallocate($image, $this->r + 127, $this->g + 127, $this->b + 127);
                @ImageTTFText($image, $size, $angle, $x + (int)($size / 15), $y, $shadow, $this->change_TTF(), $text);
                @ImageTTFText($image, $size, $angle, $x, $y - (int)($size / 15), $color, $this->TTF_file, $text);
                $x += (int)($size + ($this->minsize / 5));
            }

		header('Content-Type: image/jpeg');
		imagejpeg($image, NULL, $this->jpegquality);
 		imagedestroy($image);
 		exit;

	}




}

$captcha = new GenerateCaptcha();

?>