<?php
  define('PAGE_PARSE_START_TIME', microtime());
  $db_queries_count = 0;
  $debug = array();
  error_reporting(E_ALL & ~E_NOTICE);


	if ( true === file_exists('configure/catalog_configure.php') ) {
		require_once( 'configure/catalog_configure.php' );
	} else {
	    if ( true === is_dir('install') ) {
	      header('Location: install/index.php');
	    } else {
	    	die('configuration file is missing.');
	    }
	}

  define('PROJECT_VERSION', 'eclime');

  $request_type = ( 'on' == getenv('HTTPS') ? 'SSL' : 'NONSSL' );

  if ( true === empty($PHP_SELF) ) {
  	$PHP_SELF = $_SERVER['PHP_SELF'];
  }


  if ( 'NONSSL' === $request_type ) {
    define('DIR_WS_CATALOG', DIR_WS_HTTP_CATALOG);
  } else {
    define('DIR_WS_CATALOG', DIR_WS_HTTPS_CATALOG);
  }

	$cookie_domain = ( ($request_type == 'NONSSL') ? HTTP_COOKIE_DOMAIN : HTTPS_COOKIE_DOMAIN );
	$cookie_path = ( ($request_type == 'NONSSL') ? HTTP_COOKIE_PATH : HTTPS_COOKIE_PATH );


	require_once ( DIR_WS_INCLUDES . 'filenames.php' );
	require_once ( DIR_WS_INCLUDES . 'database_tables.php' );

	require_once ( DIR_WS_FUNCTIONS . 'compatibility.php');
	require_once ( DIR_WS_FUNCTIONS . 'database.php' );
	require_once ( DIR_WS_FUNCTIONS . 'general.php' );
	require_once ( DIR_WS_FUNCTIONS . 'refund_functions.php' );
	require_once ( DIR_WS_FUNCTIONS . 'html_output.php' );
	require_once ( DIR_WS_FUNCTIONS . 'sessions.php' );
	require_once ( DIR_WS_FUNCTIONS . 'image_stamp.php' );
	require_once ( DIR_WS_FUNCTIONS . 'articles.php' );
	require_once ( DIR_WS_FUNCTIONS . 'article_header_tags.php' );

	require_once ( DIR_WS_CLASSES . 'currencies.php' );
	require_once ( DIR_WS_CLASSES . 'mime.php' );
	require_once ( DIR_WS_CLASSES . 'email.php' );
	require_once ( DIR_WS_CLASSES . 'shopping_cart.php' );
	require_once ( DIR_WS_CLASSES . 'wishlist.php' );
	require_once ( DIR_WS_CLASSES . 'navigation_history.php' );
	require_once ( DIR_WS_CLASSES . 'tax.php' );

	$configuration_query_sql = 'SELECT configuration_key, configuration_value FROM ' . TABLE_CONFIGURATION;
	$configuration_query = tep_db_query($configuration_query_sql);
	while ( $configuration = tep_db_fetch_array($configuration_query) ) {
		define($configuration['configuration_key'], $configuration['configuration_value']);
	}

	//check if sessions are supported, otherwise use the php3 compatible session class
	if (!function_exists('session_start')) {
		define('PHP_SESSION_NAME', 'osCsid');
		define('PHP_SESSION_PATH', $cookie_path);
		define('PHP_SESSION_DOMAIN', $cookie_domain);
		define('PHP_SESSION_SAVE_PATH', SESSION_WRITE_DIRECTORY);

		include ( DIR_WS_CLASSES . 'sessions.php' );
	}




// set the session name and save path
  tep_session_name('osCsid');
  tep_session_save_path(SESSION_WRITE_DIRECTORY);

// set the session cookie parameters
   if (function_exists('session_set_cookie_params')) {
    session_set_cookie_params(0, $cookie_path, $cookie_domain);
  } elseif (function_exists('ini_set')) {
    ini_set('session.cookie_lifetime', '0');
    ini_set('session.cookie_path', $cookie_path);
    ini_set('session.cookie_domain', $cookie_domain);
  }

// set the session ID if it exists
   if (isset($_POST[tep_session_name()])) {
     tep_session_id($_POST[tep_session_name()]);
   } elseif ( ($request_type == 'SSL') && isset($_GET[tep_session_name()]) ) {
     tep_session_id($_GET[tep_session_name()]);
   }

// start the session
  $session_started = false;
  if ( SESSION_FORCE_COOKIE_USE == 'True' ) {
    tep_setcookie('cookie_test', 'please_accept_for_session', time()+60*60*24*30, $cookie_path, $cookie_domain);

    if (isset($_COOKIE['cookie_test'])) {
      tep_session_start();
      $session_started = true;
    }
  } elseif (SESSION_BLOCK_SPIDERS == 'True') {
    $user_agent = strtolower(getenv('HTTP_USER_AGENT'));
    $spider_flag = false;

    if (tep_not_null($user_agent)) {
      $spiders = file(DIR_WS_INCLUDES . 'spiders.txt');

      for ($i=0, $n=sizeof($spiders); $i<$n; $i++) {
        if (tep_not_null($spiders[$i])) {
          if (is_integer(strpos($user_agent, trim($spiders[$i])))) {
            $spider_flag = true;
            break;
          }
        }
      }
    }

    if ($spider_flag == false) {
      tep_session_start();
      $session_started = true;
    }
  } else {
    tep_session_start();
    $session_started = true;
  }

  $SID = ( defined('SID') ? SID : '' );

// verify the ssl_session_id if the feature is enabled
  if ( ($request_type == 'SSL') && (SESSION_CHECK_SSL_SESSION_ID == 'True') && (ENABLE_SSL == true) && ($session_started == true) ) {
    $ssl_session_id = getenv('SSL_SESSION_ID');
    if (!tep_session_is_registered('SSL_SESSION_ID')) {
      $SESSION_SSL_ID = $ssl_session_id;
      tep_session_register('SESSION_SSL_ID');
    }

    if ($SESSION_SSL_ID != $ssl_session_id) {
      tep_session_destroy();
      tep_redirect(tep_href_link(FILENAME_SSL_CHECK));
    }
  }

// verify the browser user agent if the feature is enabled
  if (SESSION_CHECK_USER_AGENT == 'True') {
    $http_user_agent = getenv('HTTP_USER_AGENT');
    if (!tep_session_is_registered('SESSION_USER_AGENT')) {
      $SESSION_USER_AGENT = $http_user_agent;
      tep_session_register('SESSION_USER_AGENT');
    }

    if ($SESSION_USER_AGENT != $http_user_agent) {
      tep_session_destroy();
      tep_redirect(tep_href_link(FILENAME_LOGIN));
    }
  }

// verify the IP address if the feature is enabled
  if (SESSION_CHECK_IP_ADDRESS == 'True') {
    $ip_address = tep_get_ip_address();
    if (!tep_session_is_registered('SESSION_IP_ADDRESS')) {
      $SESSION_IP_ADDRESS = $ip_address;
      tep_session_register('SESSION_IP_ADDRESS');
    }

    if ($SESSION_IP_ADDRESS != $ip_address) {
      tep_session_destroy();
      tep_redirect(tep_href_link(FILENAME_LOGIN));
    }
  }


// create the shopping cart & fix the cart if necesary
  if (tep_session_is_registered('cart') && is_object($cart)) {
    if (PHP_VERSION < 4) {
      $broken_cart = $cart;
      $cart = new shoppingCart;
      $cart->unserialize($broken_cart);
    }
  } else {
    tep_session_register('cart');
    $cart = new shoppingCart;
  }


  	// initialize the message stack for output messages
	require_once ( DIR_WS_CLASSES . 'message_stack.php' );
	$messageStack = new messageStack;


// set the language
  if (!tep_session_is_registered('language') || isset($_GET['language'])) {



    include(DIR_WS_CLASSES . 'language.php');
    $lng = new language();



    if (isset($_GET['language']) && tep_not_null($_GET['language'])) {
      $lng->set_language($_GET['language']);
    } else {
      $lng->get_browser_language();
    }

    $language = $lng->language['directory'];
    $languages_id = $lng->language['id'];
    $languages_code = $lng->language['code'];
    $encoding = $lng->language['encoding'];

    if (!tep_session_is_registered('language')) {
      tep_session_register('language');
      tep_session_register('languages_id');
      tep_session_register('languages_code');
      tep_session_register('encoding');
    }
  }

	if ( false === defined('CHARSET') && false === empty($encoding) ) {
		define('CHARSET', $encoding);
	}


	// include the language translations
	@include_once ( DIR_WS_LANGUAGES . $language . '.php' );

	require_once ( DIR_WS_FUNCTIONS . 'coupons.php' );

	# include the cache class
	include('includes/classes/cache.class.php');
	$cache = new cache($languages_id);
	# include the Ultimate SEO URLs cache file
	include('includes/seo_cache.php');
	# Get the cache - no parameters will get all GLOBAL cache entries for this language
	$cache->get_cache('GLOBAL');


if (  (strpos($_SERVER['REQUEST_URI'], '.html') !== false) && (defined('FWR_VALIDATION_ON') && FWR_VALIDATION_ON === 'true') ) { // SEO URLS is active and there is .html in the querystring
tep_validate_seo_urls();
}

if ( isset($_GET['cName']) && defined(urldecode($_GET['cName'])) ) {
  $cPath = str_replace( 'cPath=', '', constant(urldecode($_GET['cName'])) );
  $_GET['cPath'] = $cPath;
}
if (isset($_GET['pName']) && defined(urldecode($_GET['pName'])) ) {
  $pid = str_replace('products_id=', '', constant(urldecode($_GET['pName'])));
  $_GET['products_id'] = (int)$pid;
}
// EOF: MOD

// currency
  if (!tep_session_is_registered('currency') || isset($_GET['currency']) || ( (USE_DEFAULT_LANGUAGE_CURRENCY == 'true') && (LANGUAGE_CURRENCY != $currency) ) ) {
    if (!tep_session_is_registered('currency')) tep_session_register('currency');

    if (isset($_GET['currency'])) {
      if (!$currency = tep_currency_exists($_GET['currency'])) $currency = (USE_DEFAULT_LANGUAGE_CURRENCY == 'true') ? LANGUAGE_CURRENCY : DEFAULT_CURRENCY;
    } else {
      $currency = (USE_DEFAULT_LANGUAGE_CURRENCY == 'true') ? LANGUAGE_CURRENCY : DEFAULT_CURRENCY;
    }
  }

	# navigation history
	if ( true == tep_session_is_registered('navigation') ) {
		if ( PHP_VERSION < 4 ) {
			$broken_navigation = $navigation;
			$navigation = new navigationHistory;
			$navigation->unserialize($broken_navigation);
		}
	} else {
		tep_session_register('navigation');
		$navigation = new navigationHistory;
	}
	$navigation->add_current_page();

// BOF: MOD - Down for Maintenance except for admin ip
if (EXCLUDE_ADMIN_IP_FOR_MAINTENANCE != getenv('REMOTE_ADDR')){
  if (DOWN_FOR_MAINTENANCE=='true' and !strstr($PHP_SELF,DOWN_FOR_MAINTENANCE_FILENAME)) { tep_redirect(tep_href_link(DOWN_FOR_MAINTENANCE_FILENAME)); }
  }
// do not let people get to down for maintenance page if not turned on
if (DOWN_FOR_MAINTENANCE=='false' and strstr($PHP_SELF,DOWN_FOR_MAINTENANCE_FILENAME)) {
    tep_redirect(tep_href_link(FILENAME_DEFAULT));
}
// EOF: MOD - Down for Maintenance

// wishlist data
	if(!tep_session_is_registered('wishList')) {
		tep_session_register('wishList');
		$wishList = new wishlist;
	}
//Wishlist actions (must be before shopping cart actions)
	if( true == isset($_POST['wishlist_x'])) {
		if(isset($_POST['products_id'])) {
			if(isset($_POST['id'])) {
				$attributes_id = $_POST['id'];
				tep_session_register('attributes_id');
			}
			$wishlist_products_id = $_POST['products_id'];
			tep_session_register('wishlist_products_id');
		}
	tep_redirect(tep_href_link(FILENAME_WISHLIST));
	}


	  if( true === isset($_POST['add_prod_x']) ) {
	  	if (isset($_POST['add_wishprod'])) {
			foreach ($_POST['add_wishprod'] as $value) {
				$products_id = tep_get_prid($value);
				$available = tep_product_is_available($products_id);
				if ( true === $available ) {
					$quantity = $cart->get_quantity(tep_get_uprid($products_id, $_POST['id'][$value])) + 1;
					$cart->add_cart($products_id, $quantity, $_POST['id'][$value]);
					$wishList->remove($value);
				} else {
					$messageStack->add('wishlist', WISHLIST_ERROR_PRODUCTS_NOT_AVAILABLE, 'warning');
				}
			}
	  	} else {
			$messageStack->add('wishlist', WISHLIST_ERROR_CHECK_PRODUCTS, 'warning');
	  	}
	  }



	if( true == tep_session_is_registered('customer_id') ) {
		##### WISHLIST START
		$wishlist_query_count = "SELECT count(*) AS NUM_PRODS FROM " . TABLE_WISHLIST . " where customers_id = '$customer_id'";
		$wishlist_query = tep_db_query($wishlist_query_count);
		$wishlist_count = tep_db_fetch_array($wishlist_query);
		$wishlist_prod_count = $wishlist_count['NUM_PRODS'];
		##### WISHLIST END
	}



// Shopping cart actions
  if (isset($_GET['action'])) {
// redirect the customer to a friendly cookie-must-be-enabled page if cookies are disabled
    if ($session_started == false) {
      tep_redirect(tep_href_link(FILENAME_COOKIE_USAGE));
    }

    if (DISPLAY_CART == 'true') {
      $goto =  FILENAME_SHOPPING_CART;
     $parameters = array('action', 'cPath', 'products_id', 'pid', 'cName', 'pName');
    } else {
      $goto = basename($PHP_SELF);
      if ($_GET['action'] == 'buy_now') {
        $parameters = array('action', 'pid', 'products_id', 'pName');
      } else {
        $parameters = array('action', 'pid');
      }
    }
    switch ($_GET['action']) {
      // customer wants to update the product quantity in their shopping cart
      case 'update_product':
      for ($i=0, $n=sizeof($_POST['products_id']); $i<$n; $i++) {
        if (in_array($_POST['products_id'][$i], (is_array($_POST['cart_delete']) ? $_POST['cart_delete'] : array()))) {
          $cart->remove($_POST['products_id'][$i]);
        } else {
          if (PHP_VERSION < 4) {
            // if PHP3, make correction for lack of multidimensional array.
            reset($_POST);
            while (list($key, $value) = each($_POST)) {
              if (is_array($value)) {
                while (list($key2, $value2) = each($value)) {
                  if (ereg ("(.*)\]\[(.*)", $key2, $var)) {
                    $id2[$var[1]][$var[2]] = $value2;
                  }
                }
              }
            }
            $attributes = ($id2[$_POST['products_id'][$i]]) ? $id2[$_POST['products_id'][$i]] : '';
          } else {
            $attributes = ($_POST['id'][$_POST['products_id'][$i]]) ? $_POST['id'][$_POST['products_id'][$i]] : '';
          }
          $cart->add_cart($_POST['products_id'][$i], $_POST['cart_quantity'][$i], $attributes, false);
        }
      }
      $cart->calculate();
      silent_revalidate_coupon();

      tep_redirect(tep_href_link($goto, tep_get_all_get_params($parameters)));
      break;

	case 'add_product' :

      	if (isset($_POST['products_id']) && is_numeric($_POST['products_id']) && ($_POST['products_id']==(int)$_POST['products_id'])) {
      		$attributes = array();
      		if (isset($_POST['attrcomb']) && (preg_match("/^\d{1,10}-\d{1,10}(,\d{1,10}-\d{1,10})*$/", $_POST['attrcomb']))) {
      			$attrlist=explode(',',$_POST['attrcomb']);
      			foreach ($attrlist as $attr) {
      				list($oid, $oval) = explode('-', $attr);
      				if (is_numeric($oid) && $oid == (int)$oid && is_numeric($oval) && $oval==(int)$oval)
      				$attributes[$oid]=$oval;

          }
        }
        if (isset($_POST['id']) && is_array($_POST['id'])) {
          foreach ($_POST['id'] as $key=>$val) {
            if (is_numeric($key) && $key==(int)$key && is_numeric($val) && $val==(int)$val)
              $attributes=$attributes + $_POST['id'];
          }
        }

		$qty = ( true === is_numeric($_POST['cart_quantity']) ? $_POST['cart_quantity'] : 1 );
		$cart->add_cart($_POST['products_id'], $cart->get_quantity(tep_get_uprid($_POST['products_id'], $attributes))+$qty, $attributes);
        }

        tep_redirect(tep_href_link($goto, tep_get_all_get_params($parameters)));
        break;
	// performed by the 'buy now' button in product listings and review page
	case 'buy_now' :
		if ( false === empty($_GET['products_id']) ) {
            if (tep_session_is_registered('customer_id')) {
              tep_db_query("delete from " . TABLE_WISHLIST . " WHERE customers_id='$customer_id' AND products_id='{$_GET['products_id']}'");
              tep_db_query("delete from " . TABLE_WISHLIST_ATTRIBUTES . " WHERE customers_id='$customer_id' AND products_id='{$_GET['products_id']}'");
            }
            if (tep_has_product_attributes($_GET['products_id'])) {
            	$messageStack->add_session('choose_options', TEXT_CHOOSE_OPTIONS_FIRST, 'warning');
              tep_redirect(tep_href_link(FILENAME_PRODUCT_INFO, 'products_id=' . $_GET['products_id']));
            } else {
              $cart->add_cart($_GET['products_id'], $cart->get_quantity($_GET['products_id'])+1);
            }

          }
          if ( (defined('SEO_URLS') && SEO_URLS == 'true') && (defined('SEO_URLS_TYPE') && SEO_URLS_TYPE == 'Rewrite') ){
            $cPath = tep_get_product_path($_GET['products_id']);
            $cPath_array = tep_parse_category_path($cPath);
            $cPath = implode('_', $cPath_array);
            tep_redirect(tep_href_link($goto, 'cPath=' . $cPath . '&' . tep_get_all_get_params($parameters)));
          } else {
            tep_redirect(tep_href_link($goto, tep_get_all_get_params($parameters)));
          }
          break;
      case 'notify' : if (tep_session_is_registered('customer_id')) {
                      if (isset($_GET['products_id'])) {
                        $notify = $_GET['products_id'];
                      } elseif (isset($_GET['notify'])) {
                        $notify = $_GET['notify'];
                      } elseif (isset($_POST['notify'])) {
                        $notify = $_POST['notify'];
                      } else {
                        tep_redirect(tep_href_link(basename($PHP_SELF), tep_get_all_get_params(array('action', 'notify'))));
                      }
                      if (!is_array($notify)) $notify = array($notify);
                      for ($i=0, $n=sizeof($notify); $i<$n; $i++) {
                        $check_query = tep_db_query("select count(*) as count from " . TABLE_PRODUCTS_NOTIFICATIONS . " where products_id = '" . $notify[$i] . "' and customers_id = '" . $customer_id . "'");
                        $check = tep_db_fetch_array($check_query);
                        if ($check['count'] < 1) {
                          tep_db_query("insert into " . TABLE_PRODUCTS_NOTIFICATIONS . " (products_id, customers_id, date_added) values ('" . $notify[$i] . "', '" . $customer_id . "', now())");
                        }
                      }
                      tep_redirect(tep_href_link(basename($PHP_SELF), tep_get_all_get_params(array('action', 'notify'))));
                    } else {
                      $navigation->set_snapshot();
                      tep_redirect(tep_href_link(FILENAME_LOGIN, '', 'SSL'));
                    }
                    break;
      case 'notify_remove' :  if (tep_session_is_registered('customer_id') && isset($_GET['products_id'])) {
                                $check_query = tep_db_query("select count(*) as count from " . TABLE_PRODUCTS_NOTIFICATIONS . " where products_id = '" . $_GET['products_id'] . "' and customers_id = '" . $customer_id . "'");
                                $check = tep_db_fetch_array($check_query);
                                if ($check['count'] > 0) {
                                  tep_db_query("delete from " . TABLE_PRODUCTS_NOTIFICATIONS . " where products_id = '" . $_GET['products_id'] . "' and customers_id = '" . $customer_id . "'");
                                }
                                tep_redirect(tep_href_link(basename($PHP_SELF), tep_get_all_get_params(array('action'))));
                              } else {
                                $navigation->set_snapshot();
                                tep_redirect(tep_href_link(FILENAME_LOGIN, '', 'SSL'));
                              }
                              break;

    }

  }


	// include the who's online functions
	require_once (DIR_WS_FUNCTIONS . 'whos_online.php');
	tep_update_whos_online();

	// include the password crypto functions
	require_once (DIR_WS_FUNCTIONS . 'password_funcs.php');

	// include validation functions (right now only email address)
	require_once (DIR_WS_FUNCTIONS . 'validations.php');

	// split-page-results
	require_once (DIR_WS_CLASSES . 'split_page_results.php');

	// auto activate and expire banners
	require_once ( DIR_WS_FUNCTIONS . 'banner.php' );
	if ( 'true' == BANNER_SYSTEM_ENABLED ) {
		tep_activate_banners();
		tep_expire_banners();
		$active_banners_array = tep_get_active_banners_group_ids_array();
	}


	// auto expire special products
	require_once (DIR_WS_FUNCTIONS . 'specials.php');
	tep_expire_specials();

// calculate category path
  if (isset($_GET['cPath'])) {
    $cPath = $_GET['cPath'];
  } elseif (isset($_GET['products_id']) && !isset($_GET['manufacturers_id'])) {
    $cPath = tep_get_product_path($_GET['products_id']);
  } else {
    $cPath = '';
  }

  if (tep_not_null($cPath)) {
    $cPath_array = tep_parse_category_path($cPath);
    $cPath = implode('_', $cPath_array);
    $current_category_id = $cPath_array[(sizeof($cPath_array)-1)];
  } else {
    $current_category_id = 0;
  }

// include the breadcrumb class and start the breadcrumb trail
  require_once (DIR_WS_CLASSES . 'breadcrumb.php');
  $breadcrumb = new breadcrumb;


  $breadcrumb->add(HEADER_TITLE_CATALOG, tep_href_link(FILENAME_DEFAULT));

// add category names or the manufacturer name to the breadcrumb trail
  if (isset($cPath_array) && ('index.php' == basename($_SERVER['PHP_SELF']) || 'product_info.php' == basename($_SERVER['PHP_SELF'])) ) {
    for ($i=0, $n=sizeof($cPath_array); $i<$n; $i++) {
      $categories_query = tep_db_query("select categories_name from " . TABLE_CATEGORIES_DESCRIPTION . " where categories_id = '" . (int)$cPath_array[$i] . "' and language_id = '" . (int)$languages_id . "'");
		if (tep_db_num_rows($categories_query) > 0) {
			$categories = tep_db_fetch_array($categories_query);
			if ( ($i+1) === $n && 'product_info.php' !== basename($_SERVER['PHP_SELF']) && true === empty($_GET['sort']) ) {
				$breadcrumb->add($categories['categories_name']);
			} else {
				$breadcrumb->add($categories['categories_name'], tep_href_link(FILENAME_DEFAULT, 'cPath=' . implode('_', array_slice($cPath_array, 0, ($i+1)))));
			}
		} else {
			// sub category does not exists
			header('HTTP/1.0 404 Not Found');
			header('Location: ' . HTTP_SERVER);
		break;
      }
    }

	} elseif ( false === empty($_GET['manufacturers_id']) ) {
		$manufacturers_query_sql = "
							SELECT
								*
							FROM
								" . TABLE_MANUFACTURERS . " m,
								" . TABLE_MANUFACTURERS_INFO . " i
							WHERE
								m.manufacturers_id = i.manufacturers_id
								AND m.manufacturers_id = '{$_GET['manufacturers_id']}'

								";
		$manufacturers_query = tep_db_query($manufacturers_query_sql);
		if ( 0 < tep_db_num_rows($manufacturers_query) ) {
			$manufacturers = tep_db_fetch_array($manufacturers_query);
			$breadcrumb->add(BOX_HEADING_MANUFACTURERS, tep_href_link(FILENAME_MANUFACTURERS));
			$breadcrumb->add($manufacturers['manufacturers_name']);
		}
	}

// calculate topic path
  if (isset($_GET['tPath'])) {
    $tPath = $_GET['tPath'];
  } elseif (isset($_GET['articles_id']) && !isset($_GET['authors_id'])) {
    $tPath = tep_get_article_path($_GET['articles_id']);
  } else {
    $tPath = '';
  }

  if (tep_not_null($tPath)) {
    $tPath_array = tep_parse_topic_path($tPath);
    $tPath = implode('_', $tPath_array);
    $current_topic_id = $tPath_array[(sizeof($tPath_array)-1)];
  } else {
    $current_topic_id = 0;
  }

	// add topic names or the author name to the breadcrumb trail
	if ( false === empty($tPath_array) ) {
		for ($i=0, $n=sizeof($tPath_array); $i<$n; $i++) {
			$topics_query_sql = "
							SELECT
								topics_name
							FROM
								" . TABLE_TOPICS_DESCRIPTION . "
							WHERE
								topics_id = '" . (int)$tPath_array[$i] . "'
								AND language_id = '" . (int)$languages_id . "'";
			$topics_query = tep_db_query($topics_query_sql);
			if (tep_db_num_rows($topics_query) > 0) {
				$topics = tep_db_fetch_array($topics_query);
				$breadcrumb->add($topics['topics_name'], tep_href_link(FILENAME_ARTICLES, 'tPath=' . implode('_', array_slice($tPath_array, 0, ($i+1)))));
			} else {
				break;
			}
		}
	} elseif ( false === empty($_GET['authors_id']) ) {
		$authors_query_sql = "
								SELECT
									authors_name
								FROM
									" . TABLE_AUTHORS . "
								WHERE
									authors_id = '" . (int)$_GET['authors_id'] . "'";
		$authors_query = tep_db_query($authors_query_sql);
		if ( 0 < tep_db_num_rows($authors_query) ) {
			$authors = tep_db_fetch_array($authors_query);
			$breadcrumb->add('Articles by ' . $authors['authors_name'], tep_href_link(FILENAME_ARTICLES, 'authors_id=' . $_GET['authors_id']));
		}
	}

	// add the articles name to the breadcrumb trail
	if ( false === empty($_GET['articles_id']) ) {
		$article_query_sql = "
						SELECT
							articles_name
						FROM
							" . TABLE_ARTICLES_DESCRIPTION . "
						WHERE
							articles_id = '" . (int)$_GET['articles_id'] . "'";
		$article_query = tep_db_query($article_query_sql);
		if (tep_db_num_rows($article_query)) {
			$article = tep_db_fetch_array($article_query);
			if (isset($_GET['authors_id'])) {
				$breadcrumb->add($article['articles_name'], tep_href_link(FILENAME_ARTICLE_INFO, 'authors_id=' . $_GET['authors_id'] . '&articles_id=' . $_GET['articles_id']));
			} else {
				$breadcrumb->add($article['articles_name'], tep_href_link(FILENAME_ARTICLE_INFO, 'tPath=' . $tPath . '&articles_id=' . $_GET['articles_id']));
			}
		}
	}

	// add only if Header Tags not already installed
	require_once (DIR_WS_FUNCTIONS . 'clean_html_comments.php');



	// set which precautions should be checked
	define('WARN_INSTALL_EXISTENCE', 'true');
	define('WARN_CONFIG_WRITEABLE', 'true');
	define('WARN_SESSION_DIRECTORY_NOT_WRITEABLE', 'true');
	define('WARN_SESSION_AUTO_START', 'true');
	define('WARN_DOWNLOAD_DIRECTORY_NOT_READABLE', 'true');
	require_once ( DIR_WS_INCLUDES . 'add_ccgvdc_application_top.php' );



if ( false === empty($_GET['coupon_action']) ) {

	switch ( $_GET['coupon_action'] ) {
		case 'apply_coupon':
			if ( $_POST['gv_redeem_code'] ) {

				$coupon_error = validate_coupon($_POST['gv_redeem_code']);
				if ( $coupon_error['count'] > 0 ) {
					$messageStack->add('coupon_message', $coupon_error['message'], 'warning');
				} else {
					require_once ( DIR_WS_CLASSES . 'order.php');
					$order = new order;
					require_once ( DIR_WS_CLASSES . 'order_total.php');
					$order_total_modules = new order_total;
					$order_total_modules->collect_posts();
					$order_total_modules->process();
				}
			}
		break;
		case 'remove_coupon':
			tep_session_unregister('cc_id');
			$coupon_free_shipping = ( tep_session_is_registered('cc_free_shipping') ? true : false );
			tep_session_unregister('cc_free_shipping');
			if ( FILENAME_CHECKOUT_PAYMENT == basename($_SERVER['PHP_SELF']) ) {
				if ( true === $coupon_free_shipping ) {
					$coupon_redirect_url = FILENAME_CHECKOUT_SHIPPING;
				} else {
					$coupon_redirect_url = basename($_SERVER['PHP_SELF']);
				}
			} else {
				$coupon_redirect_url = basename($_SERVER['PHP_SELF']);
			}
			tep_redirect(tep_href_link($coupon_redirect_url));
		break;
	}
}

	//---PayPal WPP Modification START ---//
	include_once ( DIR_WS_INCLUDES . 'paypal_wpp/paypal_wpp_include.php' );
	//---PayPal WPP Modification END ---//

	if ( 'logoff.php' == basename($_SERVER['PHP_SELF']) ) {
		require_once ( DIR_WS_INCLUDES . 'logoff.php' );
	}

	if ( true === defined('AFFILIATE_SYSTEM') && 'On' === AFFILIATE_SYSTEM ) {
		require_once ( DIR_WS_CLASSES . 'affiliate.php');
		$affiliate = new Affiliate();
	}


	define('SMARTY_TEMPLATE_DIR', SMARTY_TEMPLATES_DIR . CURRENT_TEMPLATE . '/');
	define('TEMPLATE_IMAGES_DIR', SMARTY_TEMPLATE_DIR.'images/');
	define('TEMPLATE_PLUGINS_DIR', SMARTY_TEMPLATE_DIR.'plugins/');
	define('TEMPLATE_CSS_DIR', SMARTY_TEMPLATE_DIR.'stylesheets/');
	define('TEMPLATE_JAVASCRIPT_DIR', SMARTY_TEMPLATE_DIR.'javascript/');

	######################
	require_once( SMARTY_DIR . 'Smarty.class.php' );
	$smarty = new Smarty;
	$smarty->compile_check = true;
	$smarty->template_dir = SMARTY_TEMPLATE_DIR;
	$smarty->php_handling = SMARTY_PHP_REMOVE;
	######################

	if ( true === is_dir('install') ) {
		$messageStack->add_global('installation_exists', WARNING_INSTALL_DIRECTORY_EXISTS, 'error');
	}

	if ( true === is_writable('configure/catalog_configure.php') ) {
		$messageStack->add_global('installation_exists', sprintf(WARNING_CONFIG_FILE_WRITEABLE, dirname($_SERVER['SCRIPT_FILENAME']) . '/configure/catalog_configure.php'), 'warning');
	}

	$smarty->assign('messagestack_global', $messageStack->get_global_messages());

	$SHOPPING_CART_ITEMS_COUNT = $cart->count_contents();
	$smarty->assign('SHOPPING_CART_ITEMS_COUNT', $SHOPPING_CART_ITEMS_COUNT);

	// do not show shopping cart link on checkout pages.
	$show_checkout_link = ( !strstr($_SERVER['PHP_SELF'], 'checkout_') ? 'true' : 'false' );
	$smarty->assign('show_checkout_link', $show_checkout_link);

	$smarty->assign('wishlist_prod_count', $wishlist_prod_count);


	if ( false === empty($sppc_customer_group_id) ) {
		$customers_group_id = $sppc_customer_group_id;
	}


	require_once ( DIR_WS_FUNCTIONS . 'products.php' );// fetch products functions
	require_once ( DIR_WS_FUNCTIONS . 'plugins.php' ); // PLUGINS
	// make sure 'CENTER' plugins included only on the default page

	if ( false === empty($cPath) || 'index.php' !== basename($_SERVER['PHP_SELF']) || false === empty($_GET['manufacturers_id']) ) {
		$plugin_files = getActivePluginsInfo($languages_id, array('CENTER'));
	} else {
		$plugin_files = getActivePluginsInfo($languages_id);
	}

	if ( true === is_array($plugin_files) ) {
		foreach ( $plugin_files as $plugin_group => $plgs ) {
			if ( true === is_array($plgs) ) {
				foreach ( $plgs as $plg ) {
					if ( false === empty( $plg['plugins_file_name']) ) {
						include_once ( DIR_WS_PLUGINS . $plg['plugins_file_name'] );
					}
				}
			}
		}
	}

	$smarty->assign('plugins', $plugin_files);
	$smarty->assign('plugins_info', $plugins_info); // $plugins_info collected from all plugin files.
	$smarty->assign('language', $language);

	if ( true === defined('HTML_PARAMS') ) {
		$smarty->assign('HTML_PARAMS', HTML_PARAMS);
	}

	$smarty->assign('CHARSET', CHARSET);

	$logout_continue_allowed = array(
								FILENAME_PRODUCT_INFO,
								FILENAME_REVIEWS,
								FILENAME_PRODUCT_REVIEWS,
								FILENAME_PRODUCT_REVIEWS_INFO,
								FILENAME_DEFAULT,
								FILENAME_MANUFACTURERS,
								FILENAME_ADVANCED_SEARCH,
								FILENAME_ARTICLES,
								FILENAME_ARTICLE_INFO,
								FILENAME_MANUFACTURERS
							);
	if ( true === in_array(basename($_SERVER['PHP_SELF']), $logout_continue_allowed) ) {
		$login_logout_params = '?continue_to='.base64_encode(basename($_SERVER['PHP_SELF']).'?'.tep_get_all_get_params(array('osCsid')));
	}

	if ( 'true' == BANNER_SYSTEM_ENABLED && true === is_array($active_banners_array) ) {
		foreach ( $active_banners_array as $banners_group ) {
			$banners[$banners_group] = tep_get_banner_by_group_id($banners_group);
		}
		$smarty->assign('_BANNERS', $banners);
	}

	$smarty->assign('DIR_WS_IMAGES', DIR_WS_IMAGES);
	$smarty->assign('URL_DEFAULT', tep_href_link(FILENAME_DEFAULT));
	$smarty->assign('HEADER_TITLE_HOME', HEADER_TITLE_HOME);

	$smarty->assign('URL_LOGOFF', tep_href_link(FILENAME_LOGOFF, $login_logout_params, 'SSL'));
	$smarty->assign('HEADER_TITLE_LOGOFF', HEADER_TITLE_LOGOFF);

	$smarty->assign('URL_LOGIN', tep_href_link(FILENAME_LOGIN, $login_logout_params, 'SSL'));
	$smarty->assign('HEADER_TITLE_LOGIN', HEADER_TITLE_LOGIN);

	$smarty->assign('URL_CREATE_ACCOUNT', tep_href_link(FILENAME_CREATE_ACCOUNT, '', 'SSL'));
	$smarty->assign('HEADER_TITLE_CREATE_ACCOUNT', HEADER_TITLE_CREATE_ACCOUNT);

	$smarty->assign('URL_WISHLIST', tep_href_link(FILENAME_WISHLIST));
	$smarty->assign('HEADER_TITLE_WISHLIST', HEADER_TITLE_WISHLIST);

	$smarty->assign('URL_SHOPPING_CART', tep_href_link(FILENAME_SHOPPING_CART, '', 'NONSSL'));
	$smarty->assign('BOX_HEADING_SHOPPING_CART', BOX_HEADING_SHOPPING_CART);

	$smarty->assign('HEADER_TITLE_SHOPPING_CART', HEADER_TITLE_SHOPPING_CART);

	$smarty->assign('URL_ACCOUNT', tep_href_link(FILENAME_ACCOUNT, 'my_account_f=1', 'SSL'));
	$smarty->assign('HEADER_TITLE_MY_ACCOUNT', HEADER_TITLE_MY_ACCOUNT);

	if ( 'Enabled' == PHPBB_INTEGRATION ) {
		$smarty->assign('URL_FORUM', tep_href_link_phpbb(PHPBB_DIR.'index.php'));
	}

	define('BASE_URL', (($request_type == 'SSL') ? HTTPS_SERVER : HTTP_SERVER) . DIR_WS_CATALOG);

	$smarty->assign('BASE_URL', BASE_URL);
	$smarty->assign('BASE_URL_RSS', BASE_URL . 'rss.php');
	$smarty->assign('DIR_WS_INCLUDES', DIR_WS_INCLUDES);

	$smarty->assign('TEMPLATE_IMAGES_DIR', TEMPLATE_IMAGES_DIR);
	$smarty->assign('TEMPLATE_PLUGINS_DIR', TEMPLATE_PLUGINS_DIR);
	define('TEMPLATE_LANGUAGE_BUTTONS_DIR', TEMPLATE_IMAGES_DIR.'languages/'. $language . '/buttons/');
	$smarty->assign('TEMPLATE_LANGUAGE_BUTTONS_DIR', TEMPLATE_LANGUAGE_BUTTONS_DIR);
	define('TEMPLATE_LANGUAGE_IMAGES_DIR', TEMPLATE_IMAGES_DIR.'languages/'. $language . '/images/');
	$smarty->assign('TEMPLATE_LANGUAGE_IMAGES_DIR', TEMPLATE_LANGUAGE_IMAGES_DIR);
	$smarty->assign('TEMPLATE_CSS_DIR', TEMPLATE_CSS_DIR);
	$smarty->assign('TEMPLATE_JAVASCRIPT_DIR', TEMPLATE_JAVASCRIPT_DIR);
	$smarty->assign('URL_CHECKOUT_SHIPPING', tep_href_link(FILENAME_CHECKOUT_SHIPPING));
	$smarty->assign('HEADER_TITLE_CHECKOUT', HEADER_TITLE_CHECKOUT);
	$smarty->assign('DISPLAY_PRICE_WITH_TAX', DISPLAY_PRICE_WITH_TAX);

	$_JAVASCRIPTINCLUDES = '<script type="text/javascript" src="'.HTTP_SERVER.DIR_WS_CATALOG.DIR_WS_INCLUDES.'javascript/js.js"></script>';

	$smarty->assign('_JAVASCRIPTINCLUDES', $_JAVASCRIPTINCLUDES);
	$smarty->assign('TEMPLATE_JAVASCRIPT_DIR', TEMPLATE_JAVASCRIPT_DIR);
	$smarty->assign('POWERED_BY', POWERED_BY);

	### LOGIN CHECK
  	$smarty->assign('USER_LOGGEDIN', tep_session_is_registered('customer_id'));
  	### LOGIN CHECK

  	$smarty->assign('wo_full_name', $wo_full_name);

?>