<?php
  class messageStack {

	function messageStack() {
		global $messageToStack;
		$this->messages = array();
		if ( true == tep_session_is_registered('messageToStack') ) {
			foreach ( $messageToStack as $msgStack ) {
				$this->add($msgStack['class'], $msgStack['text'], $msgStack['type']);
			}
			tep_session_unregister('messageToStack');
		}
	}

	function add($class, $message, $type = 'error') {
		if ( true === $this->exists($class, $message) ) {
			return false;
		}
		switch ( $type ) {
			case 'warning':
				$this->messages[] = array('params' => ' class="messageStackWarning"', 'class' => $class, 'text' =>  $message, 'image' =>  '<img src="'.DIR_WS_IMAGES.'/info.png" alt="'.ICON_WARNING.'" />');
				break;
			case 'success':
				$this->messages[] = array('params' => ' class="messageStackSuccess"', 'class' => $class, 'text' =>  $message, 'image' =>  '<img src="'.DIR_WS_IMAGES.'/ok.png" alt="'.ICON_SUCCESS.'" />');
				break;
			default;
			case 'error':
				$this->messages[] = array('params' => ' class="messageStackError"', 'class' => $class, 'text' =>  $message, 'image' =>  '<img src="'.DIR_WS_IMAGES.'/error.png" alt="'.ICON_ERROR.'" />');
				break;
		}
		return true;
	}

	function add_global($class, $message, $type = 'error') {
		if ( true === $this->exists($class, $message) ) {
			return false;
		}
		switch ( $type ) {
			case 'warning':
				$this->global_messages[] = array('params' => ' class="messageStackWarning"', 'class' => $class, 'text' =>  $message, 'image' =>  '<img src="'.DIR_WS_IMAGES.'/info.png" alt="'.ICON_WARNING.'" />');
				break;
			case 'success':
				$this->global_messages[] = array('params' => ' class="messageStackSuccess"', 'class' => $class, 'text' =>  $message, 'image' =>  '<img src="'.DIR_WS_IMAGES.'/ok.png" alt="'.ICON_SUCCESS.'" />');
				break;
			default;
			case 'error':
				$this->global_messages[] = array('params' => ' class="messageStackError"', 'class' => $class, 'text' =>  $message, 'image' =>  '<img src="'.DIR_WS_IMAGES.'/error.png" alt="'.ICON_ERROR.'" />');
				break;
		}
		return true;
	}

	function exists_global($class, $message) {
    		if ( true === empty($class) || true === empty($message) ) {
    			return false;
    		}
    		if ( false === is_array($this->global_messages) || 0 >= count($this->global_messages) ) {
    			return false;
    		}
		foreach ( $this->global_messages as $msg ) {
			if ( $msg['class'] == $class && $msg['text'] == $message) {
				return true;
			}
		}
		return false;
    }

    function exists($class, $message) {
    		if ( true === empty($class) || true === empty($message) ) {
    			return false;
    		}
    		if ( false === is_array($this->messages) || 0 >= count($this->messages) ) {
    			return false;
    		}
		foreach ( $this->messages as $msg ) {
			if ( $msg['class'] == $class && $msg['text'] == $message) {
				return true;
			}
		}
		return false;
    }

	function add_session($class, $message, $type = 'error') {
		global $messageToStack;

		if ( false == tep_session_is_registered('messageToStack') ) {
			tep_session_register('messageToStack');
			$messageToStack = array();
		}
		$messageToStack[] = array('class' => $class, 'text' => $message, 'type' => $type);
	}

    function reset() {
     $this->messages = array();
    }

    /*
    function output($class) {
      $this->table_data_parameters = 'class="messageBox"';

      $output = array();
      for ($i=0, $n=sizeof($this->messages); $i<$n; $i++) {
        if ($this->messages[$i]['class'] == $class) {
          $output[] = $this->messages[$i];
        }
      }
	  $return = '';
	  foreach($output as $message){
	  	$return .= '<p '.$message['params'].'>'.$message['text'].'</p>';
	  }
	  return $return;

     //return $this->tableBox($output);
    }

    */

	function get_messages() {
		if ( true === is_array($this->messages) ) {
			foreach ( $this->messages as $message ) {
				$output[] = $message;
			}
			return $output;
		}
    }

    function get_global_messages() {
		if ( true === is_array($this->global_messages) ) {
			foreach ( $this->global_messages as $message ) {
				$output[] = $message;
			}
			return $output;
		}
    }


    function size($class) {
      $count = 0;
      for ($i=0, $n=sizeof($this->messages); $i<$n; $i++) {
        if ($this->messages[$i]['class'] == $class) {
          $count++;
        }
      }
      return $count;
    }
  }
  /**/
?>