<?php

function tep_get_recent_orders($days = 30, $limit = 10) {
	global $customer_id, $languages_id;
	if ( true === empty($days) || false === is_numeric($days) ) {
		$days = 30;
	}
	if ( true === empty($limit) || false === is_numeric($limit) ) {
		$limit = 10;
	}

	if ( false === tep_session_is_registered('customer_id') ) {
		return false;
	}
	$orders_query_sql = "
						SELECT
							o.orders_id,
							o.date_purchased,
							os.orders_status_name
						FROM
							" . TABLE_ORDERS . " o,
							" . TABLE_ORDERS_STATUS . " os
						WHERE
							o.orders_status = os.orders_status_id
							AND os.language_id = '$languages_id'
							AND o.customers_id = '$customer_id'
							AND o.date_purchased >= ( CURRENT_DATE() - INTERVAL $days DAY )
							ORDER BY o.date_purchased DESC LIMIT $limit";
	$orders_query = tep_db_query($orders_query_sql);
    if ( 0 < tep_db_num_rows($orders_query) ) {
    	while ( $orders = tep_db_fetch_array($orders_query) ) {
    		$orders_total_query_sql = "SELECT text FROM " . TABLE_ORDERS_TOTAL . " WHERE orders_id = '{$orders['orders_id']}' AND class = 'ot_total'";
    		$orders_total_query = tep_db_query($orders_total_query_sql);
    		$order_total = tep_db_fetch_array($orders_total_query);
    		$orders['total'] = $order_total['text'];
    		$orders['date_purchased_long'] = tep_date_long($orders['date_purchased']);
    		$orders['url'] = tep_href_link(FILENAME_ACCOUNT_HISTORY_INFO, 'order_id=' . $orders['orders_id']);
    		$orders_return[] = $orders;
    	}
    } else {
    	return false;
    }
    return $orders_return;
}

?>