<?php


  function tep_set_banner_status($banners_id, $status) {
    if ($status == '1') {
      return tep_db_query("update " . TABLE_BANNERS . " set status = '1', date_status_change = now(), date_scheduled = NULL where banners_id = '" . (int)$banners_id . "'");
    } elseif ($status == '0') {
      return tep_db_query("update " . TABLE_BANNERS . " set status = '0', date_status_change = now() where banners_id = '" . (int)$banners_id . "'");
    } else {
      return -1;
    }
  }

  function tep_activate_banners() {
    $banners_query = tep_db_query("select banners_id, date_scheduled from " . TABLE_BANNERS . " where date_scheduled != ''");
    if (tep_db_num_rows($banners_query)) {
      while ($banners = tep_db_fetch_array($banners_query)) {
        if (date('Y-m-d H:i:s') >= $banners['date_scheduled']) {
          tep_set_banner_status($banners['banners_id'], '1');
        }
      }
    }
  }

  function tep_get_active_banners_group_ids_array() {
  	if ( 'true' == BANNER_SYSTEM_ENABLED ) {

  		$banners_query_sql = "
  						SELECT DISTINCT banners_group
  						FROM " . TABLE_BANNERS . "
  						WHERE status = '1'";
  		$banners_query = tep_db_query($banners_query_sql);
		    if ( 1 <= tep_db_num_rows($banners_query) ) {
		    	$return_array = array();
		      while ($banners = tep_db_fetch_array($banners_query)) {
		        array_push($return_array, $banners['banners_group']);
		      }
		    }
		return $return_array;
  	} else {
  		return false;
  	}
  }


	function tep_expire_banners() {
	$banners_query_sql = "
					SELECT
						b.banners_id,
						b.expires_date,
						b.expires_impressions,
						b.expires_clicks,
						sum(bh.banners_shown) as banners_shown,
						sum(bh.banners_clicked) as banners_clicked
					FROM
						" . TABLE_BANNERS . " b,
						" . TABLE_BANNERS_HISTORY . " bh
					WHERE
						b.status = '1'
						AND b.banners_id = bh.banners_id
					GROUP BY
						b.banners_id";
	$banners_query = tep_db_query($banners_query_sql);
		if ( 0 < tep_db_num_rows($banners_query) ) {
			while ($banners = tep_db_fetch_array($banners_query)) {
				if ( tep_not_null($banners['expires_date']) ) {
					if (date('Y-m-d H:i:s') >= $banners['expires_date']) {
						tep_set_banner_status($banners['banners_id'], '0');
					}
				} elseif ( tep_not_null($banners['expires_impressions']) ) {
					if ( ($banners['expires_impressions'] > 0) && ($banners['banners_shown'] >= $banners['expires_impressions']) ) {
						tep_set_banner_status($banners['banners_id'], '0');
					}
				} elseif ( tep_not_null($banners['expires_clicks']) ) {
					if ( ($banners['expires_clicks'] > 0) && ($banners['banners_clicked'] >= $banners['expires_clicks']) ) {
						tep_set_banner_status($banners['banners_id'], '0');
					}
				}
			}
		}
	}


  function tep_display_banner($action, $identifier) {

  	switch ( $action ) {
  		case 'dynamic':
		$banner_query_sql = "
     		SELECT
     			banners_id,
     			banners_title,
     			banners_image,
     			banners_html_text
     		FROM " . TABLE_BANNERS . "
     		WHERE
     			status = '1'
     			ORDER BY RAND()
     			";
        $banner_query = tep_db_query($banner_query_sql);
        $banner = tep_db_fetch_array($banner_query);

        if ( 0 >= tep_db_num_rows() ) {
		return '<b>TEP ERROR! (tep_display_banner(' . $action . ', ' . $identifier . ') -> No banners with group \'' . $identifier . '\' found!</b>';
        }
        break;

        case 'static':
        	 if (is_array($identifier)) {
	        $banner = $identifier;
	      } else {

	        $banner_query_sql = "
	        			SELECT
	        				banners_id,
	        				banners_title,
	        				banners_image,
	        				banners_html_text
	        			FROM " . TABLE_BANNERS . "
	        			WHERE
	        				status = '1'
	        				AND banners_id = '" . (int)$identifier . "'";
	        $banner_query = tep_db_query($banner_query_sql);
	        if (tep_db_num_rows($banner_query)) {
	          $banner = tep_db_fetch_array($banner_query);
	        } else {
	          return '<b>TEP ERROR! (tep_display_banner(' . $action . ', ' . $identifier . ') -> Banner with ID \'' . $identifier . '\' not found, or status inactive</b>';
	        }
	      }
	   break;

        default:
        	 return '<b>TEP ERROR! (tep_display_banner(' . $action . ', ' . $identifier . ') -> Unknown $action parameter value - it must be either \'dynamic\' or \'static\'</b>';
        break;
  	}


    $banner_string = '<a href="' . tep_href_link(FILENAME_REDIRECT, 'action=banner&goto=' . $banner['banners_id']) . '" target="_blank">' . tep_image(DIR_WS_IMAGES . $banner['banners_image'], $banner['banners_title']) . '</a>';
    if (tep_not_null($banner['banners_html_text']))
    $banner_string .= '<br />'.$banner['banners_html_text'];

    tep_update_banner_display_count($banner['banners_id']);

    return $banner_string;
  }


  function tep_banner_exists($action, $identifier) {
    if ($action == 'dynamic') {
      return tep_random_select("select banners_id, banners_title, banners_image, banners_html_text from " . TABLE_BANNERS . " where status = '1' and banners_group = '" . $identifier . "'");
    } elseif ($action == 'static') {
      $banner_query = tep_db_query("select banners_id, banners_title, banners_image, banners_html_text from " . TABLE_BANNERS . " where status = '1' and banners_id = '" . (int)$identifier . "'");
      return tep_db_fetch_array($banner_query);
    } else {
      return false;
    }
  }


  function tep_update_banner_display_count($banner_id) {
    $banner_check_query = tep_db_query("select count(*) as count from " . TABLE_BANNERS_HISTORY . " where banners_id = '" . (int)$banner_id . "' and date_format(banners_history_date, '%Y%m%d') = date_format(now(), '%Y%m%d')");
    $banner_check = tep_db_fetch_array($banner_check_query);

    if ($banner_check['count'] > 0) {
      tep_db_query("update " . TABLE_BANNERS_HISTORY . " set banners_shown = banners_shown + 1 where banners_id = '" . (int)$banner_id . "' and date_format(banners_history_date, '%Y%m%d') = date_format(now(), '%Y%m%d')");
    } else {
      tep_db_query("insert into " . TABLE_BANNERS_HISTORY . " (banners_id, banners_shown, banners_history_date) values ('" . (int)$banner_id . "', 1, now())");
    }
  }

	function tep_update_banner_click_count($banner_id) {
  		if ( false === empty($banner_id) && true === is_numeric($banner_id) ) {
			tep_db_query("update " . TABLE_BANNERS_HISTORY . " set banners_clicked = banners_clicked + 1 where banners_id = '" . (int)$banner_id . "' and date_format(banners_history_date, '%Y%m%d') = date_format(now(), '%Y%m%d')");
  		}
	}


	function tep_update_multiple_banners_display_count($banner_ids = array()) {
		if ( true === is_array($banner_ids) && 0 < count($banner_ids) ) {
			$banner_ids_sql = '(';
			foreach ( $banner_ids as $banner_id ) {
				if ( true === is_numeric($banner_id) ) {
					$banner_ids_sql .= $banner_id. ',';
				}
			}
			$banner_ids_sql = substr($banner_ids_sql, 0, -1); // remove the last ,
			$banner_ids_sql .= ')';
			$banner_check_query = tep_db_query("SELECT count(*) as count FROM " . TABLE_BANNERS_HISTORY . " WHERE banners_id IN $banner_ids_sql AND date_format(banners_history_date, '%Y%m%d') = date_format(now(), '%Y%m%d')");
			$banner_check = tep_db_fetch_array($banner_check_query);
			if ( $banner_check['count'] == count($banner_ids) ) {
				tep_db_query("update " . TABLE_BANNERS_HISTORY . " set banners_shown = banners_shown + 1 where banners_id IN $banner_ids_sql and date_format(banners_history_date, '%Y%m%d') = date_format(now(), '%Y%m%d')");
			} else {
				foreach ( $banner_ids as $bnr_id ) {
					$banner_inner_check_query = tep_db_query("SELECT count(*) as count FROM " . TABLE_BANNERS_HISTORY . " WHERE banners_id = '$bnr_id' AND date_format(banners_history_date, '%Y%m%d') = date_format(now(), '%Y%m%d')");
					$banner_inner_check = tep_db_fetch_array($banner_inner_check_query);
					if ( 0 < $banner_inner_check['count'] ) {
						tep_db_query('UPDATE ' . TABLE_BANNERS_HISTORY . " set banners_shown = banners_shown + 1 where banners_id = '$bnr_id' and date_format(banners_history_date, '%Y%m%d') = date_format(now(), '%Y%m%d')");
					} else {
						tep_db_query('INSERT INTO ' . TABLE_BANNERS_HISTORY . " (banners_id, banners_shown, banners_history_date) values ('$bnr_id', 1, now())");
					}
				}
			}
		}
	}


	function tep_get_banners($banner_ids = array()) {
		if ( true === is_array($banner_ids) && 0 < count($banner_ids) ) {
			$banner_ids_sql = ' AND banners_id IN (';
			foreach ( $banner_ids as $banner_id ) {
				if ( true === is_numeric($banner_id) ) {
					$banner_ids_sql .= $banner_id. ',';
				}
			}
			$banner_ids_sql = substr($banner_ids_sql, 0, -1); // remove the last ,
			$banner_ids_sql .= ')';
			$banner_query_sql = "
	     		SELECT
	     			banners_id,
	     			banners_title,
	     			banners_image,
	     			banners_html_text
	     		FROM " . TABLE_BANNERS . "
	     		WHERE
	     			status = '1'
	     			AND banners_group = ''
	     			$banner_ids_sql";
			$banner_query = tep_db_query($banner_query_sql);
			while ( $banner = tep_db_fetch_array($banner_query) ) {
				$banners_array[] = $banner;
				$banners_ids_array[] = $banner['banners_id'];
			}
			$banners_return['banners'] = $banners_array;
			$banners_return['banners_ids'] = $banners_ids_array;
			return $banners_return;
		} else {
			return false;
		}
	}

	function tep_get_banner_by_group_id($banners_group) {
		if ( false === empty($banners_group) ) {
			$banner_query_sql = "
	     		SELECT
	     			banners_id,
	     			banners_title,
	     			banners_image,
	     			banners_html_text
	     		FROM " . TABLE_BANNERS . "
	     		WHERE
	     			status = '1'
	     			AND banners_group = '$banners_group'
	     		ORDER BY RAND()
	     		LIMIT 1";
			$banner_query = tep_db_query($banner_query_sql);
			$banner = tep_db_fetch_array($banner_query);

			if ( false === empty($banner['banners_html_text']) ) {
				$banner_html = $banner['banners_html_text'];
			} elseif ( false === empty($banner['banners_image']) ) {
				$banner_html = '<a href="'.tep_href_link(FILENAME_REDIRECT, 'action=banner&goto=' . $banner['banners_id']).'">'.tep_image(DIR_WS_IMAGES.$banner['banners_image'], $banner['banners_title']).'</a>';
			}
			return $banner_html;
		} else {
			return false;
		}
	}

	function tep_insert_banners($text = '') {
		// Insert banners code
		// banner text example: {:BANNER-2:} where '2' is the banners_id.
		if ( 'true' !== BANNER_SYSTEM_ENABLED ) {
			$text = preg_replace('/{:BANNER-\d{0,30}:}/', '', $text); // clean up unused banner inserts
			return $text;
		}

		if ( false === empty($text) && true === is_string($text) ) {
			preg_match_all('/{:BANNER-\d{0,30}:}/', $text, $matches);
			if ( true === is_array($matches[0]) && 0 < count($matches[0]) ) {
				$insert_banners = array();
				foreach ( $matches[0] as $match ) {
					$remove = array('{:BANNER-', ':}');
					$banner_id = str_replace($remove, '', $match);
					$insert_banners[$banner_id] = $match;
				}
				foreach ( $insert_banners as $banners_id => $bnr ) {
					$banners_id_array[] = $banners_id;
				}
				$banners_array = tep_get_banners($banners_id_array);
				if ( true === is_array($banners_array['banners']) ) {
					foreach ( $banners_array['banners'] as $banner ) {
						$banner_html = '';
						if ( false === empty($banner['banners_html_text']) ) {
							$banner_html = $banner['banners_html_text'];
						} elseif ( false === empty($banner['banners_image']) ) {
							$banner_html = '<a href="'.tep_href_link(FILENAME_REDIRECT, 'action=banner&goto=' . $banner['banners_id']).'">'.tep_image(DIR_WS_IMAGES.$banner['banners_image'], $banner['banners_title']).'</a>';
						}
						if ( false === empty($banner_html)  ) {
							$text = str_replace($insert_banners[$banner['banners_id']], $banner_html, $text);
						}
					}
				}
			}
			$text = preg_replace('/{:BANNER-\d{0,30}:}/', '', $text); // clean up unused banner inserts
			tep_update_multiple_banners_display_count($banners_array['banners_ids']);
			return $text;
		} else {
			return false;
		}
	}
?>