<?php
	function get_user_coupon() {
		global $cart, $currencies, $cc_id;
		if ( true == tep_session_is_registered('cc_id') ) { // Found a coupon!
			$coupon_query_sql = "SELECT
								*
							FROM
								" . TABLE_COUPONS . "
							WHERE
								coupon_id = '$cc_id'
								AND coupon_active = 'Y'";
			$coupon_query = tep_db_query($coupon_query_sql);
		    	$coupon = tep_db_fetch_array($coupon_query);

		    	if ( 0 == tep_db_num_rows($coupon_query) ) {
					tep_session_unregister('cc_id');
					return false;
		    	}
		    	$coupon_output = array();

		    	// products restrictions
		    	if ( true === is_array($cart->contents) && false === empty($coupon['restrict_to_products']) ) {
		    		$restrict_to_products = explode(',', $coupon['restrict_to_products']);
		    		foreach ( $cart->contents as $contents_pr_id => $contents_pr) {
		    			if ( false === in_array((int)$contents_pr_id, $restrict_to_products) ) {
						tep_session_unregister('cc_id');
						return false;
		    			}
		    		}
		    	}
		    	$total_amount = $cart->show_total();


		    	$shiptotal = $cart->get_shiptotal();

			//if ( 'true' == MODULE_ORDER_TOTAL_COUPON_INC_TAX ) {
				//$total_amount = tep_round($total_amount + $order->info['tax'], $currencies->currencies[$currency]['decimal_places']);
			//}

		    	switch ($coupon['coupon_type']) {
		    		case 'F':
		    			$coupon_return['text_coupon'] = $currencies->format($coupon['coupon_amount']).' '.TEXT_OFF;
		    			$coupon_return['new_total'] = ($total_amount - $coupon['coupon_amount']);
		    			$coupon_return['total_redeemed'] = $coupon['coupon_amount'];
		    			$coupon_return['coupon_new_total'] = $currencies->format($coupon_return['new_total']);
		    			$coupon_return['coupon_total_redeemed'] = $currencies->format($coupon_return['total_redeemed']);
		    			$coupon_return['coupon_code'] = $coupon['coupon_code'];
		    		break;
		    		case 'P':
		    			if ( $coupon['coupon_amount'] != 0 ) {
		    				$coupon_return['new_total'] = ($total_amount - ($total_amount * $coupon['coupon_amount'] / 100));
		    				$coupon_return['total_redeemed'] = ($total_amount * $coupon['coupon_amount'] / 100);
		    				$coupon_return['coupon_new_total'] = $currencies->format($coupon_return['new_total']);
		    				$coupon_return['coupon_total_redeemed'] = $currencies->format($coupon_return['total_redeemed']);
		    			}
		    			$coupon_return['text_coupon'] = number_format($coupon['coupon_amount'],2).'% '.TEXT_OFF;
		    			$coupon_return['coupon_code'] = $coupon['coupon_code'];
		    		break;
		    		case 'S':
		    			$coupon_return['coupon_type'] = 'FREE_SHIPPING';
		    			$coupon_return['text_coupon'] = TEXT_FREE_SHIPPING;
		    			$coupon_return['coupon_code'] = $coupon['coupon_code'];
		    		break;
		    	}
	    	return $coupon_return;
		} else {
			return false;
		}

	}

	function validate_coupon($coupon_code) {
		global $currencies, $order, $cart, $customer_id;

		$error['count'] = 0;
		$error['message'] = '';

		$coupon_query_sql = "
							SELECT
								coupon_id,
								coupon_code,
								coupon_amount,
								coupon_type,
								coupon_minimum_order,
								uses_per_coupon,
								uses_per_user,
								coupon_start_date,
								coupon_expire_date,
								restrict_to_products,
								restrict_to_categories
							FROM " . TABLE_COUPONS . "
							WHERE
								coupon_code = '$coupon_code'
							AND coupon_active = 'Y'";
		$coupon_query = tep_db_query($coupon_query_sql);

		if ( 0 == tep_db_num_rows($coupon_query) ) {
			$error['message'] = ERROR_NO_INVALID_REDEEM_COUPON;
			$error['count'] = 1;
			return $error;
		}

		$coupon_result = tep_db_fetch_array($coupon_query);
		$error['coupon_result'] = $coupon_result;
		if ( $coupon_result['coupon_type'] != 'G' ) {
		if ( 0 == $coupon_result['uses_per_user'] || tep_session_is_registered('customer_id') ) {
			if ( $coupon_result['coupon_start_date'] || $coupon_result['coupon_expire_date'] ) {
				if ( '0000-00-00 00:00:00' != $coupon_result['coupon_start_date'] ) {
					$coupon_start_time = strtotime($coupon_result['coupon_start_date']);
					if ( time() < $coupon_start_time ) {
						$error['message'] = sprintf(ERROR_INVALID_STARTDATE_COUPON, date('F jS, Y', $coupon_start_time));
						$error['count'] = 1;
						return $error;

					}
				}
				if ( '0000-00-00 00:00:00' != $coupon_result['coupon_expire_date'] ) {
					$coupon_expire_date = strtotime($coupon_result['coupon_expire_date']);
					if ( time() > $coupon_expire_date ) {
						$error['message'] = sprintf(ERROR_INVALID_FINISHDATE_COUPON, date('F jS, Y', $coupon_expire_date));
						$error['count'] = 1;
						return $error;
					}
				}
			}

			if ( $cart->total < $coupon_result['coupon_minimum_order'] ) {
				$error['message'] = sprintf(ERROR_MINIMUM_AMOUNT, $currencies->format($coupon_result['coupon_minimum_order']));
				$error['count'] = 1;
				return $error;
			}

			$coupon_count_sql = "
								SELECT
									coupon_id
								FROM
									" . TABLE_COUPON_REDEEM_TRACK . "
								WHERE
									coupon_id = '{$coupon_result['coupon_id']}'";
			$coupon_count = tep_db_query($coupon_count_sql);

			if ( tep_db_num_rows($coupon_count) >= $coupon_result['uses_per_coupon'] && $coupon_result['uses_per_coupon'] > 0) {
				$error['message'] = sprintf(ERROR_INVALID_USES_COUPON, $coupon_result['uses_per_coupon']);
				$error['count'] = 1;
				return $error;
			}

			$coupon_count_customer_sql = "
										SELECT
											coupon_id
										FROM
											" . TABLE_COUPON_REDEEM_TRACK . "
										WHERE
											coupon_id = '{$coupon_result['coupon_id']}'
											AND customer_id = '$customer_id'";
			$coupon_count_customer = tep_db_query($coupon_count_customer_sql);

			if ( tep_db_num_rows($coupon_count_customer) >= $coupon_result['uses_per_user'] && $coupon_result['uses_per_user'] > 0 ) {
				$error['message'] = ERROR_INVALID_USES_USER_COUPON;
				$error['count'] = 1;
				return $error;
			}

			# Product/Category Restrictions Start
			if ( false === empty($coupon_result['restrict_to_products']) || false === empty($coupon_result['restrict_to_categories']) ) {
				if ( false === is_array($cart->contents) ) {
					$error['message'] = ERROR_RESTRICTIONS;
					$error['count'] = 1;
					return $error;
				}
				foreach ( $cart->contents as $productid => $vals) {
					$productid = (int)$productid; // remove all trailing attributes

					if ( $coupon_result['restrict_to_products'] ) {
						$pr_ids = explode(',', $coupon_result['restrict_to_products']);
						if ( false === in_array($productid, $pr_ids) ) {
							$error['message'] = ERROR_RESTRICTIONS;
							$error['count'] = 1;
							return $error;
						}
					}

					if ( $coupon_result['restrict_to_categories'] ) {
						$cat_ids = split(',', $coupon_result['restrict_to_categories']);
						$my_path = tep_get_product_path($productid);
						$sub_cat_ids = split('_', $my_path);
						foreach ( $sub_cat_ids as $sub_cat_id) {
							if ( false === in_array($sub_cat_id, $cat_ids) ) {
								$error['message'] = ERROR_RESTRICTIONS;
								$error['count'] = 1;
								return $error;
							}
						}
					}
				}
			}
			/**/
			# Product/Category Restrictions End
		} else {
			$error['message'] = ERROR_LOGIN_TO_CHECK;
			$error['count'] = 1;
			return $error;
		}

		}

		return $error;
	}

	function get_coupon_code_by_cc_id($cc_id) {
		if ( false === empty($cc_id) ) {
		$coupon_cc_id_query_sql = "
								SELECT
									coupon_code
								FROM " . TABLE_COUPONS . "
								WHERE
									coupon_id = '$cc_id'
									AND coupon_active = 'Y'";
		$coupon_cc_id_query = tep_db_query($coupon_cc_id_query_sql);
			if ( 0 < tep_db_num_rows($coupon_cc_id_query) ) {
				$coupon_result = tep_db_fetch_array($coupon_cc_id_query);
				return $coupon_result['coupon_code'];
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	function get_coupon_discount($coupon_code) {
		if ( false === empty($coupon_code) ) {
		$coupon_code_query_sql = "
								SELECT
									coupon_type,
									coupon_amount
								FROM " . TABLE_COUPONS . "
								WHERE
									coupon_code = '$coupon_code'
									AND coupon_active = 'Y'";
		$coupon_code_query = tep_db_query($coupon_code_query_sql);
			if ( 0 < tep_db_num_rows($coupon_code_query) ) {
				$coupon_result = tep_db_fetch_array($coupon_code_query);
				return $coupon_result;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	function silent_revalidate_coupon() {
		global $cc_id, $cart;

		if ( true == tep_session_is_registered('cc_id') ) { // Found a coupon!
			$coupon_query_sql = "
								SELECT
									coupon_code
								FROM " . TABLE_COUPONS . "
								WHERE
									coupon_id = '$cc_id'
									AND coupon_active = 'Y'";
			$coupon_query = tep_db_query($coupon_query_sql);

			if ( 0 < tep_db_num_rows($coupon_query) ) {
				$coupon_result = tep_db_fetch_array($coupon_query);
				$coupon_code = $coupon_result['coupon_code'];
				$coupon_error = validate_coupon($coupon_code);
				if ( 0 < $coupon_error['count'] ) {
					tep_session_unregister('cc_id');
					$cc_id = '';
				}
			} else {
				tep_session_unregister('cc_id');
				$cc_id = '';
			}
		}
	}

?>