<?php

  function implode_assoc($array, $inner_glue='=', $outer_glue='&') {
    $output = array();
    foreach( $array as $key => $item )
    $output[] = $key . $inner_glue . $item;

    return implode($outer_glue, $output);
  }

  function short_name($str, $limit = 3) {
    if (defined('SEO_URLS_FILTER_SHORT_WORDS')) $limit = SEO_URLS_FILTER_SHORT_WORDS;
    $foo = explode('-', $str);
    foreach($foo as $index => $value){
		switch (true) {
			case ( strlen($value) <= $limit ):
				continue;
			default:
				$container[] = $value;
			break;
		}
    } # end foreach
    $container = ( sizeof($container) > 1 ? implode('-', $container) : $str );
    return $container;
  }


	# tep_purefy_link($link)
	# strange bug fix : when linking from shopping cart:
	# /product_info.php?products_id=231{2}7{1}1?osCsid=43e458ae774a4683f34fe70d3e8686b0b
	# the link is generate with two "?" on some servers. not sure why.
	# so here is a quick fix for that.
	function tep_purefy_link($link){
		$link_chunks = explode('?', $link);
		if ( 1 >= count($link_chunks) ) {
			return $link;
		}
		if( 2 < count($link_chunks) ) {
			# Detected the problem
			foreach($link_chunks as $link_chunk){
				if ( $link_chunks[0] == $link_chunk ) {
					$newborn_url .= $link_chunk.'?';
				} else if ( $link_chunks[1] == $link_chunk ) {
					$newborn_url .= $link_chunk;
				} else {
					$newborn_url .= '&'.$link_chunk;
				}
			}
		} else {
			$newborn_url = $link; # kinda old one - no problems :)
		}

		return $newborn_url;
	}



	function tep_href_link_external($link = '') {
		if( true === empty($link) ) {
			return false;
		}
		if ( !strstr($link, 'http://') && !strstr($link, 'https://') ) {
			return 'http://'.$link;
		} else {
			return $link;
		}
	}

	function tep_href_link_phpbb($link = '') {
		if( true === empty($link) ) {
			return false;
		}
		if ( strstr($link, '?') ) {
			return $link. '&sid=' .tep_session_id();
		} else {
			return $link. '?sid=' .tep_session_id();
		}

	}

	function tep_href_link($page = '', $parameters = '', $connection = 'NONSSL', $add_session_id = true, $search_engine_safe = true) {
		global $request_type, $session_started, $SID;

		$seo = ( defined('SEO_URLS') ? SEO_URLS : false );
		$seo_rewrite_type = ( defined('SEO_URLS_TYPE') ? SEO_URLS_TYPE : false );
		$seo_pages = array('index.php', 'product_info.php', 'article_info.php', 'manufacturers.php');
		if ( !in_array($page, $seo_pages) ) {
			$seo = false;
		}

		if (!tep_not_null($page)) {
			$page = $_SERVER['PHP_SELF'];
		}
		if ($page == '/') $page = '';

		if ($connection == 'NONSSL') {
			$link = HTTP_SERVER . DIR_WS_HTTP_CATALOG;
			$seo_link = HTTP_SERVER . DIR_WS_HTTP_CATALOG;
			$seo_rewrite_link = HTTP_SERVER . DIR_WS_HTTP_CATALOG;
		} elseif ($connection == 'SSL') {

			if (ENABLE_SSL == true) {
				$link = HTTPS_SERVER . DIR_WS_HTTPS_CATALOG;
				$seo_link = HTTPS_SERVER . DIR_WS_HTTPS_CATALOG;
				$seo_rewrite_link = HTTPS_SERVER . DIR_WS_HTTPS_CATALOG;
			} else {
				$link = HTTP_SERVER . DIR_WS_HTTP_CATALOG;
				$seo_link = HTTP_SERVER . DIR_WS_HTTP_CATALOG;
				$seo_rewrite_link = HTTP_SERVER . DIR_WS_HTTP_CATALOG;
			}

		} else {
			die('<font color="#ff0000"><b>Error!</b><br /><br /><b>Unable to determine connection method on a link!<br><br>Known methods: NONSSL SSL</b>');
		}

		if ( true == tep_not_null($parameters) ) {
			$link .= $page . '?' . tep_output_string($parameters);
			$separator = '&';

			if ( $seo == 'true' ) {
				$p = explode('&', $parameters);
				krsort($p);
				$params = array();

				if ( $seo_rewrite_type == 'Rewrite' ) {
					foreach ($p as $index => $valuepair) {
						$p2 = explode('=', $valuepair);
						switch ( $p2[0] ) {
							case 'products_id':
								$rewrite_product = true;
								if ( defined('PRODUCT_NAME_'.$p2[1]) ) {
									$rewrite_page_product = short_name(constant('PRODUCT_NAME_'.$p2[1])) . '-p-' . $p2[1] . '.html';
								} else {
									$seo = false;
								}
							break;
							case 'cPath':
								$rewrite_category = true;
								if ( defined('CATEGORY_NAME_'.$p2[1]) ) {
									$rewrite_page_category = short_name(constant('CATEGORY_NAME_'.$p2[1])) . '-c-' . $p2[1] . '.html';
								} else {
									$seo = false;
								}

							break;
							case 'articles_id':
								$rewrite_article = true;
								if ( defined('ARTICLE_NAME_'.$p2[1]) ) {
									$rewrite_page_article = short_name(constant('ARTICLE_NAME_'.$p2[1])) . '-a-' . $p2[1] . '.html';
								} else {
									$seo = false;
								}
							break;
							case 'manufacturers_id':
								$rewrite_manufacturer = true;
								if ( defined('MANUFACTURER_NAME_'.$p2[1]) ){
									$rewrite_page_manufacturer = short_name(constant('MANUFACTURER_NAME_'.$p2[1])) . '-m-' . $p2[1] . '.html';
								} else {
									$seo = false;
								}
							break;
							default:
								$params[$p2[0]] = $p2[1];
							break;
							}
						}
					$params_stripped = implode_assoc($params);
					switch (true){
						case ( $rewrite_product && $rewrite_category ):
							case ( $rewrite_product ):
								$rewrite_page = $rewrite_page_product;
								$rewrite_category = false;
							break;

							case ( $rewrite_category ):
								$rewrite_page = $rewrite_page_category;
							break;

							case ( $rewrite_article ):
								$rewrite_page = $rewrite_page_article;
							break;

							case ( $rewrite_manufacturer ):
								$rewrite_page = $rewrite_page_manufacturer;
							break;
							default:
								$seo = false;
							break;
					}
					$seo_rewrite_link .= $rewrite_page . ( tep_not_null($params_stripped) ? '?'.tep_output_string($params_stripped) : '' );
					$separator = ( tep_not_null($params_stripped) ? '&' : '?' );
				} else {
					foreach ($p as $index => $valuepair) {
						$p2 = explode('=', $valuepair);
						switch ($p2[0]){
							case 'products_id':
								if ( defined('PRODUCT_NAME_'.$p2[1]) ){
									$params['pName'] = constant('PRODUCT_NAME_'.$p2[1]);
									} else {
										$seo = false;
									}
							break;

							case 'cPath':
								if ( defined('CATEGORY_NAME_'.$p2[1]) ){
									$params['cName'] = constant('CATEGORY_NAME_'.$p2[1]);
								} else {
									$seo = false;
								}
							break;

							case 'articles_id':
								$rewrite_article = true;
								if ( defined('ARTICLE_NAME_'.$p2[1]) ) {
									$params['articles_id'] = constant('ARTICLE_NAME_'.$p2[1]);
									} else {
										$seo = false;
									}
								break;
							case 'manufacturers_id':
								if ( defined('MANUFACTURER_NAME_'.$p2[1]) ){
									$params['mName'] = constant('MANUFACTURER_NAME_'.$p2[1]);
									} else {
										$seo = false;
									}
							break;

							default:
								$params[$p2[0]] = $p2[1];
							break;
							}
					}
					$params_stripped = implode_assoc($params);
					$seo_link .= $page . '?'.httep_output_string($params_stripped);
					$separator = '&';
				}
				}
			} else {
				$link .= $page;
				$separator = '?';
				$seo = false;
			}

		while ( (substr($link, -1) == '&') || (substr($link, -1) == '?') ) $link = substr($link, 0, -1);

		// Add the session ID when moving from different HTTP and HTTPS servers, or when SID is defined
		if ( ($add_session_id == true) && ($session_started == true) && (SESSION_FORCE_COOKIE_USE == 'False') ) {
			if (tep_not_null($SID)) {
				$_sid = $SID;
			} elseif ( ( ($request_type == 'NONSSL') && ($connection == 'SSL') && (ENABLE_SSL == true) ) || ( ($request_type == 'SSL') && ($connection == 'NONSSL') ) ) {
				if (HTTP_COOKIE_DOMAIN != HTTPS_COOKIE_DOMAIN) {
					$_sid = tep_session_name() . '=' . tep_session_id();
				}
			}
		}

		if (!tep_session_is_registered('customer_id') && ENABLE_PAGE_CACHE == 'true' && class_exists('page_cache')) {
			$link .= $separator . '<osCsid>';
			$seo_link .= $separator . '<osCsid>';
			$seo_rewrite_link .= $separator . '<osCsid>';
		} elseif (isset($_sid)) {
			$link .= $separator . tep_output_string($_sid);
			$seo_link .= $separator . tep_output_string($_sid);
			$seo_rewrite_link .= $separator . tep_output_string($_sid);
		}

		if ($seo == 'true') {
			return ($seo_rewrite_type == 'Rewrite' ? $seo_rewrite_link : $seo_link);
		} else {
			$link = tep_purefy_link($link);
			list($server, $params) = explode('?', $link);
			$params = htmlentities($params); // valid xhtml
			if ( true === empty($params) ) {
				return $server;
			} else {
				return $server . '?' . $params;
			}

		}

	}

////
// The HTML image wrapper function
// "On the Fly" Auto Thumbnailer using GD Library, servercaching and browsercaching
// Scales product images dynamically, resulting in smaller file sizes, and keeps
// proper image ratio. Used in conjunction with product_thumb.php t/n generator.
function tep_image($src, $alt = '', $width = '', $height = '', $params = '', $nocache = false, $full_path = false) {

	// if no file exists display the 'no image' file
	  if ( false === is_file($src) ) {
	 	$src = TEMPLATE_IMAGES_DIR . 'no_image.jpg';
	  }

    // Set default image variable and code
    $image = '<img src="' . $src . '"';

    // Don't calculate if the image is set to a "%" width
    if (strstr($width,'%') == false || strstr($height,'%') == false) {
        $dont_calculate = 0;
    } else {
        $dont_calculate = 1;
    }

    // Dont calculate if a pixel image is being passed (hope you dont have pixels for sale)
    if (!strstr($image, 'pixel')) {
        $dont_calculate = 0;
    } else {
        $dont_calculate = 1;
    }

    // Do we calculate the image size?
    if (CONFIG_CALCULATE_IMAGE_SIZE && !$dont_calculate) {

        // Get the image's information
        if ($image_size = @getimagesize($src)) {

            $ratio = $image_size[1] / $image_size[0];

            // Set the width and height to the proper ratio
            if (!$width && $height) {
                $ratio = $height / $image_size[1];
                $width = intval($image_size[0] * $ratio);
            } elseif ($width && !$height) {
                $ratio = $width / $image_size[0];
                $height = intval($image_size[1] * $ratio);
            } elseif (!$width && !$height) {
                $width = $image_size[0];
                $height = $image_size[1];
            }

            // Scale the image if not the original size
            if ($image_size[0] != $width || $image_size[1] != $height) {

                $rx = ( 0 < $width ? $image_size[0] / $width : 0 );
                $ry = ( 0 < $height ? $image_size[1] / $height : 0 );

                if ($rx < $ry) {
                    $width = intval($height / $ratio);
                } else {
                    $height = intval($width * $ratio);
                }
				if ( true === $nocache ) {
					$nocache_string = '&amp;nocache=1&amp;time='.time();
				}
				$full_path_string = '';
				if ( true === $full_path ) {
					$full_path_string = HTTP_SERVER . DIR_WS_CATALOG;
				}
                $image = '<img src="'.$full_path_string.'product_thumb.php?img=' . $src . '&amp;w=' .
                tep_output_string($width) . '&amp;h=' . tep_output_string($height) .$nocache_string. '"';
            }

        } elseif (IMAGE_REQUIRED == 'false') {
            return '';
        }
    }

    // Add remaining image parameters if they exist
	if ( false === empty($width) ) {
		$image .= ' width="' . tep_output_string($width) . '"';
	}

	if ( false === empty($height) ) {
		$image .= ' height="' . tep_output_string($height) . '"';
	}

    if (tep_not_null($params)) $image .= ' ' . $params;

    $image .= ' alt="' . tep_output_string($alt, false, true) . '"';

    if (tep_not_null($alt)) {
        $image .= ' title="' . tep_output_string($alt, false, true) . '"';
    }

    $image .= ' />';

    return $image;
}

////
// The HTML form submit button wrapper function
// Outputs a button in the selected language
  function tep_image_submit($image, $alt = '', $parameters = '') {
    global $language;

    $image_submit = '<input type="image" src="' . tep_output_string(DIR_WS_LANGUAGES . $language . '/images/buttons/' . $image) . '" alt="' . tep_output_string($alt) . '"';

    if (tep_not_null($alt)) $image_submit .= ' title=" ' . tep_output_string($alt) . ' "';

    if (tep_not_null($parameters)) $image_submit .= ' ' . $parameters;

    $image_submit .= ' />';

    return $image_submit;
  }

////
// Output a function button in the selected language
  function tep_image_button($image, $alt = '', $parameters = '') {
    global $language;

    return tep_image(DIR_WS_LANGUAGES . $language . '/images/buttons/' . $image, $alt, '', '', $parameters);
  }

////
// Output a separator either through whitespace, or with an image
  function tep_draw_separator($image = 'pixel_black.gif', $width = '100%', $height = '1') {
    return tep_image(DIR_WS_IMAGES . $image, '', $width, $height);
  }

////
// Output a form
/*
  function tep_draw_form($name, $action, $method = 'post', $parameters = '') {
    $form = '<form name="' . tep_output_string($name) . '" action="' . tep_output_string($action) . '" method="' . tep_output_string($method) . '"';


    if (tep_not_null($parameters)) $form .= ' ' . $parameters;

    $form .= '>';

    return $form;
  }
  */
	# XHTML 'Strict' complaint
	function tep_draw_form($id, $action, $method = 'post', $parameters = '') {
		$form = '<form id="' . tep_output_string($id) . '" action="' . tep_output_string($action) . '" method="' . tep_output_string($method) . '"' .
				( true == tep_not_null($parameters) ? " $parameters" : '' ) . '>';
		return $form;
	}

////
// Output a form input field
  function tep_draw_input_field($name, $value = '', $parameters = '', $type = 'text', $reinsert_value = true) {
    $field = '<input type="' . tep_output_string($type) . '" name="' . tep_output_string($name) . '"';

    if ( (isset($GLOBALS[$name])) && ($reinsert_value == true) ) {
      $field .= ' value="' . tep_output_string(stripslashes($GLOBALS[$name])) . '"';
    } elseif (tep_not_null($value)) {
      $field .= ' value="' . tep_output_string($value) . '"';
    }

    if (tep_not_null($parameters)) $field .= ' ' . $parameters;

    $field .= ' />';

    return $field;
  }

////
// Output a form password field
  function tep_draw_password_field($name, $value = '', $parameters = 'maxlength="40"') {
    return tep_draw_input_field($name, $value, $parameters, 'password', false);
  }

////
// Output a selection field - alias function for tep_draw_checkbox_field() and tep_draw_radio_field()
  function tep_draw_selection_field($name, $type, $value = '', $checked = false, $parameters = '') {
    $selection = '<input type="' . tep_output_string($type) . '" name="' . tep_output_string($name) . '"';

    if (tep_not_null($value)) $selection .= ' value="' . tep_output_string($value) . '"';

    if ( ($checked == true) || ( isset($GLOBALS[$name]) && is_string($GLOBALS[$name]) && ( ($GLOBALS[$name] == 'on') || (isset($value) && (stripslashes($GLOBALS[$name]) == $value)) ) ) ) {
      $selection .= ' checked="checked"';
    }

    if (tep_not_null($parameters)) $selection .= ' ' . $parameters;

    $selection .= ' />';

    return $selection;
  }

////
// Output a form checkbox field
  function tep_draw_checkbox_field($name, $value = '', $checked = false, $parameters = '') {
    return tep_draw_selection_field($name, 'checkbox', $value, $checked, $parameters);
  }

////
// Output a form radio field
  function tep_draw_radio_field($name, $value = '', $checked = false, $parameters = '') {
    return tep_draw_selection_field($name, 'radio', $value, $checked, $parameters);
  }

////
// Output a form textarea field
  function tep_draw_textarea_field($name, $wrap, $width, $height, $text = '', $parameters = '', $reinsert_value = true) {
   // $field = '<textarea name="' . tep_output_string($name) . '" wrap="' . tep_output_string($wrap) . '" cols="' . tep_output_string($width) . '" rows="' . tep_output_string($height) . '"';
	 $field = '<textarea name="' . tep_output_string($name) . '" cols="' . tep_output_string($width) . '" rows="' . tep_output_string($height) . '"';

    if (tep_not_null($parameters)) $field .= ' ' . $parameters;

    $field .= '>';

    if ( (isset($GLOBALS[$name])) && ($reinsert_value == true) ) {
// LINE CHANGED: MS2 update 501112 - Added: tep_output_string_protected(...)
      $field .= tep_output_string_protected(stripslashes($GLOBALS[$name]));
    } elseif (tep_not_null($text)) {
// LINE CHANGED: MS2 update 501112 - Added: tep_output_string_protected(...)
      $field .= tep_output_string_protected($text);
    }

    $field .= '</textarea>';

    return $field;
  }

////
// Output a form hidden field
  function tep_draw_hidden_field($name, $value = '', $parameters = '') {
    $field = '<input type="hidden" name="' . tep_output_string($name) . '"';

    if (tep_not_null($value)) {
      $field .= ' value="' . tep_output_string($value) . '"';
    } elseif (isset($GLOBALS[$name])) {
      $field .= ' value="' . tep_output_string(stripslashes($GLOBALS[$name])) . '"';
    }

    if (tep_not_null($parameters)) $field .= ' ' . $parameters;

    $field .= ' />';

    return $field;
  }

////
// Hide form elements
  function tep_hide_session_id() {
    global $session_started, $SID;

    if (($session_started == true) && tep_not_null($SID)) {
      return tep_draw_hidden_field(tep_session_name(), tep_session_id());
    }
  }

////
// Output a form pull down menu
  function tep_draw_pull_down_menu($name, $values, $default = '', $parameters = '', $required = false) {
    $field = '<select name="' . tep_output_string($name) . '"';

    if (tep_not_null($parameters)) $field .= ' ' . $parameters;

    $field .= '>';

    if (empty($default) && isset($GLOBALS[$name])) $default = stripslashes($GLOBALS[$name]);

    for ($i=0, $n=sizeof($values); $i<$n; $i++) {
      $field .= '<option value="' . tep_output_string($values[$i]['id']) . '"';
      if ($default == $values[$i]['id']) {
        $field .= ' selected="selected"';
      }

      $field .= '>' . tep_output_string($values[$i]['text'], array('"' => '&quot;', '\'' => '&#039;', '<' => '&lt;', '>' => '&gt;')) . '</option>';
    }
    $field .= '</select>';

    if ($required == true) $field .= TEXT_FIELD_REQUIRED;

    return $field;
  }

////
// Creates a pull-down list of countries
  function tep_get_country_list($name, $selected = '', $parameters = '') {
    $countries_array = array(array('id' => '', 'text' => PULL_DOWN_DEFAULT));
    $countries = tep_get_countries();

    for ($i=0, $n=sizeof($countries); $i<$n; $i++) {
      $countries_array[] = array('id' => $countries[$i]['countries_id'], 'text' => $countries[$i]['countries_name']);
    }

    return tep_draw_pull_down_menu($name, $countries_array, $selected, $parameters);
  }


  function tep_star_image_name($value = 5, $ext = 'gif', $size = 'SMALL'){
		$val        = round($value,1);
		$floorvalue = floor($val);

		if(($val > $floorvalue) && !($val > ($floorvalue+0.5)))
		$new_value = $floorvalue+0.5;

		if($val > ($floorvalue+0.5))
		$new_value = $floorvalue+1;


		if($floorvalue==$val)
		$new_value = $val;

		if($new_value==floor($new_value)): # one digit.
		if($size=='BIG')
		$image_name = 'stars_big_'.$new_value.'.'.$ext;
		else
		$image_name = 'stars_'.$new_value.'.'.$ext;

		else:
			$d1 = floor($new_value);
			$d2 = ((($new_value - $d1)+0.5)+4);

		if($size=='BIG')
		$image_name = 'stars_big_'.$d1.'_'.$d2.'.'.$ext;
		else
		$image_name = 'stars_'.$d1.'_'.$d2.'.'.$ext;
		endif;
		return $image_name;
	}


?>
