<?php

	function getActivePluginsInfo($languages_id = 1, $exclude_group_array = array()) {
		$not_in_sql = '';

		if ( true === is_array($exclude_group_array) ) {
			if ( 0 < count($exclude_group_array) ) {
				#
				$not_in_sql = " AND plugins_group NOT IN (";
				foreach ( $exclude_group_array as $exclude_group ) {
					$not_in_sql .= "'$exclude_group'";
					$not_in_sql .= ( $exclude_group != end($exclude_group_array) ? ',' : '' );
				}
				$not_in_sql .= " ) ";
			}
		}

		$plugins_query_sql = "
						SELECT
							plugins_id,
							language_id,
							plugins_key,
							plugins_group,
							plugins_options,
							plugins_name,
							plugins_text,
							plugins_file_name,
							plugins_description,
							plugins_sort_order
						FROM
							" . TABLE_PLUGINS . "
						WHERE
							plugins_status = '1'
							AND language_id = '$languages_id'
							$not_in_sql
						ORDER BY
							plugins_sort_order
						";
		$plugins_query = tep_db_query($plugins_query_sql);

		if ( 0 < tep_db_num_rows($plugins_query) ) {
			$return_plugins = array();
			while ( $plugins = tep_db_fetch_array($plugins_query) ) {
				if ( false === is_array($return_plugins[$plugins['plugins_group']]) ) {
					$return_plugins[$plugins['plugins_group']] = array();
				}
				list($tpl, $ext) = explode('.',$plugins['plugins_file_name']);
				$plugins['plugins_tpl_file_name'] = 'plugins/'.$tpl.'.tpl';
				$plugins['plugins_options'] = unserialize($plugins['plugins_options']);
				array_push($return_plugins[$plugins['plugins_group']], $plugins);
			}
			return $return_plugins;

		} else {
			return false;
		}

	}


	function init($PLUGIN_KEY = '') {
		global $plugins_info, $plugin_files;
		if ( true === is_array($plugin_files) ) {
			foreach ( $plugin_files as $plugin_file ) {
				if ( true === is_array($plugin_file) ) {
					foreach ( $plugin_file as $plg ) {
						if ( $PLUGIN_KEY == $plg['plugins_key'] ) {
							$return_init = array(
											'PLUGIN_KEY' 		=> $plg['plugins_key'],
											'PLUGIN_LANGUAGE' 	=> $plg['language_id'],
											'PLUGIN_ID' 		=> $plg['plugins_id'],
											'PLUGIN_GROUP'		=> $plg['plugins_group'],
											'PLUGIN_NAME'		=> stripslashes($plg['plugins_name']),
											'PLUGIN_OPTIONS'	=> $plg['plugins_options'],
											'PLUGIN_TEXT' 		=> $plg['plugins_text']
							);
						}

					}
				}

			}
			return $return_init;
		}
	}
?>