<?php
	function fetchProducts($products_query_sql = '', $paging = true) {
		global $currencies, $smarty, $customers_group_id, $customer_id, $customer_email, $wo_full_name, $number_of_products;

		if ( true === $paging ) {
			$listing_split = new splitPageResults($products_query_sql, MAX_DISPLAY_SEARCH_RESULTS, 'p.products_id' );
			$products_query = tep_db_query($listing_split->sql_query);
			$number_of_products = $listing_split->number_of_rows;
		} else {
			$products_query = tep_db_query($products_query_sql);
			$number_of_products = tep_db_num_rows($products_query);

		}

		while ( $product = tep_db_fetch_array($products_query) ) {
		// products access
		if ( true === isset($product['products_access']) ) {
			$customer_access_ids = explode(',', $product['products_access']);
			$customers_group_id = ( true === empty($customers_group_id) ? '0' : $customers_group_id );
			if ( false === in_array($customers_group_id, $customer_access_ids)) {
				continue;
			}
		}

		if( false === empty($product['products_image_thumb']) ) {
			$product['products_image'] = DIR_WS_IMAGES.$product['products_image_thumb'];
		} else {
			$product['products_image'] = DIR_WS_IMAGES.$product['products_image'];
			if ( 'on' === IMAGE_STAMP_ON_OFF ) {
				if( $product['products_image_stamp'] ) {
					$product['products_image'] = generate_image_stamp($product['products_image'], DIR_WS_IMAGES.$product['products_image_stamp']);
				}
			}
		}
		$review_stars_alt = ( 0 >= $product['average_rating'] ? 'Not rated' : $product['average_rating'] .' out of '.$product['average_rating'].' stars' );
		$product['average_rating_image_src'] = TEMPLATE_IMAGES_DIR.tep_star_image_name($product['average_rating'], 'gif','SMALL' );
		$product['average_rating_image'] = '<img src="'.$product['average_rating_image_src'].'" alt="'.$review_stars_alt.'" title="'.$review_stars_alt.'" />';


		$product['url'] = tep_href_link(FILENAME_PRODUCT_INFO, ($cPath ? 'cPath=' . $cPath . '&' : '') . 'products_id=' . $product['products_id']);
		if( false === empty($product['products_image_thumb']) ) {
			$product['image'] = tep_image($product['products_image'], stripslashes($product['products_name']));
		} else {
			$product['image'] = tep_image($product['products_image'], stripslashes($product['products_name']), SUBCATEGORY_IMAGE_WIDTH, SUBCATEGORY_IMAGE_HEIGHT);
		}
		$product['image_smaller'] = tep_image($product['products_image'], stripslashes($product['products_name']), SMALLER_IMAGE_WIDTH, SMALLER_IMAGE_HEIGHT);


		if ( false === empty($product['manufacturers_image']) ) {
			$product['manufacturers_image'] = tep_image(DIR_WS_IMAGES . $product['manufacturers_image'], stripslashes($product['manufacturers_name']), MANUFACTURERS_SMALL_IMAGE_WIDTH, MANUFACTURERS_SMALL_IMAGE_HEIGHT);
		}

		if ( false === empty($product['manufacturers_id']) ) {
			$product['manufacturers_link_url'] = tep_href_link(FILENAME_MANUFACTURERS, 'manufacturers_id=' . $product['manufacturers_id']);
		}

		$product['tax'] = tep_get_tax_rate($product['products_tax_class_id']);

		//specials_new_products_price
		$new_price = $product['specials_new_products_price'];
		$products_base_price = $product['products_price'];
		if ( '0' != $customers_group_id && true === is_numeric($customers_group_id) && '1' == $product['products_price_groups'] && false === empty($product['products_id']) ) {
			$products_base_price = tep_get_products_group_base_price($product['products_id'], $customers_group_id, $product['products_price']);
		}
		$product['price'] = $currencies->display_price($products_base_price, 0);
		$product['price_with_tax'] = $currencies->display_price($products_base_price, $product['tax']);

		if ( 0 < $product['products_ship_price'] ) {
			$product['products_ship_price'] = $currencies->display_price($product['products_ship_price'], 0);
		} else {
			$product['products_ship_price'] = '';
		}

		if ( 0 < $product['products_ship_price_two'] ) {
			$product['products_ship_price_two'] = $currencies->display_price($product['products_ship_price_two'], 0);
		} else {
			$product['products_ship_price_two'] = '';
		}

		if ( 'On' == ENABLE_PRODUCTS_BUNDLES && '1' == $product['products_bundle'] ) {
			if ( false === empty($new_price) &&  $new_price < $products_base_price ) {
				$product['price'] = $currencies->display_price($new_price, 0);
			}
		} else {
			if ( false === empty($new_price) ) {
				if ( $new_price < $products_base_price ) {
				$product['price'] = $currencies->display_price($products_base_price, 0);
				$product['price_special'] = $currencies->display_price($new_price, 0);
				$product['price_saved'] = $currencies->display_price($product['products_price']-$new_price, 0);
				$product['price_saved_percent'] = floor(($product['products_price']-$new_price) *  100 / $product['products_price']);
				$product['price_special_with_tax'] = $currencies->display_price($new_price, $product['tax']);
				}
			}
		}

		$product['buy_now_url'] = tep_href_link(FILENAME_DEFAULT, 'action=buy_now&products_id='.$product['products_id']);
		$product['reviews_url'] = tep_href_link(FILENAME_PRODUCT_REVIEWS, 'products_id='.$product['products_id']);

		$product['time_available'] = strtotime($product['products_date_available']);
		if ( time() >= $product['time_available'] ) {
			$product['available'] = 'true';
		} else {
			$product['available'] = 'false';
			$smarty->assign('TEXT_PRODUCT_NOT_AVAILABLE_DATE',sprintf(TEXT_PRODUCT_NOT_AVAILABLE_DATE,  date("M-d-Y", $product['time_available'])));
			$smarty->assign('TEXT_PRODUCT_NOT_AVAILABLE',TEXT_PRODUCT_NOT_AVAILABLE);
		}
		switch ( $product['products_price_hidden'] ) {
			case 1;
				if ( true === empty($customer_id) ) {
					$product['available'] = 'false';
					$product['price'] = 0;
					$product['price_hidden'] = true;
					$product['price_hidden_text'] = TEXT_PRICE_LOGIN;
					$product['price_hidden_text_url'] = tep_href_link(FILENAME_LOGIN, $login_logout_params, 'SSL');
				}
			break;
			case 2;
				$product['available'] = 'false';
				$product['price'] = 0;
				$product['price_hidden'] = true;
				$product['price_hidden_text'] = TEXT_PRICE_CALL;
				if ( true === defined('DEFAULT_CONTACT_PAGE') && '' != DEFAULT_CONTACT_PAGE ) {
					$products_name = urlencode($product['products_name']);
					$contact_params = ( false === empty($customer_id) ? 'subject='.TEXT_PRICE_SUBJECT.'&enquiry='.$products_name.'&email=' . $customer_email . '&name=' . $wo_full_name : 'subject='.TEXT_PRICE_SUBJECT.'&enquiry='.$products_name );
					$product['price_hidden_text_url'] = tep_href_link(DEFAULT_CONTACT_PAGE, $contact_params);
				}
			break;
		}
		$product['products_name'] = htmlspecialchars($product['products_name']);
		$_PRODUCTS[] = $product;

		}
		### PAGING
		if ( true === $paging ) {
			if ( $listing_split->get_number_of_pages() > 1 ) {
				$smarty->assign('TEXT_DISPLAY_NUMBER_OF_PRODUCTS', $listing_split->display_count(TEXT_DISPLAY_NUMBER_OF_PRODUCTS));
				$_PAGING = TEXT_RESULT_PAGE . ' ' . $listing_split->display_links(MAX_DISPLAY_PAGE_LINKS, tep_get_all_get_params(array('page', 'info', 'x', 'y')));
				if ( (PREV_NEXT_BAR_LOCATION == '1' || PREV_NEXT_BAR_LOCATION == '3')  ) { // top
					$smarty->assign('_PAGINGTOP', $_PAGING);
				}
				if ( (PREV_NEXT_BAR_LOCATION == '2' || PREV_NEXT_BAR_LOCATION == '3')  ) { // top
					$smarty->assign('_PAGINGBOTTOM', $_PAGING);
				}
			}
		}
		### PAGING

		return $_PRODUCTS;
	}
	function fetchBundleProducts($products_id = 0, $products_price = 0) {
		global $currencies, $smarty, $languages_id, $customers_group_id;
		if ( false === is_numeric($products_id) || 0 == $products_id ) {
			return false;
		}
		$bundle_data_array = tep_get_bundle_products($products_id);
		if ( true === is_array($bundle_data_array['products']) ) {
			foreach ( $bundle_data_array['products'] as $bundle_data ) {
				$bundle_data['url'] = tep_href_link(FILENAME_PRODUCT_INFO, ($cPath ? 'cPath=' . $cPath . '&' : '') . 'products_id=' . $bundle_data['products_id']);
				if ( false === empty($bundle_data['specials_new_products_price']) ) {
					if ( $bundle_data['specials_new_products_price'] < $bundle_data['products_price'] ) {
					$bundle_data['products_price'] = $bundle_data['specials_new_products_price'];
					}
				}
				$bundle_data['price'] = $currencies->display_price($bundle_data['products_price'], tep_get_tax_rate($product_info['products_tax_class_id']));
				$bundle_data['products_price_total'] = $currencies->display_price($bundle_data['products_price']*$bundle_data['products_bundle_qty'], tep_get_tax_rate($product_info['products_tax_class_id']));
				$bundle_data['products_image_src'] = DIR_WS_IMAGES.$bundle_data['products_image'];
				if ( 'on' === IMAGE_STAMP_ON_OFF ) {
					if( false === empty($bundle_data['products_image_stamp']) ) {
						$bundle_data['products_image_src'] = generate_image_stamp($bundle_data['products_image_src'], DIR_WS_IMAGES.$bundle_data['products_image_stamp']);
					}
				}
				$bundle_data['image'] = tep_image($bundle_data['products_image_src'], $bundle_data['products_image_src'], SMALL_IMAGE_WIDTH, SMALL_IMAGE_HEIGHT, 'hspace="1" vspace="1"');
				$bundle_data['price_saved'] =  $currencies->display_price($bundle_data['products_price_total']-$products_price, tep_get_tax_rate($product_info['products_tax_class_id']));

				$products_bundle['products_price_total'] += ($bundle_data['products_price']*$bundle_data['products_bundle_qty']);
				$products_bundle['products'][] = $bundle_data;
			}
			unset($bundle_data);
			$products_bundle['products_price_saved_total'] = $products_bundle['products_price_total']-$products_price;
			$products_bundle['price_saved_total'] = $currencies->display_price($products_bundle['products_price_saved_total'], tep_get_tax_rate($product_info['products_tax_class_id']));
			$products_bundle['price_saved_total_percent'] = floor(($products_bundle['products_price_total']-$products_price) *  100 / $products_price);
			$products_bundle['price_total'] = $currencies->display_price($products_bundle['products_price_total'], tep_get_tax_rate($product_info['products_tax_class_id']));
		}
		return $products_bundle;
	}

	function fetchProduct($products_id = 0) {
		global $currencies, $smarty, $languages_id, $customers_group_id,$customer_id,$customer_email,$login_logout_params, $_JAVASCRIPTINCLUDES, $wo_full_name;
		$products_id = (int)$products_id;
		if ( false === is_numeric($products_id) || 0 == $products_id ) {
			return false;
		}
		if ( true === empty($customers_group_id) || false === is_numeric($customers_group_id) ) {
			$customers_group_id = '0';
		}
		$product_info_query_sql = "
						SELECT
							p.products_id,
							pd.products_name,
							pd.products_description,
							pd.products_description2,
							pd.products_meta_title,
							pd.products_meta_description,
							pd.products_meta_keywords,
							p.products_model,
							p.products_quantity,
							p.products_image,
							p.products_image_stamp,
							p.products_image_thumb,
							pd.products_url,
							p.products_price,
							p.products_price_hidden,
							p.products_ship_price,
							p.products_ship_price_two,
							p.average_rating,
							p.reviews_count,
							p.products_status,
							IF (s.status, s.specials_new_products_price, NULL)
								AS specials_new_products_price,
							IF (s.status, s.specials_new_products_price, p.products_price)
								AS final_price,
							IF (s.status, s.specials_text, NULL)
								AS price_special_text,
							p.products_tax_class_id,
							p.products_date_added,
							p.products_date_available,
							p.manufacturers_id,
							p.accessories,
							p.products_price_groups,
							p.products_bundle,
							p.media,
							p.products_access,
							m.manufacturers_name,
							m.manufacturers_image,
							mi.manufacturers_url
						FROM
							" . TABLE_PRODUCTS_DESCRIPTION . " pd,
							" . TABLE_PRODUCTS . " p
						LEFT JOIN
							" . TABLE_SPECIALS . " s
							ON ( p.products_id = s.products_id AND s.customers_group_id = '$customers_group_id')
						LEFT JOIN
							" . TABLE_MANUFACTURERS . " m
						ON
							m.manufacturers_id = p.manufacturers_id
						LEFT JOIN
							" . TABLE_MANUFACTURERS_INFO . " mi
						ON
							m.manufacturers_id = mi.manufacturers_id
						WHERE
							p.products_status = '1'
							AND p.products_id = '$products_id'
							AND pd.products_id = p.products_id
							AND pd.language_id = '$languages_id'";
	$product_info_query = tep_db_query($product_info_query_sql);
	if ( 0 < tep_db_num_rows($product_info_query) ) {
		$product_info = tep_db_fetch_array($product_info_query);

		// products access
		if ( true === isset($product_info['products_access']) ) {
			$customer_access_ids = explode(',', $product_info['products_access']);
			$customers_group_id = ( true === empty($customers_group_id) ? '0' : $customers_group_id );
			if ( false === in_array($customers_group_id, $customer_access_ids)) {
				return false;
			}
		}
		if ( 'On' == ENABLE_PRODUCTS_BUNDLES && '1' == $product_info['products_bundle'] ) {
			$product_info['products_bundles'] = fetchBundleProducts($products_id, $product_info['final_price']);
		}
		$update_views_sql = "
						UPDATE
							" . TABLE_PRODUCTS_DESCRIPTION . "
						SET
							products_viewed = products_viewed+1
						WHERE
							products_id = '$products_id'
							AND language_id = '$languages_id'";
		tep_db_query($update_views_sql);
		$product_info['tax'] = tep_get_tax_rate($product_info['products_tax_class_id']);
		$new_price = $product_info['specials_new_products_price'];
		$products_base_price = $product_info['products_price'];
		if ( '0' != $customers_group_id && true === is_numeric($customers_group_id) && '1' == $product_info['products_price_groups'] && false === empty($product_info['products_id']) ) {
			$products_base_price = tep_get_products_group_base_price($product_info['products_id'], $customers_group_id, $product_info['products_price']);
		}
		$product_info['price'] = $currencies->display_price($products_base_price, 0);
		$product_info['price_final'] = $product_info['price'];
		$product_info['price_with_tax'] = $currencies->display_price($products_base_price, $product_info['tax']);
		if ( false === empty($new_price) ) {
			if ( $new_price < $products_base_price ) {
			$product_info['price'] = $currencies->display_price($products_base_price, 0);
			$product_info['price_special'] = $currencies->display_price($new_price, 0);
			$product_info['price_final'] = $product_info['price_special'];
			$product_info['price_saved'] = $currencies->display_price($product_info['products_price']-$new_price, 0);
			$product_info['price_saved_percent'] = floor(($product_info['products_price']-$new_price) *  100 / $product_info['products_price']);
			$product_info['price_special_with_tax'] = $currencies->display_price($new_price, $product_info['tax']);
			}
		}
		if ( '1' == $product_info['products_price_groups'] ) {
			$product_info['price_breaks'] = tep_get_products_group_prices_array($products_id, $customers_group_id, $product_info['tax']);
		}
		if ( false === empty($product_info['manufacturers_image']) ) {
			$product_info['manufacturers_image'] = tep_image(DIR_WS_IMAGES . $product_info['manufacturers_image'], stripslashes($product_info['manufacturers_name']), MANUFACTURERS_SMALL_IMAGE_WIDTH, MANUFACTURERS_SMALL_IMAGE_HEIGHT);
		}
		if ( false === empty($product_info['manufacturers_id']) ) {
			$product_info['manufacturers_link_url'] = tep_href_link(FILENAME_MANUFACTURERS, 'manufacturers_id=' . $product_info['manufacturers_id']);
		}
		$products_attributes_query_sql = "
									SELECT
										count(*) AS total
									FROM
										" . TABLE_PRODUCTS_OPTIONS . " popt,
										" . TABLE_PRODUCTS_ATTRIBUTES . " patrib
									WHERE
										patrib.products_id='$products_id'
										AND patrib.options_id = popt.products_options_id";
		$products_attributes_query = tep_db_query($products_attributes_query_sql);
		$products_attributes = tep_db_fetch_array($products_attributes_query);
		if ($products_attributes['total'] > 0) {
			$products_id = (preg_match("/^\d{1,10}(\{\d{1,10}\}\d{1,10})*$/",$_GET['products_id']) ? $_GET['products_id'] : (int)$_GET['products_id']);
			require_once ( DIR_WS_CLASSES . 'pad_base.php' );
			$class = 'pad_base';
			$pad = new $class($products_id);
			$smarty->assign('_PRODUCTSATTRIBUTES', $pad->draw());

			$_JAVASCRIPTINCLUDES = $_JAVASCRIPTINCLUDES.$pad->javascript;
			$smarty->assign('_JAVASCRIPTINCLUDES', $_JAVASCRIPTINCLUDES);
		}
		$product_info['products_image_src'] = DIR_WS_IMAGES.$product_info['products_image'];
		if ( 'on' === IMAGE_STAMP_ON_OFF ) {
			if( false === empty($product_info['products_image_stamp']) ) {
				$product_info['products_image_src'] = generate_image_stamp($product_info['products_image_src'], DIR_WS_IMAGES.$product_info['products_image_stamp']);
			}
		}
		if ( 0 >= $product_info['average_rating'] ) {
			$average_rating = tep_get_products_average_rating($products_id);
			if ( 0 < $average_rating ) {
				tep_db_query("UPDATE " . TABLE_PRODUCTS . " SET average_rating = '$average_rating' WHERE products_id = '$products_id'");
				$product_info['average_rating'] = $average_rating;
			}
		}
		$product_info['average_rating_image_src'] = TEMPLATE_IMAGES_DIR.tep_star_image_name($product_info['average_rating'], 'gif','SMALL' );
		$product_info['average_rating_image_big_src'] = TEMPLATE_IMAGES_DIR.tep_star_image_name($product_info['average_rating'], 'gif','BIG' );

		$review_stars_alt = ( 0 >= $product_info['average_rating'] ? 'Not rated' : $product_info['average_rating'] .' out of 5 stars' );
		$product_info['average_rating_image'] = '<img src="'.$product_info['average_rating_image_src'].'" alt="'.$review_stars_alt.'" title="'.$review_stars_alt.'" />';
		$product_info['average_rating_image_big'] = '<img src="'.$product_info['average_rating_image_big_src'].'" alt="'.$review_stars_alt.'" title="'.$review_stars_alt.'" />';
		//$product_info['products_image_onclick'] = "javascript:popupProductImage('".FILENAME_POPUP_IMAGE."', document.prodimg.src, '". addslashes(strip_quotes($product_info['products_name']))."' ); return false;";
		$product_info['products_image'] = tep_image($product_info['products_image_src'], stripslashes($product_info['products_name']), LARGE_IMAGE_WIDTH, LARGE_IMAGE_HEIGHT, 'id="id_prodimg" class="products_image"' );
		$product_info['time_available'] = strtotime($product_info['products_date_available']);
		if ( time() >= $product_info['time_available'] ) {
			$product_info['available'] = 'true';
		} else {
			$product_info['available'] = 'false';
			$smarty->assign('TEXT_PRODUCT_NOT_AVAILABLE_DATE',sprintf(TEXT_PRODUCT_NOT_AVAILABLE_DATE,  date("M-d-Y", $product_info['time_available'])));
			$smarty->assign('TEXT_PRODUCT_NOT_AVAILABLE',TEXT_PRODUCT_NOT_AVAILABLE);
		}
		switch ( $product_info['products_price_hidden'] ) {
			case 1;
				if ( true === empty($customer_id) ) {
					$product_info['available'] = 'false';
					$product_info['price'] = 0;
					$product_info['price_hidden'] = true;
					$product_info['price_hidden_text'] = TEXT_PRICE_LOGIN;
					$product_info['price_hidden_text_url'] = tep_href_link(FILENAME_LOGIN, $login_logout_params, 'SSL');
				}
			break;
			case 2;
				$product_info['available'] = 'false';
				$product_info['price'] = 0;
				$product_info['price_hidden'] = true;
				$product_info['price_hidden_text'] = TEXT_PRICE_CALL;
				if ( true === defined('DEFAULT_CONTACT_PAGE') && '' != DEFAULT_CONTACT_PAGE ) {
					$products_name = urlencode($product_info['products_name']);
					$contact_params = ( false === empty($customer_id) ? 'subject='.TEXT_PRICE_SUBJECT.'&enquiry='.$products_name.'&email=' . $customer_email . '&name=' . $wo_full_name : 'subject='.TEXT_PRICE_SUBJECT.'&enquiry='.$products_name );
					$product_info['price_hidden_text_url'] = tep_href_link(DEFAULT_CONTACT_PAGE, $contact_params);
				}
				if ( true === defined('STORE_PHONE') && '' != STORE_PHONE ) {
					$product_info['price_hidden_phone'] = STORE_PHONE;
				}
			break;
		}
		return $product_info;
	} else {
		return false;
	}
}


function tep_get_products_sorting($user_sort = '') {

	switch ($user_sort) {
		case 'name-desc':
			$return_array['nameasc'] = tep_href_link(basename($_SERVER['PHP_SELF']), tep_get_all_get_params(array('sort')).'sort=name-asc');
		break;
		case 'name-asc':
			$return_array['namedesc'] = tep_href_link(basename($_SERVER['PHP_SELF']), tep_get_all_get_params(array('sort')).'sort=name-desc');
		break;
		default:
			$return_array['name'] = tep_href_link(basename($_SERVER['PHP_SELF']), tep_get_all_get_params(array('sort')).'sort=name-asc');
		break;

	}

	switch ($user_sort) {
		case 'price-desc':
			$return_array['priceasc'] = tep_href_link(basename($_SERVER['PHP_SELF']), tep_get_all_get_params(array('sort')).'sort=price-asc');
		break;
		case 'price-asc':
			$return_array['pricedesc'] = tep_href_link(basename($_SERVER['PHP_SELF']), tep_get_all_get_params(array('sort')).'sort=price-desc');
		break;
		default:
			$return_array['price'] = tep_href_link(basename($_SERVER['PHP_SELF']), tep_get_all_get_params(array('sort')).'sort=price-asc');
		break;
	}

	switch ($user_sort) {
		case 'date-desc':
			$return_array['dateasc'] = tep_href_link(basename($_SERVER['PHP_SELF']), tep_get_all_get_params(array('sort')).'sort=date-asc');
		break;
		case 'date-asc':
			$return_array['datedesc'] = tep_href_link(basename($_SERVER['PHP_SELF']), tep_get_all_get_params(array('sort')).'sort=date-desc');
		break;
		default:
			$return_array['date'] = tep_href_link(basename($_SERVER['PHP_SELF']), tep_get_all_get_params(array('sort')).'sort=date-desc');
		break;
	}

	switch ($user_sort) {
		case 'rating-desc':
			$return_array['ratingasc'] = tep_href_link(basename($_SERVER['PHP_SELF']), tep_get_all_get_params(array('sort')).'sort=rating-asc');
		break;
		case 'rating-asc':
			$return_array['ratingdesc'] = tep_href_link(basename($_SERVER['PHP_SELF']), tep_get_all_get_params(array('sort')).'sort=rating-desc');
		break;
		default:
			$return_array['rating'] = tep_href_link(basename($_SERVER['PHP_SELF']), tep_get_all_get_params(array('sort')).'sort=rating-desc');
		break;
	}
	return $return_array;
}
?>