<?php

function swap_keywords($keywords) {
	if ( true === empty($keywords) || 2 >= strlen($keywords) ) {
		return $keywords;
	}
	$keywords = trim($keywords);
	if ( true === is_array($keywords) ) {
		$keywords_array = $keywords;
	} else {
		$keywords_array = explode(' ', stripslashes(strtolower($keywords)));
	}
	$swap_words = tep_db_query("SELECT * FROM searchword_swap");
	$sw_count = 0;
	while ($swap_words_result = tep_db_fetch_array($swap_words)) {

		if ( 1 >= $keywords_array ) { # ONE KEYWORD DETECTED
			$pw_replacement = array();
			if ( stripslashes(strtolower($keywords)) == stripslashes(strtolower($swap_words_result['sws_word'])) ) {
				$pw_replacement[$keywords] = stripslashes($swap_words_result['sws_replacement']);
				$sw_keywords = $swap_words_result['sws_replacement'];
				$sw_count++;
				break;
			}
		} else { # MULTIPLE KEYWORDS DETECTED
			$pw_replacement = array();
			foreach ( $keywords_array as $keyword ) {
				if(stripslashes(strtolower($keyword))  == stripslashes(strtolower($swap_words_result['sws_word']))) {
	                   $pw_replacement[$keyword]  = stripslashes($swap_words_result['sws_replacement']);
	                   $sw_keywords .= '<strong>' . $swap_words_result['sws_replacement'] . '</strong> ';
	                   $sw_count++;
	               } else {
				    $sw_keywords .= $keyword . ' ';
	               }
	           }
	           $keywords = trim($keywords);
		}

	}
	$out = array();
	$out['swap'] = $pw_replacement;
	$out['sw_keywords'] = $sw_keywords;
	$out['sw_count'] = $sw_count;
	return $out;
}

function update_search_tag_data($tag, $results_found) {
	$tag_query_check_sql = "
						SELECT
							td.tags_data_id
						FROM
							" . TABLE_TAGS . " t,
							" . TABLE_TAGS_DATA . " td
						WHERE
							td.tags_id = t.tags_id
							AND t.tag = '$tag'";
	$tag_query_check = tep_db_query($tag_query_check_sql);
	if ( 0 < tep_db_num_rows($tag_query_check) ) {
		$tags_data = tep_db_fetch_array($tag_query_check);
		$update_tag_data_query_sql = "
							UPDATE
								" . TABLE_TAGS_DATA . "
							SET
								tag_hit_count = (tag_hit_count+1),
								last_modified = NOW()
							WHERE
								tags_data_id = '{$tags_data['tags_data_id']}'";
		return tep_db_query($update_tag_data_query_sql);
	} else {
		$tags_id_query_sql = "
						SELECT
							tags_id
						FROM
							" . TABLE_TAGS . "
						WHERE
							tag = '$tag'";
		$tags_id_query = tep_db_query($tags_id_query_sql);
		if ( 0 < tep_db_num_rows($tags_id_query) ) {
			$tags_id = tep_db_fetch_array($tags_id_query);
			$insert_tag_data_query_sql = "
								INSERT INTO
									" . TABLE_TAGS_DATA . "
								(
									tags_id,
									tag_hit_count,
									date_added
								)
									VALUES
								(
									'{$tags_id['tags_id']}',
									'1',
									NOW()
								)";
			return tep_db_query($insert_tag_data_query_sql);
		} else {
			return false;
		}
	}
}

function insert_search_query($keywords, $search_found) {
	if ( 3 > strlen($keywords)) {
		return false;
	}
	$search_found = (int)$search_found;
	$keywords = strip_tags($keywords);
	$keywords = tep_db_input($keywords);
	$search_query_check_sql = "
						SELECT
							search_text
						FROM
							" . TABLE_SEARCH_QUERIES . "
						WHERE
							search_text = '$keywords'";
	$search_query_check = tep_db_query($search_query_check_sql);
	if ( 0 < tep_db_num_rows($search_query_check) ) {
		$update_search_query_sql = "
							UPDATE
								" . TABLE_SEARCH_QUERIES . "
							SET
								search_count = (search_count+1),
								search_found = '$search_found'
							WHERE
								search_text = '$keywords'";
		return tep_db_query($update_search_query_sql);
	} else {
		$insert_search_query_sql = "
							INSERT INTO
								" . TABLE_SEARCH_QUERIES . "
							(
								search_text,
								search_count,
								search_found
							)
								VALUES
							(
								'$keywords',
								'1',
								'$search_found'
							)";
		return tep_db_query($insert_search_query_sql);
	}
}

function tep_search_products($search_query = '', $args = '') {
	global $languages_id, $messageStack, $number_of_products, $encoding;
	$return = array();
	$return['error_count'] = 0;
	$return['error_messages'] = array();
	if ( true === empty($search_query) ) {
		return false;
	}
	if ( false !== $encoding && true === function_exists('iconv') ) {
		$search_query_text = iconv('UTF-8', $encoding, $search_query);
	}

	$search_query = tep_db_input($search_query);
	if ( true === is_array($args) ) {
		$search_in_description = ( '1' == $args['search_in_description'] ? true : false );
		$categories_id = ( false === empty($args['categories_id']) && true === is_numeric($args['categories_id']) ? true : false );
		$include_subcategories = ( '1' == $args['include_subcategories'] ? true : false );
		$price_filter = ( false === empty($args['price_from']) || false === empty($args['price_to']) ? true : false );
	}

	$price_check_error = false;
	if ( false === empty($args['price_from']) && false === is_numeric($args['price_from']) ) {
		$return['error_count']++;
		$return['error_messages'][] = ERROR_PRICE_FROM_MUST_BE_NUM;
		$price_check_error = true;
	} else {
		settype($args['price_to'], 'double');
	}

	if ( false === empty($args['price_to']) && false === is_numeric($args['price_to']) ) {
		$return['error_count']++;
		$return['error_messages'][] = ERROR_PRICE_TO_MUST_BE_NUM;
		$price_check_error = true;
	} else {
		settype($args['price_to'], 'double');
	}

	if ( false === empty($args['price_to']) &&  false === empty($args['price_from']) && false === $price_check_error ) {
		if ($args['price_from'] >= $args['price_to']) {
			$return['error_count']++;
			$return['error_messages'][] = ERROR_PRICE_TO_LESS_THAN_PRICE_FROM;
      }
    }

	if ( true !== tep_parse_search_string($search_query, $search_keywords)) {
		$return['error_count']++;
		$return['error_messages'][] = ERROR_INVALID_KEYWORDS;
	}

	$keywords_array = explode(' ', $search_query_text);
	if ( 1 < count($keywords_array) ) {
		foreach ( $keywords_array as $keyw ) {
			$keyw = stripslashes($keyw);
			if ( 3 <= strlen($keyw) ) {
				$return['show_keywords'] .= '<a href="'.FILENAME_ADVANCED_SEARCH_RESULT.'?keywords='.$keyw. '&previous_keywords='.stripslashes($search_query_text) . ( false === empty($_GET['osCsid']) ? '&osCsid='.$_GET['osCsid'] : '' ) .'">'.$keyw.'</a> ';
			} else {
				$return['show_keywords'] .= "$keyw ";
			}
		}
	} else {
		$return['show_keywords'] = '"'.stripslashes($search_query_text).'"';
	}

	$previous_keywords = stripslashes($args['previous_keywords']);
	if ( false === empty($previous_keywords) ) {
		$return['show_keywords'] .= '<br />';
		$return['show_keywords'] .= sprintf(TEXT_RESULTS_BACK_TO, '<a href="' . FILENAME_ADVANCED_SEARCH_RESULT.'?keywords='.$previous_keywords. ( false === empty($_GET['osCsid']) ? '&osCsid='.$_GET['osCsid'] : '' ) . '">'. $previous_keywords.'</a>');
	}

	$search_swap = swap_keywords($search_query);
	if ( 0 < $search_swap['sw_count'] ) {
		$return['show_keywords_swap'] = sprintf(TEXT_RESULTS_DID_YOU_MEAN, '<a href="' . FILENAME_ADVANCED_SEARCH_RESULT .'?keywords='.strip_tags($search_swap['sw_keywords']) . ( false === empty($_GET['osCsid']) ? '&osCsid='.$_GET['osCsid'] : '' ) . '">' . $search_swap['sw_keywords'] .'</a>');
	}

	if ( 0 < $return['error_count'] ) {
		return $return;
	}

	// Categories filtering
	$where_categories = '';
	if ( true === $categories_id ) {
		if ( true === $include_subcategories ) {
			$subcategories_array = array();
			tep_get_subcategories($subcategories_array, $args['categories_id']);
			$where_categories .= " AND p2c.products_id = p.products_id AND p2c.products_id = pd.products_id AND (p2c.categories_id = '{$args['categories_id']}'";

		      for ($i=0, $n=sizeof($subcategories_array); $i<$n; $i++ ) {
		        $where_categories .= " OR p2c.categories_id = '" . (int)$subcategories_array[$i] . "'";
		      }

		      $where_categories .= ")";
		} else {
			$where_categories .= " AND p2c.products_id = p.products_id AND p2c.products_id = pd.products_id AND p2c.categories_id = '{$args['categories_id']}'";
		}

	}

	// Prices filtering
	$where_price = '';
	if ( true === $price_filter ) {
		$where_price .= ( 0 < $args['price_from'] ? " AND (IF(s.status AND s.customers_group_id = '" . $customer_group_id . "', s.specials_new_products_price, p.products_price) >= " . (double)$args['price_from'] . ")" : '' );
		$where_price .= ( 0 < $args['price_to'] ? " AND (IF(s.status AND s.customers_group_id = '" . $customer_group_id . "', s.specials_new_products_price, p.products_price) <= " . (double)$args['price_to'] . ")" : '' );
	}


	$products_search_query_sql = "
			SELECT DISTINCT
				p.products_id,
				p.products_image,
				p.products_image_stamp,
				p.products_image_thumb,
				p.average_rating,
				p.reviews_count,
				p.products_price_groups,
				p.products_price,
				pd.products_name,
				p.products_access,
				IF (s.status, s.specials_new_products_price, NULL)
					AS specials_new_products_price,
				IF (s.status, s.specials_new_products_price, p.products_price)
					AS final_price,
				IF (s.status, s.specials_text, NULL)
					AS price_special_text
			FROM
				" . TABLE_PRODUCTS . " p
				LEFT JOIN " . TABLE_PRODUCTS_TO_TAGS . " p2t
					ON p2t.products_id = p.products_id
				LEFT JOIN " . TABLE_TAGS . " t
					ON p2t.tags_id = t.tags_id
				LEFT JOIN " . TABLE_SPECIALS . " s
					ON ( p.products_id = s.products_id AND s.customers_group_id = '$customers_group_id'),
				" . TABLE_PRODUCTS_DESCRIPTION . " pd,
				" . TABLE_CATEGORIES . " c,
				" . TABLE_PRODUCTS_TO_CATEGORIES . " p2c
			WHERE
				p.products_status = '1'
				AND p.products_id = pd.products_id
				AND pd.language_id = '" . (int)$languages_id . "'
				AND p.products_id = p2c.products_id
				AND p2c.categories_id = c.categories_id

				AND
				(
					pd.products_name LIKE '%$search_query%'
					OR  t.tag LIKE '%$search_query%'
					" . ( true === $search_in_description ? " OR pd.products_description like '%$search_query%'" : '' ) . "
				)
				$where_categories
				$where_price
				ORDER BY
					p.products_date_added DESC,
					pd.products_name";
	require_once ( DIR_WS_FUNCTIONS . 'products.php' );
	$return['products'] = fetchProducts($products_search_query_sql, true);
	insert_search_query($search_query, $number_of_products);
	if ( 1 == count($return['products']) ) {
		$messageStack->add_session('search', sprintf(TEXT_RESULTS_ONE_FOUND, $search_query_text, FILENAME_ADVANCED_SEARCH . '?keywords=' . $search_query . ( false === empty($_GET['osCsid']) ? '&osCsid='.$_GET['osCsid'] : '' )), 'success');
		tep_redirect(tep_href_link(FILENAME_PRODUCT_INFO, 'products_id=' . $return['products'][0]['products_id']));
	}
	return $return;
}

?>