<?php

////
// Handle the estimated shipping quotes
function tep_get_estimated_shipping_quotes($country, $getvar, $customer_country) {
	global $language, $country, $cart, $currencies, $country_to_ship_to, $country_name, $order, $total_weight, $total_count;

	$return = '';

	if (tep_not_null($country)) {
		$country_name = tep_get_country_name($country);
		tep_session_register('country');
	}

	$country_to_ship_to = $country;

	require_once ( 'includes/classes/http_client.php');
	require_once ( DIR_WS_CLASSES . 'order.php');
	if ( false === is_object($order) ) {
		$order = new order;
	}

	$total_weight = $cart->show_weight();
	$total_count = $cart->count_contents();

	// load all enabled shipping modules
	require_once ( DIR_WS_CLASSES . 'shipping.php');
	$shipping_modules = new shipping;


	/* Free shipping enabled */
	if ( defined('MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING') && (MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING == 'true') ) {
		$pass = false;

		switch (MODULE_ORDER_TOTAL_SHIPPING_DESTINATION) {
			case 'national':
				if ($order->delivery['country_id'] == STORE_COUNTRY) {
					$pass = true;
				}
				break;
			case 'international':
				if ($order->delivery['country_id'] == STORE_COUNTRY) {
					$pass = true;
				}
				break;
			case 'both':
				$pass = true;
				break;
		}

		$free_shipping = false;
		if ( ($pass == true) && ($order->info['subtotal'] >= MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER) ) {
			$free_shipping = true;

			include_once ( DIR_WS_LANGUAGES . $language . '/modules/order_total/ot_shipping.php');
		}

		/* Free shipping disabled */
	} else {
		$free_shipping = false;
	}


	// process the selected shipping method

	if (!tep_session_is_registered('shipping')) tep_session_register('shipping');

	if ( (tep_count_shipping_modules() > 0) || ($free_shipping == true) ) {
		if ( (isset($_POST['shipping'])) && (strpos($_POST['shipping'], '_')) ) {
			$shipping = $_POST['shipping'];


			list($module, $method) = explode('_', $shipping);
			if ( is_object($$module) || ($shipping == 'usps_free') ) {
				if ($shipping == 'usps_free') {
					$quote[0]['methods'][0]['title'] = FREE_SHIPPING_TITLE;
					$quote[0]['methods'][0]['cost'] = '0';
				} else {
					$quote = $shipping_modules->quote($method, $module);
				}
				if (isset($quote['error'])) {
					tep_session_unregister('shipping');
				} else {
					if ( (isset($quote[0]['methods'][0]['title'])) && (isset($quote[0]['methods'][0]['cost'])) ) {
						$shipping = array('id' => $shipping,
										'title' => (($free_shipping == true) ?  $quote[0]['methods'][0]['title'] : $quote[0]['module'] . ' (' . $quote[0]['methods'][0]['title'] . ')'),
										'cost' => $quote[0]['methods'][0]['cost']);
					}
				}
			} else {
				tep_session_unregister('shipping');
			}
		}
	} else {
		$shipping = false;
	}

	// get all available shipping quotes
	$quotes = $shipping_modules->quote();


	if ($free_shipping == true) {
		$quotes[] = array('module' => FREE_SHIPPING_TITLE,
							'methods' => array(array('id' => 'free',
							'title' => sprintf(FREE_SHIPPING_DESCRIPTION, $currencies->format(MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER)),
							'cost' => 0.0)));
	}




	if ( true === is_array($quotes) ) {
		$return['title'] = sprintf(HEADING_SHIPPING_ESTIMATE, $country_name);
		foreach ( $quotes as $quote ) {

		$return['module'] = $quote['module'];
		$return['error'] = $quote['error'];

		//print_r($quote['methods']);
		if ( true === is_array($quote['methods']) && true === empty($quote['error'])) {
			foreach ( $quote['methods'] as $method ) {
				if ( false === empty($method['title']) && false === empty($method['cost']) ) {
					$return['methods'][] = array(
									'title' => $method['title'],
									'price' => $currencies->format(tep_add_tax($method['cost'], (isset($quote['tax']) ? $quote['tax'] : 0)))
									);
					if ( 1 >= count($quote['methods']) ) {
						$return['hidden'] = tep_draw_hidden_field('shipping', $quote['id'] . '_' . $method['id']);
					}
				}
			}
		}
	}
}


return $return;
}
?>