<?php

  function getPluginOptions($options = PLUGINS) {

  	##LEFT-SEARCH:[sort=0],CATEGORIES:[sort=1],MANUFACTURERS:[sort=3,limit=10,use_function=random],ARTICLES:[sort=2],|CENTER-MAINPAGE:[sort=0],RANDOMPRODUCTS:[sort=1],|RIGHT-SHOPPINGCART:[sort=0],POLL:[sort=1],BESTSELLERS:[sort=2]

  	if ( true === empty($options) ) {
  		return false;
  	}
	$groups = explode('|', $options);

	if ( true === is_array($groups) ) {

		foreach ( $groups as $group ) {
			list($group_id, $opts) = explode('-', $group);
			$return_array[$group_id] = '';

			$values = array();
			$group_options = explode('],', $opts);
			foreach ( $group_options as $group_option ) {
				if ( false === empty($group_option) ) {
					if( ']' === substr($group_option, -1, 1) ) { # remove last ]
						$group_option = substr($group_option, 0, -1);
					}

					list($goup_opt, $group_vals) = explode(':[', $group_option);

						$opts = explode(',', $group_vals);
						if ( true === is_array($opts) ) {
							$opts_array = array();
							foreach ( $opts as $opt ) {
								if ( false === empty($opt) ) {
									list($opt_name, $opt_value) = explode('=', $opt);
									$opts_array[$opt_name] = $opt_value;
								}
							}
						}

					list($goup_opt, $group_val) = explode(':', $group_option);
					$file_name = strtolower($goup_opt);

					$values[$goup_opt] = array(
									'group_id' => $group_id,
									'plugin' => $goup_opt,
									'filename' => $file_name . '.php',
									'template' => $file_name . '.tpl'
								);
					foreach ($opts_array as $opt_key => $opt_name ) {
						$values[$goup_opt][$opt_key] = $opt_name;
					}


				}

			}

			$return_array[$group_id] = $values;

		}

	} else {
		return false;
	}


	return $return_array;
  }

  function getPluginsOptionsInfo($options = PLUGINS) {
  		$plugins_options = getPluginOptions($options);


  		if ( true === is_array($plugins_options) ) {
			foreach ( $plugins_options as $group => $options ) {

				if ( true === is_array($options) ) {
					foreach ( $options as $option ) {
						$options_plugins[] = $option;
					}
				}
			}
			return $options_plugins;
  		}
  }

   function getPluginsTemplatesInfo($exclude_group_id = '') {
  		$plugins_options = getPluginOptions();


  		if ( true === is_array($plugins_options) ) {
			foreach ( $plugins_options as $group => $options ) {

				if ( true === is_array($options) ) {
					$options_plugins = array();
					foreach ( $options as $option ) {
						if ( $group !== $exclude_group_id ) {
							$options_plugins[$option['sort']] = $option['template'];
						}

					}
					if ( $group !== $exclude_group_id ) {
						$options_return[$group] = $options_plugins;
					}
				}
				ksort($options_return[$group]);
			}

			return $options_return;
  		}
  }

  function includePluginsPHPFilesArray($exclude_group_id = '') {
	$plugins = getPluginsOptionsInfo();
	if ( false === is_array($plugins) ) {
		return false;
	}

	foreach ( $plugins as $plugin ) {
		if ( $plugin['group_id'] !== $exclude_group_id ) {
			$plugin_files[] = DIR_WS_PLUGINS . $plugin['filename'];
		}
	}

	return $plugin_files;

  }




?>