<?php
// look in your $PATH_LOCALE/locale directory for available locales
// or type locale -a on the server.
// Examples:
// on RedHat try 'en_US'
// on FreeBSD try 'en_US.ISO_8859-1'
// on Windows try 'en', or 'English'
@setlocale(LC_TIME, 'en_US.ISO_8859-1');

define ('DEFAULT_COUNTRY', '223');

define('DATE_FORMAT_SHORT', '%m/%d/%Y');  // this is used for strftime()
define('DATE_FORMAT_LONG', '%A %d %B, %Y'); // this is used for strftime()
define('DATE_FORMAT', 'm/d/Y'); // this is used for date()
define('DATE_TIME_FORMAT', DATE_FORMAT_SHORT . ' %H:%M:%S');


// if USE_DEFAULT_LANGUAGE_CURRENCY is true, use the following currency, instead of the applications default currency (used when changing language)
define('LANGUAGE_CURRENCY', 'USD');

// Global entries for the <html> tag
define('HTML_PARAMS','xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en"');

// charset for web pages and emails
define('CHARSET', 'iso-8859-1');

// header text in includes/header.php

define('TEXT_SORT_BY_PRICE_ASC', 'Sort by price ascending');
define('TEXT_SORT_BY_PRICE_DESC', 'Sort by price descending');

define('TEXT_SORT_BY_NAME_ASC', 'Sort by name ascending');
define('TEXT_SORT_BY_NAME_DESC', 'Sort by name descending');

define('TEXT_SORT_BY_RATING_ASC', 'Sort by rating ascending');
define('TEXT_SORT_BY_RATING_DESC', 'Sort by rating descending');

define('TEXT_SORT_BY_DATE_ASC', 'Sort by date ascending');
define('TEXT_SORT_BY_DATE_DESC', 'Sort by date descending');


define('HEADER_TITLE_CREATE_ACCOUNT', 'New account');
define('HEADER_TITLE_MY_ACCOUNT', 'My account');
define('HEADER_TITLE_CART_CONTENTS', 'Cart contents');
define('HEADER_TITLE_CHECKOUT', 'Checkout');
define('HEADER_TITLE_TOP', 'Top');
define('HEADER_TITLE_CATALOG', 'Home');
define('HEADER_TITLE_LOGOFF', 'Logoff');
define('HEADER_TITLE_LOGIN', 'Login');
define('HEADER_TITLE_HOME', 'Home');
define('HEADER_TITLE_FORUM', 'Forum');



define('TEXT_CART_CONTAINS', 'Cart contains %d item(s)');
define('TEXT_CART_NO_ITEMS', 'Your shopping cart is empty');

define('HEADER_TITLE_WISHLIST', 'My wishlist');
define('HEADER_TITLE_SHOPPING_CART', 'Shopping cart');

// footer text in includes/footer.php
define('FOOTER_TEXT_QUERIES_COUNT', 'queries');
define('FOOTER_TEXT_REQUESTS_SINCE', 'requests since');

// text for gender
define('MALE', 'Male');
define('FEMALE', 'Female');
define('MALE_ADDRESS', 'Mr.');
define('FEMALE_ADDRESS', 'Ms.');

// text for date of birth example
define('DOB_FORMAT_STRING', 'mm/dd/yyyy');

// categories box text in includes/boxes/categories.php
define('BOX_HEADING_CATEGORIES', 'Categories');

// manufacturers box text in includes/boxes/manufacturers.php
define('BOX_HEADING_MANUFACTURERS', 'Manufacturers');

// whats_new box text in includes/boxes/whats_new.php
define('BOX_HEADING_WHATS_NEW', 'What\'s new?');

// quick_find box text in includes/boxes/quick_find.php
define('BOX_HEADING_SEARCH', 'Quick search');
define('BOX_SEARCH_TEXT', 'Use keywords to find the product you are looking for.');
define('BOX_SEARCH_ADVANCED_SEARCH', 'Advanced search');

// specials box text in includes/boxes/specials.php
define('BOX_HEADING_SPECIALS', 'Specials');
define('TEXT_SPECIALS', 'Specials');
define('TEXT_NEW_PRODUCTS', 'Latest products');

define('VALID_XHTML', 'Valid XHTML');

// reviews box text in includes/boxes/reviews.php
define('BOX_HEADING_REVIEWS', 'Reviews');
define('BOX_REVIEWS_WRITE_REVIEW', 'Write a review on this product!');
define('BOX_REVIEWS_NO_REVIEWS', 'There are currently no product reviews');
define('BOX_REVIEWS_TEXT_OF_5_STARS', '%s of 5 stars');

// shopping_cart box text in includes/boxes/shopping_cart.php
define('BOX_HEADING_SHOPPING_CART', 'My cart');
define('BOX_SHOPPING_CART_EMPTY', '0 items');

// wishlist box text in includes/boxes/wishlist.php
define('BOX_HEADING_CUSTOMER_WISHLIST', 'My wishlist');
define('TEXT_WISHLIST_COUNT', 'Currently %s items are on your wish list.');

// order_history box text in includes/boxes/order_history.php
define('BOX_HEADING_CUSTOMER_ORDERS', 'Order history');

// best_sellers box text in includes/boxes/best_sellers.php
define('BOX_HEADING_BESTSELLERS', 'Bestsellers');
define('BOX_HEADING_BESTSELLERS_IN', 'Bestsellers in');

// notifications box text in includes/boxes/products_notifications.php
define('BOX_HEADING_NOTIFICATIONS', 'Notifications');
define('BOX_NOTIFICATIONS_NOTIFY', 'Notify me of updates to <b>%s</b>');
define('BOX_NOTIFICATIONS_NOTIFY_REMOVE', 'Do not notify me of updates to <b>%s</b>');

// manufacturer box text
define('BOX_HEADING_MANUFACTURER_INFO', 'Manufacturer info');
define('BOX_MANUFACTURER_INFO_HOMEPAGE', '%s homepage');
define('BOX_MANUFACTURER_INFO_OTHER_PRODUCTS', 'Other products');

// languages box text in includes/boxes/languages.php
define('BOX_HEADING_LANGUAGES', 'Languages');

// currencies box text in includes/boxes/currencies.php
define('BOX_HEADING_CURRENCIES', 'Currencies');

// tell a friend box text in includes/boxes/tell_a_friend.php
define('BOX_HEADING_TELL_A_FRIEND', 'Tell a friend');
define('BOX_TELL_A_FRIEND_TEXT', 'Tell someone you know about this product.');

// LINE ADDED: MOD - allprods modification
define('BOX_INFORMATION_ALLPRODS', 'View all items');

// 2 LINES ADDED: MOD - Recover Carts
define('BOX_REPORTS_RECOVER_CART_SALES', 'Recover carts');
define('BOX_TOOLS_RECOVER_CART', 'Recover carts');

// checkout procedure text
define('CHECKOUT_BAR_DELIVERY', 'Shipping');
define('CHECKOUT_BAR_PAYMENT', 'Payment');
define('CHECKOUT_BAR_CONFIRMATION', 'Confirm');
define('CHECKOUT_BAR_FINISHED', 'Done!');

// pull down default text
define('PULL_DOWN_DEFAULT', 'Please select');
define('TYPE_BELOW', 'Type below');


define('ERROR_NO_PAYMENT_MODULE_SELECTED', 'Please select a payment method for your order.');

define('CATEGORY_COMPANY', 'Company details');
define('CATEGORY_PERSONAL', 'Your personal details');
define('CATEGORY_ADDRESS', 'Your address');
define('CATEGORY_CONTACT', 'Your contact information');
define('CATEGORY_OPTIONS', 'Options');
define('CATEGORY_PASSWORD', 'Your password');

define('ENTRY_COMPANY', 'Company name:');
define('ENTRY_COMPANY_ERROR', '');
define('ENTRY_COMPANY_TEXT', '');
define('ENTRY_COMPANY_TAX_ID', 'Tax ID #:');
define('ENTRY_COMPANY_TAX_ID_ERROR', '');
define('ENTRY_COMPANY_TAX_ID_TEXT', '');
define('ENTRY_GENDER', 'Gender:');
define('ENTRY_GENDER_ERROR', 'Please select your gender.');
define('ENTRY_GENDER_TEXT', '*');
define('ENTRY_NAME', 'Name:');
define('ENTRY_FIRST_NAME', 'First name:');
define('ENTRY_FIRST_NAME_ERROR', 'Your first name must contain a minimum of ' . ENTRY_FIRST_NAME_MIN_LENGTH . ' characters.');
define('ENTRY_FIRST_NAME_TEXT', '*');
define('ENTRY_LAST_NAME', 'Last Name:');
define('ENTRY_LAST_NAME_ERROR', 'Your last name must contain a minimum of ' . ENTRY_LAST_NAME_MIN_LENGTH . ' characters.');
define('ENTRY_LAST_NAME_TEXT', '*');
define('ENTRY_DATE_OF_BIRTH', 'Date of birth:');
define('ENTRY_DATE_OF_BIRTH_ERROR', 'Your date of birth must be in this format: MM/DD/YYYY (eg 03/23/1983)');
define('ENTRY_DATE_OF_BIRTH_TEXT', '*');
define('ENTRY_EMAIL_ADDRESS', 'E-mail:');
define('ENTRY_USERNAME', 'Username:');
define('ENTRY_FORUM_ACCOUNT', 'Create forum account:');
define('ENTRY_FORUM_ACCOUNT_TEXT', '');

define('TEXT_YES', 'Yes') ;
define('TEXT_NO', 'No') ;


define('TEXT_AGREE_TO_TERMS_YES', 'I Agree');
define('TEXT_AGREE_TO_TERMS_NO', 'I Do not Agree');
define('ENTRY_AGREE_TO_TERMS', 'Agree to terms and conritions:');
define('ENTRY_AGREE_TO_TERMS_TEXT', '*');
define('ENTRY_AGREE_TO_TERMS_ERROR', 'You must agree to terms and conditions.');

define('TEXT_EXAMPLE_YEAR', 'YYYY');
define('TEXT_EXAMPLE_MONTH', 'MM');
define('TEXT_EXAMPLE_MONTH_NAME', 'Month');
define('TEXT_EXAMPLE_MONTH_FULL', 'MM - Month');
define('TEXT_EXAMPLE_DAY', 'DD');


define('ENTRY_EMAIL_ADDRESS_ERROR', 'Your email address must contain a minimum of ' . ENTRY_EMAIL_ADDRESS_MIN_LENGTH . ' characters.');
define('ENTRY_EMAIL_ADDRESS_CHECK_ERROR', 'Your email address does not appear to be valid - please make any necessary corrections.');
define('ENTRY_EMAIL_ADDRESS_ERROR_EXISTS', 'Your email address already exists in our records - please log in with the e-mail address or create an account with a different address.');
define('ENTRY_EMAIL_ADDRESS_TEXT', '*');
define('ENTRY_USERNAME_TEXT', '');
define('ENTRY_STREET_ADDRESS', 'Address:');
define('ENTRY_STREET_ADDRESS_ERROR', 'Your street address must contain a minimum of ' . ENTRY_STREET_ADDRESS_MIN_LENGTH . ' characters.');
define('ENTRY_STREET_ADDRESS_TEXT', '*');
define('ENTRY_SUBURB', 'Address (2):');
define('ENTRY_SUBURB_ERROR', '');
define('ENTRY_SUBURB_TEXT', '');
define('ENTRY_POST_CODE', 'Zip:');
define('ENTRY_POST_CODE_ERROR', 'Your zip code must contain a minimum of ' . ENTRY_POSTCODE_MIN_LENGTH . ' characters.');
define('ENTRY_POST_CODE_TEXT', '*');
define('ENTRY_CITY', 'City:');
define('ENTRY_CITY_ERROR', 'Your city must contain a minimum of ' . ENTRY_CITY_MIN_LENGTH . ' characters.');
define('ENTRY_CITY_TEXT', '*');
define('ENTRY_STATE', 'State:');
define('ENTRY_STATE_ERROR', 'Your state must contain a minimum of ' . ENTRY_STATE_MIN_LENGTH . ' characters.');
define('ENTRY_STATE_ERROR_SELECT', 'Please select a state from the States pull down menu.');
define('ENTRY_STATE_TEXT', '*');
define('ENTRY_COUNTRY', 'Country:');
define('ENTRY_COUNTRY_ERROR', 'You must select a country from the Countries pull down menu.');
define('ENTRY_COUNTRY_TEXT', '*');
define('ENTRY_COUNTRY_TEXT2', '(Page will refresh when changed)');
define('ENTRY_TELEPHONE_NUMBER', 'Phone:');
define('ENTRY_TELEPHONE_NUMBER_ERROR', 'Your phone number must contain a minimum of ' . ENTRY_TELEPHONE_MIN_LENGTH . ' characters.');
define('ENTRY_PHONE_NUMBER_ERROR', 'Phone number is incorrect.');
define('ENTRY_TELEPHONE_NUMBER_TEXT', '*');
define('ENTRY_FAX_NUMBER', 'Fax number:');
define('ENTRY_FAX_NUMBER_ERROR', '');
define('ENTRY_FAX_NUMBER_TEXT', '');
define('ENTRY_NEWSLETTER', 'Newsletters:');
define('ENTRY_NEWSLETTER_TEXT', '');
define('ENTRY_NEWSLETTER_TEXT2', 'Check here to receive monthly news/coupons. <br />* We promise to never send you spam emails.');
define('ENTRY_NEWSLETTER_YES', 'Subscribed');
define('ENTRY_NEWSLETTER_NO', 'Unsubscribed');
define('ENTRY_NEWSLETTER_ERROR', '');
define('ENTRY_PASSWORD', 'Password:');
define('ENTRY_CAPTCHA', 'Security Code:');
define('ENTRY_PASSWORD_ERROR', 'Your password must contain a minimum of ' . ENTRY_PASSWORD_MIN_LENGTH . ' characters.');
define('ENTRY_PASSWORD_ERROR_NOT_MATCHING', 'The password Confirmation must match your Password.');
define('ENTRY_PASSWORD_TEXT', '*');
define('ENTRY_PASSWORD_CONFIRMATION', 'Password again:');
define('ENTRY_PASSWORD_CONFIRMATION_TEXT', '*');
define('ENTRY_PASSWORD_CURRENT', 'Current password:');
define('ENTRY_PASSWORD_CURRENT_TEXT', '*');
define('ENTRY_PASSWORD_CURRENT_ERROR', 'Your password must contain a minimum of ' . ENTRY_PASSWORD_MIN_LENGTH . ' characters.');
define('ENTRY_PASSWORD_NEW', 'New password:');
define('ENTRY_PASSWORD_NEW_TEXT', '*');
define('ENTRY_PASSWORD_NEW_ERROR', 'Your new password must contain a minimum of ' . ENTRY_PASSWORD_MIN_LENGTH . ' characters.');
define('ENTRY_PASSWORD_NEW_ERROR_NOT_MATCHING', 'The password Confirmation must match your new Password.');
define('PASSWORD_HIDDEN', '--HIDDEN--');

define('FORM_REQUIRED_INFORMATION', '* Required information');

// constants for use in tep_prev_next_display function

define('TEXT_CAPTCHA_ENTRY', 'Enter the %s letters as they are shown in the image above.<br />Letters are not case-sensitive');
define('TEXT_CAPTCHA_RELOAD', 'Reload image');
define('TEXT_RESULT_PAGE', 'Result pages:');
define('TEXT_DISPLAY_NUMBER_OF_PRODUCTS', 'Displaying <b>%d</b> to <b>%d</b> (of <b>%d</b> products)');
define('TEXT_DISPLAY_NUMBER_OF_ORDERS', 'Displaying <b>%d</b> to <b>%d</b> (of <b>%d</b> orders)');
define('TEXT_DISPLAY_NUMBER_OF_REVIEWS', 'Displaying <b>%d</b> to <b>%d</b> (of <b>%d</b> reviews)');
define('TEXT_DISPLAY_NUMBER_OF_PRODUCTS_NEW', 'Displaying <b>%d</b> to <b>%d</b> (of <b>%d</b> new products)');
define('TEXT_DISPLAY_NUMBER_OF_SPECIALS', 'Displaying <b>%d</b> to <b>%d</b> (of <b>%d</b> specials)');

define('PREVNEXT_TITLE_FIRST_PAGE', 'First page');
define('PREVNEXT_TITLE_PREVIOUS_PAGE', 'Previous page');
define('PREVNEXT_TITLE_NEXT_PAGE', 'Next page');
define('PREVNEXT_TITLE_LAST_PAGE', 'Last page');
define('PREVNEXT_TITLE_PAGE_NO', 'Page %d');
define('PREVNEXT_TITLE_PREV_SET_OF_NO_PAGE', 'Previous set of %d pages');
define('PREVNEXT_TITLE_NEXT_SET_OF_NO_PAGE', 'Next set of %d pages');
define('PREVNEXT_BUTTON_FIRST', '&lt;&lt;FIRST');
define('PREVNEXT_BUTTON_PREV', '[&lt;&lt;&nbsp;Prev]');
define('PREVNEXT_BUTTON_NEXT', '[Next&nbsp;&gt;&gt;]');
define('PREVNEXT_BUTTON_LAST', 'LAST&gt;&gt;');

define('IMAGE_BUTTON_ADD_ADDRESS', 'Add address');
define('IMAGE_BUTTON_ADDRESS_BOOK', 'Address book');
define('IMAGE_BUTTON_BACK', 'Go back');
define('IMAGE_BUTTON_BUY_NOW', 'Buy now');
define('IMAGE_BUTTON_CHANGE_ADDRESS', 'Change address');
define('IMAGE_BUTTON_CHECKOUT', 'Checkout');
define('IMAGE_BUTTON_CONFIRM_ORDER', 'Confirm order');
define('IMAGE_BUTTON_CONTINUE', 'Continue');
define('IMAGE_BUTTON_CONTINUE_SHOPPING', 'Continue shopping');
define('IMAGE_BUTTON_CREATE_ACCOUNT', 'Register');
define('IMAGE_BUTTON_DELETE', 'Delete');
define('IMAGE_BUTTON_EDIT_ACCOUNT', 'Edit account');
define('IMAGE_BUTTON_HISTORY', 'Order history');
define('IMAGE_BUTTON_LOGIN', 'Login');
define('IMAGE_BUTTON_IN_CART', 'Add to cart');
define('IMAGE_BUTTON_MORE_INFO', 'More info');
define('IMAGE_BUTTON_NOTIFICATIONS', 'Notifications');
define('IMAGE_BUTTON_QUICK_FIND', 'Quick find');
define('IMAGE_BUTTON_REMOVE_NOTIFICATIONS', 'Remove notifications');
define('IMAGE_BUTTON_REVIEWS', 'Reviews');
define('IMAGE_REDEEM_VOUCHER', 'Redeem');
define('IMAGE_BUTTON_LOGIN', 'Login');


define('IMAGE_BUTTON_SEARCH', 'Search');
define('IMAGE_BUTTON_SHIPPING_OPTIONS', 'Shipping options');
define('IMAGE_BUTTON_TELL_A_FRIEND', 'Tell a friend');
define('IMAGE_BUTTON_UPDATE', 'Update');
define('IMAGE_BUTTON_UPDATE_CART', 'Update cart');
define('IMAGE_BUTTON_WRITE_REVIEW', 'Write review');

define('SMALL_IMAGE_BUTTON_DELETE', 'Yes, delete.');
define('SMALL_IMAGE_BUTTON_DELETE_NOT', 'No, go back');
define('SMALL_IMAGE_BUTTON_EDIT', 'Edit');
define('SMALL_IMAGE_BUTTON_VIEW', 'View');
define('TEXT_VIEW_ITEM', 'View Item');



define('ICON_ARROW_RIGHT', 'more');
define('ICON_CART', 'In Cart');
define('ICON_ERROR', 'Error');
define('ICON_SUCCESS', 'Success');
define('ICON_WARNING', 'Warning');

// BOF: MOD - CATALOG_PRODUCTS_WITH_IMAGES_mod
define('BOX_CATALOG_PRODUCTS_WITH_IMAGES', 'Printable catalog');
define('IMAGE_BUTTON_UPSORT', 'Sort asending');
define('IMAGE_BUTTON_DOWNSORT', 'Sort desending');
// EOF: MOD - CATALOG_PRODUCTS_WITH_IMAGES_mod

//2 LINES ADDED: MOD - Down For Maintenance
define('TEXT_BEFORE_DOWN_FOR_MAINTENANCE', 'NOTICE: This website will be down for maintenance on: ');
define('TEXT_ADMIN_DOWN_FOR_MAINTENANCE', 'NOTICE: the website is currently Down For Maintenance to the public');
define('TEXT_GREETING_PERSONAL', 'Welcome back <span class="greetUser">%s!</span> Would you like to see which <a href="%s"><u>new products</u></a> are available to purchase?');
define('TEXT_GREETING_PERSONAL_RELOGON', '<small>If you are not %s, please <a href="%s"><u>log yourself in</u></a> with your account information.</small>');
define('TEXT_GREETING_GUEST', 'Welcome <span class="greetUser">Guest!</span> Would you like to <a href="%s"><u>log yourself in</u></a>? Or would you prefer to <a href="%s"><u>create an account</u></a>?');
define('TEXT_CHECKOUT', 'Checkout &raquo;');
define('TEXT_TOTAL', 'Total');
define('TEXT_TOTAL_VALUE', 'Total Value of');
define('TEXT_SAVED', 'You saved');
define('TEXT_NEW_TOTAL', 'New Total');
define('TEXT_FREE_SHIPPING', 'Free shipping');
define('TEXT_APPLY', 'Apply');
define('TEXT_SELECT_ALL', 'Select all');
define('TEXT_SELECT_INVERSE', 'Select inverse');
define('TEXT_SELECT_NONE', 'Select none');
define('TEXT_OFF', 'Off');
define('TEXT_PLUS_TAX', 'Plus %s&#37; tax');
define('TEXT_TAX_INCLUDED', 'tax included');
define('TEXT_PRICE', 'Price');
define('TEXT_PRICE_LOGIN', 'Login for price');
define('TEXT_PRICE_CALL', 'Call for price');
define('TEXT_PRICE_SUBJECT', 'Products price');
define('TEXT_TIME', 'Time');
define('TEXT_TRACK', 'Track');
define('TEXT_NO_TAX', 'No tax');
define('TEXT_SORT_PRODUCTS', 'Sort products ');
define('TEXT_DESCENDINGLY', 'descendingly');
define('TEXT_ASCENDINGLY', 'ascendingly');
define('TEXT_BY', ' by ');
define('TEXT_PRODUCT_REVIEW', '%s - Review');
define('TEXT_PRODUCT_REVIEWS', 'Reviews for %s');
define('TEXT_RECENT_CATEGORIES', 'Recent categories');
define('TEXT_RECENT_PRODUCTS', 'Recent products');

define('TEXT_REVIEW_BY', 'by %s');
define('TEXT_REVIEW_WORD_COUNT', '%s words');
define('TEXT_REVIEW_RATING', 'Rating: %s [%s]');
define('TEXT_REVIEW_DATE_ADDED', 'Date Added: %s');
define('TEXT_NO_REVIEWS', 'There are currently no product reviews.');
define('TEXT_NO_NEW_PRODUCTS', 'There are currently no products.');
define('TEXT_UNKNOWN_TAX_RATE', 'Unknown tax rate');
define('TEXT_REQUIRED', '<span class="errorText">Required</span>');
define('TEXT_REGULAR_PRICE', 'Regular Price');
define('TEXT_PRICE_NOW', 'Now Only');
define('TEXT_PRICE_SAVE', 'You Save');
define('TEXT_PRICE_SAVE_ADDITIONAL', 'You Save Additional');
define('TEXT_ACCESSORIES', 'Accessories');


define('TEXT_CLICK_TO_ENLARGE', 'Click to enlarge');

define('TEXT_FORUM_ACCOUNT_CREATED', 'A new account was automatically generated out of your existing forum account, Please review and update your new profile.');
define('TEXT_FORUM_ACCOUNT_INACTIVE', 'The specified board username is currently inactive. If you have problems activating your account, please contact a board administrator.');


define('ERROR_TEP_MAIL', '<font face="Verdana, Arial" size="2" color="#ff0000"><b><small>TEP ERROR:</small> Cannot send the email through the specified SMTP server. Please check your php.ini setting and correct the SMTP server if necessary.</b></font>');
define('WARNING_INSTALL_DIRECTORY_EXISTS', 'Warning: Installation directory exists at: <strong>' . dirname($_SERVER['SCRIPT_FILENAME']) . '/install</strong>. Please remove this directory for security reasons.');
define('WARNING_CONFIG_FILE_WRITEABLE', 'Warning: I am able to write to the configuration file: <strong>%s</strong>. This is a potential security risk - please set the right user permissions on this file. (read-only, CHMOD 644 or 444 are typical). You may need to use your webhost control panel/file-manager to change the permissions effectively. Contact your webhost for assistance.');
define('WARNING_SESSION_DIRECTORY_NON_EXISTENT', 'Warning: The sessions directory does not exist: ' . tep_session_save_path() . '. Sessions will not work until this directory is created.');
define('WARNING_SESSION_DIRECTORY_NOT_WRITEABLE', 'Warning: I am not able to write to the sessions directory: ' . tep_session_save_path() . '. Sessions will not work until the right user permissions are set.');
define('WARNING_SESSION_AUTO_START', 'Warning: session.auto_start is enabled - please disable this php feature in php.ini and restart the web server.');
define('WARNING_DOWNLOAD_DIRECTORY_NON_EXISTENT', 'Warning: The downloadable products directory does not exist: ' . DIR_FS_DOWNLOAD . '. Downloadable products will not work until this directory is valid.');
define('WARNING_SHOPPING_CART_COMBINED', 'For your convenience, your current shopping cart has been combined with your shopping cart from your last visit. Please review your shopping cart before checking out.');


define('TEXT_CCVAL_ERROR_INVALID_DATE', 'The expiry date entered for the credit card is invalid.<br />Please check the date and try again.');
define('TEXT_CCVAL_ERROR_INVALID_NUMBER', 'The credit card number entered is invalid.<br />Please check the number and try again.');
define('TEXT_CCVAL_ERROR_UNKNOWN_CARD', 'The first four digits of the number entered are: %s<br />If that number is correct, we do not accept that type of credit card.<br />If it is wrong, please try again.');

define('BOX_HEADING_ARTICLES', 'Articles');
define('BOX_ALL_ARTICLES', 'All articles');
define('BOX_NEW_ARTICLES', 'New articles');
define('TEXT_DISPLAY_NUMBER_OF_ARTICLES', 'Displaying <b>%d</b> to <b>%d</b> (of <b>%d</b> articles)');
define('TEXT_DISPLAY_NUMBER_OF_ARTICLES_NEW', 'Displaying <b>%d</b> to <b>%d</b> (of <b>%d</b> new articles)');
define('TABLE_HEADING_AUTHOR', 'Author');
define('TABLE_HEADING_ABSTRACT', 'Abstract');
define('BOX_HEADING_AUTHORS', 'Articles by author');
define('NAVBAR_TITLE_DEFAULT', 'Articles');

define('LOGIN_BOX_ACCOUNT_EDIT','Edit account info.');
define('LOGIN_BOX_ACCOUNT_HISTORY','Account history');
define('LOGIN_BOX_ADDRESS_BOOK','My address book');
define('LOGIN_BOX_PRODUCT_NOTIFICATIONS','Product notifications');
define('LOGIN_BOX_MY_ACCOUNT','General information');
define('LOGIN_BOX_LOGOFF','Log off');
define('LOGIN_BOX_PRODUCTS_NEW','New products');

define('BOX_HEADING_CUSTOMER_WISHLIST', 'my wishlist');
define('BOX_WISHLIST_EMPTY', 'You have no items on your wishlist');
define('IMAGE_BUTTON_ADD_WISHLIST', 'Add to wishlist');
define('TEXT_WISHLIST_COUNT', 'Currently %s items are on your wishlist.');
define('TEXT_DISPLAY_NUMBER_OF_WISHLIST', 'Displaying <b>%d</b> to <b>%d</b> (of <b>%d</b> items on your wishlist)');
define('BOX_HEADING_CUSTOMER_WISHLIST_HELP', 'Wishlist help');
define('BOX_HEADING_SEND_WISHLIST', 'Send your Wishlist');
define('BOX_TEXT_MOVE_TO_CART', 'Move to cart');
define('BOX_TEXT_DELETE', 'Delete');
define('WISHLIST_ERROR_CHECK_PRODUCTS', 'Select a product(s) first');
define('WISHLIST_ERROR_PRODUCTS_NOT_AVAILABLE', 'Some of the products are not yet available for purchase.');
define('WISHLIST_ERROR_ALREADY_ADDED', 'Product is already in the wishlist');
define('WISHLIST_ERROR_LIMIT', 'Sorry, but you cannot add more then %s products into your wishlist.');

define('BOX_INFORMATION_RSS', 'RSS feed');

define('ERROR_SECURITY', 'Please enter a valid security code.');
define('ENTRY_USENAME_ERROR_EMPTY', 'Username is empty.');
define('ENTRY_USENAME_ERROR_EXISTS', 'Your usename already exists in our records - please create an account with a different usename.');
define('ENTRY_SECURITY', 'Security Code:');

define('TEXT_PAGE_GENERATED_TIME','Page generated in %s seconds.');
define('TEXT_EXTRA_IMAGES', ' extra images ');
define('TEXT_PRODUCT_NOT_AVAILABLE', 'This product is not yet available');
define('TEXT_PRODUCT_NOT_AVAILABLE_DATE', 'This product is not yet available, it will be available on %s.');

define('TEXT_PRODUCT_TAGGED','%d product(s) tagged with %s.');
define('TEXT_USER_TAGGED','%d hit(s) for %s.');
define('TEXT_CHOOSE_OPTIONS_FIRST','Please review the product\'s options before adding it to cart.');
define('TEXT_AFFILIATE_ACCOUNT','Affiliate Account');
define('TEXT_AFFILIATE_LOGIN','Affiliate Login');
define('TEXT_AFFILIATE_REGISTER','Affiliate Register');
define('TEXT_AFFILIATE_LOGOFF','Affiliate Logoff');
define('TEXT_AFFILIATE_FAQ','Affiliate FAQ');
define('TEXT_AFFILIATE_TERMS','Affiliate Terms');
define('TEXT_AFFILIATE_INFO','Affiliate Info');


##### COUPONS
  define('MODULE_ORDER_TOTAL_COUPON_TITLE', 'Discount coupons');
  define('MODULE_ORDER_TOTAL_COUPON_HEADER', 'Gift vouchers/discount coupons');
  define('MODULE_ORDER_TOTAL_COUPON_DESCRIPTION', 'Discount coupon');
  define('MODULE_ORDER_TOTAL_COUPON_USER_PROMPT', '');
  define('MODULE_ORDER_TOTAL_COUPON_TEXT_ERROR', 'Gift voucher/discount');
  define('SHIPPING_NOT_INCLUDED', ' [Shipping not included]');
  define('TAX_NOT_INCLUDED', ' [Tax not included]');
  define('TEXT_ENTER_COUPON_CODE', 'Coupon code');

  define('FREE_SHIPPING_TITLE', 'Free Shipping');

  define('ERROR_NO_INVALID_REDEEM_COUPON', 'Invalid coupon code');
  define('ERROR_MINIMUM_AMOUNT', 'This coupon is only valid for orders over %s');
  define('ERROR_INVALID_STARTDATE_COUPON', 'This coupon will be available on %s');
  define('ERROR_INVALID_FINISHDATE_COUPON', 'This coupon has expired on %s');
  define('ERROR_INVALID_USES_COUPON', 'This coupon could only be used %s time(s).');
  define('ERROR_INVALID_USES_USER_COUPON', 'You have used the coupon the maximum number of times allowed per customer.');
  define('ERROR_REDEEMED_AMOUNT_ZERO', 'This coupon has no valid discount.');

  define('REDEEMED_COUPON', 'a coupon worth ');
  define('REDEEMED_MIN_ORDER', 'on orders over ');
  define('REDEEMED_FREE_SHIPPING', 'Congratulations, you have FREE SHIPPING');
  define('REDEEMED_RESTRICTIONS', ' [Product-category restrictions apply]');
  define('ERROR_RESTRICTIONS', 'Coupon Error: Product-category restrictions apply.');

  define('ERROR_LOGIN_TO_CHECK', 'This coupon has use-count limit, you must be <a href="'.tep_href_link(FILENAME_LOGIN).'">logged in</a> in order to use it.');
##### COUPONS END

	define('BOX_INFORMATION_GV', 'Gift Voucher FAQ');
	define('VOUCHER_BALANCE', 'Voucher Balance');
	define('BOX_HEADING_GIFT_VOUCHER', 'Gift Voucher Account');
	define('GV_FAQ', 'Gift Voucher FAQ');
	define('ERROR_REDEEMED_AMOUNT', 'Congratulations, you have redeemed ');
	define('ERROR_NO_REDEEM_CODE', 'You did not enter a redeem code.');
	define('ERROR_NO_INVALID_REDEEM_GV', 'Invalid Gift Voucher Code');
	define('TABLE_HEADING_CREDIT', 'Credits Available');
	define('GV_HAS_VOUCHERA', 'You have funds in your Gift Voucher Account. If you want you can send those funds by <a class="pageResults" href="');

	define('GV_HAS_VOUCHERB', '"><b>email</b></a> to someone');
	define('ENTRY_AMOUNT_CHECK_ERROR', 'You do not have enough funds to send this amount.');
	define('BOX_SEND_TO_FRIEND', 'Send Gift Voucher');

	define('VOUCHER_REDEEMED', 'Voucher Redeemed');
	define('CART_COUPON', 'Coupon :');
	define('CART_COUPON_INFO', 'more info');


define('BOX_INFORMATION_RETURNS', 'Track a Return');
define('POLL_SELECT_VOTE_FIRST', 'Please select your vote first.');
define('POLL_THANK_YOU_FOR_VOTING', 'Thank you for voting!');
define('POLL_ALREADY_VOTED', 'You have already voted, Thank You!');
define('POLL_TOTAL_VOTES', 'Total: %d vote(s)');
define('TEXT_QTY', 'Qty');

define('POWERED_BY', 'Powered by <a href="http://www.eclime.com">eclime.com</a>');


define('TEXT_DEMO', '<strong>THIS IS NOT A REAL ONLINE STORE!</strong> It is a DEMO of the <a href="http://www.eclime.com">eclime</a> e-commerce software.<br />
    ** NO REAL PRODUCTS CAN BE PURCHASED AND NO PRODUCTS WILL BE SHIPPED **');

?>