<?php

	if ( false === empty($current_category_id) && ($current_category_id > 0) ) {
		if ( true === empty($customers_group_id) || false === is_numeric($customers_group_id) ) {
			$customers_group_id = '0';
		}
		$best_sellers_query_sql = "
								SELECT DISTINCT
									p.products_id,
									p.products_image,
									p.products_image_stamp,
									p.products_price,
									p.products_price_hidden,
									p.products_access,
									IF (s.status, s.specials_new_products_price, NULL)
										AS specials_new_products_price,
									IF (s.status, s.specials_new_products_price, p.products_price)
										AS final_price,
									s.specials_text AS price_special_text,
									pd.products_name
								FROM
									" . TABLE_PRODUCTS . " p
									LEFT JOIN
									" . TABLE_SPECIALS . " s
										ON (p.products_id = s.products_id AND s.customers_group_id = '$customers_group_id'),
									" . TABLE_CATEGORIES . " c,
									" . TABLE_PRODUCTS_DESCRIPTION . " pd,

									" . TABLE_PRODUCTS_TO_CATEGORIES . " p2c


								WHERE
									p.products_status = '1'
									AND p.products_ordered > 0
									AND p.products_id = pd.products_id
									AND pd.language_id = '" . (int)$languages_id . "'
									AND p.products_id = p2c.products_id
									AND p2c.categories_id = c.categories_id
									AND '" . (int)$current_category_id . "' IN (c.categories_id, c.parent_id)
								ORDER BY
									p.products_ordered DESC,
									pd.products_name
								LIMIT " . MAX_DISPLAY_BESTSELLERS;
	} else {
		$best_sellers_query_sql = "
								SELECT DISTINCT
									p.products_id,
									p.products_image,
									p.products_image_stamp,
									p.products_price,
									p.products_price_hidden,
									p.products_access,
									IF (s.status, s.specials_new_products_price, NULL)
										AS specials_new_products_price,
									IF (s.status, s.specials_new_products_price, p.products_price)
										AS final_price,
									s.specials_text AS price_special_text,
									pd.products_name
								from
									" . TABLE_PRODUCTS . " p
									LEFT JOIN
										" . TABLE_SPECIALS . " s
										ON p.products_id = s.products_id,
									" . TABLE_CATEGORIES . " c,
									" . TABLE_PRODUCTS_DESCRIPTION . " pd
								where
									p.products_status = '1'
									AND p.products_ordered > 0
									AND p.products_id = pd.products_id
									AND pd.language_id = '" . (int)$languages_id . "'
								ORDER BY
									p.products_ordered DESC, pd.products_name
								LIMIT " . MAX_DISPLAY_BESTSELLERS;
	}

  $best_sellers_query = tep_db_query($best_sellers_query_sql);

  if (tep_db_num_rows($best_sellers_query) >= MIN_DISPLAY_BESTSELLERS) {
  	$smarty->assign('ENABLE_BEST_SELLERS','true');

  	$smarty->assign('BOX_HEADING_BESTSELLERS', BOX_HEADING_BESTSELLERS);

  	while ($best_sellers = tep_db_fetch_array($best_sellers_query)) {
  		// products access
		if ( true === isset($best_sellers['products_access']) ) {
			$customer_access_ids = explode(',', $best_sellers['products_access']);
			$customers_group_id = ( true === empty($customers_group_id) ? '0' : $customers_group_id );
			if ( false === in_array($customers_group_id, $customer_access_ids)) {
				continue;
			}
		}
  		$best_sellers['url'] = tep_href_link(FILENAME_PRODUCT_INFO, 'products_id=' . $best_sellers['products_id']);
  		$best_sellers['url_buy_now'] = tep_href_link(FILENAME_DEFAULT, 'action=buy_now&products_id=' . $best_sellers['products_id']);
  		$best_sellers['url_wishlist'] = tep_href_link(FILENAME_WISHLIST, 'action=add_wishlist&products_id=' . $best_sellers['products_id']);

  		$best_sellers['price'] = round($best_sellers['products_price'], 2);



  		if ( 'true' == DISPLAY_PRICE_WITH_TAX ) {
				$best_sellers['price'] = $currencies->display_price($best_sellers['products_price'], 0);
				$best_sellers['tax'] = tep_get_tax_rate($best_sellers['products_tax_class_id']);
				$best_sellers['price_with_tax'] = $currencies->display_price($best_sellers['products_price'], $best_sellers['tax']);
			} else {
				$best_sellers['price'] = $currencies->display_price($best_sellers['products_price'], 0);
		}

		$best_sellers['tax'] = tep_get_tax_rate($best_sellers['products_tax_class_id']);

		//specials_new_products_price
		$new_price = $best_sellers['specials_new_products_price'];

		if (false === empty($new_price)) {
				$best_sellers['price'] = $currencies->display_price($best_sellers['products_price'], 0);
				$best_sellers['price_special'] = $currencies->display_price($new_price, 0);
				$best_sellers['price_with_tax'] = $currencies->display_price($best_sellers['specials_new_products_price'], $best_sellers['tax']);
		} else {
				$best_sellers['price'] = $currencies->display_price($best_sellers['products_price'], 0);
				$best_sellers['price_with_tax'] = $currencies->display_price($product['products_price'], $best_sellers['tax']);
		}

		switch ( $best_sellers['products_price_hidden'] ) {
			case 1;
				if ( true === empty($customer_id) ) {
					$best_sellers['available'] = 'false';
					$best_sellers['price'] = 0;
					$best_sellers['price_hidden'] = true;
					$best_sellers['price_hidden_text'] = TEXT_PRICE_LOGIN;
					$best_sellers['price_hidden_text_url'] = tep_href_link(FILENAME_LOGIN, $login_logout_params, 'SSL');
				}
			break;
			case 2;
				$best_sellers['available'] = 'false';
				$best_sellers['price'] = 0;
				$best_sellers['price_hidden'] = true;
				$best_sellers['price_hidden_text'] = TEXT_PRICE_CALL;
				if ( true === defined('DEFAULT_CONTACT_PAGE') && '' != DEFAULT_CONTACT_PAGE ) {
					$best_sellers['price_hidden_text_url'] = tep_href_link(DEFAULT_CONTACT_PAGE);
				}
			break;
		}


  		$best_sellers['products_image'] = DIR_WS_IMAGES.$best_sellers['products_image'];

		###################   IMAGE SPECIAL MOD
		if ( 'on' === IMAGE_STAMP_ON_OFF ) {
			if( $best_sellers['products_image_stamp'] ) {
				$best_sellers['products_image'] = generate_image_stamp($best_sellers['products_image'], DIR_WS_IMAGES.$best_sellers['products_image_stamp']);
			}
		}
		###################   IMAGE SPECIAL MOD

		$best_sellers['image'] = tep_image($best_sellers['products_image'], $best_sellers['products_name'], SMALL_IMAGE_WIDTH/2, SMALL_IMAGE_HEIGHT/2, ' class="products_image"');


  		$_BESTSELLERS[] = $best_sellers;
    }
    $smarty->assign('_BESTSELLERS', $_BESTSELLERS);


  }


?>