<?php

class ot_coupon {
	var $title, $output;

	function ot_coupon() {
		$this->code = 'ot_coupon';
		$this->header = MODULE_ORDER_TOTAL_COUPON_HEADER;
		$this->title = MODULE_ORDER_TOTAL_COUPON_TITLE;
		$this->description = MODULE_ORDER_TOTAL_COUPON_DESCRIPTION;
		$this->user_prompt = '';
		$this->enabled = MODULE_ORDER_TOTAL_COUPON_STATUS;
		$this->sort_order = MODULE_ORDER_TOTAL_COUPON_SORT_ORDER;
		$this->include_shipping = MODULE_ORDER_TOTAL_COUPON_INC_SHIPPING;
		$this->tax_class = MODULE_ORDER_TOTAL_COUPON_TAX_CLASS;
		$this->credit_class = true;
		$this->output = array();
	}

	// function process is being used only in /checkout_payment.php
	function process() {
		global $order, $currencies, $coupon_result;
		$order_total = $this->get_order_total();
		$od_amount = $this->calculate_credit($order_total);
		$this->deduction = $od_amount;
		if ($od_amount > 0) {
			$order->info['total'] = $order->info['total'] - $od_amount;
			$discount = array(
							'coupon_amount' => $coupon_result['coupon_amount'],
							'coupon_type' => $coupon_result['coupon_type']
							);
			$this->output[] = array(
				'title' => $this->title,
				'text' => $coupon_result['coupon_code'] .' / '.$currencies->format($od_amount),
				'value' => $od_amount,
				'discount' => $discount
			);
		}
	}

	function selection_test() {
		return false;
	}


	function pre_confirmation_check($order_total) {
		global $customer_id;
		return $this->calculate_credit($order_total);
	}

	function use_credit_amount() {
		return $output_string;
	}



	function credit_selection_array() {
		global $customer_id, $currencies, $language;
		$gv_query_sql = "
						SELECT
							amount
						FROM
							" . TABLE_COUPON_GV_CUSTOMER . "
						WHERE
							customer_id = '$customer_id'";
		$gv_query = tep_db_query($gv_query_sql);
		$gv_result = tep_db_fetch_array($gv_query);
		if ($gv_result['amount'] > 0 ) {
			return false;
		} else {
			$output['form_start'] = tep_draw_form('checkout_payment_gift', tep_href_link(FILENAME_CHECKOUT_CONFIRMATION, '', 'SSL'), 'post', 'onsubmit="return submitRedeem();"');
			$output['TEXT_ENTER_COUPON_CODE'] = TEXT_ENTER_COUPON_CODE;
			$output['input'] = tep_draw_input_field('gv_redeem_code','',' id="gv_redeem_code"');
			$output['input_submit'] = '<input type="image" src="'.TEMPLATE_IMAGES_DIR.'languages/'. $language . '/buttons/button_apply.gif" name="submit_redeem" title="'.TEXT_APPLY.'" border="0" alt="' . TEXT_APPLY . '" title="' . IMAGE_REDEEM_VOUCHER . '" id="submit_coupon" />';
			$output['form_end'] = '</form>';
			return $output;
		}
	}



	function credit_selection() {
			$selection_array = $this->credit_selection_array();
			$selection_string  = $selection_array['form_start'];
			$selection_string .= '<div id="checkout_payment_coupon">';
			$selection_string .= '<table width="30%" border="0" cellspacing="0" cellpadding="6" class="coupon"><tr>';
			$selection_string .= '<td class="smallText" align="right">';
			$selection_string .= $selection_array['TEXT_ENTER_COUPON_CODE']  .':';
			$selection_string .= '</td>';
			$selection_string .= '<td id="enter_coupon">';
			$selection_string .= $selection_array['input'];
			$selection_string .= '</td>';
			$selection_string .= '<td id="submit_coupon" align="left">';
			$selection_string .= $selection_array['input_submit'];
			$selection_string .= '</td>';
			$selection_string .= '</table>';
			$selection_string .= '</div>';
			$selection_string .= $selection_array['form_end'];
	return $selection_string;
	}


	function collect_posts() {
	global $customer_id, $currencies, $cc_id, $cart, $order, $ot_coupon, $currency, $messageStack;
		$coupon_code = tep_db_prepare_input($_POST['gv_redeem_code']);


	        if ($coupon_code) {

	        	if ( $_POST['redirect'] ) {
	        		$redirect_link = $_POST['redirect'];
	        		$SSL = 'NONSSL';
	        	} else {
	        		$redirect_link = FILENAME_CHECKOUT_PAYMENT;
	        		$SSL = 'SSL';
	        	}

			$coupon_error = validate_coupon($coupon_code);

			if ( $coupon_error['count'] > 0 ) {
				tep_redirect(tep_href_link($redirect_link, 'payment_error='.$this->code.'&error=' . urlencode($coupon_error['message']), $SSL));
				exit();
			}

			$coupon_result = $coupon_error['coupon_result'];
			$cc_id = $coupon_result['coupon_id'];

			if ( !tep_session_is_registered('cc_id') ) {
				tep_session_register('cc_id');
			}

			if ( 'S' == $coupon_result['coupon_type'] ) {
				tep_session_register('cc_free_shipping');
				if ( FILENAME_CHECKOUT_CONFIRMATION == basename($_SERVER['PHP_SELF']) ) {
					$redirect_link = FILENAME_CHECKOUT_SHIPPING;
				}
				$messageStack->add_session('coupon_error', REDEEMED_FREE_SHIPPING, 'success');
				tep_redirect(tep_href_link($redirect_link, '', $SSL));
			}

			$sub_total = $cart->total;

			if ( 'true' == MODULE_ORDER_TOTAL_COUPON_INC_SHIPPING ) {
				$sub_total = tep_round($sub_total + $order->info['shipping_cost'], $currencies->currencies[$currency]['decimal_places']);
			}



			$coupon_amount = tep_round($ot_coupon->pre_confirmation_check($sub_total), $currencies->currencies[$currency]['decimal_places']);

			$coupon_amount_out = $currencies->format($coupon_amount) . ' ';
			if ( $coupon_result['coupon_minimum_order'] > 0 ) {
				$coupon_amount_out .= 'on orders greater than ' . $currencies->format($coupon_result['coupon_minimum_order']);
			}

			if ( false === empty($cc_id) && $coupon_amount == 0 ) {
					tep_session_unregister('cc_id');
					$messageStack->add_session('coupon_error', ERROR_REDEEMED_AMOUNT_ZERO, 'error');
					tep_redirect(tep_href_link($redirect_link, '', $SSL));
				} else {
					$messageStack->add_session('coupon_error', ERROR_REDEEMED_AMOUNT . $coupon_amount_out, 'success');
					tep_redirect(tep_href_link($redirect_link, '', $SSL));
				}


			}
	        if ($_POST['submit_redeem_coupon_x']) tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error='.$this->code.'&error=' . urlencode(ERROR_NO_REDEEM_CODE), 'SSL'));
	}

	function calculate_credit($amount) {
		global $customer_id, $order, $cc_id, $coupon_code, $coupon_result;

		$od_amount = 0;

		$coupon_code = get_coupon_code_by_cc_id($cc_id);
		$coupon_error = validate_coupon($coupon_code);

		$coupon_result = $coupon_error['coupon_result'];

		if ( $coupon_error['count'] > 0 ) { // Errors found RETURN!
			return tep_round($od_amount, 2);
		} else { // Coupon is Fine :)
			$c_deduct = $coupon_result['coupon_amount'];

			switch ( $coupon_result['coupon_type'] ) {
				case 'F': # fixed amount
					$od_amount = $c_deduct;
				break;
				case 'P': # percentage %
					$od_amount = $amount * $c_deduct / 100;
				break;

			}
			return $od_amount;
		}
	}

	/*

	function calculate_tax_deduction($amount, $od_amount, $method) {
	global $customer_id, $order, $cc_id, $cart;
	        $coupon_query = tep_db_query("select coupon_code from " . TABLE_COUPONS . " where coupon_id = '" . $cc_id . "'");
	        if ( 0 < tep_db_num_rows($coupon_query) ) {
	                $coupon_result = tep_db_fetch_array($coupon_query);
	                $coupon_get = tep_db_query("select coupon_amount, coupon_minimum_order, restrict_to_products, restrict_to_categories, coupon_type from " . TABLE_COUPONS . " where coupon_code = '". $coupon_result['coupon_code'] . "'");
	                $get_result = tep_db_fetch_array($coupon_get);
	                if ( 'S' != $get_result['coupon_type'] ) {
	                        if ($get_result['restrict_to_products'] || $get_result['restrict_to_categories']) {
	                                // What to do here.
	                                // Loop through all products and build a list of all product_ids, price, tax class
	                                // at the same time create total net amount.
	                                // then
	                                // for percentage discounts. simply reduce tax group per product by discount percentage
	                                // or
	                                // for fixed payment amount
	                                // calculate ratio based on total net
	                                // for each product reduce tax group per product by ratio amount.
	                                $products = $cart->get_products();
	                                $valid_product = false;
	                                for ($i=0; $i<sizeof($products); $i++) {
	                                $valid_product = false;
	                                        $t_prid = tep_get_prid($products[$i]['id']);
	                                        $cc_query = tep_db_query("select products_tax_class_id from " . TABLE_PRODUCTS . " where products_id = '" . $t_prid . "'");
	                                        $cc_result = tep_db_fetch_array($cc_query);
	                                        if ($get_result['restrict_to_products']) {
	                                                $pr_ids = split("[,]", $get_result['restrict_to_products']);
	                                                for ($p = 0; $p < sizeof($pr_ids); $p++) {
	                                                        if ($pr_ids[$p] == $t_prid) $valid_product = true;
	                                                }
	                                        }
	                                        if ($get_result['restrict_to_categories']) {
	                        $cat_ids = split("[,]", $get_result['restrict_to_categories']);
	                        $my_path = tep_get_product_path($t_prid);
	                        $sub_cat_ids = split("[_]", $my_path);
	                        for ($iii = 0; $iii < count($sub_cat_ids); $iii++) {
	                            for ($ii = 0; $ii < count($cat_ids); $ii++) {
	                                if ($sub_cat_ids[$iii] == $cat_ids[$ii]) {
	                                    $valid_product = true;
	                                    continue 2;
	                                }
	                            }
	                        }
	                                        }
	                        if ($valid_product) {
	                               $price_excl_vat = $products[$i]['final_price'] * $products[$i]['quantity']; //Fred - added
	                               $price_incl_vat = $this->product_price($t_prid); //Fred - added
	                               $valid_array[] = array('product_id' => $t_prid, 'products_price' => $price_excl_vat, 'products_tax_class' => $cc_result['products_tax_class_id']); //jason //Fred - changed from $products[$i]['final_price'] 'products_tax_class' => $cc_result['products_tax_class_id']);
	                                                $total_price += $price_excl_vat; // changed
	                                        }
	                                }
	                                if (sizeof($valid_array) > 0) { // if ($valid_product) {
	                                        if ($get_result['coupon_type'] == 'P') {
	                                                $ratio = $get_result['coupon_amount']/100;
	                                        } else {
	                                                $ratio = $od_amount / $total_price;
	                                        }
	                                        if ($get_result['coupon_type'] == 'S') $ratio = 1;
	                                        if ($method=='Credit Note') {
	                                                $tax_rate = tep_get_tax_rate($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']);
	                                                $tax_desc = tep_get_tax_description($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']);
	                                                if ($get_result['coupon_type'] == 'P') {
	                                                        $tod_amount = $od_amount / (100 + $tax_rate)* $tax_rate;
	                                                } else {
	                                                        $tod_amount = $order->info['tax_groups'][$tax_desc] * $od_amount/100;
	                                                }
	                                                $order->info['tax_groups'][$tax_desc] -= $tod_amount;
	                                                $order->info['total'] -= $tod_amount; //  need to modify total ...OLD
	                                                $order->info['tax'] -= $tod_amount; //Fred - added
	                                        } else {
	                                                for ($p=0; $p<sizeof($valid_array); $p++) {
	                                                        $tax_rate = tep_get_tax_rate($valid_array[$p]['products_tax_class'], $order->delivery['country']['id'], $order->delivery['zone_id']);
	                                                        $tax_desc = tep_get_tax_description($valid_array[$p]['products_tax_class'], $order->delivery['country']['id'], $order->delivery['zone_id']);
	                                                        if ($tax_rate > 0) {
	                                                                $tod_amount = ($valid_array[$p]['products_price'] * $tax_rate)/100 * $ratio; // calc total tax Fred - added
	                                                                $order->info['tax_groups'][$tax_desc] -= ($valid_array[$p]['products_price'] * $tax_rate)/100 * $ratio;
	                                                                $order->info['total'] -= ($valid_array[$p]['products_price'] * $tax_rate)/100 * $ratio; // adjust total
	                                                                $order->info['tax'] -= ($valid_array[$p]['products_price'] * $tax_rate)/100 * $ratio; // adjust tax -- Fred - added
	                                                        }
	                                                }
	                                        }
	                                }
	                                //NO RESTRICTION--------------------------------
	                        } else {
	                                if ($get_result['coupon_type'] =='F') {
	                                        $tod_amount = 0;
	                                        if ($method=='Credit Note') {
	                                                $tax_rate = tep_get_tax_rate($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']);
	                                                $tax_desc = tep_get_tax_description($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']);
	                                                $tod_amount = $od_amount / (100 + $tax_rate)* $tax_rate;
	                                                $order->info['tax_groups'][$tax_desc] -= $tod_amount;
	                                        } else {
	                                                reset($order->info['tax_groups']);
	                                                while (list($key, $value) = each($order->info['tax_groups'])) {
	                                                        $ratio1 = $od_amount/($amount-$order->info['tax_groups'][$key]); ////debug
	                                                        $tax_rate = tep_get_tax_rate_from_desc($key);
	                                                        $net = $tax_rate * $order->info['tax_groups'][$key];
	                                                        if ($net>0) {
	                                                                $god_amount = $order->info['tax_groups'][$key] * $ratio1;
	                                                                $tod_amount += $god_amount;
	                                                                $order->info['tax_groups'][$key] = $order->info['tax_groups'][$key] - $god_amount;
	                                                        }
	                                                }
	                                        }
	                                        $order->info['total'] -= $tod_amount;
	                                        $order->info['tax'] -= $tod_amount;
	                        }
	                        if ($get_result['coupon_type'] =='P') {
	                                $tod_amount=0;
	                                if ($method=='Credit Note') {
	                                        $tax_desc = tep_get_tax_description($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']);
	                                        $tod_amount = $order->info['tax_groups'][$tax_desc] * $od_amount/100;
	                                        $order->info['tax_groups'][$tax_desc] -= $tod_amount;
	                                } else {
	                                        reset($order->info['tax_groups']);
	                                        while (list($key, $value) = each($order->info['tax_groups'])) {
	                                                $god_amount=0;
	                                                $tax_rate = tep_get_tax_rate_from_desc($key);
	                                                $net = $tax_rate * $order->info['tax_groups'][$key];
	                                                if ($net>0) {
	                                                        $god_amount = $order->info['tax_groups'][$key] * $get_result['coupon_amount']/100;
	                                                        $tod_amount += $god_amount;
	                                                        $order->info['tax_groups'][$key] = $order->info['tax_groups'][$key] - $god_amount;
	                                                }
	                                        }
	                                }
	                                $order->info['total'] -= $tod_amount;
	                                $order->info['tax'] -= $tod_amount;
	                        }
	                }
	        }
	}
	return $tod_amount;
	}
	*/

	function update_credit_account($i) {
	        return false;
	}

	function apply_credit() {
	global $insert_id, $customer_id, $REMOTE_ADDR, $cc_id;
	        if ($this->deduction !=0) {
	                tep_db_query("insert into " . TABLE_COUPON_REDEEM_TRACK . " (coupon_id, redeem_date, redeem_ip, customer_id, order_id) values ('" . $cc_id . "', now(), '" . $_SERVER['REMOTE_ADDR'] . "', '" . $customer_id . "', '" . $insert_id . "')");
	        }
	        tep_session_unregister('cc_id');
	}

	function get_order_total() {
		global $order, $cart, $customer_id, $cc_id, $coupon_code, $coupon_result;

		if ( true === empty($coupon_code)) {
			$coupon_code = get_coupon_code_by_cc_id($cc_id);
		}

		$coupon_error = validate_coupon($coupon_code);
		$coupon_result = $coupon_error['coupon_result'];
		$order_total = $order->info['subtotal'];
		$order_shipping_cost = $order->info['shipping_cost'];

		if ( 'S' == $coupon_result['coupon_type'] ) {
			$order->info['shipping_cost'] = 0;
		}

		if ( 'true' == MODULE_ORDER_TOTAL_COUPON_INC_SHIPPING ) {
			$order_total = $order_total + $order_shipping_cost;
		}

	        // OK thats fine for global coupons but what about restricted coupons
	        // where you can only redeem against certain products/categories.
	        // and I though this was going to be easy !!!
	        $coupon_query=tep_db_query("select coupon_code from " . TABLE_COUPONS . " where coupon_id='".$cc_id."'");
	        if (tep_db_num_rows($coupon_query) !=0) {
	                $coupon_result=tep_db_fetch_array($coupon_query);
	                $coupon_get=tep_db_query("select coupon_amount, coupon_minimum_order,restrict_to_products,restrict_to_categories, coupon_type from " . TABLE_COUPONS . " where coupon_code='".$coupon_result['coupon_code']."'");
	                $get_result=tep_db_fetch_array($coupon_get);
	                $in_cat = true;
	                if ($get_result['restrict_to_categories']) {
	                        $cat_ids = split("[,]", $get_result['restrict_to_categories']);
	                        $in_cat=false;
	                        for ($i = 0; $i < count($cat_ids); $i++) {
	                                if (is_array($this->contents)) {
	                                        reset($this->contents);
	                                        while (list($products_id, ) = each($this->contents)) {
	                                                $cat_query = tep_db_query("select products_id from products_to_categories where products_id = '" . $products_id . "' and categories_id = '" . $cat_ids[$i] . "'");
	                                                if (tep_db_num_rows($cat_query) !=0 ) {
	                                                        $in_cat = true;
	                                                        $total_price += $this->get_product_price($products_id);
	                                                }
	                                        }
	                                }
	                        }
	                }
	                $in_cart = true;
	                if ($get_result['restrict_to_products']) {

	                        $pr_ids = split("[,]", $get_result['restrict_to_products']);

	                        $in_cart=false;
	                        $products_array = $cart->get_products();

	                        for ($i = 0; $i < sizeof($pr_ids); $i++) {
	                                for ($ii = 1; $ii<=sizeof($products_array); $ii++) {
	                                        if (tep_get_prid($products_array[$ii-1]['id']) == $pr_ids[$i]) {
	                                                $in_cart=true;
	                                                $total_price += $this->get_product_price($products_array[$ii-1]['id']);
	                                        }
	                                }
	                        }
	                        $order_total = $total_price;
	                }
	        }
	return $order_total;
	}

	function get_product_price($product_id) {
	global $cart, $order;
	        $products_id = tep_get_prid($product_id);
	        // products price
	        $qty = $cart->contents[$product_id]['qty'];
	        $product_query = tep_db_query("select products_id, products_price, products_tax_class_id, products_weight from " . TABLE_PRODUCTS . " where products_id='" . $product_id . "'");
	        if ($product = tep_db_fetch_array($product_query)) {
	        		if ( true === empty($customers_group_id) || false === is_numeric($customers_group_id) ) {
					$customers_group_id = '0';
				}
	                $prid = $product['products_id'];
	                $products_tax = tep_get_tax_rate($product['products_tax_class_id']);
	                $products_price = $product['products_price'];
	                $specials_query = tep_db_query("select specials_new_products_price from " . TABLE_SPECIALS . " where products_id = '" . $prid . "' and status = '1' AND customers_group_id = '$customers_group_id')");
	                if (tep_db_num_rows ($specials_query)) {
	                        $specials = tep_db_fetch_array($specials_query);
	                        $products_price = $specials['specials_new_products_price'];
	                }
	                if ($this->include_tax == 'true') {
	                        $total_price += ($products_price + tep_calculate_tax($products_price, $products_tax)) * $qty;
	                } else {
	                        $total_price += $products_price * $qty;
	                }

	                // attributes price
	                if (isset($cart->contents[$product_id]['attributes'])) {
	                        reset($cart->contents[$product_id]['attributes']);
	                        while (list($option, $value) = each($cart->contents[$product_id]['attributes'])) {
	                                $attribute_price_query = tep_db_query("select options_values_price, price_prefix from " . TABLE_PRODUCTS_ATTRIBUTES . " where products_id = '" . $prid . "' and options_id = '" . $option . "' and options_values_id = '" . $value . "'");
	                                $attribute_price = tep_db_fetch_array($attribute_price_query);
	                                if ($attribute_price['price_prefix'] == '+') {
	                                        if ($this->include_tax == 'true') {
	                                                $total_price += $qty * ($attribute_price['options_values_price'] + tep_calculate_tax($attribute_price['options_values_price'], $products_tax));
	                                        } else {
	                                                $total_price += $qty * ($attribute_price['options_values_price']);
	                                        }
	                                } else {
	                                        if ($this->include_tax == 'true') {
	                                                $total_price -= $qty * ($attribute_price['options_values_price'] + tep_calculate_tax($attribute_price['options_values_price'], $products_tax));
	                                        } else {
	                                                $total_price -= $qty * ($attribute_price['options_values_price']);
	                                        }
	                                }
	                        }
	                }
	        }
	        if ($this->include_shipping == 'true') {
	                $total_price += $order->info['shipping_cost'];
	        }
	        return $total_price;
	}


	function product_price($product_id) {
	        $total_price = $this->get_product_price($product_id);
	        if ($this->include_shipping == 'true') $total_price -= $order->info['shipping_cost'];
	        return $total_price;
	}

	function get_error() {
		$error = array('title' => MODULE_ORDER_TOTAL_COUPON_TEXT_ERROR,
	                     'error' => stripslashes(urldecode($_GET['error'])));
		return $error;
	}

	function check() {
	        if (!isset($this->check)) {
	                $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_ORDER_TOTAL_COUPON_STATUS'");
	                $this->check = tep_db_num_rows($check_query);
	        }
	        return $this->check;
	}

	function keys() {
	        return array('MODULE_ORDER_TOTAL_COUPON_STATUS', 'MODULE_ORDER_TOTAL_COUPON_SORT_ORDER', 'MODULE_ORDER_TOTAL_COUPON_INC_SHIPPING', 'MODULE_ORDER_TOTAL_COUPON_CALC_TAX', 'MODULE_ORDER_TOTAL_COUPON_TAX_CLASS');
	}

	function install() {
	        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Display Total', 'MODULE_ORDER_TOTAL_COUPON_STATUS', 'true', 'Do you want to display the Discount Coupon value?', '6', '1','tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
	        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_ORDER_TOTAL_COUPON_SORT_ORDER', '9', 'Sort order of display.', '6', '2', now())");
	        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function ,date_added) values ('Include Shipping', 'MODULE_ORDER_TOTAL_COUPON_INC_SHIPPING', 'false', 'Include Shipping in calculation', '6', '5', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
	        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function ,date_added) values ('Re-calculate Tax', 'MODULE_ORDER_TOTAL_COUPON_CALC_TAX', 'None', 'Re-Calculate Tax', '6', '7','tep_cfg_select_option(array(\'None\', \'Standard\', \'Credit Note\'), ', now())");
	        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Tax Class', 'MODULE_ORDER_TOTAL_COUPON_TAX_CLASS', '0', 'Use the following tax class when treating Discount Coupon as Credit Note.', '6', '0', 'tep_get_tax_class_title', 'tep_cfg_pull_down_tax_classes(', now())");
	}

	function remove() {
	        $keys = '';
	        $keys_array = $this->keys();
	        for ($i=0; $i<sizeof($keys_array); $i++) {
	                $keys .= "'" . $keys_array[$i] . "',";
	        }
	        $keys = substr($keys, 0, -1);
	        tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in (" . $keys . ")");
	}
}
?>
