<?php
/*
//--- plugin options START
This data will be used for installation.
#PLUGIN_KEY:BESTSELLERS
#PLUGIN_GROUP:LEFTRIGHT
#PLUGIN_DEFAULT_GROUP:RIGHT
#PLUGIN_NAME:Best sellers
#PLUGIN_DESCRIPTION:This is a best seller plugin
//--- plugin options END
*/

	$PLUGIN_KEY = 'BESTSELLERS';
	if ( true !== $_ADMIN ) { ## Plugin init
		$init = init($PLUGIN_KEY); #initialize plugin
		if ( true === is_array($init['PLUGIN_OPTIONS']) ) {
			foreach ( $init['PLUGIN_OPTIONS'] as $option ) {
				$opt_var = $PLUGIN_KEY . '_'.$option['key'];
				$$opt_var = $option['value']; # eg; $BESTSELLERS_name
			}
		}
		if ( true === empty($customers_group_id) || false === is_numeric($customers_group_id) ) {
			$customers_group_id = '0';
		}
		if ( false === empty($current_category_id) && ($current_category_id > 0) && '1' == $BESTSELLERS_category_sensitive ) {
			$best_sellers_query_sql = "
									SELECT DISTINCT
										p.products_id,
										p.products_image,
										p.products_image_stamp,
										p.products_price,
										p.products_price_hidden,
										p.products_price_groups,
										p.products_tax_class_id,
										IF (s.status, s.specials_new_products_price, NULL)
											AS specials_new_products_price,
										IF (s.status, s.specials_new_products_price, p.products_price)
											AS final_price,
										s.specials_text AS price_special_text,
										pd.products_name,
										p.products_access,
										p.products_bundle
									FROM
										" . TABLE_PRODUCTS . " p
										LEFT JOIN
										" . TABLE_SPECIALS . " s
											ON (p.products_id = s.products_id AND s.customers_group_id = '$customers_group_id'),
										" . TABLE_CATEGORIES . " c,
										" . TABLE_PRODUCTS_DESCRIPTION . " pd,

										" . TABLE_PRODUCTS_TO_CATEGORIES . " p2c


									WHERE
										p.products_status = '1'
										AND p.products_ordered > 0
										AND p.products_id = pd.products_id
										AND pd.language_id = '" . (int)$languages_id . "'
										AND p.products_id = p2c.products_id
										AND p2c.categories_id = c.categories_id
										AND '" . (int)$current_category_id . "' IN (c.categories_id, c.parent_id)
									ORDER BY
										p.products_ordered DESC,
										pd.products_name
									LIMIT " . MAX_DISPLAY_BESTSELLERS;
		} else {
			$best_sellers_query_sql = "
									SELECT DISTINCT
										p.products_id,
										p.products_image,
										p.products_image_stamp,
										p.products_price,
										p.products_price_hidden,
										p.products_price_groups,
										p.products_tax_class_id,
										p.products_bundle,
										p.products_access,
										IF (s.status, s.specials_new_products_price, NULL)
											AS specials_new_products_price,
										IF (s.status, s.specials_new_products_price, p.products_price)
											AS final_price,
										s.specials_text AS price_special_text,
										pd.products_name
									from
										" . TABLE_PRODUCTS . " p
										LEFT JOIN
											" . TABLE_SPECIALS . " s
											ON (p.products_id = s.products_id AND s.customers_group_id = '$customers_group_id'),
										" . TABLE_CATEGORIES . " c,
										" . TABLE_PRODUCTS_DESCRIPTION . " pd
									where
										p.products_status = '1'
										AND p.products_ordered > 0
										AND p.products_id = pd.products_id
										AND pd.language_id = '" . (int)$languages_id . "'
									ORDER BY
										p.products_ordered DESC, pd.products_name
									LIMIT " . MAX_DISPLAY_BESTSELLERS;
		}
	  $best_sellers_query = tep_db_query($best_sellers_query_sql);
	  $best_sellers_count = tep_db_num_rows($best_sellers_query);
	  if ($best_sellers_count >= MIN_DISPLAY_BESTSELLERS) {
	  	while ($best_sellers = tep_db_fetch_array($best_sellers_query)) {
	  		// products access
			if ( true === isset($best_sellers['products_access']) ) {
				$customer_access_ids = explode(',', $best_sellers['products_access']);
				$customers_group_id = ( true === empty($customers_group_id) ? '0' : $customers_group_id );
				if ( false === in_array($customers_group_id, $customer_access_ids)) {
					continue;
				}
			}
	  		$best_sellers['url'] = tep_href_link(FILENAME_PRODUCT_INFO, 'products_id=' . $best_sellers['products_id']);
	  		$best_sellers['url_buy_now'] = tep_href_link(FILENAME_DEFAULT, 'action=buy_now&products_id=' . $best_sellers['products_id']);
	  		$best_sellers['url_wishlist'] = tep_href_link(FILENAME_WISHLIST, 'action=add_wishlist&products_id=' . $best_sellers['products_id']);
	  		$best_sellers['price'] = round($best_sellers['products_price'], 2);
	  		if ( 'true' == DISPLAY_PRICE_WITH_TAX ) {
					$best_sellers['price'] = $currencies->display_price($best_sellers['products_price'], 0);
					$best_sellers['tax'] = tep_get_tax_rate($best_sellers['products_tax_class_id']);
					$best_sellers['price_with_tax'] = $currencies->display_price($best_sellers['products_price'], $best_sellers['tax']);
				} else {
					$best_sellers['price'] = $currencies->display_price($best_sellers['products_price'], 0);
			}
			$best_sellers['tax'] = tep_get_tax_rate($best_sellers['products_tax_class_id']);
			$new_price = $best_sellers['specials_new_products_price'];
			$products_base_price = $best_sellers['products_price'];
			if ( '0' != $customers_group_id && true === is_numeric($customers_group_id) && '1' == $best_sellers['products_price_groups'] && false === empty($best_sellers['products_id']) ) {
				$products_base_price = tep_get_products_group_base_price($best_sellers['products_id'], $customers_group_id, $best_sellers['products_price']);
			}
			$best_sellers['price'] = $currencies->display_price($products_base_price, 0);
			$best_sellers['price_with_tax'] = $currencies->display_price($products_base_price, $best_sellers['tax']);
			if ( false === empty($new_price) ) {
				if ( $new_price < $products_base_price ) {
				$best_sellers['price'] = $currencies->display_price($products_base_price, 0);
				$best_sellers['price_special'] = $currencies->display_price($new_price, 0);
				$best_sellers['price_saved'] = $currencies->display_price($best_sellers['products_price']-$new_price, 0);
				$best_sellers['price_saved_percent'] = floor(($best_sellers['products_price']-$new_price) *  100 / $best_sellers['products_price']);
				$best_sellers['price_special_with_tax'] = $currencies->display_price($new_price, $best_sellers['tax']);
				}
			}
			switch ( $best_sellers['products_price_hidden'] ) {
				case 1;
					if ( true === empty($customer_id) ) {
						$best_sellers['available'] = 'false';
						$best_sellers['price'] = 0;
						$best_sellers['price_hidden'] = true;
						$best_sellers['price_hidden_text'] = TEXT_PRICE_LOGIN;
						$best_sellers['price_hidden_text_url'] = tep_href_link(FILENAME_LOGIN, $login_logout_params, 'SSL');
					}
				break;
				case 2;
					$best_sellers['available'] = 'false';
					$best_sellers['price'] = 0;
					$best_sellers['price_hidden'] = true;
					$best_sellers['price_hidden_text'] = TEXT_PRICE_CALL;
					if ( true === defined('DEFAULT_CONTACT_PAGE') && '' != DEFAULT_CONTACT_PAGE ) {
						$best_sellers['price_hidden_text_url'] = tep_href_link(DEFAULT_CONTACT_PAGE);
					}
				break;
			}
	  		$best_sellers['products_image'] = DIR_WS_IMAGES.$best_sellers['products_image'];
			###################   IMAGE SPECIAL MOD
			if ( 'on' === IMAGE_STAMP_ON_OFF ) {
				if( $best_sellers['products_image_stamp'] ) {
					$best_sellers['products_image'] = generate_image_stamp($best_sellers['products_image'], DIR_WS_IMAGES.$best_sellers['products_image_stamp']);
				}
			}
			###################   IMAGE SPECIAL MOD
			$best_sellers['image'] = tep_image($best_sellers['products_image'], $best_sellers['products_name'], SMALL_IMAGE_WIDTH/2, SMALL_IMAGE_HEIGHT/2, ' class="products_image_small"');
			$best_sellers['products_name'] = htmlspecialchars($best_sellers['products_name']);
	  		$_BESTSELLERS[] = $best_sellers;
	    }

	  }
		$BESTSELLERS_name = stripslashes($BESTSELLERS_name);
		$plugin_header = ( '1' == $BESTSELLERS_show_header ? $BESTSELLERS_name : '' );
		$plugins_info[$init['PLUGIN_KEY']] = array(
								'plugin_key' => $init['PLUGIN_KEY'],
								'plugin_name' => $BESTSELLERS_name,
								'plugin_header' => $plugin_header,
								'best_sellers' => $_BESTSELLERS,
								'best_sellers_count' => $best_sellers_count);


	} else { ## Plugin Installation:
		if ( 'install_plugin' == $_GET['action'] && $PLUGIN_KEY == $_POST['plugins_key'] ) {
			## SET UP DEFAULT OPTIONS (atleast 1 is required "name")
			$plugins_default_options_array = array(
										array(
											'name' => 'Name',
											'key' => 'name',
											'options' => '', // empty - textfield
											'value' => 'Best sellers'
											),
										array(
											'name' => 'Show header',
											'key' => 'show_header',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Limit',
											'key' => 'limit',
											'options' => '', // empty - textfield
											'value' => '10'
											),
										array(
											'name' => 'Category sensitive',
											'key' => 'category_sensitive',
											'options' => array( '1'=>'On', '0'=>'Off' ), // array - dropdown
											'value' => '1'
											),
										);
			### NO NEED TO CHANGE
							$plugin->install($languages_id);
			### NO NEED TO CHANGE
		}
	}

/**/

?>