<?php
/*
//--- plugin options START
This data will be used for installation.
#PLUGIN_KEY:MANUFACTURERS
#PLUGIN_GROUP:LEFTRIGHT
#PLUGIN_DEFAULT_GROUP:RIGHT
#PLUGIN_NAME:Manufacturers
#PLUGIN_DESCRIPTION:Manufacturers Plugin
//--- plugin options END
*/


	$PLUGIN_KEY = 'MANUFACTURERS';

	if ( true !== $_ADMIN ) {

		$init = init($PLUGIN_KEY); #initialize plugin

		if ( true === is_array($init['PLUGIN_OPTIONS']) ) {
			foreach ( $init['PLUGIN_OPTIONS'] as $option ) {
				$opt_var = $PLUGIN_KEY . '_'.$option['key'];
				$$opt_var = $option['value']; # eg; $MANUFACTURERS_name
			}
		}



		if ( '0' == $MANUFACTURERS_smart_display || (basename($_SERVER['PHP_SELF']) !== FILENAME_MANUFACTURERS || false === empty($_GET['manufacturers_id'])) )  {
				$plugin_show_manufacturers = 'true';
		} else {
				$plugin_show_manufacturers = 'false';
		}
		if ( 'true' == $plugin_show_manufacturers ) {
			switch ( $MANUFACTURERS_sort_order ) {
				case 'name':
					$order_by_sql = " ORDER BY m.manufacturers_name";
				break;
				case 'name_desc':
					$order_by_sql = " ORDER BY m.manufacturers_name DESC";
				break;

				case 'date_added':
					$order_by_sql = " ORDER BY m.date_added";
				break;

				case 'date_added_desc':
					$order_by_sql = " ORDER BY m.date_added DESC";
				break;

				case 'random':
					$order_by_sql = " ORDER BY RAND()";
				break;
			}

			$plugin_manufacturers_query_sql = "
									SELECT
										*
									FROM
										" . TABLE_MANUFACTURERS . " m,
										" . TABLE_MANUFACTURERS_INFO . " i
									WHERE
										m.manufacturers_id = i.manufacturers_id
										AND languages_id = '$languages_id'
										$order_by_sql
									LIMIT $MANUFACTURERS_limit
										";
				$plugin_manufacturers_query = tep_db_query($plugin_manufacturers_query_sql);
				if ( 0 < tep_db_num_rows($plugin_manufacturers_query) ) {
					$plugin_manufacturers = array();
					if ( 'dropdown' == $MANUFACTURERS_type ) {
						$plugin_manuf[] = array(
													'id' => '',
													'text' => 'Shop by brand'
												);
					}
					while ( $plugin_manufacturers = tep_db_fetch_array($plugin_manufacturers_query) ) {

						if ( 'dropdown' == $MANUFACTURERS_type ) {
							array_push($plugin_manuf, array('id' => tep_href_link(FILENAME_MANUFACTURERS, 'manufacturers_id=' . $plugin_manufacturers['manufacturers_id']),'text' => $plugin_manufacturers['manufacturers_name']));

						} else {
							if ( false === empty($plugin_manufacturers['manufacturers_image']) ) {
								$plugin_manufacturers['manufacturers_image'] = tep_image(DIR_WS_IMAGES . $plugin_manufacturers['manufacturers_image'], htmlspecialchars(stripslashes($plugin_manufacturers['manufacturers_name'])), MANUFACTURERS_SMALL_IMAGE_WIDTH, MANUFACTURERS_SMALL_IMAGE_HEIGHT);
							}
							$plugin_manufacturers['url'] = tep_href_link(FILENAME_MANUFACTURERS, 'manufacturers_id=' . $plugin_manufacturers['manufacturers_id']);

							if ( false === empty($plugin_manufacturers['manufacturers_url']) ) {
								$plugin_manufacturers['manufacturers_url'] = tep_href_link_external($plugin_manufacturers['manufacturers_url']);
								# Remove http(s)://
								if ( strstr($plugin_manufacturers['manufacturers_url'], 'https://') ) {
									$plugin_manufacturers['manufacturers_url_name'] = substr($plugin_manufacturers['manufacturers_url'], 8);
								} elseif ( strstr($plugin_manufacturers['manufacturers_url'], 'http://') ) {
									$plugin_manufacturers['manufacturers_url_name'] = substr($plugin_manufacturers['manufacturers_url'], 7);
								}
							}
							$plugin_manufacturers_info[] = $plugin_manufacturers;
						}

					}

					if ( 'dropdown' == $MANUFACTURERS_type ) {
						$plugin_manufacturers_info = tep_draw_pull_down_menu('shop_by_brand', $plugin_manuf, '', 'onchange="window.location=this.value;"');
					}
				}
		}

		$MANUFACTURERS_name = stripslashes($MANUFACTURERS_name);
		$plugin_header = ( '1' == $MANUFACTURERS_show_header ? $MANUFACTURERS_name : '' );

		$plugin_url = ( '1' == $MANUFACTURERS_show_url ? tep_href_link(FILENAME_MANUFACTURERS) : '' );

		$plugins_info[$init['PLUGIN_KEY']] = array(
							'plugin_key' => $init['PLUGIN_KEY'],
							'plugin_name' => $MANUFACTURERS_name,
							'plugin_header' => $plugin_header,
							'plugin_url' => $plugin_url,
							'plugin_manufacturers_type' => $MANUFACTURERS_type,
							'plugin_show_manufacturers' => $plugin_show_manufacturers,
							'manufacturers_info' => $plugin_manufacturers_info
		);


	} else { ## Plugin Installation:

		if ( 'install_plugin' == $_GET['action'] && $PLUGIN_KEY == $_POST['plugins_key'] ) {
			## SET UP DEFAULT OPTIONS (atleast 1 is required "name")
			$plugins_default_options_array = array(
										array(
											'name' => 'Name',
											'key' => 'name',
											'options' => '', // empty - textfield
											'value' => 'Manufacturers'
											),
										array(
											'name' => 'Show header',
											'key' => 'show_header',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Show url',
											'description' => 'Show header as link ?',
											'key' => 'show_url',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Smart display',
											'description' => 'Hides manufacturers plugin under certain conditions (where it\'s not needed) <br />Recommended "On"',
											'key' => 'smart_display',
											'options' => array( '1'=>'On', '0'=>'Off' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Type',
											'key' => 'type',
											'options' => array( 'images'=>'Images', 'dropdown'=>'Drop down' ), // array - dropdown
											'value' => 'images'
											),
										array(
											'name' => 'Sort order',
											'key' => 'sort_order',
											'options' => array( 'name'=>'Name', 'name_desc'=>'Name Desc', 'date_added'=>'Date added', 'date_added_desc'=>'Date added Desc', 'random'=>'Random' ), // array - dropdown
											'value' => 'name'
											),
										array(
											'name' => 'Limit',
											'key' => 'limit',
											'options' => '', // empty - textfield
											'value' => '15'
											),
										);

			### NO NEED TO CHANGE
							$plugin->install($languages_id);
			### NO NEED TO CHANGE
		}
	}

?>