<?php
/*
//--- plugin options START
This data will be used for installation.
#PLUGIN_KEY:NEWPRODUCTS
#PLUGIN_GROUP:CENTER
#PLUGIN_DEFAULT_GROUP:CENTER
#PLUGIN_NAME:New Products
#PLUGIN_DESCRIPTION:Displays new products.
//--- plugin options END
*/

	$PLUGIN_KEY = 'NEWPRODUCTS';

	if ( true !== $_ADMIN ) { ## Plugin init
		$init = init($PLUGIN_KEY); #initialize plugin

		if ( true === is_array($init['PLUGIN_OPTIONS']) ) {
			foreach ( $init['PLUGIN_OPTIONS'] as $option ) {
				$opt_var = $PLUGIN_KEY . '_'.$option['key'];
				$$opt_var = $option['value']; # eg; $NEWPRODUCTS_name
			}
		}

		if ( false === is_numeric($NEWPRODUCTS_limit) ) {
			$NEWPRODUCTS_limit = 10;
		}


		if ( false === empty($NEWPRODUCTS_categories_id) || false === empty($NEWPRODUCTS_exclude_categories_id) ) {
			$categories_from_sql = ', ' . TABLE_CATEGORIES . ' c, ';
			$categories_from_sql .= TABLE_PRODUCTS_TO_CATEGORIES . ' p2c ';
			$categories_where_sql = ' AND p.products_id = p2c.products_id';
			$categories_where_sql .= ' AND p2c.categories_id = c.categories_id';
			if ( false === empty($NEWPRODUCTS_categories_id) ) {
				$inc_categories = explode(',', $NEWPRODUCTS_categories_id);
				if ( true === is_array($inc_categories) ) {
					$cat_ids_string = '';
					foreach ( $inc_categories as $cat_id ) {
						if ( false === empty($cat_id) ) {
							$cat_ids_string .= "'".(int)$cat_id . "',";
						}
					}
					$cat_ids_string = substr($cat_ids_string, 0, -1);
					if ( false === empty($cat_ids_string) ) {
						$categories_where_sql .= " AND ( c.categories_id IN ($cat_ids_string) OR c.parent_id IN ($cat_ids_string) )";
					}
				}
			}
			if ( false === empty($NEWPRODUCTS_exclude_categories_id) ) {
				$excl_categories = explode(',', $NEWPRODUCTS_exclude_categories_id);
				if ( true === is_array($excl_categories) ) {
					$excl_cat_ids_string = '';
					foreach ( $excl_categories as $excl_cat_id ) {
						if ( false === empty($excl_cat_id) ) {
							$excl_cat_ids_string .= "'".(int)$excl_cat_id . "',";
						}
					}
					$excl_cat_ids_string = substr($excl_cat_ids_string, 0, -1);
					if ( false === empty($excl_cat_ids_string) ) {
						$categories_where_sql .= " AND ( c.categories_id NOT IN ($excl_cat_ids_string) AND c.parent_id NOT IN ($excl_cat_ids_string) )";
					}
				}
			}
		}

		if ( true === is_numeric($NEWPRODUCTS_days_ago) && 0 < $NEWPRODUCTS_days_ago ) {
			$days_ago_where_sql = 'AND p.products_date_added >= ( CURRENT_DATE( ) - INTERVAL '.tep_db_prepare_input($NEWPRODUCTS_days_ago).' DAY )';
		} else {
			$days_ago_where_sql = 'AND month(p.products_date_added) = month(now())';
		}

		if ( true === empty($customers_group_id) || false === is_numeric($customers_group_id) ) {
			$customers_group_id = '0';
		}

		$new_products_query_sql = "
					SELECT DISTINCT
						pd.products_name,
						pd.products_description,
						p.products_image,
						p.products_image_thumb,
						p.products_image_stamp,
						p.products_id,
						p.manufacturers_id,
						p.products_price,
						p.products_price_hidden,
						p.products_ship_price,
						p.products_ship_price_two,
						p.average_rating,
						p.products_price_groups,
						p.reviews_count,
						p.products_bundle,
						p.products_access,
							IF (s.status, s.specials_new_products_price, NULL)
								AS specials_new_products_price,
							IF (s.status, s.specials_new_products_price, p.products_price)
								AS final_price,
							IF (s.status, s.specials_text, NULL)
								AS price_special_text,
						p.products_model,
						p.products_date_added,
						p.products_weight,
						p.products_tax_class_id,
						p.products_date_available,
						p.products_quantity,
						m.manufacturers_name,
						m.manufacturers_image
					FROM
						" . TABLE_PRODUCTS_DESCRIPTION . " pd,
						" . TABLE_PRODUCTS . " p
					LEFT JOIN
						" . TABLE_MANUFACTURERS . " m
							ON p.manufacturers_id = m.manufacturers_id
					LEFT JOIN
						" . TABLE_SPECIALS . " s
							ON (p.products_id = s.products_id AND s.customers_group_id = '$customers_group_id')
						$categories_from_sql
					WHERE
						p.products_status = '1'
						AND pd.language_id = '" . (int)$languages_id . "'
						AND p.products_id = pd.products_id
						$categories_where_sql
						$days_ago_where_sql

					ORDER BY
						p.products_date_added desc
					LIMIT $NEWPRODUCTS_limit

					";


			$new_products = fetchProducts($new_products_query_sql, false);

			$NEWPRODUCTS_name = stripslashes($NEWPRODUCTS_name);
			$plugin_header = ( '1' == $NEWPRODUCTS_show_header ? $NEWPRODUCTS_name : '' );
			$plugins_info[$init['PLUGIN_KEY']] = array(
								'plugin_key' => $init['PLUGIN_KEY'],
								'plugin_name' => $NEWPRODUCTS_name,
								'plugin_header' => $plugin_header,
								'new_products' => $new_products
								);

	} else { ## Plugin Installation:

		if ( 'install_plugin' == $_GET['action'] && $PLUGIN_KEY == $_POST['plugins_key'] ) {
			## SET UP DEFAULT OPTIONS (atleast 1 is required "name")
			$plugins_default_options_array = array(
										array(
											'name' => 'Name',
											'description' => '',
											'key' => 'name',
											'options' => '', // empty - textfield
											'value' => 'New Products'
											),
										array(
											'name' => 'Show header',
											'description' => '',
											'key' => 'show_header',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Limit',
											'description' => '',
											'key' => 'limit',
											'options' => '', // empty - textfield
											'value' => '15'
											),
										array(
											'name' => 'Days old',
											'description' => 'Show products only up to X days old. ',
											'key' => 'days_ago',
											'options' => '', // empty - textfield
											'value' => '31'
											),
										array(
											'name' => 'Categories',
											'key' => 'categories_id',
											'options' => '', // empty - textfield
											'value' => ''
											),
										array(
											'name' => 'Exclude Categories',
											'key' => 'exclude_categories_id',
											'options' => '', // empty - textfield
											'value' => ''
											),
										);

			### NO NEED TO CHANGE
							$plugin->install($languages_id);
			### NO NEED TO CHANGE
		}
	}


?>