<?php
/*
//--- plugin options START
This data will be used for installation.
#PLUGIN_KEY:POLL
#PLUGIN_GROUP:LEFTRIGHT
#PLUGIN_DEFAULT_GROUP:RIGHT
#PLUGIN_NAME:Poll
#PLUGIN_DESCRIPTION:Poll Plugin!
//--- plugin options END
*/

	$PLUGIN_KEY = 'POLL';

	if ( true !== $_ADMIN ) { ## Plugin init
		$init = init($PLUGIN_KEY); #initialize plugin

		if ( true === is_array($init['PLUGIN_OPTIONS']) ) {
			foreach ( $init['PLUGIN_OPTIONS'] as $option ) {
				$opt_var = $PLUGIN_KEY . '_'.$option['key'];
				$$opt_var = $option['value']; # eg; $POLL_name
			}
		}

		function tep_poll_vote($poll_id, $poll_options_id) {
			if ( true === empty($poll_id) || true === empty($poll_options_id) ) {
				return false;
			}
			$vote_ip = $_SERVER['REMOTE_ADDR'];

			$check_vote_ip_query_sql = "
								SELECT
									*
								FROM
									poll_votes
								WHERE
									poll_vote_ip = '$vote_ip'
									AND poll_id = '$poll_id'";
			$check_vote_ip_query = tep_db_query($check_vote_ip_query_sql);
			if ( 0 < tep_db_num_rows($check_vote_ip_query) ) {
				return false;
			}

			$update_vote_count_query_sql = "
									UPDATE
										poll
									SET
										poll_count = poll_count+1
									WHERE
										poll_id = '$poll_id'
									LIMIT 1
			";
			tep_db_query($update_vote_count_query_sql);

			$insert_vote_query_sql = "
								INSERT INTO
									poll_votes
								SET
									poll_id = '$poll_id',
									poll_option_id = '$poll_options_id',
									poll_vote_ip = '$vote_ip',
									poll_vote_time= '" . time() . "'";
			return tep_db_query($insert_vote_query_sql);
		}


		function tep_show_poll($poll_id = '', $products_id = '', $categories_id = '' ) {
			global $languages_id;

			if ( true === empty($products_id) ) {
				$where_sql = "p.products_id = '0'";

				if ( true === empty($categories_id) ) {
					$where_sql .= " AND p.categories_id = '0'";
				} else {
					$where_sql .= " AND p.categories_id = '$categories_id'";
				}
			} else {
				$where_sql .= " p.products_id = '$products_id'";
			}

			if ( !tep_session_is_registered('customer_id') ) {
				$where_sql .= " AND p.poll_public = '1'";
			}

			if ( false === empty($poll_id) ) {
				$where_sql .= " AND p.poll_id = '$poll_id'";
			}

			$poll_query_sql = "
							SELECT
								p.poll_id,
								p.poll_type,
								p.poll_public,
								p.poll_open,
								p.poll_type,
								p.categories_id,
								p.products_id,
								p.poll_count,
								p.poll_time,
								pd.poll_description
							FROM
								poll p,
								poll_description pd
							WHERE
								$where_sql
								AND p.poll_open = '1'
								AND p.poll_id = pd.poll_id
								AND pd.language_id = '$languages_id'
								ORDER BY RAND()
							LIMIT 1
							";
				$poll_query = tep_db_query($poll_query_sql);
				if ( 0 >= tep_db_num_rows($poll_query) ) {
					return false;
				}

				$poll = tep_db_fetch_array($poll_query);
				return $poll;
		}


		function tep_user_voted($poll_id) {
			$voted_query_sql = "
								SELECT
									poll_id
								FROM
									poll_votes
								WHERE
									poll_vote_ip = '{$_SERVER['REMOTE_ADDR']}'
									AND poll_id = '$poll_id'";
			$voted_query = tep_db_query($voted_query_sql);
			if ( 0 < tep_db_num_rows($voted_query) ) {
				return true;
			} else {
				return false;
			}
		}


		function tep_show_poll_results($poll_id = '') {
			global $languages_id;

			if ( true === empty($poll_id) ) {
				return false;
			}

			$poll_options_query_sql = "
								SELECT
									po.poll_options_id,
									po.poll_id,
									pd.poll_options_description
								FROM
									poll_options po,
									poll_options_description pd
								WHERE
									po.poll_id = '$poll_id'
									AND po.poll_options_id = pd.poll_options_id
									AND po.poll_id = pd.poll_id
									AND pd.language_id = '$languages_id'
								";
			$poll_options_query = tep_db_query($poll_options_query_sql);

			if ( 0 >= tep_db_num_rows($poll_options_query) ) {
				return false;
			}

			$poll_output_total = 0;
			while ( $poll_options = tep_db_fetch_array($poll_options_query) ) {
				$votes_count_query_sql = "
										SELECT
											count(poll_votes_id) as votes
										FROM
											poll_votes
										WHERE
											poll_id = '$poll_id'
											AND poll_option_id = '{$poll_options['poll_options_id']}'";
				$votes_count_query = tep_db_query($votes_count_query_sql);
				$votes_count = tep_db_fetch_array($votes_count_query);
				$votes = $votes_count['votes'];
				$poll_output_total += $votes;
				$poll_output_options_temp[] = array(
										'id' => $poll_options['poll_options_id'],
										'text' => stripslashes($poll_options['poll_options_description']),
										'votes' => $votes
										);
				}

				# this will avoid making another sql query, ( to get the total.)
				foreach ( $poll_output_options_temp as $poll_output_option ) {

					if ( 0 < $poll_output_total ) {
						$option_percent = $poll_output_option['votes'] * 100 / $poll_output_total;
					}

					if ( 1 > $option_percent ) {
						$option_percent = 1;
					}

					$poll_output_options[] = array(
										'id' => $poll_output_option['id'],
										'text' => stripslashes($poll_output_option['text']),
										'votes' => $poll_output_option['votes'],
										'percent' => $option_percent
										);
				}
				$poll_output_return = array(
									'total' => $poll_output_total,
									'options' => $poll_output_options
									);
			return $poll_output_return;
		}

		function tep_show_poll_vote($poll_id, $poll_type = 'radio') {
			global $languages_id;



			$poll_options_query_sql = "
								SELECT
									po.poll_options_id,
									po.poll_id,
									pd.poll_options_description
								FROM
									poll_options po,
									poll_options_description pd
								WHERE
									po.poll_id = '$poll_id'
									AND po.poll_options_id = pd.poll_options_id
									AND po.poll_id = pd.poll_id
									AND pd.language_id = '$languages_id'
								";
				$poll_options_query = tep_db_query($poll_options_query_sql);

				if ( 0 >= tep_db_num_rows($poll_options_query) ) {
					return false;
				}

				if ( 'dropdown' == $poll_type ) {
					$poll_output_options[] = array(
											'id' => '0',
											'text' => PULL_DOWN_DEFAULT);
				}

				while ( $poll_options = tep_db_fetch_array($poll_options_query) ) {
					$checked = ( $poll_options['poll_options_id'] === $_POST['poll_options_id'] ? true : false );

					switch ($poll_type) {
						case 'dropdown':
							$poll_output_options[] = array(
											'id' => $poll_options['poll_options_id'],
											'text' => stripslashes($poll_options['poll_options_description']));
						break;
						default:
						case 'radio':
							$poll_output_options[] = array(
											'id' => $poll_options['poll_options_id'],
											'radio' => tep_draw_radio_field('poll_options_id', $poll_options['poll_options_id'], $checked, 'id="poll_options_id_'.$poll_options['poll_options_id'].'"'),
											'text' => stripslashes($poll_options['poll_options_description']));
						break;
					}
				}

				if ( 'dropdown' == $poll_type ) {
					$poll_output_options = tep_draw_pull_down_menu('poll_options_id', $poll_output_options, '', '');
				}
				return $poll_output_options;

		}


		$poll_action = $_GET['poll_action'];
		$poll_id = (int)$_GET['poll_id'];
		$products_id = (int)$_GET['products_id'];
		$message = $_GET['message'];



		if ( 'vote' == $poll_action ) {
			$poll_id = tep_db_prepare_input($_POST['poll_id']);
			$poll_options_id = tep_db_prepare_input($_POST['poll_options_id']);

			if ( true === empty($poll_options_id) ) {
				$poll_output_message = POLL_SELECT_VOTE_FIRST;
			} else {

				$inserted = tep_poll_vote($poll_id, $poll_options_id);
				if ( true === $inserted ) {
					$msg = urlencode(POLL_THANK_YOU_FOR_VOTING);
				} else {
					$msg = urlencode(POLL_ALREADY_VOTED);
				}
				tep_redirect(tep_href_link(basename($_SERVER['PHP_SELF']), tep_get_all_get_params(array('poll_action'))."poll_action=view_results&poll_id=$poll_id&message=$msg").'#poll');
			}
		}


		if ( 'view_results' == $poll_action ) {

			$poll = tep_show_poll($poll_id, $products_id, $current_category_id);
			$poll_output_title = $poll['poll_description'];
			$poll_output_action = 'RESULTS';
			$poll_res = tep_show_poll_results($poll_id);
			$poll_output_options = $poll_res['options'];
			$poll_output_total = sprintf(POLL_TOTAL_VOTES, $poll_res['total']);
			$poll_output_message = urldecode($message);


			$user_voted = tep_user_voted($poll_id);
			if ( false === $user_voted ) {
				$poll_output_url_vote = tep_href_link(basename($_SERVER['PHP_SELF']), tep_get_all_get_params(array('poll_action','poll_id')).'poll_id='.$poll_id).'#poll';
			}


		} else {
			$poll = tep_show_poll($poll_id, $products_id, $current_category_id);

			if ( false !== $poll ) {
				$poll_id = $poll['poll_id'];
				$user_voted = tep_user_voted($poll_id);
				$poll_output_title = $poll['poll_description'];
				$poll_type = $poll['poll_type'];

				if ( false === $user_voted ) {
					$poll_output_action = 'VOTE';
					$poll_output_form = tep_draw_form('poll', tep_href_link(basename($_SERVER['PHP_SELF']), tep_get_all_get_params(array('poll_action')).'poll_action=vote').'#poll');
					$poll_output_hidden = tep_draw_hidden_field('poll_id', $poll_id);
					$poll_output_options = tep_show_poll_vote($poll_id, $poll_type);
					$poll_output_url_view_results = tep_href_link(basename($_SERVER['PHP_SELF']), tep_get_all_get_params().'poll_action=view_results&poll_id='.$poll_id).'#poll';

					//xhtml strict thing...
					$poll_output_url_view_results = html_entity_decode($poll_output_url_view_results);
					$poll_output_url_view_results = htmlspecialchars($poll_output_url_view_results);

				} elseif ( '1' == $POLL_always_show_results ) {
					$poll_output_action = 'RESULTS';
					$poll_res = tep_show_poll_results($poll_id);
					$poll_output_options = $poll_res['options'];
					$poll_output_total = $poll_res['total'];
				}
			}
		}


		$POLL_name = stripslashes($POLL_name);
		$plugin_header = ( '1' == $POLL_show_header ? $POLL_name : '' );

		   $plugins_info[$init['PLUGIN_KEY']] = array(
		    							'plugin_key' => $init['PLUGIN_KEY'],
									'plugin_name' => $POLL_name,
									'plugin_header' => $plugin_header,
									'poll_output_form' => $poll_output_form,
									'poll_output_hidden' => $poll_output_hidden,
									'poll_output_action' => $poll_output_action,
									'poll_output_title' => $poll_output_title,
									'poll_output_options' => $poll_output_options,
									'poll_output_total' => $poll_output_total,
									'poll_output_message' => $poll_output_message,
									'poll_output_url_view_results' => $poll_output_url_view_results,
									'poll_output_url_vote' => $poll_output_url_vote,
									'poll_output_type' => $poll_type,
									'show_poll' => $poll_output_title);

	} else { ## Plugin Installation:

		if ( 'install_plugin' == $_GET['action'] && $PLUGIN_KEY == $_POST['plugins_key'] ) {
			## SET UP DEFAULT OPTIONS (atleast 1 is required "name")
			$plugins_default_options_array = array(
										array(
											'name' => 'Name',
											'key' => 'name',
											'options' => '', // empty - textfield
											'value' => 'Poll'
											),
										array(
											'name' => 'Show header',
											'key' => 'show_header',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Always show results?',
											'description' => '"Yes" - Poll results will be shown all the time (uses more resources).<br />"No" - poll results will disappear after user voted and viewed the results (uses less resources).<br />(Recommended "No")',
											'key' => 'always_show_results',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '0'
											)
										);

			### NO NEED TO CHANGE
							$plugin->install($languages_id);
			### NO NEED TO CHANGE
		}
	}

?>