<?php
/*
//--- plugin options START
This data will be used for installation.
#PLUGIN_KEY:RECENTLYVISITED
#PLUGIN_GROUP:LEFTRIGHT
#PLUGIN_DEFAULT_GROUP:RIGHT
#PLUGIN_NAME:Recently Visited
#PLUGIN_DESCRIPTION:Recently visited products/categories plugin.
//--- plugin options END
*/

	$PLUGIN_KEY = 'RECENTLYVISITED';

	if ( true !== $_ADMIN ) { ## Plugin init
		$init = init($PLUGIN_KEY); #initialize plugin

		if ( true === is_array($init['PLUGIN_OPTIONS']) ) {
			foreach ( $init['PLUGIN_OPTIONS'] as $option ) {
				$opt_var = $PLUGIN_KEY . '_'.$option['key'];
				$$opt_var = $option['value']; # eg; $RECENTLYVISITED_name
			}
		}


		function tep_insert_recently_visited($id, $name, $url, $type, $limit) {
			$time = time();

			switch ( $type ) {
				case 'product':
					$session_name = 'recently_visited_products';
				break;
				case 'category':
					$session_name = 'recently_visited_categories';
				break;
				default:
					return  false;
				break;
			}
					$id = tep_db_prepare_input($id);
					$id = (int)$id;//to avoid doulbe products in rv-list
					if ( false === empty($_SESSION[$session_name]) ) {
						$recently_visited_array = unserialize($_SESSION[$session_name]);
						if ( false !== $recently_visited_array ) {
							$exists = false;
							foreach ( $recently_visited_array as $tkey => $recent ) {
								if ( $id == $recent['id'] ) {
									$exists = true;
									$exists_time = $tkey;
								}
							}
							if ( false === $exists ) {
								//limits
								if ( count($recently_visited_array) >= $limit ) {
									array_pop($recently_visited_array);//remove last
								}
							} else {
								unset($recently_visited_array[$exists_time]);
							}
								$recently_visited = array(
										'id' => $id,
										'name' => htmlspecialchars($name),
										'url' => $url);
								$recently_visited_array[$time] = $recently_visited;
								krsort($recently_visited_array);
								unset($_SESSION[$session_name]);
								$_SESSION[$session_name] = serialize($recently_visited_array);
						}
					} else {
					$recently_visited = array(
								'id' => $id,
								'name' => htmlspecialchars($name),
								'url' => $url);
					$recently_visited_insert = array();
					$recently_visited_insert[$time] = $recently_visited;
					$recently_visited_serialized = serialize($recently_visited_insert);
					$_SESSION[$session_name] = $recently_visited_serialized;
					}
		}

		if ( 'both' == $RECENTLYVISITED_type || 'products' == $RECENTLYVISITED_type ) {
			if ( false === empty($_GET['products_id']) ) {
				$product_info_query_sql = "SELECT products_name FROM " . TABLE_PRODUCTS_DESCRIPTION . " WHERE products_id = '{$_GET['products_id']}' AND language_id = '$languages_id'";
				$product_info_query = tep_db_query($product_info_query_sql);
					if ( 0 < tep_db_num_rows($product_info_query) ) {
						$product_info = tep_db_fetch_array($product_info_query);
						$products_url = tep_href_link(FILENAME_PRODUCT_INFO, ($cPath ? 'cPath=' . $cPath . '&' : '') . 'products_id=' . $_GET['products_id']);
						tep_insert_recently_visited($_GET['products_id'], $product_info['products_name'], $products_url,'product', $RECENTLYVISITED_products_limit);
					}
			}
			if ( $_SESSION['recently_visited_products'] ) {
				$recent_products = unserialize($_SESSION['recently_visited_products']);
			}
		}

		if ( 'both' == $RECENTLYVISITED_type || 'categories' == $RECENTLYVISITED_type ) {
			if ( false === empty($_GET['cPath']) && true === empty($_GET['products_id']) ) {
				$category_info_query_sql = "SELECT categories_name FROM " . TABLE_CATEGORIES_DESCRIPTION . " WHERE categories_id = '$current_category_id' AND language_id = '$languages_id'";
				$category_info_query = tep_db_query($category_info_query_sql);
					if ( 0 < tep_db_num_rows($category_info_query) ) {
						$category_info = tep_db_fetch_array($category_info_query);
						tep_insert_recently_visited($current_category_id, $category_info['categories_name'], tep_href_link(FILENAME_DEFAULT, 'cPath='.$_GET['cPath']), 'category', $RECENTLYVISITED_categories_limit);
					}
			}
			if ( $_SESSION['recently_visited_categories'] ) {
				$recent_categories = unserialize($_SESSION['recently_visited_categories']);
			}
		}

		$RECENTLYVISITED_name = stripslashes($RECENTLYVISITED_name);
		$plugin_header = ( '1' == $RECENTLYVISITED_show_header ? $RECENTLYVISITED_name : '' );

		$plugins_info[$init['PLUGIN_KEY']] = array(
								'plugin_key' => $init['PLUGIN_KEY'],
								'plugin_name' => $RECENTLYVISITED_name,
								'plugin_header' => $plugin_header,
								'recent_products' => $recent_products,
								'recent_products_header' => $RECENTLYVISITED_products_header,
								'recent_categories' => $recent_categories,
								'recent_categories_header' => $RECENTLYVISITED_categories_header
		);


	} else { ## Plugin Installation:

		if ( 'install_plugin' == $_GET['action'] && $PLUGIN_KEY == $_POST['plugins_key'] ) {
			## SET UP DEFAULT OPTIONS (atleast 1 is required "name")
			$plugins_default_options_array = array(
										array(
											'name' => 'Name',
											'key' => 'name',
											'options' => '', // empty - textfield
											'value' => 'Recently Visited'
											),
										array(
											'name' => 'Show header',
											'key' => 'show_header',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Type',
											'key' => 'type',
											'options' => array( 'both'=>'Both','products'=>'Products only','categories'=>'Categories only' ), // array - dropdown
											'value' => 'both'
											),
										array(
											'name' => 'Products header',
											'key' => 'products_header',
											'options' => '', // empty - textfield
											'value' => 'Recent products'
											),
										array(
											'name' => 'Categories header',
											'key' => 'categories_header',
											'options' => '',
											'value' => 'Recent categories'
											),
										array(
											'name' => 'Products Limit',
											'key' => 'products_limit',
											'options' => '',
											'value' => '5'
											),
										array(
											'name' => 'Categories Limit',
											'key' => 'categories_limit',
											'options' => '',
											'value' => '3'
											)
										);

			### NO NEED TO CHANGE
							$plugin->install($languages_id);
			### NO NEED TO CHANGE
		}
	}


?>