<?php
/*
//--- plugin options START
This data will be used for installation.
#PLUGIN_KEY:REVIEWS
#PLUGIN_GROUP:LEFTRIGHT
#PLUGIN_DEFAULT_GROUP:RIGHT
#PLUGIN_NAME:Reviews
#PLUGIN_DESCRIPTION:Reviews Plugin!
//--- plugin options END
*/

	$PLUGIN_KEY = 'REVIEWS';

	if ( true !== $_ADMIN ) { ## Plugin init
		$init = init($PLUGIN_KEY); #initialize plugin

		if ( true === is_array($init['PLUGIN_OPTIONS']) ) {
			foreach ( $init['PLUGIN_OPTIONS'] as $option ) {
				$opt_var = $PLUGIN_KEY . '_'.$option['key'];
				$$opt_var = $option['value']; # eg; $REVIEWS_name
			}
		}



		if ( '0' == $REVIEWS_smart_display ||
			(
			basename($_SERVER['PHP_SELF']) !== FILENAME_REVIEWS  &&
			basename($_SERVER['PHP_SELF']) !== FILENAME_PRODUCT_REVIEWS  &&
			basename($_SERVER['PHP_SELF']) !== FILENAME_PRODUCT_REVIEWS_WRITE
			)
		)  {

		$REVIEWS_name = stripslashes($REVIEWS_name);
		$plugin_header = ( '1' == $REVIEWS_show_header ? $REVIEWS_name : '' );

		if ( false === is_numeric($REVIEWS_limit) || 100 < $REVIEWS_limit ) {
			$REVIEWS_limit = 5;
		}

		if ( false === empty($_GET['products_id']) || '1' == $REVIEWS_force_diplay) {
			$reviews_query_sql = "
						SELECT
							p.products_id,
							r.reviews_id,
							r.reviews_rating,
							p.products_image,
							p.products_image_stamp,
							p.products_image_thumb,
							p.products_price_groups,
							p.products_bundle,
							r.reviews_rating,
							pd.products_name,
							p.products_access,
							substring(rd.reviews_text, 1, 60) as reviews_text
						FROM
							" . TABLE_REVIEWS . " r,
							" . TABLE_REVIEWS_DESCRIPTION . " rd,
							" . TABLE_PRODUCTS . " p,
							" . TABLE_PRODUCTS_DESCRIPTION . " pd
						WHERE
							p.products_status = '1'
							AND p.products_id = r.products_id
							AND r.reviews_id = rd.reviews_id
							AND rd.languages_id = '$languages_id'
							AND p.products_id = pd.products_id
							AND pd.language_id = '$languages_id'
							AND r.status = '1'
							";
			if (isset($_GET['products_id']) && '1' == $REVIEWS_product_sensitive ) {
				$reviews_query_sql .= " and p.products_id = '" . (int)$_GET['products_id'] . "'";
			}


			switch ( $REVIEWS_sort_order ) {
				case 'name':
					$reviews_query_sql .= " ORDER BY pd.products_name";
				break;
				case 'name_desc':
					$reviews_query_sql .= " ORDER BY pd.products_name DESC";
				break;

				case 'date_added':
					$reviews_query_sql .= " ORDER BY r.date_added";
				break;

				case 'date_added_desc':
					$reviews_query_sql .= " ORDER BY r.date_added DESC";
				break;

				case 'random':
					$reviews_query_sql .= " ORDER BY RAND()";
				break;
			}
			$reviews_query_sql .= ' LIMIT '.$REVIEWS_limit ;
			$reviews_query = tep_db_query($reviews_query_sql);

			while ( $reviews = tep_db_fetch_array($reviews_query) ) {
				// products access
				if ( true === isset($reviews['products_access']) ) {
					$customer_access_ids = explode(',', $reviews['products_access']);
					$customers_group_id = ( true === empty($customers_group_id) ? '0' : $customers_group_id );
					if ( false === in_array($customers_group_id, $customer_access_ids)) {
						continue;
					}
				}
				$reviews_array['average_rating_image_src'] = TEMPLATE_IMAGES_DIR.tep_star_image_name($reviews['reviews_rating'], 'gif','SMALL' );
				$reviews_array['average_rating_image'] = tep_image($reviews_array['average_rating_image_src'], sprintf(TEXT_OF_5_STARS, $reviews['reviews_rating']));
				$reviews_array['url'] = tep_href_link(FILENAME_PRODUCT_REVIEWS_INFO, 'products_id=' . $reviews['products_id'] . '&reviews_id=' . $reviews['reviews_id']);
				$reviews_array['reviews_text'] = trim_words(stripslashes($reviews['reviews_text']), 59);
				$reviews_array['reviews_text'] = htmlspecialchars($reviews_array['reviews_text']);

				###################   IMAGE SPECIAL MOD
				$reviews['products_image_src'] = DIR_WS_IMAGES.$reviews['products_image'];
				if ( 'on' === IMAGE_STAMP_ON_OFF ) {
					if( $reviews['products_image_stamp'] ) {
						$reviews['products_image_src'] = generate_image_stamp($reviews['products_image_src'], DIR_WS_IMAGES.$reviews['products_image_stamp']);
					}
				}
				$plugin_products_reviews[$reviews['products_id']]['image'] = tep_image($reviews['products_image_src'], stripslashes($reviews['products_name']), SMALLER_IMAGE_WIDTH, SMALLER_IMAGE_HEIGHT, 'class="products_image_small"' );
				###################   IMAGE SPECIAL MOD

				$plugin_products_reviews[$reviews['products_id']]['name'] = htmlspecialchars(stripslashes($reviews['products_name']));
				$plugin_products_reviews[$reviews['products_id']]['url'] = tep_href_link(FILENAME_PRODUCT_REVIEWS, 'products_id=' . $reviews['products_id']);
				$plugin_products_reviews[$reviews['products_id']]['reviews'][] = $reviews_array;

			}

		}

		$plugin_url = ( '1' == $REVIEWS_show_url ? tep_href_link(FILENAME_REVIEWS) : '' );

		$plugins_info[$init['PLUGIN_KEY']] = array(
							'plugin_key' => $init['PLUGIN_KEY'],
							'plugin_name' => $REVIEWS_name,
							'plugin_header' => $plugin_header,
							'plugin_url' => $plugin_url,
							'plugin_products_reviews' => $plugin_products_reviews,
							'plugin_reviews_url' => tep_href_link(FILENAME_REVIEWS),

	);

	}

	} else { ## Plugin Installation:

		if ( 'install_plugin' == $_GET['action'] && $PLUGIN_KEY == $_POST['plugins_key'] ) {
			## SET UP DEFAULT OPTIONS (atleast 1 is required "name")
			$plugins_default_options_array = array(
										array(
											'name' => 'Name',
											'key' => 'name',
											'options' => '', // empty - textfield
											'value' => 'Product reviews'
											),
										array(
											'name' => 'Show header',
											'key' => 'show_header',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Show url',
											'description' => 'Show header as link ?',
											'key' => 'show_url',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Smart display',
											'description' => 'Hides reviews plugin under certain conditions (where it\'s not needed) <br />Recommended "On"',
											'key' => 'smart_display',
											'options' => array( '1'=>'On', '0'=>'Off' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Product sensitive',
											'description' => 'When user is viewing a product; available reviews will be shown specifically for that product',
											'key' => 'product_sensitive',
											'options' => array( '1'=>'On', '0'=>'Off' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Force Display',
											'description' => 'If set to \'On\' and there are no reviews to diplay for a particular product; any available review(s) will be shown in custom order.',
											'key' => 'force_diplay',
											'options' => array( '1'=>'On', '0'=>'Off' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Sort order',
											'key' => 'sort_order',
											'options' => array('date_added_desc'=>'Date added Desc', 'date_added'=>'Date added', 'name'=>'Name', 'name_desc'=>'Name Desc', 'random'=>'Random' ), // array - dropdown
											'value' => 'date_added_desc'
											),
										array(
											'name' => 'Limit',
											'key' => 'limit',
											'options' => '',
											'value' => '5'
											),
										);

			### NO NEED TO CHANGE
				$plugin->install($languages_id);
			### NO NEED TO CHANGE
		}
	}
?>