<?php
/*
//--- plugin options START
This data will be used for installation.
#PLUGIN_KEY:SHIPPING
#PLUGIN_GROUP:LEFTRIGHT
#PLUGIN_DEFAULT_GROUP:RIGHT
#PLUGIN_NAME:Shipping estimate
#PLUGIN_DESCRIPTION:Shipping estimate plugin
//--- plugin options END
*/

	$PLUGIN_KEY = 'SHIPPING';

	if ( true !== $_ADMIN ) { ## Plugin init
		$init = init($PLUGIN_KEY); #initialize plugin

		if ( true === is_array($init['PLUGIN_OPTIONS']) ) {
			foreach ( $init['PLUGIN_OPTIONS'] as $option ) {
				$opt_var = $PLUGIN_KEY . '_'.$option['key'];
				$$opt_var = $option['value']; # eg; $SHIPPING_name
			}
		}

		$SHIPPING_name = stripslashes($SHIPPING_name);
		$plugin_header = ( '1' == $SHIPPING_show_header ? $SHIPPING_name : '' );

		if ( $SHOPPING_CART_ITEMS_COUNT > 0 &&
				(false === strpos(basename($_SERVER['PHP_SELF']), 'checkout') &&
				false === strpos(basename($_SERVER['PHP_SELF']), 'shopping_cart'))
				) {
			@include_once ( DIR_WS_LANGUAGES . $language . '/' . FILENAME_SHIPPING_ESTIMATE );
			require_once ( DIR_WS_FUNCTIONS . 'shipping_estimate.php' );
			if ( true == tep_session_is_registered('country') && false === empty($_POST['country']) ) {
				$country = $_POST['country'];
			}

			if ( true == tep_session_is_registered('customer_id') && !tep_not_null($country) ) {
				$country = $customer_country_id;
			} elseif ( !tep_not_null($country) ) {
				$country = STORE_COUNTRY;
			}
			$shipping_estimated_quotes = tep_get_estimated_shipping_quotes($country,  $_GET['action'],$customer_country_id);
			$plugin_show_shipping = 'true';
			$plugin_text_description = ( '1' == $SHIPPING_show_description ? TEXT_SHIPPING_ESTIMATE_DESCRIPTION : '' );

		} elseif (tep_session_is_registered('country')) {
				tep_session_unregister('country');
		}

		$init['PLUGIN_TEXT'] = tep_insert_banners($init['PLUGIN_TEXT']);
		if ( 'SSL' === $request_type ) {
			$init['PLUGIN_TEXT'] = preg_replace('/http:\/\//', 'https://', $init['PLUGIN_TEXT']);
		}

		$plugins_info[$init['PLUGIN_KEY']] = array(
							'plugin_key' => $init['PLUGIN_KEY'],
							'plugin_name' => $SHIPPING_name,
							'plugin_header' => $plugin_header,
							'plugin_show_shipping' => $plugin_show_shipping,
							'merge_with_shopping_cart' => $SHIPPING_merge,
							'plugin_text_ship_to' => TEXT_COUNTRY_TO_SHIP_TO,
							'plugin_text_description' => $plugin_text_description,
							'shipping_output_form' => tep_draw_form('estimated_shipping', tep_href_link(basename($_SERVER['PHP_SELF'])), 'post'),
							'shipping_output_hidden' => tep_hide_session_id(),
							'shipping_country_list' => ( 'true' == 	ACCOUNT_COUNTRY ? tep_get_country_list('country', $country, 'onchange="this.form.submit();" style="width:160px;"') : '' ),
							'shipping_estimated_quotes' => $shipping_estimated_quotes
							);

	} else { ## Plugin Installation:

		if ( 'install_plugin' == $_GET['action'] && $PLUGIN_KEY == $_POST['plugins_key'] ) {
			## SET UP DEFAULT OPTIONS (atleast 1 is required "name")
			$plugins_default_options_array = array(
										array(
											'name' => 'Name',
											'key' => 'name',
											'options' => '', // empty - textfield
											'value' => 'Shipping estimate'
											),
										array(
											'name' => 'Show header',
											'key' => 'show_header',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Show description',
											'key' => 'show_description',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Merge with shopping cart',
											'key' => 'merge',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '0'
											),
										);

			### NO NEED TO CHANGE
				$plugin->install($languages_id);
			### NO NEED TO CHANGE
		}
	}

?>