<?php
/*
//--- plugin options START
This data will be used for installation.
#PLUGIN_KEY:SHOPPINGCART
#PLUGIN_GROUP:LEFTRIGHT
#PLUGIN_DEFAULT_GROUP:RIGHT
#PLUGIN_NAME:Shopping cart
#PLUGIN_DESCRIPTION:Mini shopping cart plugin!
//--- plugin options END
*/

	$PLUGIN_KEY = 'SHOPPINGCART';

	if ( true !== $_ADMIN ) { ## Plugin init
		$init = init($PLUGIN_KEY); #initialize plugin

		if ( true === is_array($init['PLUGIN_OPTIONS']) ) {
			foreach ( $init['PLUGIN_OPTIONS'] as $option ) {
				$opt_var = $PLUGIN_KEY . '_'.$option['key'];
				$$opt_var = $option['value']; # eg; $SHOPPINGCART_name
			}
		}

		if ( $SHOPPING_CART_ITEMS_COUNT > 0 &&
				(false === strpos(basename($_SERVER['PHP_SELF']), 'checkout') &&
				false === strpos(basename($_SERVER['PHP_SELF']), 'shopping_cart')) ||
				'0' == $SHOPPINGCART_smart_display
				) {
				$_SHOPPINGCART = $cart->get_products();
				$plugin_show_shopping_cart = 'true';
			} else {
				$plugin_show_shopping_cart = 'false';
			}

		if ( true === is_array($_SHOPPINGCART) ) {

			foreach ( $_SHOPPINGCART as $product ) {

				if ( '1' == $SHOPPINGCART_show_image ) {
					$product['image'] = DIR_WS_IMAGES . $product['image'];
					###################   IMAGE SPECIAL MOD
					if ( 'on' === IMAGE_STAMP_ON_OFF ) {
						if( $product['image_stamp'] ) {
							$product['image'] = generate_image_stamp($product['image'], DIR_WS_IMAGES.$product['image_stamp']);
						}
					}
					###################   IMAGE SPECIAL MOD
				}

				if ( '1' == $SHOPPINGCART_show_attr ) {
					if ( false === empty($product['attributes']) && is_array($product['attributes']) ) {
						while ( list($option, $value) = each($product['attributes']) ) {
							$attributes_sql = "
										SELECT
											poptd.products_options_name,
											popt.products_options_track_stock,
											poval.products_options_values_name,
											pa.options_values_price,
											pa.price_prefix,
											pa.products_attributes_image,
				          					pa.products_attributes_image_stamp
										FROM
											" . TABLE_PRODUCTS_OPTIONS . " popt,
											" . TABLE_PRODUCTS_OPTIONS_DESCRIPTION . " poptd,
											" . TABLE_PRODUCTS_OPTIONS_VALUES . " poval,
											" . TABLE_PRODUCTS_ATTRIBUTES . " pa
										WHERE
											pa.products_id = '" . $product['id'] . "'
											AND pa.options_id = '" . $option . "'
											AND pa.options_id = popt.products_options_id
											AND poptd.products_options_id = popt.products_options_id
											AND pa.options_values_id = '" . $value . "'
											AND pa.options_values_id = poval.products_options_values_id
											AND poptd.language_id = '$languages_id'";
							$attributes_query = tep_db_query($attributes_sql);

							$attributes_values = tep_db_fetch_array($attributes_query);
							$product['attribute'][$option]['products_options_name'] = $attributes_values['products_options_name'];
							$product['attribute'][$option]['products_options_values_name'] = $attributes_values['products_options_values_name'];
							$product['attribute'][$option]['options_values_price'] = $attributes_values['options_values_price'];
							$product['attribute'][$option]['price_prefix'] = $attributes_values['price_prefix'];
							$product['attribute'][$option]['options_price'] = $currencies->display_price($attributes_values['options_values_price'], 0);
							if ( $attributes_values['products_attributes_image'] && '1' == $SHOPPINGCART_show_image ) {
								$product['image'] = DIR_WS_IMAGES.$attributes_values['products_attributes_image'];
								###################   IMAGE SPECIAL MOD - ATTRIBUTES
								if ( 'on' === IMAGE_STAMP_ON_OFF ) {
									if( $attributes_values['products_attributes_image_stamp'] ) {
										$product['image'] = generate_image_stamp($product['image'], DIR_WS_IMAGES.$attributes_values['products_attributes_image_stamp']);
									}
								}
								###################   IMAGE SPECIAL MOD - ATTRIBUTES

							}
						}
					}
				}



				if ( '1' == $SHOPPINGCART_show_price ) {
					$product['tax'] = tep_get_tax_rate($product['tax_class_id']);
					$product['price'] = $currencies->display_price($product['final_price'], tep_get_tax_rate($product['tax_class_id']), $product['quantity']);
				} else {
					$product['price'] = false;
				}

				if ( '1' == $SHOPPINGCART_show_image ) { // should be here in case attribute has changed
					$product['image'] = tep_image($product['image'], $product['name'], SMALL_IMAGE_WIDTH/2, SMALL_IMAGE_HEIGHT/2, ' class="products_image_small"');
				} else {
					$product['image'] = false;
				}

				$product['url']  = tep_href_link(FILENAME_PRODUCT_INFO, 'products_id=' . $product['id']);
				$_CARTPRODUCTS[] = $product;
		    }


			$SHOPPINGCART_name = stripslashes($SHOPPINGCART_name);
			$plugin_header = ( '1' == $SHOPPINGCART_show_header ? $SHOPPINGCART_name : '' );
			$plugin_url = ( '1' == $SHOPPINGCART_show_url ? tep_href_link(FILENAME_SHOPPING_CART) : '' );

			if ( '1' == $SHOPPINGCART_show_products_count ) {
				$plugin_products_count = sprintf(TEXT_CART_CONTAINS, $SHOPPING_CART_ITEMS_COUNT);
			}

			$plugin_user_coupon = get_user_coupon();
			$smarty->assign('CART_COUPON', CART_COUPON);
			$smarty->assign('CART_COUPON_INFO', CART_COUPON_INFO);
			$smarty->assign('URL_POPUP_COUPON_HELP', tep_href_link(FILENAME_POPUP_COUPON_HELP, 'cID=' . $cc_id));

		    $plugins_info[$init['PLUGIN_KEY']] = array(
									'plugin_key' => $init['PLUGIN_KEY'],
									'plugin_name' => $SHOPPINGCART_name,
									'plugin_header' => $plugin_header,
									'plugin_url' => $plugin_url,
									'plugin_text_total' => TEXT_TOTAL,
									'plugin_text_saved' => TEXT_SAVED,
									'plugin_text_new_total' => TEXT_NEW_TOTAL,
									'plugin_text_price' => TEXT_PRICE,
									'plugin_show_products' => $SHOPPINGCART_show_products,
									'plugin_user_coupon' => $plugin_user_coupon,
									'plugin_products_count' => $plugin_products_count,
									'plugin_show_shopping_cart' => $plugin_show_shopping_cart,
									'shopping_cart_products' => $_CARTPRODUCTS,
									'shopping_cart_total' => ( '1' == $SHOPPINGCART_show_total ? $currencies->format($cart->show_total()) : '' ),
									'shopping_cart_url' => tep_href_link(FILENAME_SHOPPING_CART, '', 'NONSSL')

			);

		}


	} else { ## Plugin Installation:

		if ( 'install_plugin' == $_GET['action'] && $PLUGIN_KEY == $_POST['plugins_key'] ) {
			## SET UP DEFAULT OPTIONS (atleast 1 is required "name")
			$plugins_default_options_array = array(
										array(
											'name' => 'Name',
											'key' => 'name',
											'options' => '', // empty - textfield
											'value' => 'Shopping cart'
											),
										array(
											'name' => 'Show header',
											'key' => 'show_header',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Show url',
											'description' => 'Show header as link ?',
											'key' => 'show_url',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Show Products',
											'description' => 'Show products',
											'key' => 'show_products',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Show Products Count',
											'description' => 'Show products count',
											'key' => 'show_products_count',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '0'
											),
										array(
											'name' => 'Show Price',
											'description' => 'Show products price',
											'key' => 'show_price',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Show Total',
											'description' => 'Show products total price',
											'key' => 'show_total',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Show Image',
											'description' => 'Show products image',
											'key' => 'show_image',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Show Attr.',
											'description' => 'Show products attributes',
											'key' => 'show_attr',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Smart display',
											'description' => 'Hides shopping cart under certain conditions (where it\'s not needed) <br />Recommended "On"',
											'key' => 'smart_display',
											'options' => array( '1'=>'On', '0'=>'Off' ), // array - dropdown
											'value' => '1'
											),
										);

			### NO NEED TO CHANGE
				$plugin->install($languages_id);
			### NO NEED TO CHANGE
		}
	}

/**/

?>