<?php
/*
//--- plugin options START
This data will be used for installation.
#PLUGIN_KEY:TAGCLOUD
#PLUGIN_GROUP:LEFTRIGHT
#PLUGIN_DEFAULT_GROUP:RIGHT
#PLUGIN_NAME:Tag Cloud
#PLUGIN_DESCRIPTION:Tag Cloud Plugin.
//--- plugin options END
*/

	$PLUGIN_KEY = 'TAGCLOUD';

	if ( true !== $_ADMIN ) { ## Plugin init
		$init = init($PLUGIN_KEY); #initialize plugin

		if ( true === is_array($init['PLUGIN_OPTIONS']) ) {
			foreach ( $init['PLUGIN_OPTIONS'] as $option ) {
				$opt_var = $PLUGIN_KEY . '_'.$option['key'];
				$$opt_var = $option['value']; # eg; $TAGCLOUD_name
			}
		}

		$TAGCLOUD_name = stripslashes($TAGCLOUD_name);
		$plugin_header = ( '1' == $TAGCLOUD_show_header ? $TAGCLOUD_name : '' );

		function plg_get_tag_cloud($limit = 10, $tags_type, $sort) {
			if ( true === empty($limit) || false === is_numeric($limit) ) {
				$limit = 10;
			}

			switch ( $tags_type ) {
				case 'products':
					$tags = plg_get_products_tag_cloud_data($limit);
				break;

				default:
				case 'users':
					$tags_type = 'users';
					$tags = plg_get_users_tag_cloud_data($limit);
				break;
			}
			if ( false == $tags ) {
				return false;
			}
			switch ( $sort ) {
				case 'random':
					// shuffle() function didn't work as expected :(
					while ( 0 < count($tags) ) {
				        $val = array_rand($tags);
				        $new_arr[$val] = $tags[$val];
				        unset($tags[$val]);
				    }
				    $tags = $new_arr;
				break;
				default:
				case 'count':
					arsort($tags);
				break;
			}

			$max_size = 10;
			$min_size = 1;

			$max_qty = max(array_values($tags));
			$min_qty = min(array_values($tags));
			$spread = $max_qty - $min_qty;
			if ($spread == 0 ) {
				$spread = 1;
			}

			$step = ($max_size - $min_size) / ($spread);
			$return = '';
			foreach ($tags as $key => $value) {
				$size = round($min_size + (($value - $min_qty) * $step));
				$tagged_text = ( 'products' == $tags_type ? sprintf(TEXT_PRODUCT_TAGGED, $value, $key) : sprintf(TEXT_USER_TAGGED, $value, $key)  );
				$return .= '<a href="'.FILENAME_ADVANCED_SEARCH_RESULT . '?keywords='.$key . ( false === empty($_GET['osCsid']) ? '&osCsid='.$_GET['osCsid'] : '' ).'" class="tag' . $size . '" title="' . $tagged_text . '">' . $key . '</a> ';
			}
			return $return;
		}


		function plg_count_vowels($tag) {
			$count = 0;
			$tag = strtolower($tag);
			$tag_array = array();
			$nr = 0;
			while ( true === isset($tag{$nr}) ) {
				$tag_array[$nr] = $tag{$nr};
				$nr++;
			}
			for ($i = 0; $i <= count($tag_array); $i++ ) {
				switch( $tag_array[$i]) {
					case 'a': $count++; break;
					case 'e': $count++; break;
					case 'i': $count++; break;
					case 'o': $count++; break;
					case 'u': $count++; break;
				}
			}
			return $count;
		}

		function plg_capitalize_tag($tag) {
			$tag_array = explode(' ', $tag);
			if ( 1 < count($tag_array) ) {
				$tg_strong = '';
				foreach ( $tag_array as $tg ) {
					if ( 4 < strlen($tg) ) {
						$tg_strong .= ucwords($tg). ' ';
					} else {
						$vow = plg_count_vowels($tg);
						if ( 0 >= $vow ) {
							$tg_strong .= strtoupper($tg). ' ';
						} else {
							$tg_strong .= ucwords($tg). ' ';
						}
					}
				}
				return trim($tg_strong);
			} else {
				if ( 4 < strlen($tag) ) {
					return ucwords($tag);
				} else {
					$vow = plg_count_vowels($tag);
					if ( 0 >= $vow ) {
						return strtoupper($tag);
					} else {
						return ucwords($tag);
					}
				}
			}
		}

		function plg_get_users_tag_cloud_data($limit = 10) {
			global $languages_id, $encoding;
			if ( true === empty($limit) || false === is_numeric($limit) ) {
				$limit = 10;
			}
			$tag_cloud_query_sql = "SELECT
									t.tag,
									td.tag_hit_count
							FROM
								" . TABLE_TAGS . " t,
								" . TABLE_TAGS_DATA . " td
							WHERE
								t.tags_id = td.tags_id
								AND t.language_id = '$languages_id'
							ORDER BY
								tag_hit_count DESC
							LIMIT $limit";
			$tag_cloud_query = tep_db_query($tag_cloud_query_sql);
			if ( 0 < tep_db_num_rows($tag_cloud_query) ) {
				$tagcloud = array();
				while ( $tag_cloud = tep_db_fetch_array($tag_cloud_query) ) {
					$tag = $tag_cloud['tag'];
					if ( false !== $encoding && true === function_exists('iconv') ) {
						$tag = iconv('UTF-8', $encoding, $tag);
					}
					if ( $tag_cloud['tag'] === $tag ) {
						$tag = plg_capitalize_tag($tag);
					}
					$tagcloud[$tag] = $tag_cloud['tag_hit_count'];
				}
				return $tagcloud;
			} else {
				return false;
			}
		}

		function plg_get_products_tag_cloud_data($limit = 10) {
			global $encoding, $languages_id;
			if ( true === empty($limit) || false === is_numeric($limit) ) {
				$limit = 10;
			}
			$tag_cloud_query_sql = "SELECT
										tag,
										products_count
									FROM
										" . TABLE_TAGS . "
									WHERE
										language_id = '$languages_id'
									ORDER BY
										products_count DESC
									LIMIT $limit";
			$tag_cloud_query = tep_db_query($tag_cloud_query_sql);
			if ( 0 < tep_db_num_rows($tag_cloud_query) ) {
				$tagcloud = array();
				while ( $tag_cloud = tep_db_fetch_array($tag_cloud_query) ) {
					$tag = $tag_cloud['tag'];
					if ( false !== $encoding && true === function_exists('iconv') ) {
						$tag = iconv('UTF-8', $encoding, $tag);
					}
					if ( $tag_cloud['tag'] === $tag ) {
						$tag = plg_capitalize_tag($tag);
					}
					$tagcloud[$tag] = $tag_cloud['products_count'];
				}
				return $tagcloud;
			} else {
				return false;
			}
		}

		$plugin_tag_cloud = plg_get_tag_cloud($TAGCLOUD_tag_limit, $TAGCLOUD_tags_type, $TAGCLOUD_sort);

		$plugins_info[$init['PLUGIN_KEY']] = array(
							'plugin_key' => $init['PLUGIN_KEY'],
							'plugin_name' => $TAGCLOUD_name,
							'plugin_header' => $plugin_header,
							'plugin_tag_cloud' => $plugin_tag_cloud
							);

	} else { ## Plugin Installation:

		if ( 'install_plugin' == $_GET['action'] && $PLUGIN_KEY == $_POST['plugins_key'] ) {
			## SET UP DEFAULT OPTIONS (atleast 1 is required "name")
			$plugins_default_options_array = array(
										array(
											'name' => 'Name',
											'key' => 'name',
											'options' => '', // empty - textfield
											'value' => 'Tag Cloud'
											),
										array(
											'name' => 'Show header',
											'key' => 'show_header',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Tags sort',
											'key' => 'sort',
											'options' => array( 'count'=>'Count', 'random'=>'Random' ), // array - dropdown
											'value' => 'random'
											),
										array(
											'name' => 'Tags generated from',
											'key' => 'tags_type',
											'options' =>  array( 'users'=>'User clicks', 'products'=>'Products density' ), // array - dropdown
											'value' => 'users',
											'description' => '<strong>User clicks</strong> &mdash; tag cloud is based on how many times user clicked on a specific tag.<br /><br /><strong>Products density</strong> &mdash; tag cloud is based on how many tags are available per product.'
											),
										array(
											'name' => 'Tags limit',
											'key' => 'tag_limit',
											'options' => '', // empty - textfield
											'value' => '15'
											),
										);
			### NO NEED TO CHANGE
							$plugin->install($languages_id);
			### NO NEED TO CHANGE
		}
	}

/**/

?>