<?php
/*
//--- plugin options START
This data will be used for installation.
#PLUGIN_KEY:VIRTUALPRODUCTS
#PLUGIN_GROUP:CENTER
#PLUGIN_DEFAULT_GROUP:CENTER
#PLUGIN_NAME:Virtual Products
#PLUGIN_DESCRIPTION:Displays existing products in custom sort order.
//--- plugin options END
*/

	$PLUGIN_KEY = 'VIRTUALPRODUCTS';

	if ( true !== $_ADMIN ) { ## Plugin init
		$init = init($PLUGIN_KEY); #initialize plugin

		if ( true === is_array($init['PLUGIN_OPTIONS']) ) {
			foreach ( $init['PLUGIN_OPTIONS'] as $option ) {
				$opt_var = $PLUGIN_KEY . '_'.$option['key'];
				$$opt_var = $option['value']; # eg; $VIRTUALPRODUCTS_name
			}
		}

		if ( 'random' == $VIRTUALPRODUCTS_sort_order ) {
			$VIRTUALPRODUCTS_sort_order = "ORDER BY RAND()";
		} else {
			$VIRTUALPRODUCTS_sort_order = "ORDER BY v.sort_order, pd.products_name";
		}

		if ( true === empty($customers_group_id) || false === is_numeric($customers_group_id) ) {
			$customers_group_id = '0';
		}

		$products_query_sql = "
				SELECT
					p.products_id,
					p.products_quantity,
					p.products_model,
					p.products_image,
					p.products_image_thumb,
					p.products_image_stamp,
					p.products_price,
					p.products_price_hidden,
					p.products_ship_price,
					p.products_ship_price_two,
					p.average_rating,
					p.reviews_count,
					p.products_bundle,
					IF (s.status, s.specials_new_products_price, NULL)
						AS specials_new_products_price,
					IF (s.status, s.specials_new_products_price, p.products_price)
						AS final_price,
					IF (s.status, s.specials_text, NULL)
						AS price_special_text,
					p.products_date_added,
					p.products_last_modified,
					p.products_date_available,
					p.products_weight,
					p.products_status,
					p.products_tax_class_id,
					p.manufacturers_id,
					p.products_ordered,
					p.products_ship_price,
					p.products_length,
					p.products_width,
					p.products_height,
					p.products_ready_to_ship,
					p.products_to_rss,
					p.products_ship_price_two,
					p.sort_order,
					p.products_access,
					p.products_price_groups,
					pd.products_name,
					pd.products_description,
					m.manufacturers_name,
					m.manufacturers_image
				FROM
					virtual_display v,
					" . TABLE_PRODUCTS . " p
					LEFT JOIN
						" . TABLE_MANUFACTURERS . " m
					ON
						p.manufacturers_id = m.manufacturers_id
					LEFT JOIN
						" . TABLE_SPECIALS . " s
					ON (p.products_id = s.products_id AND s.customers_group_id = '$customers_group_id'),
					" . TABLE_PRODUCTS_DESCRIPTION . " pd

					WHERE
					v.category_cover_id = '0'
					AND v.virtual_display_type = 'product'
					AND p.products_id = v.products_id
					AND pd.products_id = p.products_id
					AND pd.language_id = '$languages_id'
				$VIRTUALPRODUCTS_sort_order
		";

		$virtual_products = fetchProducts($products_query_sql, false);

		$VIRTUALPRODUCTS_name = stripslashes($VIRTUALPRODUCTS_name);
		$plugin_header = ( '1' == $VIRTUALPRODUCTS_show_header ? $VIRTUALPRODUCTS_name : '' );
		$plugins_info[$init['PLUGIN_KEY']] = array(
							'plugin_key' => $init['PLUGIN_KEY'],
							'plugin_name' => $VIRTUALPRODUCTS_name,
							'plugin_header' => $plugin_header,
							'virtual_products' => $virtual_products
							);

	} else { ## Plugin Installation:

		if ( 'install_plugin' == $_GET['action'] && $PLUGIN_KEY == $_POST['plugins_key'] ) {
			## SET UP DEFAULT OPTIONS (atleast 1 is required "name")
			$plugins_default_options_array = array(
										array(
											'name' => 'Name',
											'key' => 'name',
											'options' => '', // empty - textfield
											'value' => 'Virtual products'
											),
										array(
											'name' => 'Show header',
											'key' => 'show_header',
											'options' => array( '1'=>'Yes', '0'=>'No' ), // array - dropdown
											'value' => '1'
											),
										array(
											'name' => 'Sort order',
											'key' => 'sort_order',
											'options' => array( 'custom'=>'Custom', 'random'=>'Random' ), // array - dropdown
											'value' => 'custom'
											),
										array(
											'name' => tep_image_button('mini_edit_products.gif' , ICON_EDIT_PRODUCTS),
											'key' => 'edit_products',
											'options' => 'hidden',
											'value' => 'plugin_key=' . $PLUGIN_KEY.'&action=show'
											),
										);

			### NO NEED TO CHANGE
							$plugin->install($languages_id);
			### NO NEED TO CHANGE
		}
	}

/**/
?>