<?php
	require_once('includes/functions/general.php');
	require_once('includes/functions/database.php');

	$exports = array();
	$exports['oscommerce'] = array(
					'name' => 'osCommerce',
					'version' => '2.2',
					'import_file' => 'oscommerce_import.php',
					'image' => 'images/oscommerce_import.jpg'
					);
	$exports['zencart'] = array(
					'name' => 'Zen Cart',
					'version' => 'Version 1.3.8',
					'import_file' => 'zencart_import.php',
					'image' => 'images/zencart_import.jpg'
					);

	$current_platform_id = $_GET['platform'];

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<title><?php echo $exports[$current_platform_id]['name']; ?> => eclime - database import</title>
<link rel="stylesheet" type="text/css" href="stylesheet/stylesheet.css" media="screen" />
<script language="javascript" src="includes/javascript/prototype.js" type="text/javascript"></script>
<script language="javascript" src="includes/javascript/scriptaculous/scriptaculous.js" type="text/javascript"></script>
<?php if ( false === empty($current_platform_id) ) { ?>
<script language="javascript" type="text/javascript">

dbimport = {};
dbimport.lock_count=2;
dbimport.connect = function(suffix){
		var div_id = 'test_connection_'+suffix;
		var database_server = $('database_server_'+suffix).value;
		var database_name = $('database_name_'+suffix).value;
		var database_username = $('database_username_'+suffix).value;
		var database_password = $('database_password_'+suffix).value;
		div_id.innerHTML = 'Connecting...';
		var updater = new Ajax.Updater(
			div_id,
			'includes/install_handler.php',
				{
					asynchronous:true,
					evalScripts:true,
					onComplete:function(request){
						new Effect.Opacity(div_id, {duration:1.0, from:0.1, to:1.0});
					},
					parameters:'?install_action=connect&suffix=' + suffix +
								'&database_server='+ database_server +
								'&database_name=' + database_name +
								'&database_username=' + database_username +
								'&database_password=' + database_password
				}
			);
}


dbimport.lock = function(suffix) {
	dbimport.lock_count++;
	$('btn_testconnection_'+suffix).value = 'Locked';
	$('btn_testconnection_'+suffix).disabled = true;
	$('database_server_'+suffix).disabled = true;
	$('database_name_'+suffix).disabled = true;
	$('database_username_'+suffix).disabled = true;
	$('database_password_'+suffix).disabled = true;
	$('unlock_connection_'+suffix).innerHTML='<input type="button" value="Unlock" onclick="dbimport.unlock(\''+suffix+'\');" />';
	if ( 2 == dbimport.lock_count ) {
		$('btn_final_import').disabled=false;
		$('btn_final_import').value = ' Import data now ';
	}
}

dbimport.unlock = function(suffix) {
	dbimport.lock_count--;
	$('btn_testconnection_'+suffix).value = 'Connect';
	$('btn_testconnection_'+suffix).disabled = false;
	$('database_server_'+suffix).disabled = false;
	$('database_name_'+suffix).disabled = false;
	$('database_username_'+suffix).disabled = false;
	$('database_password_'+suffix).disabled = false;
	$('unlock_connection_'+suffix).innerHTML='';
	$('test_connection_'+suffix).innerHTML='';
	if ( 2 != dbimport.lock_count ) {
		$('btn_final_import').disabled=true;
		$('btn_final_import').value = ' Import data now ';
	}
}

dbimport.init = function (){
	dbimport.unlock('to');
	dbimport.unlock('from');

}
dbimport.import_success = function () {
	$('btn_final_import').value = 'Done!';
}

dbimport.import_data = function () {

	var conf = confirm('!!! WARNING !!! \nDO NOT PLAY AROUND WITH LIVE DATA!!!\nBACK UP EVERYTHING!');
	if ( !conf ) {
		return false;
	}

	var div_id = 'final_import';
	$('btn_final_import').disabled = true;
	$('btn_final_import').value = ' Importing data... Please wait!';

	var database_server_from = $('database_server_from').value;
	var database_name_from = $('database_name_from').value;
	var database_username_from = $('database_username_from').value;
	var database_password_from = $('database_password_from').value;

	var database_server_to = $('database_server_to').value;
	var database_name_to = $('database_name_to').value;
	var database_username_to = $('database_username_to').value;
	var database_password_to = $('database_password_to').value;

	var updater = new Ajax.Updater(
			div_id,
			'includes/install_handler.php',
				{
					asynchronous:true,
					evalScripts:true,
					onComplete:function(request){
						new Effect.Opacity(div_id, {duration:1.0, from:0.1, to:1.0});
					},
					parameters:'?install_action=import_data&' +
								'&database_server_from='+ database_server_from +
								'&database_name_from=' + database_name_from +
								'&database_username_from=' + database_username_from +
								'&database_password_from=' + database_password_from +

								'&database_server_to='+ database_server_to +
								'&database_name_to=' + database_name_to +
								'&database_username_to=' + database_username_to +
								'&database_password_to=' + database_password_to +
								'&include_file=<?php echo $exports[$current_platform_id]['import_file']; ?>'
				}
			);
}


Event.observe(window, 'load', dbimport.init, false);

</script>
<?php } ?>
</head>

<body>
<?php
	if ( true === is_array($exports) && true === empty($_GET['platform'])) {
		echo '<div style="padding:0.5em; text-align:center;">';
			foreach ( $exports as $key => $export ) {
				echo '<a href="'.$_SERVER['PHP_SELF'].'?platform='.$key.'"><img src="'.$export['image'].'" border="0" alt="'.$export_info['name'].' to eclime database import" /></a>';
				echo '<br />';
			}
		echo '</div>';
	}
	if ( false === empty($current_platform_id) ) {
		echo '<h3><img src="'.$exports[$current_platform_id]['image'].'" border="0" alt="'.$exports[$current_platform_id]['name'].' to eclime database import" /><br />' . $exports[$current_platform_id]['name'] . ' - ' .  $exports[$current_platform_id]['version']  . ' to eclime Database import<br /><small><a href="'.$_SERVER['PHP_SELF'].'">Choose other platform</a><small></h3>';

?>

<table cellpadding="5" cellspacing="2" width="800" align="center" border="0" style="border:1px solid #DDDDDD;">
	<tr>
		<th width="50%" style="background-color:#DDDDDD;"><?php echo $exports[$current_platform_id]['name']; ?> database</th>
		<th width="50%" style="background-color:#DDDDDD;">eclime database</th>
	</tr>
	<tr>
		<td width="50%">
		<div class="cssform_import">
		<form action="index.php" method="post">
		<p>Please enter the database server information:</p>
			<p>
				<label for="database_server_from">Database server:</label>
				<input type="text" name="database_server_from" id="database_server_from" class="inputNormal" value="<?php echo $database_server_from; ?>" /> e.g: localhost
			</p>

			<p>
				<label for="database_name_from">Database name:</label>
				<input type="text" name="database_name_from" id="database_name_from" class="inputNormal" value="<?php echo $database_name_from; ?>" />
			</p>

			<p>
				<label for="database_username_from">Database username:</label>
				<input type="text" name="database_username_from" id="database_username_from" class="inputNormal" value="<?php echo $database_username_from; ?>" />
			</p>

			<p>
				<label for="database_password_from">Database password:</label>
				<input type="password" name="database_password_from" id="database_password_from" class="inputNormal" value="<?php echo $database_password_from; ?>" />
			</p>
			<p>
				<label for="test_connection_from">&nbsp;</label>
				<input type="button" value="Connect &raquo;" onclick="javascript:dbimport.connect('from');" id="btn_testconnection_from" />&nbsp;<span id="unlock_connection_from" style="text-aligh:center;"></span><span id="test_connection_from" style="text-aligh:center;"></span>
			</p>
		</form>
		</div>
		</td>
		<td width="50%">
		<div class="cssform_import">
		<form action="index.php" method="post">
		<p>Please enter the database server information:</p>
			<p>
				<label for="database_server_to">Database server:</label>
				<input type="text" name="database_server_to" id="database_server_to" class="inputNormal" value="<?php echo $database_server_to; ?>" /> e.g: localhost
			</p>

			<p>
				<label for="database_name_to">Database name:</label>
				<input type="text" name="database_name_to" id="database_name_to" class="inputNormal" value="<?php echo $database_name_to; ?>" />
			</p>

			<p>
				<label for="database_username_to">Database username:</label>
				<input type="text" name="database_username_to" id="database_username_to" class="inputNormal" value="<?php echo $database_username_to; ?>" />
			</p>

			<p>
				<label for="database_password_to">Database password:</label>
				<input type="password" name="database_password_to" id="database_password_to" class="inputNormal" value="<?php echo $database_password_to; ?>" />
			</p>
			<p>
				<label for="test_connection_to">&nbsp;</label>
				<input type="button" value="Connect &raquo;" onclick="javascript:dbimport.connect('to');" id="btn_testconnection_to" />&nbsp;<span id="unlock_connection_to" style="text-aligh:center;"></span><span id="test_connection_to" style="text-aligh:center;"></span>
			</p>
		</form>
		</div>

		</td>
	</tr>
	<tr>
		<td colspan="2" align="center">
			<input type="button" name="import" id="btn_final_import" value="Import" disabled="disabled" onclick="dbimport.import_data();" />
			<div id="final_import"></div>
		</td>
	</tr>
</table>

<?php
	}
?>

</body>

</html>
