<?php
	function testDbConnection($database_server, $database_username, $database_password) {
		if ( true === empty($database_server) || true === empty($database_username) || true === empty($database_password) ) {
			return false;
		}

		$link = @mysql_connect($database_server, $database_username, $database_password);

		if ( false === $link ) {
			return false;
		} else {
			return true;
		}
	}

	function testDbSelect($database_server, $database_name, $database_username, $database_password) {
		if ( true === empty($database_server) || true === empty($database_name) || true === empty($database_username) || true === empty($database_password) ) {
			return false;
		}

		$link = @mysql_connect($database_server, $database_username, $database_password);

		if ( false === $link ) {
			return false;
		} else {
			return @mysql_select_db($database_name, $link);
		}
	}

// Return a random value
  function tep_rand($min = null, $max = null) {
    static $seeded;

    if (!$seeded) {
      mt_srand((double)microtime()*1000000);
      $seeded = true;
    }

    if (isset($min) && isset($max)) {
      if ($min >= $max) {
        return $min;
      } else {
        return mt_rand($min, $max);
      }
    } else {
      return mt_rand();
    }
  }

    function tep_create_random_value($length, $type = 'mixed') {
    if ( ($type != 'mixed') && ($type != 'chars') && ($type != 'digits')) return false;

    $rand_value = '';
    while (strlen($rand_value) < $length) {
      if ($type == 'digits') {
        $char = tep_rand(0,9);
      } else {
        $char = chr(tep_rand(0,255));
      }
      if ($type == 'mixed') {
        if (eregi('^[a-z0-9]$', $char)) $rand_value .= $char;
      } elseif ($type == 'chars') {
        if (eregi('^[a-z]$', $char)) $rand_value .= $char;
      } elseif ($type == 'digits') {
        if (ereg('^[0-9]$', $char)) $rand_value .= $char;
      }
    }

    return $rand_value;
  }

// This function makes a new password from a plaintext password.
  function tep_encrypt_password($plain) {
    $password = '';

    for ($i=0; $i<10; $i++) {
      $password .= tep_rand();
    }

    $salt = substr(md5($password), 0, 2);

    $password = md5($salt . $plain) . ':' . $salt;

    return $password;
  }

  function php_info_array(){
		ob_start();
		phpinfo();
		$phpinfo = array('phpinfo' => array());
		if(preg_match_all('#(?:<h2>(?:<a name=".*?">)?(.*?)(?:</a>)?</h2>)|(?:<tr(?: class=".*?")?><t[hd](?: class=".*?")?>(.*?)\s*</t[hd]>(?:<t[hd](?: class=".*?")?>(.*?)\s*</t[hd]>(?:<t[hd](?: class=".*?")?>(.*?)\s*</t[hd]>)?)?</tr>)#s', ob_get_clean(), $matches, PREG_SET_ORDER))
		foreach($matches as $match)
		if(strlen($match[1]))
		$phpinfo[$match[1]] = array();
		elseif(isset($match[3]))
		$phpinfo[end(array_keys($phpinfo))][$match[2]] = isset($match[4]) ? array($match[3], $match[4]) : $match[3];
		else
		$phpinfo[end(array_keys($phpinfo))][] = $match[2];

		return $phpinfo;
	}


	function installation_requirements() {
		$errors = array();

		$errors['count'] = 0;

		if ( false === is_writable('../configure/') ) {
			if ( false === @chmod('../configure/', 777) ) {
				$errors['count']++;
				$errors['message'] .= 'Dir: configure/ is not writable. <br />';
			}
		}

		if ( false === is_writable('../templates_c/') ) {
			if ( false === @chmod('../templates_c/', 777) ) {
				$errors['count']++;
				$errors['message'] .= 'Dir: templates_c/ is not writable. <br />';
			}
		}

		if ( false === is_writable('../images/') ) {
			if ( false === @chmod('../images/', 777) ) {
				$errors['count']++;
				$errors['message'] .= 'Dir: images/ is not writable. <br />';
			}
		}

		if ( false === is_writable('../temp/') ) {
			if ( false === @chmod('../temp/', 777) ) {
				$errors['count']++;
				$errors['message'] .= 'Dir: temp/ is not writable. <br />';
			}
		}

		if ( false === is_writable('../cache/') ) {
			if ( false === @chmod('../cache/', 777) ) {
				$errors['count']++;
				$errors['message'] .= 'Dir: cache/ is not writable. <br />';
			}
		}

		if ( false === is_writable('../sessions/') ) {
			if ( false === @chmod('../sessions/', 777) ) {
				$errors['count']++;
				$errors['message'] .= 'Dir: sessions/ is not writable. <br />';
			}
		}

		if ( false === is_writable('../admin/backups/') ) {
			if ( false === @chmod('../admin/backups/', 777) ) {
				$errors['count']++;
				$errors['message'] .= 'Dir: admin/backups/ is not writable. <br />';
			}
		}

		if ( false === is_writable('../admin/images/graphs/') ) {
			if ( false === @chmod('../admin/images/graphs/', 777) ) {
				$errors['count']++;
				$errors['message'] .= 'Dir: admin/images/graphs/ is not writable. <br />';
			}
		}
		return $errors;

	}



  function write_configure_files($params) {

  	$catalog_configure = '../configure/catalog_configure.php';
  	$admin_configure = '../configure/admin_configure.php';

  	if (true === file_exists($catalog_configure) ) {
		if ( false === is_writable($catalog_configure) ) {
			return false;
		}
  	}

  	if (true === file_exists($admin_configure) ) {
		if ( false === is_writable($admin_configure) ) {
			return false;
		}
  	}

	if (!$c_handle = fopen($catalog_configure, 'w')) {
		//echo "Cannot open file ($filename)";
		return false;
    	}
    	if (!$a_handle = fopen($admin_configure, 'w')) {
		//echo "Cannot open file ($filename)";
		return false;
    	}

    	$CAPTCHA_ENCRYPTION_KEY = tep_create_random_value(40);
    	
    	$params['http_server_absolute']=('/'!==substr($params['http_server_absolute'], -1)?$params['http_server_absolute'].'/':$params['http_server_absolute']);

  	$catalog_configure_content =
	"<?php\n\n" .
  	"\tdefine('ENABLE_SSL', false); // secure webserver for checkout procedure?\n" .
	"\tdefine('HTTP_SERVER', '{$params['http_server']}'); // eg, http://localhost - should not be empty for productive servers\n" .
	"\tdefine('HTTPS_SERVER', ''); // eg, https://localhost - should not be empty for productive servers\n" .
	"\tdefine('HTTP_COOKIE_DOMAIN', '{$params['cookie_domain']}');\n" .
	"\tdefine('HTTPS_COOKIE_DOMAIN', '');\n" .
	"\tdefine('HTTP_COOKIE_PATH', '{$params['http_catalog']}');\n" .
	"\tdefine('HTTPS_COOKIE_PATH', '');\n" .
	"\tdefine('DIR_WS_HTTP_CATALOG', '{$params['http_catalog']}');\n" .
	"\tdefine('DIR_WS_HTTPS_CATALOG', '');\n" .
	"\tdefine('DIR_WS_IMAGES', 'images/');\n" .
	"\tdefine('DIR_WS_IMAGES_THUMBNAILS', DIR_WS_IMAGES.'thumbnails/');\n" .
	"\tdefine('DIR_WS_ICONS', DIR_WS_IMAGES . 'icons/');\n" .
	"\tdefine('DIR_WS_INCLUDES', 'includes/');\n" .
	"\tdefine('DIR_WS_BOXES', DIR_WS_INCLUDES . 'boxes/');\n" .
	"\tdefine('DIR_WS_FUNCTIONS', DIR_WS_INCLUDES . 'functions/');\n" .
	"\tdefine('DIR_WS_CLASSES', DIR_WS_INCLUDES . 'classes/');\n" .
	"\tdefine('DIR_WS_MODULES', DIR_WS_INCLUDES . 'modules/');\n" .
	"\tdefine('DIR_WS_PLUGINS', DIR_WS_INCLUDES . 'plugins/');\n" .
	"\tdefine('DIR_WS_LANGUAGES', DIR_WS_INCLUDES . 'languages/');\n\n" .

	"\tdefine('DIR_WS_DOWNLOAD_PUBLIC', 'pub/');\n" .
	"\tdefine('DIR_FS_CATALOG', '{$params['http_server_absolute']}');\n" .
	"\tdefine('DIR_FS_DOWNLOAD', DIR_FS_CATALOG . 'download/');\n" .
	"\tdefine('DIR_FS_DOWNLOAD_PUBLIC', DIR_FS_CATALOG . 'pub/');\n" .
	"\tdefine('CAPTCHA_ENCRYPTION_KEY', '".$CAPTCHA_ENCRYPTION_KEY."');\n\n" .

	"\tdefine('IMG_STAMP_FILENAME_PREFIX', 'img_pr_');\n" .
	"\tdefine('SMARTY_DIR',DIR_WS_INCLUDES.'smarty/');\n" .
	"\tdefine('SMARTY_TEMPLATES_DIR','templates/');\n" .

	"\tdefine('DB_SERVER', '{$params['database_server']}'); // eg, localhost - should not be empty for productive servers\n" .
	"\tdefine('DB_SERVER_USERNAME', '{$params['database_username']}');\n" .
	"\tdefine('DB_SERVER_PASSWORD', '{$params['database_password']}');\n" .
	"\tdefine('DB_DATABASE', '{$params['database_name']}');\n" .
	"\tdefine('USE_PCONNECT', 'false'); // use persistent connections?\n" .
	"\tdefine('STORE_SESSIONS', 'mysql'); // leave empty '' for default handler or set to 'mysql'" .
	"\n\n?>";

	if (@fwrite($c_handle, $catalog_configure_content) === false) {
        //echo "Cannot write to file ($catalog_configure)";
        return false;
    }


	$admin_configure_content =

	"<?php\n\n" .
      "\tdefine('HTTP_SERVER', '".$params['http_server'].substr($params['http_catalog'], 0, -1)."'); // eg, http://localhost - should not be empty for productive servers\n" .
	 "\tdefine('HTTP_CATALOG_SERVER', '".$params['http_server'].substr($params['http_catalog'], 0, -1)."');\n" .
	 "\tdefine('HTTPS_CATALOG_SERVER', '');\n" .
	 "\tdefine('ENABLE_SSL_CATALOG', false); // secure webserver for catalog module\n" .
	 "\tdefine('DIR_FS_DOCUMENT_ROOT', '{$params['http_server_absolute']}'); // where the pages are located on the server\n" .
	 "\tdefine('DIR_WS_ADMIN', '/admin/'); // absolute path required\n" .
	 "\tdefine('DIR_FS_ADMIN', '{$params['http_server_absolute']}admin/'); // absolute pate required\n" .
	 "\tdefine('DIR_WS_CATALOG', '/'); // absolute path required\n" .
	 "\tdefine('DIR_FS_CATALOG', '{$params['http_server_absolute']}'); // absolute path required\n" .
	 "\tdefine('DIR_WS_IMAGES', 'images/');\n" .
	 "\tdefine('DIR_WS_ICONS', DIR_WS_IMAGES . 'icons/');\n" .
	 "\tdefine('DIR_WS_CATALOG_IMAGES', '../images/');\n\n" .

	 "\tdefine('SMARTY_DIR', DIR_FS_CATALOG . 'includes/smarty/');\n" .
	 "\tdefine('SMARTY_TEMPLATES_DIR', DIR_FS_CATALOG . 'templates/');\n\n" .

	 "\tdefine('DIR_WS_INCLUDES', 'includes/');\n" .
	 "\tdefine('DIR_WS_BOXES', DIR_WS_INCLUDES . 'boxes/');\n" .
	 "\tdefine('DIR_WS_FUNCTIONS', DIR_WS_INCLUDES . 'functions/');\n" .
	 "\tdefine('DIR_WS_CLASSES', DIR_WS_INCLUDES . 'classes/');\n" .
	 "\tdefine('DIR_WS_MODULES', DIR_WS_INCLUDES . 'modules/');\n" .
	 "\tdefine('DIR_WS_PLUGINS', '../'.DIR_WS_INCLUDES . 'plugins/');\n\n" .

	 "\tdefine('DIR_WS_LANGUAGES', DIR_WS_INCLUDES . 'languages/');\n" .
	 "\tdefine('DIR_WS_CATALOG_LANGUAGES', DIR_WS_CATALOG . 'includes/languages/');\n" .
	 "\tdefine('DIR_FS_CATALOG_LANGUAGES', DIR_FS_CATALOG . 'includes/languages/');\n" .
	 "\tdefine('DIR_FS_CATALOG_IMAGES', DIR_FS_CATALOG . 'images/');\n" .
	 "\tdefine('DIR_FS_CATALOG_IMAGES_THUMBNAILS', DIR_WS_CATALOG_IMAGES . 'thumbnails/');\n\n" .

	 "\tdefine('IMG_STAMP_FILENAME_PREFIX', 'img_pr_');\n\n" .

	 "\tdefine('DIR_FS_CATALOG_MODULES', DIR_FS_CATALOG . 'includes/modules/');\n" .
	 "\tdefine('DIR_FS_BACKUP', DIR_FS_ADMIN . 'backups/');\n" .
	 "\tdefine('DIR_FS_FCKEDITOR', DIR_FS_ADMIN . 'ckeditor/');\n" .
	 "\tdefine('DIR_WS_CKEDITOR', HTTP_SERVER . DIR_WS_ADMIN . DIR_WS_INCLUDES . 'ckeditor/');\n\n" .
	 "\tdefine('CAPTCHA_ENCRYPTION_KEY', '".$CAPTCHA_ENCRYPTION_KEY."');\n\n" .

	 "\tdefine('DB_SERVER', '{$params['database_server']}'); // eg, localhost - should not be empty for productive servers\n" .
	 "\tdefine('DB_SERVER_USERNAME', '{$params['database_username']}');\n" .
	 "\tdefine('DB_SERVER_PASSWORD', '{$params['database_password']}');\n" .
	 "\tdefine('DB_DATABASE', '{$params['database_name']}');\n" .
	 "\tdefine('USE_PCONNECT', 'false'); // use persistent connections?\n" .
	 "\tdefine('STORE_SESSIONS', 'mysql'); // leave empty '' for default handler or set to 'mysql'\n" .
	 "\n\n?>";

	 if (@fwrite($a_handle, $admin_configure_content) === false) {
        //echo "Cannot write to file ($admin_configure)";
        return false;
    }


    fclose($c_handle);
    fclose($a_handle);

    return true;

  }

  function import_standard_table($table_name, $params, $exceptions = '', $custom_fields = '' ) {

		/*
			example:
			$exceptions = array(
					array('action'=>'add', 'field'=>'field_name', 'value'=>'1'),
					array('action'=>'remove', 'field'=>'field_name'),
			);
		*/
		$sel = '';
		if ( true === is_array($custom_fields) ){
			foreach ( $custom_fields as $custom_field ) {
				if ( true === is_array($custom_field) ) {
					$sel .= $custom_field['rename_from'] . ' AS ' . $custom_field['rename_to'].',';
				} else {
					$sel .= $custom_field.',';
				}
			}
			$sel = substr($sel, 0, -1);
		} else {
			$sel='*';
		}
		$query_sql = "SELECT $sel FROM `$table_name`";
		mysql_select_db($params['db_name_from'], $params['db_from']);
		$query = mysql_query($query_sql, $params['db_from']);
		if ( 0 < osc_db_num_rows($query) ) {
			$import_sql = "INSERT INTO `$table_name` ";
			$insert_keys = '';
			$insert_vals = '';
			while ( $result = osc_db_fetch_array($query) ) {
				if ( true === empty($insert_keys) ) {
					foreach ( $result as $key => $val ) {
						if ( false === is_int($key) ) {
							if ( true === is_array($exceptions) ) {
								$insert_keys .= "`$key`,";
								foreach ( $exceptions as $exception ) {
									if ( 'add' == $exception['action'] && false === strstr($insert_keys, $exception['field'] )) {
										$insert_keys .= "`{$exception['field']}`,";
									}
								}
							} else {
								$insert_keys .= "`$key`,";
							}
						}
					}
					$insert_keys = substr($insert_keys, 0, -1);
					$import_sql .= "( $insert_keys ) VALUES ";
				}
				foreach ( $result as $key => $val ) {
					if ( false === is_int($key) ) {
						if ( true === is_array($exceptions) ) {
							$insert_vals .= "'".addslashes($val)."',";
							if ( true != $inserted_extra_vals ) {
								foreach ( $exceptions as $exception ) {
									if ( 'add' == $exception['action'] ) {
										$insert_vals .= "'".addslashes($exception['value'])."',";
									}
									$inserted_extra_vals = true;
								}
							}
						} else {
							$insert_vals .= "'".addslashes($val)."',";
						}

					}
				}

				$insert_vals = substr($insert_vals, 0, -1);
				$import_sql .= "($insert_vals),\n";
				$insert_vals = '';
				$inserted_extra_vals = false;

			}
			$import_sql = substr($import_sql, 0, -2);
			mysql_select_db($params['db_name_to'], $params['db_to']);
			$deleted = mysql_query("DELETE FROM `$table_name` WHERE 1", $params['db_to']);
			if ( $deleted ) {
				$inserted = mysql_query($import_sql, $params['db_to']);
			} else {
				echo "Error: Unable to delete from `$table_name`.<br />";
			}
			if ( $inserted ) {
				echo "Table `$table_name` - Successfully imported.<br />";
			} else {
				echo "Error: unable to insert into: `$table_name`.<br />";
				echo "<textarea cols=\"50\" rows=\"10\">$import_sql</textarea>";
				echo '<br /><strong>'.mysql_error($params['db_to']).'</strong><br />';
			}
		} else {
			mysql_select_db($params['db_name_to'], $params['db_to']);
			$deleted = mysql_query("DELETE FROM `$table_name` WHERE 1", $params['db_to']);
			echo "<strong>Table `$table_name` - Empty, nothing imported</strong>.<br />";
		}
	}

	function import_standard_store_config($params) {
		$query_sql = "SELECT * FROM `configuration`";
		mysql_select_db($params['db_name_from'], $params['db_from']);
		$query = mysql_query($query_sql, $params['db_from']);
		if ( 0 < osc_db_num_rows($query) ) {
			while ( $result = osc_db_fetch_array($query) ) {
				$config_import_from_array[] = $result;
			}
		}
		if ( true === is_array($config_import_from_array) ) {
			mysql_select_db($params['db_name_to'], $params['db_to']);
			foreach ( $config_import_from_array as $config_import_from ) {
				$sql = "UPDATE configuration SET configuration_value='{$config_import_from['configuration_value']}', last_modified=NOW() WHERE configuration_key = '{$config_import_from['configuration_key']}'";
				$updated = mysql_query($sql);
				if ( true == $updated && mysql_affected_rows() >= 1 ) {
					$updated_list .= "<i>Configuration: '{$config_import_from['configuration_key']}' was updated to => '{$config_import_from['configuration_value']}'</i><br />";
				}
			}
			echo $updated_list;
		}
	}
	
	
	function replaceLine($file, $pattern, $replacement) {
    if ( false === file_exists($file) || false === is_writable($file) ) {
    	return false;
    } else {
        $f = file($file);
        $content = '';
        foreach($f as $line_num => $line){
        	if(eregi($pattern, $line)) {
        		$content .= $replacement . "\n";
        	} else {
        		$content .= $line;
        	}
        }
        $fi = fopen($file, "w");
        fwrite($fi, $content);
        fclose($fi);
        return true;
    }
}

?>