<?php

	if ( !$_POST ) {
		exit();
	}

	require_once('functions/general.php');
	switch ($_POST['install_action']) {
		case 'test_connection':
		case 'connect':
			$database_server = $_POST['database_server'];
			$database_name = $_POST['database_name'];
			$database_username = $_POST['database_username'];
			$database_password = $_POST['database_password'];
			$suffix = $_POST['suffix'];

			$errors['count'] = 0;

			if ( true === empty($database_server) ) {
				$error['count']++;
				$error['message'] .= "<br />Database server is empty.";
			}

			if ( true === empty($database_name) ) {
				$error['count']++;
				$error['message'] .= "<br />Database name is empty.";
			}

			if ( true === empty($database_username) ) {
				$error['count']++;
				$error['message'] .= "<br />Database username is empty.";
			}

			if ( true === empty($database_password) ) {
				$error['count']++;
				$error['message'] .= "<br />Database password is empty.";
			}

			if ( 0 < $error['count'] ) {
				echo '<span class="error">'.$error['message'].'</span>';
			} else {

				$db_connection = testDbConnection($database_server,$database_username,$database_password);

				if ( false === $db_connection ) {
					echo '<span class="error">Failed to connect!</span>';
				} else {
					$db_select = testDbSelect($database_server,$database_name,$database_username,$database_password);
					if ( false === $db_select ) {
						echo "<span class=\"error\"><br />Connected to database. Failed selecting '$database_name' database</span> ";
					} else {
						echo '<span class="success">Successfully connected!</span>';
						if ( 'connect' == $_POST['install_action'] ) {
							echo '<script language="javascript" type="text/javascript">dbimport.lock(\''.$suffix.'\');</script>';
						} else {
							echo '<script language="javascript" type="text/javascript">connected();</script>';
						}
					}


				}

			}
		break;
		case 'import_data':
			if ( false === file_exists($_POST['include_file']) ) {
				die('Error: Import file does not exists!');
			}
			require_once ($_POST['include_file']);

			$imported = import($_POST);

			if ( true === $imported ) {
				echo "Hooray! The database was successfuly imported!";
				echo '<script language="javascript" type="text/javascript">dbimport.import_success();</script>';
			} else {
				echo "Failed! The database was not imported.";
			}
		break;

		case 'enable_seo_urls':
			chdir('../../');
			require_once ( 'configure/catalog_configure.php' );
			$seo_enabled = false;
			if ( true === defined('DIR_WS_HTTP_CATALOG') ) {
				require_once ( DIR_WS_FUNCTIONS . 'database.php');
				$update_query_sql = "UPDATE configuration SET configuration_value = 'true' WHERE configuration_key = 'SEO_URLS'";
				if ( '/' != DIR_WS_HTTP_CATALOG ) {
					$replaced = replaceLine('.htaccess', '#RewriteBase \/', '#RewriteBase '.DIR_WS_HTTP_CATALOG);
					if ( true === $replaced ) {
						
						$seo_enabled = ( tep_db_query($update_query_sql) ? true : false );
					}
				} else {
					$seo_enabled = ( tep_db_query($update_query_sql) ? true : false );
				}
			}
			if ( true === $seo_enabled ) {
				echo '<script type="text/javascript">$(\'seo_urls\').innerHTML=\'SEO URLs Enabled\';$(\'seo_urls\').style.display=\'block\';</script>';
			}
		break;
	}




?>
