<?php

	require_once('includes/functions/general.php');
	require_once('includes/functions/database.php');

	if ( 'true' != $_GET['install_success'] ) {
		if ( true === file_exists('../configure/catalog_configure.php') ) {
			@include_once('../configure/catalog_configure.php');
		}
		if ( true === defined('DB_SERVER') && true === defined('DB_SERVER_USERNAME') &&
			true === defined('DB_SERVER_PASSWORD') && true === defined('DB_DATABASE')) {
				if ( true === testDbSelect(DB_SERVER, DB_DATABASE, DB_SERVER_USERNAME, DB_SERVER_PASSWORD) ) {
					header ('Location: index.php?install_success=true');
				}
		}
	} else {
		if ( false === file_exists('../configure/catalog_configure.php') || false === file_exists('../configure/admin_configure.php') ) {
			header ('Location: index.php');
		}
	}

	$requirements = installation_requirements();
	if ( true === is_array($_POST) ) {
		foreach ( $_POST as $key => $post ) {
			$$key = $post;
		}
	}

	$install_success = $_GET['install_success'];
	$cookie_domain = ( false === empty($cookie_domain) ? $cookie_domain : $_SERVER['HTTP_HOST'] );
	$http_catalog_default = dirname(str_replace('/install', '', $_SERVER['PHP_SELF'])).'/';
	if ( '//' === $http_catalog_default ) {
		$http_catalog_default = '/';
	}
	$http_server = ( false === empty($http_server) ? $http_server : 'http://'.$_SERVER['HTTP_HOST'] );
	$http_catalog = ( false === empty($http_catalog) ? $http_catalog : $http_catalog_default );
	$http_server_absolute_default = str_replace("\\","/", realpath('../'));
	$http_server_absolute = ( false === empty($http_server_absolute) ? $http_server_absolute : $http_server_absolute_default );//dirname(str_replace('/install', '', $_SERVER['PHP_SELF'])) .'/' );
	$store_owner = ( false === empty($_POST['store_owner']) ? $_POST['store_owner'] : 'Roman Vidyayev' );
	$email_address = ( false === empty($_POST['email_address']) ? $_POST['email_address'] : 'admin@localhost.com' );
	$store_name = ( false === empty($_POST['store_name']) ? $_POST['store_name'] : 'eclime' );
	$index_meta_description = ( false === empty($_POST['index_meta_description']) ? $_POST['index_meta_description'] : 'eclime powerful smarty based e-commerce/shopping cart software based on osCommerce' );
	$index_title = ( false === empty($_POST['index_title']) ? $_POST['index_title'] : 'eclime - e-commerce software.' );
	$index_meta_keywords = ( false === empty($_POST['index_meta_keywords']) ? $_POST['index_meta_keywords'] : 'e-commerce software, oscommerce' );
	$admin_username = ( false === empty($_POST['admin_username']) ? $admin_username : 'admin' );

	if ( false === empty($install_action) && 'step1' != $install_action ) {
		$db_link = testDbSelect($database_server,$database_name,$database_username,$database_password);
		if ( false === empty($database_server) && false === empty($database_name) && false === empty($database_username) && false === empty($database_password) ) {
			$db_link = osc_db_connect($database_server, $database_username, $database_password);
			osc_db_select_db($database_name);
		}
		$configuration_table_exists = osc_db_table_exists('configuration');
		if ( true === $configuration_table_exists ) {
			$store_owner = osc_db_get_configuration_value('STORE_OWNER');
			$email_address = osc_db_get_configuration_value('STORE_OWNER_EMAIL_ADDRESS');
			$store_name = osc_db_get_configuration_value('STORE_NAME');
			$index_meta_description = osc_db_get_configuration_value('INDEX_META_DESCRIPTION');
			$index_title = osc_db_get_configuration_value('INDEX_META_TITLE');
			$index_meta_keywords = osc_db_get_configuration_value('INDEX_META_KEYWORDS');
			$import_database_required = false;
		} else {
			$import_database_required = true;
		}
	}

	if ( 'install' == $install_action || 'express_install' == $install_action ) {
		$install_errors['count'] = 0;
		$install_errors['message'] = '';
		$db_text = testDbSelect($database_server, $database_name, $database_username, $database_password);
		if ( false === $db_text ) {
			$install_errors['count']++;
			$install_errors['message'] .= 'Could not connect to database<br />';
		}
		if ( true === empty($skip_import_admin_data) ) {
			if ( true === empty($admin_username) ) {
				$install_errors['count']++;
				$install_errors['message'] .= 'Admin username is empty.<br />';
			}
			if ( true === empty($admin_password) || true === empty($admin_password2) ) {
				$install_errors['count']++;
				$install_errors['message'] .= 'Admin password is empty.<br />';
			} elseif ( $admin_password !== $admin_password2 ) {
				$install_errors['count']++;
				$install_errors['message'] .= 'Admin passwords do not match.<br />';
			}
		}

		if ( true === empty($http_server) ) {
			$install_errors['count']++;
			$install_errors['message'] .= 'Catalog path is empty.<br />';
		}

		if ( true === empty($http_server_absolute) ) {
			$install_errors['count']++;
			$install_errors['message'] .= 'Catalog absolute path is empty.<br />';
		}

		if ( true === empty($cookie_domain) ) {
			$install_errors['count']++;
			$install_errors['message'] .= 'Cookie domain is empty.<br />';
		}

		if ( true === empty($store_owner) ) {
			$install_errors['count']++;
			$install_errors['message'] .= 'Store owner is empty.<br />';
		}

		if ( true === empty($email_address) ) {
			$install_errors['count']++;
			$install_errors['message'] .= 'E-mail address is empty.<br />';
		}

		if ( true === empty($store_name) ) {
			$install_errors['count']++;
			$install_errors['message'] .= 'Store name is empty.<br />';
		}

		if ( true === empty($index_title) ) {
			$install_errors['count']++;
			$install_errors['message'] .= 'Store title is empty.<br />';
		}

	if ( 0 >= $install_errors['count'] ) {
			$admin_password_hash = tep_encrypt_password($admin_password);
			list($admin_firstname, $admin_lastname) = explode(' ', $store_owner);
			$db_link = osc_db_connect($database_server, $database_username, $database_password);
			$db_select = osc_db_select_db($database_name);
			$installation_success = false;
			if ( false === empty($db_link) ) {
				$installation_success = write_configure_files($_POST);
				if ( '1' == $import_database ) {
					$installation_success = mysql_import_file('sql/eclime.sql', $errmsg);
				}
				if ( true === empty($skip_import_admin_data) ) {
				######### INSERT ADMIN
				$sql_insert_admin = "
										INSERT INTO admin
										(
											`admin_id`,
											`admin_username`,
											`admin_groups_id`,
											`admin_firstname`,
											`admin_lastname`,
											`admin_email_address`,
											`admin_password`,
											`admin_created`,
											`admin_modified`,
											`admin_logdate`,
											`admin_lognum`
										)
											VALUES
										(
											1,
											'$admin_username',
											1,
											'$admin_firstname',
											'$admin_lastname',
											'$email_address',
											'$admin_password_hash',
											NOW(),
											NOW(),
											NOW(),
											0
										)";
						$installation_success = osc_db_query($sql_insert_admin);
						######### INSERT ADMIN
				}

				osc_db_update_configuration_value('STORE_OWNER', $store_owner);
				osc_db_update_configuration_value('STORE_OWNER_EMAIL_ADDRESS', $email_address);
				osc_db_update_configuration_value('STORE_NAME', $store_name);
				osc_db_update_configuration_value('INDEX_META_DESCRIPTION', $index_meta_description);
				osc_db_update_configuration_value('INDEX_META_TITLE', $index_title);
				osc_db_update_configuration_value('INDEX_META_KEYWORDS', $index_meta_keywords);
				if ( true === $installation_success ) {
					if ( '1' == $import_catalog_data ) {
						$installation_success = mysql_import_file('sql/catalog_data.sql', $errmsg);
					}
				}
			} else {
				$errmsg = "Cannot Connect to DB.";
			}
			if ( true == $installation_success ) {
				header ('Location: index.php?install_success=true');
			} else {
				echo "ERROR Installing<br />$errmsg";
			}
		} else {
			echo $install_errors['message'];
		}
	}
	/**/
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<title>eclime installation</title>
<link rel="stylesheet" type="text/css" href="stylesheet/stylesheet.css" media="screen" />
<script language="javascript" src="includes/javascript/prototype.js" type="text/javascript"></script>
<script language="javascript" src="includes/javascript/scriptaculous/scriptaculous.js" type="text/javascript"></script>
<script language="javascript" type="text/javascript">

function passwordStrength(password) {

        var desc = new Array();
        desc[0] = "Very Weak";
        desc[1] = "Weak";
        desc[2] = "Better";
        desc[3] = "Medium";
        desc[4] = "Strong";
        desc[5] = "Strongest";
        var score   = 0;
        //if password bigger than 6 give 1 point
        if (password.length > 6) score++;

        //if password has both lower and uppercase characters give 1 point
        if ( ( password.match(/[a-z]/) ) && ( password.match(/[A-Z]/) ) ) score++;

        //if password has at least one number give 1 point
        if (password.match(/\d+/)) score++;

        //if password has at least one special caracther give 1 point
        if ( password.match(/.[!,@,#,$,%,^,&,*,?,_,~,-,(,)]/) ) score++;

        //if password bigger than 12 give another 1 point
        if (password.length > 12) score++;

         $("passwordDescription").innerHTML = desc[score];
         $("passwordStrength").className = "strength" + score;

}

function enableSEO(){
var updater = new Ajax.Updater(
			'seo_urls',
			'includes/install_handler.html',
				{
					asynchronous:true,
					evalScripts:true,
					onComplete:function(request){new Effect.Opacity(div, {duration:1.0, from:0.1, to:1.0});},
					parameters:'?install_action=enable_seo_urls'
				}
			);
}

function testDbConnection(){
		var div_id = 'test_connection';
		var database_server = $('database_server').value;
		var database_name = $('database_name').value;
		var database_username = $('database_username').value;
		var database_password = $('database_password').value;
		$(div_id).innerHTML = 'Connecting...';
		var updater = new Ajax.Updater(
			div_id,
			'includes/install_handler.php',
				{
					asynchronous:true,
					evalScripts:true,
					onComplete:function(request){new Effect.Opacity(div, {duration:1.0, from:0.1, to:1.0});},
					parameters:'?install_action=test_connection' +
								'&database_server='+ database_server +
								'&database_name=' + database_name +
								'&database_username=' + database_username +
								'&database_password=' + database_password
				}
			);
}

function install_auto_cleanup(){
		var div_id = 'id_install_auto_clean_up';
		div_id.innerHTML = 'Cleaning...';
		var updater = new Ajax.Updater(
			div_id,
			'includes/install_handler.php',
				{
					asynchronous:true,
					evalScripts:true,
					onComplete:function(request){new Effect.Opacity(div, {duration:1.0, from:0.1, to:1.0});},
					parameters:'?install_action=auto_cleanup'
				}
			);
}
function connected(){
	$('installation_form').submit();
}

function step1KeyButtonSwitch() {
	if($('btn_step1')) {
		$('btn_step1').insert({'after':'<a href="#" onclick="javascript:testDbConnection(); return false;" id="btn_testconnection"><img src="images/button_connect.gif" alt="Connect" /></a>'});
		$('btn_step1').remove();
		Effect.Pulsate('btn_testconnection', { pulses: 1, duration: 0.5 });
	}
}

function isValidEmail(str) {
   return (str.indexOf(".") > 2) && (str.indexOf("@") > 0);
}

function isValidEmail(email) {
	var filter = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
	if (!filter.test(email)) {
		return false;
	} else {
		return true;
	}
}

function validateSteps(step) {
	switch (step) {
		case 2:
		var errors = 0;
		var error_message = '';
		var http_server = $('http_server').value;
		var http_server_absolute = $('http_server_absolute').value;
		var cookie_domain = $('cookie_domain').value;

		if ( 0 >= http_server.length ) {
			errors++;
			error_message += "Catalog path is empty \n";
		}

		if ( 0 >= cookie_domain.length ) {
			errors++;
			error_message += "Cookie domain is empty \n";
		}

		if ( 0 < errors ) {
			alert(error_message);
			return false;
		} else {

			if ( '/' == http_server.substr(http_server.length-1,http_server.length) ) {
				$('http_server').value = http_server.substr(0,http_server.length-1);
			}

			if ( 0 >= http_server_absolute.length ) {
				$('http_server_absolute').value = '/';
			}

			if ( '/' != http_server_absolute.substr(http_server_absolute.length-1,http_server_absolute.length) ) {
				$('http_server_absolute').value = http_server_absolute + '/';
			}
			return true;
		}
		break;

		case 3:
			var errors = 0;
			var error_message = '';
			var store_owner = $('store_owner').value;
			var email_address = $('email_address').value;
			var store_name = $('store_name').value;
			var index_title = $('index_title').value;
			var index_meta_description = $('index_meta_description').value;
			var index_meta_keywords = $('index_meta_keywords').value;

			if ( 0 >= store_owner.length ) {
				errors++;
				error_message += "Store owner name is empty \n";
			}

			if ( 0 >= email_address.length ) {
				errors++;
				error_message += "E-mail address is empty \n";
			}

			if ( !isValidEmail(email_address) ) {
				errors++;
				error_message += "Invalid email \n";
			}

			if ( 0 >= store_name.length ) {
				errors++;
				error_message += "Store name is empty \n";
			}

			if ( 0 >= index_title.length ) {
				errors++;
				error_message += "Index title is empty \n";
			}

			if ( 0 >= index_meta_description.length ) {
				errors++;
				error_message += "Index meta description is empty \n";
			}

			if ( 0 >= index_meta_keywords.length ) {
				errors++;
				error_message += "Index meta keywords is empty \n";
			}

			if ( 0 < errors ) {
				alert(error_message);
				return false;
			} else {
				return true;
			}
		break;

		case 4:

			var errors = 0;
			var error_message = '';
			var admin_username = $('admin_username').value;
			var admin_password = $('admin_password').value;
			var admin_password2 = $('admin_password2').value;

			if ( 0 >= admin_username.length ) {
				errors++;
				error_message += "Admin username is empty \n";
			}

			if ( 0 >= admin_password.length || 0 >= admin_password2.length ) {
				errors++;
				error_message += "Password is empty \n";
			} else {

				if ( admin_password != admin_password2 ) {
					errors++;
					error_message += "Passwords do not match \n";
				}

			}
			if ( 0 < errors ) {
				alert(error_message);
				return false;
			} else {
				return true;
			}
		break;
		default:
			return fasle;
		break;
	}
}

function express_install() {
	var conf=confirm("Express Installation\n--------------------\nA default username and password will be used:\n\tUsername: admin\n\tPassword: admin\n--------------------\nClick OK to continue...");
	if(conf){
		$('btn_express_install').hide();
		$('btn_express_install').insert({'after':'<img src="images/button_install_express_p.gif" alt="Express Install" />'});
		$('btn_back_step1').remove();
		$('btn_custom_install').remove();
		$('label_import_catalog_data').insert({'after':'<br /><br /><span style="color:#FF0000; font-weight:bold;" id="id_installing_message">IMPORTANT!<br />Do not interrupt installation procedure, otherwise the database may end up corrupt.</span><br />'});
		Effect.Pulsate('id_installing_message', { pulses: 3, duration: 2.0 });
		return true;
	}else{return false;}
}

function install() {
	$('btn_install').disabled = true;
	$('btn_install').value = 'Installing, please wait...';
	$('install_processing').innerHTML = '<img src="images/processing.gif" border="0" alt="Processing..." align="absmiddle" />';
	$('form_install').submit();
	return true;
}

function installation() {
	if( true == $('agreed').checked ) {
		return true;
	} else {
		alert("You must agree");
		return false;
	}
}

function database_check(){
	if ( false == $('import_database').checked ) {
		$('import_catalog_data').checked = false;
	}
}

function database_catalog_check(){
	if ( true == $('import_catalog_data').checked ) {
		$('import_database').checked = true;
	}
}
</script>

<script type="text/javascript">
<!--//--><![CDATA[//><!--
if (document.images) {
	img1 = new Image();
	img1.src = "images/button_install_express_p.gif";

}
//--><!]]>
</script>

</head>

<body>
<h1 class="header"><img src="images/logo.gif" border="0" alt="eclime installation" /></h1>
<div class="install_body">
<?php
	if ( 0 < $requirements['count'] ) {
?>

<fieldset>
<legend>Requirements</legend>
<?php
	echo $requirements['message'];
?>
</fieldset>


<?php
	} else {

	if ( 0 < $install_errors['count'] ) {
?>
<fieldset class="install_error">
<legend>Install errors</legend>
<?php echo $install_errors['message']; ?>
</fieldset>

<?php
	}
		if ( 'true' == $install_success ) {
	?>

		<img src="images/step6.png" border="0" alt="Step 6" />
		<h3>Installation complete!</h1>

		<form action="index.php" method="post">
		CHMOD[<a href="http://en.wikipedia.org/wiki/Chmod" target="_blank">?</a>] "755" &mdash; <strong>configure/</strong> directory<br />
		DELETE &mdash; <strong>install/</strong> directory <br />
		<br />
		<a href="../admin/index.php"><strong>Continue to admin</strong></a> |
		<a href="../index.php">View catalog</strong></a>
		<br />
		<br />
		<a href="db_import.php?platform=oscommerce">Import &raquo; <strong>osCommerce v2.2</strong> &raquo; database</strong></a><br />
		<a href="db_import.php?platform=zencart">Import &raquo; <strong>Zen Cart v1.3.8</strong> &raquo; database</strong></a>
		<br />
		<span id="seo_urls" style="display:none;"></span>
		<script type="text/javascript">
			enableSEO();
		</script>

	<?php
		} else {

	switch ( $install_action ) {
		default:
		?>
		<form action="index.php" method="post">
		<input type="image" src="images/button_install.gif" value="Install" onclick="return installation();" />
		<br /><br />
		<label><input type="checkbox" name="agreed" id="agreed" value="yes" /> I have read and agree the <a href="license.html" target="_blank">License Agreement</a>.</label>
		<input type="hidden" name="install_action" value="step1" />
		</form>
	<?php
		break;
		case 'step1':
	?>
	<img src="images/step1.png" border="0" alt="Step 1" />
	<br />
	<form action="index.php" method="post" id="installation_form">
	<table class="form" align="center">
		<tr>
			<th colspan="2">Database Server Information:</th>
		<tr>
		<tr>
			<td class="label"><label for="database_server">Database Server:</label></td>
			<td class="input"><input type="text" name="database_server" id="database_server" class="inputNormal" value="<?php echo $database_server; ?>" onchange="javascript:step1KeyButtonSwitch();" /> e.g: localhost</td>
		</tr>
		<tr>
			<td class="label"><label for="database_name">Database Name:</label></td>
			<td class="input"><input type="text" name="database_name" id="database_name" class="inputNormal" value="<?php echo $database_name; ?>" onchange="javascript:step1KeyButtonSwitch();" /></td>
		</tr>
		<tr>
			<td class="label"><label for="database_username">Database Username:</label></td>
			<td class="input"><input type="text" name="database_username" id="database_username" class="inputNormal" value="<?php echo $database_username; ?>" onchange="javascript:step1KeyButtonSwitch();" /></td>
		</tr>
		<tr>
			<td class="label"><label for="database_password">Database Password:</label></td>
			<td class="input"><input type="password" name="database_password" id="database_password" class="inputNormal" value="<?php echo $database_password; ?>" onchange="javascript:step1KeyButtonSwitch();" /></td>
		</tr>
		<tr>
			<td>&nbsp;</td>
			<td class="input">
			<a href="#" onclick="javascript:testDbConnection(); return false;" id="btn_testconnection"><img src="images/button_connect.gif" alt="Connect" /></a>
			</td>
		</tr>
		<tr>
			<td>&nbsp;</td>
			<td class="input"><span id="test_connection"></span></td>
		</tr>
		<tr>
			<td class="label">&nbsp;</td>
			<td class="input">
				<a href="index.php"><img src="images/button_back.gif" alt="Go Back" border="0" /></a>
			</td>
		</tr>
	</table>
	<input type="hidden" name="install_action" value="install_type" />
	</form>
	<?php
		break;
		case 'install_type':
	?>

		<form action="index.php" method="post">
		<input type="image" src="images/button_install_express.gif" value="Express Install" onclick="return express_install();" id="btn_express_install" />
		<br />
		<?php if ( true === file_exists('sql/catalog_data.sql') ) {?>
		<label id="label_import_catalog_data"><input type="checkbox" name="import_catalog_data" id="id_import_catalog_data" value="1" checked="checked" />Add Demo Products</label>
		<?php } else { ?>
		<input type="hidden" name="import_catalog_data" value="0" />
		<?php } ?>
		<input type="hidden" name="install_action" value="express_install" />
		<input type="hidden" name="database_server" value="<?php echo $database_server; ?>" />
		<input type="hidden" name="database_name" value="<?php echo $database_name; ?>" />
		<input type="hidden" name="database_username" value="<?php echo $database_username; ?>" />
		<input type="hidden" name="database_password" value="<?php echo $database_password; ?>" />
		<input type="hidden" name="http_server" value="<?php echo 'http://'.$_SERVER['HTTP_HOST']; ?>" />
		<input type="hidden" name="http_server_absolute" value="<?php echo str_replace("\\","/", realpath('../')); ?>" />
		<input type="hidden" name="http_catalog" value="<?php echo dirname(str_replace('/install', '', $_SERVER['PHP_SELF'])).'/'; ?>" />
		<input type="hidden" name="cookie_domain" value="<?php echo $_SERVER['HTTP_HOST']; ?>" />
		<input type="hidden" name="store_owner" value="<?php echo 'Roman Vidyayev'; ?>" />
		<input type="hidden" name="email_address" value="<?php echo 'admin@localhost.com'; ?>" />
		<input type="hidden" name="store_name" value="<?php echo 'eclime'; ?>" />
		<input type="hidden" name="index_meta_description" value="<?php echo 'eclime powerful smarty based e-commerce/shopping cart software based on osCommerce'; ?>" />
		<input type="hidden" name="index_title" value="<?php echo 'eclime - A free smarty based open source e-commerce shopping cart'; ?>" />
		<input type="hidden" name="index_meta_keywords" value="<?php echo 'smarty e-commerce'; ?>" />
		<input type="hidden" name="admin_username" value="<?php echo 'admin'; ?>" />
		<input type="hidden" name="admin_password" value="<?php echo 'admin'; ?>" />
		<input type="hidden" name="admin_password2" value="<?php echo 'admin'; ?>" />
		<input type="hidden" name="import_database" value="1" />
		</form>
		<br />
		<br />
		<form action="index.php" method="post">
		<input type="image" src="images/button_install_custom.gif" value="Custom Install" id="btn_custom_install" />
		<input type="hidden" name="install_action" value="step2" />
			<input type="hidden" name="database_server" value="<?php echo $database_server; ?>" />
			<input type="hidden" name="database_name" value="<?php echo $database_name; ?>" />
			<input type="hidden" name="database_username" value="<?php echo $database_username; ?>" />
			<input type="hidden" name="database_password" value="<?php echo $database_password; ?>" />
		</form>
		<br />
		<br />
		<form action="index.php" method="post" id="form_back">
		<input type="image" src="images/button_back.gif" value="Go Back" id="btn_back_step1" />
		<input type="hidden" name="install_action" value="step1" />
			<input type="hidden" name="database_server" value="<?php echo $database_server; ?>" />
			<input type="hidden" name="database_name" value="<?php echo $database_name; ?>" />
			<input type="hidden" name="database_username" value="<?php echo $database_username; ?>" />
			<input type="hidden" name="database_password" value="<?php echo $database_password; ?>" />
		</form>
	<?php

		break;

		case 'step2':
	?>
	<img src="images/step2.png" border="0" alt="Step 2" />
	<form action="index.php" method="post">
	<table class="form" align="center">
		<tr>
			<th colspan="2">Database Server Information:</th>
		<tr>
		<tr>
			<td class="label"><label for="http_server">HTTP Server:</label></td>
			<td class="input"><input type="text" name="http_server" value="<?php echo $http_server; ?>" id="http_server" class="inputLong"></td>
		</tr>
		<tr>
			<td class="label"><label for="http_catalog">Catalog Path:</label></td>
			<td class="input"><input type="text" name="http_catalog" value="<?php echo $http_catalog; ?>" id="http_catalog" class="inputLong"></td>
		</tr>
		<tr>
			<td class="label"><label for="http_server_absolute">Absolute Catalog Path:</label></td>
			<td class="input"><input type="text" name="http_server_absolute" value="<?php echo $http_server_absolute; ?>" id="http_server_absolute" class="inputLong"></td>
		</tr>
		<tr>
			<td class="label"><label for="cookie_gomain">Cookie Domain:</label></td>
			<td class="input"><input type="text" name="cookie_domain" value="<?php echo $cookie_domain; ?>" id="cookie_domain" class="inputNormal"></td>
		</tr>
		<tr>
			<td class="label"></td>
			<td class="input"><input type="image" src="images/button_next.gif" value="Next >" onclick="return validateSteps(2);"></td>
		</tr>
	</table>
	<input type="hidden" name="database_server" value="<?php echo $database_server; ?>" />
			<input type="hidden" name="database_name" value="<?php echo $database_name; ?>" />
			<input type="hidden" name="database_username" value="<?php echo $database_username; ?>" />
			<input type="hidden" name="database_password" value="<?php echo $database_password; ?>" />
			<input type="hidden" name="install_action" value="step3" />
	</form>
	<form action="index.php" method="post" id="form_back">
	<table class="form" align="center">
		<tr>
			<td class="label">&nbsp;</td>
			<td class="input"><input type="image" src="images/button_back.gif" value="Go Back" id="btn_back_step2" /></td>
		</tr>
	</table>
		<input type="hidden" name="install_action" value="install_type" />
		<input type="hidden" name="database_server" value="<?php echo $database_server; ?>" />
		<input type="hidden" name="database_name" value="<?php echo $database_name; ?>" />
		<input type="hidden" name="database_username" value="<?php echo $database_username; ?>" />
		<input type="hidden" name="database_password" value="<?php echo $database_password; ?>" />
	</form>
	<?php
		break;

		case 'step3':
	?>
	<img src="images/step3.png" border="0" alt="Step 3" />
	<form action="index.php" method="post">
	<table class="form" align="center">
		<tr>
			<th colspan="2">Database Server Information:</th>
		<tr>
		<tr>
			<td class="label"><label for="store_owner">Store Owner:</label></td>
			<td class="input"><input type="text" name="store_owner" value="<?php echo $store_owner; ?>" id="store_owner" class="inputNormal" /> John Doe</td>
		</tr>
		<tr>
			<td class="label"><label for="email_address">E-Mail Address:</label></td>
			<td class="input"><input type="text" name="email_address" value="<?php echo $email_address; ?>" id="email_address" class="inputNormal" /></td>
		</tr>
		<tr>
			<td class="label"><label for="store_name">Store Name:</label></td>
			<td class="input"><input type="text" name="store_name" value="<?php echo $store_name; ?>" id="store_name" class="inputLong" /></td>
		</tr>
		<tr>
			<td class="label"><label for="index_title">Default Title:</label></td>
			<td class="input"><input type="text" name="index_title" value="<?php echo $index_title; ?>" id="index_title" class="inputLong" /></td>
		</tr>
		<tr>
			<td class="label"><label for="index_meta_description">Default Meta Description:</label></td>
			<td class="input"><input type="text" name="index_meta_description" value="<?php echo $index_meta_description; ?>" id="index_meta_description" class="inputLong" /></td>
		</tr>
		<tr>
			<td class="label"><label for="index_meta_keywords">Default Meta Keywords:</label></td>
			<td class="input"><input type="text" name="index_meta_keywords" value="<?php echo $index_meta_keywords; ?>" id="index_meta_keywords" class="inputLong" /></td>
		</tr>
		<tr>
			<td class="label" valign="top"><label for="import_database">Load New Database:</label></td>
			<td class="input">
				<?php
					if ( true === $import_database_required ) {
				?>
					<input type="checkbox" checked="checked" disabled="disabled" />
					<input type="hidden" name="import_database" value="1" />
				<?php
					} else {
				?>
					<input type="checkbox" name="import_database" checked="checked" value="1" id="import_database" onchange="javascript:database_check();" />
				<?php
					}

					if ( true === file_exists('sql/eclime.sql') ) {
				?>
				<label for="import_database">
				<strong>WARNING!</strong> If checked, all your existing tables in <strong><i>'<?php echo $database_name; ?>'</i></strong> database<br />
				will be <span style="color:#FF0000; font-weight:bold;">DROPPED</span> (Permanently deleted!), only then new tables will be created.
				</label>
				<br />
				<span style="color:#10AA00; font-weight:bold;">/sql/eclime.sql</span>
				<br />
				**Must check for the first time installations.
				<?php
					} else {
						echo '<span style="color:#FF0000; font-weight:bold;">File: /sql/eclime.sql does NOT exists.</span>';
						echo '<script language="javascript">$(\'import_database\').checked=false;$(\'import_database\').disabled=true;$(\'import_catalog_data\').checked=false;$(\'import_catalog_data\').disabled=true;</script>';
					}
				?>
			</td>
		</tr>
		<?php if ( true === file_exists('sql/catalog_data.sql') ) { ?>
		<tr>
			<td class="label"><label for="import_catalog_data">Import Demo Products:</label></td>
			<td class="input">
			<input type="checkbox" checked="checked" name="import_catalog_data" value="1" id="import_catalog_data" onchange="javascript:database_catalog_check();">
			<label for="import_catalog_data">Import catalog data (For demonstration purposes only)</label><br />
			<span style="color:#10AA00; font-weight:bold;">/sql/catalog_data.sql</span>
			</td>
		</tr>
		<?php } ?>
		<tr>
			<td class="label"></td>
			<td class="input"><input type="image" src="images/button_next.gif" value="Next >" onclick="return validateSteps(3);"></td>
		</tr>
	</table>
			<input type="hidden" name="install_action" value="step4" />
			<input type="hidden" name="database_server" value="<?php echo $database_server; ?>" />
			<input type="hidden" name="database_name" value="<?php echo $database_name; ?>" />
			<input type="hidden" name="database_username" value="<?php echo $database_username; ?>" />
			<input type="hidden" name="database_password" value="<?php echo $database_password; ?>" />
			<input type="hidden" name="http_server" value="<?php echo $http_server; ?>" />
			<input type="hidden" name="http_catalog" value="<?php echo $http_catalog; ?>" />
			<input type="hidden" name="http_server_absolute" value="<?php echo $http_server_absolute; ?>" />
			<input type="hidden" name="cookie_domain" value="<?php echo $cookie_domain; ?>" />
	</form>
	<form action="index.php" method="post" id="form_back">
	<table class="form" align="center">
		<tr>
			<td class="label">&nbsp;</td>
			<td class="input"><input type="image" src="images/button_back.gif" value="Go Back" id="btn_back_step3" /></td>
		</tr>
	</table>
		<input type="hidden" name="install_action" value="step2" />
		<input type="hidden" name="database_server" value="<?php echo $database_server; ?>" />
		<input type="hidden" name="database_name" value="<?php echo $database_name; ?>" />
		<input type="hidden" name="database_username" value="<?php echo $database_username; ?>" />
		<input type="hidden" name="database_password" value="<?php echo $database_password; ?>" />
		<input type="hidden" name="http_server" value="<?php echo $http_server; ?>" />
		<input type="hidden" name="http_server_absolute" value="<?php echo $http_server_absolute; ?>" />
		<input type="hidden" name="http_catalog" value="<?php echo $http_catalog; ?>" />
		<input type="hidden" name="cookie_domain" value="<?php echo $cookie_domain; ?>" />
	</form>
	<?php
		break;
		case 'step4':
	?>
	<img src="images/step4.png" border="0" alt="Step 4" />
	<form action="index.php" method="post">
	<table class="form" align="center">
		<tr>
			<td class="label"><label for="admin_username">Admin Username:</label></td>
			<td class="input"><input type="text" name="admin_username" value="<?php echo $admin_username;?>" id="admin_username" class="inputNormal" /></td>
		</tr>
		<tr>
			<td class="label"><label for="admin_password">Admin Password:</label></td>
			<td class="input"><input type="password" name="admin_password" value="" id="admin_password" class="inputNormal" onkeyup="passwordStrength(this.value);" /></td>
		</tr>
		<tr>
			<td class="label"><label for="admin_password2">Password Again:</label></td>
			<td class="input"><input type="password" name="admin_password2" value="" id="admin_password2" class="inputNormal" /></td>
		</tr>
		<tr>
			<td class="label"><label for="passwordStrength">Password Strength</label></td>
			<td class="input">
			<span id="passwordDescription"></span>
			<br />
			<span id="passwordStrength" class="strength0"></span>
			</td>
		</tr>
		<tr>
			<td class="label"></td>
			<td class="input">
			<?php
			if ( '1' == $import_database ) {
			?>
				<input type="image" src="images/button_next.gif" value="Next >" onclick="return validateSteps(4);" />
			<?php
				} else {
			?>
				<input type="image" src="images/button_next.gif" value="Next >" onclick="return validateSteps(4);" />
				<br /><br />
				<input type="image" src="images/button_skip.gif" value="Skip >" name="skip_import_admin_data" />
				By skipping this step an existing admin account will be used.
			<?php
				}
			?>
			</td>
		</tr>
	</table>
		<input type="hidden" name="install_action" value="step5" />
		<input type="hidden" name="database_server" value="<?php echo $database_server; ?>" />
		<input type="hidden" name="database_name" value="<?php echo $database_name; ?>" />
		<input type="hidden" name="database_username" value="<?php echo $database_username; ?>" />
		<input type="hidden" name="database_password" value="<?php echo $database_password; ?>" />
		<input type="hidden" name="http_server" value="<?php echo $http_server; ?>" />
		<input type="hidden" name="http_server_absolute" value="<?php echo $http_server_absolute; ?>" />
		<input type="hidden" name="http_catalog" value="<?php echo $http_catalog; ?>" />
		<input type="hidden" name="cookie_domain" value="<?php echo $cookie_domain; ?>" />
		<input type="hidden" name="store_owner" value="<?php echo $store_owner; ?>" />
		<input type="hidden" name="email_address" value="<?php echo $email_address; ?>" />
		<input type="hidden" name="store_name" value="<?php echo $store_name; ?>" />
		<input type="hidden" name="index_meta_description" value="<?php echo $index_meta_description; ?>" />
		<input type="hidden" name="index_title" value="<?php echo $index_title; ?>" />
		<input type="hidden" name="index_meta_keywords" value="<?php echo $index_meta_keywords; ?>" />
		<input type="hidden" name="import_database" value="<?php echo $import_database; ?>" />
		<input type="hidden" name="import_catalog_data" value="<?php echo $import_catalog_data; ?>" />
	</form>
	<form action="index.php" method="post" id="form_back">
	<table class="form" align="center">
		<tr>
			<td class="label">&nbsp;</td>
			<td class="input"><input type="image" src="images/button_back.gif" value="Go Back" id="btn_back_step4" /></td>
		</tr>
	</table>
		<input type="hidden" name="install_action" value="step3" />
		<input type="hidden" name="database_server" value="<?php echo $database_server; ?>" />
		<input type="hidden" name="database_name" value="<?php echo $database_name; ?>" />
		<input type="hidden" name="database_username" value="<?php echo $database_username; ?>" />
		<input type="hidden" name="database_password" value="<?php echo $database_password; ?>" />
		<input type="hidden" name="http_server" value="<?php echo $http_server; ?>" />
		<input type="hidden" name="http_server_absolute" value="<?php echo $http_server_absolute; ?>" />
		<input type="hidden" name="http_catalog" value="<?php echo $http_catalog; ?>" />
		<input type="hidden" name="cookie_domain" value="<?php echo $cookie_domain; ?>" />
		<input type="hidden" name="store_owner" value="<?php echo $store_owner; ?>" />
		<input type="hidden" name="email_address" value="<?php echo $email_address; ?>" />
		<input type="hidden" name="store_name" value="<?php echo $store_name; ?>" />
		<input type="hidden" name="index_meta_description" value="<?php echo $index_meta_description; ?>" />
		<input type="hidden" name="index_title" value="<?php echo $index_title; ?>" />
		<input type="hidden" name="index_meta_keywords" value="<?php echo $index_meta_keywords; ?>" />
		<input type="hidden" name="import_database" value="<?php echo $import_database; ?>" />
		<input type="hidden" name="import_catalog_data" value="<?php echo $import_catalog_data; ?>" />

	</form>
	<?php
		break;
		case 'step5':
		case 'install':
	?>
	<img src="images/step5.png" border="0" alt="Step 5" />
	<form action="index.php" method="post" id="form_install">
	<table class="form" align="center">
		<tr>
			<td class="label">Store Name:</td>
			<td class="input"><?php echo $_POST['store_name']; ?></td>
		</tr>
		<tr>
			<td class="label">Store Owner:</td>
			<td class="input"><?php echo $_POST['store_owner']; ?></td>
		</tr>
		<tr>
			<td class="label">Email Address:</td>
			<td class="input"><?php echo $_POST['email_address']; ?></td>
		</tr>
		<?php
			if ( true === empty($skip_import_admin_data) ) {
		?>
		<tr>
			<td class="label">Admin Username:</td>
			<td class="input"><?php echo $_POST['admin_username']; ?></td>
		</tr>
		<tr>
			<td class="label">Admin Password:</td>
			<td class="input"><?php for ($ct=1; $ct <= strlen($_POST['admin_password']); $ct++) echo '*'; ?></td>
		</tr>
		<?php
			}
		?>
		<tr>
			<td class="label">Database Server:</td>
			<td class="input"><?php echo $_POST['database_server']; ?></td>
		</tr>
		<tr>
			<td class="label">Database Name:</td>
			<td class="input"><?php echo $_POST['database_name']; ?></td>
		</tr>
		<tr>
			<td class="label">Database Username:</td>
			<td class="input"><?php echo $_POST['database_username']; ?></td>
		</tr>
		<tr>
			<td class="label">Database Password:</td>
			<td class="input"><?php for ($ct=1; $ct <= strlen($_POST['database_password']); $ct++) echo '*'; ?></td>
		</tr>
		<tr>
			<td class="label">HTTP Server:</td>
			<td class="input"><?php echo $_POST['http_server']; ?></td>
		</tr>
		<tr>
			<td class="label">Catalog Path:</td>
			<td class="input"><?php echo $_POST['http_catalog']; ?></td>
		</tr>
		<tr>
			<td class="label">Catalog Absolute Path:</td>
			<td class="input"><?php echo $_POST['http_server_absolute']; ?></td>
		</tr>
		<tr>
			<td class="label">Cookie Domain:</td>
			<td class="input"><?php echo $_POST['cookie_domain']; ?></td>
		</tr>
		<tr>
			<td class="label">Default Meta Description:</td>
			<td class="input"><?php echo $_POST['index_meta_description']; ?></td>
		</tr>
		<tr>
			<td class="label">Default Meta Title:</td>
			<td class="input"><?php echo $_POST['index_title']; ?></td>
		</tr>
		<tr>
			<td class="label">Default Meta Keywords:</td>
			<td class="input"><?php echo $_POST['index_meta_keywords']; ?></td>
		</tr>
		<tr>
			<td class="label">&nbsp;</td>
			<td class="input">
				<?php
					if ( '1' == $_POST['import_database'] ) {
				?>
						<span style="color:#10AA00; font-weight:bold;">
						<br /> New database will be imported.
						<?php if ( '1' == $_POST['import_catalog_data'] ) { ?>
							<br /> Also catalog data will be imported.
						<?php } ?>
						</span>
				<?php } ?>
			<br /><br />
			<span style="color:#FF0000; font-weight:bold;">IMPORTANT!<br />Do not interrupt installation procedure, otherwise the database may end up corrupt.</span>
			<br /><br />
			<input type="image" src="images/button_install_now.gif" value="<?php echo ( 0 >= $install_errors['count'] ? 'Install Now!' : 'Retry Installation?' ); ?>" id="btn_install" onclick="return install();" />
			&nbsp;<span id="install_processing"></span>
			</td>
		</tr>
	</table>

		<input type="hidden" name="install_action" value="install" />
		<input type="hidden" name="database_server" value="<?php echo $database_server; ?>" />
		<input type="hidden" name="database_name" value="<?php echo $database_name; ?>" />
		<input type="hidden" name="database_username" value="<?php echo $database_username; ?>" />
		<input type="hidden" name="database_password" value="<?php echo $database_password; ?>" />
		<input type="hidden" name="http_server" value="<?php echo $http_server; ?>" />
		<input type="hidden" name="http_server_absolute" value="<?php echo $http_server_absolute; ?>" />
		<input type="hidden" name="http_catalog" value="<?php echo $http_catalog; ?>" />
		<input type="hidden" name="cookie_domain" value="<?php echo $cookie_domain; ?>" />
		<input type="hidden" name="store_owner" value="<?php echo $store_owner; ?>" />
		<input type="hidden" name="email_address" value="<?php echo $email_address; ?>" />
		<input type="hidden" name="store_name" value="<?php echo $store_name; ?>" />
		<input type="hidden" name="index_meta_description" value="<?php echo $index_meta_description; ?>" />
		<input type="hidden" name="index_title" value="<?php echo $index_title; ?>" />
		<input type="hidden" name="index_meta_keywords" value="<?php echo $index_meta_keywords; ?>" />
		<input type="hidden" name="admin_username" value="<?php echo $admin_username; ?>" />
		<input type="hidden" name="admin_password" value="<?php echo $admin_password; ?>" />
		<input type="hidden" name="admin_password2" value="<?php echo $admin_password2; ?>" />
		<input type="hidden" name="import_database" value="<?php echo $import_database; ?>" />
		<input type="hidden" name="import_catalog_data" value="<?php echo $import_catalog_data; ?>" />
		<input type="hidden" name="skip_import_admin_data" value="<?php echo $skip_import_admin_data; ?>" />
	</form>
	<form action="index.php" method="post" id="form_back">
	<table class="form" align="center">
		<tr>
			<td class="label">&nbsp;</td>
			<td class="input"><input type="image" src="images/button_back.gif" value="Go Back" id="btn_back_step4" /></td>
		</tr>
	</table>
		<input type="hidden" name="install_action" value="step4" />
		<input type="hidden" name="database_server" value="<?php echo $database_server; ?>" />
		<input type="hidden" name="database_name" value="<?php echo $database_name; ?>" />
		<input type="hidden" name="database_username" value="<?php echo $database_username; ?>" />
		<input type="hidden" name="database_password" value="<?php echo $database_password; ?>" />
		<input type="hidden" name="http_server" value="<?php echo $http_server; ?>" />
		<input type="hidden" name="http_server_absolute" value="<?php echo $http_server_absolute; ?>" />
		<input type="hidden" name="http_catalog" value="<?php echo $http_catalog; ?>" />
		<input type="hidden" name="cookie_domain" value="<?php echo $cookie_domain; ?>" />
		<input type="hidden" name="store_owner" value="<?php echo $store_owner; ?>" />
		<input type="hidden" name="email_address" value="<?php echo $email_address; ?>" />
		<input type="hidden" name="store_name" value="<?php echo $store_name; ?>" />
		<input type="hidden" name="index_meta_description" value="<?php echo $index_meta_description; ?>" />
		<input type="hidden" name="index_title" value="<?php echo $index_title; ?>" />
		<input type="hidden" name="index_meta_keywords" value="<?php echo $index_meta_keywords; ?>" />
		<input type="hidden" name="admin_username" value="<?php echo $admin_username; ?>" />
		<input type="hidden" name="admin_password" value="<?php echo $admin_password; ?>" />
		<input type="hidden" name="admin_password2" value="<?php echo $admin_password2; ?>" />
		<input type="hidden" name="import_database" value="<?php echo $import_database; ?>" />
		<input type="hidden" name="import_catalog_data" value="<?php echo $import_catalog_data; ?>" />
		<input type="hidden" name="skip_import_admin_data" value="<?php echo $skip_import_admin_data; ?>" />
	</form>
<?php
	break;
	}

		}
?>

</div>
<?php
	if ( true === empty($install_action) ) {
?>
		<div style="width:99%;text-align:center;margin-top:20px;margin-bottom:20px;">
		Minimum browser requirements for admin panel:<br />
		<a href="http://www.mozilla.com/en-US/firefox/"><img src="images/firefox_3.gif" border="0" /></a>
		<a href="http://www.google.com/chrome"><img src="images/googlechrome.gif" border="0" /></a>
		<a href="http://www.microsoft.com/windows/downloads/ie/getitnow.mspx"><img src="images/ie_7.gif" border="0" /></a>
		</div>
	<?php
	}
}
?>
</body>
</html>
