<?php
	require_once ( 'includes/application_top.php' );
	require_once ( DIR_WS_FUNCTIONS . FILENAME_REVIEWS );
	@include_once ( DIR_WS_LANGUAGES . $language . '/' . FILENAME_PRODUCT_REVIEWS_WRITE);
	include (DIR_WS_FUNCTIONS . 'filter.php');


	if (!tep_session_is_registered('customer_id')) {
		$navigation->set_snapshot();
		$messageStack->add_session('login', sprintf(TEXT_LOGIN_FIRST, tep_href_link(FILENAME_CREATE_ACCOUNT)), 'success');
    	header('Location: '.tep_href_link(FILENAME_LOGIN, '', 'SSL'));
	}

	define('REVIEWS_PER_PRODUCT', 1);

	$products_id = tep_db_input($_GET['products_id']);

	$product_info = fetchProduct($_GET['products_id']); // includes/functions/products.php

	if ( false === $product_info ) {
		tep_redirect(tep_href_link(FILENAME_PRODUCT_REVIEWS, tep_get_all_get_params(array('action'))));
		exit();
	}

	if ( false === empty($_GET['reviews_id']) && true === is_numeric($_GET['reviews_id']) ) {
		$edit_mode = true;
		$reviews_id = tep_db_prepare_input($_GET['reviews_id']);
		$user_review = tep_get_user_review($customer_id, $reviews_id);
	} else {
		$edit_mode = false;
		$customer_reviews = tep_product_reviewed_by_customer($customer_id, $products_id);
		if ( false === defined('REVIEWS_PER_PRODUCT') ) {
			define('REVIEWS_PER_PRODUCT', 1);
		}
		if ( false !== $customer_reviews || REVIEWS_PER_PRODUCT <= $customer_reviews) {
			tep_redirect(tep_href_link(FILENAME_PRODUCT_REVIEWS, tep_get_all_get_params(array('action'))));
			exit;
		}
	}

	$customer_query_sql = "
						SELECT
							customers_firstname,
							customers_lastname
						FROM
							" . TABLE_CUSTOMERS . "
						WHERE
							customers_id = '" . (int)$customer_id . "'";
	$customer_query = tep_db_query($customer_query_sql);
	$customer = tep_db_fetch_array($customer_query);




	if (isset($_GET['action']) && ($_GET['action'] == 'insert_process')) {
		$rating = tep_db_prepare_input($_POST['rating']);
		$review = tep_db_prepare_input($_POST['review']);
		$customers_name = tep_db_prepare_input($_POST['customers_name']);


		$error = false;

		if (strlen($review) < REVIEW_TEXT_MIN_LENGTH) {
			$error = true;
			$messageStack->add('review', ERROR_REVIEW_TEXT);
		}

		if (($rating <= 0) || ($rating > 5)) {
			$error = true;
			$messageStack->add('review', ERROR_REVIEW_RATING);
		}

		if ($error == false) {
			$filtered_customers_name = tep_filter_text($customers_name);
			$filtered_review = tep_filter_text($review);
			if ( false == $filtered_customers_name['passed'] || false === $filtered_review['passed']) {
				$status = '2';
			} else {
				$status = '1';
			}

			tep_db_query("INSERT INTO " . TABLE_REVIEWS . " (products_id, customers_id, customers_name, reviews_rating, date_added, status) values ('$products_id', '" . (int)$customer_id . "', '" . tep_db_input($customers_name) . "', '" . tep_db_input($rating) . "', now(), '$status')");
			$insert_id = tep_db_insert_id();

			tep_db_query("INSERT INTO " . TABLE_REVIEWS_DESCRIPTION . " (reviews_id, languages_id, reviews_text) values ('" . (int)$insert_id . "', '" . (int)$languages_id . "', '" . tep_db_input($review) . "')");
			$average_rating = tep_get_products_average_rating($products_id);
			$reviews_count = tep_get_products_reviews_count($products_id);

			tep_db_query("UPDATE " . TABLE_PRODUCTS . " SET average_rating = '$average_rating', reviews_count = '$reviews_count' WHERE products_id = '$products_id'");
			tep_redirect(tep_href_link(FILENAME_PRODUCT_REVIEWS, tep_get_all_get_params(array('action'))));
			exit;
		}
	} elseif (isset($_GET['action']) && ($_GET['action'] == 'edit_process')) {

		$rating = ( false === empty($_POST['rating']) ? tep_db_prepare_input($_POST['rating']) : tep_db_prepare_input($_POST['rating_value']) );
		$review = tep_db_prepare_input(addslashes($_POST['review']));
		$customers_name = tep_db_prepare_input(addslashes($_POST['customers_name']));


		$error = false;

		if (strlen($review) < REVIEW_TEXT_MIN_LENGTH) {
			$error = true;
			$messageStack->add('review', ERROR_REVIEW_TEXT);
		}

		if ( false === $user_review ) {
			$error = true;
			$messageStack->add('review', 'you cannot edit this review');
		}

		if (($rating <= 0) || ($rating > 5)) {
			$error = true;
			$messageStack->add('review', ERROR_REVIEW_RATING);
		}

			$filtered_customers_name = tep_filter_text($customers_name);
			$filtered_review = tep_filter_text($review);
			if ( false == $filtered_customers_name['passed'] || false === $filtered_review['passed']) {
				$status = '2';
			} else {
				$status = '1';
			}


		if ($error == false) {
			$review_update_query_sql = "
									UPDATE
										" . TABLE_REVIEWS . "
									SET
										products_id = '".(int)$products_id."',
										customers_id = '".(int)$customer_id."',
										customers_name = '".$customers_name."',
										reviews_rating = '".$rating."',
										last_modified = now(),
										status = '$status'
									WHERE
										reviews_id = '".(int)$reviews_id."'";
			$review_update_query = tep_db_query($review_update_query_sql);
			if ( true == $review_update_query ) {
				$review_description_update_query_sql = "
									UPDATE
										" . TABLE_REVIEWS_DESCRIPTION . "
									SET
										reviews_text = '".$review."'
									WHERE
										reviews_id = '".(int)$reviews_id."'
										AND languages_id = '".(int)$languages_id."'";
				$review_description_update_query = tep_db_query($review_description_update_query_sql);
				if ( true == $review_description_update_query ) {
					$average_rating = tep_get_products_average_rating($products_id);
					$reviews_count = tep_get_products_reviews_count($products_id);
					tep_db_query("UPDATE " . TABLE_PRODUCTS . " SET average_rating = '$average_rating', reviews_count = '$reviews_count' WHERE products_id = '$products_id'");
					tep_redirect(tep_href_link(FILENAME_PRODUCT_REVIEWS_INFO, tep_get_all_get_params(array('action'))));
				} else {
					$messageStack->add('review', 'Cannot update reviews description');
				}
			} else {
				$messageStack->add('review', 'Cannot update review');
			}
		}
	}

	$products_name_trimmed = trim_words($product_info['products_name'], 25);
	$breadcrumb->add(NAVBAR_TITLE, tep_href_link(FILENAME_REVIEWS, tep_get_all_get_params()));
	$breadcrumb->add($products_name_trimmed, tep_href_link(FILENAME_PRODUCT_REVIEWS, tep_get_all_get_params()));
	$breadcrumb->add(NAVBAR_TITLE_1);


	$smarty->assign('breadcrumb', $breadcrumb->_trail);
	$smarty->assign('messagestack', $messageStack->get_messages());

	define('HEADING_TITLE', $product_info['products_name']);

	$smarty->assign('HEADER_TITLE', HEADING_TITLE);

	$smarty->assign('IMAGE_BUTTON_IN_CART', IMAGE_BUTTON_IN_CART);
	$smarty->assign('URL_BUY_NOW', tep_href_link(basename($_SERVER['PHP_SELF']), tep_get_all_get_params(array('action')) . 'action=buy_now'));
	$smarty->assign('URL_VIEW', tep_href_link(FILENAME_PRODUCT_INFO, tep_get_all_get_params(array('action'))));
	$smarty->assign('URL_PRODUCT_INFO', tep_href_link(FILENAME_PRODUCT_INFO, tep_get_all_get_params()));
	$smarty->assign('URL_PRODUCT_REVIEWS_WRITE', tep_href_link(FILENAME_PRODUCT_REVIEWS_WRITE, tep_get_all_get_params(array('reviews_id'))));
	$smarty->assign('IMAGE_BUTTON_BACK', IMAGE_BUTTON_BACK);
	$smarty->assign('IMAGE_BUTTON_WRITE_REVIEW', IMAGE_BUTTON_WRITE_REVIEW);
	$smarty->assign('IMAGE_BUTTON_EDIT_REVIEW', IMAGE_BUTTON_EDIT_REVIEW);

	$smarty->assign('TEXT_CLICK_TO_ENLARGE', TEXT_CLICK_TO_ENLARGE);
	$smarty->assign('TEXT_REGULAR_PRICE', TEXT_REGULAR_PRICE);
	$smarty->assign('TEXT_PRICE', TEXT_PRICE);
	$smarty->assign('TEXT_PRICE_NOW', TEXT_PRICE_NOW);
	$smarty->assign('TEXT_PRICE_SAVE', TEXT_PRICE_SAVE);




	$smarty->assign('SUB_TITLE_FROM', SUB_TITLE_FROM);
	$smarty->assign('TEXT_CUSTOMERS_NAME', tep_output_string_protected($customer['customers_firstname'] . ' ' . $customer['customers_lastname']));

	$customers_name = ( false === empty($user_review['customers_name']) ? $user_review['customers_name'] : $customer['customers_firstname'] . ' ' . $customer['customers_lastname'] );;

	$smarty->assign('INPUT_CUSTOMERS_NAME', tep_draw_input_field('customers_name', $customers_name));
	$smarty->assign('TEXTAREA_REVIEW', tep_draw_textarea_field('review', 'soft', 40, 8, $user_review['reviews_text'], 'id="review"'));


	$smarty->assign('rating_selected', ( false === empty($user_review['reviews_rating']) ? $user_review['reviews_rating'] : $_POST['rating'] ) );

	$smarty->assign('URL_PRODUCT_REVIEWS', tep_href_link(FILENAME_PRODUCT_REVIEWS, tep_get_all_get_params()));
	$smarty->assign('TEXT_NO_HTML', TEXT_NO_HTML);

	$smarty->assign('URL_POPUP_IMAGE', tep_href_link(FILENAME_POPUP_IMAGE, 'pID=' . $product_info['products_id']));



	$breadcrumb->add(NAVBAR_TITLE, tep_href_link(FILENAME_PRODUCT_REVIEWS, tep_get_all_get_params()));

	$smarty->assign('_PRODUCTSINFO', $product_info);



	$content = CONTENT_PRODUCT_REVIEWS_WRITE;


	if ( true === $edit_mode ) {
		$page_content = tep_draw_form('product_reviews_write', tep_href_link(FILENAME_PRODUCT_REVIEWS_WRITE, 'action=edit_process&products_id=' . $products_id . '&reviews_id=' . $reviews_id), 'post', '');
		$page_content .= $smarty->fetch('product_reviews_edit.tpl');
	} else {
		$page_content = tep_draw_form('product_reviews_write', tep_href_link(FILENAME_PRODUCT_REVIEWS_WRITE, 'action=insert_process&products_id=' . $products_id), 'post', '');
		$page_content .= $smarty->fetch('product_reviews_write.tpl');
	}
	$page_content .= '</form>';


	require_once ( DIR_WS_INCLUDES . 'meta_tags.php');

	$smarty->assign('page_content', $page_content);

	require_once ( DIR_WS_INCLUDES . 'application_bottom.php');
	$smarty->display('common/page.tpl');
?>
