<?php
	require_once ( 'includes/application_top.php' );
	@include_once ( DIR_WS_LANGUAGES . $language . '/' . FILENAME_REVIEWS);


	$content = CONTENT_REVIEWS;
	$smarty->assign('HEADER_TITLE', HEADING_TITLE);


	$breadcrumb->add(NAVBAR_TITLE);
	$smarty->assign('breadcrumb', $breadcrumb->_trail);
	$smarty->assign('messagestack', $messageStack->get_messages());

	$smarty->assign('IMAGE_BUTTON_WRITE_REVIEW', IMAGE_BUTTON_WRITE_REVIEW);
	$smarty->assign('TEXT_VIEW_MORE_REVIEWS', TEXT_VIEW_MORE_REVIEWS);


	$products_query_raw = "
					SELECT DISTINCT
						p.products_id,
						pd.products_name,
						pd.products_description,
						pd.products_description2,
						p.products_image,
						p.products_image_thumb,
						p.products_image_stamp
					FROM
						" . TABLE_REVIEWS . " r,
						" . TABLE_PRODUCTS . " p,
						" . TABLE_PRODUCTS_DESCRIPTION . " pd
					WHERE
						p.products_status = '1'
						AND p.products_id = r.products_id
						AND p.products_id = pd.products_id
						AND pd.language_id = '" . (int)$languages_id . "'
						AND (r.status = '1' OR r.customers_id = '$customer_id')
					ORDER BY
						pd.products_name ASC
						";
	define('MAX_DISPLAY_NEW_REVIEWS_PRODUCTS', 10);

	$products_split = new splitPageResults($products_query_raw, MAX_DISPLAY_NEW_REVIEWS_PRODUCTS);
	$products_query = tep_db_query($products_split->sql_query);

	$products_count = tep_db_num_rows($products_query);
	while ($product = tep_db_fetch_array($products_query)) {

		###################   THUMBNAIL
		if( false === empty($product['products_image_thumb']) ) {
			$product['image'] = tep_image(DIR_WS_IMAGES.$product['products_image_thumb'], $product['products_name']);
		} else {
		###################   THUMBNAIL
			$product['products_image'] = DIR_WS_IMAGES.$product['products_image'];
			###################   IMAGE SPECIAL MOD
			if ( 'on' === IMAGE_STAMP_ON_OFF ) {
				if( $product['products_image_stamp'] ) {
					$product['products_image'] = generate_image_stamp($product['products_image'], DIR_WS_IMAGES.$product['products_image_stamp']);
				}
			}
			###################   IMAGE SPECIAL MOD

			$product['image']  = tep_image($product['products_image'], $product['products_name'], SMALL_IMAGE_WIDTH, SMALL_IMAGE_HEIGHT, ' class="products_image_small"');
		}

		$product['url'] = tep_href_link(FILENAME_PRODUCT_REVIEWS, 'products_id=' . $product['products_id']);

		$reviews_count_query_sql = "
					SELECT count(*) as TOTAL
					FROM
						" . TABLE_REVIEWS . "
					WHERE
						products_id = '{$product['products_id']}'
						";
		$reviews_count_query = tep_db_query($reviews_count_query_sql);
		$reviews_count = tep_db_fetch_array($reviews_count_query);

		if ( $reviews_count['TOTAL'] > MAX_DISPLAY_NEW_REVIEWS ) {
			$product['reviews_more'] = true;
		} else {
			$product['reviews_more'] = false;
		}

		$reviews_query_sql = "
					SELECT
						r.reviews_id,
						left(rd.reviews_text, 100) as reviews_text,
						r.reviews_rating,
						r.date_added,
						r.customers_name,
						r.status
					FROM
						" . TABLE_REVIEWS . " r,
						" . TABLE_REVIEWS_DESCRIPTION . " rd
					WHERE
						r.products_id = '{$product['products_id']}'
						AND r.reviews_id = rd.reviews_id
						AND rd.languages_id = '" . (int)$languages_id . "'
						AND (r.status = '1' OR r.customers_id = '$customer_id')
					ORDER BY
						r.reviews_id DESC
						LIMIT ".MAX_DISPLAY_NEW_REVIEWS."
						";
		$reviews_query = tep_db_query($reviews_query_sql);
		$reviews_count = tep_db_num_rows($reviews_query);


		$reviews = array();
		while ($review = tep_db_fetch_array($reviews_query)) {

			list($first_name, $last_name) = explode(' ', $review['customers_name']);
			$review['customers_name'] = sprintf(TEXT_REVIEW_BY, tep_output_string_protected(ucfirst($first_name)." ".ucfirst(substr($last_name,0,1))));

			$review_stars_alt = ( 0 >= $review['average_rating'] ? 'Not rated' : $review['reviews_rating'] .' out of 5 stars' );
			$review['average_rating_image_src'] = TEMPLATE_IMAGES_DIR.tep_star_image_name($review['reviews_rating'], 'gif','SMALL' );
			$review['average_rating_image_big_src'] = TEMPLATE_IMAGES_DIR.tep_star_image_name($review['reviews_rating'], 'gif','BIG' );

			$review['average_rating_image'] = tep_image($review['average_rating_image_src'], sprintf(TEXT_OF_5_STARS, $review['reviews_rating']));
			$review['average_rating_image_big'] = tep_image($review['average_rating_image_big_src'], sprintf(TEXT_OF_5_STARS, $review['reviews_rating']));
			$review['date_added'] = sprintf(TEXT_REVIEW_DATE_ADDED, tep_date_long($review['date_added']));
			$review['reviews_text'] = tep_break_string(tep_output_string_protected(stripslashes($review['reviews_text'])), 60, '-<br />' );
			$review['url'] = tep_href_link(FILENAME_PRODUCT_REVIEWS_INFO, 'products_id=' . $product['products_id'] . '&reviews_id=' . $review['reviews_id']);

			$reviews[] = $review;

		}
		$product['reviews'] = $reviews;
		$product['url_write_review'] = tep_href_link(FILENAME_PRODUCT_REVIEWS_WRITE, 'products_id='.$product['products_id']);

		$_PRODUCTS[] = $product;
	}




	$smarty->assign('_PRODUCTS', $_PRODUCTS);



	### PAGING
	if ( $products_split->get_number_of_pages() > 1 ) {
		$smarty->assign('TEXT_DISPLAY_NUMBER_OF_REVIEWS', $products_split->display_count(TEXT_DISPLAY_NUMBER_OF_REVIEWS));
		$_PAGING = TEXT_RESULT_PAGE . ' ' . $products_split->display_links(MAX_DISPLAY_PAGE_LINKS, tep_get_all_get_params(array('page', 'info', 'x', 'y')));
	}

	if ( (PREV_NEXT_BAR_LOCATION == '1' || PREV_NEXT_BAR_LOCATION == '3')  ) { // top
		$smarty->assign('_PAGINGTOP', $_PAGING);
	}

	if ( (PREV_NEXT_BAR_LOCATION == '2' || PREV_NEXT_BAR_LOCATION == '3')  ) { // top
		$smarty->assign('_PAGINGBOTTOM', $_PAGING);
	}
	### PAGING

	if ( $products_count > 0 ) {
		$page_content = $smarty->fetch('reviews.tpl' );
	} else {
		$smarty->assign('TEXT_NO_REVIEWS', TEXT_NO_REVIEWS);
		$page_content = $smarty->fetch('reviews_empty.tpl' );
	}


	require_once ( DIR_WS_INCLUDES . 'meta_tags.php' );

	$smarty->assign('page_content', $page_content);

	require_once (  DIR_WS_INCLUDES . 'application_bottom.php' );
	$smarty->display('common/page.tpl' );

?>