<?php

	require_once ( 'includes/application_top.php' );

	$navigation->remove_current_page();

	// If the language is not specified
	if ($_GET['language'] == '') {
		$lang_query = tep_db_query('select languages_id, code from ' . TABLE_LANGUAGES . ' where directory = \'' . $language . '\'' );
	} else {
		$cur_language = tep_db_output($_GET['language']);
		$lang_query = tep_db_query('select languages_id, code from ' . TABLE_LANGUAGES . ' where code = \'' . $cur_language . '\'' );
	}

	// Recover the code (fr, en, etc) and the id (1, 2, etc) of the current language
	if (tep_db_num_rows($lang_query)) {
		$lang_a = tep_db_fetch_array($lang_query);
		$lang_code = $lang_a['code'];
		$lang_id = $lang_a['languages_id'];
	}

	$category = ( 'specials' == $_GET['type'] ? TEXT_SPECIALS : TEXT_NEW_PRODUCTS );

	$store_name 	= utf8_encode(htmlentities(STORE_NAME));
	$rss_title 		= utf8_encode(htmlentities(STORE_NAME . ' - ' . $category));
	$weblink 		= utf8_encode(htmlentities(BASE_URL));
	$description 	= utf8_encode(htmlentities(INDEX_META_DESCRIPTION));
	$email_address 	= utf8_encode(htmlentities(STORE_OWNER_EMAIL_ADDRESS));
	$rss_date		= date(r);

	header('Content-Type: application/xml');

	echo '<?phpxml version="1.0"?>' , "\n",
		'<rss version="2.0">' , "\n",
		"\t<channel>\n",
		//" <!-- RSS for $store_name, generated on $rss_date -->\n",
		"\t\t<title>$rss_title</title>\n",
     	"\t\t<link>$weblink</link>\n",
      	"\t\t<description>$description</description>\n",
      	"\t\t<language>$lang_code</language>\n",
      	"\t\t<pubDate>$rss_date</pubDate>\n",
      	"\t\t<lastBuildDate>$rss_date</lastBuildDate>\n",
      	"\t\t<docs>http://blogs.law.harvard.edu/tech/rss</docs>\n",
      	"\t\t<generator>eclime.com</generator>\n",
      	"\t\t<managingEditor>$email_address</managingEditor>\n",
      	"\t\t<webMaster>$email_address</webMaster>\n";

if ( 'categories' === $_GET['show'] ) {
	$category_query_sql = "
			SELECT
				c.categories_id,
				cd.categories_name,
				c.categories_image,
				c.parent_id
			FROM
				" . TABLE_CATEGORIES . " c,
				" . TABLE_CATEGORIES_DESCRIPTION . " cd
			WHERE
				c.categories_id = cd.categories_id
				AND cd.language_id = '" . (int)$languages_id . "'
			ORDER BY c.date_added DESC
			LIMIT " . MAX_DISPLAY_NEW_CATEGORIES;

	$new_categories_query = tep_db_query($category_query_sql);

	while ( $new_categories = tep_db_fetch_array($new_categories_query) ) {
		$image = $new_categories['categories_image'];
		$image_url = HTTP_SERVER . DIR_WS_CATALOG. $image;
		$id = $new_categories['categories_id'];
		$parent_id = $new_categories['parent_id'];
		$added = date(r,strtotime($new_categories['date_added']));
		$name = utf8_encode ( htmlentities($new_categories['categories_name']) );
		$link = utf8_encode ( tep_href_link(FILENAME_PRODUCT_INFO, 'cPath=' . $new_categories['parent_id'].'_'.$new_categories['categories_id'], 'NONSSL', false) );
		echo "\t\t<item>\n",
			"\t\t\t<title>$name</title>\n",
			"\t\t\t<link>$link</link>\n",
			"\t\t\t<description>";
		  if ($ecommerce=='' && $image != '') {
		    echo "<![CDATA[<a href=\"$link\"><img src=\"$image_url\"></a>]]>";
		  }
		echo "</description>\n",
			"\t\t\t<pubDate>$added</pubDate>\n",
			"\t\t\t<guid>$link</guid>\n",
			"\t\t</item>\n";
	}

} else {

	if( false == tep_session_is_registered('sppc_customer_group_id') ) {
		$customer_group_id = '0';
	} else {
		$customer_group_id = $sppc_customer_group_id;
	}

	switch ( $_GET['type'] ) {
		case 'specials':
			$new_products_query_sql = "
							SELECT DISTINCT
								p.products_id,
								pd.products_name,
								p2c.categories_id,
								c.categories_name,
								pd.products_description,
								p.products_image,
								IF (s.status, s.specials_new_products_price, NULL)
										AS specials_new_products_price,
									IF (s.status, s.specials_new_products_price, p.products_price)
										AS final_price,
									IF (s.status, s.specials_text, NULL)
										AS price_special_text,
								p.products_image_thumb,
								p.products_image_stamp,
								p.products_price,
								p.products_price_hidden,
								p.products_date_added,
								p.products_access
							FROM
								" . TABLE_PRODUCTS . " p,
								" . TABLE_PRODUCTS_DESCRIPTION . " pd,
								" . TABLE_SPECIALS . " s,
								" . TABLE_PRODUCTS_TO_CATEGORIES . " p2c,
								" . TABLE_CATEGORIES_DESCRIPTION . " c
							WHERE
								p.products_status = '1'
								AND s.products_id = p.products_id
								AND c.categories_id = p2c.categories_id
								AND p2c.products_id = p.products_id
								AND p.products_id = pd.products_id
								AND pd.language_id = '$languages_id'
								AND s.status = '1'
								AND s.customers_group_id = '$customer_group_id'
							ORDER BY
								s.specials_date_added DESC";
		break;

		default:
		case 'newproducts':
			if ( true === empty($customers_group_id) || false === is_numeric($customers_group_id) ) {
				$customers_group_id = '0';
			}
			$new_products_query_sql = "
							SELECT DISTINCT
								p.products_id,
								pd.products_name,
								p2c.categories_id,
								c.categories_name,
								pd.products_description,
								p.products_image,
								IF (s.status, s.specials_new_products_price, NULL)
										AS specials_new_products_price,
									IF (s.status, s.specials_new_products_price, p.products_price)
										AS final_price,
									IF (s.status, s.specials_text, NULL)
										AS price_special_text,
								p.products_image_thumb,
								p.products_image_stamp,
								p.products_price,
								p.products_price_hidden,
								p.products_date_added,
								p.products_access
							FROM
								" . TABLE_PRODUCTS . " p
								LEFT JOIN
									" . TABLE_SPECIALS . " s
									ON (p.products_id = s.products_id AND s.customers_group_id = '$customers_group_id'),
								" . TABLE_PRODUCTS_DESCRIPTION . " pd,
								" . TABLE_PRODUCTS_TO_CATEGORIES . " p2c,
								" . TABLE_CATEGORIES_DESCRIPTION . " c

							WHERE
								c.categories_id = p2c.categories_id
								AND p2c.products_id = p.products_id
								AND p.products_id = pd.products_id
								AND p.products_status = '1'
								AND pd.language_id = '$languages_id'

							ORDER BY p.products_date_added DESC LIMIT ". MAX_DISPLAY_NEW_PRODUCTS;
		break;
	}

	$new_products_query = tep_db_query($new_products_query_sql);

	while ( $new_products = tep_db_fetch_array($new_products_query) ) {
		// products access
		if ( true === isset($new_products['products_access']) ) {
			$customer_access_ids = explode(',', $new_products['products_access']);
			if ( false === in_array('0', $customer_access_ids)) {
				continue;
			}
		}

			###################   THUMBNAIL
			if( false === empty($new_products['products_image_thumb']) ) {
				$use_thumb = true;
				$new_products['products_image'] = DIR_WS_IMAGES . basename($new_products['products_image_thumb']);
			} else {
				$use_thumb = false;
			###################   THUMBNAIL
			$new_products['products_image'] = DIR_WS_IMAGES.$new_products['products_image'];

				###################   IMAGE SPECIAL MOD
				if ( 'on' === IMAGE_STAMP_ON_OFF ) {
					if( $new_products['products_image_stamp'] ) {
						$new_products['products_image'] = generate_image_stamp($new_products['products_image'], DIR_WS_IMAGES.$new_products['products_image_stamp']);
					}
				}
				###################   IMAGE SPECIAL MOD
			}


			if ( true === $use_thumb ) {
				$new_products['products_image'] = tep_image($new_products['products_image'], $new_products['products_name'], '', '', 'style="float: left; margin: 0px 8px 8px 0px;"', false, true );
			} else {
				$new_products['products_image'] = tep_image($new_products['products_image'], $new_products['products_name'], SMALL_IMAGE_WIDTH, SMALL_IMAGE_HEIGHT, 'style="float: left; margin: 0px 8px 8px 0px;"', false, true );
			}


			$new_price = $new_products['specials_new_products_price'];

			if (false === empty($new_price)) {
				$new_products['price'] = '<strong>'.$currencies->display_price($new_price, 0).'</strong><br />';
				$new_products['price'] .= ' <s>'.$currencies->display_price($new_products['products_price'], 0) .'</s><br />';
				$new_products['price'] .= ' You Save: ' . $currencies->display_price($new_products['products_price']-$new_price, 0);
				$new_products['price'] .= ' ('.floor(($new_products['products_price']-$new_price) *  100 / $new_products['products_price']).'%)';
			} else {
				$new_products['price'] = $currencies->display_price($new_products['products_price'], 0);
			}

			switch ( $new_products['products_price_hidden'] ) {
				case 1;
					if ( true === empty($customer_id) ) {
						$new_products['price'] = '<a href="'.tep_href_link(FILENAME_LOGIN, $login_logout_params, 'SSL').'">'.TEXT_PRICE_LOGIN . '</a>';
					}
				break;
				case 2;
					$new_products['price'] = TEXT_PRICE_CALL;
				break;
			}

			$new_products['price'] .= '<br />';
			$new_products['url'] 				= utf8_encode(tep_href_link(FILENAME_PRODUCT_INFO, 'products_id=' . $new_products['products_id'], 'NONSSL', false));
			$new_products['url_buy_now']			= utf8_encode(tep_href_link(FILENAME_PRODUCT_INFO, tep_get_all_get_params(array('action')) . 'action=buy_now&products_id=' . $new_products['products_id']));
			$new_products['price'] 				= utf8_encode($new_products['price']);
			$new_products['products_image']		= utf8_encode($new_products['products_image']);
			$new_products['products_name'] 		= utf8_encode($new_products['products_name']);
			$new_products['products_description'] 	= utf8_encode($new_products['products_description']);
			$new_products['categories_name'] 		= utf8_encode($new_products['categories_name']);
			$new_products['products_date_added']	= date(r, strtotime($new_products['products_date_added']));
			$new_products['products_description']	.= '<a href="' .$new_products['url_buy_now']. '"><img src="' . BASE_URL . TEMPLATE_LANGUAGE_BUTTONS_DIR . 'button_buy_now.gif' . '" border="0"></a>';
			$new_products['products_description']	.= '&nbsp;<a href="' .$new_products['url']. '"><img src="' . BASE_URL . TEMPLATE_LANGUAGE_BUTTONS_DIR . 'button_view.gif' . '" border="0"></a>';
			$new_products['products_description']	.= '<br /><br />';


		// Writing the output
		echo "\t\t<item>\n",
			"\t\t<title><![CDATA[{$new_products['products_name']}]]></title>\n",
			"\t\t<category><![CDATA[{$new_products['categories_name']}]]></category>\n",
			"\t\t<link><![CDATA[{$new_products['url']}]]></link>\n",
			"\t\t<description><![CDATA[";

			if ( false === empty($new_products['products_image']) ) {
				echo '<a href="' . $new_products['url'] . '">'.$new_products['products_image'].'</a><br />';
			}
			echo $new_products['price'],
				$new_products['products_description'],
				"]]></description>\n",
				"		<guid><![CDATA[{$new_products['url']}]]></guid>\n",
				"		<pubDate>{$new_products['products_date_added']}</pubDate>\n",
				'	</item>' . "\n";


	}

}
?>
</channel>
</rss>